/*! For license information please see index.js.LICENSE.txt */
var __webpack_modules__ = {
    "./node_modules/.pnpm/@braintree+sanitize-url@7.1.1/node_modules/@braintree/sanitize-url/dist/constants.js": function(__unused_webpack_module, exports1) {
        Object.defineProperty(exports1, "__esModule", {
            value: true
        });
        exports1.BLANK_URL = exports1.relativeFirstCharacters = exports1.whitespaceEscapeCharsRegex = exports1.urlSchemeRegex = exports1.ctrlCharactersRegex = exports1.htmlCtrlEntityRegex = exports1.htmlEntitiesRegex = exports1.invalidProtocolRegex = void 0;
        exports1.invalidProtocolRegex = /^([^\w]*)(javascript|data|vbscript)/im;
        exports1.htmlEntitiesRegex = /&#(\w+)(^\w|;)?/g;
        exports1.htmlCtrlEntityRegex = /&(newline|tab);/gi;
        exports1.ctrlCharactersRegex = /[\u0000-\u001F\u007F-\u009F\u2000-\u200D\uFEFF]/gim;
        exports1.urlSchemeRegex = /^.+(:|&colon;)/gim;
        exports1.whitespaceEscapeCharsRegex = /(\\|%5[cC])((%(6[eE]|72|74))|[nrt])/g;
        exports1.relativeFirstCharacters = [
            ".",
            "/"
        ];
        exports1.BLANK_URL = "about:blank";
    },
    "./node_modules/.pnpm/@braintree+sanitize-url@7.1.1/node_modules/@braintree/sanitize-url/dist/index.js": function(__unused_webpack_module, exports1, __webpack_require__) {
        exports1.sanitizeUrl = void 0;
        var constants_1 = __webpack_require__("./node_modules/.pnpm/@braintree+sanitize-url@7.1.1/node_modules/@braintree/sanitize-url/dist/constants.js");
        function isRelativeUrlWithoutProtocol(url) {
            return constants_1.relativeFirstCharacters.indexOf(url[0]) > -1;
        }
        function decodeHtmlCharacters(str) {
            var removedNullByte = str.replace(constants_1.ctrlCharactersRegex, "");
            return removedNullByte.replace(constants_1.htmlEntitiesRegex, function(match, dec) {
                return String.fromCharCode(dec);
            });
        }
        function isValidUrl(url) {
            return URL.canParse(url);
        }
        function decodeURI(uri) {
            try {
                return decodeURIComponent(uri);
            } catch (e) {
                return uri;
            }
        }
        function sanitizeUrl(url) {
            if (!url) return constants_1.BLANK_URL;
            var charsToDecode;
            var decodedUrl = decodeURI(url.trim());
            do {
                decodedUrl = decodeHtmlCharacters(decodedUrl).replace(constants_1.htmlCtrlEntityRegex, "").replace(constants_1.ctrlCharactersRegex, "").replace(constants_1.whitespaceEscapeCharsRegex, "").trim();
                decodedUrl = decodeURI(decodedUrl);
                charsToDecode = decodedUrl.match(constants_1.ctrlCharactersRegex) || decodedUrl.match(constants_1.htmlEntitiesRegex) || decodedUrl.match(constants_1.htmlCtrlEntityRegex) || decodedUrl.match(constants_1.whitespaceEscapeCharsRegex);
            }while (charsToDecode && charsToDecode.length > 0);
            var sanitizedUrl = decodedUrl;
            if (!sanitizedUrl) return constants_1.BLANK_URL;
            if (isRelativeUrlWithoutProtocol(sanitizedUrl)) return sanitizedUrl;
            var trimmedUrl = sanitizedUrl.trimStart();
            var urlSchemeParseResults = trimmedUrl.match(constants_1.urlSchemeRegex);
            if (!urlSchemeParseResults) return sanitizedUrl;
            var urlScheme = urlSchemeParseResults[0].toLowerCase().trim();
            if (constants_1.invalidProtocolRegex.test(urlScheme)) return constants_1.BLANK_URL;
            var backSanitized = trimmedUrl.replace(/\\/g, "/");
            if ("mailto:" === urlScheme || urlScheme.includes("://")) return backSanitized;
            if ("http:" === urlScheme || "https:" === urlScheme) {
                if (!isValidUrl(backSanitized)) return constants_1.BLANK_URL;
                var url_1 = new URL(backSanitized);
                url_1.protocol = url_1.protocol.toLowerCase();
                url_1.hostname = url_1.hostname.toLowerCase();
                return url_1.toString();
            }
            return backSanitized;
        }
        exports1.sanitizeUrl = sanitizeUrl;
    },
    "./node_modules/.pnpm/dayjs@1.11.11/node_modules/dayjs/dayjs.min.js": function(module1) {
        !function(t, e) {
            module1.exports = e();
        }(0, function() {
            "use strict";
            var t = 1e3, e = 6e4, n = 36e5, r = "millisecond", i = "second", s = "minute", u = "hour", a = "day", o = "week", c = "month", f = "quarter", h = "year", d = "date", l = "Invalid Date", $ = /^(\d{4})[-/]?(\d{1,2})?[-/]?(\d{0,2})[Tt\s]*(\d{1,2})?:?(\d{1,2})?:?(\d{1,2})?[.:]?(\d+)?$/, y = /\[([^\]]+)]|Y{1,4}|M{1,4}|D{1,2}|d{1,4}|H{1,2}|h{1,2}|a|A|m{1,2}|s{1,2}|Z{1,2}|SSS/g, M = {
                name: "en",
                weekdays: "Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),
                months: "January_February_March_April_May_June_July_August_September_October_November_December".split("_"),
                ordinal: function(t) {
                    var e = [
                        "th",
                        "st",
                        "nd",
                        "rd"
                    ], n = t % 100;
                    return "[" + t + (e[(n - 20) % 10] || e[n] || e[0]) + "]";
                }
            }, m = function(t, e, n) {
                var r = String(t);
                return !r || r.length >= e ? t : "" + Array(e + 1 - r.length).join(n) + t;
            }, v = {
                s: m,
                z: function(t) {
                    var e = -t.utcOffset(), n = Math.abs(e), r = Math.floor(n / 60), i = n % 60;
                    return (e <= 0 ? "+" : "-") + m(r, 2, "0") + ":" + m(i, 2, "0");
                },
                m: function t(e, n) {
                    if (e.date() < n.date()) return -t(n, e);
                    var r = 12 * (n.year() - e.year()) + (n.month() - e.month()), i = e.clone().add(r, c), s = n - i < 0, u = e.clone().add(r + (s ? -1 : 1), c);
                    return +(-(r + (n - i) / (s ? i - u : u - i)) || 0);
                },
                a: function(t) {
                    return t < 0 ? Math.ceil(t) || 0 : Math.floor(t);
                },
                p: function(t) {
                    return ({
                        M: c,
                        y: h,
                        w: o,
                        d: a,
                        D: d,
                        h: u,
                        m: s,
                        s: i,
                        ms: r,
                        Q: f
                    })[t] || String(t || "").toLowerCase().replace(/s$/, "");
                },
                u: function(t) {
                    return void 0 === t;
                }
            }, g = "en", D = {};
            D[g] = M;
            var p = "$isDayjsObject", S = function(t) {
                return t instanceof _ || !(!t || !t[p]);
            }, w = function t(e, n, r) {
                var i;
                if (!e) return g;
                if ("string" == typeof e) {
                    var s = e.toLowerCase();
                    D[s] && (i = s), n && (D[s] = n, i = s);
                    var u = e.split("-");
                    if (!i && u.length > 1) return t(u[0]);
                } else {
                    var a = e.name;
                    D[a] = e, i = a;
                }
                return !r && i && (g = i), i || !r && g;
            }, O = function(t, e) {
                if (S(t)) return t.clone();
                var n = "object" == typeof e ? e : {};
                return n.date = t, n.args = arguments, new _(n);
            }, b = v;
            b.l = w, b.i = S, b.w = function(t, e) {
                return O(t, {
                    locale: e.$L,
                    utc: e.$u,
                    x: e.$x,
                    $offset: e.$offset
                });
            };
            var _ = function() {
                function M(t) {
                    this.$L = w(t.locale, null, !0), this.parse(t), this.$x = this.$x || t.x || {}, this[p] = !0;
                }
                var m = M.prototype;
                return m.parse = function(t) {
                    this.$d = function(t) {
                        var e = t.date, n = t.utc;
                        if (null === e) return new Date(NaN);
                        if (b.u(e)) return new Date;
                        if (e instanceof Date) return new Date(e);
                        if ("string" == typeof e && !/Z$/i.test(e)) {
                            var r = e.match($);
                            if (r) {
                                var i = r[2] - 1 || 0, s = (r[7] || "0").substring(0, 3);
                                return n ? new Date(Date.UTC(r[1], i, r[3] || 1, r[4] || 0, r[5] || 0, r[6] || 0, s)) : new Date(r[1], i, r[3] || 1, r[4] || 0, r[5] || 0, r[6] || 0, s);
                            }
                        }
                        return new Date(e);
                    }(t), this.init();
                }, m.init = function() {
                    var t = this.$d;
                    this.$y = t.getFullYear(), this.$M = t.getMonth(), this.$D = t.getDate(), this.$W = t.getDay(), this.$H = t.getHours(), this.$m = t.getMinutes(), this.$s = t.getSeconds(), this.$ms = t.getMilliseconds();
                }, m.$utils = function() {
                    return b;
                }, m.isValid = function() {
                    return this.$d.toString() !== l;
                }, m.isSame = function(t, e) {
                    var n = O(t);
                    return this.startOf(e) <= n && n <= this.endOf(e);
                }, m.isAfter = function(t, e) {
                    return O(t) < this.startOf(e);
                }, m.isBefore = function(t, e) {
                    return this.endOf(e) < O(t);
                }, m.$g = function(t, e, n) {
                    return b.u(t) ? this[e] : this.set(n, t);
                }, m.unix = function() {
                    return Math.floor(this.valueOf() / 1e3);
                }, m.valueOf = function() {
                    return this.$d.getTime();
                }, m.startOf = function(t, e) {
                    var n = this, r = !!b.u(e) || e, f = b.p(t), l = function(t, e) {
                        var i = b.w(n.$u ? Date.UTC(n.$y, e, t) : new Date(n.$y, e, t), n);
                        return r ? i : i.endOf(a);
                    }, $ = function(t, e) {
                        return b.w(n.toDate()[t].apply(n.toDate("s"), (r ? [
                            0,
                            0,
                            0,
                            0
                        ] : [
                            23,
                            59,
                            59,
                            999
                        ]).slice(e)), n);
                    }, y = this.$W, M = this.$M, m = this.$D, v = "set" + (this.$u ? "UTC" : "");
                    switch(f){
                        case h:
                            return r ? l(1, 0) : l(31, 11);
                        case c:
                            return r ? l(1, M) : l(0, M + 1);
                        case o:
                            var g = this.$locale().weekStart || 0, D = (y < g ? y + 7 : y) - g;
                            return l(r ? m - D : m + (6 - D), M);
                        case a:
                        case d:
                            return $(v + "Hours", 0);
                        case u:
                            return $(v + "Minutes", 1);
                        case s:
                            return $(v + "Seconds", 2);
                        case i:
                            return $(v + "Milliseconds", 3);
                        default:
                            return this.clone();
                    }
                }, m.endOf = function(t) {
                    return this.startOf(t, !1);
                }, m.$set = function(t, e) {
                    var n, o = b.p(t), f = "set" + (this.$u ? "UTC" : ""), l = (n = {}, n[a] = f + "Date", n[d] = f + "Date", n[c] = f + "Month", n[h] = f + "FullYear", n[u] = f + "Hours", n[s] = f + "Minutes", n[i] = f + "Seconds", n[r] = f + "Milliseconds", n)[o], $ = o === a ? this.$D + (e - this.$W) : e;
                    if (o === c || o === h) {
                        var y = this.clone().set(d, 1);
                        y.$d[l]($), y.init(), this.$d = y.set(d, Math.min(this.$D, y.daysInMonth())).$d;
                    } else l && this.$d[l]($);
                    return this.init(), this;
                }, m.set = function(t, e) {
                    return this.clone().$set(t, e);
                }, m.get = function(t) {
                    return this[b.p(t)]();
                }, m.add = function(r, f) {
                    var d, l = this;
                    r = Number(r);
                    var $ = b.p(f), y = function(t) {
                        var e = O(l);
                        return b.w(e.date(e.date() + Math.round(t * r)), l);
                    };
                    if ($ === c) return this.set(c, this.$M + r);
                    if ($ === h) return this.set(h, this.$y + r);
                    if ($ === a) return y(1);
                    if ($ === o) return y(7);
                    var M = (d = {}, d[s] = e, d[u] = n, d[i] = t, d)[$] || 1, m = this.$d.getTime() + r * M;
                    return b.w(m, this);
                }, m.subtract = function(t, e) {
                    return this.add(-1 * t, e);
                }, m.format = function(t) {
                    var e = this, n = this.$locale();
                    if (!this.isValid()) return n.invalidDate || l;
                    var r = t || "YYYY-MM-DDTHH:mm:ssZ", i = b.z(this), s = this.$H, u = this.$m, a = this.$M, o = n.weekdays, c = n.months, f = n.meridiem, h = function(t, n, i, s) {
                        return t && (t[n] || t(e, r)) || i[n].slice(0, s);
                    }, d = function(t) {
                        return b.s(s % 12 || 12, t, "0");
                    }, $ = f || function(t, e, n) {
                        var r = t < 12 ? "AM" : "PM";
                        return n ? r.toLowerCase() : r;
                    };
                    return r.replace(y, function(t, r) {
                        return r || function(t) {
                            switch(t){
                                case "YY":
                                    return String(e.$y).slice(-2);
                                case "YYYY":
                                    return b.s(e.$y, 4, "0");
                                case "M":
                                    return a + 1;
                                case "MM":
                                    return b.s(a + 1, 2, "0");
                                case "MMM":
                                    return h(n.monthsShort, a, c, 3);
                                case "MMMM":
                                    return h(c, a);
                                case "D":
                                    return e.$D;
                                case "DD":
                                    return b.s(e.$D, 2, "0");
                                case "d":
                                    return String(e.$W);
                                case "dd":
                                    return h(n.weekdaysMin, e.$W, o, 2);
                                case "ddd":
                                    return h(n.weekdaysShort, e.$W, o, 3);
                                case "dddd":
                                    return o[e.$W];
                                case "H":
                                    return String(s);
                                case "HH":
                                    return b.s(s, 2, "0");
                                case "h":
                                    return d(1);
                                case "hh":
                                    return d(2);
                                case "a":
                                    return $(s, u, !0);
                                case "A":
                                    return $(s, u, !1);
                                case "m":
                                    return String(u);
                                case "mm":
                                    return b.s(u, 2, "0");
                                case "s":
                                    return String(e.$s);
                                case "ss":
                                    return b.s(e.$s, 2, "0");
                                case "SSS":
                                    return b.s(e.$ms, 3, "0");
                                case "Z":
                                    return i;
                            }
                            return null;
                        }(t) || i.replace(":", "");
                    });
                }, m.utcOffset = function() {
                    return 15 * -Math.round(this.$d.getTimezoneOffset() / 15);
                }, m.diff = function(r, d, l) {
                    var $, y = this, M = b.p(d), m = O(r), v = (m.utcOffset() - this.utcOffset()) * e, g = this - m, D = function() {
                        return b.m(y, m);
                    };
                    switch(M){
                        case h:
                            $ = D() / 12;
                            break;
                        case c:
                            $ = D();
                            break;
                        case f:
                            $ = D() / 3;
                            break;
                        case o:
                            $ = (g - v) / 6048e5;
                            break;
                        case a:
                            $ = (g - v) / 864e5;
                            break;
                        case u:
                            $ = g / n;
                            break;
                        case s:
                            $ = g / e;
                            break;
                        case i:
                            $ = g / t;
                            break;
                        default:
                            $ = g;
                    }
                    return l ? $ : b.a($);
                }, m.daysInMonth = function() {
                    return this.endOf(c).$D;
                }, m.$locale = function() {
                    return D[this.$L];
                }, m.locale = function(t, e) {
                    if (!t) return this.$L;
                    var n = this.clone(), r = w(t, e, !0);
                    return r && (n.$L = r), n;
                }, m.clone = function() {
                    return b.w(this.$d, this);
                }, m.toDate = function() {
                    return new Date(this.valueOf());
                }, m.toJSON = function() {
                    return this.isValid() ? this.toISOString() : null;
                }, m.toISOString = function() {
                    return this.$d.toISOString();
                }, m.toString = function() {
                    return this.$d.toUTCString();
                }, M;
            }(), k = _.prototype;
            return O.prototype = k, [
                [
                    "$ms",
                    r
                ],
                [
                    "$s",
                    i
                ],
                [
                    "$m",
                    s
                ],
                [
                    "$H",
                    u
                ],
                [
                    "$W",
                    a
                ],
                [
                    "$M",
                    c
                ],
                [
                    "$y",
                    h
                ],
                [
                    "$D",
                    d
                ]
            ].forEach(function(t) {
                k[t[1]] = function(e) {
                    return this.$g(e, t[0], t[1]);
                };
            }), O.extend = function(t, e) {
                return t.$i || (t(e, _, O), t.$i = !0), O;
            }, O.locale = w, O.isDayjs = S, O.unix = function(t) {
                return O(1e3 * t);
            }, O.en = D[g], O.Ls = D, O.p = {}, O;
        });
    },
    "./node_modules/.pnpm/roughjs@4.6.6/node_modules/roughjs/bundled/rough.esm.js": function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>at
        });
        function t(t, e, s) {
            if (t && t.length) {
                const [n, o] = e, a = Math.PI / 180 * s, h = Math.cos(a), r = Math.sin(a);
                for (const e of t){
                    const [t, s] = e;
                    e[0] = (t - n) * h - (s - o) * r + n, e[1] = (t - n) * r + (s - o) * h + o;
                }
            }
        }
        function e(t, e) {
            return t[0] === e[0] && t[1] === e[1];
        }
        function s(s1, n, o, a = 1) {
            const h = o, r = Math.max(n, .1), i = s1[0] && s1[0][0] && "number" == typeof s1[0][0] ? [
                s1
            ] : s1, c = [
                0,
                0
            ];
            if (h) for (const e of i)t(e, c, h);
            const l = function(t, s, n) {
                const o = [];
                for (const s of t){
                    const t = [
                        ...s
                    ];
                    e(t[0], t[t.length - 1]) || t.push([
                        t[0][0],
                        t[0][1]
                    ]), t.length > 2 && o.push(t);
                }
                const a = [];
                s = Math.max(s, .1);
                const h = [];
                for (const t of o)for(let e = 0; e < t.length - 1; e++){
                    const s = t[e], n = t[e + 1];
                    if (s[1] !== n[1]) {
                        const t = Math.min(s[1], n[1]);
                        h.push({
                            ymin: t,
                            ymax: Math.max(s[1], n[1]),
                            x: t === s[1] ? s[0] : n[0],
                            islope: (n[0] - s[0]) / (n[1] - s[1])
                        });
                    }
                }
                if (h.sort((t, e)=>t.ymin < e.ymin ? -1 : t.ymin > e.ymin ? 1 : t.x < e.x ? -1 : t.x > e.x ? 1 : t.ymax === e.ymax ? 0 : (t.ymax - e.ymax) / Math.abs(t.ymax - e.ymax)), !h.length) return a;
                let r = [], i = h[0].ymin, c = 0;
                for(; r.length || h.length;){
                    if (h.length) {
                        let t = -1;
                        for(let e = 0; e < h.length && !(h[e].ymin > i); e++)t = e;
                        h.splice(0, t + 1).forEach((t)=>{
                            r.push({
                                s: i,
                                edge: t
                            });
                        });
                    }
                    if (r = r.filter((t)=>!(t.edge.ymax <= i)), r.sort((t, e)=>t.edge.x === e.edge.x ? 0 : (t.edge.x - e.edge.x) / Math.abs(t.edge.x - e.edge.x)), (1 !== n || c % s == 0) && r.length > 1) for(let t = 0; t < r.length; t += 2){
                        const e = t + 1;
                        if (e >= r.length) break;
                        const s = r[t].edge, n = r[e].edge;
                        a.push([
                            [
                                Math.round(s.x),
                                i
                            ],
                            [
                                Math.round(n.x),
                                i
                            ]
                        ]);
                    }
                    i += n, r.forEach((t)=>{
                        t.edge.x = t.edge.x + n * t.edge.islope;
                    }), c++;
                }
                return a;
            }(i, r, a);
            if (h) {
                for (const e of i)t(e, c, -h);
                !function(e, s, n) {
                    const o = [];
                    e.forEach((t)=>o.push(...t)), t(o, s, n);
                }(l, c, -h);
            }
            return l;
        }
        function n(t, e) {
            var n;
            const o = e.hachureAngle + 90;
            let a = e.hachureGap;
            a < 0 && (a = 4 * e.strokeWidth), a = Math.round(Math.max(a, .1));
            let h = 1;
            return e.roughness >= 1 && ((null === (n = e.randomizer) || void 0 === n ? void 0 : n.next()) || Math.random()) > .7 && (h = a), s(t, a, o, h || 1);
        }
        class o {
            constructor(t){
                this.helper = t;
            }
            fillPolygons(t, e) {
                return this._fillPolygons(t, e);
            }
            _fillPolygons(t, e) {
                const s = n(t, e);
                return {
                    type: "fillSketch",
                    ops: this.renderLines(s, e)
                };
            }
            renderLines(t, e) {
                const s = [];
                for (const n of t)s.push(...this.helper.doubleLineOps(n[0][0], n[0][1], n[1][0], n[1][1], e));
                return s;
            }
        }
        function a(t) {
            const e = t[0], s = t[1];
            return Math.sqrt(Math.pow(e[0] - s[0], 2) + Math.pow(e[1] - s[1], 2));
        }
        class h extends o {
            fillPolygons(t, e) {
                let s = e.hachureGap;
                s < 0 && (s = 4 * e.strokeWidth), s = Math.max(s, .1);
                const o = n(t, Object.assign({}, e, {
                    hachureGap: s
                })), h = Math.PI / 180 * e.hachureAngle, r = [], i = .5 * s * Math.cos(h), c = .5 * s * Math.sin(h);
                for (const [t, e] of o)a([
                    t,
                    e
                ]) && r.push([
                    [
                        t[0] - i,
                        t[1] + c
                    ],
                    [
                        ...e
                    ]
                ], [
                    [
                        t[0] + i,
                        t[1] - c
                    ],
                    [
                        ...e
                    ]
                ]);
                return {
                    type: "fillSketch",
                    ops: this.renderLines(r, e)
                };
            }
        }
        class r extends o {
            fillPolygons(t, e) {
                const s = this._fillPolygons(t, e), n = Object.assign({}, e, {
                    hachureAngle: e.hachureAngle + 90
                }), o = this._fillPolygons(t, n);
                return s.ops = s.ops.concat(o.ops), s;
            }
        }
        class i {
            constructor(t){
                this.helper = t;
            }
            fillPolygons(t, e) {
                const s = n(t, e = Object.assign({}, e, {
                    hachureAngle: 0
                }));
                return this.dotsOnLines(s, e);
            }
            dotsOnLines(t, e) {
                const s = [];
                let n = e.hachureGap;
                n < 0 && (n = 4 * e.strokeWidth), n = Math.max(n, .1);
                let o = e.fillWeight;
                o < 0 && (o = e.strokeWidth / 2);
                const h = n / 4;
                for (const r of t){
                    const t = a(r), i = t / n, c = Math.ceil(i) - 1, l = t - c * n, u = (r[0][0] + r[1][0]) / 2 - n / 4, p = Math.min(r[0][1], r[1][1]);
                    for(let t = 0; t < c; t++){
                        const a = p + l + t * n, r = u - h + 2 * Math.random() * h, i = a - h + 2 * Math.random() * h, c = this.helper.ellipse(r, i, o, o, e);
                        s.push(...c.ops);
                    }
                }
                return {
                    type: "fillSketch",
                    ops: s
                };
            }
        }
        class c {
            constructor(t){
                this.helper = t;
            }
            fillPolygons(t, e) {
                const s = n(t, e);
                return {
                    type: "fillSketch",
                    ops: this.dashedLine(s, e)
                };
            }
            dashedLine(t, e) {
                const s = e.dashOffset < 0 ? e.hachureGap < 0 ? 4 * e.strokeWidth : e.hachureGap : e.dashOffset, n = e.dashGap < 0 ? e.hachureGap < 0 ? 4 * e.strokeWidth : e.hachureGap : e.dashGap, o = [];
                return t.forEach((t)=>{
                    const h = a(t), r = Math.floor(h / (s + n)), i = (h + n - r * (s + n)) / 2;
                    let c = t[0], l = t[1];
                    c[0] > l[0] && (c = t[1], l = t[0]);
                    const u = Math.atan((l[1] - c[1]) / (l[0] - c[0]));
                    for(let t = 0; t < r; t++){
                        const a = t * (s + n), h = a + s, r = [
                            c[0] + a * Math.cos(u) + i * Math.cos(u),
                            c[1] + a * Math.sin(u) + i * Math.sin(u)
                        ], l = [
                            c[0] + h * Math.cos(u) + i * Math.cos(u),
                            c[1] + h * Math.sin(u) + i * Math.sin(u)
                        ];
                        o.push(...this.helper.doubleLineOps(r[0], r[1], l[0], l[1], e));
                    }
                }), o;
            }
        }
        class l {
            constructor(t){
                this.helper = t;
            }
            fillPolygons(t, e) {
                const s = e.hachureGap < 0 ? 4 * e.strokeWidth : e.hachureGap, o = e.zigzagOffset < 0 ? s : e.zigzagOffset, a = n(t, e = Object.assign({}, e, {
                    hachureGap: s + o
                }));
                return {
                    type: "fillSketch",
                    ops: this.zigzagLines(a, o, e)
                };
            }
            zigzagLines(t, e, s) {
                const n = [];
                return t.forEach((t)=>{
                    const o = a(t), h = Math.round(o / (2 * e));
                    let r = t[0], i = t[1];
                    r[0] > i[0] && (r = t[1], i = t[0]);
                    const c = Math.atan((i[1] - r[1]) / (i[0] - r[0]));
                    for(let t = 0; t < h; t++){
                        const o = 2 * t * e, a = 2 * (t + 1) * e, h = Math.sqrt(2 * Math.pow(e, 2)), i = [
                            r[0] + o * Math.cos(c),
                            r[1] + o * Math.sin(c)
                        ], l = [
                            r[0] + a * Math.cos(c),
                            r[1] + a * Math.sin(c)
                        ], u = [
                            i[0] + h * Math.cos(c + Math.PI / 4),
                            i[1] + h * Math.sin(c + Math.PI / 4)
                        ];
                        n.push(...this.helper.doubleLineOps(i[0], i[1], u[0], u[1], s), ...this.helper.doubleLineOps(u[0], u[1], l[0], l[1], s));
                    }
                }), n;
            }
        }
        const u = {};
        class p {
            constructor(t){
                this.seed = t;
            }
            next() {
                return this.seed ? (2 ** 31 - 1 & (this.seed = Math.imul(48271, this.seed))) / 2 ** 31 : Math.random();
            }
        }
        const f = 0, d = 1, g = 2, M = {
            A: 7,
            a: 7,
            C: 6,
            c: 6,
            H: 1,
            h: 1,
            L: 2,
            l: 2,
            M: 2,
            m: 2,
            Q: 4,
            q: 4,
            S: 4,
            s: 4,
            T: 2,
            t: 2,
            V: 1,
            v: 1,
            Z: 0,
            z: 0
        };
        function k(t, e) {
            return t.type === e;
        }
        function b(t) {
            const e = [], s = function(t) {
                const e = new Array;
                for(; "" !== t;)if (t.match(/^([ \t\r\n,]+)/)) t = t.substr(RegExp.$1.length);
                else if (t.match(/^([aAcChHlLmMqQsStTvVzZ])/)) e[e.length] = {
                    type: f,
                    text: RegExp.$1
                }, t = t.substr(RegExp.$1.length);
                else {
                    if (!t.match(/^(([-+]?[0-9]+(\.[0-9]*)?|[-+]?\.[0-9]+)([eE][-+]?[0-9]+)?)/)) return [];
                    e[e.length] = {
                        type: d,
                        text: `${parseFloat(RegExp.$1)}`
                    }, t = t.substr(RegExp.$1.length);
                }
                return e[e.length] = {
                    type: g,
                    text: ""
                }, e;
            }(t);
            let n = "BOD", o = 0, a = s[o];
            for(; !k(a, g);){
                let h = 0;
                const r = [];
                if ("BOD" === n) {
                    if ("M" !== a.text && "m" !== a.text) return b("M0,0" + t);
                    o++, h = M[a.text], n = a.text;
                } else k(a, d) ? h = M[n] : (o++, h = M[a.text], n = a.text);
                if (!(o + h < s.length)) throw new Error("Path data ended short");
                for(let t = o; t < o + h; t++){
                    const e = s[t];
                    if (!k(e, d)) throw new Error("Param not a number: " + n + "," + e.text);
                    r[r.length] = +e.text;
                }
                if ("number" != typeof M[n]) throw new Error("Bad segment: " + n);
                {
                    const t = {
                        key: n,
                        data: r
                    };
                    e.push(t), o += h, a = s[o], "M" === n && (n = "L"), "m" === n && (n = "l");
                }
            }
            return e;
        }
        function y(t) {
            let e = 0, s = 0, n = 0, o = 0;
            const a = [];
            for (const { key: h, data: r } of t)switch(h){
                case "M":
                    a.push({
                        key: "M",
                        data: [
                            ...r
                        ]
                    }), [e, s] = r, [n, o] = r;
                    break;
                case "m":
                    e += r[0], s += r[1], a.push({
                        key: "M",
                        data: [
                            e,
                            s
                        ]
                    }), n = e, o = s;
                    break;
                case "L":
                    a.push({
                        key: "L",
                        data: [
                            ...r
                        ]
                    }), [e, s] = r;
                    break;
                case "l":
                    e += r[0], s += r[1], a.push({
                        key: "L",
                        data: [
                            e,
                            s
                        ]
                    });
                    break;
                case "C":
                    a.push({
                        key: "C",
                        data: [
                            ...r
                        ]
                    }), e = r[4], s = r[5];
                    break;
                case "c":
                    {
                        const t = r.map((t, n)=>n % 2 ? t + s : t + e);
                        a.push({
                            key: "C",
                            data: t
                        }), e = t[4], s = t[5];
                        break;
                    }
                case "Q":
                    a.push({
                        key: "Q",
                        data: [
                            ...r
                        ]
                    }), e = r[2], s = r[3];
                    break;
                case "q":
                    {
                        const t = r.map((t, n)=>n % 2 ? t + s : t + e);
                        a.push({
                            key: "Q",
                            data: t
                        }), e = t[2], s = t[3];
                        break;
                    }
                case "A":
                    a.push({
                        key: "A",
                        data: [
                            ...r
                        ]
                    }), e = r[5], s = r[6];
                    break;
                case "a":
                    e += r[5], s += r[6], a.push({
                        key: "A",
                        data: [
                            r[0],
                            r[1],
                            r[2],
                            r[3],
                            r[4],
                            e,
                            s
                        ]
                    });
                    break;
                case "H":
                    a.push({
                        key: "H",
                        data: [
                            ...r
                        ]
                    }), e = r[0];
                    break;
                case "h":
                    e += r[0], a.push({
                        key: "H",
                        data: [
                            e
                        ]
                    });
                    break;
                case "V":
                    a.push({
                        key: "V",
                        data: [
                            ...r
                        ]
                    }), s = r[0];
                    break;
                case "v":
                    s += r[0], a.push({
                        key: "V",
                        data: [
                            s
                        ]
                    });
                    break;
                case "S":
                    a.push({
                        key: "S",
                        data: [
                            ...r
                        ]
                    }), e = r[2], s = r[3];
                    break;
                case "s":
                    {
                        const t = r.map((t, n)=>n % 2 ? t + s : t + e);
                        a.push({
                            key: "S",
                            data: t
                        }), e = t[2], s = t[3];
                        break;
                    }
                case "T":
                    a.push({
                        key: "T",
                        data: [
                            ...r
                        ]
                    }), e = r[0], s = r[1];
                    break;
                case "t":
                    e += r[0], s += r[1], a.push({
                        key: "T",
                        data: [
                            e,
                            s
                        ]
                    });
                    break;
                case "Z":
                case "z":
                    a.push({
                        key: "Z",
                        data: []
                    }), e = n, s = o;
            }
            return a;
        }
        function m(t) {
            const e = [];
            let s = "", n = 0, o = 0, a = 0, h = 0, r = 0, i = 0;
            for (const { key: c, data: l } of t){
                switch(c){
                    case "M":
                        e.push({
                            key: "M",
                            data: [
                                ...l
                            ]
                        }), [n, o] = l, [a, h] = l;
                        break;
                    case "C":
                        e.push({
                            key: "C",
                            data: [
                                ...l
                            ]
                        }), n = l[4], o = l[5], r = l[2], i = l[3];
                        break;
                    case "L":
                        e.push({
                            key: "L",
                            data: [
                                ...l
                            ]
                        }), [n, o] = l;
                        break;
                    case "H":
                        n = l[0], e.push({
                            key: "L",
                            data: [
                                n,
                                o
                            ]
                        });
                        break;
                    case "V":
                        o = l[0], e.push({
                            key: "L",
                            data: [
                                n,
                                o
                            ]
                        });
                        break;
                    case "S":
                        {
                            let t = 0, a = 0;
                            "C" === s || "S" === s ? (t = n + (n - r), a = o + (o - i)) : (t = n, a = o), e.push({
                                key: "C",
                                data: [
                                    t,
                                    a,
                                    ...l
                                ]
                            }), r = l[0], i = l[1], n = l[2], o = l[3];
                            break;
                        }
                    case "T":
                        {
                            const [t, a] = l;
                            let h = 0, c = 0;
                            "Q" === s || "T" === s ? (h = n + (n - r), c = o + (o - i)) : (h = n, c = o);
                            const u = n + 2 * (h - n) / 3, p = o + 2 * (c - o) / 3, f = t + 2 * (h - t) / 3, d = a + 2 * (c - a) / 3;
                            e.push({
                                key: "C",
                                data: [
                                    u,
                                    p,
                                    f,
                                    d,
                                    t,
                                    a
                                ]
                            }), r = h, i = c, n = t, o = a;
                            break;
                        }
                    case "Q":
                        {
                            const [t, s, a, h] = l, c = n + 2 * (t - n) / 3, u = o + 2 * (s - o) / 3, p = a + 2 * (t - a) / 3, f = h + 2 * (s - h) / 3;
                            e.push({
                                key: "C",
                                data: [
                                    c,
                                    u,
                                    p,
                                    f,
                                    a,
                                    h
                                ]
                            }), r = t, i = s, n = a, o = h;
                            break;
                        }
                    case "A":
                        {
                            const t = Math.abs(l[0]), s = Math.abs(l[1]), a = l[2], h = l[3], r = l[4], i = l[5], c = l[6];
                            if (0 === t || 0 === s) e.push({
                                key: "C",
                                data: [
                                    n,
                                    o,
                                    i,
                                    c,
                                    i,
                                    c
                                ]
                            }), n = i, o = c;
                            else if (n !== i || o !== c) x(n, o, i, c, t, s, a, h, r).forEach(function(t) {
                                e.push({
                                    key: "C",
                                    data: t
                                });
                            }), n = i, o = c;
                            break;
                        }
                    case "Z":
                        e.push({
                            key: "Z",
                            data: []
                        }), n = a, o = h;
                }
                s = c;
            }
            return e;
        }
        function w(t, e, s) {
            return [
                t * Math.cos(s) - e * Math.sin(s),
                t * Math.sin(s) + e * Math.cos(s)
            ];
        }
        function x(t, e, s, n, o, a, h, r, i, c) {
            const l = (u = h, Math.PI * u / 180);
            var u;
            let p = [], f = 0, d = 0, g = 0, M = 0;
            if (c) [f, d, g, M] = c;
            else {
                [t, e] = w(t, e, -l), [s, n] = w(s, n, -l);
                const h = (t - s) / 2, c = (e - n) / 2;
                let u = h * h / (o * o) + c * c / (a * a);
                u > 1 && (u = Math.sqrt(u), o *= u, a *= u);
                const p = o * o, k = a * a, b = p * k - p * c * c - k * h * h, y = p * c * c + k * h * h, m = (r === i ? -1 : 1) * Math.sqrt(Math.abs(b / y));
                g = m * o * c / a + (t + s) / 2, M = m * -a * h / o + (e + n) / 2, f = Math.asin(parseFloat(((e - M) / a).toFixed(9))), d = Math.asin(parseFloat(((n - M) / a).toFixed(9))), t < g && (f = Math.PI - f), s < g && (d = Math.PI - d), f < 0 && (f = 2 * Math.PI + f), d < 0 && (d = 2 * Math.PI + d), i && f > d && (f -= 2 * Math.PI), !i && d > f && (d -= 2 * Math.PI);
            }
            let k = d - f;
            if (Math.abs(k) > 120 * Math.PI / 180) {
                const t = d, e = s, r = n;
                d = i && d > f ? f + 120 * Math.PI / 180 * 1 : f + 120 * Math.PI / 180 * -1, p = x(s = g + o * Math.cos(d), n = M + a * Math.sin(d), e, r, o, a, h, 0, i, [
                    d,
                    t,
                    g,
                    M
                ]);
            }
            k = d - f;
            const b = Math.cos(f), y = Math.sin(f), m = Math.cos(d), P = Math.sin(d), v = Math.tan(k / 4), S = 4 / 3 * o * v, O = 4 / 3 * a * v, L = [
                t,
                e
            ], T = [
                t + S * y,
                e - O * b
            ], D = [
                s + S * P,
                n - O * m
            ], A = [
                s,
                n
            ];
            if (T[0] = 2 * L[0] - T[0], T[1] = 2 * L[1] - T[1], c) return [
                T,
                D,
                A
            ].concat(p);
            {
                p = [
                    T,
                    D,
                    A
                ].concat(p);
                const t = [];
                for(let e = 0; e < p.length; e += 3){
                    const s = w(p[e][0], p[e][1], l), n = w(p[e + 1][0], p[e + 1][1], l), o = w(p[e + 2][0], p[e + 2][1], l);
                    t.push([
                        s[0],
                        s[1],
                        n[0],
                        n[1],
                        o[0],
                        o[1]
                    ]);
                }
                return t;
            }
        }
        const P = {
            randOffset: function(t, e) {
                return G(t, e);
            },
            randOffsetWithRange: function(t, e, s) {
                return E(t, e, s);
            },
            ellipse: function(t, e, s, n, o) {
                const a = T(s, n, o);
                return D(t, e, o, a).opset;
            },
            doubleLineOps: function(t, e, s, n, o) {
                return $(t, e, s, n, o, !0);
            }
        };
        function v(t, e, s, n, o) {
            return {
                type: "path",
                ops: $(t, e, s, n, o)
            };
        }
        function S(t, e, s) {
            const n = (t || []).length;
            if (n > 2) {
                const o = [];
                for(let e = 0; e < n - 1; e++)o.push(...$(t[e][0], t[e][1], t[e + 1][0], t[e + 1][1], s));
                return e && o.push(...$(t[n - 1][0], t[n - 1][1], t[0][0], t[0][1], s)), {
                    type: "path",
                    ops: o
                };
            }
            return 2 === n ? v(t[0][0], t[0][1], t[1][0], t[1][1], s) : {
                type: "path",
                ops: []
            };
        }
        function O(t, e, s, n, o) {
            return function(t, e) {
                return S(t, !0, e);
            }([
                [
                    t,
                    e
                ],
                [
                    t + s,
                    e
                ],
                [
                    t + s,
                    e + n
                ],
                [
                    t,
                    e + n
                ]
            ], o);
        }
        function L(t, e) {
            if (t.length) {
                const s = "number" == typeof t[0][0] ? [
                    t
                ] : t, n = j(s[0], 1 * (1 + .2 * e.roughness), e), o = e.disableMultiStroke ? [] : j(s[0], 1.5 * (1 + .22 * e.roughness), z(e));
                for(let t = 1; t < s.length; t++){
                    const a = s[t];
                    if (a.length) {
                        const t = j(a, 1 * (1 + .2 * e.roughness), e), s = e.disableMultiStroke ? [] : j(a, 1.5 * (1 + .22 * e.roughness), z(e));
                        for (const e of t)"move" !== e.op && n.push(e);
                        for (const t of s)"move" !== t.op && o.push(t);
                    }
                }
                return {
                    type: "path",
                    ops: n.concat(o)
                };
            }
            return {
                type: "path",
                ops: []
            };
        }
        function T(t, e, s) {
            const n = Math.sqrt(2 * Math.PI * Math.sqrt((Math.pow(t / 2, 2) + Math.pow(e / 2, 2)) / 2)), o = Math.ceil(Math.max(s.curveStepCount, s.curveStepCount / Math.sqrt(200) * n)), a = 2 * Math.PI / o;
            let h = Math.abs(t / 2), r = Math.abs(e / 2);
            const i = 1 - s.curveFitting;
            return h += G(h * i, s), r += G(r * i, s), {
                increment: a,
                rx: h,
                ry: r
            };
        }
        function D(t, e, s, n) {
            const [o, a] = F(n.increment, t, e, n.rx, n.ry, 1, n.increment * E(.1, E(.4, 1, s), s), s);
            let h = q(o, null, s);
            if (!s.disableMultiStroke && 0 !== s.roughness) {
                const [o] = F(n.increment, t, e, n.rx, n.ry, 1.5, 0, s), a = q(o, null, s);
                h = h.concat(a);
            }
            return {
                estimatedPoints: a,
                opset: {
                    type: "path",
                    ops: h
                }
            };
        }
        function A(t, e, s, n, o, a, h, r, i) {
            const c = t, l = e;
            let u = Math.abs(s / 2), p = Math.abs(n / 2);
            u += G(.01 * u, i), p += G(.01 * p, i);
            let f = o, d = a;
            for(; f < 0;)f += 2 * Math.PI, d += 2 * Math.PI;
            d - f > 2 * Math.PI && (f = 0, d = 2 * Math.PI);
            const g = 2 * Math.PI / i.curveStepCount, M = Math.min(g / 2, (d - f) / 2), k = V(M, c, l, u, p, f, d, 1, i);
            if (!i.disableMultiStroke) {
                const t = V(M, c, l, u, p, f, d, 1.5, i);
                k.push(...t);
            }
            return h && (r ? k.push(...$(c, l, c + u * Math.cos(f), l + p * Math.sin(f), i), ...$(c, l, c + u * Math.cos(d), l + p * Math.sin(d), i)) : k.push({
                op: "lineTo",
                data: [
                    c,
                    l
                ]
            }, {
                op: "lineTo",
                data: [
                    c + u * Math.cos(f),
                    l + p * Math.sin(f)
                ]
            })), {
                type: "path",
                ops: k
            };
        }
        function _(t, e) {
            const s = m(y(b(t))), n = [];
            let o = [
                0,
                0
            ], a = [
                0,
                0
            ];
            for (const { key: t, data: h } of s)switch(t){
                case "M":
                    a = [
                        h[0],
                        h[1]
                    ], o = [
                        h[0],
                        h[1]
                    ];
                    break;
                case "L":
                    n.push(...$(a[0], a[1], h[0], h[1], e)), a = [
                        h[0],
                        h[1]
                    ];
                    break;
                case "C":
                    {
                        const [t, s, o, r, i, c] = h;
                        n.push(...Z(t, s, o, r, i, c, a, e)), a = [
                            i,
                            c
                        ];
                        break;
                    }
                case "Z":
                    n.push(...$(a[0], a[1], o[0], o[1], e)), a = [
                        o[0],
                        o[1]
                    ];
            }
            return {
                type: "path",
                ops: n
            };
        }
        function I(t, e) {
            const s = [];
            for (const n of t)if (n.length) {
                const t = e.maxRandomnessOffset || 0, o = n.length;
                if (o > 2) {
                    s.push({
                        op: "move",
                        data: [
                            n[0][0] + G(t, e),
                            n[0][1] + G(t, e)
                        ]
                    });
                    for(let a = 1; a < o; a++)s.push({
                        op: "lineTo",
                        data: [
                            n[a][0] + G(t, e),
                            n[a][1] + G(t, e)
                        ]
                    });
                }
            }
            return {
                type: "fillPath",
                ops: s
            };
        }
        function C(t, e) {
            return (function(t, e) {
                let s = t.fillStyle || "hachure";
                if (!u[s]) switch(s){
                    case "zigzag":
                        u[s] || (u[s] = new h(e));
                        break;
                    case "cross-hatch":
                        u[s] || (u[s] = new r(e));
                        break;
                    case "dots":
                        u[s] || (u[s] = new i(e));
                        break;
                    case "dashed":
                        u[s] || (u[s] = new c(e));
                        break;
                    case "zigzag-line":
                        u[s] || (u[s] = new l(e));
                        break;
                    default:
                        s = "hachure", u[s] || (u[s] = new o(e));
                }
                return u[s];
            })(e, P).fillPolygons(t, e);
        }
        function z(t) {
            const e = Object.assign({}, t);
            return e.randomizer = void 0, t.seed && (e.seed = t.seed + 1), e;
        }
        function W(t) {
            return t.randomizer || (t.randomizer = new p(t.seed || 0)), t.randomizer.next();
        }
        function E(t, e, s, n = 1) {
            return s.roughness * n * (W(s) * (e - t) + t);
        }
        function G(t, e, s = 1) {
            return E(-t, t, e, s);
        }
        function $(t, e, s, n, o, a = !1) {
            const h = a ? o.disableMultiStrokeFill : o.disableMultiStroke, r = R(t, e, s, n, o, !0, !1);
            if (h) return r;
            const i = R(t, e, s, n, o, !0, !0);
            return r.concat(i);
        }
        function R(t, e, s, n, o, a, h) {
            const r = Math.pow(t - s, 2) + Math.pow(e - n, 2), i = Math.sqrt(r);
            let c = 1;
            c = i < 200 ? 1 : i > 500 ? .4 : -0.0016668 * i + 1.233334;
            let l = o.maxRandomnessOffset || 0;
            l * l * 100 > r && (l = i / 10);
            const u = l / 2, p = .2 + .2 * W(o);
            let f = o.bowing * o.maxRandomnessOffset * (n - e) / 200, d = o.bowing * o.maxRandomnessOffset * (t - s) / 200;
            f = G(f, o, c), d = G(d, o, c);
            const g = [], M = ()=>G(u, o, c), k = ()=>G(l, o, c), b = o.preserveVertices;
            return a && (h ? g.push({
                op: "move",
                data: [
                    t + (b ? 0 : M()),
                    e + (b ? 0 : M())
                ]
            }) : g.push({
                op: "move",
                data: [
                    t + (b ? 0 : G(l, o, c)),
                    e + (b ? 0 : G(l, o, c))
                ]
            })), h ? g.push({
                op: "bcurveTo",
                data: [
                    f + t + (s - t) * p + M(),
                    d + e + (n - e) * p + M(),
                    f + t + 2 * (s - t) * p + M(),
                    d + e + 2 * (n - e) * p + M(),
                    s + (b ? 0 : M()),
                    n + (b ? 0 : M())
                ]
            }) : g.push({
                op: "bcurveTo",
                data: [
                    f + t + (s - t) * p + k(),
                    d + e + (n - e) * p + k(),
                    f + t + 2 * (s - t) * p + k(),
                    d + e + 2 * (n - e) * p + k(),
                    s + (b ? 0 : k()),
                    n + (b ? 0 : k())
                ]
            }), g;
        }
        function j(t, e, s) {
            if (!t.length) return [];
            const n = [];
            n.push([
                t[0][0] + G(e, s),
                t[0][1] + G(e, s)
            ]), n.push([
                t[0][0] + G(e, s),
                t[0][1] + G(e, s)
            ]);
            for(let o = 1; o < t.length; o++)n.push([
                t[o][0] + G(e, s),
                t[o][1] + G(e, s)
            ]), o === t.length - 1 && n.push([
                t[o][0] + G(e, s),
                t[o][1] + G(e, s)
            ]);
            return q(n, null, s);
        }
        function q(t, e, s) {
            const n = t.length, o = [];
            if (n > 3) {
                const a = [], h = 1 - s.curveTightness;
                o.push({
                    op: "move",
                    data: [
                        t[1][0],
                        t[1][1]
                    ]
                });
                for(let e = 1; e + 2 < n; e++){
                    const s = t[e];
                    a[0] = [
                        s[0],
                        s[1]
                    ], a[1] = [
                        s[0] + (h * t[e + 1][0] - h * t[e - 1][0]) / 6,
                        s[1] + (h * t[e + 1][1] - h * t[e - 1][1]) / 6
                    ], a[2] = [
                        t[e + 1][0] + (h * t[e][0] - h * t[e + 2][0]) / 6,
                        t[e + 1][1] + (h * t[e][1] - h * t[e + 2][1]) / 6
                    ], a[3] = [
                        t[e + 1][0],
                        t[e + 1][1]
                    ], o.push({
                        op: "bcurveTo",
                        data: [
                            a[1][0],
                            a[1][1],
                            a[2][0],
                            a[2][1],
                            a[3][0],
                            a[3][1]
                        ]
                    });
                }
                if (e && 2 === e.length) {
                    const t = s.maxRandomnessOffset;
                    o.push({
                        op: "lineTo",
                        data: [
                            e[0] + G(t, s),
                            e[1] + G(t, s)
                        ]
                    });
                }
            } else 3 === n ? (o.push({
                op: "move",
                data: [
                    t[1][0],
                    t[1][1]
                ]
            }), o.push({
                op: "bcurveTo",
                data: [
                    t[1][0],
                    t[1][1],
                    t[2][0],
                    t[2][1],
                    t[2][0],
                    t[2][1]
                ]
            })) : 2 === n && o.push(...R(t[0][0], t[0][1], t[1][0], t[1][1], s, !0, !0));
            return o;
        }
        function F(t, e, s, n, o, a, h, r) {
            const i = [], c = [];
            if (0 === r.roughness) {
                t /= 4, c.push([
                    e + n * Math.cos(-t),
                    s + o * Math.sin(-t)
                ]);
                for(let a = 0; a <= 2 * Math.PI; a += t){
                    const t = [
                        e + n * Math.cos(a),
                        s + o * Math.sin(a)
                    ];
                    i.push(t), c.push(t);
                }
                c.push([
                    e + n * Math.cos(0),
                    s + o * Math.sin(0)
                ]), c.push([
                    e + n * Math.cos(t),
                    s + o * Math.sin(t)
                ]);
            } else {
                const l = G(.5, r) - Math.PI / 2;
                c.push([
                    G(a, r) + e + .9 * n * Math.cos(l - t),
                    G(a, r) + s + .9 * o * Math.sin(l - t)
                ]);
                const u = 2 * Math.PI + l - .01;
                for(let h = l; h < u; h += t){
                    const t = [
                        G(a, r) + e + n * Math.cos(h),
                        G(a, r) + s + o * Math.sin(h)
                    ];
                    i.push(t), c.push(t);
                }
                c.push([
                    G(a, r) + e + n * Math.cos(l + 2 * Math.PI + .5 * h),
                    G(a, r) + s + o * Math.sin(l + 2 * Math.PI + .5 * h)
                ]), c.push([
                    G(a, r) + e + .98 * n * Math.cos(l + h),
                    G(a, r) + s + .98 * o * Math.sin(l + h)
                ]), c.push([
                    G(a, r) + e + .9 * n * Math.cos(l + .5 * h),
                    G(a, r) + s + .9 * o * Math.sin(l + .5 * h)
                ]);
            }
            return [
                c,
                i
            ];
        }
        function V(t, e, s, n, o, a, h, r, i) {
            const c = a + G(.1, i), l = [];
            l.push([
                G(r, i) + e + .9 * n * Math.cos(c - t),
                G(r, i) + s + .9 * o * Math.sin(c - t)
            ]);
            for(let a = c; a <= h; a += t)l.push([
                G(r, i) + e + n * Math.cos(a),
                G(r, i) + s + o * Math.sin(a)
            ]);
            return l.push([
                e + n * Math.cos(h),
                s + o * Math.sin(h)
            ]), l.push([
                e + n * Math.cos(h),
                s + o * Math.sin(h)
            ]), q(l, null, i);
        }
        function Z(t, e, s, n, o, a, h, r) {
            const i = [], c = [
                r.maxRandomnessOffset || 1,
                (r.maxRandomnessOffset || 1) + .3
            ];
            let l = [
                0,
                0
            ];
            const u = r.disableMultiStroke ? 1 : 2, p = r.preserveVertices;
            for(let f = 0; f < u; f++)0 === f ? i.push({
                op: "move",
                data: [
                    h[0],
                    h[1]
                ]
            }) : i.push({
                op: "move",
                data: [
                    h[0] + (p ? 0 : G(c[0], r)),
                    h[1] + (p ? 0 : G(c[0], r))
                ]
            }), l = p ? [
                o,
                a
            ] : [
                o + G(c[f], r),
                a + G(c[f], r)
            ], i.push({
                op: "bcurveTo",
                data: [
                    t + G(c[f], r),
                    e + G(c[f], r),
                    s + G(c[f], r),
                    n + G(c[f], r),
                    l[0],
                    l[1]
                ]
            });
            return i;
        }
        function Q(t) {
            return [
                ...t
            ];
        }
        function H(t, e = 0) {
            const s = t.length;
            if (s < 3) throw new Error("A curve must have at least three points.");
            const n = [];
            if (3 === s) n.push(Q(t[0]), Q(t[1]), Q(t[2]), Q(t[2]));
            else {
                const s = [];
                s.push(t[0], t[0]);
                for(let e = 1; e < t.length; e++)s.push(t[e]), e === t.length - 1 && s.push(t[e]);
                const o = [], a = 1 - e;
                n.push(Q(s[0]));
                for(let t = 1; t + 2 < s.length; t++){
                    const e = s[t];
                    o[0] = [
                        e[0],
                        e[1]
                    ], o[1] = [
                        e[0] + (a * s[t + 1][0] - a * s[t - 1][0]) / 6,
                        e[1] + (a * s[t + 1][1] - a * s[t - 1][1]) / 6
                    ], o[2] = [
                        s[t + 1][0] + (a * s[t][0] - a * s[t + 2][0]) / 6,
                        s[t + 1][1] + (a * s[t][1] - a * s[t + 2][1]) / 6
                    ], o[3] = [
                        s[t + 1][0],
                        s[t + 1][1]
                    ], n.push(o[1], o[2], o[3]);
                }
            }
            return n;
        }
        function N(t, e) {
            return Math.pow(t[0] - e[0], 2) + Math.pow(t[1] - e[1], 2);
        }
        function B(t, e, s) {
            const n = N(e, s);
            if (0 === n) return N(t, e);
            let o = ((t[0] - e[0]) * (s[0] - e[0]) + (t[1] - e[1]) * (s[1] - e[1])) / n;
            return o = Math.max(0, Math.min(1, o)), N(t, J(e, s, o));
        }
        function J(t, e, s) {
            return [
                t[0] + (e[0] - t[0]) * s,
                t[1] + (e[1] - t[1]) * s
            ];
        }
        function K(t, e, s, n) {
            const o = n || [];
            if (function(t, e) {
                const s = t[e + 0], n = t[e + 1], o = t[e + 2], a = t[e + 3];
                let h = 3 * n[0] - 2 * s[0] - a[0];
                h *= h;
                let r = 3 * n[1] - 2 * s[1] - a[1];
                r *= r;
                let i = 3 * o[0] - 2 * a[0] - s[0];
                i *= i;
                let c = 3 * o[1] - 2 * a[1] - s[1];
                return c *= c, h < i && (h = i), r < c && (r = c), h + r;
            }(t, e) < s) {
                const s = t[e + 0];
                if (o.length) a = o[o.length - 1], h = s, Math.sqrt(N(a, h)) > 1 && o.push(s);
                else o.push(s);
                o.push(t[e + 3]);
            } else {
                const n = .5, a = t[e + 0], h = t[e + 1], r = t[e + 2], i = t[e + 3], c = J(a, h, n), l = J(h, r, n), u = J(r, i, n), p = J(c, l, n), f = J(l, u, n), d = J(p, f, n);
                K([
                    a,
                    c,
                    p,
                    d
                ], 0, s, o), K([
                    d,
                    f,
                    u,
                    i
                ], 0, s, o);
            }
            var a, h;
            return o;
        }
        function U(t, e) {
            return X(t, 0, t.length, e);
        }
        function X(t, e, s, n, o) {
            const a = o || [], h = t[e], r = t[s - 1];
            let i = 0, c = 1;
            for(let n = e + 1; n < s - 1; ++n){
                const e = B(t[n], h, r);
                e > i && (i = e, c = n);
            }
            return Math.sqrt(i) > n ? (X(t, e, c + 1, n, a), X(t, c, s, n, a)) : (a.length || a.push(h), a.push(r)), a;
        }
        function Y(t, e = .15, s) {
            const n = [], o = (t.length - 1) / 3;
            for(let s = 0; s < o; s++)K(t, 3 * s, e, n);
            return s && s > 0 ? X(n, 0, n.length, s) : n;
        }
        const tt = "none";
        class et {
            constructor(t){
                this.defaultOptions = {
                    maxRandomnessOffset: 2,
                    roughness: 1,
                    bowing: 1,
                    stroke: "#000",
                    strokeWidth: 1,
                    curveTightness: 0,
                    curveFitting: .95,
                    curveStepCount: 9,
                    fillStyle: "hachure",
                    fillWeight: -1,
                    hachureAngle: -41,
                    hachureGap: -1,
                    dashOffset: -1,
                    dashGap: -1,
                    zigzagOffset: -1,
                    seed: 0,
                    disableMultiStroke: !1,
                    disableMultiStrokeFill: !1,
                    preserveVertices: !1,
                    fillShapeRoughnessGain: .8
                }, this.config = t || {}, this.config.options && (this.defaultOptions = this._o(this.config.options));
            }
            static newSeed() {
                return Math.floor(Math.random() * 2 ** 31);
            }
            _o(t) {
                return t ? Object.assign({}, this.defaultOptions, t) : this.defaultOptions;
            }
            _d(t, e, s) {
                return {
                    shape: t,
                    sets: e || [],
                    options: s || this.defaultOptions
                };
            }
            line(t, e, s, n, o) {
                const a = this._o(o);
                return this._d("line", [
                    v(t, e, s, n, a)
                ], a);
            }
            rectangle(t, e, s, n, o) {
                const a = this._o(o), h = [], r = O(t, e, s, n, a);
                if (a.fill) {
                    const o = [
                        [
                            t,
                            e
                        ],
                        [
                            t + s,
                            e
                        ],
                        [
                            t + s,
                            e + n
                        ],
                        [
                            t,
                            e + n
                        ]
                    ];
                    "solid" === a.fillStyle ? h.push(I([
                        o
                    ], a)) : h.push(C([
                        o
                    ], a));
                }
                return a.stroke !== tt && h.push(r), this._d("rectangle", h, a);
            }
            ellipse(t, e, s, n, o) {
                const a = this._o(o), h = [], r = T(s, n, a), i = D(t, e, a, r);
                if (a.fill) {
                    if ("solid" === a.fillStyle) {
                        const s = D(t, e, a, r).opset;
                        s.type = "fillPath", h.push(s);
                    } else h.push(C([
                        i.estimatedPoints
                    ], a));
                }
                return a.stroke !== tt && h.push(i.opset), this._d("ellipse", h, a);
            }
            circle(t, e, s, n) {
                const o = this.ellipse(t, e, s, s, n);
                return o.shape = "circle", o;
            }
            linearPath(t, e) {
                const s = this._o(e);
                return this._d("linearPath", [
                    S(t, !1, s)
                ], s);
            }
            arc(t, e, s, n, o, a, h = !1, r) {
                const i = this._o(r), c = [], l = A(t, e, s, n, o, a, h, !0, i);
                if (h && i.fill) {
                    if ("solid" === i.fillStyle) {
                        const h = Object.assign({}, i);
                        h.disableMultiStroke = !0;
                        const r = A(t, e, s, n, o, a, !0, !1, h);
                        r.type = "fillPath", c.push(r);
                    } else c.push(function(t, e, s, n, o, a, h) {
                        const r = t, i = e;
                        let c = Math.abs(s / 2), l = Math.abs(n / 2);
                        c += G(.01 * c, h), l += G(.01 * l, h);
                        let u = o, p = a;
                        for(; u < 0;)u += 2 * Math.PI, p += 2 * Math.PI;
                        p - u > 2 * Math.PI && (u = 0, p = 2 * Math.PI);
                        const f = (p - u) / h.curveStepCount, d = [];
                        for(let t = u; t <= p; t += f)d.push([
                            r + c * Math.cos(t),
                            i + l * Math.sin(t)
                        ]);
                        return d.push([
                            r + c * Math.cos(p),
                            i + l * Math.sin(p)
                        ]), d.push([
                            r,
                            i
                        ]), C([
                            d
                        ], h);
                    }(t, e, s, n, o, a, i));
                }
                return i.stroke !== tt && c.push(l), this._d("arc", c, i);
            }
            curve(t, e) {
                const s = this._o(e), n = [], o = L(t, s);
                if (s.fill && s.fill !== tt) {
                    if ("solid" === s.fillStyle) {
                        const e = L(t, Object.assign(Object.assign({}, s), {
                            disableMultiStroke: !0,
                            roughness: s.roughness ? s.roughness + s.fillShapeRoughnessGain : 0
                        }));
                        n.push({
                            type: "fillPath",
                            ops: this._mergedShape(e.ops)
                        });
                    } else {
                        const e = [], o = t;
                        if (o.length) {
                            const t = "number" == typeof o[0][0] ? [
                                o
                            ] : o;
                            for (const n of t)n.length < 3 ? e.push(...n) : 3 === n.length ? e.push(...Y(H([
                                n[0],
                                n[0],
                                n[1],
                                n[2]
                            ]), 10, (1 + s.roughness) / 2)) : e.push(...Y(H(n), 10, (1 + s.roughness) / 2));
                        }
                        e.length && n.push(C([
                            e
                        ], s));
                    }
                }
                return s.stroke !== tt && n.push(o), this._d("curve", n, s);
            }
            polygon(t, e) {
                const s = this._o(e), n = [], o = S(t, !0, s);
                return s.fill && ("solid" === s.fillStyle ? n.push(I([
                    t
                ], s)) : n.push(C([
                    t
                ], s))), s.stroke !== tt && n.push(o), this._d("polygon", n, s);
            }
            path(t, e) {
                const s = this._o(e), n = [];
                if (!t) return this._d("path", n, s);
                t = (t || "").replace(/\n/g, " ").replace(/(-\s)/g, "-").replace("/(ss)/g", " ");
                const o = s.fill && "transparent" !== s.fill && s.fill !== tt, a = s.stroke !== tt, h = !!(s.simplification && s.simplification < 1), r = function(t, e, s) {
                    const n = m(y(b(t))), o = [];
                    let a = [], h = [
                        0,
                        0
                    ], r = [];
                    const i = ()=>{
                        r.length >= 4 && a.push(...Y(r, e)), r = [];
                    }, c = ()=>{
                        i(), a.length && (o.push(a), a = []);
                    };
                    for (const { key: t, data: e } of n)switch(t){
                        case "M":
                            c(), h = [
                                e[0],
                                e[1]
                            ], a.push(h);
                            break;
                        case "L":
                            i(), a.push([
                                e[0],
                                e[1]
                            ]);
                            break;
                        case "C":
                            if (!r.length) {
                                const t = a.length ? a[a.length - 1] : h;
                                r.push([
                                    t[0],
                                    t[1]
                                ]);
                            }
                            r.push([
                                e[0],
                                e[1]
                            ]), r.push([
                                e[2],
                                e[3]
                            ]), r.push([
                                e[4],
                                e[5]
                            ]);
                            break;
                        case "Z":
                            i(), a.push([
                                h[0],
                                h[1]
                            ]);
                    }
                    if (c(), !s) return o;
                    const l = [];
                    for (const t of o){
                        const e = U(t, s);
                        e.length && l.push(e);
                    }
                    return l;
                }(t, 1, h ? 4 - 4 * (s.simplification || 1) : (1 + s.roughness) / 2), i = _(t, s);
                if (o) {
                    if ("solid" === s.fillStyle) {
                        if (1 === r.length) {
                            const e = _(t, Object.assign(Object.assign({}, s), {
                                disableMultiStroke: !0,
                                roughness: s.roughness ? s.roughness + s.fillShapeRoughnessGain : 0
                            }));
                            n.push({
                                type: "fillPath",
                                ops: this._mergedShape(e.ops)
                            });
                        } else n.push(I(r, s));
                    } else n.push(C(r, s));
                }
                return a && (h ? r.forEach((t)=>{
                    n.push(S(t, !1, s));
                }) : n.push(i)), this._d("path", n, s);
            }
            opsToPath(t, e) {
                let s = "";
                for (const n of t.ops){
                    const t = "number" == typeof e && e >= 0 ? n.data.map((t)=>+t.toFixed(e)) : n.data;
                    switch(n.op){
                        case "move":
                            s += `M${t[0]} ${t[1]} `;
                            break;
                        case "bcurveTo":
                            s += `C${t[0]} ${t[1]}, ${t[2]} ${t[3]}, ${t[4]} ${t[5]} `;
                            break;
                        case "lineTo":
                            s += `L${t[0]} ${t[1]} `;
                    }
                }
                return s.trim();
            }
            toPaths(t) {
                const e = t.sets || [], s = t.options || this.defaultOptions, n = [];
                for (const t of e){
                    let e = null;
                    switch(t.type){
                        case "path":
                            e = {
                                d: this.opsToPath(t),
                                stroke: s.stroke,
                                strokeWidth: s.strokeWidth,
                                fill: tt
                            };
                            break;
                        case "fillPath":
                            e = {
                                d: this.opsToPath(t),
                                stroke: tt,
                                strokeWidth: 0,
                                fill: s.fill || tt
                            };
                            break;
                        case "fillSketch":
                            e = this.fillSketch(t, s);
                    }
                    e && n.push(e);
                }
                return n;
            }
            fillSketch(t, e) {
                let s = e.fillWeight;
                return s < 0 && (s = e.strokeWidth / 2), {
                    d: this.opsToPath(t),
                    stroke: e.fill || tt,
                    strokeWidth: s,
                    fill: tt
                };
            }
            _mergedShape(t) {
                return t.filter((t, e)=>0 === e || "move" !== t.op);
            }
        }
        class st {
            constructor(t, e){
                this.canvas = t, this.ctx = this.canvas.getContext("2d"), this.gen = new et(e);
            }
            draw(t) {
                const e = t.sets || [], s = t.options || this.getDefaultOptions(), n = this.ctx, o = t.options.fixedDecimalPlaceDigits;
                for (const a of e)switch(a.type){
                    case "path":
                        n.save(), n.strokeStyle = "none" === s.stroke ? "transparent" : s.stroke, n.lineWidth = s.strokeWidth, s.strokeLineDash && n.setLineDash(s.strokeLineDash), s.strokeLineDashOffset && (n.lineDashOffset = s.strokeLineDashOffset), this._drawToContext(n, a, o), n.restore();
                        break;
                    case "fillPath":
                        {
                            n.save(), n.fillStyle = s.fill || "";
                            const e = "curve" === t.shape || "polygon" === t.shape || "path" === t.shape ? "evenodd" : "nonzero";
                            this._drawToContext(n, a, o, e), n.restore();
                            break;
                        }
                    case "fillSketch":
                        this.fillSketch(n, a, s);
                }
            }
            fillSketch(t, e, s) {
                let n = s.fillWeight;
                n < 0 && (n = s.strokeWidth / 2), t.save(), s.fillLineDash && t.setLineDash(s.fillLineDash), s.fillLineDashOffset && (t.lineDashOffset = s.fillLineDashOffset), t.strokeStyle = s.fill || "", t.lineWidth = n, this._drawToContext(t, e, s.fixedDecimalPlaceDigits), t.restore();
            }
            _drawToContext(t, e, s, n = "nonzero") {
                t.beginPath();
                for (const n of e.ops){
                    const e = "number" == typeof s && s >= 0 ? n.data.map((t)=>+t.toFixed(s)) : n.data;
                    switch(n.op){
                        case "move":
                            t.moveTo(e[0], e[1]);
                            break;
                        case "bcurveTo":
                            t.bezierCurveTo(e[0], e[1], e[2], e[3], e[4], e[5]);
                            break;
                        case "lineTo":
                            t.lineTo(e[0], e[1]);
                    }
                }
                "fillPath" === e.type ? t.fill(n) : t.stroke();
            }
            get generator() {
                return this.gen;
            }
            getDefaultOptions() {
                return this.gen.defaultOptions;
            }
            line(t, e, s, n, o) {
                const a = this.gen.line(t, e, s, n, o);
                return this.draw(a), a;
            }
            rectangle(t, e, s, n, o) {
                const a = this.gen.rectangle(t, e, s, n, o);
                return this.draw(a), a;
            }
            ellipse(t, e, s, n, o) {
                const a = this.gen.ellipse(t, e, s, n, o);
                return this.draw(a), a;
            }
            circle(t, e, s, n) {
                const o = this.gen.circle(t, e, s, n);
                return this.draw(o), o;
            }
            linearPath(t, e) {
                const s = this.gen.linearPath(t, e);
                return this.draw(s), s;
            }
            polygon(t, e) {
                const s = this.gen.polygon(t, e);
                return this.draw(s), s;
            }
            arc(t, e, s, n, o, a, h = !1, r) {
                const i = this.gen.arc(t, e, s, n, o, a, h, r);
                return this.draw(i), i;
            }
            curve(t, e) {
                const s = this.gen.curve(t, e);
                return this.draw(s), s;
            }
            path(t, e) {
                const s = this.gen.path(t, e);
                return this.draw(s), s;
            }
        }
        const nt = "http://www.w3.org/2000/svg";
        class ot {
            constructor(t, e){
                this.svg = t, this.gen = new et(e);
            }
            draw(t) {
                const e = t.sets || [], s = t.options || this.getDefaultOptions(), n = this.svg.ownerDocument || window.document, o = n.createElementNS(nt, "g"), a = t.options.fixedDecimalPlaceDigits;
                for (const h of e){
                    let e = null;
                    switch(h.type){
                        case "path":
                            e = n.createElementNS(nt, "path"), e.setAttribute("d", this.opsToPath(h, a)), e.setAttribute("stroke", s.stroke), e.setAttribute("stroke-width", s.strokeWidth + ""), e.setAttribute("fill", "none"), s.strokeLineDash && e.setAttribute("stroke-dasharray", s.strokeLineDash.join(" ").trim()), s.strokeLineDashOffset && e.setAttribute("stroke-dashoffset", `${s.strokeLineDashOffset}`);
                            break;
                        case "fillPath":
                            e = n.createElementNS(nt, "path"), e.setAttribute("d", this.opsToPath(h, a)), e.setAttribute("stroke", "none"), e.setAttribute("stroke-width", "0"), e.setAttribute("fill", s.fill || ""), "curve" !== t.shape && "polygon" !== t.shape || e.setAttribute("fill-rule", "evenodd");
                            break;
                        case "fillSketch":
                            e = this.fillSketch(n, h, s);
                    }
                    e && o.appendChild(e);
                }
                return o;
            }
            fillSketch(t, e, s) {
                let n = s.fillWeight;
                n < 0 && (n = s.strokeWidth / 2);
                const o = t.createElementNS(nt, "path");
                return o.setAttribute("d", this.opsToPath(e, s.fixedDecimalPlaceDigits)), o.setAttribute("stroke", s.fill || ""), o.setAttribute("stroke-width", n + ""), o.setAttribute("fill", "none"), s.fillLineDash && o.setAttribute("stroke-dasharray", s.fillLineDash.join(" ").trim()), s.fillLineDashOffset && o.setAttribute("stroke-dashoffset", `${s.fillLineDashOffset}`), o;
            }
            get generator() {
                return this.gen;
            }
            getDefaultOptions() {
                return this.gen.defaultOptions;
            }
            opsToPath(t, e) {
                return this.gen.opsToPath(t, e);
            }
            line(t, e, s, n, o) {
                const a = this.gen.line(t, e, s, n, o);
                return this.draw(a);
            }
            rectangle(t, e, s, n, o) {
                const a = this.gen.rectangle(t, e, s, n, o);
                return this.draw(a);
            }
            ellipse(t, e, s, n, o) {
                const a = this.gen.ellipse(t, e, s, n, o);
                return this.draw(a);
            }
            circle(t, e, s, n) {
                const o = this.gen.circle(t, e, s, n);
                return this.draw(o);
            }
            linearPath(t, e) {
                const s = this.gen.linearPath(t, e);
                return this.draw(s);
            }
            polygon(t, e) {
                const s = this.gen.polygon(t, e);
                return this.draw(s);
            }
            arc(t, e, s, n, o, a, h = !1, r) {
                const i = this.gen.arc(t, e, s, n, o, a, h, r);
                return this.draw(i);
            }
            curve(t, e) {
                const s = this.gen.curve(t, e);
                return this.draw(s);
            }
            path(t, e) {
                const s = this.gen.path(t, e);
                return this.draw(s);
            }
        }
        var at = {
            canvas: (t, e)=>new st(t, e),
            svg: (t, e)=>new ot(t, e),
            generator: (t)=>new et(t),
            newSeed: ()=>et.newSeed()
        };
    },
    "./node_modules/.pnpm/ts-dedent@2.2.0/node_modules/ts-dedent/esm/index.js": function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>dedent
        });
        function dedent(templ) {
            var values = [];
            for(var _i = 1; _i < arguments.length; _i++)values[_i - 1] = arguments[_i];
            var strings = Array.from('string' == typeof templ ? [
                templ
            ] : templ);
            strings[strings.length - 1] = strings[strings.length - 1].replace(/\r?\n([\t ]*)$/, '');
            var indentLengths = strings.reduce(function(arr, str) {
                var matches = str.match(/\n([\t ]+|(?!\s).)/g);
                if (matches) return arr.concat(matches.map(function(match) {
                    var _a, _b;
                    return null !== (_b = null === (_a = match.match(/[\t ]/g)) || void 0 === _a ? void 0 : _a.length) && void 0 !== _b ? _b : 0;
                }));
                return arr;
            }, []);
            if (indentLengths.length) {
                var pattern_1 = new RegExp("\n[\t ]{" + Math.min.apply(Math, indentLengths) + "}", 'g');
                strings = strings.map(function(str) {
                    return str.replace(pattern_1, '\n');
                });
            }
            strings[0] = strings[0].replace(/^\r?\n/, '');
            var string = strings[0];
            values.forEach(function(value, i) {
                var endentations = string.match(/(?:^|\n)( *)$/);
                var endentation = endentations ? endentations[1] : '';
                var indentedValue = value;
                if ('string' == typeof value && value.includes('\n')) indentedValue = String(value).split('\n').map(function(str, i) {
                    return 0 === i ? str : "" + endentation + str;
                }).join('\n');
                string += indentedValue + strings[i + 1];
            });
            return string;
        }
    },
    "./node_modules/.pnpm/d3@7.9.0/node_modules/d3/src/index.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Fp7: ()=>max_max,
            qpX: ()=>bumpX,
            S1K: ()=>second_second,
            iJ: ()=>stepBefore,
            LqH: ()=>timeSaturday,
            PKp: ()=>ordinal,
            Z_i: ()=>timeMinute,
            jvg: ()=>src_line,
            VV$: ()=>min_min,
            Ox9: ()=>timeMonday,
            tFB: ()=>curve_bundle,
            $0Z: ()=>curve_basis,
            WQD: ()=>timeHour,
            dCK: ()=>cardinalOpen,
            c_6: ()=>curve_linear,
            YY7: ()=>curve_cardinal,
            zgE: ()=>curve_catmullRom,
            F5q: ()=>axisTop,
            jsv: ()=>stepAfter,
            BYU: ()=>linear_linear,
            Zyz: ()=>timeSunday,
            Dts: ()=>curve_basisClosed,
            YDX: ()=>timeTuesday,
            ve8: ()=>src_pie,
            $m7: ()=>catmullRomOpen,
            K2I: ()=>Tableau10,
            Nb1: ()=>src_arc,
            fGX: ()=>catmullRomClosed,
            rr1: ()=>timeDay,
            JHv: ()=>src_hcl,
            tiA: ()=>band,
            U8T: ()=>millisecond,
            LLu: ()=>axisBottom,
            SxZ: ()=>natural,
            F0B: ()=>timeMonth,
            WQY: ()=>basisOpen,
            Ys: ()=>src_select,
            OvA: ()=>cardinalClosed,
            ak_: ()=>monotoneY,
            eA_: ()=>curve_step,
            y2j: ()=>timeFriday,
            EFj: ()=>timeWednesday,
            u93: ()=>bumpY,
            fxm: ()=>linearClosed,
            Igq: ()=>timeThursday,
            i$Z: ()=>timeFormat,
            Xf: ()=>time_time,
            FdL: ()=>monotoneX
        });
        function max_max(values, valueof) {
            let max;
            if (void 0 === valueof) {
                for (const value of values)if (null != value && (max < value || void 0 === max && value >= value)) max = value;
            } else {
                let index = -1;
                for (let value of values)if (null != (value = valueof(value, ++index, values)) && (max < value || void 0 === max && value >= value)) max = value;
            }
            return max;
        }
        function min_min(values, valueof) {
            let min;
            if (void 0 === valueof) {
                for (const value of values)if (null != value && (min > value || void 0 === min && value >= value)) min = value;
            } else {
                let index = -1;
                for (let value of values)if (null != (value = valueof(value, ++index, values)) && (min > value || void 0 === min && value >= value)) min = value;
            }
            return min;
        }
        function src_identity(x) {
            return x;
        }
        var axis_top = 1, axis_right = 2, bottom = 3, axis_left = 4, epsilon = 1e-6;
        function translateX(x) {
            return "translate(" + x + ",0)";
        }
        function translateY(y) {
            return "translate(0," + y + ")";
        }
        function number(scale) {
            return (d)=>+scale(d);
        }
        function axis_center(scale, offset) {
            offset = Math.max(0, scale.bandwidth() - 2 * offset) / 2;
            if (scale.round()) offset = Math.round(offset);
            return (d)=>+scale(d) + offset;
        }
        function entering() {
            return !this.__axis;
        }
        function axis_axis(orient, scale) {
            var tickArguments = [], tickValues = null, tickFormat = null, tickSizeInner = 6, tickSizeOuter = 6, tickPadding = 3, offset = "undefined" != typeof window && window.devicePixelRatio > 1 ? 0 : 0.5, k = orient === axis_top || orient === axis_left ? -1 : 1, x = orient === axis_left || orient === axis_right ? "x" : "y", transform = orient === axis_top || orient === bottom ? translateX : translateY;
            function axis(context) {
                var values = null == tickValues ? scale.ticks ? scale.ticks.apply(scale, tickArguments) : scale.domain() : tickValues, format = null == tickFormat ? scale.tickFormat ? scale.tickFormat.apply(scale, tickArguments) : src_identity : tickFormat, spacing = Math.max(tickSizeInner, 0) + tickPadding, range = scale.range(), range0 = +range[0] + offset, range1 = +range[range.length - 1] + offset, position = (scale.bandwidth ? axis_center : number)(scale.copy(), offset), selection = context.selection ? context.selection() : context, path = selection.selectAll(".domain").data([
                    null
                ]), tick = selection.selectAll(".tick").data(values, scale).order(), tickExit = tick.exit(), tickEnter = tick.enter().append("g").attr("class", "tick"), line = tick.select("line"), text = tick.select("text");
                path = path.merge(path.enter().insert("path", ".tick").attr("class", "domain").attr("stroke", "currentColor"));
                tick = tick.merge(tickEnter);
                line = line.merge(tickEnter.append("line").attr("stroke", "currentColor").attr(x + "2", k * tickSizeInner));
                text = text.merge(tickEnter.append("text").attr("fill", "currentColor").attr(x, k * spacing).attr("dy", orient === axis_top ? "0em" : orient === bottom ? "0.71em" : "0.32em"));
                if (context !== selection) {
                    path = path.transition(context);
                    tick = tick.transition(context);
                    line = line.transition(context);
                    text = text.transition(context);
                    tickExit = tickExit.transition(context).attr("opacity", epsilon).attr("transform", function(d) {
                        return isFinite(d = position(d)) ? transform(d + offset) : this.getAttribute("transform");
                    });
                    tickEnter.attr("opacity", epsilon).attr("transform", function(d) {
                        var p = this.parentNode.__axis;
                        return transform((p && isFinite(p = p(d)) ? p : position(d)) + offset);
                    });
                }
                tickExit.remove();
                path.attr("d", orient === axis_left || orient === axis_right ? tickSizeOuter ? "M" + k * tickSizeOuter + "," + range0 + "H" + offset + "V" + range1 + "H" + k * tickSizeOuter : "M" + offset + "," + range0 + "V" + range1 : tickSizeOuter ? "M" + range0 + "," + k * tickSizeOuter + "V" + offset + "H" + range1 + "V" + k * tickSizeOuter : "M" + range0 + "," + offset + "H" + range1);
                tick.attr("opacity", 1).attr("transform", function(d) {
                    return transform(position(d) + offset);
                });
                line.attr(x + "2", k * tickSizeInner);
                text.attr(x, k * spacing).text(format);
                selection.filter(entering).attr("fill", "none").attr("font-size", 10).attr("font-family", "sans-serif").attr("text-anchor", orient === axis_right ? "start" : orient === axis_left ? "end" : "middle");
                selection.each(function() {
                    this.__axis = position;
                });
            }
            axis.scale = function(_) {
                return arguments.length ? (scale = _, axis) : scale;
            };
            axis.ticks = function() {
                return tickArguments = Array.from(arguments), axis;
            };
            axis.tickArguments = function(_) {
                return arguments.length ? (tickArguments = null == _ ? [] : Array.from(_), axis) : tickArguments.slice();
            };
            axis.tickValues = function(_) {
                return arguments.length ? (tickValues = null == _ ? null : Array.from(_), axis) : tickValues && tickValues.slice();
            };
            axis.tickFormat = function(_) {
                return arguments.length ? (tickFormat = _, axis) : tickFormat;
            };
            axis.tickSize = function(_) {
                return arguments.length ? (tickSizeInner = tickSizeOuter = +_, axis) : tickSizeInner;
            };
            axis.tickSizeInner = function(_) {
                return arguments.length ? (tickSizeInner = +_, axis) : tickSizeInner;
            };
            axis.tickSizeOuter = function(_) {
                return arguments.length ? (tickSizeOuter = +_, axis) : tickSizeOuter;
            };
            axis.tickPadding = function(_) {
                return arguments.length ? (tickPadding = +_, axis) : tickPadding;
            };
            axis.offset = function(_) {
                return arguments.length ? (offset = +_, axis) : offset;
            };
            return axis;
        }
        function axisTop(scale) {
            return axis_axis(axis_top, scale);
        }
        function axisBottom(scale) {
            return axis_axis(bottom, scale);
        }
        function none() {}
        function src_selector(selector) {
            return null == selector ? none : function() {
                return this.querySelector(selector);
            };
        }
        function selection_select(select) {
            if ("function" != typeof select) select = src_selector(select);
            for(var groups = this._groups, m = groups.length, subgroups = new Array(m), j = 0; j < m; ++j)for(var group = groups[j], n = group.length, subgroup = subgroups[j] = new Array(n), node, subnode, i = 0; i < n; ++i)if ((node = group[i]) && (subnode = select.call(node, node.__data__, i, group))) {
                if ("__data__" in node) subnode.__data__ = node.__data__;
                subgroup[i] = subnode;
            }
            return new Selection(subgroups, this._parents);
        }
        function array(x) {
            return null == x ? [] : Array.isArray(x) ? x : Array.from(x);
        }
        function selectorAll_empty() {
            return [];
        }
        function selectorAll(selector) {
            return null == selector ? selectorAll_empty : function() {
                return this.querySelectorAll(selector);
            };
        }
        function arrayAll(select) {
            return function() {
                return array(select.apply(this, arguments));
            };
        }
        function selectAll(select) {
            select = "function" == typeof select ? arrayAll(select) : selectorAll(select);
            for(var groups = this._groups, m = groups.length, subgroups = [], parents = [], j = 0; j < m; ++j)for(var group = groups[j], n = group.length, node, i = 0; i < n; ++i)if (node = group[i]) {
                subgroups.push(select.call(node, node.__data__, i, group));
                parents.push(node);
            }
            return new Selection(subgroups, parents);
        }
        function matcher(selector) {
            return function() {
                return this.matches(selector);
            };
        }
        function childMatcher(selector) {
            return function(node) {
                return node.matches(selector);
            };
        }
        var find = Array.prototype.find;
        function childFind(match) {
            return function() {
                return find.call(this.children, match);
            };
        }
        function childFirst() {
            return this.firstElementChild;
        }
        function selectChild(match) {
            return this.select(null == match ? childFirst : childFind("function" == typeof match ? match : childMatcher(match)));
        }
        var selectChildren_filter = Array.prototype.filter;
        function selectChildren_children() {
            return Array.from(this.children);
        }
        function childrenFilter(match) {
            return function() {
                return selectChildren_filter.call(this.children, match);
            };
        }
        function selectChildren(match) {
            return this.selectAll(null == match ? selectChildren_children : childrenFilter("function" == typeof match ? match : childMatcher(match)));
        }
        function selection_filter(match) {
            if ("function" != typeof match) match = matcher(match);
            for(var groups = this._groups, m = groups.length, subgroups = new Array(m), j = 0; j < m; ++j)for(var group = groups[j], n = group.length, subgroup = subgroups[j] = [], node, i = 0; i < n; ++i)if ((node = group[i]) && match.call(node, node.__data__, i, group)) subgroup.push(node);
            return new Selection(subgroups, this._parents);
        }
        function sparse(update) {
            return new Array(update.length);
        }
        function selection_enter() {
            return new Selection(this._enter || this._groups.map(sparse), this._parents);
        }
        function EnterNode(parent, datum) {
            this.ownerDocument = parent.ownerDocument;
            this.namespaceURI = parent.namespaceURI;
            this._next = null;
            this._parent = parent;
            this.__data__ = datum;
        }
        EnterNode.prototype = {
            constructor: EnterNode,
            appendChild: function(child) {
                return this._parent.insertBefore(child, this._next);
            },
            insertBefore: function(child, next) {
                return this._parent.insertBefore(child, next);
            },
            querySelector: function(selector) {
                return this._parent.querySelector(selector);
            },
            querySelectorAll: function(selector) {
                return this._parent.querySelectorAll(selector);
            }
        };
        function src_constant(x) {
            return function() {
                return x;
            };
        }
        function bindIndex(parent, group, enter, update, exit, data) {
            var i = 0, node, groupLength = group.length, dataLength = data.length;
            for(; i < dataLength; ++i)if (node = group[i]) {
                node.__data__ = data[i];
                update[i] = node;
            } else enter[i] = new EnterNode(parent, data[i]);
            for(; i < groupLength; ++i)if (node = group[i]) exit[i] = node;
        }
        function bindKey(parent, group, enter, update, exit, data, key) {
            var i, node, nodeByKeyValue = new Map, groupLength = group.length, dataLength = data.length, keyValues = new Array(groupLength), keyValue;
            for(i = 0; i < groupLength; ++i)if (node = group[i]) {
                keyValues[i] = keyValue = key.call(node, node.__data__, i, group) + "";
                if (nodeByKeyValue.has(keyValue)) exit[i] = node;
                else nodeByKeyValue.set(keyValue, node);
            }
            for(i = 0; i < dataLength; ++i){
                keyValue = key.call(parent, data[i], i, data) + "";
                if (node = nodeByKeyValue.get(keyValue)) {
                    update[i] = node;
                    node.__data__ = data[i];
                    nodeByKeyValue.delete(keyValue);
                } else enter[i] = new EnterNode(parent, data[i]);
            }
            for(i = 0; i < groupLength; ++i)if ((node = group[i]) && nodeByKeyValue.get(keyValues[i]) === node) exit[i] = node;
        }
        function data_datum(node) {
            return node.__data__;
        }
        function selection_data(value, key) {
            if (!arguments.length) return Array.from(this, data_datum);
            var bind = key ? bindKey : bindIndex, parents = this._parents, groups = this._groups;
            if ("function" != typeof value) value = src_constant(value);
            for(var m = groups.length, update = new Array(m), enter = new Array(m), exit = new Array(m), j = 0; j < m; ++j){
                var parent = parents[j], group = groups[j], groupLength = group.length, data = arraylike(value.call(parent, parent && parent.__data__, j, parents)), dataLength = data.length, enterGroup = enter[j] = new Array(dataLength), updateGroup = update[j] = new Array(dataLength), exitGroup = exit[j] = new Array(groupLength);
                bind(parent, group, enterGroup, updateGroup, exitGroup, data, key);
                for(var i0 = 0, i1 = 0, previous, next; i0 < dataLength; ++i0)if (previous = enterGroup[i0]) {
                    if (i0 >= i1) i1 = i0 + 1;
                    while(!(next = updateGroup[i1]) && ++i1 < dataLength);
                    previous._next = next || null;
                }
            }
            update = new Selection(update, parents);
            update._enter = enter;
            update._exit = exit;
            return update;
        }
        function arraylike(data) {
            return "object" == typeof data && "length" in data ? data : Array.from(data);
        }
        function selection_exit() {
            return new Selection(this._exit || this._groups.map(sparse), this._parents);
        }
        function join(onenter, onupdate, onexit) {
            var enter = this.enter(), update = this, exit = this.exit();
            if ("function" == typeof onenter) {
                enter = onenter(enter);
                if (enter) enter = enter.selection();
            } else enter = enter.append(onenter + "");
            if (null != onupdate) {
                update = onupdate(update);
                if (update) update = update.selection();
            }
            if (null == onexit) exit.remove();
            else onexit(exit);
            return enter && update ? enter.merge(update).order() : update;
        }
        function selection_merge(context) {
            var selection = context.selection ? context.selection() : context;
            for(var groups0 = this._groups, groups1 = selection._groups, m0 = groups0.length, m1 = groups1.length, m = Math.min(m0, m1), merges = new Array(m0), j = 0; j < m; ++j)for(var group0 = groups0[j], group1 = groups1[j], n = group0.length, merge = merges[j] = new Array(n), node, i = 0; i < n; ++i)if (node = group0[i] || group1[i]) merge[i] = node;
            for(; j < m0; ++j)merges[j] = groups0[j];
            return new Selection(merges, this._parents);
        }
        function order() {
            for(var groups = this._groups, j = -1, m = groups.length; ++j < m;)for(var group = groups[j], i = group.length - 1, next = group[i], node; --i >= 0;)if (node = group[i]) {
                if (next && 4 ^ node.compareDocumentPosition(next)) next.parentNode.insertBefore(node, next);
                next = node;
            }
            return this;
        }
        function selection_sort(compare) {
            if (!compare) compare = ascending;
            function compareNode(a, b) {
                return a && b ? compare(a.__data__, b.__data__) : !a - !b;
            }
            for(var groups = this._groups, m = groups.length, sortgroups = new Array(m), j = 0; j < m; ++j){
                for(var group = groups[j], n = group.length, sortgroup = sortgroups[j] = new Array(n), node, i = 0; i < n; ++i)if (node = group[i]) sortgroup[i] = node;
                sortgroup.sort(compareNode);
            }
            return new Selection(sortgroups, this._parents).order();
        }
        function ascending(a, b) {
            return a < b ? -1 : a > b ? 1 : a >= b ? 0 : NaN;
        }
        function call() {
            var callback = arguments[0];
            arguments[0] = this;
            callback.apply(null, arguments);
            return this;
        }
        function nodes() {
            return Array.from(this);
        }
        function selection_node() {
            for(var groups = this._groups, j = 0, m = groups.length; j < m; ++j)for(var group = groups[j], i = 0, n = group.length; i < n; ++i){
                var node = group[i];
                if (node) return node;
            }
            return null;
        }
        function selection_size() {
            let size = 0;
            for (const node of this)++size;
            return size;
        }
        function selection_empty() {
            return !this.node();
        }
        function each(callback) {
            for(var groups = this._groups, j = 0, m = groups.length; j < m; ++j)for(var group = groups[j], i = 0, n = group.length, node; i < n; ++i)if (node = group[i]) callback.call(node, node.__data__, i, group);
            return this;
        }
        var xhtml = "http://www.w3.org/1999/xhtml";
        const namespaces = {
            svg: "http://www.w3.org/2000/svg",
            xhtml: xhtml,
            xlink: "http://www.w3.org/1999/xlink",
            xml: "http://www.w3.org/XML/1998/namespace",
            xmlns: "http://www.w3.org/2000/xmlns/"
        };
        function namespace(name) {
            var prefix = name += "", i = prefix.indexOf(":");
            if (i >= 0 && "xmlns" !== (prefix = name.slice(0, i))) name = name.slice(i + 1);
            return namespaces.hasOwnProperty(prefix) ? {
                space: namespaces[prefix],
                local: name
            } : name;
        }
        function attrRemove(name) {
            return function() {
                this.removeAttribute(name);
            };
        }
        function attrRemoveNS(fullname) {
            return function() {
                this.removeAttributeNS(fullname.space, fullname.local);
            };
        }
        function attrConstant(name, value) {
            return function() {
                this.setAttribute(name, value);
            };
        }
        function attrConstantNS(fullname, value) {
            return function() {
                this.setAttributeNS(fullname.space, fullname.local, value);
            };
        }
        function attrFunction(name, value) {
            return function() {
                var v = value.apply(this, arguments);
                if (null == v) this.removeAttribute(name);
                else this.setAttribute(name, v);
            };
        }
        function attrFunctionNS(fullname, value) {
            return function() {
                var v = value.apply(this, arguments);
                if (null == v) this.removeAttributeNS(fullname.space, fullname.local);
                else this.setAttributeNS(fullname.space, fullname.local, v);
            };
        }
        function attr(name, value) {
            var fullname = namespace(name);
            if (arguments.length < 2) {
                var node = this.node();
                return fullname.local ? node.getAttributeNS(fullname.space, fullname.local) : node.getAttribute(fullname);
            }
            return this.each((null == value ? fullname.local ? attrRemoveNS : attrRemove : "function" == typeof value ? fullname.local ? attrFunctionNS : attrFunction : fullname.local ? attrConstantNS : attrConstant)(fullname, value));
        }
        function src_window(node) {
            return node.ownerDocument && node.ownerDocument.defaultView || node.document && node || node.defaultView;
        }
        function styleRemove(name) {
            return function() {
                this.style.removeProperty(name);
            };
        }
        function styleConstant(name, value, priority) {
            return function() {
                this.style.setProperty(name, value, priority);
            };
        }
        function styleFunction(name, value, priority) {
            return function() {
                var v = value.apply(this, arguments);
                if (null == v) this.style.removeProperty(name);
                else this.style.setProperty(name, v, priority);
            };
        }
        function style(name, value, priority) {
            return arguments.length > 1 ? this.each((null == value ? styleRemove : "function" == typeof value ? styleFunction : styleConstant)(name, value, null == priority ? "" : priority)) : styleValue(this.node(), name);
        }
        function styleValue(node, name) {
            return node.style.getPropertyValue(name) || src_window(node).getComputedStyle(node, null).getPropertyValue(name);
        }
        function propertyRemove(name) {
            return function() {
                delete this[name];
            };
        }
        function propertyConstant(name, value) {
            return function() {
                this[name] = value;
            };
        }
        function propertyFunction(name, value) {
            return function() {
                var v = value.apply(this, arguments);
                if (null == v) delete this[name];
                else this[name] = v;
            };
        }
        function property(name, value) {
            return arguments.length > 1 ? this.each((null == value ? propertyRemove : "function" == typeof value ? propertyFunction : propertyConstant)(name, value)) : this.node()[name];
        }
        function classArray(string) {
            return string.trim().split(/^|\s+/);
        }
        function classList(node) {
            return node.classList || new ClassList(node);
        }
        function ClassList(node) {
            this._node = node;
            this._names = classArray(node.getAttribute("class") || "");
        }
        ClassList.prototype = {
            add: function(name) {
                var i = this._names.indexOf(name);
                if (i < 0) {
                    this._names.push(name);
                    this._node.setAttribute("class", this._names.join(" "));
                }
            },
            remove: function(name) {
                var i = this._names.indexOf(name);
                if (i >= 0) {
                    this._names.splice(i, 1);
                    this._node.setAttribute("class", this._names.join(" "));
                }
            },
            contains: function(name) {
                return this._names.indexOf(name) >= 0;
            }
        };
        function classedAdd(node, names) {
            var list = classList(node), i = -1, n = names.length;
            while(++i < n)list.add(names[i]);
        }
        function classedRemove(node, names) {
            var list = classList(node), i = -1, n = names.length;
            while(++i < n)list.remove(names[i]);
        }
        function classedTrue(names) {
            return function() {
                classedAdd(this, names);
            };
        }
        function classedFalse(names) {
            return function() {
                classedRemove(this, names);
            };
        }
        function classedFunction(names, value) {
            return function() {
                (value.apply(this, arguments) ? classedAdd : classedRemove)(this, names);
            };
        }
        function classed(name, value) {
            var names = classArray(name + "");
            if (arguments.length < 2) {
                var list = classList(this.node()), i = -1, n = names.length;
                while(++i < n)if (!list.contains(names[i])) return false;
                return true;
            }
            return this.each(("function" == typeof value ? classedFunction : value ? classedTrue : classedFalse)(names, value));
        }
        function textRemove() {
            this.textContent = "";
        }
        function textConstant(value) {
            return function() {
                this.textContent = value;
            };
        }
        function textFunction(value) {
            return function() {
                var v = value.apply(this, arguments);
                this.textContent = null == v ? "" : v;
            };
        }
        function selection_text(value) {
            return arguments.length ? this.each(null == value ? textRemove : ("function" == typeof value ? textFunction : textConstant)(value)) : this.node().textContent;
        }
        function htmlRemove() {
            this.innerHTML = "";
        }
        function htmlConstant(value) {
            return function() {
                this.innerHTML = value;
            };
        }
        function htmlFunction(value) {
            return function() {
                var v = value.apply(this, arguments);
                this.innerHTML = null == v ? "" : v;
            };
        }
        function html(value) {
            return arguments.length ? this.each(null == value ? htmlRemove : ("function" == typeof value ? htmlFunction : htmlConstant)(value)) : this.node().innerHTML;
        }
        function raise() {
            if (this.nextSibling) this.parentNode.appendChild(this);
        }
        function selection_raise() {
            return this.each(raise);
        }
        function lower() {
            if (this.previousSibling) this.parentNode.insertBefore(this, this.parentNode.firstChild);
        }
        function selection_lower() {
            return this.each(lower);
        }
        function creatorInherit(name) {
            return function() {
                var document1 = this.ownerDocument, uri = this.namespaceURI;
                return uri === xhtml && document1.documentElement.namespaceURI === xhtml ? document1.createElement(name) : document1.createElementNS(uri, name);
            };
        }
        function creatorFixed(fullname) {
            return function() {
                return this.ownerDocument.createElementNS(fullname.space, fullname.local);
            };
        }
        function creator(name) {
            var fullname = namespace(name);
            return (fullname.local ? creatorFixed : creatorInherit)(fullname);
        }
        function append(name) {
            var create = "function" == typeof name ? name : creator(name);
            return this.select(function() {
                return this.appendChild(create.apply(this, arguments));
            });
        }
        function constantNull() {
            return null;
        }
        function insert(name, before) {
            var create = "function" == typeof name ? name : creator(name), select = null == before ? constantNull : "function" == typeof before ? before : src_selector(before);
            return this.select(function() {
                return this.insertBefore(create.apply(this, arguments), select.apply(this, arguments) || null);
            });
        }
        function remove_remove() {
            var parent = this.parentNode;
            if (parent) parent.removeChild(this);
        }
        function selection_remove() {
            return this.each(remove_remove);
        }
        function selection_cloneShallow() {
            var clone = this.cloneNode(false), parent = this.parentNode;
            return parent ? parent.insertBefore(clone, this.nextSibling) : clone;
        }
        function selection_cloneDeep() {
            var clone = this.cloneNode(true), parent = this.parentNode;
            return parent ? parent.insertBefore(clone, this.nextSibling) : clone;
        }
        function selection_clone(deep) {
            return this.select(deep ? selection_cloneDeep : selection_cloneShallow);
        }
        function selection_datum(value) {
            return arguments.length ? this.property("__data__", value) : this.node().__data__;
        }
        function contextListener(listener) {
            return function(event) {
                listener.call(this, event, this.__data__);
            };
        }
        function parseTypenames(typenames) {
            return typenames.trim().split(/^|\s+/).map(function(t) {
                var name = "", i = t.indexOf(".");
                if (i >= 0) name = t.slice(i + 1), t = t.slice(0, i);
                return {
                    type: t,
                    name: name
                };
            });
        }
        function onRemove(typename) {
            return function() {
                var on = this.__on;
                if (!on) return;
                for(var j = 0, i = -1, m = on.length, o; j < m; ++j)if (o = on[j], typename.type && o.type !== typename.type || o.name !== typename.name) on[++i] = o;
                else this.removeEventListener(o.type, o.listener, o.options);
                if (++i) on.length = i;
                else delete this.__on;
            };
        }
        function onAdd(typename, value, options) {
            return function() {
                var on = this.__on, o, listener = contextListener(value);
                if (on) {
                    for(var j = 0, m = on.length; j < m; ++j)if ((o = on[j]).type === typename.type && o.name === typename.name) {
                        this.removeEventListener(o.type, o.listener, o.options);
                        this.addEventListener(o.type, o.listener = listener, o.options = options);
                        o.value = value;
                        return;
                    }
                }
                this.addEventListener(typename.type, listener, options);
                o = {
                    type: typename.type,
                    name: typename.name,
                    value: value,
                    listener: listener,
                    options: options
                };
                if (on) on.push(o);
                else this.__on = [
                    o
                ];
            };
        }
        function selection_on(typename, value, options) {
            var typenames = parseTypenames(typename + ""), i, n = typenames.length, t;
            if (arguments.length < 2) {
                var on = this.node().__on;
                if (on) {
                    for(var j = 0, m = on.length, o; j < m; ++j)for(i = 0, o = on[j]; i < n; ++i)if ((t = typenames[i]).type === o.type && t.name === o.name) return o.value;
                }
                return;
            }
            on = value ? onAdd : onRemove;
            for(i = 0; i < n; ++i)this.each(on(typenames[i], value, options));
            return this;
        }
        function dispatchEvent(node, type, params) {
            var window1 = src_window(node), event = window1.CustomEvent;
            if ("function" == typeof event) event = new event(type, params);
            else {
                event = window1.document.createEvent("Event");
                if (params) event.initEvent(type, params.bubbles, params.cancelable), event.detail = params.detail;
                else event.initEvent(type, false, false);
            }
            node.dispatchEvent(event);
        }
        function dispatchConstant(type, params) {
            return function() {
                return dispatchEvent(this, type, params);
            };
        }
        function dispatchFunction(type, params) {
            return function() {
                return dispatchEvent(this, type, params.apply(this, arguments));
            };
        }
        function selection_dispatch(type, params) {
            return this.each(("function" == typeof params ? dispatchFunction : dispatchConstant)(type, params));
        }
        function* iterator() {
            for(var groups = this._groups, j = 0, m = groups.length; j < m; ++j)for(var group = groups[j], i = 0, n = group.length, node; i < n; ++i)if (node = group[i]) yield node;
        }
        var root = [
            null
        ];
        function Selection(groups, parents) {
            this._groups = groups;
            this._parents = parents;
        }
        function selection_selection() {
            return new Selection([
                [
                    document.documentElement
                ]
            ], root);
        }
        function selection_selection_selection() {
            return this;
        }
        Selection.prototype = selection_selection.prototype = {
            constructor: Selection,
            select: selection_select,
            selectAll: selectAll,
            selectChild: selectChild,
            selectChildren: selectChildren,
            filter: selection_filter,
            data: selection_data,
            enter: selection_enter,
            exit: selection_exit,
            join: join,
            merge: selection_merge,
            selection: selection_selection_selection,
            order: order,
            sort: selection_sort,
            call: call,
            nodes: nodes,
            node: selection_node,
            size: selection_size,
            empty: selection_empty,
            each: each,
            attr: attr,
            style: style,
            property: property,
            classed: classed,
            text: selection_text,
            html: html,
            raise: selection_raise,
            lower: selection_lower,
            append: append,
            insert: insert,
            remove: selection_remove,
            clone: selection_clone,
            datum: selection_datum,
            on: selection_on,
            dispatch: selection_dispatch,
            [Symbol.iterator]: iterator
        };
        const src_selection = selection_selection;
        var noop = {
            value: ()=>{}
        };
        function dispatch_dispatch() {
            for(var i = 0, n = arguments.length, _ = {}, t; i < n; ++i){
                if (!(t = arguments[i] + "") || t in _ || /[\s.]/.test(t)) throw new Error("illegal type: " + t);
                _[t] = [];
            }
            return new Dispatch(_);
        }
        function Dispatch(_) {
            this._ = _;
        }
        function dispatch_parseTypenames(typenames, types) {
            return typenames.trim().split(/^|\s+/).map(function(t) {
                var name = "", i = t.indexOf(".");
                if (i >= 0) name = t.slice(i + 1), t = t.slice(0, i);
                if (t && !types.hasOwnProperty(t)) throw new Error("unknown type: " + t);
                return {
                    type: t,
                    name: name
                };
            });
        }
        Dispatch.prototype = dispatch_dispatch.prototype = {
            constructor: Dispatch,
            on: function(typename, callback) {
                var _ = this._, T = dispatch_parseTypenames(typename + "", _), t, i = -1, n = T.length;
                if (arguments.length < 2) {
                    while(++i < n)if ((t = (typename = T[i]).type) && (t = get(_[t], typename.name))) return t;
                    return;
                }
                if (null != callback && "function" != typeof callback) throw new Error("invalid callback: " + callback);
                while(++i < n)if (t = (typename = T[i]).type) _[t] = set(_[t], typename.name, callback);
                else if (null == callback) for(t in _)_[t] = set(_[t], typename.name, null);
                return this;
            },
            copy: function() {
                var copy = {}, _ = this._;
                for(var t in _)copy[t] = _[t].slice();
                return new Dispatch(copy);
            },
            call: function(type, that) {
                if ((n = arguments.length - 2) > 0) for(var args = new Array(n), i = 0, n, t; i < n; ++i)args[i] = arguments[i + 2];
                if (!this._.hasOwnProperty(type)) throw new Error("unknown type: " + type);
                for(t = this._[type], i = 0, n = t.length; i < n; ++i)t[i].value.apply(that, args);
            },
            apply: function(type, that, args) {
                if (!this._.hasOwnProperty(type)) throw new Error("unknown type: " + type);
                for(var t = this._[type], i = 0, n = t.length; i < n; ++i)t[i].value.apply(that, args);
            }
        };
        function get(type, name) {
            for(var i = 0, n = type.length, c; i < n; ++i)if ((c = type[i]).name === name) return c.value;
        }
        function set(type, name, callback) {
            for(var i = 0, n = type.length; i < n; ++i)if (type[i].name === name) {
                type[i] = noop, type = type.slice(0, i).concat(type.slice(i + 1));
                break;
            }
            if (null != callback) type.push({
                name: name,
                value: callback
            });
            return type;
        }
        const src_dispatch = dispatch_dispatch;
        var timer_frame = 0, timeout = 0, timer_interval = 0, pokeDelay = 1000, taskHead, taskTail, clockLast = 0, clockNow = 0, clockSkew = 0, clock = "object" == typeof performance && performance.now ? performance : Date, setFrame = "object" == typeof window && window.requestAnimationFrame ? window.requestAnimationFrame.bind(window) : function(f) {
            setTimeout(f, 17);
        };
        function timer_now() {
            return clockNow || (setFrame(clearNow), clockNow = clock.now() + clockSkew);
        }
        function clearNow() {
            clockNow = 0;
        }
        function Timer() {
            this._call = this._time = this._next = null;
        }
        Timer.prototype = timer.prototype = {
            constructor: Timer,
            restart: function(callback, delay, time) {
                if ("function" != typeof callback) throw new TypeError("callback is not a function");
                time = (null == time ? timer_now() : +time) + (null == delay ? 0 : +delay);
                if (!this._next && taskTail !== this) {
                    if (taskTail) taskTail._next = this;
                    else taskHead = this;
                    taskTail = this;
                }
                this._call = callback;
                this._time = time;
                sleep();
            },
            stop: function() {
                if (this._call) {
                    this._call = null;
                    this._time = 1 / 0;
                    sleep();
                }
            }
        };
        function timer(callback, delay, time) {
            var t = new Timer;
            t.restart(callback, delay, time);
            return t;
        }
        function timerFlush() {
            timer_now();
            ++timer_frame;
            var t = taskHead, e;
            while(t){
                if ((e = clockNow - t._time) >= 0) t._call.call(void 0, e);
                t = t._next;
            }
            --timer_frame;
        }
        function wake() {
            clockNow = (clockLast = clock.now()) + clockSkew;
            timer_frame = timeout = 0;
            try {
                timerFlush();
            } finally{
                timer_frame = 0;
                nap();
                clockNow = 0;
            }
        }
        function poke() {
            var now = clock.now(), delay = now - clockLast;
            if (delay > pokeDelay) clockSkew -= delay, clockLast = now;
        }
        function nap() {
            var t0, t1 = taskHead, t2, time = 1 / 0;
            while(t1)if (t1._call) {
                if (time > t1._time) time = t1._time;
                t0 = t1, t1 = t1._next;
            } else {
                t2 = t1._next, t1._next = null;
                t1 = t0 ? t0._next = t2 : taskHead = t2;
            }
            taskTail = t0;
            sleep(time);
        }
        function sleep(time) {
            if (timer_frame) return;
            if (timeout) timeout = clearTimeout(timeout);
            var delay = time - clockNow;
            if (delay > 24) {
                if (time < 1 / 0) timeout = setTimeout(wake, time - clock.now() - clockSkew);
                if (timer_interval) timer_interval = clearInterval(timer_interval);
            } else {
                if (!timer_interval) clockLast = clock.now(), timer_interval = setInterval(poke, pokeDelay);
                timer_frame = 1, setFrame(wake);
            }
        }
        function src_timeout(callback, delay, time) {
            var t = new Timer;
            delay = null == delay ? 0 : +delay;
            t.restart((elapsed)=>{
                t.stop();
                callback(elapsed + delay);
            }, delay, time);
            return t;
        }
        var emptyOn = src_dispatch("start", "end", "cancel", "interrupt");
        var emptyTween = [];
        var CREATED = 0;
        var SCHEDULED = 1;
        var STARTING = 2;
        var STARTED = 3;
        var RUNNING = 4;
        var ENDING = 5;
        var ENDED = 6;
        function transition_schedule(node, name, id, index, group, timing) {
            var schedules = node.__transition;
            if (schedules) {
                if (id in schedules) return;
            } else node.__transition = {};
            schedule_create(node, id, {
                name: name,
                index: index,
                group: group,
                on: emptyOn,
                tween: emptyTween,
                time: timing.time,
                delay: timing.delay,
                duration: timing.duration,
                ease: timing.ease,
                timer: null,
                state: CREATED
            });
        }
        function init(node, id) {
            var schedule = schedule_get(node, id);
            if (schedule.state > CREATED) throw new Error("too late; already scheduled");
            return schedule;
        }
        function schedule_set(node, id) {
            var schedule = schedule_get(node, id);
            if (schedule.state > STARTED) throw new Error("too late; already running");
            return schedule;
        }
        function schedule_get(node, id) {
            var schedule = node.__transition;
            if (!schedule || !(schedule = schedule[id])) throw new Error("transition not found");
            return schedule;
        }
        function schedule_create(node, id, self1) {
            var schedules = node.__transition, tween;
            schedules[id] = self1;
            self1.timer = timer(schedule, 0, self1.time);
            function schedule(elapsed) {
                self1.state = SCHEDULED;
                self1.timer.restart(start, self1.delay, self1.time);
                if (self1.delay <= elapsed) start(elapsed - self1.delay);
            }
            function start(elapsed) {
                var i, j, n, o;
                if (self1.state !== SCHEDULED) return stop();
                for(i in schedules){
                    o = schedules[i];
                    if (o.name === self1.name) {
                        if (o.state === STARTED) return src_timeout(start);
                        if (o.state === RUNNING) {
                            o.state = ENDED;
                            o.timer.stop();
                            o.on.call("interrupt", node, node.__data__, o.index, o.group);
                            delete schedules[i];
                        } else if (+i < id) {
                            o.state = ENDED;
                            o.timer.stop();
                            o.on.call("cancel", node, node.__data__, o.index, o.group);
                            delete schedules[i];
                        }
                    }
                }
                src_timeout(function() {
                    if (self1.state === STARTED) {
                        self1.state = RUNNING;
                        self1.timer.restart(tick, self1.delay, self1.time);
                        tick(elapsed);
                    }
                });
                self1.state = STARTING;
                self1.on.call("start", node, node.__data__, self1.index, self1.group);
                if (self1.state !== STARTING) return;
                self1.state = STARTED;
                tween = new Array(n = self1.tween.length);
                for(i = 0, j = -1; i < n; ++i)if (o = self1.tween[i].value.call(node, node.__data__, self1.index, self1.group)) tween[++j] = o;
                tween.length = j + 1;
            }
            function tick(elapsed) {
                var t = elapsed < self1.duration ? self1.ease.call(null, elapsed / self1.duration) : (self1.timer.restart(stop), self1.state = ENDING, 1), i = -1, n = tween.length;
                while(++i < n)tween[i].call(node, t);
                if (self1.state === ENDING) {
                    self1.on.call("end", node, node.__data__, self1.index, self1.group);
                    stop();
                }
            }
            function stop() {
                self1.state = ENDED;
                self1.timer.stop();
                delete schedules[id];
                for(var i in schedules)return;
                delete node.__transition;
            }
        }
        function src_interrupt(node, name) {
            var schedules = node.__transition, schedule, active, empty = true, i;
            if (!schedules) return;
            name = null == name ? null : name + "";
            for(i in schedules){
                if ((schedule = schedules[i]).name !== name) {
                    empty = false;
                    continue;
                }
                active = schedule.state > STARTING && schedule.state < ENDING;
                schedule.state = ENDED;
                schedule.timer.stop();
                schedule.on.call(active ? "interrupt" : "cancel", node, node.__data__, schedule.index, schedule.group);
                delete schedules[i];
            }
            if (empty) delete node.__transition;
        }
        function selection_interrupt(name) {
            return this.each(function() {
                src_interrupt(this, name);
            });
        }
        function src_number(a, b) {
            return a = +a, b = +b, function(t) {
                return a * (1 - t) + b * t;
            };
        }
        var degrees = 180 / Math.PI;
        var decompose_identity = {
            translateX: 0,
            translateY: 0,
            rotate: 0,
            skewX: 0,
            scaleX: 1,
            scaleY: 1
        };
        function decompose(a, b, c, d, e, f) {
            var scaleX, scaleY, skewX;
            if (scaleX = Math.sqrt(a * a + b * b)) a /= scaleX, b /= scaleX;
            if (skewX = a * c + b * d) c -= a * skewX, d -= b * skewX;
            if (scaleY = Math.sqrt(c * c + d * d)) c /= scaleY, d /= scaleY, skewX /= scaleY;
            if (a * d < b * c) a = -a, b = -b, skewX = -skewX, scaleX = -scaleX;
            return {
                translateX: e,
                translateY: f,
                rotate: Math.atan2(b, a) * degrees,
                skewX: Math.atan(skewX) * degrees,
                scaleX: scaleX,
                scaleY: scaleY
            };
        }
        var svgNode;
        function parseCss(value) {
            const m = new ("function" == typeof DOMMatrix ? DOMMatrix : WebKitCSSMatrix)(value + "");
            return m.isIdentity ? decompose_identity : decompose(m.a, m.b, m.c, m.d, m.e, m.f);
        }
        function parseSvg(value) {
            if (null == value) return decompose_identity;
            if (!svgNode) svgNode = document.createElementNS("http://www.w3.org/2000/svg", "g");
            svgNode.setAttribute("transform", value);
            if (!(value = svgNode.transform.baseVal.consolidate())) return decompose_identity;
            value = value.matrix;
            return decompose(value.a, value.b, value.c, value.d, value.e, value.f);
        }
        function interpolateTransform(parse, pxComma, pxParen, degParen) {
            function pop(s) {
                return s.length ? s.pop() + " " : "";
            }
            function translate(xa, ya, xb, yb, s, q) {
                if (xa !== xb || ya !== yb) {
                    var i = s.push("translate(", null, pxComma, null, pxParen);
                    q.push({
                        i: i - 4,
                        x: src_number(xa, xb)
                    }, {
                        i: i - 2,
                        x: src_number(ya, yb)
                    });
                } else if (xb || yb) s.push("translate(" + xb + pxComma + yb + pxParen);
            }
            function rotate(a, b, s, q) {
                if (a !== b) {
                    if (a - b > 180) b += 360;
                    else if (b - a > 180) a += 360;
                    q.push({
                        i: s.push(pop(s) + "rotate(", null, degParen) - 2,
                        x: src_number(a, b)
                    });
                } else if (b) s.push(pop(s) + "rotate(" + b + degParen);
            }
            function skewX(a, b, s, q) {
                if (a !== b) q.push({
                    i: s.push(pop(s) + "skewX(", null, degParen) - 2,
                    x: src_number(a, b)
                });
                else if (b) s.push(pop(s) + "skewX(" + b + degParen);
            }
            function scale(xa, ya, xb, yb, s, q) {
                if (xa !== xb || ya !== yb) {
                    var i = s.push(pop(s) + "scale(", null, ",", null, ")");
                    q.push({
                        i: i - 4,
                        x: src_number(xa, xb)
                    }, {
                        i: i - 2,
                        x: src_number(ya, yb)
                    });
                } else if (1 !== xb || 1 !== yb) s.push(pop(s) + "scale(" + xb + "," + yb + ")");
            }
            return function(a, b) {
                var s = [], q = [];
                a = parse(a), b = parse(b);
                translate(a.translateX, a.translateY, b.translateX, b.translateY, s, q);
                rotate(a.rotate, b.rotate, s, q);
                skewX(a.skewX, b.skewX, s, q);
                scale(a.scaleX, a.scaleY, b.scaleX, b.scaleY, s, q);
                a = b = null;
                return function(t) {
                    var i = -1, n = q.length, o;
                    while(++i < n)s[(o = q[i]).i] = o.x(t);
                    return s.join("");
                };
            };
        }
        var interpolateTransformCss = interpolateTransform(parseCss, "px, ", "px)", "deg)");
        var interpolateTransformSvg = interpolateTransform(parseSvg, ", ", ")", ")");
        function tweenRemove(id, name) {
            var tween0, tween1;
            return function() {
                var schedule = schedule_set(this, id), tween = schedule.tween;
                if (tween !== tween0) {
                    tween1 = tween0 = tween;
                    for(var i = 0, n = tween1.length; i < n; ++i)if (tween1[i].name === name) {
                        tween1 = tween1.slice();
                        tween1.splice(i, 1);
                        break;
                    }
                }
                schedule.tween = tween1;
            };
        }
        function tweenFunction(id, name, value) {
            var tween0, tween1;
            if ("function" != typeof value) throw new Error;
            return function() {
                var schedule = schedule_set(this, id), tween = schedule.tween;
                if (tween !== tween0) {
                    tween1 = (tween0 = tween).slice();
                    for(var t = {
                        name: name,
                        value: value
                    }, i = 0, n = tween1.length; i < n; ++i)if (tween1[i].name === name) {
                        tween1[i] = t;
                        break;
                    }
                    if (i === n) tween1.push(t);
                }
                schedule.tween = tween1;
            };
        }
        function transition_tween(name, value) {
            var id = this._id;
            name += "";
            if (arguments.length < 2) {
                var tween = schedule_get(this.node(), id).tween;
                for(var i = 0, n = tween.length, t; i < n; ++i)if ((t = tween[i]).name === name) return t.value;
                return null;
            }
            return this.each((null == value ? tweenRemove : tweenFunction)(id, name, value));
        }
        function tweenValue(transition, name, value) {
            var id = transition._id;
            transition.each(function() {
                var schedule = schedule_set(this, id);
                (schedule.value || (schedule.value = {}))[name] = value.apply(this, arguments);
            });
            return function(node) {
                return schedule_get(node, id).value[name];
            };
        }
        function src_define(constructor, factory, prototype) {
            constructor.prototype = factory.prototype = prototype;
            prototype.constructor = constructor;
        }
        function extend(parent, definition) {
            var prototype = Object.create(parent.prototype);
            for(var key in definition)prototype[key] = definition[key];
            return prototype;
        }
        function Color() {}
        var darker = 0.7;
        var brighter = 1 / darker;
        var reI = "\\s*([+-]?\\d+)\\s*", reN = "\\s*([+-]?(?:\\d*\\.)?\\d+(?:[eE][+-]?\\d+)?)\\s*", reP = "\\s*([+-]?(?:\\d*\\.)?\\d+(?:[eE][+-]?\\d+)?)%\\s*", reHex = /^#([0-9a-f]{3,8})$/, reRgbInteger = new RegExp(`^rgb\\(${reI},${reI},${reI}\\)$`), reRgbPercent = new RegExp(`^rgb\\(${reP},${reP},${reP}\\)$`), reRgbaInteger = new RegExp(`^rgba\\(${reI},${reI},${reI},${reN}\\)$`), reRgbaPercent = new RegExp(`^rgba\\(${reP},${reP},${reP},${reN}\\)$`), reHslPercent = new RegExp(`^hsl\\(${reN},${reP},${reP}\\)$`), reHslaPercent = new RegExp(`^hsla\\(${reN},${reP},${reP},${reN}\\)$`);
        var named = {
            aliceblue: 0xf0f8ff,
            antiquewhite: 0xfaebd7,
            aqua: 0x00ffff,
            aquamarine: 0x7fffd4,
            azure: 0xf0ffff,
            beige: 0xf5f5dc,
            bisque: 0xffe4c4,
            black: 0x000000,
            blanchedalmond: 0xffebcd,
            blue: 0x0000ff,
            blueviolet: 0x8a2be2,
            brown: 0xa52a2a,
            burlywood: 0xdeb887,
            cadetblue: 0x5f9ea0,
            chartreuse: 0x7fff00,
            chocolate: 0xd2691e,
            coral: 0xff7f50,
            cornflowerblue: 0x6495ed,
            cornsilk: 0xfff8dc,
            crimson: 0xdc143c,
            cyan: 0x00ffff,
            darkblue: 0x00008b,
            darkcyan: 0x008b8b,
            darkgoldenrod: 0xb8860b,
            darkgray: 0xa9a9a9,
            darkgreen: 0x006400,
            darkgrey: 0xa9a9a9,
            darkkhaki: 0xbdb76b,
            darkmagenta: 0x8b008b,
            darkolivegreen: 0x556b2f,
            darkorange: 0xff8c00,
            darkorchid: 0x9932cc,
            darkred: 0x8b0000,
            darksalmon: 0xe9967a,
            darkseagreen: 0x8fbc8f,
            darkslateblue: 0x483d8b,
            darkslategray: 0x2f4f4f,
            darkslategrey: 0x2f4f4f,
            darkturquoise: 0x00ced1,
            darkviolet: 0x9400d3,
            deeppink: 0xff1493,
            deepskyblue: 0x00bfff,
            dimgray: 0x696969,
            dimgrey: 0x696969,
            dodgerblue: 0x1e90ff,
            firebrick: 0xb22222,
            floralwhite: 0xfffaf0,
            forestgreen: 0x228b22,
            fuchsia: 0xff00ff,
            gainsboro: 0xdcdcdc,
            ghostwhite: 0xf8f8ff,
            gold: 0xffd700,
            goldenrod: 0xdaa520,
            gray: 0x808080,
            green: 0x008000,
            greenyellow: 0xadff2f,
            grey: 0x808080,
            honeydew: 0xf0fff0,
            hotpink: 0xff69b4,
            indianred: 0xcd5c5c,
            indigo: 0x4b0082,
            ivory: 0xfffff0,
            khaki: 0xf0e68c,
            lavender: 0xe6e6fa,
            lavenderblush: 0xfff0f5,
            lawngreen: 0x7cfc00,
            lemonchiffon: 0xfffacd,
            lightblue: 0xadd8e6,
            lightcoral: 0xf08080,
            lightcyan: 0xe0ffff,
            lightgoldenrodyellow: 0xfafad2,
            lightgray: 0xd3d3d3,
            lightgreen: 0x90ee90,
            lightgrey: 0xd3d3d3,
            lightpink: 0xffb6c1,
            lightsalmon: 0xffa07a,
            lightseagreen: 0x20b2aa,
            lightskyblue: 0x87cefa,
            lightslategray: 0x778899,
            lightslategrey: 0x778899,
            lightsteelblue: 0xb0c4de,
            lightyellow: 0xffffe0,
            lime: 0x00ff00,
            limegreen: 0x32cd32,
            linen: 0xfaf0e6,
            magenta: 0xff00ff,
            maroon: 0x800000,
            mediumaquamarine: 0x66cdaa,
            mediumblue: 0x0000cd,
            mediumorchid: 0xba55d3,
            mediumpurple: 0x9370db,
            mediumseagreen: 0x3cb371,
            mediumslateblue: 0x7b68ee,
            mediumspringgreen: 0x00fa9a,
            mediumturquoise: 0x48d1cc,
            mediumvioletred: 0xc71585,
            midnightblue: 0x191970,
            mintcream: 0xf5fffa,
            mistyrose: 0xffe4e1,
            moccasin: 0xffe4b5,
            navajowhite: 0xffdead,
            navy: 0x000080,
            oldlace: 0xfdf5e6,
            olive: 0x808000,
            olivedrab: 0x6b8e23,
            orange: 0xffa500,
            orangered: 0xff4500,
            orchid: 0xda70d6,
            palegoldenrod: 0xeee8aa,
            palegreen: 0x98fb98,
            paleturquoise: 0xafeeee,
            palevioletred: 0xdb7093,
            papayawhip: 0xffefd5,
            peachpuff: 0xffdab9,
            peru: 0xcd853f,
            pink: 0xffc0cb,
            plum: 0xdda0dd,
            powderblue: 0xb0e0e6,
            purple: 0x800080,
            rebeccapurple: 0x663399,
            red: 0xff0000,
            rosybrown: 0xbc8f8f,
            royalblue: 0x4169e1,
            saddlebrown: 0x8b4513,
            salmon: 0xfa8072,
            sandybrown: 0xf4a460,
            seagreen: 0x2e8b57,
            seashell: 0xfff5ee,
            sienna: 0xa0522d,
            silver: 0xc0c0c0,
            skyblue: 0x87ceeb,
            slateblue: 0x6a5acd,
            slategray: 0x708090,
            slategrey: 0x708090,
            snow: 0xfffafa,
            springgreen: 0x00ff7f,
            steelblue: 0x4682b4,
            tan: 0xd2b48c,
            teal: 0x008080,
            thistle: 0xd8bfd8,
            tomato: 0xff6347,
            turquoise: 0x40e0d0,
            violet: 0xee82ee,
            wheat: 0xf5deb3,
            white: 0xffffff,
            whitesmoke: 0xf5f5f5,
            yellow: 0xffff00,
            yellowgreen: 0x9acd32
        };
        src_define(Color, color_color, {
            copy (channels) {
                return Object.assign(new this.constructor, this, channels);
            },
            displayable () {
                return this.rgb().displayable();
            },
            hex: color_formatHex,
            formatHex: color_formatHex,
            formatHex8: color_formatHex8,
            formatHsl: color_formatHsl,
            formatRgb: color_formatRgb,
            toString: color_formatRgb
        });
        function color_formatHex() {
            return this.rgb().formatHex();
        }
        function color_formatHex8() {
            return this.rgb().formatHex8();
        }
        function color_formatHsl() {
            return hslConvert(this).formatHsl();
        }
        function color_formatRgb() {
            return this.rgb().formatRgb();
        }
        function color_color(format) {
            var m, l;
            format = (format + "").trim().toLowerCase();
            return (m = reHex.exec(format)) ? (l = m[1].length, m = parseInt(m[1], 16), 6 === l ? rgbn(m) : 3 === l ? new Rgb(m >> 8 & 0xf | m >> 4 & 0xf0, m >> 4 & 0xf | 0xf0 & m, (0xf & m) << 4 | 0xf & m, 1) : 8 === l ? rgba(m >> 24 & 0xff, m >> 16 & 0xff, m >> 8 & 0xff, (0xff & m) / 0xff) : 4 === l ? rgba(m >> 12 & 0xf | m >> 8 & 0xf0, m >> 8 & 0xf | m >> 4 & 0xf0, m >> 4 & 0xf | 0xf0 & m, ((0xf & m) << 4 | 0xf & m) / 0xff) : null) : (m = reRgbInteger.exec(format)) ? new Rgb(m[1], m[2], m[3], 1) : (m = reRgbPercent.exec(format)) ? new Rgb(255 * m[1] / 100, 255 * m[2] / 100, 255 * m[3] / 100, 1) : (m = reRgbaInteger.exec(format)) ? rgba(m[1], m[2], m[3], m[4]) : (m = reRgbaPercent.exec(format)) ? rgba(255 * m[1] / 100, 255 * m[2] / 100, 255 * m[3] / 100, m[4]) : (m = reHslPercent.exec(format)) ? hsla(m[1], m[2] / 100, m[3] / 100, 1) : (m = reHslaPercent.exec(format)) ? hsla(m[1], m[2] / 100, m[3] / 100, m[4]) : named.hasOwnProperty(format) ? rgbn(named[format]) : "transparent" === format ? new Rgb(NaN, NaN, NaN, 0) : null;
        }
        function rgbn(n) {
            return new Rgb(n >> 16 & 0xff, n >> 8 & 0xff, 0xff & n, 1);
        }
        function rgba(r, g, b, a) {
            if (a <= 0) r = g = b = NaN;
            return new Rgb(r, g, b, a);
        }
        function rgbConvert(o) {
            if (!(o instanceof Color)) o = color_color(o);
            if (!o) return new Rgb;
            o = o.rgb();
            return new Rgb(o.r, o.g, o.b, o.opacity);
        }
        function color_rgb(r, g, b, opacity) {
            return 1 === arguments.length ? rgbConvert(r) : new Rgb(r, g, b, null == opacity ? 1 : opacity);
        }
        function Rgb(r, g, b, opacity) {
            this.r = +r;
            this.g = +g;
            this.b = +b;
            this.opacity = +opacity;
        }
        src_define(Rgb, color_rgb, extend(Color, {
            brighter (k) {
                k = null == k ? brighter : Math.pow(brighter, k);
                return new Rgb(this.r * k, this.g * k, this.b * k, this.opacity);
            },
            darker (k) {
                k = null == k ? darker : Math.pow(darker, k);
                return new Rgb(this.r * k, this.g * k, this.b * k, this.opacity);
            },
            rgb () {
                return this;
            },
            clamp () {
                return new Rgb(clampi(this.r), clampi(this.g), clampi(this.b), clampa(this.opacity));
            },
            displayable () {
                return -0.5 <= this.r && this.r < 255.5 && -0.5 <= this.g && this.g < 255.5 && -0.5 <= this.b && this.b < 255.5 && 0 <= this.opacity && this.opacity <= 1;
            },
            hex: rgb_formatHex,
            formatHex: rgb_formatHex,
            formatHex8: rgb_formatHex8,
            formatRgb: rgb_formatRgb,
            toString: rgb_formatRgb
        }));
        function rgb_formatHex() {
            return `#${hex(this.r)}${hex(this.g)}${hex(this.b)}`;
        }
        function rgb_formatHex8() {
            return `#${hex(this.r)}${hex(this.g)}${hex(this.b)}${hex((isNaN(this.opacity) ? 1 : this.opacity) * 255)}`;
        }
        function rgb_formatRgb() {
            const a = clampa(this.opacity);
            return `${1 === a ? "rgb(" : "rgba("}${clampi(this.r)}, ${clampi(this.g)}, ${clampi(this.b)}${1 === a ? ")" : `, ${a})`}`;
        }
        function clampa(opacity) {
            return isNaN(opacity) ? 1 : Math.max(0, Math.min(1, opacity));
        }
        function clampi(value) {
            return Math.max(0, Math.min(255, Math.round(value) || 0));
        }
        function hex(value) {
            value = clampi(value);
            return (value < 16 ? "0" : "") + value.toString(16);
        }
        function hsla(h, s, l, a) {
            if (a <= 0) h = s = l = NaN;
            else if (l <= 0 || l >= 1) h = s = NaN;
            else if (s <= 0) h = NaN;
            return new Hsl(h, s, l, a);
        }
        function hslConvert(o) {
            if (o instanceof Hsl) return new Hsl(o.h, o.s, o.l, o.opacity);
            if (!(o instanceof Color)) o = color_color(o);
            if (!o) return new Hsl;
            if (o instanceof Hsl) return o;
            o = o.rgb();
            var r = o.r / 255, g = o.g / 255, b = o.b / 255, min = Math.min(r, g, b), max = Math.max(r, g, b), h = NaN, s = max - min, l = (max + min) / 2;
            if (s) {
                h = r === max ? (g - b) / s + (g < b) * 6 : g === max ? (b - r) / s + 2 : (r - g) / s + 4;
                s /= l < 0.5 ? max + min : 2 - max - min;
                h *= 60;
            } else s = l > 0 && l < 1 ? 0 : h;
            return new Hsl(h, s, l, o.opacity);
        }
        function hsl(h, s, l, opacity) {
            return 1 === arguments.length ? hslConvert(h) : new Hsl(h, s, l, null == opacity ? 1 : opacity);
        }
        function Hsl(h, s, l, opacity) {
            this.h = +h;
            this.s = +s;
            this.l = +l;
            this.opacity = +opacity;
        }
        src_define(Hsl, hsl, extend(Color, {
            brighter (k) {
                k = null == k ? brighter : Math.pow(brighter, k);
                return new Hsl(this.h, this.s, this.l * k, this.opacity);
            },
            darker (k) {
                k = null == k ? darker : Math.pow(darker, k);
                return new Hsl(this.h, this.s, this.l * k, this.opacity);
            },
            rgb () {
                var h = this.h % 360 + (this.h < 0) * 360, s = isNaN(h) || isNaN(this.s) ? 0 : this.s, l = this.l, m2 = l + (l < 0.5 ? l : 1 - l) * s, m1 = 2 * l - m2;
                return new Rgb(hsl2rgb(h >= 240 ? h - 240 : h + 120, m1, m2), hsl2rgb(h, m1, m2), hsl2rgb(h < 120 ? h + 240 : h - 120, m1, m2), this.opacity);
            },
            clamp () {
                return new Hsl(clamph(this.h), clampt(this.s), clampt(this.l), clampa(this.opacity));
            },
            displayable () {
                return (0 <= this.s && this.s <= 1 || isNaN(this.s)) && 0 <= this.l && this.l <= 1 && 0 <= this.opacity && this.opacity <= 1;
            },
            formatHsl () {
                const a = clampa(this.opacity);
                return `${1 === a ? "hsl(" : "hsla("}${clamph(this.h)}, ${100 * clampt(this.s)}%, ${100 * clampt(this.l)}%${1 === a ? ")" : `, ${a})`}`;
            }
        }));
        function clamph(value) {
            value = (value || 0) % 360;
            return value < 0 ? value + 360 : value;
        }
        function clampt(value) {
            return Math.max(0, Math.min(1, value || 0));
        }
        function hsl2rgb(h, m1, m2) {
            return (h < 60 ? m1 + (m2 - m1) * h / 60 : h < 180 ? m2 : h < 240 ? m1 + (m2 - m1) * (240 - h) / 60 : m1) * 255;
        }
        function basis(t1, v0, v1, v2, v3) {
            var t2 = t1 * t1, t3 = t2 * t1;
            return ((1 - 3 * t1 + 3 * t2 - t3) * v0 + (4 - 6 * t2 + 3 * t3) * v1 + (1 + 3 * t1 + 3 * t2 - 3 * t3) * v2 + t3 * v3) / 6;
        }
        function src_basis(values) {
            var n = values.length - 1;
            return function(t) {
                var i = t <= 0 ? t = 0 : t >= 1 ? (t = 1, n - 1) : Math.floor(t * n), v1 = values[i], v2 = values[i + 1], v0 = i > 0 ? values[i - 1] : 2 * v1 - v2, v3 = i < n - 1 ? values[i + 2] : 2 * v2 - v1;
                return basis((t - i / n) * n, v0, v1, v2, v3);
            };
        }
        function basisClosed(values) {
            var n = values.length;
            return function(t) {
                var i = Math.floor(((t %= 1) < 0 ? ++t : t) * n), v0 = values[(i + n - 1) % n], v1 = values[i % n], v2 = values[(i + 1) % n], v3 = values[(i + 2) % n];
                return basis((t - i / n) * n, v0, v1, v2, v3);
            };
        }
        const d3_interpolate_src_constant = (x)=>()=>x;
        function linear(a, d) {
            return function(t) {
                return a + t * d;
            };
        }
        function exponential(a, b, y) {
            return a = Math.pow(a, y), b = Math.pow(b, y) - a, y = 1 / y, function(t) {
                return Math.pow(a + t * b, y);
            };
        }
        function color_hue(a, b) {
            var d = b - a;
            return d ? linear(a, d > 180 || d < -180 ? d - 360 * Math.round(d / 360) : d) : d3_interpolate_src_constant(isNaN(a) ? b : a);
        }
        function gamma(y) {
            return 1 === (y = +y) ? nogamma : function(a, b) {
                return b - a ? exponential(a, b, y) : d3_interpolate_src_constant(isNaN(a) ? b : a);
            };
        }
        function nogamma(a, b) {
            var d = b - a;
            return d ? linear(a, d) : d3_interpolate_src_constant(isNaN(a) ? b : a);
        }
        const src_rgb = function rgbGamma(y) {
            var color = gamma(y);
            function rgb(start, end) {
                var r = color((start = color_rgb(start)).r, (end = color_rgb(end)).r), g = color(start.g, end.g), b = color(start.b, end.b), opacity = nogamma(start.opacity, end.opacity);
                return function(t) {
                    start.r = r(t);
                    start.g = g(t);
                    start.b = b(t);
                    start.opacity = opacity(t);
                    return start + "";
                };
            }
            rgb.gamma = rgbGamma;
            return rgb;
        }(1);
        function rgbSpline(spline) {
            return function(colors) {
                var n = colors.length, r = new Array(n), g = new Array(n), b = new Array(n), i, color;
                for(i = 0; i < n; ++i){
                    color = color_rgb(colors[i]);
                    r[i] = color.r || 0;
                    g[i] = color.g || 0;
                    b[i] = color.b || 0;
                }
                r = spline(r);
                g = spline(g);
                b = spline(b);
                color.opacity = 1;
                return function(t) {
                    color.r = r(t);
                    color.g = g(t);
                    color.b = b(t);
                    return color + "";
                };
            };
        }
        rgbSpline(src_basis);
        rgbSpline(basisClosed);
        var reA = /[-+]?(?:\d+\.?\d*|\.?\d+)(?:[eE][-+]?\d+)?/g, reB = new RegExp(reA.source, "g");
        function string_zero(b) {
            return function() {
                return b;
            };
        }
        function one(b) {
            return function(t) {
                return b(t) + "";
            };
        }
        function src_string(a, b) {
            var bi = reA.lastIndex = reB.lastIndex = 0, am, bm, bs, i = -1, s = [], q = [];
            a += "", b += "";
            while((am = reA.exec(a)) && (bm = reB.exec(b))){
                if ((bs = bm.index) > bi) {
                    bs = b.slice(bi, bs);
                    if (s[i]) s[i] += bs;
                    else s[++i] = bs;
                }
                if ((am = am[0]) === (bm = bm[0])) {
                    if (s[i]) s[i] += bm;
                    else s[++i] = bm;
                } else {
                    s[++i] = null;
                    q.push({
                        i: i,
                        x: src_number(am, bm)
                    });
                }
                bi = reB.lastIndex;
            }
            if (bi < b.length) {
                bs = b.slice(bi);
                if (s[i]) s[i] += bs;
                else s[++i] = bs;
            }
            return s.length < 2 ? q[0] ? one(q[0].x) : string_zero(b) : (b = q.length, function(t) {
                for(var i = 0, o; i < b; ++i)s[(o = q[i]).i] = o.x(t);
                return s.join("");
            });
        }
        function transition_interpolate(a, b) {
            var c;
            return ("number" == typeof b ? src_number : b instanceof color_color ? src_rgb : (c = color_color(b)) ? (b = c, src_rgb) : src_string)(a, b);
        }
        function attr_attrRemove(name) {
            return function() {
                this.removeAttribute(name);
            };
        }
        function attr_attrRemoveNS(fullname) {
            return function() {
                this.removeAttributeNS(fullname.space, fullname.local);
            };
        }
        function attr_attrConstant(name, interpolate, value1) {
            var string00, string1 = value1 + "", interpolate0;
            return function() {
                var string0 = this.getAttribute(name);
                return string0 === string1 ? null : string0 === string00 ? interpolate0 : interpolate0 = interpolate(string00 = string0, value1);
            };
        }
        function attr_attrConstantNS(fullname, interpolate, value1) {
            var string00, string1 = value1 + "", interpolate0;
            return function() {
                var string0 = this.getAttributeNS(fullname.space, fullname.local);
                return string0 === string1 ? null : string0 === string00 ? interpolate0 : interpolate0 = interpolate(string00 = string0, value1);
            };
        }
        function attr_attrFunction(name, interpolate, value) {
            var string00, string10, interpolate0;
            return function() {
                var string0, value1 = value(this), string1;
                if (null == value1) return void this.removeAttribute(name);
                string0 = this.getAttribute(name);
                string1 = value1 + "";
                return string0 === string1 ? null : string0 === string00 && string1 === string10 ? interpolate0 : (string10 = string1, interpolate0 = interpolate(string00 = string0, value1));
            };
        }
        function attr_attrFunctionNS(fullname, interpolate, value) {
            var string00, string10, interpolate0;
            return function() {
                var string0, value1 = value(this), string1;
                if (null == value1) return void this.removeAttributeNS(fullname.space, fullname.local);
                string0 = this.getAttributeNS(fullname.space, fullname.local);
                string1 = value1 + "";
                return string0 === string1 ? null : string0 === string00 && string1 === string10 ? interpolate0 : (string10 = string1, interpolate0 = interpolate(string00 = string0, value1));
            };
        }
        function transition_attr(name, value) {
            var fullname = namespace(name), i = "transform" === fullname ? interpolateTransformSvg : transition_interpolate;
            return this.attrTween(name, "function" == typeof value ? (fullname.local ? attr_attrFunctionNS : attr_attrFunction)(fullname, i, tweenValue(this, "attr." + name, value)) : null == value ? (fullname.local ? attr_attrRemoveNS : attr_attrRemove)(fullname) : (fullname.local ? attr_attrConstantNS : attr_attrConstant)(fullname, i, value));
        }
        function attrInterpolate(name, i) {
            return function(t) {
                this.setAttribute(name, i.call(this, t));
            };
        }
        function attrInterpolateNS(fullname, i) {
            return function(t) {
                this.setAttributeNS(fullname.space, fullname.local, i.call(this, t));
            };
        }
        function attrTweenNS(fullname, value) {
            var t0, i0;
            function tween() {
                var i = value.apply(this, arguments);
                if (i !== i0) t0 = (i0 = i) && attrInterpolateNS(fullname, i);
                return t0;
            }
            tween._value = value;
            return tween;
        }
        function attrTween(name, value) {
            var t0, i0;
            function tween() {
                var i = value.apply(this, arguments);
                if (i !== i0) t0 = (i0 = i) && attrInterpolate(name, i);
                return t0;
            }
            tween._value = value;
            return tween;
        }
        function transition_attrTween(name, value) {
            var key = "attr." + name;
            if (arguments.length < 2) return (key = this.tween(key)) && key._value;
            if (null == value) return this.tween(key, null);
            if ("function" != typeof value) throw new Error;
            var fullname = namespace(name);
            return this.tween(key, (fullname.local ? attrTweenNS : attrTween)(fullname, value));
        }
        function delayFunction(id, value) {
            return function() {
                init(this, id).delay = +value.apply(this, arguments);
            };
        }
        function delayConstant(id, value) {
            return value = +value, function() {
                init(this, id).delay = value;
            };
        }
        function transition_delay(value) {
            var id = this._id;
            return arguments.length ? this.each(("function" == typeof value ? delayFunction : delayConstant)(id, value)) : schedule_get(this.node(), id).delay;
        }
        function durationFunction(id, value) {
            return function() {
                schedule_set(this, id).duration = +value.apply(this, arguments);
            };
        }
        function durationConstant(id, value) {
            return value = +value, function() {
                schedule_set(this, id).duration = value;
            };
        }
        function transition_duration(value) {
            var id = this._id;
            return arguments.length ? this.each(("function" == typeof value ? durationFunction : durationConstant)(id, value)) : schedule_get(this.node(), id).duration;
        }
        function easeConstant(id, value) {
            if ("function" != typeof value) throw new Error;
            return function() {
                schedule_set(this, id).ease = value;
            };
        }
        function ease(value) {
            var id = this._id;
            return arguments.length ? this.each(easeConstant(id, value)) : schedule_get(this.node(), id).ease;
        }
        function easeVarying_easeVarying(id, value) {
            return function() {
                var v = value.apply(this, arguments);
                if ("function" != typeof v) throw new Error;
                schedule_set(this, id).ease = v;
            };
        }
        function easeVarying(value) {
            if ("function" != typeof value) throw new Error;
            return this.each(easeVarying_easeVarying(this._id, value));
        }
        function transition_filter(match) {
            if ("function" != typeof match) match = matcher(match);
            for(var groups = this._groups, m = groups.length, subgroups = new Array(m), j = 0; j < m; ++j)for(var group = groups[j], n = group.length, subgroup = subgroups[j] = [], node, i = 0; i < n; ++i)if ((node = group[i]) && match.call(node, node.__data__, i, group)) subgroup.push(node);
            return new Transition(subgroups, this._parents, this._name, this._id);
        }
        function transition_merge(transition) {
            if (transition._id !== this._id) throw new Error;
            for(var groups0 = this._groups, groups1 = transition._groups, m0 = groups0.length, m1 = groups1.length, m = Math.min(m0, m1), merges = new Array(m0), j = 0; j < m; ++j)for(var group0 = groups0[j], group1 = groups1[j], n = group0.length, merge = merges[j] = new Array(n), node, i = 0; i < n; ++i)if (node = group0[i] || group1[i]) merge[i] = node;
            for(; j < m0; ++j)merges[j] = groups0[j];
            return new Transition(merges, this._parents, this._name, this._id);
        }
        function on_start(name) {
            return (name + "").trim().split(/^|\s+/).every(function(t) {
                var i = t.indexOf(".");
                if (i >= 0) t = t.slice(0, i);
                return !t || "start" === t;
            });
        }
        function onFunction(id, name, listener) {
            var on0, on1, sit = on_start(name) ? init : schedule_set;
            return function() {
                var schedule = sit(this, id), on = schedule.on;
                if (on !== on0) (on1 = (on0 = on).copy()).on(name, listener);
                schedule.on = on1;
            };
        }
        function transition_on(name, listener) {
            var id = this._id;
            return arguments.length < 2 ? schedule_get(this.node(), id).on.on(name) : this.each(onFunction(id, name, listener));
        }
        function removeFunction(id) {
            return function() {
                var parent = this.parentNode;
                for(var i in this.__transition)if (+i !== id) return;
                if (parent) parent.removeChild(this);
            };
        }
        function transition_remove() {
            return this.on("end.remove", removeFunction(this._id));
        }
        function transition_select(select) {
            var name = this._name, id = this._id;
            if ("function" != typeof select) select = src_selector(select);
            for(var groups = this._groups, m = groups.length, subgroups = new Array(m), j = 0; j < m; ++j)for(var group = groups[j], n = group.length, subgroup = subgroups[j] = new Array(n), node, subnode, i = 0; i < n; ++i)if ((node = group[i]) && (subnode = select.call(node, node.__data__, i, group))) {
                if ("__data__" in node) subnode.__data__ = node.__data__;
                subgroup[i] = subnode;
                transition_schedule(subgroup[i], name, id, i, subgroup, schedule_get(node, id));
            }
            return new Transition(subgroups, this._parents, name, id);
        }
        function transition_selectAll(select) {
            var name = this._name, id = this._id;
            if ("function" != typeof select) select = selectorAll(select);
            for(var groups = this._groups, m = groups.length, subgroups = [], parents = [], j = 0; j < m; ++j)for(var group = groups[j], n = group.length, node, i = 0; i < n; ++i)if (node = group[i]) {
                for(var children = select.call(node, node.__data__, i, group), child, inherit = schedule_get(node, id), k = 0, l = children.length; k < l; ++k)if (child = children[k]) transition_schedule(child, name, id, k, children, inherit);
                subgroups.push(children);
                parents.push(node);
            }
            return new Transition(subgroups, parents, name, id);
        }
        var selection_Selection = src_selection.prototype.constructor;
        function transition_selection() {
            return new selection_Selection(this._groups, this._parents);
        }
        function styleNull(name, interpolate) {
            var string00, string10, interpolate0;
            return function() {
                var string0 = styleValue(this, name), string1 = (this.style.removeProperty(name), styleValue(this, name));
                return string0 === string1 ? null : string0 === string00 && string1 === string10 ? interpolate0 : interpolate0 = interpolate(string00 = string0, string10 = string1);
            };
        }
        function style_styleRemove(name) {
            return function() {
                this.style.removeProperty(name);
            };
        }
        function style_styleConstant(name, interpolate, value1) {
            var string00, string1 = value1 + "", interpolate0;
            return function() {
                var string0 = styleValue(this, name);
                return string0 === string1 ? null : string0 === string00 ? interpolate0 : interpolate0 = interpolate(string00 = string0, value1);
            };
        }
        function style_styleFunction(name, interpolate, value) {
            var string00, string10, interpolate0;
            return function() {
                var string0 = styleValue(this, name), value1 = value(this), string1 = value1 + "";
                if (null == value1) string1 = value1 = (this.style.removeProperty(name), styleValue(this, name));
                return string0 === string1 ? null : string0 === string00 && string1 === string10 ? interpolate0 : (string10 = string1, interpolate0 = interpolate(string00 = string0, value1));
            };
        }
        function styleMaybeRemove(id, name) {
            var on0, on1, listener0, key = "style." + name, event = "end." + key, remove;
            return function() {
                var schedule = schedule_set(this, id), on = schedule.on, listener = null == schedule.value[key] ? remove || (remove = style_styleRemove(name)) : void 0;
                if (on !== on0 || listener0 !== listener) (on1 = (on0 = on).copy()).on(event, listener0 = listener);
                schedule.on = on1;
            };
        }
        function transition_style(name, value, priority) {
            var i = "transform" === (name += "") ? interpolateTransformCss : transition_interpolate;
            return null == value ? this.styleTween(name, styleNull(name, i)).on("end.style." + name, style_styleRemove(name)) : "function" == typeof value ? this.styleTween(name, style_styleFunction(name, i, tweenValue(this, "style." + name, value))).each(styleMaybeRemove(this._id, name)) : this.styleTween(name, style_styleConstant(name, i, value), priority).on("end.style." + name, null);
        }
        function styleInterpolate(name, i, priority) {
            return function(t) {
                this.style.setProperty(name, i.call(this, t), priority);
            };
        }
        function styleTween(name, value, priority) {
            var t, i0;
            function tween() {
                var i = value.apply(this, arguments);
                if (i !== i0) t = (i0 = i) && styleInterpolate(name, i, priority);
                return t;
            }
            tween._value = value;
            return tween;
        }
        function transition_styleTween(name, value, priority) {
            var key = "style." + (name += "");
            if (arguments.length < 2) return (key = this.tween(key)) && key._value;
            if (null == value) return this.tween(key, null);
            if ("function" != typeof value) throw new Error;
            return this.tween(key, styleTween(name, value, null == priority ? "" : priority));
        }
        function text_textConstant(value) {
            return function() {
                this.textContent = value;
            };
        }
        function text_textFunction(value) {
            return function() {
                var value1 = value(this);
                this.textContent = null == value1 ? "" : value1;
            };
        }
        function transition_text(value) {
            return this.tween("text", "function" == typeof value ? text_textFunction(tweenValue(this, "text", value)) : text_textConstant(null == value ? "" : value + ""));
        }
        function textInterpolate(i) {
            return function(t) {
                this.textContent = i.call(this, t);
            };
        }
        function textTween_textTween(value) {
            var t0, i0;
            function tween() {
                var i = value.apply(this, arguments);
                if (i !== i0) t0 = (i0 = i) && textInterpolate(i);
                return t0;
            }
            tween._value = value;
            return tween;
        }
        function textTween(value) {
            var key = "text";
            if (arguments.length < 1) return (key = this.tween(key)) && key._value;
            if (null == value) return this.tween(key, null);
            if ("function" != typeof value) throw new Error;
            return this.tween(key, textTween_textTween(value));
        }
        function transition_transition() {
            var name = this._name, id0 = this._id, id1 = newId();
            for(var groups = this._groups, m = groups.length, j = 0; j < m; ++j)for(var group = groups[j], n = group.length, node, i = 0; i < n; ++i)if (node = group[i]) {
                var inherit = schedule_get(node, id0);
                transition_schedule(node, name, id1, i, group, {
                    time: inherit.time + inherit.delay + inherit.duration,
                    delay: 0,
                    duration: inherit.duration,
                    ease: inherit.ease
                });
            }
            return new Transition(groups, this._parents, name, id1);
        }
        function transition_end() {
            var on0, on1, that = this, id = that._id, size = that.size();
            return new Promise(function(resolve, reject) {
                var cancel = {
                    value: reject
                }, end = {
                    value: function() {
                        if (0 === --size) resolve();
                    }
                };
                that.each(function() {
                    var schedule = schedule_set(this, id), on = schedule.on;
                    if (on !== on0) {
                        on1 = (on0 = on).copy();
                        on1._.cancel.push(cancel);
                        on1._.interrupt.push(cancel);
                        on1._.end.push(end);
                    }
                    schedule.on = on1;
                });
                if (0 === size) resolve();
            });
        }
        var transition_id = 0;
        function Transition(groups, parents, name, id) {
            this._groups = groups;
            this._parents = parents;
            this._name = name;
            this._id = id;
        }
        function src_transition_transition(name) {
            return src_selection().transition(name);
        }
        function newId() {
            return ++transition_id;
        }
        var selection_prototype = src_selection.prototype;
        Transition.prototype = src_transition_transition.prototype = {
            constructor: Transition,
            select: transition_select,
            selectAll: transition_selectAll,
            selectChild: selection_prototype.selectChild,
            selectChildren: selection_prototype.selectChildren,
            filter: transition_filter,
            merge: transition_merge,
            selection: transition_selection,
            transition: transition_transition,
            call: selection_prototype.call,
            nodes: selection_prototype.nodes,
            node: selection_prototype.node,
            size: selection_prototype.size,
            empty: selection_prototype.empty,
            each: selection_prototype.each,
            on: transition_on,
            attr: transition_attr,
            attrTween: transition_attrTween,
            style: transition_style,
            styleTween: transition_styleTween,
            text: transition_text,
            textTween: textTween,
            remove: transition_remove,
            tween: transition_tween,
            delay: transition_delay,
            duration: transition_duration,
            ease: ease,
            easeVarying: easeVarying,
            end: transition_end,
            [Symbol.iterator]: selection_prototype[Symbol.iterator]
        };
        function cubicInOut(t) {
            return ((t *= 2) <= 1 ? t * t * t : (t -= 2) * t * t + 2) / 2;
        }
        var defaultTiming = {
            time: null,
            delay: 0,
            duration: 250,
            ease: cubicInOut
        };
        function transition_inherit(node, id) {
            var timing;
            while(!(timing = node.__transition) || !(timing = timing[id]))if (!(node = node.parentNode)) throw new Error(`transition ${id} not found`);
            return timing;
        }
        function selection_transition(name) {
            var id, timing;
            if (name instanceof Transition) id = name._id, name = name._name;
            else id = newId(), (timing = defaultTiming).time = timer_now(), name = null == name ? null : name + "";
            for(var groups = this._groups, m = groups.length, j = 0; j < m; ++j)for(var group = groups[j], n = group.length, node, i = 0; i < n; ++i)if (node = group[i]) transition_schedule(node, name, id, i, group, timing || transition_inherit(node, id));
            return new Transition(groups, this._parents, name, id);
        }
        src_selection.prototype.interrupt = selection_interrupt;
        src_selection.prototype.transition = selection_transition;
        const { abs, max: brush_max, min: brush_min } = Math;
        function number1(e) {
            return [
                +e[0],
                +e[1]
            ];
        }
        [
            "w",
            "e"
        ].map(brush_type);
        [
            "n",
            "s"
        ].map(brush_type);
        [
            "n",
            "w",
            "e",
            "s",
            "nw",
            "ne",
            "sw",
            "se"
        ].map(brush_type);
        function brush_type(t) {
            return {
                type: t
            };
        }
        const radians = Math.PI / 180;
        const math_degrees = 180 / Math.PI;
        const K = 18, Xn = 0.96422, Yn = 1, Zn = 0.82521, lab_t0 = 4 / 29, lab_t1 = 6 / 29, lab_t2 = 3 * lab_t1 * lab_t1, lab_t3 = lab_t1 * lab_t1 * lab_t1;
        function labConvert(o) {
            if (o instanceof Lab) return new Lab(o.l, o.a, o.b, o.opacity);
            if (o instanceof Hcl) return hcl2lab(o);
            if (!(o instanceof Rgb)) o = rgbConvert(o);
            var r = rgb2lrgb(o.r), g = rgb2lrgb(o.g), b = rgb2lrgb(o.b), y = xyz2lab((0.2225045 * r + 0.7168786 * g + 0.0606169 * b) / Yn), x, z;
            if (r === g && g === b) x = z = y;
            else {
                x = xyz2lab((0.4360747 * r + 0.3850649 * g + 0.1430804 * b) / Xn);
                z = xyz2lab((0.0139322 * r + 0.0971045 * g + 0.7141733 * b) / Zn);
            }
            return new Lab(116 * y - 16, 500 * (x - y), 200 * (y - z), o.opacity);
        }
        function lab(l, a, b, opacity) {
            return 1 === arguments.length ? labConvert(l) : new Lab(l, a, b, null == opacity ? 1 : opacity);
        }
        function Lab(l, a, b, opacity) {
            this.l = +l;
            this.a = +a;
            this.b = +b;
            this.opacity = +opacity;
        }
        src_define(Lab, lab, extend(Color, {
            brighter (k) {
                return new Lab(this.l + K * (null == k ? 1 : k), this.a, this.b, this.opacity);
            },
            darker (k) {
                return new Lab(this.l - K * (null == k ? 1 : k), this.a, this.b, this.opacity);
            },
            rgb () {
                var y = (this.l + 16) / 116, x = isNaN(this.a) ? y : y + this.a / 500, z = isNaN(this.b) ? y : y - this.b / 200;
                x = Xn * lab2xyz(x);
                y = Yn * lab2xyz(y);
                z = Zn * lab2xyz(z);
                return new Rgb(lrgb2rgb(3.1338561 * x - 1.6168667 * y - 0.4906146 * z), lrgb2rgb(-0.9787684 * x + 1.9161415 * y + 0.0334540 * z), lrgb2rgb(0.0719453 * x - 0.2289914 * y + 1.4052427 * z), this.opacity);
            }
        }));
        function xyz2lab(t) {
            return t > lab_t3 ? Math.pow(t, 1 / 3) : t / lab_t2 + lab_t0;
        }
        function lab2xyz(t) {
            return t > lab_t1 ? t * t * t : lab_t2 * (t - lab_t0);
        }
        function lrgb2rgb(x) {
            return 255 * (x <= 0.0031308 ? 12.92 * x : 1.055 * Math.pow(x, 1 / 2.4) - 0.055);
        }
        function rgb2lrgb(x) {
            return (x /= 255) <= 0.04045 ? x / 12.92 : Math.pow((x + 0.055) / 1.055, 2.4);
        }
        function hclConvert(o) {
            if (o instanceof Hcl) return new Hcl(o.h, o.c, o.l, o.opacity);
            if (!(o instanceof Lab)) o = labConvert(o);
            if (0 === o.a && 0 === o.b) return new Hcl(NaN, 0 < o.l && o.l < 100 ? 0 : NaN, o.l, o.opacity);
            var h = Math.atan2(o.b, o.a) * math_degrees;
            return new Hcl(h < 0 ? h + 360 : h, Math.sqrt(o.a * o.a + o.b * o.b), o.l, o.opacity);
        }
        function hcl(h, c, l, opacity) {
            return 1 === arguments.length ? hclConvert(h) : new Hcl(h, c, l, null == opacity ? 1 : opacity);
        }
        function Hcl(h, c, l, opacity) {
            this.h = +h;
            this.c = +c;
            this.l = +l;
            this.opacity = +opacity;
        }
        function hcl2lab(o) {
            if (isNaN(o.h)) return new Lab(o.l, 0, 0, o.opacity);
            var h = o.h * radians;
            return new Lab(o.l, Math.cos(h) * o.c, Math.sin(h) * o.c, o.opacity);
        }
        src_define(Hcl, hcl, extend(Color, {
            brighter (k) {
                return new Hcl(this.h, this.c, this.l + K * (null == k ? 1 : k), this.opacity);
            },
            darker (k) {
                return new Hcl(this.h, this.c, this.l - K * (null == k ? 1 : k), this.opacity);
            },
            rgb () {
                return hcl2lab(this).rgb();
            }
        }));
        function hcl_hcl(hue) {
            return function(start, end) {
                var h = hue((start = hcl(start)).h, (end = hcl(end)).h), c = nogamma(start.c, end.c), l = nogamma(start.l, end.l), opacity = nogamma(start.opacity, end.opacity);
                return function(t) {
                    start.h = h(t);
                    start.c = c(t);
                    start.l = l(t);
                    start.opacity = opacity(t);
                    return start + "";
                };
            };
        }
        const src_hcl = hcl_hcl(color_hue);
        hcl_hcl(nogamma);
        function range_range(start, stop, step) {
            start = +start, stop = +stop, step = (n = arguments.length) < 2 ? (stop = start, start = 0, 1) : n < 3 ? 1 : +step;
            var i = -1, n = 0 | Math.max(0, Math.ceil((stop - start) / step)), range = new Array(n);
            while(++i < n)range[i] = start + i * step;
            return range;
        }
        function initRange(domain, range) {
            switch(arguments.length){
                case 0:
                    break;
                case 1:
                    this.range(domain);
                    break;
                default:
                    this.range(range).domain(domain);
                    break;
            }
            return this;
        }
        class InternMap extends Map {
            constructor(entries, key = keyof){
                super();
                Object.defineProperties(this, {
                    _intern: {
                        value: new Map()
                    },
                    _key: {
                        value: key
                    }
                });
                if (null != entries) for (const [key, value] of entries)this.set(key, value);
            }
            get(key) {
                return super.get(intern_get(this, key));
            }
            has(key) {
                return super.has(intern_get(this, key));
            }
            set(key, value) {
                return super.set(intern_set(this, key), value);
            }
            delete(key) {
                return super.delete(intern_delete(this, key));
            }
        }
        function intern_get({ _intern, _key }, value) {
            const key = _key(value);
            return _intern.has(key) ? _intern.get(key) : value;
        }
        function intern_set({ _intern, _key }, value) {
            const key = _key(value);
            if (_intern.has(key)) return _intern.get(key);
            _intern.set(key, value);
            return value;
        }
        function intern_delete({ _intern, _key }, value) {
            const key = _key(value);
            if (_intern.has(key)) {
                value = _intern.get(key);
                _intern.delete(key);
            }
            return value;
        }
        function keyof(value) {
            return null !== value && "object" == typeof value ? value.valueOf() : value;
        }
        const implicit = Symbol("implicit");
        function ordinal() {
            var index = new InternMap(), domain = [], range = [], unknown = implicit;
            function scale(d) {
                let i = index.get(d);
                if (void 0 === i) {
                    if (unknown !== implicit) return unknown;
                    index.set(d, i = domain.push(d) - 1);
                }
                return range[i % range.length];
            }
            scale.domain = function(_) {
                if (!arguments.length) return domain.slice();
                domain = [], index = new InternMap();
                for (const value of _)if (!index.has(value)) index.set(value, domain.push(value) - 1);
                return scale;
            };
            scale.range = function(_) {
                return arguments.length ? (range = Array.from(_), scale) : range.slice();
            };
            scale.unknown = function(_) {
                return arguments.length ? (unknown = _, scale) : unknown;
            };
            scale.copy = function() {
                return ordinal(domain, range).unknown(unknown);
            };
            initRange.apply(scale, arguments);
            return scale;
        }
        function band() {
            var scale = ordinal().unknown(void 0), domain = scale.domain, ordinalRange = scale.range, r0 = 0, r1 = 1, step, bandwidth, round = false, paddingInner = 0, paddingOuter = 0, align = 0.5;
            delete scale.unknown;
            function rescale() {
                var n = domain().length, reverse = r1 < r0, start = reverse ? r1 : r0, stop = reverse ? r0 : r1;
                step = (stop - start) / Math.max(1, n - paddingInner + 2 * paddingOuter);
                if (round) step = Math.floor(step);
                start += (stop - start - step * (n - paddingInner)) * align;
                bandwidth = step * (1 - paddingInner);
                if (round) start = Math.round(start), bandwidth = Math.round(bandwidth);
                var values = range_range(n).map(function(i) {
                    return start + step * i;
                });
                return ordinalRange(reverse ? values.reverse() : values);
            }
            scale.domain = function(_) {
                return arguments.length ? (domain(_), rescale()) : domain();
            };
            scale.range = function(_) {
                return arguments.length ? ([r0, r1] = _, r0 = +r0, r1 = +r1, rescale()) : [
                    r0,
                    r1
                ];
            };
            scale.rangeRound = function(_) {
                return [r0, r1] = _, r0 = +r0, r1 = +r1, round = true, rescale();
            };
            scale.bandwidth = function() {
                return bandwidth;
            };
            scale.step = function() {
                return step;
            };
            scale.round = function(_) {
                return arguments.length ? (round = !!_, rescale()) : round;
            };
            scale.padding = function(_) {
                return arguments.length ? (paddingInner = Math.min(1, paddingOuter = +_), rescale()) : paddingInner;
            };
            scale.paddingInner = function(_) {
                return arguments.length ? (paddingInner = Math.min(1, _), rescale()) : paddingInner;
            };
            scale.paddingOuter = function(_) {
                return arguments.length ? (paddingOuter = +_, rescale()) : paddingOuter;
            };
            scale.align = function(_) {
                return arguments.length ? (align = Math.max(0, Math.min(1, _)), rescale()) : align;
            };
            scale.copy = function() {
                return band(domain(), [
                    r0,
                    r1
                ]).round(round).paddingInner(paddingInner).paddingOuter(paddingOuter).align(align);
            };
            return initRange.apply(rescale(), arguments);
        }
        const e10 = Math.sqrt(50), e5 = Math.sqrt(10), e2 = Math.sqrt(2);
        function tickSpec(start, stop, count) {
            const step = (stop - start) / Math.max(0, count), power = Math.floor(Math.log10(step)), error = step / Math.pow(10, power), factor = error >= e10 ? 10 : error >= e5 ? 5 : error >= e2 ? 2 : 1;
            let i1, i2, inc;
            if (power < 0) {
                inc = Math.pow(10, -power) / factor;
                i1 = Math.round(start * inc);
                i2 = Math.round(stop * inc);
                if (i1 / inc < start) ++i1;
                if (i2 / inc > stop) --i2;
                inc = -inc;
            } else {
                inc = Math.pow(10, power) * factor;
                i1 = Math.round(start / inc);
                i2 = Math.round(stop / inc);
                if (i1 * inc < start) ++i1;
                if (i2 * inc > stop) --i2;
            }
            if (i2 < i1 && 0.5 <= count && count < 2) return tickSpec(start, stop, 2 * count);
            return [
                i1,
                i2,
                inc
            ];
        }
        function ticks_ticks(start, stop, count) {
            stop = +stop, start = +start, count = +count;
            if (!(count > 0)) return [];
            if (start === stop) return [
                start
            ];
            const reverse = stop < start, [i1, i2, inc] = reverse ? tickSpec(stop, start, count) : tickSpec(start, stop, count);
            if (!(i2 >= i1)) return [];
            const n = i2 - i1 + 1, ticks = new Array(n);
            if (reverse) {
                if (inc < 0) for(let i = 0; i < n; ++i)ticks[i] = (i2 - i) / -inc;
                else for(let i = 0; i < n; ++i)ticks[i] = (i2 - i) * inc;
            } else if (inc < 0) for(let i = 0; i < n; ++i)ticks[i] = (i1 + i) / -inc;
            else for(let i = 0; i < n; ++i)ticks[i] = (i1 + i) * inc;
            return ticks;
        }
        function tickIncrement(start, stop, count) {
            stop = +stop, start = +start, count = +count;
            return tickSpec(start, stop, count)[2];
        }
        function tickStep(start, stop, count) {
            stop = +stop, start = +start, count = +count;
            const reverse = stop < start, inc = reverse ? tickIncrement(stop, start, count) : tickIncrement(start, stop, count);
            return (reverse ? -1 : 1) * (inc < 0 ? 1 / -inc : inc);
        }
        function ascending_ascending(a, b) {
            return null == a || null == b ? NaN : a < b ? -1 : a > b ? 1 : a >= b ? 0 : NaN;
        }
        function descending(a, b) {
            return null == a || null == b ? NaN : b < a ? -1 : b > a ? 1 : b >= a ? 0 : NaN;
        }
        function bisector(f) {
            let compare1, compare2, delta;
            if (2 !== f.length) {
                compare1 = ascending_ascending;
                compare2 = (d, x)=>ascending_ascending(f(d), x);
                delta = (d, x)=>f(d) - x;
            } else {
                compare1 = f === ascending_ascending || f === descending ? f : bisector_zero;
                compare2 = f;
                delta = f;
            }
            function left(a, x, lo = 0, hi = a.length) {
                if (lo < hi) {
                    if (0 !== compare1(x, x)) return hi;
                    do {
                        const mid = lo + hi >>> 1;
                        if (compare2(a[mid], x) < 0) lo = mid + 1;
                        else hi = mid;
                    }while (lo < hi);
                }
                return lo;
            }
            function right(a, x, lo = 0, hi = a.length) {
                if (lo < hi) {
                    if (0 !== compare1(x, x)) return hi;
                    do {
                        const mid = lo + hi >>> 1;
                        if (compare2(a[mid], x) <= 0) lo = mid + 1;
                        else hi = mid;
                    }while (lo < hi);
                }
                return lo;
            }
            function center(a, x, lo = 0, hi = a.length) {
                const i = left(a, x, lo, hi - 1);
                return i > lo && delta(a[i - 1], x) > -delta(a[i], x) ? i - 1 : i;
            }
            return {
                left,
                center,
                right
            };
        }
        function bisector_zero() {
            return 0;
        }
        function number_number(x) {
            return null === x ? NaN : +x;
        }
        const ascendingBisect = bisector(ascending_ascending);
        const bisectRight = ascendingBisect.right;
        ascendingBisect.left;
        bisector(number_number).center;
        const bisect = bisectRight;
        function genericArray(a, b) {
            var nb = b ? b.length : 0, na = a ? Math.min(nb, a.length) : 0, x = new Array(na), c = new Array(nb), i;
            for(i = 0; i < na; ++i)x[i] = src_value(a[i], b[i]);
            for(; i < nb; ++i)c[i] = b[i];
            return function(t) {
                for(i = 0; i < na; ++i)c[i] = x[i](t);
                return c;
            };
        }
        function src_date(a, b) {
            var d = new Date;
            return a = +a, b = +b, function(t) {
                return d.setTime(a * (1 - t) + b * t), d;
            };
        }
        function object(a, b) {
            var i = {}, c = {}, k;
            if (null === a || "object" != typeof a) a = {};
            if (null === b || "object" != typeof b) b = {};
            for(k in b)if (k in a) i[k] = src_value(a[k], b[k]);
            else c[k] = b[k];
            return function(t) {
                for(k in i)c[k] = i[k](t);
                return c;
            };
        }
        function src_numberArray(a, b) {
            if (!b) b = [];
            var n = a ? Math.min(b.length, a.length) : 0, c = b.slice(), i;
            return function(t) {
                for(i = 0; i < n; ++i)c[i] = a[i] * (1 - t) + b[i] * t;
                return c;
            };
        }
        function numberArray_isNumberArray(x) {
            return ArrayBuffer.isView(x) && !(x instanceof DataView);
        }
        function src_value(a, b) {
            var t = typeof b, c;
            return null == b || "boolean" === t ? d3_interpolate_src_constant(b) : ("number" === t ? src_number : "string" === t ? (c = color_color(b)) ? (b = c, src_rgb) : src_string : b instanceof color_color ? src_rgb : b instanceof Date ? src_date : numberArray_isNumberArray(b) ? src_numberArray : Array.isArray(b) ? genericArray : "function" != typeof b.valueOf && "function" != typeof b.toString || isNaN(b) ? object : src_number)(a, b);
        }
        function src_round(a, b) {
            return a = +a, b = +b, function(t) {
                return Math.round(a * (1 - t) + b * t);
            };
        }
        function constants(x) {
            return function() {
                return x;
            };
        }
        function src_number_number(x) {
            return +x;
        }
        var unit = [
            0,
            1
        ];
        function continuous_identity(x) {
            return x;
        }
        function normalize(a, b) {
            return (b -= a = +a) ? function(x) {
                return (x - a) / b;
            } : constants(isNaN(b) ? NaN : 0.5);
        }
        function clamper(a, b) {
            var t;
            if (a > b) t = a, a = b, b = t;
            return function(x) {
                return Math.max(a, Math.min(b, x));
            };
        }
        function bimap(domain, range, interpolate) {
            var d0 = domain[0], d1 = domain[1], r0 = range[0], r1 = range[1];
            if (d1 < d0) d0 = normalize(d1, d0), r0 = interpolate(r1, r0);
            else d0 = normalize(d0, d1), r0 = interpolate(r0, r1);
            return function(x) {
                return r0(d0(x));
            };
        }
        function polymap(domain, range, interpolate) {
            var j = Math.min(domain.length, range.length) - 1, d = new Array(j), r = new Array(j), i = -1;
            if (domain[j] < domain[0]) {
                domain = domain.slice().reverse();
                range = range.slice().reverse();
            }
            while(++i < j){
                d[i] = normalize(domain[i], domain[i + 1]);
                r[i] = interpolate(range[i], range[i + 1]);
            }
            return function(x) {
                var i = bisect(domain, x, 1, j) - 1;
                return r[i](d[i](x));
            };
        }
        function continuous_copy(source, target) {
            return target.domain(source.domain()).range(source.range()).interpolate(source.interpolate()).clamp(source.clamp()).unknown(source.unknown());
        }
        function transformer() {
            var domain = unit, range = unit, interpolate = src_value, transform, untransform, unknown, clamp = continuous_identity, piecewise, output, input;
            function rescale() {
                var n = Math.min(domain.length, range.length);
                if (clamp !== continuous_identity) clamp = clamper(domain[0], domain[n - 1]);
                piecewise = n > 2 ? polymap : bimap;
                output = input = null;
                return scale;
            }
            function scale(x) {
                return null == x || isNaN(x = +x) ? unknown : (output || (output = piecewise(domain.map(transform), range, interpolate)))(transform(clamp(x)));
            }
            scale.invert = function(y) {
                return clamp(untransform((input || (input = piecewise(range, domain.map(transform), src_number)))(y)));
            };
            scale.domain = function(_) {
                return arguments.length ? (domain = Array.from(_, src_number_number), rescale()) : domain.slice();
            };
            scale.range = function(_) {
                return arguments.length ? (range = Array.from(_), rescale()) : range.slice();
            };
            scale.rangeRound = function(_) {
                return range = Array.from(_), interpolate = src_round, rescale();
            };
            scale.clamp = function(_) {
                return arguments.length ? (clamp = !!_ || continuous_identity, rescale()) : clamp !== continuous_identity;
            };
            scale.interpolate = function(_) {
                return arguments.length ? (interpolate = _, rescale()) : interpolate;
            };
            scale.unknown = function(_) {
                return arguments.length ? (unknown = _, scale) : unknown;
            };
            return function(t, u) {
                transform = t, untransform = u;
                return rescale();
            };
        }
        function continuous() {
            return transformer()(continuous_identity, continuous_identity);
        }
        var re = /^(?:(.)?([<>=^]))?([+\-( ])?([$#])?(0)?(\d+)?(,)?(\.\d+)?(~)?([a-z%])?$/i;
        function formatSpecifier(specifier) {
            if (!(match = re.exec(specifier))) throw new Error("invalid format: " + specifier);
            var match;
            return new FormatSpecifier({
                fill: match[1],
                align: match[2],
                sign: match[3],
                symbol: match[4],
                zero: match[5],
                width: match[6],
                comma: match[7],
                precision: match[8] && match[8].slice(1),
                trim: match[9],
                type: match[10]
            });
        }
        formatSpecifier.prototype = FormatSpecifier.prototype;
        function FormatSpecifier(specifier) {
            this.fill = void 0 === specifier.fill ? " " : specifier.fill + "";
            this.align = void 0 === specifier.align ? ">" : specifier.align + "";
            this.sign = void 0 === specifier.sign ? "-" : specifier.sign + "";
            this.symbol = void 0 === specifier.symbol ? "" : specifier.symbol + "";
            this.zero = !!specifier.zero;
            this.width = void 0 === specifier.width ? void 0 : +specifier.width;
            this.comma = !!specifier.comma;
            this.precision = void 0 === specifier.precision ? void 0 : +specifier.precision;
            this.trim = !!specifier.trim;
            this.type = void 0 === specifier.type ? "" : specifier.type + "";
        }
        FormatSpecifier.prototype.toString = function() {
            return this.fill + this.align + this.sign + this.symbol + (this.zero ? "0" : "") + (void 0 === this.width ? "" : Math.max(1, 0 | this.width)) + (this.comma ? "," : "") + (void 0 === this.precision ? "" : "." + Math.max(0, 0 | this.precision)) + (this.trim ? "~" : "") + this.type;
        };
        function formatDecimal(x) {
            return Math.abs(x = Math.round(x)) >= 1e21 ? x.toLocaleString("en").replace(/,/g, "") : x.toString(10);
        }
        function formatDecimalParts(x, p) {
            if ((i = (x = p ? x.toExponential(p - 1) : x.toExponential()).indexOf("e")) < 0) return null;
            var i, coefficient = x.slice(0, i);
            return [
                coefficient.length > 1 ? coefficient[0] + coefficient.slice(2) : coefficient,
                +x.slice(i + 1)
            ];
        }
        function src_exponent(x) {
            return x = formatDecimalParts(Math.abs(x)), x ? x[1] : NaN;
        }
        function precisionPrefix(step, value) {
            return Math.max(0, 3 * Math.max(-8, Math.min(8, Math.floor(src_exponent(value) / 3))) - src_exponent(Math.abs(step)));
        }
        function formatGroup(grouping, thousands) {
            return function(value, width) {
                var i = value.length, t = [], j = 0, g = grouping[0], length = 0;
                while(i > 0 && g > 0){
                    if (length + g + 1 > width) g = Math.max(1, width - length);
                    t.push(value.substring(i -= g, i + g));
                    if ((length += g + 1) > width) break;
                    g = grouping[j = (j + 1) % grouping.length];
                }
                return t.reverse().join(thousands);
            };
        }
        function formatNumerals(numerals) {
            return function(value) {
                return value.replace(/[0-9]/g, function(i) {
                    return numerals[+i];
                });
            };
        }
        function formatTrim(s) {
            out: for(var n = s.length, i = 1, i0 = -1, i1; i < n; ++i)switch(s[i]){
                case ".":
                    i0 = i1 = i;
                    break;
                case "0":
                    if (0 === i0) i0 = i;
                    i1 = i;
                    break;
                default:
                    if (!+s[i]) break out;
                    if (i0 > 0) i0 = 0;
                    break;
            }
            return i0 > 0 ? s.slice(0, i0) + s.slice(i1 + 1) : s;
        }
        var prefixExponent;
        function formatPrefixAuto(x, p) {
            var d = formatDecimalParts(x, p);
            if (!d) return x + "";
            var coefficient = d[0], exponent = d[1], i = exponent - (prefixExponent = 3 * Math.max(-8, Math.min(8, Math.floor(exponent / 3)))) + 1, n = coefficient.length;
            return i === n ? coefficient : i > n ? coefficient + new Array(i - n + 1).join("0") : i > 0 ? coefficient.slice(0, i) + "." + coefficient.slice(i) : "0." + new Array(1 - i).join("0") + formatDecimalParts(x, Math.max(0, p + i - 1))[0];
        }
        function formatRounded(x, p) {
            var d = formatDecimalParts(x, p);
            if (!d) return x + "";
            var coefficient = d[0], exponent = d[1];
            return exponent < 0 ? "0." + new Array(-exponent).join("0") + coefficient : coefficient.length > exponent + 1 ? coefficient.slice(0, exponent + 1) + "." + coefficient.slice(exponent + 1) : coefficient + new Array(exponent - coefficient.length + 2).join("0");
        }
        const formatTypes = {
            "%": (x, p)=>(100 * x).toFixed(p),
            b: (x)=>Math.round(x).toString(2),
            c: (x)=>x + "",
            d: formatDecimal,
            e: (x, p)=>x.toExponential(p),
            f: (x, p)=>x.toFixed(p),
            g: (x, p)=>x.toPrecision(p),
            o: (x)=>Math.round(x).toString(8),
            p: (x, p)=>formatRounded(100 * x, p),
            r: formatRounded,
            s: formatPrefixAuto,
            X: (x)=>Math.round(x).toString(16).toUpperCase(),
            x: (x)=>Math.round(x).toString(16)
        };
        function d3_format_src_identity(x) {
            return x;
        }
        var map = Array.prototype.map, prefixes = [
            "y",
            "z",
            "a",
            "f",
            "p",
            "n",
            "µ",
            "m",
            "",
            "k",
            "M",
            "G",
            "T",
            "P",
            "E",
            "Z",
            "Y"
        ];
        function src_locale(locale) {
            var group = void 0 === locale.grouping || void 0 === locale.thousands ? d3_format_src_identity : formatGroup(map.call(locale.grouping, Number), locale.thousands + ""), currencyPrefix = void 0 === locale.currency ? "" : locale.currency[0] + "", currencySuffix = void 0 === locale.currency ? "" : locale.currency[1] + "", decimal = void 0 === locale.decimal ? "." : locale.decimal + "", numerals = void 0 === locale.numerals ? d3_format_src_identity : formatNumerals(map.call(locale.numerals, String)), percent = void 0 === locale.percent ? "%" : locale.percent + "", minus = void 0 === locale.minus ? "−" : locale.minus + "", nan = void 0 === locale.nan ? "NaN" : locale.nan + "";
            function newFormat(specifier) {
                specifier = formatSpecifier(specifier);
                var fill = specifier.fill, align = specifier.align, sign = specifier.sign, symbol = specifier.symbol, zero = specifier.zero, width = specifier.width, comma = specifier.comma, precision = specifier.precision, trim = specifier.trim, type = specifier.type;
                if ("n" === type) comma = true, type = "g";
                else if (!formatTypes[type]) void 0 === precision && (precision = 12), trim = true, type = "g";
                if (zero || "0" === fill && "=" === align) zero = true, fill = "0", align = "=";
                var prefix = "$" === symbol ? currencyPrefix : "#" === symbol && /[boxX]/.test(type) ? "0" + type.toLowerCase() : "", suffix = "$" === symbol ? currencySuffix : /[%p]/.test(type) ? percent : "";
                var formatType = formatTypes[type], maybeSuffix = /[defgprs%]/.test(type);
                precision = void 0 === precision ? 6 : /[gprs]/.test(type) ? Math.max(1, Math.min(21, precision)) : Math.max(0, Math.min(20, precision));
                function format(value) {
                    var valuePrefix = prefix, valueSuffix = suffix, i, n, c;
                    if ("c" === type) {
                        valueSuffix = formatType(value) + valueSuffix;
                        value = "";
                    } else {
                        value = +value;
                        var valueNegative = value < 0 || 1 / value < 0;
                        value = isNaN(value) ? nan : formatType(Math.abs(value), precision);
                        if (trim) value = formatTrim(value);
                        if (valueNegative && 0 === +value && "+" !== sign) valueNegative = false;
                        valuePrefix = (valueNegative ? "(" === sign ? sign : minus : "-" === sign || "(" === sign ? "" : sign) + valuePrefix;
                        valueSuffix = ("s" === type ? prefixes[8 + prefixExponent / 3] : "") + valueSuffix + (valueNegative && "(" === sign ? ")" : "");
                        if (maybeSuffix) {
                            i = -1, n = value.length;
                            while(++i < n)if (c = value.charCodeAt(i), 48 > c || c > 57) {
                                valueSuffix = (46 === c ? decimal + value.slice(i + 1) : value.slice(i)) + valueSuffix;
                                value = value.slice(0, i);
                                break;
                            }
                        }
                    }
                    if (comma && !zero) value = group(value, 1 / 0);
                    var length = valuePrefix.length + value.length + valueSuffix.length, padding = length < width ? new Array(width - length + 1).join(fill) : "";
                    if (comma && zero) value = group(padding + value, padding.length ? width - valueSuffix.length : 1 / 0), padding = "";
                    switch(align){
                        case "<":
                            value = valuePrefix + value + valueSuffix + padding;
                            break;
                        case "=":
                            value = valuePrefix + padding + value + valueSuffix;
                            break;
                        case "^":
                            value = padding.slice(0, length = padding.length >> 1) + valuePrefix + value + valueSuffix + padding.slice(length);
                            break;
                        default:
                            value = padding + valuePrefix + value + valueSuffix;
                            break;
                    }
                    return numerals(value);
                }
                format.toString = function() {
                    return specifier + "";
                };
                return format;
            }
            function formatPrefix(specifier, value) {
                var f = newFormat((specifier = formatSpecifier(specifier), specifier.type = "f", specifier)), e = 3 * Math.max(-8, Math.min(8, Math.floor(src_exponent(value) / 3))), k = Math.pow(10, -e), prefix = prefixes[8 + e / 3];
                return function(value) {
                    return f(k * value) + prefix;
                };
            }
            return {
                format: newFormat,
                formatPrefix: formatPrefix
            };
        }
        var defaultLocale_locale;
        var defaultLocale_format;
        var defaultLocale_formatPrefix;
        defaultLocale({
            thousands: ",",
            grouping: [
                3
            ],
            currency: [
                "$",
                ""
            ]
        });
        function defaultLocale(definition) {
            defaultLocale_locale = src_locale(definition);
            defaultLocale_format = defaultLocale_locale.format;
            defaultLocale_formatPrefix = defaultLocale_locale.formatPrefix;
            return defaultLocale_locale;
        }
        function precisionRound(step, max) {
            step = Math.abs(step), max = Math.abs(max) - step;
            return Math.max(0, src_exponent(max) - src_exponent(step)) + 1;
        }
        function precisionFixed(step) {
            return Math.max(0, -src_exponent(Math.abs(step)));
        }
        function tickFormat_tickFormat(start, stop, count, specifier) {
            var step = tickStep(start, stop, count), precision;
            specifier = formatSpecifier(null == specifier ? ",f" : specifier);
            switch(specifier.type){
                case "s":
                    var value = Math.max(Math.abs(start), Math.abs(stop));
                    if (null == specifier.precision && !isNaN(precision = precisionPrefix(step, value))) specifier.precision = precision;
                    return defaultLocale_formatPrefix(specifier, value);
                case "":
                case "e":
                case "g":
                case "p":
                case "r":
                    if (null == specifier.precision && !isNaN(precision = precisionRound(step, Math.max(Math.abs(start), Math.abs(stop))))) specifier.precision = precision - ("e" === specifier.type);
                    break;
                case "f":
                case "%":
                    if (null == specifier.precision && !isNaN(precision = precisionFixed(step))) specifier.precision = precision - ("%" === specifier.type) * 2;
                    break;
            }
            return defaultLocale_format(specifier);
        }
        function linearish(scale) {
            var domain = scale.domain;
            scale.ticks = function(count) {
                var d = domain();
                return ticks_ticks(d[0], d[d.length - 1], null == count ? 10 : count);
            };
            scale.tickFormat = function(count, specifier) {
                var d = domain();
                return tickFormat_tickFormat(d[0], d[d.length - 1], null == count ? 10 : count, specifier);
            };
            scale.nice = function(count) {
                if (null == count) count = 10;
                var d = domain();
                var i0 = 0;
                var i1 = d.length - 1;
                var start = d[i0];
                var stop = d[i1];
                var prestep;
                var step;
                var maxIter = 10;
                if (stop < start) {
                    step = start, start = stop, stop = step;
                    step = i0, i0 = i1, i1 = step;
                }
                while(maxIter-- > 0){
                    step = tickIncrement(start, stop, count);
                    if (step === prestep) {
                        d[i0] = start;
                        d[i1] = stop;
                        return domain(d);
                    }
                    if (step > 0) {
                        start = Math.floor(start / step) * step;
                        stop = Math.ceil(stop / step) * step;
                    } else if (step < 0) {
                        start = Math.ceil(start * step) / step;
                        stop = Math.floor(stop * step) / step;
                    } else break;
                    prestep = step;
                }
                return scale;
            };
            return scale;
        }
        function linear_linear() {
            var scale = continuous();
            scale.copy = function() {
                return continuous_copy(scale, linear_linear());
            };
            initRange.apply(scale, arguments);
            return linearish(scale);
        }
        const durationSecond = 1000;
        const durationMinute = 60 * durationSecond;
        const durationHour = 60 * durationMinute;
        const durationDay = 24 * durationHour;
        const durationWeek = 7 * durationDay;
        const durationMonth = 30 * durationDay;
        const durationYear = 365 * durationDay;
        const interval_t0 = new Date, interval_t1 = new Date;
        function timeInterval(floori, offseti, count, field) {
            function interval(date) {
                return floori(date = 0 === arguments.length ? new Date : new Date(+date)), date;
            }
            interval.floor = (date)=>(floori(date = new Date(+date)), date);
            interval.ceil = (date)=>(floori(date = new Date(date - 1)), offseti(date, 1), floori(date), date);
            interval.round = (date)=>{
                const d0 = interval(date), d1 = interval.ceil(date);
                return date - d0 < d1 - date ? d0 : d1;
            };
            interval.offset = (date, step)=>(offseti(date = new Date(+date), null == step ? 1 : Math.floor(step)), date);
            interval.range = (start, stop, step)=>{
                const range = [];
                start = interval.ceil(start);
                step = null == step ? 1 : Math.floor(step);
                if (!(start < stop) || !(step > 0)) return range;
                let previous;
                do range.push(previous = new Date(+start)), offseti(start, step), floori(start);
                while (previous < start && start < stop);
                return range;
            };
            interval.filter = (test)=>timeInterval((date)=>{
                    if (date >= date) while(floori(date), !test(date))date.setTime(date - 1);
                }, (date, step)=>{
                    if (date >= date) {
                        if (step < 0) while(++step <= 0)while(offseti(date, -1), !test(date));
                        else while(--step >= 0)while(offseti(date, 1), !test(date));
                    }
                });
            if (count) {
                interval.count = (start, end)=>{
                    interval_t0.setTime(+start), interval_t1.setTime(+end);
                    floori(interval_t0), floori(interval_t1);
                    return Math.floor(count(interval_t0, interval_t1));
                };
                interval.every = (step)=>{
                    step = Math.floor(step);
                    return isFinite(step) && step > 0 ? step > 1 ? interval.filter(field ? (d)=>field(d) % step === 0 : (d)=>interval.count(0, d) % step === 0) : interval : null;
                };
            }
            return interval;
        }
        const millisecond = timeInterval(()=>{}, (date, step)=>{
            date.setTime(+date + step);
        }, (start, end)=>end - start);
        millisecond.every = (k)=>{
            k = Math.floor(k);
            if (!isFinite(k) || !(k > 0)) return null;
            if (!(k > 1)) return millisecond;
            return timeInterval((date)=>{
                date.setTime(Math.floor(date / k) * k);
            }, (date, step)=>{
                date.setTime(+date + step * k);
            }, (start, end)=>(end - start) / k);
        };
        millisecond.range;
        const second_second = timeInterval((date)=>{
            date.setTime(date - date.getMilliseconds());
        }, (date, step)=>{
            date.setTime(+date + step * durationSecond);
        }, (start, end)=>(end - start) / durationSecond, (date)=>date.getUTCSeconds());
        second_second.range;
        const timeMinute = timeInterval((date)=>{
            date.setTime(date - date.getMilliseconds() - date.getSeconds() * durationSecond);
        }, (date, step)=>{
            date.setTime(+date + step * durationMinute);
        }, (start, end)=>(end - start) / durationMinute, (date)=>date.getMinutes());
        timeMinute.range;
        const utcMinute = timeInterval((date)=>{
            date.setUTCSeconds(0, 0);
        }, (date, step)=>{
            date.setTime(+date + step * durationMinute);
        }, (start, end)=>(end - start) / durationMinute, (date)=>date.getUTCMinutes());
        utcMinute.range;
        const timeHour = timeInterval((date)=>{
            date.setTime(date - date.getMilliseconds() - date.getSeconds() * durationSecond - date.getMinutes() * durationMinute);
        }, (date, step)=>{
            date.setTime(+date + step * durationHour);
        }, (start, end)=>(end - start) / durationHour, (date)=>date.getHours());
        timeHour.range;
        const utcHour = timeInterval((date)=>{
            date.setUTCMinutes(0, 0, 0);
        }, (date, step)=>{
            date.setTime(+date + step * durationHour);
        }, (start, end)=>(end - start) / durationHour, (date)=>date.getUTCHours());
        utcHour.range;
        const timeDay = timeInterval((date)=>date.setHours(0, 0, 0, 0), (date, step)=>date.setDate(date.getDate() + step), (start, end)=>(end - start - (end.getTimezoneOffset() - start.getTimezoneOffset()) * durationMinute) / durationDay, (date)=>date.getDate() - 1);
        timeDay.range;
        const utcDay = timeInterval((date)=>{
            date.setUTCHours(0, 0, 0, 0);
        }, (date, step)=>{
            date.setUTCDate(date.getUTCDate() + step);
        }, (start, end)=>(end - start) / durationDay, (date)=>date.getUTCDate() - 1);
        utcDay.range;
        const unixDay = timeInterval((date)=>{
            date.setUTCHours(0, 0, 0, 0);
        }, (date, step)=>{
            date.setUTCDate(date.getUTCDate() + step);
        }, (start, end)=>(end - start) / durationDay, (date)=>Math.floor(date / durationDay));
        unixDay.range;
        function timeWeekday(i) {
            return timeInterval((date)=>{
                date.setDate(date.getDate() - (date.getDay() + 7 - i) % 7);
                date.setHours(0, 0, 0, 0);
            }, (date, step)=>{
                date.setDate(date.getDate() + 7 * step);
            }, (start, end)=>(end - start - (end.getTimezoneOffset() - start.getTimezoneOffset()) * durationMinute) / durationWeek);
        }
        const timeSunday = timeWeekday(0);
        const timeMonday = timeWeekday(1);
        const timeTuesday = timeWeekday(2);
        const timeWednesday = timeWeekday(3);
        const timeThursday = timeWeekday(4);
        const timeFriday = timeWeekday(5);
        const timeSaturday = timeWeekday(6);
        timeSunday.range;
        timeMonday.range;
        timeTuesday.range;
        timeWednesday.range;
        timeThursday.range;
        timeFriday.range;
        timeSaturday.range;
        function utcWeekday(i) {
            return timeInterval((date)=>{
                date.setUTCDate(date.getUTCDate() - (date.getUTCDay() + 7 - i) % 7);
                date.setUTCHours(0, 0, 0, 0);
            }, (date, step)=>{
                date.setUTCDate(date.getUTCDate() + 7 * step);
            }, (start, end)=>(end - start) / durationWeek);
        }
        const utcSunday = utcWeekday(0);
        const utcMonday = utcWeekday(1);
        const utcTuesday = utcWeekday(2);
        const utcWednesday = utcWeekday(3);
        const utcThursday = utcWeekday(4);
        const utcFriday = utcWeekday(5);
        const utcSaturday = utcWeekday(6);
        utcSunday.range;
        utcMonday.range;
        utcTuesday.range;
        utcWednesday.range;
        utcThursday.range;
        utcFriday.range;
        utcSaturday.range;
        const timeMonth = timeInterval((date)=>{
            date.setDate(1);
            date.setHours(0, 0, 0, 0);
        }, (date, step)=>{
            date.setMonth(date.getMonth() + step);
        }, (start, end)=>end.getMonth() - start.getMonth() + (end.getFullYear() - start.getFullYear()) * 12, (date)=>date.getMonth());
        timeMonth.range;
        const utcMonth = timeInterval((date)=>{
            date.setUTCDate(1);
            date.setUTCHours(0, 0, 0, 0);
        }, (date, step)=>{
            date.setUTCMonth(date.getUTCMonth() + step);
        }, (start, end)=>end.getUTCMonth() - start.getUTCMonth() + (end.getUTCFullYear() - start.getUTCFullYear()) * 12, (date)=>date.getUTCMonth());
        utcMonth.range;
        const timeYear = timeInterval((date)=>{
            date.setMonth(0, 1);
            date.setHours(0, 0, 0, 0);
        }, (date, step)=>{
            date.setFullYear(date.getFullYear() + step);
        }, (start, end)=>end.getFullYear() - start.getFullYear(), (date)=>date.getFullYear());
        timeYear.every = (k)=>isFinite(k = Math.floor(k)) && k > 0 ? timeInterval((date)=>{
                date.setFullYear(Math.floor(date.getFullYear() / k) * k);
                date.setMonth(0, 1);
                date.setHours(0, 0, 0, 0);
            }, (date, step)=>{
                date.setFullYear(date.getFullYear() + step * k);
            }) : null;
        timeYear.range;
        const utcYear = timeInterval((date)=>{
            date.setUTCMonth(0, 1);
            date.setUTCHours(0, 0, 0, 0);
        }, (date, step)=>{
            date.setUTCFullYear(date.getUTCFullYear() + step);
        }, (start, end)=>end.getUTCFullYear() - start.getUTCFullYear(), (date)=>date.getUTCFullYear());
        utcYear.every = (k)=>isFinite(k = Math.floor(k)) && k > 0 ? timeInterval((date)=>{
                date.setUTCFullYear(Math.floor(date.getUTCFullYear() / k) * k);
                date.setUTCMonth(0, 1);
                date.setUTCHours(0, 0, 0, 0);
            }, (date, step)=>{
                date.setUTCFullYear(date.getUTCFullYear() + step * k);
            }) : null;
        utcYear.range;
        function ticker(year, month, week, day, hour, minute) {
            const tickIntervals = [
                [
                    second_second,
                    1,
                    durationSecond
                ],
                [
                    second_second,
                    5,
                    5 * durationSecond
                ],
                [
                    second_second,
                    15,
                    15 * durationSecond
                ],
                [
                    second_second,
                    30,
                    30 * durationSecond
                ],
                [
                    minute,
                    1,
                    durationMinute
                ],
                [
                    minute,
                    5,
                    5 * durationMinute
                ],
                [
                    minute,
                    15,
                    15 * durationMinute
                ],
                [
                    minute,
                    30,
                    30 * durationMinute
                ],
                [
                    hour,
                    1,
                    durationHour
                ],
                [
                    hour,
                    3,
                    3 * durationHour
                ],
                [
                    hour,
                    6,
                    6 * durationHour
                ],
                [
                    hour,
                    12,
                    12 * durationHour
                ],
                [
                    day,
                    1,
                    durationDay
                ],
                [
                    day,
                    2,
                    2 * durationDay
                ],
                [
                    week,
                    1,
                    durationWeek
                ],
                [
                    month,
                    1,
                    durationMonth
                ],
                [
                    month,
                    3,
                    3 * durationMonth
                ],
                [
                    year,
                    1,
                    durationYear
                ]
            ];
            function ticks(start, stop, count) {
                const reverse = stop < start;
                if (reverse) [start, stop] = [
                    stop,
                    start
                ];
                const interval = count && "function" == typeof count.range ? count : tickInterval(start, stop, count);
                const ticks = interval ? interval.range(start, +stop + 1) : [];
                return reverse ? ticks.reverse() : ticks;
            }
            function tickInterval(start, stop, count) {
                const target = Math.abs(stop - start) / count;
                const i = bisector(([, , step])=>step).right(tickIntervals, target);
                if (i === tickIntervals.length) return year.every(tickStep(start / durationYear, stop / durationYear, count));
                if (0 === i) return millisecond.every(Math.max(tickStep(start, stop, count), 1));
                const [t, step] = tickIntervals[target / tickIntervals[i - 1][2] < tickIntervals[i][2] / target ? i - 1 : i];
                return t.every(step);
            }
            return [
                ticks,
                tickInterval
            ];
        }
        const [utcTicks, utcTickInterval] = ticker(utcYear, utcMonth, utcSunday, unixDay, utcHour, utcMinute);
        const [timeTicks, timeTickInterval] = ticker(timeYear, timeMonth, timeSunday, timeDay, timeHour, timeMinute);
        function localDate(d) {
            if (0 <= d.y && d.y < 100) {
                var date = new Date(-1, d.m, d.d, d.H, d.M, d.S, d.L);
                date.setFullYear(d.y);
                return date;
            }
            return new Date(d.y, d.m, d.d, d.H, d.M, d.S, d.L);
        }
        function utcDate(d) {
            if (0 <= d.y && d.y < 100) {
                var date = new Date(Date.UTC(-1, d.m, d.d, d.H, d.M, d.S, d.L));
                date.setUTCFullYear(d.y);
                return date;
            }
            return new Date(Date.UTC(d.y, d.m, d.d, d.H, d.M, d.S, d.L));
        }
        function newDate(y, m, d) {
            return {
                y: y,
                m: m,
                d: d,
                H: 0,
                M: 0,
                S: 0,
                L: 0
            };
        }
        function formatLocale(locale) {
            var locale_dateTime = locale.dateTime, locale_date = locale.date, locale_time = locale.time, locale_periods = locale.periods, locale_weekdays = locale.days, locale_shortWeekdays = locale.shortDays, locale_months = locale.months, locale_shortMonths = locale.shortMonths;
            var periodRe = formatRe(locale_periods), periodLookup = formatLookup(locale_periods), weekdayRe = formatRe(locale_weekdays), weekdayLookup = formatLookup(locale_weekdays), shortWeekdayRe = formatRe(locale_shortWeekdays), shortWeekdayLookup = formatLookup(locale_shortWeekdays), monthRe = formatRe(locale_months), monthLookup = formatLookup(locale_months), shortMonthRe = formatRe(locale_shortMonths), shortMonthLookup = formatLookup(locale_shortMonths);
            var formats = {
                a: formatShortWeekday,
                A: formatWeekday,
                b: formatShortMonth,
                B: formatMonth,
                c: null,
                d: formatDayOfMonth,
                e: formatDayOfMonth,
                f: formatMicroseconds,
                g: formatYearISO,
                G: formatFullYearISO,
                H: formatHour24,
                I: formatHour12,
                j: formatDayOfYear,
                L: formatMilliseconds,
                m: formatMonthNumber,
                M: formatMinutes,
                p: formatPeriod,
                q: formatQuarter,
                Q: formatUnixTimestamp,
                s: formatUnixTimestampSeconds,
                S: formatSeconds,
                u: formatWeekdayNumberMonday,
                U: formatWeekNumberSunday,
                V: formatWeekNumberISO,
                w: formatWeekdayNumberSunday,
                W: formatWeekNumberMonday,
                x: null,
                X: null,
                y: locale_formatYear,
                Y: formatFullYear,
                Z: formatZone,
                "%": formatLiteralPercent
            };
            var utcFormats = {
                a: formatUTCShortWeekday,
                A: formatUTCWeekday,
                b: formatUTCShortMonth,
                B: formatUTCMonth,
                c: null,
                d: formatUTCDayOfMonth,
                e: formatUTCDayOfMonth,
                f: formatUTCMicroseconds,
                g: formatUTCYearISO,
                G: formatUTCFullYearISO,
                H: formatUTCHour24,
                I: formatUTCHour12,
                j: formatUTCDayOfYear,
                L: formatUTCMilliseconds,
                m: formatUTCMonthNumber,
                M: formatUTCMinutes,
                p: formatUTCPeriod,
                q: formatUTCQuarter,
                Q: formatUnixTimestamp,
                s: formatUnixTimestampSeconds,
                S: formatUTCSeconds,
                u: formatUTCWeekdayNumberMonday,
                U: formatUTCWeekNumberSunday,
                V: formatUTCWeekNumberISO,
                w: formatUTCWeekdayNumberSunday,
                W: formatUTCWeekNumberMonday,
                x: null,
                X: null,
                y: formatUTCYear,
                Y: formatUTCFullYear,
                Z: formatUTCZone,
                "%": formatLiteralPercent
            };
            var parses = {
                a: parseShortWeekday,
                A: parseWeekday,
                b: parseShortMonth,
                B: parseMonth,
                c: parseLocaleDateTime,
                d: parseDayOfMonth,
                e: parseDayOfMonth,
                f: parseMicroseconds,
                g: parseYear,
                G: parseFullYear,
                H: parseHour24,
                I: parseHour24,
                j: parseDayOfYear,
                L: parseMilliseconds,
                m: parseMonthNumber,
                M: parseMinutes,
                p: parsePeriod,
                q: parseQuarter,
                Q: parseUnixTimestamp,
                s: parseUnixTimestampSeconds,
                S: parseSeconds,
                u: parseWeekdayNumberMonday,
                U: parseWeekNumberSunday,
                V: parseWeekNumberISO,
                w: parseWeekdayNumberSunday,
                W: parseWeekNumberMonday,
                x: parseLocaleDate,
                X: parseLocaleTime,
                y: parseYear,
                Y: parseFullYear,
                Z: parseZone,
                "%": parseLiteralPercent
            };
            formats.x = newFormat(locale_date, formats);
            formats.X = newFormat(locale_time, formats);
            formats.c = newFormat(locale_dateTime, formats);
            utcFormats.x = newFormat(locale_date, utcFormats);
            utcFormats.X = newFormat(locale_time, utcFormats);
            utcFormats.c = newFormat(locale_dateTime, utcFormats);
            function newFormat(specifier, formats) {
                return function(date) {
                    var string = [], i = -1, j = 0, n = specifier.length, c, pad, format;
                    if (!(date instanceof Date)) date = new Date(+date);
                    while(++i < n)if (37 === specifier.charCodeAt(i)) {
                        string.push(specifier.slice(j, i));
                        if (null != (pad = pads[c = specifier.charAt(++i)])) c = specifier.charAt(++i);
                        else pad = "e" === c ? " " : "0";
                        if (format = formats[c]) c = format(date, pad);
                        string.push(c);
                        j = i + 1;
                    }
                    string.push(specifier.slice(j, i));
                    return string.join("");
                };
            }
            function newParse(specifier, Z) {
                return function(string) {
                    var d = newDate(1900, void 0, 1), i = parseSpecifier(d, specifier, string += "", 0), week, day;
                    if (i != string.length) return null;
                    if ("Q" in d) return new Date(d.Q);
                    if ("s" in d) return new Date(1000 * d.s + ("L" in d ? d.L : 0));
                    if (Z && !("Z" in d)) d.Z = 0;
                    if ("p" in d) d.H = d.H % 12 + 12 * d.p;
                    if (void 0 === d.m) d.m = "q" in d ? d.q : 0;
                    if ("V" in d) {
                        if (d.V < 1 || d.V > 53) return null;
                        if (!("w" in d)) d.w = 1;
                        if ("Z" in d) {
                            week = utcDate(newDate(d.y, 0, 1)), day = week.getUTCDay();
                            week = day > 4 || 0 === day ? utcMonday.ceil(week) : utcMonday(week);
                            week = utcDay.offset(week, (d.V - 1) * 7);
                            d.y = week.getUTCFullYear();
                            d.m = week.getUTCMonth();
                            d.d = week.getUTCDate() + (d.w + 6) % 7;
                        } else {
                            week = localDate(newDate(d.y, 0, 1)), day = week.getDay();
                            week = day > 4 || 0 === day ? timeMonday.ceil(week) : timeMonday(week);
                            week = timeDay.offset(week, (d.V - 1) * 7);
                            d.y = week.getFullYear();
                            d.m = week.getMonth();
                            d.d = week.getDate() + (d.w + 6) % 7;
                        }
                    } else if ("W" in d || "U" in d) {
                        if (!("w" in d)) d.w = "u" in d ? d.u % 7 : "W" in d ? 1 : 0;
                        day = "Z" in d ? utcDate(newDate(d.y, 0, 1)).getUTCDay() : localDate(newDate(d.y, 0, 1)).getDay();
                        d.m = 0;
                        d.d = "W" in d ? (d.w + 6) % 7 + 7 * d.W - (day + 5) % 7 : d.w + 7 * d.U - (day + 6) % 7;
                    }
                    if ("Z" in d) {
                        d.H += d.Z / 100 | 0;
                        d.M += d.Z % 100;
                        return utcDate(d);
                    }
                    return localDate(d);
                };
            }
            function parseSpecifier(d, specifier, string, j) {
                var i = 0, n = specifier.length, m = string.length, c, parse;
                while(i < n){
                    if (j >= m) return -1;
                    c = specifier.charCodeAt(i++);
                    if (37 === c) {
                        c = specifier.charAt(i++);
                        parse = parses[c in pads ? specifier.charAt(i++) : c];
                        if (!parse || (j = parse(d, string, j)) < 0) return -1;
                    } else if (c != string.charCodeAt(j++)) return -1;
                }
                return j;
            }
            function parsePeriod(d, string, i) {
                var n = periodRe.exec(string.slice(i));
                return n ? (d.p = periodLookup.get(n[0].toLowerCase()), i + n[0].length) : -1;
            }
            function parseShortWeekday(d, string, i) {
                var n = shortWeekdayRe.exec(string.slice(i));
                return n ? (d.w = shortWeekdayLookup.get(n[0].toLowerCase()), i + n[0].length) : -1;
            }
            function parseWeekday(d, string, i) {
                var n = weekdayRe.exec(string.slice(i));
                return n ? (d.w = weekdayLookup.get(n[0].toLowerCase()), i + n[0].length) : -1;
            }
            function parseShortMonth(d, string, i) {
                var n = shortMonthRe.exec(string.slice(i));
                return n ? (d.m = shortMonthLookup.get(n[0].toLowerCase()), i + n[0].length) : -1;
            }
            function parseMonth(d, string, i) {
                var n = monthRe.exec(string.slice(i));
                return n ? (d.m = monthLookup.get(n[0].toLowerCase()), i + n[0].length) : -1;
            }
            function parseLocaleDateTime(d, string, i) {
                return parseSpecifier(d, locale_dateTime, string, i);
            }
            function parseLocaleDate(d, string, i) {
                return parseSpecifier(d, locale_date, string, i);
            }
            function parseLocaleTime(d, string, i) {
                return parseSpecifier(d, locale_time, string, i);
            }
            function formatShortWeekday(d) {
                return locale_shortWeekdays[d.getDay()];
            }
            function formatWeekday(d) {
                return locale_weekdays[d.getDay()];
            }
            function formatShortMonth(d) {
                return locale_shortMonths[d.getMonth()];
            }
            function formatMonth(d) {
                return locale_months[d.getMonth()];
            }
            function formatPeriod(d) {
                return locale_periods[+(d.getHours() >= 12)];
            }
            function formatQuarter(d) {
                return 1 + ~~(d.getMonth() / 3);
            }
            function formatUTCShortWeekday(d) {
                return locale_shortWeekdays[d.getUTCDay()];
            }
            function formatUTCWeekday(d) {
                return locale_weekdays[d.getUTCDay()];
            }
            function formatUTCShortMonth(d) {
                return locale_shortMonths[d.getUTCMonth()];
            }
            function formatUTCMonth(d) {
                return locale_months[d.getUTCMonth()];
            }
            function formatUTCPeriod(d) {
                return locale_periods[+(d.getUTCHours() >= 12)];
            }
            function formatUTCQuarter(d) {
                return 1 + ~~(d.getUTCMonth() / 3);
            }
            return {
                format: function(specifier) {
                    var f = newFormat(specifier += "", formats);
                    f.toString = function() {
                        return specifier;
                    };
                    return f;
                },
                parse: function(specifier) {
                    var p = newParse(specifier += "", false);
                    p.toString = function() {
                        return specifier;
                    };
                    return p;
                },
                utcFormat: function(specifier) {
                    var f = newFormat(specifier += "", utcFormats);
                    f.toString = function() {
                        return specifier;
                    };
                    return f;
                },
                utcParse: function(specifier) {
                    var p = newParse(specifier += "", true);
                    p.toString = function() {
                        return specifier;
                    };
                    return p;
                }
            };
        }
        var pads = {
            "-": "",
            _: " ",
            0: "0"
        }, numberRe = /^\s*\d+/, percentRe = /^%/, requoteRe = /[\\^$*+?|[\]().{}]/g;
        function locale_pad(value, fill, width) {
            var sign = value < 0 ? "-" : "", string = (sign ? -value : value) + "", length = string.length;
            return sign + (length < width ? new Array(width - length + 1).join(fill) + string : string);
        }
        function requote(s) {
            return s.replace(requoteRe, "\\$&");
        }
        function formatRe(names) {
            return new RegExp("^(?:" + names.map(requote).join("|") + ")", "i");
        }
        function formatLookup(names) {
            return new Map(names.map((name, i)=>[
                    name.toLowerCase(),
                    i
                ]));
        }
        function parseWeekdayNumberSunday(d, string, i) {
            var n = numberRe.exec(string.slice(i, i + 1));
            return n ? (d.w = +n[0], i + n[0].length) : -1;
        }
        function parseWeekdayNumberMonday(d, string, i) {
            var n = numberRe.exec(string.slice(i, i + 1));
            return n ? (d.u = +n[0], i + n[0].length) : -1;
        }
        function parseWeekNumberSunday(d, string, i) {
            var n = numberRe.exec(string.slice(i, i + 2));
            return n ? (d.U = +n[0], i + n[0].length) : -1;
        }
        function parseWeekNumberISO(d, string, i) {
            var n = numberRe.exec(string.slice(i, i + 2));
            return n ? (d.V = +n[0], i + n[0].length) : -1;
        }
        function parseWeekNumberMonday(d, string, i) {
            var n = numberRe.exec(string.slice(i, i + 2));
            return n ? (d.W = +n[0], i + n[0].length) : -1;
        }
        function parseFullYear(d, string, i) {
            var n = numberRe.exec(string.slice(i, i + 4));
            return n ? (d.y = +n[0], i + n[0].length) : -1;
        }
        function parseYear(d, string, i) {
            var n = numberRe.exec(string.slice(i, i + 2));
            return n ? (d.y = +n[0] + (+n[0] > 68 ? 1900 : 2000), i + n[0].length) : -1;
        }
        function parseZone(d, string, i) {
            var n = /^(Z)|([+-]\d\d)(?::?(\d\d))?/.exec(string.slice(i, i + 6));
            return n ? (d.Z = n[1] ? 0 : -(n[2] + (n[3] || "00")), i + n[0].length) : -1;
        }
        function parseQuarter(d, string, i) {
            var n = numberRe.exec(string.slice(i, i + 1));
            return n ? (d.q = 3 * n[0] - 3, i + n[0].length) : -1;
        }
        function parseMonthNumber(d, string, i) {
            var n = numberRe.exec(string.slice(i, i + 2));
            return n ? (d.m = n[0] - 1, i + n[0].length) : -1;
        }
        function parseDayOfMonth(d, string, i) {
            var n = numberRe.exec(string.slice(i, i + 2));
            return n ? (d.d = +n[0], i + n[0].length) : -1;
        }
        function parseDayOfYear(d, string, i) {
            var n = numberRe.exec(string.slice(i, i + 3));
            return n ? (d.m = 0, d.d = +n[0], i + n[0].length) : -1;
        }
        function parseHour24(d, string, i) {
            var n = numberRe.exec(string.slice(i, i + 2));
            return n ? (d.H = +n[0], i + n[0].length) : -1;
        }
        function parseMinutes(d, string, i) {
            var n = numberRe.exec(string.slice(i, i + 2));
            return n ? (d.M = +n[0], i + n[0].length) : -1;
        }
        function parseSeconds(d, string, i) {
            var n = numberRe.exec(string.slice(i, i + 2));
            return n ? (d.S = +n[0], i + n[0].length) : -1;
        }
        function parseMilliseconds(d, string, i) {
            var n = numberRe.exec(string.slice(i, i + 3));
            return n ? (d.L = +n[0], i + n[0].length) : -1;
        }
        function parseMicroseconds(d, string, i) {
            var n = numberRe.exec(string.slice(i, i + 6));
            return n ? (d.L = Math.floor(n[0] / 1000), i + n[0].length) : -1;
        }
        function parseLiteralPercent(d, string, i) {
            var n = percentRe.exec(string.slice(i, i + 1));
            return n ? i + n[0].length : -1;
        }
        function parseUnixTimestamp(d, string, i) {
            var n = numberRe.exec(string.slice(i));
            return n ? (d.Q = +n[0], i + n[0].length) : -1;
        }
        function parseUnixTimestampSeconds(d, string, i) {
            var n = numberRe.exec(string.slice(i));
            return n ? (d.s = +n[0], i + n[0].length) : -1;
        }
        function formatDayOfMonth(d, p) {
            return locale_pad(d.getDate(), p, 2);
        }
        function formatHour24(d, p) {
            return locale_pad(d.getHours(), p, 2);
        }
        function formatHour12(d, p) {
            return locale_pad(d.getHours() % 12 || 12, p, 2);
        }
        function formatDayOfYear(d, p) {
            return locale_pad(1 + timeDay.count(timeYear(d), d), p, 3);
        }
        function formatMilliseconds(d, p) {
            return locale_pad(d.getMilliseconds(), p, 3);
        }
        function formatMicroseconds(d, p) {
            return formatMilliseconds(d, p) + "000";
        }
        function formatMonthNumber(d, p) {
            return locale_pad(d.getMonth() + 1, p, 2);
        }
        function formatMinutes(d, p) {
            return locale_pad(d.getMinutes(), p, 2);
        }
        function formatSeconds(d, p) {
            return locale_pad(d.getSeconds(), p, 2);
        }
        function formatWeekdayNumberMonday(d) {
            var day = d.getDay();
            return 0 === day ? 7 : day;
        }
        function formatWeekNumberSunday(d, p) {
            return locale_pad(timeSunday.count(timeYear(d) - 1, d), p, 2);
        }
        function dISO(d) {
            var day = d.getDay();
            return day >= 4 || 0 === day ? timeThursday(d) : timeThursday.ceil(d);
        }
        function formatWeekNumberISO(d, p) {
            d = dISO(d);
            return locale_pad(timeThursday.count(timeYear(d), d) + (4 === timeYear(d).getDay()), p, 2);
        }
        function formatWeekdayNumberSunday(d) {
            return d.getDay();
        }
        function formatWeekNumberMonday(d, p) {
            return locale_pad(timeMonday.count(timeYear(d) - 1, d), p, 2);
        }
        function locale_formatYear(d, p) {
            return locale_pad(d.getFullYear() % 100, p, 2);
        }
        function formatYearISO(d, p) {
            d = dISO(d);
            return locale_pad(d.getFullYear() % 100, p, 2);
        }
        function formatFullYear(d, p) {
            return locale_pad(d.getFullYear() % 10000, p, 4);
        }
        function formatFullYearISO(d, p) {
            var day = d.getDay();
            d = day >= 4 || 0 === day ? timeThursday(d) : timeThursday.ceil(d);
            return locale_pad(d.getFullYear() % 10000, p, 4);
        }
        function formatZone(d) {
            var z = d.getTimezoneOffset();
            return (z > 0 ? "-" : (z *= -1, "+")) + locale_pad(z / 60 | 0, "0", 2) + locale_pad(z % 60, "0", 2);
        }
        function formatUTCDayOfMonth(d, p) {
            return locale_pad(d.getUTCDate(), p, 2);
        }
        function formatUTCHour24(d, p) {
            return locale_pad(d.getUTCHours(), p, 2);
        }
        function formatUTCHour12(d, p) {
            return locale_pad(d.getUTCHours() % 12 || 12, p, 2);
        }
        function formatUTCDayOfYear(d, p) {
            return locale_pad(1 + utcDay.count(utcYear(d), d), p, 3);
        }
        function formatUTCMilliseconds(d, p) {
            return locale_pad(d.getUTCMilliseconds(), p, 3);
        }
        function formatUTCMicroseconds(d, p) {
            return formatUTCMilliseconds(d, p) + "000";
        }
        function formatUTCMonthNumber(d, p) {
            return locale_pad(d.getUTCMonth() + 1, p, 2);
        }
        function formatUTCMinutes(d, p) {
            return locale_pad(d.getUTCMinutes(), p, 2);
        }
        function formatUTCSeconds(d, p) {
            return locale_pad(d.getUTCSeconds(), p, 2);
        }
        function formatUTCWeekdayNumberMonday(d) {
            var dow = d.getUTCDay();
            return 0 === dow ? 7 : dow;
        }
        function formatUTCWeekNumberSunday(d, p) {
            return locale_pad(utcSunday.count(utcYear(d) - 1, d), p, 2);
        }
        function UTCdISO(d) {
            var day = d.getUTCDay();
            return day >= 4 || 0 === day ? utcThursday(d) : utcThursday.ceil(d);
        }
        function formatUTCWeekNumberISO(d, p) {
            d = UTCdISO(d);
            return locale_pad(utcThursday.count(utcYear(d), d) + (4 === utcYear(d).getUTCDay()), p, 2);
        }
        function formatUTCWeekdayNumberSunday(d) {
            return d.getUTCDay();
        }
        function formatUTCWeekNumberMonday(d, p) {
            return locale_pad(utcMonday.count(utcYear(d) - 1, d), p, 2);
        }
        function formatUTCYear(d, p) {
            return locale_pad(d.getUTCFullYear() % 100, p, 2);
        }
        function formatUTCYearISO(d, p) {
            d = UTCdISO(d);
            return locale_pad(d.getUTCFullYear() % 100, p, 2);
        }
        function formatUTCFullYear(d, p) {
            return locale_pad(d.getUTCFullYear() % 10000, p, 4);
        }
        function formatUTCFullYearISO(d, p) {
            var day = d.getUTCDay();
            d = day >= 4 || 0 === day ? utcThursday(d) : utcThursday.ceil(d);
            return locale_pad(d.getUTCFullYear() % 10000, p, 4);
        }
        function formatUTCZone() {
            return "+0000";
        }
        function formatLiteralPercent() {
            return "%";
        }
        function formatUnixTimestamp(d) {
            return +d;
        }
        function formatUnixTimestampSeconds(d) {
            return Math.floor(+d / 1000);
        }
        var src_defaultLocale_locale;
        var timeFormat;
        defaultLocale_defaultLocale({
            dateTime: "%x, %X",
            date: "%-m/%-d/%Y",
            time: "%-I:%M:%S %p",
            periods: [
                "AM",
                "PM"
            ],
            days: [
                "Sunday",
                "Monday",
                "Tuesday",
                "Wednesday",
                "Thursday",
                "Friday",
                "Saturday"
            ],
            shortDays: [
                "Sun",
                "Mon",
                "Tue",
                "Wed",
                "Thu",
                "Fri",
                "Sat"
            ],
            months: [
                "January",
                "February",
                "March",
                "April",
                "May",
                "June",
                "July",
                "August",
                "September",
                "October",
                "November",
                "December"
            ],
            shortMonths: [
                "Jan",
                "Feb",
                "Mar",
                "Apr",
                "May",
                "Jun",
                "Jul",
                "Aug",
                "Sep",
                "Oct",
                "Nov",
                "Dec"
            ]
        });
        function defaultLocale_defaultLocale(definition) {
            src_defaultLocale_locale = formatLocale(definition);
            timeFormat = src_defaultLocale_locale.format;
            src_defaultLocale_locale.parse;
            src_defaultLocale_locale.utcFormat;
            src_defaultLocale_locale.utcParse;
            return src_defaultLocale_locale;
        }
        function nice(domain, interval) {
            domain = domain.slice();
            var i0 = 0, i1 = domain.length - 1, x0 = domain[i0], x1 = domain[i1], t;
            if (x1 < x0) {
                t = i0, i0 = i1, i1 = t;
                t = x0, x0 = x1, x1 = t;
            }
            domain[i0] = interval.floor(x0);
            domain[i1] = interval.ceil(x1);
            return domain;
        }
        function time_date(t) {
            return new Date(t);
        }
        function time_number(t) {
            return t instanceof Date ? +t : +new Date(+t);
        }
        function calendar(ticks, tickInterval, year, month, week, day, hour, minute, second, format) {
            var scale = continuous(), invert = scale.invert, domain = scale.domain;
            var formatMillisecond = format(".%L"), formatSecond = format(":%S"), formatMinute = format("%I:%M"), formatHour = format("%I %p"), formatDay = format("%a %d"), formatWeek = format("%b %d"), formatMonth = format("%B"), formatYear = format("%Y");
            function tickFormat(date) {
                return (second(date) < date ? formatMillisecond : minute(date) < date ? formatSecond : hour(date) < date ? formatMinute : day(date) < date ? formatHour : month(date) < date ? week(date) < date ? formatDay : formatWeek : year(date) < date ? formatMonth : formatYear)(date);
            }
            scale.invert = function(y) {
                return new Date(invert(y));
            };
            scale.domain = function(_) {
                return arguments.length ? domain(Array.from(_, time_number)) : domain().map(time_date);
            };
            scale.ticks = function(interval) {
                var d = domain();
                return ticks(d[0], d[d.length - 1], null == interval ? 10 : interval);
            };
            scale.tickFormat = function(count, specifier) {
                return null == specifier ? tickFormat : format(specifier);
            };
            scale.nice = function(interval) {
                var d = domain();
                if (!interval || "function" != typeof interval.range) interval = tickInterval(d[0], d[d.length - 1], null == interval ? 10 : interval);
                return interval ? domain(nice(d, interval)) : scale;
            };
            scale.copy = function() {
                return continuous_copy(scale, calendar(ticks, tickInterval, year, month, week, day, hour, minute, second, format));
            };
            return scale;
        }
        function time_time() {
            return initRange.apply(calendar(timeTicks, timeTickInterval, timeYear, timeMonth, timeSunday, timeDay, timeHour, timeMinute, second_second, timeFormat).domain([
                new Date(2000, 0, 1),
                new Date(2000, 0, 2)
            ]), arguments);
        }
        function src_colors(specifier) {
            var n = specifier.length / 6 | 0, colors = new Array(n), i = 0;
            while(i < n)colors[i] = "#" + specifier.slice(6 * i, 6 * ++i);
            return colors;
        }
        const Tableau10 = src_colors("4e79a7f28e2ce1575976b7b259a14fedc949af7aa1ff9da79c755fbab0ab");
        function src_select(selector) {
            return "string" == typeof selector ? new Selection([
                [
                    document.querySelector(selector)
                ]
            ], [
                document.documentElement
            ]) : new Selection([
                [
                    selector
                ]
            ], root);
        }
        function d3_shape_src_constant(x) {
            return function() {
                return x;
            };
        }
        const math_abs = Math.abs;
        const atan2 = Math.atan2;
        const cos = Math.cos;
        const math_max = Math.max;
        const math_min = Math.min;
        const sin = Math.sin;
        const sqrt = Math.sqrt;
        const math_epsilon = 1e-12;
        const pi = Math.PI;
        const halfPi = pi / 2;
        const tau = 2 * pi;
        function acos(x) {
            return x > 1 ? 0 : x < -1 ? pi : Math.acos(x);
        }
        function asin(x) {
            return x >= 1 ? halfPi : x <= -1 ? -halfPi : Math.asin(x);
        }
        const path_pi = Math.PI, path_tau = 2 * path_pi, path_epsilon = 1e-6, tauEpsilon = path_tau - path_epsilon;
        function path_append(strings) {
            this._ += strings[0];
            for(let i = 1, n = strings.length; i < n; ++i)this._ += arguments[i] + strings[i];
        }
        function appendRound(digits) {
            let d = Math.floor(digits);
            if (!(d >= 0)) throw new Error(`invalid digits: ${digits}`);
            if (d > 15) return path_append;
            const k = 10 ** d;
            return function(strings) {
                this._ += strings[0];
                for(let i = 1, n = strings.length; i < n; ++i)this._ += Math.round(arguments[i] * k) / k + strings[i];
            };
        }
        class Path {
            constructor(digits){
                this._x0 = this._y0 = this._x1 = this._y1 = null;
                this._ = "";
                this._append = null == digits ? path_append : appendRound(digits);
            }
            moveTo(x, y) {
                this._append`M${this._x0 = this._x1 = +x},${this._y0 = this._y1 = +y}`;
            }
            closePath() {
                if (null !== this._x1) {
                    this._x1 = this._x0, this._y1 = this._y0;
                    this._append`Z`;
                }
            }
            lineTo(x, y) {
                this._append`L${this._x1 = +x},${this._y1 = +y}`;
            }
            quadraticCurveTo(x1, y1, x, y) {
                this._append`Q${+x1},${+y1},${this._x1 = +x},${this._y1 = +y}`;
            }
            bezierCurveTo(x1, y1, x2, y2, x, y) {
                this._append`C${+x1},${+y1},${+x2},${+y2},${this._x1 = +x},${this._y1 = +y}`;
            }
            arcTo(x1, y1, x2, y2, r) {
                x1 = +x1, y1 = +y1, x2 = +x2, y2 = +y2, r = +r;
                if (r < 0) throw new Error(`negative radius: ${r}`);
                let x0 = this._x1, y0 = this._y1, x21 = x2 - x1, y21 = y2 - y1, x01 = x0 - x1, y01 = y0 - y1, l01_2 = x01 * x01 + y01 * y01;
                if (null === this._x1) this._append`M${this._x1 = x1},${this._y1 = y1}`;
                else if (l01_2 > path_epsilon) {
                    if (Math.abs(y01 * x21 - y21 * x01) > path_epsilon && r) {
                        let x20 = x2 - x0, y20 = y2 - y0, l21_2 = x21 * x21 + y21 * y21, l20_2 = x20 * x20 + y20 * y20, l21 = Math.sqrt(l21_2), l01 = Math.sqrt(l01_2), l = r * Math.tan((path_pi - Math.acos((l21_2 + l01_2 - l20_2) / (2 * l21 * l01))) / 2), t01 = l / l01, t21 = l / l21;
                        if (Math.abs(t01 - 1) > path_epsilon) this._append`L${x1 + t01 * x01},${y1 + t01 * y01}`;
                        this._append`A${r},${r},0,0,${+(y01 * x20 > x01 * y20)},${this._x1 = x1 + t21 * x21},${this._y1 = y1 + t21 * y21}`;
                    } else this._append`L${this._x1 = x1},${this._y1 = y1}`;
                }
            }
            arc(x, y, r, a0, a1, ccw) {
                x = +x, y = +y, r = +r, ccw = !!ccw;
                if (r < 0) throw new Error(`negative radius: ${r}`);
                let dx = r * Math.cos(a0), dy = r * Math.sin(a0), x0 = x + dx, y0 = y + dy, cw = 1 ^ ccw, da = ccw ? a0 - a1 : a1 - a0;
                if (null === this._x1) this._append`M${x0},${y0}`;
                else if (Math.abs(this._x1 - x0) > path_epsilon || Math.abs(this._y1 - y0) > path_epsilon) this._append`L${x0},${y0}`;
                if (!r) return;
                if (da < 0) da = da % path_tau + path_tau;
                if (da > tauEpsilon) this._append`A${r},${r},0,1,${cw},${x - dx},${y - dy}A${r},${r},0,1,${cw},${this._x1 = x0},${this._y1 = y0}`;
                else if (da > path_epsilon) this._append`A${r},${r},0,${+(da >= path_pi)},${cw},${this._x1 = x + r * Math.cos(a1)},${this._y1 = y + r * Math.sin(a1)}`;
            }
            rect(x, y, w, h) {
                this._append`M${this._x0 = this._x1 = +x},${this._y0 = this._y1 = +y}h${w = +w}v${+h}h${-w}Z`;
            }
            toString() {
                return this._;
            }
        }
        function path_path() {
            return new Path;
        }
        path_path.prototype = Path.prototype;
        function withPath(shape) {
            let digits = 3;
            shape.digits = function(_) {
                if (!arguments.length) return digits;
                if (null == _) digits = null;
                else {
                    const d = Math.floor(_);
                    if (!(d >= 0)) throw new RangeError(`invalid digits: ${_}`);
                    digits = d;
                }
                return shape;
            };
            return ()=>new Path(digits);
        }
        function arcInnerRadius(d) {
            return d.innerRadius;
        }
        function arcOuterRadius(d) {
            return d.outerRadius;
        }
        function arcStartAngle(d) {
            return d.startAngle;
        }
        function arcEndAngle(d) {
            return d.endAngle;
        }
        function arcPadAngle(d) {
            return d && d.padAngle;
        }
        function intersect(x0, y0, x1, y1, x2, y2, x3, y3) {
            var x10 = x1 - x0, y10 = y1 - y0, x32 = x3 - x2, y32 = y3 - y2, t = y32 * x10 - x32 * y10;
            if (t * t < math_epsilon) return;
            t = (x32 * (y0 - y2) - y32 * (x0 - x2)) / t;
            return [
                x0 + t * x10,
                y0 + t * y10
            ];
        }
        function cornerTangents(x0, y0, x1, y1, r1, rc, cw) {
            var x01 = x0 - x1, y01 = y0 - y1, lo = (cw ? rc : -rc) / sqrt(x01 * x01 + y01 * y01), ox = lo * y01, oy = -lo * x01, x11 = x0 + ox, y11 = y0 + oy, x10 = x1 + ox, y10 = y1 + oy, x00 = (x11 + x10) / 2, y00 = (y11 + y10) / 2, dx = x10 - x11, dy = y10 - y11, d2 = dx * dx + dy * dy, r = r1 - rc, D = x11 * y10 - x10 * y11, d = (dy < 0 ? -1 : 1) * sqrt(math_max(0, r * r * d2 - D * D)), cx0 = (D * dy - dx * d) / d2, cy0 = (-D * dx - dy * d) / d2, cx1 = (D * dy + dx * d) / d2, cy1 = (-D * dx + dy * d) / d2, dx0 = cx0 - x00, dy0 = cy0 - y00, dx1 = cx1 - x00, dy1 = cy1 - y00;
            if (dx0 * dx0 + dy0 * dy0 > dx1 * dx1 + dy1 * dy1) cx0 = cx1, cy0 = cy1;
            return {
                cx: cx0,
                cy: cy0,
                x01: -ox,
                y01: -oy,
                x11: cx0 * (r1 / r - 1),
                y11: cy0 * (r1 / r - 1)
            };
        }
        function src_arc() {
            var innerRadius = arcInnerRadius, outerRadius = arcOuterRadius, cornerRadius = d3_shape_src_constant(0), padRadius = null, startAngle = arcStartAngle, endAngle = arcEndAngle, padAngle = arcPadAngle, context = null, path = withPath(arc);
            function arc() {
                var buffer, r, r0 = +innerRadius.apply(this, arguments), r1 = +outerRadius.apply(this, arguments), a0 = startAngle.apply(this, arguments) - halfPi, a1 = endAngle.apply(this, arguments) - halfPi, da = math_abs(a1 - a0), cw = a1 > a0;
                if (!context) context = buffer = path();
                if (r1 < r0) r = r1, r1 = r0, r0 = r;
                if (r1 > math_epsilon) {
                    if (da > tau - math_epsilon) {
                        context.moveTo(r1 * cos(a0), r1 * sin(a0));
                        context.arc(0, 0, r1, a0, a1, !cw);
                        if (r0 > math_epsilon) {
                            context.moveTo(r0 * cos(a1), r0 * sin(a1));
                            context.arc(0, 0, r0, a1, a0, cw);
                        }
                    } else {
                        var a01 = a0, a11 = a1, a00 = a0, a10 = a1, da0 = da, da1 = da, ap = padAngle.apply(this, arguments) / 2, rp = ap > math_epsilon && (padRadius ? +padRadius.apply(this, arguments) : sqrt(r0 * r0 + r1 * r1)), rc = math_min(math_abs(r1 - r0) / 2, +cornerRadius.apply(this, arguments)), rc0 = rc, rc1 = rc, t0, t1;
                        if (rp > math_epsilon) {
                            var p0 = asin(rp / r0 * sin(ap)), p1 = asin(rp / r1 * sin(ap));
                            if ((da0 -= 2 * p0) > math_epsilon) p0 *= cw ? 1 : -1, a00 += p0, a10 -= p0;
                            else da0 = 0, a00 = a10 = (a0 + a1) / 2;
                            if ((da1 -= 2 * p1) > math_epsilon) p1 *= cw ? 1 : -1, a01 += p1, a11 -= p1;
                            else da1 = 0, a01 = a11 = (a0 + a1) / 2;
                        }
                        var x01 = r1 * cos(a01), y01 = r1 * sin(a01), x10 = r0 * cos(a10), y10 = r0 * sin(a10);
                        if (rc > math_epsilon) {
                            var x11 = r1 * cos(a11), y11 = r1 * sin(a11), x00 = r0 * cos(a00), y00 = r0 * sin(a00), oc;
                            if (da < pi) {
                                if (oc = intersect(x01, y01, x00, y00, x11, y11, x10, y10)) {
                                    var ax = x01 - oc[0], ay = y01 - oc[1], bx = x11 - oc[0], by = y11 - oc[1], kc = 1 / sin(acos((ax * bx + ay * by) / (sqrt(ax * ax + ay * ay) * sqrt(bx * bx + by * by))) / 2), lc = sqrt(oc[0] * oc[0] + oc[1] * oc[1]);
                                    rc0 = math_min(rc, (r0 - lc) / (kc - 1));
                                    rc1 = math_min(rc, (r1 - lc) / (kc + 1));
                                } else rc0 = rc1 = 0;
                            }
                        }
                        if (da1 > math_epsilon) {
                            if (rc1 > math_epsilon) {
                                t0 = cornerTangents(x00, y00, x01, y01, r1, rc1, cw);
                                t1 = cornerTangents(x11, y11, x10, y10, r1, rc1, cw);
                                context.moveTo(t0.cx + t0.x01, t0.cy + t0.y01);
                                if (rc1 < rc) context.arc(t0.cx, t0.cy, rc1, atan2(t0.y01, t0.x01), atan2(t1.y01, t1.x01), !cw);
                                else {
                                    context.arc(t0.cx, t0.cy, rc1, atan2(t0.y01, t0.x01), atan2(t0.y11, t0.x11), !cw);
                                    context.arc(0, 0, r1, atan2(t0.cy + t0.y11, t0.cx + t0.x11), atan2(t1.cy + t1.y11, t1.cx + t1.x11), !cw);
                                    context.arc(t1.cx, t1.cy, rc1, atan2(t1.y11, t1.x11), atan2(t1.y01, t1.x01), !cw);
                                }
                            } else context.moveTo(x01, y01), context.arc(0, 0, r1, a01, a11, !cw);
                        } else context.moveTo(x01, y01);
                        if (r0 > math_epsilon && da0 > math_epsilon) {
                            if (rc0 > math_epsilon) {
                                t0 = cornerTangents(x10, y10, x11, y11, r0, -rc0, cw);
                                t1 = cornerTangents(x01, y01, x00, y00, r0, -rc0, cw);
                                context.lineTo(t0.cx + t0.x01, t0.cy + t0.y01);
                                if (rc0 < rc) context.arc(t0.cx, t0.cy, rc0, atan2(t0.y01, t0.x01), atan2(t1.y01, t1.x01), !cw);
                                else {
                                    context.arc(t0.cx, t0.cy, rc0, atan2(t0.y01, t0.x01), atan2(t0.y11, t0.x11), !cw);
                                    context.arc(0, 0, r0, atan2(t0.cy + t0.y11, t0.cx + t0.x11), atan2(t1.cy + t1.y11, t1.cx + t1.x11), cw);
                                    context.arc(t1.cx, t1.cy, rc0, atan2(t1.y11, t1.x11), atan2(t1.y01, t1.x01), !cw);
                                }
                            } else context.arc(0, 0, r0, a10, a00, cw);
                        } else context.lineTo(x10, y10);
                    }
                } else context.moveTo(0, 0);
                context.closePath();
                if (buffer) return context = null, buffer + "" || null;
            }
            arc.centroid = function() {
                var r = (+innerRadius.apply(this, arguments) + +outerRadius.apply(this, arguments)) / 2, a = (+startAngle.apply(this, arguments) + +endAngle.apply(this, arguments)) / 2 - pi / 2;
                return [
                    cos(a) * r,
                    sin(a) * r
                ];
            };
            arc.innerRadius = function(_) {
                return arguments.length ? (innerRadius = "function" == typeof _ ? _ : d3_shape_src_constant(+_), arc) : innerRadius;
            };
            arc.outerRadius = function(_) {
                return arguments.length ? (outerRadius = "function" == typeof _ ? _ : d3_shape_src_constant(+_), arc) : outerRadius;
            };
            arc.cornerRadius = function(_) {
                return arguments.length ? (cornerRadius = "function" == typeof _ ? _ : d3_shape_src_constant(+_), arc) : cornerRadius;
            };
            arc.padRadius = function(_) {
                return arguments.length ? (padRadius = null == _ ? null : "function" == typeof _ ? _ : d3_shape_src_constant(+_), arc) : padRadius;
            };
            arc.startAngle = function(_) {
                return arguments.length ? (startAngle = "function" == typeof _ ? _ : d3_shape_src_constant(+_), arc) : startAngle;
            };
            arc.endAngle = function(_) {
                return arguments.length ? (endAngle = "function" == typeof _ ? _ : d3_shape_src_constant(+_), arc) : endAngle;
            };
            arc.padAngle = function(_) {
                return arguments.length ? (padAngle = "function" == typeof _ ? _ : d3_shape_src_constant(+_), arc) : padAngle;
            };
            arc.context = function(_) {
                return arguments.length ? (context = null == _ ? null : _, arc) : context;
            };
            return arc;
        }
        Array.prototype.slice;
        function d3_shape_src_array(x) {
            return "object" == typeof x && "length" in x ? x : Array.from(x);
        }
        function Linear(context) {
            this._context = context;
        }
        Linear.prototype = {
            areaStart: function() {
                this._line = 0;
            },
            areaEnd: function() {
                this._line = NaN;
            },
            lineStart: function() {
                this._point = 0;
            },
            lineEnd: function() {
                if (this._line || 0 !== this._line && 1 === this._point) this._context.closePath();
                this._line = 1 - this._line;
            },
            point: function(x, y) {
                x = +x, y = +y;
                switch(this._point){
                    case 0:
                        this._point = 1;
                        this._line ? this._context.lineTo(x, y) : this._context.moveTo(x, y);
                        break;
                    case 1:
                        this._point = 2;
                    default:
                        this._context.lineTo(x, y);
                        break;
                }
            }
        };
        function curve_linear(context) {
            return new Linear(context);
        }
        function point_x(p) {
            return p[0];
        }
        function point_y(p) {
            return p[1];
        }
        function src_line(x, y) {
            var defined = d3_shape_src_constant(true), context = null, curve = curve_linear, output = null, path = withPath(line);
            x = "function" == typeof x ? x : void 0 === x ? point_x : d3_shape_src_constant(x);
            y = "function" == typeof y ? y : void 0 === y ? point_y : d3_shape_src_constant(y);
            function line(data) {
                var i, n = (data = d3_shape_src_array(data)).length, d, defined0 = false, buffer;
                if (null == context) output = curve(buffer = path());
                for(i = 0; i <= n; ++i){
                    if (!(i < n && defined(d = data[i], i, data)) === defined0) {
                        if (defined0 = !defined0) output.lineStart();
                        else output.lineEnd();
                    }
                    if (defined0) output.point(+x(d, i, data), +y(d, i, data));
                }
                if (buffer) return output = null, buffer + "" || null;
            }
            line.x = function(_) {
                return arguments.length ? (x = "function" == typeof _ ? _ : d3_shape_src_constant(+_), line) : x;
            };
            line.y = function(_) {
                return arguments.length ? (y = "function" == typeof _ ? _ : d3_shape_src_constant(+_), line) : y;
            };
            line.defined = function(_) {
                return arguments.length ? (defined = "function" == typeof _ ? _ : d3_shape_src_constant(!!_), line) : defined;
            };
            line.curve = function(_) {
                return arguments.length ? (curve = _, null != context && (output = curve(context)), line) : curve;
            };
            line.context = function(_) {
                return arguments.length ? (null == _ ? context = output = null : output = curve(context = _), line) : context;
            };
            return line;
        }
        function src_descending(a, b) {
            return b < a ? -1 : b > a ? 1 : b >= a ? 0 : NaN;
        }
        function d3_shape_src_identity(d) {
            return d;
        }
        function src_pie() {
            var value = d3_shape_src_identity, sortValues = src_descending, sort = null, startAngle = d3_shape_src_constant(0), endAngle = d3_shape_src_constant(tau), padAngle = d3_shape_src_constant(0);
            function pie(data) {
                var i, n = (data = d3_shape_src_array(data)).length, j, k, sum = 0, index = new Array(n), arcs = new Array(n), a0 = +startAngle.apply(this, arguments), da = Math.min(tau, Math.max(-tau, endAngle.apply(this, arguments) - a0)), a1, p = Math.min(Math.abs(da) / n, padAngle.apply(this, arguments)), pa = p * (da < 0 ? -1 : 1), v;
                for(i = 0; i < n; ++i)if ((v = arcs[index[i] = i] = +value(data[i], i, data)) > 0) sum += v;
                if (null != sortValues) index.sort(function(i, j) {
                    return sortValues(arcs[i], arcs[j]);
                });
                else if (null != sort) index.sort(function(i, j) {
                    return sort(data[i], data[j]);
                });
                for(i = 0, k = sum ? (da - n * pa) / sum : 0; i < n; ++i, a0 = a1)j = index[i], v = arcs[j], a1 = a0 + (v > 0 ? v * k : 0) + pa, arcs[j] = {
                    data: data[j],
                    index: i,
                    value: v,
                    startAngle: a0,
                    endAngle: a1,
                    padAngle: p
                };
                return arcs;
            }
            pie.value = function(_) {
                return arguments.length ? (value = "function" == typeof _ ? _ : d3_shape_src_constant(+_), pie) : value;
            };
            pie.sortValues = function(_) {
                return arguments.length ? (sortValues = _, sort = null, pie) : sortValues;
            };
            pie.sort = function(_) {
                return arguments.length ? (sort = _, sortValues = null, pie) : sort;
            };
            pie.startAngle = function(_) {
                return arguments.length ? (startAngle = "function" == typeof _ ? _ : d3_shape_src_constant(+_), pie) : startAngle;
            };
            pie.endAngle = function(_) {
                return arguments.length ? (endAngle = "function" == typeof _ ? _ : d3_shape_src_constant(+_), pie) : endAngle;
            };
            pie.padAngle = function(_) {
                return arguments.length ? (padAngle = "function" == typeof _ ? _ : d3_shape_src_constant(+_), pie) : padAngle;
            };
            return pie;
        }
        function src_noop() {}
        function basis_point(that, x, y) {
            that._context.bezierCurveTo((2 * that._x0 + that._x1) / 3, (2 * that._y0 + that._y1) / 3, (that._x0 + 2 * that._x1) / 3, (that._y0 + 2 * that._y1) / 3, (that._x0 + 4 * that._x1 + x) / 6, (that._y0 + 4 * that._y1 + y) / 6);
        }
        function Basis(context) {
            this._context = context;
        }
        Basis.prototype = {
            areaStart: function() {
                this._line = 0;
            },
            areaEnd: function() {
                this._line = NaN;
            },
            lineStart: function() {
                this._x0 = this._x1 = this._y0 = this._y1 = NaN;
                this._point = 0;
            },
            lineEnd: function() {
                switch(this._point){
                    case 3:
                        basis_point(this, this._x1, this._y1);
                    case 2:
                        this._context.lineTo(this._x1, this._y1);
                        break;
                }
                if (this._line || 0 !== this._line && 1 === this._point) this._context.closePath();
                this._line = 1 - this._line;
            },
            point: function(x, y) {
                x = +x, y = +y;
                switch(this._point){
                    case 0:
                        this._point = 1;
                        this._line ? this._context.lineTo(x, y) : this._context.moveTo(x, y);
                        break;
                    case 1:
                        this._point = 2;
                        break;
                    case 2:
                        this._point = 3;
                        this._context.lineTo((5 * this._x0 + this._x1) / 6, (5 * this._y0 + this._y1) / 6);
                    default:
                        basis_point(this, x, y);
                        break;
                }
                this._x0 = this._x1, this._x1 = x;
                this._y0 = this._y1, this._y1 = y;
            }
        };
        function curve_basis(context) {
            return new Basis(context);
        }
        function BasisClosed(context) {
            this._context = context;
        }
        BasisClosed.prototype = {
            areaStart: src_noop,
            areaEnd: src_noop,
            lineStart: function() {
                this._x0 = this._x1 = this._x2 = this._x3 = this._x4 = this._y0 = this._y1 = this._y2 = this._y3 = this._y4 = NaN;
                this._point = 0;
            },
            lineEnd: function() {
                switch(this._point){
                    case 1:
                        this._context.moveTo(this._x2, this._y2);
                        this._context.closePath();
                        break;
                    case 2:
                        this._context.moveTo((this._x2 + 2 * this._x3) / 3, (this._y2 + 2 * this._y3) / 3);
                        this._context.lineTo((this._x3 + 2 * this._x2) / 3, (this._y3 + 2 * this._y2) / 3);
                        this._context.closePath();
                        break;
                    case 3:
                        this.point(this._x2, this._y2);
                        this.point(this._x3, this._y3);
                        this.point(this._x4, this._y4);
                        break;
                }
            },
            point: function(x, y) {
                x = +x, y = +y;
                switch(this._point){
                    case 0:
                        this._point = 1;
                        this._x2 = x, this._y2 = y;
                        break;
                    case 1:
                        this._point = 2;
                        this._x3 = x, this._y3 = y;
                        break;
                    case 2:
                        this._point = 3;
                        this._x4 = x, this._y4 = y;
                        this._context.moveTo((this._x0 + 4 * this._x1 + x) / 6, (this._y0 + 4 * this._y1 + y) / 6);
                        break;
                    default:
                        basis_point(this, x, y);
                        break;
                }
                this._x0 = this._x1, this._x1 = x;
                this._y0 = this._y1, this._y1 = y;
            }
        };
        function curve_basisClosed(context) {
            return new BasisClosed(context);
        }
        function BasisOpen(context) {
            this._context = context;
        }
        BasisOpen.prototype = {
            areaStart: function() {
                this._line = 0;
            },
            areaEnd: function() {
                this._line = NaN;
            },
            lineStart: function() {
                this._x0 = this._x1 = this._y0 = this._y1 = NaN;
                this._point = 0;
            },
            lineEnd: function() {
                if (this._line || 0 !== this._line && 3 === this._point) this._context.closePath();
                this._line = 1 - this._line;
            },
            point: function(x, y) {
                x = +x, y = +y;
                switch(this._point){
                    case 0:
                        this._point = 1;
                        break;
                    case 1:
                        this._point = 2;
                        break;
                    case 2:
                        this._point = 3;
                        var x0 = (this._x0 + 4 * this._x1 + x) / 6, y0 = (this._y0 + 4 * this._y1 + y) / 6;
                        this._line ? this._context.lineTo(x0, y0) : this._context.moveTo(x0, y0);
                        break;
                    case 3:
                        this._point = 4;
                    default:
                        basis_point(this, x, y);
                        break;
                }
                this._x0 = this._x1, this._x1 = x;
                this._y0 = this._y1, this._y1 = y;
            }
        };
        function basisOpen(context) {
            return new BasisOpen(context);
        }
        class Bump {
            constructor(context, x){
                this._context = context;
                this._x = x;
            }
            areaStart() {
                this._line = 0;
            }
            areaEnd() {
                this._line = NaN;
            }
            lineStart() {
                this._point = 0;
            }
            lineEnd() {
                if (this._line || 0 !== this._line && 1 === this._point) this._context.closePath();
                this._line = 1 - this._line;
            }
            point(x, y) {
                x = +x, y = +y;
                switch(this._point){
                    case 0:
                        this._point = 1;
                        if (this._line) this._context.lineTo(x, y);
                        else this._context.moveTo(x, y);
                        break;
                    case 1:
                        this._point = 2;
                    default:
                        if (this._x) this._context.bezierCurveTo(this._x0 = (this._x0 + x) / 2, this._y0, this._x0, y, x, y);
                        else this._context.bezierCurveTo(this._x0, this._y0 = (this._y0 + y) / 2, x, this._y0, x, y);
                        break;
                }
                this._x0 = x, this._y0 = y;
            }
        }
        function bumpX(context) {
            return new Bump(context, true);
        }
        function bumpY(context) {
            return new Bump(context, false);
        }
        function Bundle(context, beta) {
            this._basis = new Basis(context);
            this._beta = beta;
        }
        Bundle.prototype = {
            lineStart: function() {
                this._x = [];
                this._y = [];
                this._basis.lineStart();
            },
            lineEnd: function() {
                var x = this._x, y = this._y, j = x.length - 1;
                if (j > 0) {
                    var x0 = x[0], y0 = y[0], dx = x[j] - x0, dy = y[j] - y0, i = -1, t;
                    while(++i <= j){
                        t = i / j;
                        this._basis.point(this._beta * x[i] + (1 - this._beta) * (x0 + t * dx), this._beta * y[i] + (1 - this._beta) * (y0 + t * dy));
                    }
                }
                this._x = this._y = null;
                this._basis.lineEnd();
            },
            point: function(x, y) {
                this._x.push(+x);
                this._y.push(+y);
            }
        };
        const curve_bundle = function custom(beta) {
            function bundle(context) {
                return 1 === beta ? new Basis(context) : new Bundle(context, beta);
            }
            bundle.beta = function(beta) {
                return custom(+beta);
            };
            return bundle;
        }(0.85);
        function cardinal_point(that, x, y) {
            that._context.bezierCurveTo(that._x1 + that._k * (that._x2 - that._x0), that._y1 + that._k * (that._y2 - that._y0), that._x2 + that._k * (that._x1 - x), that._y2 + that._k * (that._y1 - y), that._x2, that._y2);
        }
        function Cardinal(context, tension) {
            this._context = context;
            this._k = (1 - tension) / 6;
        }
        Cardinal.prototype = {
            areaStart: function() {
                this._line = 0;
            },
            areaEnd: function() {
                this._line = NaN;
            },
            lineStart: function() {
                this._x0 = this._x1 = this._x2 = this._y0 = this._y1 = this._y2 = NaN;
                this._point = 0;
            },
            lineEnd: function() {
                switch(this._point){
                    case 2:
                        this._context.lineTo(this._x2, this._y2);
                        break;
                    case 3:
                        cardinal_point(this, this._x1, this._y1);
                        break;
                }
                if (this._line || 0 !== this._line && 1 === this._point) this._context.closePath();
                this._line = 1 - this._line;
            },
            point: function(x, y) {
                x = +x, y = +y;
                switch(this._point){
                    case 0:
                        this._point = 1;
                        this._line ? this._context.lineTo(x, y) : this._context.moveTo(x, y);
                        break;
                    case 1:
                        this._point = 2;
                        this._x1 = x, this._y1 = y;
                        break;
                    case 2:
                        this._point = 3;
                    default:
                        cardinal_point(this, x, y);
                        break;
                }
                this._x0 = this._x1, this._x1 = this._x2, this._x2 = x;
                this._y0 = this._y1, this._y1 = this._y2, this._y2 = y;
            }
        };
        const curve_cardinal = function custom(tension) {
            function cardinal(context) {
                return new Cardinal(context, tension);
            }
            cardinal.tension = function(tension) {
                return custom(+tension);
            };
            return cardinal;
        }(0);
        function CardinalClosed(context, tension) {
            this._context = context;
            this._k = (1 - tension) / 6;
        }
        CardinalClosed.prototype = {
            areaStart: src_noop,
            areaEnd: src_noop,
            lineStart: function() {
                this._x0 = this._x1 = this._x2 = this._x3 = this._x4 = this._x5 = this._y0 = this._y1 = this._y2 = this._y3 = this._y4 = this._y5 = NaN;
                this._point = 0;
            },
            lineEnd: function() {
                switch(this._point){
                    case 1:
                        this._context.moveTo(this._x3, this._y3);
                        this._context.closePath();
                        break;
                    case 2:
                        this._context.lineTo(this._x3, this._y3);
                        this._context.closePath();
                        break;
                    case 3:
                        this.point(this._x3, this._y3);
                        this.point(this._x4, this._y4);
                        this.point(this._x5, this._y5);
                        break;
                }
            },
            point: function(x, y) {
                x = +x, y = +y;
                switch(this._point){
                    case 0:
                        this._point = 1;
                        this._x3 = x, this._y3 = y;
                        break;
                    case 1:
                        this._point = 2;
                        this._context.moveTo(this._x4 = x, this._y4 = y);
                        break;
                    case 2:
                        this._point = 3;
                        this._x5 = x, this._y5 = y;
                        break;
                    default:
                        cardinal_point(this, x, y);
                        break;
                }
                this._x0 = this._x1, this._x1 = this._x2, this._x2 = x;
                this._y0 = this._y1, this._y1 = this._y2, this._y2 = y;
            }
        };
        const cardinalClosed = function custom(tension) {
            function cardinal(context) {
                return new CardinalClosed(context, tension);
            }
            cardinal.tension = function(tension) {
                return custom(+tension);
            };
            return cardinal;
        }(0);
        function CardinalOpen(context, tension) {
            this._context = context;
            this._k = (1 - tension) / 6;
        }
        CardinalOpen.prototype = {
            areaStart: function() {
                this._line = 0;
            },
            areaEnd: function() {
                this._line = NaN;
            },
            lineStart: function() {
                this._x0 = this._x1 = this._x2 = this._y0 = this._y1 = this._y2 = NaN;
                this._point = 0;
            },
            lineEnd: function() {
                if (this._line || 0 !== this._line && 3 === this._point) this._context.closePath();
                this._line = 1 - this._line;
            },
            point: function(x, y) {
                x = +x, y = +y;
                switch(this._point){
                    case 0:
                        this._point = 1;
                        break;
                    case 1:
                        this._point = 2;
                        break;
                    case 2:
                        this._point = 3;
                        this._line ? this._context.lineTo(this._x2, this._y2) : this._context.moveTo(this._x2, this._y2);
                        break;
                    case 3:
                        this._point = 4;
                    default:
                        cardinal_point(this, x, y);
                        break;
                }
                this._x0 = this._x1, this._x1 = this._x2, this._x2 = x;
                this._y0 = this._y1, this._y1 = this._y2, this._y2 = y;
            }
        };
        const cardinalOpen = function custom(tension) {
            function cardinal(context) {
                return new CardinalOpen(context, tension);
            }
            cardinal.tension = function(tension) {
                return custom(+tension);
            };
            return cardinal;
        }(0);
        function catmullRom_point(that, x, y) {
            var x1 = that._x1, y1 = that._y1, x2 = that._x2, y2 = that._y2;
            if (that._l01_a > math_epsilon) {
                var a = 2 * that._l01_2a + 3 * that._l01_a * that._l12_a + that._l12_2a, n = 3 * that._l01_a * (that._l01_a + that._l12_a);
                x1 = (x1 * a - that._x0 * that._l12_2a + that._x2 * that._l01_2a) / n;
                y1 = (y1 * a - that._y0 * that._l12_2a + that._y2 * that._l01_2a) / n;
            }
            if (that._l23_a > math_epsilon) {
                var b = 2 * that._l23_2a + 3 * that._l23_a * that._l12_a + that._l12_2a, m = 3 * that._l23_a * (that._l23_a + that._l12_a);
                x2 = (x2 * b + that._x1 * that._l23_2a - x * that._l12_2a) / m;
                y2 = (y2 * b + that._y1 * that._l23_2a - y * that._l12_2a) / m;
            }
            that._context.bezierCurveTo(x1, y1, x2, y2, that._x2, that._y2);
        }
        function CatmullRom(context, alpha) {
            this._context = context;
            this._alpha = alpha;
        }
        CatmullRom.prototype = {
            areaStart: function() {
                this._line = 0;
            },
            areaEnd: function() {
                this._line = NaN;
            },
            lineStart: function() {
                this._x0 = this._x1 = this._x2 = this._y0 = this._y1 = this._y2 = NaN;
                this._l01_a = this._l12_a = this._l23_a = this._l01_2a = this._l12_2a = this._l23_2a = this._point = 0;
            },
            lineEnd: function() {
                switch(this._point){
                    case 2:
                        this._context.lineTo(this._x2, this._y2);
                        break;
                    case 3:
                        this.point(this._x2, this._y2);
                        break;
                }
                if (this._line || 0 !== this._line && 1 === this._point) this._context.closePath();
                this._line = 1 - this._line;
            },
            point: function(x, y) {
                x = +x, y = +y;
                if (this._point) {
                    var x23 = this._x2 - x, y23 = this._y2 - y;
                    this._l23_a = Math.sqrt(this._l23_2a = Math.pow(x23 * x23 + y23 * y23, this._alpha));
                }
                switch(this._point){
                    case 0:
                        this._point = 1;
                        this._line ? this._context.lineTo(x, y) : this._context.moveTo(x, y);
                        break;
                    case 1:
                        this._point = 2;
                        break;
                    case 2:
                        this._point = 3;
                    default:
                        catmullRom_point(this, x, y);
                        break;
                }
                this._l01_a = this._l12_a, this._l12_a = this._l23_a;
                this._l01_2a = this._l12_2a, this._l12_2a = this._l23_2a;
                this._x0 = this._x1, this._x1 = this._x2, this._x2 = x;
                this._y0 = this._y1, this._y1 = this._y2, this._y2 = y;
            }
        };
        const curve_catmullRom = function custom(alpha) {
            function catmullRom(context) {
                return alpha ? new CatmullRom(context, alpha) : new Cardinal(context, 0);
            }
            catmullRom.alpha = function(alpha) {
                return custom(+alpha);
            };
            return catmullRom;
        }(0.5);
        function CatmullRomClosed(context, alpha) {
            this._context = context;
            this._alpha = alpha;
        }
        CatmullRomClosed.prototype = {
            areaStart: src_noop,
            areaEnd: src_noop,
            lineStart: function() {
                this._x0 = this._x1 = this._x2 = this._x3 = this._x4 = this._x5 = this._y0 = this._y1 = this._y2 = this._y3 = this._y4 = this._y5 = NaN;
                this._l01_a = this._l12_a = this._l23_a = this._l01_2a = this._l12_2a = this._l23_2a = this._point = 0;
            },
            lineEnd: function() {
                switch(this._point){
                    case 1:
                        this._context.moveTo(this._x3, this._y3);
                        this._context.closePath();
                        break;
                    case 2:
                        this._context.lineTo(this._x3, this._y3);
                        this._context.closePath();
                        break;
                    case 3:
                        this.point(this._x3, this._y3);
                        this.point(this._x4, this._y4);
                        this.point(this._x5, this._y5);
                        break;
                }
            },
            point: function(x, y) {
                x = +x, y = +y;
                if (this._point) {
                    var x23 = this._x2 - x, y23 = this._y2 - y;
                    this._l23_a = Math.sqrt(this._l23_2a = Math.pow(x23 * x23 + y23 * y23, this._alpha));
                }
                switch(this._point){
                    case 0:
                        this._point = 1;
                        this._x3 = x, this._y3 = y;
                        break;
                    case 1:
                        this._point = 2;
                        this._context.moveTo(this._x4 = x, this._y4 = y);
                        break;
                    case 2:
                        this._point = 3;
                        this._x5 = x, this._y5 = y;
                        break;
                    default:
                        catmullRom_point(this, x, y);
                        break;
                }
                this._l01_a = this._l12_a, this._l12_a = this._l23_a;
                this._l01_2a = this._l12_2a, this._l12_2a = this._l23_2a;
                this._x0 = this._x1, this._x1 = this._x2, this._x2 = x;
                this._y0 = this._y1, this._y1 = this._y2, this._y2 = y;
            }
        };
        const catmullRomClosed = function custom(alpha) {
            function catmullRom(context) {
                return alpha ? new CatmullRomClosed(context, alpha) : new CardinalClosed(context, 0);
            }
            catmullRom.alpha = function(alpha) {
                return custom(+alpha);
            };
            return catmullRom;
        }(0.5);
        function CatmullRomOpen(context, alpha) {
            this._context = context;
            this._alpha = alpha;
        }
        CatmullRomOpen.prototype = {
            areaStart: function() {
                this._line = 0;
            },
            areaEnd: function() {
                this._line = NaN;
            },
            lineStart: function() {
                this._x0 = this._x1 = this._x2 = this._y0 = this._y1 = this._y2 = NaN;
                this._l01_a = this._l12_a = this._l23_a = this._l01_2a = this._l12_2a = this._l23_2a = this._point = 0;
            },
            lineEnd: function() {
                if (this._line || 0 !== this._line && 3 === this._point) this._context.closePath();
                this._line = 1 - this._line;
            },
            point: function(x, y) {
                x = +x, y = +y;
                if (this._point) {
                    var x23 = this._x2 - x, y23 = this._y2 - y;
                    this._l23_a = Math.sqrt(this._l23_2a = Math.pow(x23 * x23 + y23 * y23, this._alpha));
                }
                switch(this._point){
                    case 0:
                        this._point = 1;
                        break;
                    case 1:
                        this._point = 2;
                        break;
                    case 2:
                        this._point = 3;
                        this._line ? this._context.lineTo(this._x2, this._y2) : this._context.moveTo(this._x2, this._y2);
                        break;
                    case 3:
                        this._point = 4;
                    default:
                        catmullRom_point(this, x, y);
                        break;
                }
                this._l01_a = this._l12_a, this._l12_a = this._l23_a;
                this._l01_2a = this._l12_2a, this._l12_2a = this._l23_2a;
                this._x0 = this._x1, this._x1 = this._x2, this._x2 = x;
                this._y0 = this._y1, this._y1 = this._y2, this._y2 = y;
            }
        };
        const catmullRomOpen = function custom(alpha) {
            function catmullRom(context) {
                return alpha ? new CatmullRomOpen(context, alpha) : new CardinalOpen(context, 0);
            }
            catmullRom.alpha = function(alpha) {
                return custom(+alpha);
            };
            return catmullRom;
        }(0.5);
        function LinearClosed(context) {
            this._context = context;
        }
        LinearClosed.prototype = {
            areaStart: src_noop,
            areaEnd: src_noop,
            lineStart: function() {
                this._point = 0;
            },
            lineEnd: function() {
                if (this._point) this._context.closePath();
            },
            point: function(x, y) {
                x = +x, y = +y;
                if (this._point) this._context.lineTo(x, y);
                else this._point = 1, this._context.moveTo(x, y);
            }
        };
        function linearClosed(context) {
            return new LinearClosed(context);
        }
        function monotone_sign(x) {
            return x < 0 ? -1 : 1;
        }
        function slope3(that, x2, y2) {
            var h0 = that._x1 - that._x0, h1 = x2 - that._x1, s0 = (that._y1 - that._y0) / (h0 || h1 < 0 && -0), s1 = (y2 - that._y1) / (h1 || h0 < 0 && -0), p = (s0 * h1 + s1 * h0) / (h0 + h1);
            return (monotone_sign(s0) + monotone_sign(s1)) * Math.min(Math.abs(s0), Math.abs(s1), 0.5 * Math.abs(p)) || 0;
        }
        function slope2(that, t) {
            var h = that._x1 - that._x0;
            return h ? (3 * (that._y1 - that._y0) / h - t) / 2 : t;
        }
        function monotone_point(that, t0, t1) {
            var x0 = that._x0, y0 = that._y0, x1 = that._x1, y1 = that._y1, dx = (x1 - x0) / 3;
            that._context.bezierCurveTo(x0 + dx, y0 + dx * t0, x1 - dx, y1 - dx * t1, x1, y1);
        }
        function MonotoneX(context) {
            this._context = context;
        }
        MonotoneX.prototype = {
            areaStart: function() {
                this._line = 0;
            },
            areaEnd: function() {
                this._line = NaN;
            },
            lineStart: function() {
                this._x0 = this._x1 = this._y0 = this._y1 = this._t0 = NaN;
                this._point = 0;
            },
            lineEnd: function() {
                switch(this._point){
                    case 2:
                        this._context.lineTo(this._x1, this._y1);
                        break;
                    case 3:
                        monotone_point(this, this._t0, slope2(this, this._t0));
                        break;
                }
                if (this._line || 0 !== this._line && 1 === this._point) this._context.closePath();
                this._line = 1 - this._line;
            },
            point: function(x, y) {
                var t1 = NaN;
                x = +x, y = +y;
                if (x === this._x1 && y === this._y1) return;
                switch(this._point){
                    case 0:
                        this._point = 1;
                        this._line ? this._context.lineTo(x, y) : this._context.moveTo(x, y);
                        break;
                    case 1:
                        this._point = 2;
                        break;
                    case 2:
                        this._point = 3;
                        monotone_point(this, slope2(this, t1 = slope3(this, x, y)), t1);
                        break;
                    default:
                        monotone_point(this, this._t0, t1 = slope3(this, x, y));
                        break;
                }
                this._x0 = this._x1, this._x1 = x;
                this._y0 = this._y1, this._y1 = y;
                this._t0 = t1;
            }
        };
        function MonotoneY(context) {
            this._context = new ReflectContext(context);
        }
        (MonotoneY.prototype = Object.create(MonotoneX.prototype)).point = function(x, y) {
            MonotoneX.prototype.point.call(this, y, x);
        };
        function ReflectContext(context) {
            this._context = context;
        }
        ReflectContext.prototype = {
            moveTo: function(x, y) {
                this._context.moveTo(y, x);
            },
            closePath: function() {
                this._context.closePath();
            },
            lineTo: function(x, y) {
                this._context.lineTo(y, x);
            },
            bezierCurveTo: function(x1, y1, x2, y2, x, y) {
                this._context.bezierCurveTo(y1, x1, y2, x2, y, x);
            }
        };
        function monotoneX(context) {
            return new MonotoneX(context);
        }
        function monotoneY(context) {
            return new MonotoneY(context);
        }
        function Natural(context) {
            this._context = context;
        }
        Natural.prototype = {
            areaStart: function() {
                this._line = 0;
            },
            areaEnd: function() {
                this._line = NaN;
            },
            lineStart: function() {
                this._x = [];
                this._y = [];
            },
            lineEnd: function() {
                var x = this._x, y = this._y, n = x.length;
                if (n) {
                    this._line ? this._context.lineTo(x[0], y[0]) : this._context.moveTo(x[0], y[0]);
                    if (2 === n) this._context.lineTo(x[1], y[1]);
                    else {
                        var px = controlPoints(x), py = controlPoints(y);
                        for(var i0 = 0, i1 = 1; i1 < n; ++i0, ++i1)this._context.bezierCurveTo(px[0][i0], py[0][i0], px[1][i0], py[1][i0], x[i1], y[i1]);
                    }
                }
                if (this._line || 0 !== this._line && 1 === n) this._context.closePath();
                this._line = 1 - this._line;
                this._x = this._y = null;
            },
            point: function(x, y) {
                this._x.push(+x);
                this._y.push(+y);
            }
        };
        function controlPoints(x) {
            var i, n = x.length - 1, m, a = new Array(n), b = new Array(n), r = new Array(n);
            a[0] = 0, b[0] = 2, r[0] = x[0] + 2 * x[1];
            for(i = 1; i < n - 1; ++i)a[i] = 1, b[i] = 4, r[i] = 4 * x[i] + 2 * x[i + 1];
            a[n - 1] = 2, b[n - 1] = 7, r[n - 1] = 8 * x[n - 1] + x[n];
            for(i = 1; i < n; ++i)m = a[i] / b[i - 1], b[i] -= m, r[i] -= m * r[i - 1];
            a[n - 1] = r[n - 1] / b[n - 1];
            for(i = n - 2; i >= 0; --i)a[i] = (r[i] - a[i + 1]) / b[i];
            b[n - 1] = (x[n] + a[n - 1]) / 2;
            for(i = 0; i < n - 1; ++i)b[i] = 2 * x[i + 1] - a[i + 1];
            return [
                a,
                b
            ];
        }
        function natural(context) {
            return new Natural(context);
        }
        function Step(context, t) {
            this._context = context;
            this._t = t;
        }
        Step.prototype = {
            areaStart: function() {
                this._line = 0;
            },
            areaEnd: function() {
                this._line = NaN;
            },
            lineStart: function() {
                this._x = this._y = NaN;
                this._point = 0;
            },
            lineEnd: function() {
                if (0 < this._t && this._t < 1 && 2 === this._point) this._context.lineTo(this._x, this._y);
                if (this._line || 0 !== this._line && 1 === this._point) this._context.closePath();
                if (this._line >= 0) this._t = 1 - this._t, this._line = 1 - this._line;
            },
            point: function(x, y) {
                x = +x, y = +y;
                switch(this._point){
                    case 0:
                        this._point = 1;
                        this._line ? this._context.lineTo(x, y) : this._context.moveTo(x, y);
                        break;
                    case 1:
                        this._point = 2;
                    default:
                        if (this._t <= 0) {
                            this._context.lineTo(this._x, y);
                            this._context.lineTo(x, y);
                        } else {
                            var x1 = this._x * (1 - this._t) + x * this._t;
                            this._context.lineTo(x1, this._y);
                            this._context.lineTo(x1, y);
                        }
                        break;
                }
                this._x = x, this._y = y;
            }
        };
        function curve_step(context) {
            return new Step(context, 0.5);
        }
        function stepBefore(context) {
            return new Step(context, 0);
        }
        function stepAfter(context) {
            return new Step(context, 1);
        }
        function transform_Transform(k, x, y) {
            this.k = k;
            this.x = x;
            this.y = y;
        }
        transform_Transform.prototype = {
            constructor: transform_Transform,
            scale: function(k) {
                return 1 === k ? this : new transform_Transform(this.k * k, this.x, this.y);
            },
            translate: function(x, y) {
                return 0 === x & 0 === y ? this : new transform_Transform(this.k, this.x + this.k * x, this.y + this.k * y);
            },
            apply: function(point) {
                return [
                    point[0] * this.k + this.x,
                    point[1] * this.k + this.y
                ];
            },
            applyX: function(x) {
                return x * this.k + this.x;
            },
            applyY: function(y) {
                return y * this.k + this.y;
            },
            invert: function(location) {
                return [
                    (location[0] - this.x) / this.k,
                    (location[1] - this.y) / this.k
                ];
            },
            invertX: function(x) {
                return (x - this.x) / this.k;
            },
            invertY: function(y) {
                return (y - this.y) / this.k;
            },
            rescaleX: function(x) {
                return x.copy().domain(x.range().map(this.invertX, this).map(x.invert, x));
            },
            rescaleY: function(y) {
                return y.copy().domain(y.range().map(this.invertY, this).map(y.invert, y));
            },
            toString: function() {
                return "translate(" + this.x + "," + this.y + ") scale(" + this.k + ")";
            }
        };
        var transform_identity = new transform_Transform(1, 0, 0);
        transform_transform.prototype = transform_Transform.prototype;
        function transform_transform(node) {
            while(!node.__zoom)if (!(node = node.parentNode)) return transform_identity;
            return node.__zoom;
        }
    },
    "./node_modules/.pnpm/dompurify@3.2.4/node_modules/dompurify/dist/purify.es.mjs": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>purify
        });
        /*! @license DOMPurify 3.2.4 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.2.4/LICENSE */ const { entries, setPrototypeOf, isFrozen, getPrototypeOf, getOwnPropertyDescriptor } = Object;
        let { freeze, seal, create } = Object;
        let { apply, construct } = 'undefined' != typeof Reflect && Reflect;
        if (!freeze) freeze = function(x) {
            return x;
        };
        if (!seal) seal = function(x) {
            return x;
        };
        if (!apply) apply = function(fun, thisValue, args) {
            return fun.apply(thisValue, args);
        };
        if (!construct) construct = function(Func, args) {
            return new Func(...args);
        };
        const arrayForEach = unapply(Array.prototype.forEach);
        const arrayLastIndexOf = unapply(Array.prototype.lastIndexOf);
        const arrayPop = unapply(Array.prototype.pop);
        const arrayPush = unapply(Array.prototype.push);
        const arraySplice = unapply(Array.prototype.splice);
        const stringToLowerCase = unapply(String.prototype.toLowerCase);
        const stringToString = unapply(String.prototype.toString);
        const stringMatch = unapply(String.prototype.match);
        const stringReplace = unapply(String.prototype.replace);
        const stringIndexOf = unapply(String.prototype.indexOf);
        const stringTrim = unapply(String.prototype.trim);
        const objectHasOwnProperty = unapply(Object.prototype.hasOwnProperty);
        const regExpTest = unapply(RegExp.prototype.test);
        const typeErrorCreate = unconstruct(TypeError);
        function unapply(func) {
            return function(thisArg) {
                for(var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++)args[_key - 1] = arguments[_key];
                return apply(func, thisArg, args);
            };
        }
        function unconstruct(func) {
            return function() {
                for(var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++)args[_key2] = arguments[_key2];
                return construct(func, args);
            };
        }
        function addToSet(set, array) {
            let transformCaseFunc = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : stringToLowerCase;
            if (setPrototypeOf) setPrototypeOf(set, null);
            let l = array.length;
            while(l--){
                let element = array[l];
                if ('string' == typeof element) {
                    const lcElement = transformCaseFunc(element);
                    if (lcElement !== element) {
                        if (!isFrozen(array)) array[l] = lcElement;
                        element = lcElement;
                    }
                }
                set[element] = true;
            }
            return set;
        }
        function cleanArray(array) {
            for(let index = 0; index < array.length; index++){
                const isPropertyExist = objectHasOwnProperty(array, index);
                if (!isPropertyExist) array[index] = null;
            }
            return array;
        }
        function clone(object) {
            const newObject = create(null);
            for (const [property, value] of entries(object)){
                const isPropertyExist = objectHasOwnProperty(object, property);
                if (isPropertyExist) {
                    if (Array.isArray(value)) newObject[property] = cleanArray(value);
                    else if (value && 'object' == typeof value && value.constructor === Object) newObject[property] = clone(value);
                    else newObject[property] = value;
                }
            }
            return newObject;
        }
        function lookupGetter(object, prop) {
            while(null !== object){
                const desc = getOwnPropertyDescriptor(object, prop);
                if (desc) {
                    if (desc.get) return unapply(desc.get);
                    if ('function' == typeof desc.value) return unapply(desc.value);
                }
                object = getPrototypeOf(object);
            }
            function fallbackValue() {
                return null;
            }
            return fallbackValue;
        }
        const html$1 = freeze([
            'a',
            'abbr',
            'acronym',
            'address',
            'area',
            'article',
            'aside',
            'audio',
            'b',
            'bdi',
            'bdo',
            'big',
            'blink',
            'blockquote',
            'body',
            'br',
            'button',
            'canvas',
            'caption',
            'center',
            'cite',
            'code',
            'col',
            'colgroup',
            'content',
            'data',
            'datalist',
            'dd',
            'decorator',
            'del',
            'details',
            'dfn',
            'dialog',
            'dir',
            'div',
            'dl',
            'dt',
            'element',
            'em',
            'fieldset',
            'figcaption',
            'figure',
            'font',
            'footer',
            'form',
            'h1',
            'h2',
            'h3',
            'h4',
            'h5',
            'h6',
            'head',
            'header',
            'hgroup',
            'hr',
            'html',
            'i',
            'img',
            'input',
            'ins',
            'kbd',
            'label',
            'legend',
            'li',
            'main',
            'map',
            'mark',
            'marquee',
            'menu',
            'menuitem',
            'meter',
            'nav',
            'nobr',
            'ol',
            'optgroup',
            'option',
            'output',
            'p',
            'picture',
            'pre',
            'progress',
            'q',
            'rp',
            'rt',
            'ruby',
            's',
            'samp',
            'section',
            'select',
            'shadow',
            'small',
            'source',
            'spacer',
            'span',
            'strike',
            'strong',
            'style',
            'sub',
            'summary',
            'sup',
            'table',
            'tbody',
            'td',
            'template',
            'textarea',
            'tfoot',
            'th',
            'thead',
            'time',
            'tr',
            'track',
            'tt',
            'u',
            'ul',
            'var',
            'video',
            'wbr'
        ]);
        const svg$1 = freeze([
            'svg',
            'a',
            'altglyph',
            'altglyphdef',
            'altglyphitem',
            'animatecolor',
            'animatemotion',
            'animatetransform',
            'circle',
            'clippath',
            'defs',
            'desc',
            'ellipse',
            'filter',
            'font',
            'g',
            'glyph',
            'glyphref',
            'hkern',
            'image',
            'line',
            'lineargradient',
            'marker',
            'mask',
            'metadata',
            'mpath',
            'path',
            'pattern',
            'polygon',
            'polyline',
            'radialgradient',
            'rect',
            'stop',
            'style',
            'switch',
            'symbol',
            'text',
            'textpath',
            'title',
            'tref',
            'tspan',
            'view',
            'vkern'
        ]);
        const svgFilters = freeze([
            'feBlend',
            'feColorMatrix',
            'feComponentTransfer',
            'feComposite',
            'feConvolveMatrix',
            'feDiffuseLighting',
            'feDisplacementMap',
            'feDistantLight',
            'feDropShadow',
            'feFlood',
            'feFuncA',
            'feFuncB',
            'feFuncG',
            'feFuncR',
            'feGaussianBlur',
            'feImage',
            'feMerge',
            'feMergeNode',
            'feMorphology',
            'feOffset',
            'fePointLight',
            'feSpecularLighting',
            'feSpotLight',
            'feTile',
            'feTurbulence'
        ]);
        const svgDisallowed = freeze([
            'animate',
            'color-profile',
            'cursor',
            'discard',
            'font-face',
            'font-face-format',
            'font-face-name',
            'font-face-src',
            'font-face-uri',
            'foreignobject',
            'hatch',
            'hatchpath',
            'mesh',
            'meshgradient',
            'meshpatch',
            'meshrow',
            'missing-glyph',
            "script",
            'set',
            'solidcolor',
            'unknown',
            'use'
        ]);
        const mathMl$1 = freeze([
            'math',
            'menclose',
            'merror',
            'mfenced',
            'mfrac',
            'mglyph',
            'mi',
            'mlabeledtr',
            "mmultiscripts",
            'mn',
            'mo',
            'mover',
            'mpadded',
            'mphantom',
            'mroot',
            'mrow',
            'ms',
            'mspace',
            'msqrt',
            'mstyle',
            'msub',
            'msup',
            'msubsup',
            'mtable',
            'mtd',
            'mtext',
            'mtr',
            'munder',
            'munderover',
            "mprescripts"
        ]);
        const mathMlDisallowed = freeze([
            'maction',
            'maligngroup',
            'malignmark',
            'mlongdiv',
            'mscarries',
            'mscarry',
            'msgroup',
            'mstack',
            'msline',
            'msrow',
            'semantics',
            'annotation',
            'annotation-xml',
            "mprescripts",
            'none'
        ]);
        const text = freeze([
            '#text'
        ]);
        const html = freeze([
            'accept',
            'action',
            'align',
            'alt',
            'autocapitalize',
            'autocomplete',
            'autopictureinpicture',
            'autoplay',
            'background',
            'bgcolor',
            'border',
            'capture',
            'cellpadding',
            'cellspacing',
            'checked',
            'cite',
            'class',
            'clear',
            'color',
            'cols',
            'colspan',
            'controls',
            'controlslist',
            'coords',
            'crossorigin',
            'datetime',
            'decoding',
            'default',
            'dir',
            'disabled',
            'disablepictureinpicture',
            'disableremoteplayback',
            'download',
            'draggable',
            'enctype',
            'enterkeyhint',
            'face',
            'for',
            'headers',
            'height',
            'hidden',
            'high',
            'href',
            'hreflang',
            'id',
            'inputmode',
            'integrity',
            'ismap',
            'kind',
            'label',
            'lang',
            'list',
            'loading',
            'loop',
            'low',
            'max',
            'maxlength',
            'media',
            'method',
            'min',
            'minlength',
            'multiple',
            'muted',
            'name',
            'nonce',
            'noshade',
            'novalidate',
            'nowrap',
            'open',
            'optimum',
            'pattern',
            'placeholder',
            'playsinline',
            'popover',
            'popovertarget',
            'popovertargetaction',
            'poster',
            'preload',
            'pubdate',
            'radiogroup',
            'readonly',
            'rel',
            'required',
            'rev',
            'reversed',
            'role',
            'rows',
            'rowspan',
            'spellcheck',
            'scope',
            'selected',
            'shape',
            'size',
            'sizes',
            'span',
            'srclang',
            'start',
            'src',
            'srcset',
            'step',
            'style',
            'summary',
            'tabindex',
            'title',
            'translate',
            'type',
            'usemap',
            'valign',
            'value',
            'width',
            'wrap',
            'xmlns',
            'slot'
        ]);
        const svg = freeze([
            'accent-height',
            'accumulate',
            'additive',
            'alignment-baseline',
            'amplitude',
            'ascent',
            'attributename',
            'attributetype',
            'azimuth',
            'basefrequency',
            'baseline-shift',
            'begin',
            'bias',
            'by',
            'class',
            'clip',
            'clippathunits',
            'clip-path',
            'clip-rule',
            'color',
            'color-interpolation',
            'color-interpolation-filters',
            'color-profile',
            'color-rendering',
            'cx',
            'cy',
            'd',
            'dx',
            'dy',
            'diffuseconstant',
            'direction',
            'display',
            'divisor',
            'dur',
            'edgemode',
            'elevation',
            'end',
            'exponent',
            'fill',
            'fill-opacity',
            'fill-rule',
            'filter',
            'filterunits',
            'flood-color',
            'flood-opacity',
            'font-family',
            'font-size',
            'font-size-adjust',
            'font-stretch',
            'font-style',
            'font-variant',
            'font-weight',
            'fx',
            'fy',
            'g1',
            'g2',
            'glyph-name',
            'glyphref',
            'gradientunits',
            'gradienttransform',
            'height',
            'href',
            'id',
            'image-rendering',
            'in',
            'in2',
            'intercept',
            'k',
            'k1',
            'k2',
            'k3',
            'k4',
            'kerning',
            'keypoints',
            'keysplines',
            'keytimes',
            'lang',
            'lengthadjust',
            'letter-spacing',
            'kernelmatrix',
            'kernelunitlength',
            'lighting-color',
            'local',
            'marker-end',
            'marker-mid',
            'marker-start',
            'markerheight',
            'markerunits',
            'markerwidth',
            'maskcontentunits',
            'maskunits',
            'max',
            'mask',
            'media',
            'method',
            'mode',
            'min',
            'name',
            'numoctaves',
            'offset',
            'operator',
            'opacity',
            'order',
            'orient',
            'orientation',
            'origin',
            'overflow',
            'paint-order',
            'path',
            'pathlength',
            'patterncontentunits',
            'patterntransform',
            'patternunits',
            'points',
            'preservealpha',
            'preserveaspectratio',
            'primitiveunits',
            'r',
            'rx',
            'ry',
            'radius',
            'refx',
            'refy',
            'repeatcount',
            'repeatdur',
            'restart',
            'result',
            'rotate',
            'scale',
            'seed',
            'shape-rendering',
            'slope',
            'specularconstant',
            'specularexponent',
            'spreadmethod',
            'startoffset',
            'stddeviation',
            'stitchtiles',
            'stop-color',
            'stop-opacity',
            'stroke-dasharray',
            'stroke-dashoffset',
            'stroke-linecap',
            'stroke-linejoin',
            'stroke-miterlimit',
            'stroke-opacity',
            'stroke',
            'stroke-width',
            'style',
            'surfacescale',
            'systemlanguage',
            'tabindex',
            'tablevalues',
            'targetx',
            'targety',
            'transform',
            'transform-origin',
            'text-anchor',
            'text-decoration',
            'text-rendering',
            'textlength',
            'type',
            'u1',
            'u2',
            'unicode',
            'values',
            'viewbox',
            'visibility',
            'version',
            'vert-adv-y',
            'vert-origin-x',
            'vert-origin-y',
            'width',
            'word-spacing',
            'wrap',
            'writing-mode',
            'xchannelselector',
            'ychannelselector',
            'x',
            'x1',
            'x2',
            'xmlns',
            'y',
            'y1',
            'y2',
            'z',
            'zoomandpan'
        ]);
        const mathMl = freeze([
            'accent',
            'accentunder',
            'align',
            'bevelled',
            'close',
            'columnsalign',
            'columnlines',
            'columnspan',
            'denomalign',
            'depth',
            'dir',
            'display',
            'displaystyle',
            'encoding',
            'fence',
            'frame',
            'height',
            'href',
            'id',
            'largeop',
            'length',
            'linethickness',
            'lspace',
            'lquote',
            'mathbackground',
            'mathcolor',
            'mathsize',
            'mathvariant',
            'maxsize',
            'minsize',
            'movablelimits',
            'notation',
            'numalign',
            'open',
            'rowalign',
            'rowlines',
            'rowspacing',
            'rowspan',
            'rspace',
            'rquote',
            "scriptlevel",
            "scriptminsize",
            "scriptsizemultiplier",
            'selection',
            'separator',
            'separators',
            'stretchy',
            "subscriptshift",
            "supscriptshift",
            'symmetric',
            'voffset',
            'width',
            'xmlns'
        ]);
        const xml = freeze([
            'xlink:href',
            'xml:id',
            'xlink:title',
            'xml:space',
            'xmlns:xlink'
        ]);
        const MUSTACHE_EXPR = seal(/\{\{[\w\W]*|[\w\W]*\}\}/gm);
        const ERB_EXPR = seal(/<%[\w\W]*|[\w\W]*%>/gm);
        const TMPLIT_EXPR = seal(/\$\{[\w\W]*/gm);
        const DATA_ATTR = seal(/^data-[\-\w.\u00B7-\uFFFF]+$/);
        const ARIA_ATTR = seal(/^aria-[\-\w]+$/);
        const IS_ALLOWED_URI = seal(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i);
        const IS_SCRIPT_OR_DATA = seal(/^(?:\w+script|data):/i);
        const ATTR_WHITESPACE = seal(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g);
        const DOCTYPE_NAME = seal(/^html$/i);
        const CUSTOM_ELEMENT = seal(/^[a-z][.\w]*(-[.\w]+)+$/i);
        var EXPRESSIONS = /*#__PURE__*/ Object.freeze({
            __proto__: null,
            ARIA_ATTR: ARIA_ATTR,
            ATTR_WHITESPACE: ATTR_WHITESPACE,
            CUSTOM_ELEMENT: CUSTOM_ELEMENT,
            DATA_ATTR: DATA_ATTR,
            DOCTYPE_NAME: DOCTYPE_NAME,
            ERB_EXPR: ERB_EXPR,
            IS_ALLOWED_URI: IS_ALLOWED_URI,
            IS_SCRIPT_OR_DATA: IS_SCRIPT_OR_DATA,
            MUSTACHE_EXPR: MUSTACHE_EXPR,
            TMPLIT_EXPR: TMPLIT_EXPR
        });
        const NODE_TYPE = {
            element: 1,
            attribute: 2,
            text: 3,
            cdataSection: 4,
            entityReference: 5,
            entityNode: 6,
            progressingInstruction: 7,
            comment: 8,
            document: 9,
            documentType: 10,
            documentFragment: 11,
            notation: 12
        };
        const getGlobal = function() {
            return 'undefined' == typeof window ? null : window;
        };
        const _createTrustedTypesPolicy = function(trustedTypes, purifyHostElement) {
            if ('object' != typeof trustedTypes || 'function' != typeof trustedTypes.createPolicy) return null;
            let suffix = null;
            const ATTR_NAME = 'data-tt-policy-suffix';
            if (purifyHostElement && purifyHostElement.hasAttribute(ATTR_NAME)) suffix = purifyHostElement.getAttribute(ATTR_NAME);
            const policyName = 'dompurify' + (suffix ? '#' + suffix : '');
            try {
                return trustedTypes.createPolicy(policyName, {
                    createHTML (html) {
                        return html;
                    },
                    createScriptURL (scriptUrl) {
                        return scriptUrl;
                    }
                });
            } catch (_) {
                console.warn('TrustedTypes policy ' + policyName + ' could not be created.');
                return null;
            }
        };
        const _createHooksMap = function() {
            return {
                afterSanitizeAttributes: [],
                afterSanitizeElements: [],
                afterSanitizeShadowDOM: [],
                beforeSanitizeAttributes: [],
                beforeSanitizeElements: [],
                beforeSanitizeShadowDOM: [],
                uponSanitizeAttribute: [],
                uponSanitizeElement: [],
                uponSanitizeShadowNode: []
            };
        };
        function createDOMPurify() {
            let window1 = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : getGlobal();
            const DOMPurify = (root)=>createDOMPurify(root);
            DOMPurify.version = '3.2.4';
            DOMPurify.removed = [];
            if (!window1 || !window1.document || window1.document.nodeType !== NODE_TYPE.document || !window1.Element) {
                DOMPurify.isSupported = false;
                return DOMPurify;
            }
            let { document: document1 } = window1;
            const originalDocument = document1;
            const currentScript = originalDocument.currentScript;
            const { DocumentFragment, HTMLTemplateElement, Node, Element: Element1, NodeFilter, NamedNodeMap = window1.NamedNodeMap || window1.MozNamedAttrMap, HTMLFormElement, DOMParser, trustedTypes } = window1;
            const ElementPrototype = Element1.prototype;
            const cloneNode = lookupGetter(ElementPrototype, 'cloneNode');
            const remove = lookupGetter(ElementPrototype, 'remove');
            const getNextSibling = lookupGetter(ElementPrototype, 'nextSibling');
            const getChildNodes = lookupGetter(ElementPrototype, 'childNodes');
            const getParentNode = lookupGetter(ElementPrototype, 'parentNode');
            if ('function' == typeof HTMLTemplateElement) {
                const template = document1.createElement('template');
                if (template.content && template.content.ownerDocument) document1 = template.content.ownerDocument;
            }
            let trustedTypesPolicy;
            let emptyHTML = '';
            const { implementation, createNodeIterator, createDocumentFragment, getElementsByTagName } = document1;
            const { importNode } = originalDocument;
            let hooks = _createHooksMap();
            DOMPurify.isSupported = 'function' == typeof entries && 'function' == typeof getParentNode && implementation && void 0 !== implementation.createHTMLDocument;
            const { MUSTACHE_EXPR, ERB_EXPR, TMPLIT_EXPR, DATA_ATTR, ARIA_ATTR, IS_SCRIPT_OR_DATA, ATTR_WHITESPACE, CUSTOM_ELEMENT } = EXPRESSIONS;
            let { IS_ALLOWED_URI: IS_ALLOWED_URI$1 } = EXPRESSIONS;
            let ALLOWED_TAGS = null;
            const DEFAULT_ALLOWED_TAGS = addToSet({}, [
                ...html$1,
                ...svg$1,
                ...svgFilters,
                ...mathMl$1,
                ...text
            ]);
            let ALLOWED_ATTR = null;
            const DEFAULT_ALLOWED_ATTR = addToSet({}, [
                ...html,
                ...svg,
                ...mathMl,
                ...xml
            ]);
            let CUSTOM_ELEMENT_HANDLING = Object.seal(create(null, {
                tagNameCheck: {
                    writable: true,
                    configurable: false,
                    enumerable: true,
                    value: null
                },
                attributeNameCheck: {
                    writable: true,
                    configurable: false,
                    enumerable: true,
                    value: null
                },
                allowCustomizedBuiltInElements: {
                    writable: true,
                    configurable: false,
                    enumerable: true,
                    value: false
                }
            }));
            let FORBID_TAGS = null;
            let FORBID_ATTR = null;
            let ALLOW_ARIA_ATTR = true;
            let ALLOW_DATA_ATTR = true;
            let ALLOW_UNKNOWN_PROTOCOLS = false;
            let ALLOW_SELF_CLOSE_IN_ATTR = true;
            let SAFE_FOR_TEMPLATES = false;
            let SAFE_FOR_XML = true;
            let WHOLE_DOCUMENT = false;
            let SET_CONFIG = false;
            let FORCE_BODY = false;
            let RETURN_DOM = false;
            let RETURN_DOM_FRAGMENT = false;
            let RETURN_TRUSTED_TYPE = false;
            let SANITIZE_DOM = true;
            let SANITIZE_NAMED_PROPS = false;
            const SANITIZE_NAMED_PROPS_PREFIX = 'user-content-';
            let KEEP_CONTENT = true;
            let IN_PLACE = false;
            let USE_PROFILES = {};
            let FORBID_CONTENTS = null;
            const DEFAULT_FORBID_CONTENTS = addToSet({}, [
                'annotation-xml',
                'audio',
                'colgroup',
                'desc',
                'foreignobject',
                'head',
                'iframe',
                'math',
                'mi',
                'mn',
                'mo',
                'ms',
                'mtext',
                'noembed',
                'noframes',
                "noscript",
                'plaintext',
                "script",
                'style',
                'svg',
                'template',
                'thead',
                'title',
                'video',
                'xmp'
            ]);
            let DATA_URI_TAGS = null;
            const DEFAULT_DATA_URI_TAGS = addToSet({}, [
                'audio',
                'video',
                'img',
                'source',
                'image',
                'track'
            ]);
            let URI_SAFE_ATTRIBUTES = null;
            const DEFAULT_URI_SAFE_ATTRIBUTES = addToSet({}, [
                'alt',
                'class',
                'for',
                'id',
                'label',
                'name',
                'pattern',
                'placeholder',
                'role',
                'summary',
                'title',
                'value',
                'style',
                'xmlns'
            ]);
            const MATHML_NAMESPACE = 'http://www.w3.org/1998/Math/MathML';
            const SVG_NAMESPACE = 'http://www.w3.org/2000/svg';
            const HTML_NAMESPACE = 'http://www.w3.org/1999/xhtml';
            let NAMESPACE = HTML_NAMESPACE;
            let IS_EMPTY_INPUT = false;
            let ALLOWED_NAMESPACES = null;
            const DEFAULT_ALLOWED_NAMESPACES = addToSet({}, [
                MATHML_NAMESPACE,
                SVG_NAMESPACE,
                HTML_NAMESPACE
            ], stringToString);
            let MATHML_TEXT_INTEGRATION_POINTS = addToSet({}, [
                'mi',
                'mo',
                'mn',
                'ms',
                'mtext'
            ]);
            let HTML_INTEGRATION_POINTS = addToSet({}, [
                'annotation-xml'
            ]);
            const COMMON_SVG_AND_HTML_ELEMENTS = addToSet({}, [
                'title',
                'style',
                'font',
                'a',
                "script"
            ]);
            let PARSER_MEDIA_TYPE = null;
            const SUPPORTED_PARSER_MEDIA_TYPES = [
                'application/xhtml+xml',
                'text/html'
            ];
            const DEFAULT_PARSER_MEDIA_TYPE = 'text/html';
            let transformCaseFunc = null;
            let CONFIG = null;
            const formElement = document1.createElement('form');
            const isRegexOrFunction = function(testValue) {
                return testValue instanceof RegExp || testValue instanceof Function;
            };
            const _parseConfig = function() {
                let cfg = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {};
                if (CONFIG && CONFIG === cfg) return;
                if (!cfg || 'object' != typeof cfg) cfg = {};
                cfg = clone(cfg);
                PARSER_MEDIA_TYPE = -1 === SUPPORTED_PARSER_MEDIA_TYPES.indexOf(cfg.PARSER_MEDIA_TYPE) ? DEFAULT_PARSER_MEDIA_TYPE : cfg.PARSER_MEDIA_TYPE;
                transformCaseFunc = 'application/xhtml+xml' === PARSER_MEDIA_TYPE ? stringToString : stringToLowerCase;
                ALLOWED_TAGS = objectHasOwnProperty(cfg, 'ALLOWED_TAGS') ? addToSet({}, cfg.ALLOWED_TAGS, transformCaseFunc) : DEFAULT_ALLOWED_TAGS;
                ALLOWED_ATTR = objectHasOwnProperty(cfg, 'ALLOWED_ATTR') ? addToSet({}, cfg.ALLOWED_ATTR, transformCaseFunc) : DEFAULT_ALLOWED_ATTR;
                ALLOWED_NAMESPACES = objectHasOwnProperty(cfg, 'ALLOWED_NAMESPACES') ? addToSet({}, cfg.ALLOWED_NAMESPACES, stringToString) : DEFAULT_ALLOWED_NAMESPACES;
                URI_SAFE_ATTRIBUTES = objectHasOwnProperty(cfg, 'ADD_URI_SAFE_ATTR') ? addToSet(clone(DEFAULT_URI_SAFE_ATTRIBUTES), cfg.ADD_URI_SAFE_ATTR, transformCaseFunc) : DEFAULT_URI_SAFE_ATTRIBUTES;
                DATA_URI_TAGS = objectHasOwnProperty(cfg, 'ADD_DATA_URI_TAGS') ? addToSet(clone(DEFAULT_DATA_URI_TAGS), cfg.ADD_DATA_URI_TAGS, transformCaseFunc) : DEFAULT_DATA_URI_TAGS;
                FORBID_CONTENTS = objectHasOwnProperty(cfg, 'FORBID_CONTENTS') ? addToSet({}, cfg.FORBID_CONTENTS, transformCaseFunc) : DEFAULT_FORBID_CONTENTS;
                FORBID_TAGS = objectHasOwnProperty(cfg, 'FORBID_TAGS') ? addToSet({}, cfg.FORBID_TAGS, transformCaseFunc) : {};
                FORBID_ATTR = objectHasOwnProperty(cfg, 'FORBID_ATTR') ? addToSet({}, cfg.FORBID_ATTR, transformCaseFunc) : {};
                USE_PROFILES = !!objectHasOwnProperty(cfg, 'USE_PROFILES') && cfg.USE_PROFILES;
                ALLOW_ARIA_ATTR = false !== cfg.ALLOW_ARIA_ATTR;
                ALLOW_DATA_ATTR = false !== cfg.ALLOW_DATA_ATTR;
                ALLOW_UNKNOWN_PROTOCOLS = cfg.ALLOW_UNKNOWN_PROTOCOLS || false;
                ALLOW_SELF_CLOSE_IN_ATTR = false !== cfg.ALLOW_SELF_CLOSE_IN_ATTR;
                SAFE_FOR_TEMPLATES = cfg.SAFE_FOR_TEMPLATES || false;
                SAFE_FOR_XML = false !== cfg.SAFE_FOR_XML;
                WHOLE_DOCUMENT = cfg.WHOLE_DOCUMENT || false;
                RETURN_DOM = cfg.RETURN_DOM || false;
                RETURN_DOM_FRAGMENT = cfg.RETURN_DOM_FRAGMENT || false;
                RETURN_TRUSTED_TYPE = cfg.RETURN_TRUSTED_TYPE || false;
                FORCE_BODY = cfg.FORCE_BODY || false;
                SANITIZE_DOM = false !== cfg.SANITIZE_DOM;
                SANITIZE_NAMED_PROPS = cfg.SANITIZE_NAMED_PROPS || false;
                KEEP_CONTENT = false !== cfg.KEEP_CONTENT;
                IN_PLACE = cfg.IN_PLACE || false;
                IS_ALLOWED_URI$1 = cfg.ALLOWED_URI_REGEXP || IS_ALLOWED_URI;
                NAMESPACE = cfg.NAMESPACE || HTML_NAMESPACE;
                MATHML_TEXT_INTEGRATION_POINTS = cfg.MATHML_TEXT_INTEGRATION_POINTS || MATHML_TEXT_INTEGRATION_POINTS;
                HTML_INTEGRATION_POINTS = cfg.HTML_INTEGRATION_POINTS || HTML_INTEGRATION_POINTS;
                CUSTOM_ELEMENT_HANDLING = cfg.CUSTOM_ELEMENT_HANDLING || {};
                if (cfg.CUSTOM_ELEMENT_HANDLING && isRegexOrFunction(cfg.CUSTOM_ELEMENT_HANDLING.tagNameCheck)) CUSTOM_ELEMENT_HANDLING.tagNameCheck = cfg.CUSTOM_ELEMENT_HANDLING.tagNameCheck;
                if (cfg.CUSTOM_ELEMENT_HANDLING && isRegexOrFunction(cfg.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)) CUSTOM_ELEMENT_HANDLING.attributeNameCheck = cfg.CUSTOM_ELEMENT_HANDLING.attributeNameCheck;
                if (cfg.CUSTOM_ELEMENT_HANDLING && 'boolean' == typeof cfg.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements) CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements = cfg.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements;
                if (SAFE_FOR_TEMPLATES) ALLOW_DATA_ATTR = false;
                if (RETURN_DOM_FRAGMENT) RETURN_DOM = true;
                if (USE_PROFILES) {
                    ALLOWED_TAGS = addToSet({}, text);
                    ALLOWED_ATTR = [];
                    if (true === USE_PROFILES.html) {
                        addToSet(ALLOWED_TAGS, html$1);
                        addToSet(ALLOWED_ATTR, html);
                    }
                    if (true === USE_PROFILES.svg) {
                        addToSet(ALLOWED_TAGS, svg$1);
                        addToSet(ALLOWED_ATTR, svg);
                        addToSet(ALLOWED_ATTR, xml);
                    }
                    if (true === USE_PROFILES.svgFilters) {
                        addToSet(ALLOWED_TAGS, svgFilters);
                        addToSet(ALLOWED_ATTR, svg);
                        addToSet(ALLOWED_ATTR, xml);
                    }
                    if (true === USE_PROFILES.mathMl) {
                        addToSet(ALLOWED_TAGS, mathMl$1);
                        addToSet(ALLOWED_ATTR, mathMl);
                        addToSet(ALLOWED_ATTR, xml);
                    }
                }
                if (cfg.ADD_TAGS) {
                    if (ALLOWED_TAGS === DEFAULT_ALLOWED_TAGS) ALLOWED_TAGS = clone(ALLOWED_TAGS);
                    addToSet(ALLOWED_TAGS, cfg.ADD_TAGS, transformCaseFunc);
                }
                if (cfg.ADD_ATTR) {
                    if (ALLOWED_ATTR === DEFAULT_ALLOWED_ATTR) ALLOWED_ATTR = clone(ALLOWED_ATTR);
                    addToSet(ALLOWED_ATTR, cfg.ADD_ATTR, transformCaseFunc);
                }
                if (cfg.ADD_URI_SAFE_ATTR) addToSet(URI_SAFE_ATTRIBUTES, cfg.ADD_URI_SAFE_ATTR, transformCaseFunc);
                if (cfg.FORBID_CONTENTS) {
                    if (FORBID_CONTENTS === DEFAULT_FORBID_CONTENTS) FORBID_CONTENTS = clone(FORBID_CONTENTS);
                    addToSet(FORBID_CONTENTS, cfg.FORBID_CONTENTS, transformCaseFunc);
                }
                if (KEEP_CONTENT) ALLOWED_TAGS['#text'] = true;
                if (WHOLE_DOCUMENT) addToSet(ALLOWED_TAGS, [
                    'html',
                    'head',
                    'body'
                ]);
                if (ALLOWED_TAGS.table) {
                    addToSet(ALLOWED_TAGS, [
                        'tbody'
                    ]);
                    delete FORBID_TAGS.tbody;
                }
                if (cfg.TRUSTED_TYPES_POLICY) {
                    if ('function' != typeof cfg.TRUSTED_TYPES_POLICY.createHTML) throw typeErrorCreate('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');
                    if ('function' != typeof cfg.TRUSTED_TYPES_POLICY.createScriptURL) throw typeErrorCreate('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');
                    trustedTypesPolicy = cfg.TRUSTED_TYPES_POLICY;
                    emptyHTML = trustedTypesPolicy.createHTML('');
                } else {
                    if (void 0 === trustedTypesPolicy) trustedTypesPolicy = _createTrustedTypesPolicy(trustedTypes, currentScript);
                    if (null !== trustedTypesPolicy && 'string' == typeof emptyHTML) emptyHTML = trustedTypesPolicy.createHTML('');
                }
                if (freeze) freeze(cfg);
                CONFIG = cfg;
            };
            const ALL_SVG_TAGS = addToSet({}, [
                ...svg$1,
                ...svgFilters,
                ...svgDisallowed
            ]);
            const ALL_MATHML_TAGS = addToSet({}, [
                ...mathMl$1,
                ...mathMlDisallowed
            ]);
            const _checkValidNamespace = function(element) {
                let parent = getParentNode(element);
                if (!parent || !parent.tagName) parent = {
                    namespaceURI: NAMESPACE,
                    tagName: 'template'
                };
                const tagName = stringToLowerCase(element.tagName);
                const parentTagName = stringToLowerCase(parent.tagName);
                if (!ALLOWED_NAMESPACES[element.namespaceURI]) return false;
                if (element.namespaceURI === SVG_NAMESPACE) {
                    if (parent.namespaceURI === HTML_NAMESPACE) return 'svg' === tagName;
                    if (parent.namespaceURI === MATHML_NAMESPACE) return 'svg' === tagName && ('annotation-xml' === parentTagName || MATHML_TEXT_INTEGRATION_POINTS[parentTagName]);
                    return Boolean(ALL_SVG_TAGS[tagName]);
                }
                if (element.namespaceURI === MATHML_NAMESPACE) {
                    if (parent.namespaceURI === HTML_NAMESPACE) return 'math' === tagName;
                    if (parent.namespaceURI === SVG_NAMESPACE) return 'math' === tagName && HTML_INTEGRATION_POINTS[parentTagName];
                    return Boolean(ALL_MATHML_TAGS[tagName]);
                }
                if (element.namespaceURI === HTML_NAMESPACE) {
                    if (parent.namespaceURI === SVG_NAMESPACE && !HTML_INTEGRATION_POINTS[parentTagName]) return false;
                    if (parent.namespaceURI === MATHML_NAMESPACE && !MATHML_TEXT_INTEGRATION_POINTS[parentTagName]) return false;
                    return !ALL_MATHML_TAGS[tagName] && (COMMON_SVG_AND_HTML_ELEMENTS[tagName] || !ALL_SVG_TAGS[tagName]);
                }
                if ('application/xhtml+xml' === PARSER_MEDIA_TYPE && ALLOWED_NAMESPACES[element.namespaceURI]) return true;
                return false;
            };
            const _forceRemove = function(node) {
                arrayPush(DOMPurify.removed, {
                    element: node
                });
                try {
                    getParentNode(node).removeChild(node);
                } catch (_) {
                    remove(node);
                }
            };
            const _removeAttribute = function(name, element) {
                try {
                    arrayPush(DOMPurify.removed, {
                        attribute: element.getAttributeNode(name),
                        from: element
                    });
                } catch (_) {
                    arrayPush(DOMPurify.removed, {
                        attribute: null,
                        from: element
                    });
                }
                element.removeAttribute(name);
                if ('is' === name) {
                    if (RETURN_DOM || RETURN_DOM_FRAGMENT) try {
                        _forceRemove(element);
                    } catch (_) {}
                    else try {
                        element.setAttribute(name, '');
                    } catch (_) {}
                }
            };
            const _initDocument = function(dirty) {
                let doc = null;
                let leadingWhitespace = null;
                if (FORCE_BODY) dirty = '<remove></remove>' + dirty;
                else {
                    const matches = stringMatch(dirty, /^[\r\n\t ]+/);
                    leadingWhitespace = matches && matches[0];
                }
                if ('application/xhtml+xml' === PARSER_MEDIA_TYPE && NAMESPACE === HTML_NAMESPACE) dirty = '<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>' + dirty + '</body></html>';
                const dirtyPayload = trustedTypesPolicy ? trustedTypesPolicy.createHTML(dirty) : dirty;
                if (NAMESPACE === HTML_NAMESPACE) try {
                    doc = new DOMParser().parseFromString(dirtyPayload, PARSER_MEDIA_TYPE);
                } catch (_) {}
                if (!doc || !doc.documentElement) {
                    doc = implementation.createDocument(NAMESPACE, 'template', null);
                    try {
                        doc.documentElement.innerHTML = IS_EMPTY_INPUT ? emptyHTML : dirtyPayload;
                    } catch (_) {}
                }
                const body = doc.body || doc.documentElement;
                if (dirty && leadingWhitespace) body.insertBefore(document1.createTextNode(leadingWhitespace), body.childNodes[0] || null);
                if (NAMESPACE === HTML_NAMESPACE) return getElementsByTagName.call(doc, WHOLE_DOCUMENT ? 'html' : 'body')[0];
                return WHOLE_DOCUMENT ? doc.documentElement : body;
            };
            const _createNodeIterator = function(root) {
                return createNodeIterator.call(root.ownerDocument || root, root, NodeFilter.SHOW_ELEMENT | NodeFilter.SHOW_COMMENT | NodeFilter.SHOW_TEXT | NodeFilter.SHOW_PROCESSING_INSTRUCTION | NodeFilter.SHOW_CDATA_SECTION, null);
            };
            const _isClobbered = function(element) {
                return element instanceof HTMLFormElement && ('string' != typeof element.nodeName || 'string' != typeof element.textContent || 'function' != typeof element.removeChild || !(element.attributes instanceof NamedNodeMap) || 'function' != typeof element.removeAttribute || 'function' != typeof element.setAttribute || 'string' != typeof element.namespaceURI || 'function' != typeof element.insertBefore || 'function' != typeof element.hasChildNodes);
            };
            const _isNode = function(value) {
                return 'function' == typeof Node && value instanceof Node;
            };
            function _executeHooks(hooks, currentNode, data) {
                arrayForEach(hooks, (hook)=>{
                    hook.call(DOMPurify, currentNode, data, CONFIG);
                });
            }
            const _sanitizeElements = function(currentNode) {
                let content = null;
                _executeHooks(hooks.beforeSanitizeElements, currentNode, null);
                if (_isClobbered(currentNode)) {
                    _forceRemove(currentNode);
                    return true;
                }
                const tagName = transformCaseFunc(currentNode.nodeName);
                _executeHooks(hooks.uponSanitizeElement, currentNode, {
                    tagName,
                    allowedTags: ALLOWED_TAGS
                });
                if (currentNode.hasChildNodes() && !_isNode(currentNode.firstElementChild) && regExpTest(/<[/\w]/g, currentNode.innerHTML) && regExpTest(/<[/\w]/g, currentNode.textContent)) {
                    _forceRemove(currentNode);
                    return true;
                }
                if (currentNode.nodeType === NODE_TYPE.progressingInstruction) {
                    _forceRemove(currentNode);
                    return true;
                }
                if (SAFE_FOR_XML && currentNode.nodeType === NODE_TYPE.comment && regExpTest(/<[/\w]/g, currentNode.data)) {
                    _forceRemove(currentNode);
                    return true;
                }
                if (!ALLOWED_TAGS[tagName] || FORBID_TAGS[tagName]) {
                    if (!FORBID_TAGS[tagName] && _isBasicCustomElement(tagName)) {
                        if (CUSTOM_ELEMENT_HANDLING.tagNameCheck instanceof RegExp && regExpTest(CUSTOM_ELEMENT_HANDLING.tagNameCheck, tagName)) return false;
                        if (CUSTOM_ELEMENT_HANDLING.tagNameCheck instanceof Function && CUSTOM_ELEMENT_HANDLING.tagNameCheck(tagName)) return false;
                    }
                    if (KEEP_CONTENT && !FORBID_CONTENTS[tagName]) {
                        const parentNode = getParentNode(currentNode) || currentNode.parentNode;
                        const childNodes = getChildNodes(currentNode) || currentNode.childNodes;
                        if (childNodes && parentNode) {
                            const childCount = childNodes.length;
                            for(let i = childCount - 1; i >= 0; --i){
                                const childClone = cloneNode(childNodes[i], true);
                                childClone.__removalCount = (currentNode.__removalCount || 0) + 1;
                                parentNode.insertBefore(childClone, getNextSibling(currentNode));
                            }
                        }
                    }
                    _forceRemove(currentNode);
                    return true;
                }
                if (currentNode instanceof Element1 && !_checkValidNamespace(currentNode)) {
                    _forceRemove(currentNode);
                    return true;
                }
                if (("noscript" === tagName || 'noembed' === tagName || 'noframes' === tagName) && regExpTest(/<\/no(script|embed|frames)/i, currentNode.innerHTML)) {
                    _forceRemove(currentNode);
                    return true;
                }
                if (SAFE_FOR_TEMPLATES && currentNode.nodeType === NODE_TYPE.text) {
                    content = currentNode.textContent;
                    arrayForEach([
                        MUSTACHE_EXPR,
                        ERB_EXPR,
                        TMPLIT_EXPR
                    ], (expr)=>{
                        content = stringReplace(content, expr, ' ');
                    });
                    if (currentNode.textContent !== content) {
                        arrayPush(DOMPurify.removed, {
                            element: currentNode.cloneNode()
                        });
                        currentNode.textContent = content;
                    }
                }
                _executeHooks(hooks.afterSanitizeElements, currentNode, null);
                return false;
            };
            const _isValidAttribute = function(lcTag, lcName, value) {
                if (SANITIZE_DOM && ('id' === lcName || 'name' === lcName) && (value in document1 || value in formElement)) return false;
                if (ALLOW_DATA_ATTR && !FORBID_ATTR[lcName] && regExpTest(DATA_ATTR, lcName)) ;
                else if (ALLOW_ARIA_ATTR && regExpTest(ARIA_ATTR, lcName)) ;
                else if (!ALLOWED_ATTR[lcName] || FORBID_ATTR[lcName]) {
                    if (!(_isBasicCustomElement(lcTag) && (CUSTOM_ELEMENT_HANDLING.tagNameCheck instanceof RegExp && regExpTest(CUSTOM_ELEMENT_HANDLING.tagNameCheck, lcTag) || CUSTOM_ELEMENT_HANDLING.tagNameCheck instanceof Function && CUSTOM_ELEMENT_HANDLING.tagNameCheck(lcTag)) && (CUSTOM_ELEMENT_HANDLING.attributeNameCheck instanceof RegExp && regExpTest(CUSTOM_ELEMENT_HANDLING.attributeNameCheck, lcName) || CUSTOM_ELEMENT_HANDLING.attributeNameCheck instanceof Function && CUSTOM_ELEMENT_HANDLING.attributeNameCheck(lcName)) || 'is' === lcName && CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements && (CUSTOM_ELEMENT_HANDLING.tagNameCheck instanceof RegExp && regExpTest(CUSTOM_ELEMENT_HANDLING.tagNameCheck, value) || CUSTOM_ELEMENT_HANDLING.tagNameCheck instanceof Function && CUSTOM_ELEMENT_HANDLING.tagNameCheck(value)))) return false;
                } else if (URI_SAFE_ATTRIBUTES[lcName]) ;
                else if (regExpTest(IS_ALLOWED_URI$1, stringReplace(value, ATTR_WHITESPACE, ''))) ;
                else if (('src' === lcName || 'xlink:href' === lcName || 'href' === lcName) && "script" !== lcTag && 0 === stringIndexOf(value, 'data:') && DATA_URI_TAGS[lcTag]) ;
                else if (ALLOW_UNKNOWN_PROTOCOLS && !regExpTest(IS_SCRIPT_OR_DATA, stringReplace(value, ATTR_WHITESPACE, ''))) ;
                else if (value) return false;
                return true;
            };
            const _isBasicCustomElement = function(tagName) {
                return 'annotation-xml' !== tagName && stringMatch(tagName, CUSTOM_ELEMENT);
            };
            const _sanitizeAttributes = function(currentNode) {
                _executeHooks(hooks.beforeSanitizeAttributes, currentNode, null);
                const { attributes } = currentNode;
                if (!attributes || _isClobbered(currentNode)) return;
                const hookEvent = {
                    attrName: '',
                    attrValue: '',
                    keepAttr: true,
                    allowedAttributes: ALLOWED_ATTR,
                    forceKeepAttr: void 0
                };
                let l = attributes.length;
                while(l--){
                    const attr = attributes[l];
                    const { name, namespaceURI, value: attrValue } = attr;
                    const lcName = transformCaseFunc(name);
                    let value = 'value' === name ? attrValue : stringTrim(attrValue);
                    hookEvent.attrName = lcName;
                    hookEvent.attrValue = value;
                    hookEvent.keepAttr = true;
                    hookEvent.forceKeepAttr = void 0;
                    _executeHooks(hooks.uponSanitizeAttribute, currentNode, hookEvent);
                    value = hookEvent.attrValue;
                    if (SANITIZE_NAMED_PROPS && ('id' === lcName || 'name' === lcName)) {
                        _removeAttribute(name, currentNode);
                        value = SANITIZE_NAMED_PROPS_PREFIX + value;
                    }
                    if (SAFE_FOR_XML && regExpTest(/((--!?|])>)|<\/(style|title)/i, value)) {
                        _removeAttribute(name, currentNode);
                        continue;
                    }
                    if (hookEvent.forceKeepAttr) continue;
                    _removeAttribute(name, currentNode);
                    if (!hookEvent.keepAttr) continue;
                    if (!ALLOW_SELF_CLOSE_IN_ATTR && regExpTest(/\/>/i, value)) {
                        _removeAttribute(name, currentNode);
                        continue;
                    }
                    if (SAFE_FOR_TEMPLATES) arrayForEach([
                        MUSTACHE_EXPR,
                        ERB_EXPR,
                        TMPLIT_EXPR
                    ], (expr)=>{
                        value = stringReplace(value, expr, ' ');
                    });
                    const lcTag = transformCaseFunc(currentNode.nodeName);
                    if (!_isValidAttribute(lcTag, lcName, value)) continue;
                    if (trustedTypesPolicy && 'object' == typeof trustedTypes && 'function' == typeof trustedTypes.getAttributeType) {
                        if (namespaceURI) ;
                        else switch(trustedTypes.getAttributeType(lcTag, lcName)){
                            case 'TrustedHTML':
                                value = trustedTypesPolicy.createHTML(value);
                                break;
                            case 'TrustedScriptURL':
                                value = trustedTypesPolicy.createScriptURL(value);
                                break;
                        }
                    }
                    try {
                        if (namespaceURI) currentNode.setAttributeNS(namespaceURI, name, value);
                        else currentNode.setAttribute(name, value);
                        if (_isClobbered(currentNode)) _forceRemove(currentNode);
                        else arrayPop(DOMPurify.removed);
                    } catch (_) {}
                }
                _executeHooks(hooks.afterSanitizeAttributes, currentNode, null);
            };
            const _sanitizeShadowDOM = function _sanitizeShadowDOM(fragment) {
                let shadowNode = null;
                const shadowIterator = _createNodeIterator(fragment);
                _executeHooks(hooks.beforeSanitizeShadowDOM, fragment, null);
                while(shadowNode = shadowIterator.nextNode()){
                    _executeHooks(hooks.uponSanitizeShadowNode, shadowNode, null);
                    _sanitizeElements(shadowNode);
                    _sanitizeAttributes(shadowNode);
                    if (shadowNode.content instanceof DocumentFragment) _sanitizeShadowDOM(shadowNode.content);
                }
                _executeHooks(hooks.afterSanitizeShadowDOM, fragment, null);
            };
            DOMPurify.sanitize = function(dirty) {
                let cfg = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : {};
                let body = null;
                let importedNode = null;
                let currentNode = null;
                let returnNode = null;
                IS_EMPTY_INPUT = !dirty;
                if (IS_EMPTY_INPUT) dirty = '<!-->';
                if ('string' != typeof dirty && !_isNode(dirty)) {
                    if ('function' == typeof dirty.toString) {
                        dirty = dirty.toString();
                        if ('string' != typeof dirty) throw typeErrorCreate('dirty is not a string, aborting');
                    } else throw typeErrorCreate('toString is not a function');
                }
                if (!DOMPurify.isSupported) return dirty;
                if (!SET_CONFIG) _parseConfig(cfg);
                DOMPurify.removed = [];
                if ('string' == typeof dirty) IN_PLACE = false;
                if (IN_PLACE) {
                    if (dirty.nodeName) {
                        const tagName = transformCaseFunc(dirty.nodeName);
                        if (!ALLOWED_TAGS[tagName] || FORBID_TAGS[tagName]) throw typeErrorCreate('root node is forbidden and cannot be sanitized in-place');
                    }
                } else if (dirty instanceof Node) {
                    body = _initDocument('<!---->');
                    importedNode = body.ownerDocument.importNode(dirty, true);
                    if (importedNode.nodeType === NODE_TYPE.element && 'BODY' === importedNode.nodeName) body = importedNode;
                    else if ('HTML' === importedNode.nodeName) body = importedNode;
                    else body.appendChild(importedNode);
                } else {
                    if (!RETURN_DOM && !SAFE_FOR_TEMPLATES && !WHOLE_DOCUMENT && -1 === dirty.indexOf('<')) return trustedTypesPolicy && RETURN_TRUSTED_TYPE ? trustedTypesPolicy.createHTML(dirty) : dirty;
                    body = _initDocument(dirty);
                    if (!body) return RETURN_DOM ? null : RETURN_TRUSTED_TYPE ? emptyHTML : '';
                }
                if (body && FORCE_BODY) _forceRemove(body.firstChild);
                const nodeIterator = _createNodeIterator(IN_PLACE ? dirty : body);
                while(currentNode = nodeIterator.nextNode()){
                    _sanitizeElements(currentNode);
                    _sanitizeAttributes(currentNode);
                    if (currentNode.content instanceof DocumentFragment) _sanitizeShadowDOM(currentNode.content);
                }
                if (IN_PLACE) return dirty;
                if (RETURN_DOM) {
                    if (RETURN_DOM_FRAGMENT) {
                        returnNode = createDocumentFragment.call(body.ownerDocument);
                        while(body.firstChild)returnNode.appendChild(body.firstChild);
                    } else returnNode = body;
                    if (ALLOWED_ATTR.shadowroot || ALLOWED_ATTR.shadowrootmode) returnNode = importNode.call(originalDocument, returnNode, true);
                    return returnNode;
                }
                let serializedHTML = WHOLE_DOCUMENT ? body.outerHTML : body.innerHTML;
                if (WHOLE_DOCUMENT && ALLOWED_TAGS['!doctype'] && body.ownerDocument && body.ownerDocument.doctype && body.ownerDocument.doctype.name && regExpTest(DOCTYPE_NAME, body.ownerDocument.doctype.name)) serializedHTML = '<!DOCTYPE ' + body.ownerDocument.doctype.name + '>\n' + serializedHTML;
                if (SAFE_FOR_TEMPLATES) arrayForEach([
                    MUSTACHE_EXPR,
                    ERB_EXPR,
                    TMPLIT_EXPR
                ], (expr)=>{
                    serializedHTML = stringReplace(serializedHTML, expr, ' ');
                });
                return trustedTypesPolicy && RETURN_TRUSTED_TYPE ? trustedTypesPolicy.createHTML(serializedHTML) : serializedHTML;
            };
            DOMPurify.setConfig = function() {
                let cfg = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {};
                _parseConfig(cfg);
                SET_CONFIG = true;
            };
            DOMPurify.clearConfig = function() {
                CONFIG = null;
                SET_CONFIG = false;
            };
            DOMPurify.isValidAttribute = function(tag, attr, value) {
                if (!CONFIG) _parseConfig({});
                const lcTag = transformCaseFunc(tag);
                const lcName = transformCaseFunc(attr);
                return _isValidAttribute(lcTag, lcName, value);
            };
            DOMPurify.addHook = function(entryPoint, hookFunction) {
                if ('function' != typeof hookFunction) return;
                arrayPush(hooks[entryPoint], hookFunction);
            };
            DOMPurify.removeHook = function(entryPoint, hookFunction) {
                if (void 0 !== hookFunction) {
                    const index = arrayLastIndexOf(hooks[entryPoint], hookFunction);
                    return -1 === index ? void 0 : arraySplice(hooks[entryPoint], index, 1)[0];
                }
                return arrayPop(hooks[entryPoint]);
            };
            DOMPurify.removeHooks = function(entryPoint) {
                hooks[entryPoint] = [];
            };
            DOMPurify.removeAllHooks = function() {
                hooks = _createHooksMap();
            };
            return DOMPurify;
        }
        var purify = createDOMPurify();
    },
    "./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/channels/reusable.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>reusable
        });
        var utils = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/utils/index.js");
        var constants = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/constants.js");
        class Type {
            constructor(){
                this.type = constants.w.ALL;
            }
            get() {
                return this.type;
            }
            set(type) {
                if (this.type && this.type !== type) throw new Error('Cannot change both RGB and HSL channels at the same time');
                this.type = type;
            }
            reset() {
                this.type = constants.w.ALL;
            }
            is(type) {
                return this.type === type;
            }
        }
        const channels_type = Type;
        class Channels {
            constructor(data, color){
                this.color = color;
                this.changed = false;
                this.data = data;
                this.type = new channels_type();
            }
            set(data, color) {
                this.color = color;
                this.changed = false;
                this.data = data;
                this.type.type = constants.w.ALL;
                return this;
            }
            _ensureHSL() {
                const data = this.data;
                const { h, s, l } = data;
                if (void 0 === h) data.h = utils.Z.channel.rgb2hsl(data, 'h');
                if (void 0 === s) data.s = utils.Z.channel.rgb2hsl(data, 's');
                if (void 0 === l) data.l = utils.Z.channel.rgb2hsl(data, 'l');
            }
            _ensureRGB() {
                const data = this.data;
                const { r, g, b } = data;
                if (void 0 === r) data.r = utils.Z.channel.hsl2rgb(data, 'r');
                if (void 0 === g) data.g = utils.Z.channel.hsl2rgb(data, 'g');
                if (void 0 === b) data.b = utils.Z.channel.hsl2rgb(data, 'b');
            }
            get r() {
                const data = this.data;
                const r = data.r;
                if (!this.type.is(constants.w.HSL) && void 0 !== r) return r;
                this._ensureHSL();
                return utils.Z.channel.hsl2rgb(data, 'r');
            }
            get g() {
                const data = this.data;
                const g = data.g;
                if (!this.type.is(constants.w.HSL) && void 0 !== g) return g;
                this._ensureHSL();
                return utils.Z.channel.hsl2rgb(data, 'g');
            }
            get b() {
                const data = this.data;
                const b = data.b;
                if (!this.type.is(constants.w.HSL) && void 0 !== b) return b;
                this._ensureHSL();
                return utils.Z.channel.hsl2rgb(data, 'b');
            }
            get h() {
                const data = this.data;
                const h = data.h;
                if (!this.type.is(constants.w.RGB) && void 0 !== h) return h;
                this._ensureRGB();
                return utils.Z.channel.rgb2hsl(data, 'h');
            }
            get s() {
                const data = this.data;
                const s = data.s;
                if (!this.type.is(constants.w.RGB) && void 0 !== s) return s;
                this._ensureRGB();
                return utils.Z.channel.rgb2hsl(data, 's');
            }
            get l() {
                const data = this.data;
                const l = data.l;
                if (!this.type.is(constants.w.RGB) && void 0 !== l) return l;
                this._ensureRGB();
                return utils.Z.channel.rgb2hsl(data, 'l');
            }
            get a() {
                return this.data.a;
            }
            set r(r) {
                this.type.set(constants.w.RGB);
                this.changed = true;
                this.data.r = r;
            }
            set g(g) {
                this.type.set(constants.w.RGB);
                this.changed = true;
                this.data.g = g;
            }
            set b(b) {
                this.type.set(constants.w.RGB);
                this.changed = true;
                this.data.b = b;
            }
            set h(h) {
                this.type.set(constants.w.HSL);
                this.changed = true;
                this.data.h = h;
            }
            set s(s) {
                this.type.set(constants.w.HSL);
                this.changed = true;
                this.data.s = s;
            }
            set l(l) {
                this.type.set(constants.w.HSL);
                this.changed = true;
                this.data.l = l;
            }
            set a(a) {
                this.changed = true;
                this.data.a = a;
            }
        }
        const channels = Channels;
        const reusable_channels = new channels({
            r: 0,
            g: 0,
            b: 0,
            a: 0
        }, 'transparent');
        const reusable = reusable_channels;
    },
    "./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/color/index.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>dist_color
        });
        var reusable = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/channels/reusable.js");
        var constants = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/constants.js");
        const Hex = {
            re: /^#((?:[a-f0-9]{2}){2,4}|[a-f0-9]{3})$/i,
            parse: (color)=>{
                if (35 !== color.charCodeAt(0)) return;
                const match = color.match(Hex.re);
                if (!match) return;
                const hex = match[1];
                const dec = parseInt(hex, 16);
                const length = hex.length;
                const hasAlpha = length % 4 === 0;
                const isFullLength = length > 4;
                const multiplier = isFullLength ? 1 : 17;
                const bits = isFullLength ? 8 : 4;
                const bitsOffset = hasAlpha ? 0 : -1;
                const mask = isFullLength ? 255 : 15;
                return reusable.Z.set({
                    r: (dec >> bits * (bitsOffset + 3) & mask) * multiplier,
                    g: (dec >> bits * (bitsOffset + 2) & mask) * multiplier,
                    b: (dec >> bits * (bitsOffset + 1) & mask) * multiplier,
                    a: hasAlpha ? (dec & mask) * multiplier / 255 : 1
                }, color);
            },
            stringify: (channels)=>{
                const { r, g, b, a } = channels;
                if (a < 1) return `#${constants.Q[Math.round(r)]}${constants.Q[Math.round(g)]}${constants.Q[Math.round(b)]}${constants.Q[Math.round(255 * a)]}`;
                return `#${constants.Q[Math.round(r)]}${constants.Q[Math.round(g)]}${constants.Q[Math.round(b)]}`;
            }
        };
        const color_hex = Hex;
        var utils = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/utils/index.js");
        const HSL = {
            re: /^hsla?\(\s*?(-?(?:\d+(?:\.\d+)?|(?:\.\d+))(?:e-?\d+)?(?:deg|grad|rad|turn)?)\s*?(?:,|\s)\s*?(-?(?:\d+(?:\.\d+)?|(?:\.\d+))(?:e-?\d+)?%)\s*?(?:,|\s)\s*?(-?(?:\d+(?:\.\d+)?|(?:\.\d+))(?:e-?\d+)?%)(?:\s*?(?:,|\/)\s*?\+?(-?(?:\d+(?:\.\d+)?|(?:\.\d+))(?:e-?\d+)?(%)?))?\s*?\)$/i,
            hueRe: /^(.+?)(deg|grad|rad|turn)$/i,
            _hue2deg: (hue)=>{
                const match = hue.match(HSL.hueRe);
                if (match) {
                    const [, number, unit] = match;
                    switch(unit){
                        case 'grad':
                            return utils.Z.channel.clamp.h(.9 * parseFloat(number));
                        case 'rad':
                            return utils.Z.channel.clamp.h(180 * parseFloat(number) / Math.PI);
                        case 'turn':
                            return utils.Z.channel.clamp.h(360 * parseFloat(number));
                    }
                }
                return utils.Z.channel.clamp.h(parseFloat(hue));
            },
            parse: (color)=>{
                const charCode = color.charCodeAt(0);
                if (104 !== charCode && 72 !== charCode) return;
                const match = color.match(HSL.re);
                if (!match) return;
                const [, h, s, l, a, isAlphaPercentage] = match;
                return reusable.Z.set({
                    h: HSL._hue2deg(h),
                    s: utils.Z.channel.clamp.s(parseFloat(s)),
                    l: utils.Z.channel.clamp.l(parseFloat(l)),
                    a: a ? utils.Z.channel.clamp.a(isAlphaPercentage ? parseFloat(a) / 100 : parseFloat(a)) : 1
                }, color);
            },
            stringify: (channels)=>{
                const { h, s, l, a } = channels;
                if (a < 1) return `hsla(${utils.Z.lang.round(h)}, ${utils.Z.lang.round(s)}%, ${utils.Z.lang.round(l)}%, ${a})`;
                return `hsl(${utils.Z.lang.round(h)}, ${utils.Z.lang.round(s)}%, ${utils.Z.lang.round(l)}%)`;
            }
        };
        const hsl = HSL;
        const Keyword = {
            colors: {
                aliceblue: '#f0f8ff',
                antiquewhite: '#faebd7',
                aqua: '#00ffff',
                aquamarine: '#7fffd4',
                azure: '#f0ffff',
                beige: '#f5f5dc',
                bisque: '#ffe4c4',
                black: '#000000',
                blanchedalmond: '#ffebcd',
                blue: '#0000ff',
                blueviolet: '#8a2be2',
                brown: '#a52a2a',
                burlywood: '#deb887',
                cadetblue: '#5f9ea0',
                chartreuse: '#7fff00',
                chocolate: '#d2691e',
                coral: '#ff7f50',
                cornflowerblue: '#6495ed',
                cornsilk: '#fff8dc',
                crimson: '#dc143c',
                cyanaqua: '#00ffff',
                darkblue: '#00008b',
                darkcyan: '#008b8b',
                darkgoldenrod: '#b8860b',
                darkgray: '#a9a9a9',
                darkgreen: '#006400',
                darkgrey: '#a9a9a9',
                darkkhaki: '#bdb76b',
                darkmagenta: '#8b008b',
                darkolivegreen: '#556b2f',
                darkorange: '#ff8c00',
                darkorchid: '#9932cc',
                darkred: '#8b0000',
                darksalmon: '#e9967a',
                darkseagreen: '#8fbc8f',
                darkslateblue: '#483d8b',
                darkslategray: '#2f4f4f',
                darkslategrey: '#2f4f4f',
                darkturquoise: '#00ced1',
                darkviolet: '#9400d3',
                deeppink: '#ff1493',
                deepskyblue: '#00bfff',
                dimgray: '#696969',
                dimgrey: '#696969',
                dodgerblue: '#1e90ff',
                firebrick: '#b22222',
                floralwhite: '#fffaf0',
                forestgreen: '#228b22',
                fuchsia: '#ff00ff',
                gainsboro: '#dcdcdc',
                ghostwhite: '#f8f8ff',
                gold: '#ffd700',
                goldenrod: '#daa520',
                gray: '#808080',
                green: '#008000',
                greenyellow: '#adff2f',
                grey: '#808080',
                honeydew: '#f0fff0',
                hotpink: '#ff69b4',
                indianred: '#cd5c5c',
                indigo: '#4b0082',
                ivory: '#fffff0',
                khaki: '#f0e68c',
                lavender: '#e6e6fa',
                lavenderblush: '#fff0f5',
                lawngreen: '#7cfc00',
                lemonchiffon: '#fffacd',
                lightblue: '#add8e6',
                lightcoral: '#f08080',
                lightcyan: '#e0ffff',
                lightgoldenrodyellow: '#fafad2',
                lightgray: '#d3d3d3',
                lightgreen: '#90ee90',
                lightgrey: '#d3d3d3',
                lightpink: '#ffb6c1',
                lightsalmon: '#ffa07a',
                lightseagreen: '#20b2aa',
                lightskyblue: '#87cefa',
                lightslategray: '#778899',
                lightslategrey: '#778899',
                lightsteelblue: '#b0c4de',
                lightyellow: '#ffffe0',
                lime: '#00ff00',
                limegreen: '#32cd32',
                linen: '#faf0e6',
                magenta: '#ff00ff',
                maroon: '#800000',
                mediumaquamarine: '#66cdaa',
                mediumblue: '#0000cd',
                mediumorchid: '#ba55d3',
                mediumpurple: '#9370db',
                mediumseagreen: '#3cb371',
                mediumslateblue: '#7b68ee',
                mediumspringgreen: '#00fa9a',
                mediumturquoise: '#48d1cc',
                mediumvioletred: '#c71585',
                midnightblue: '#191970',
                mintcream: '#f5fffa',
                mistyrose: '#ffe4e1',
                moccasin: '#ffe4b5',
                navajowhite: '#ffdead',
                navy: '#000080',
                oldlace: '#fdf5e6',
                olive: '#808000',
                olivedrab: '#6b8e23',
                orange: '#ffa500',
                orangered: '#ff4500',
                orchid: '#da70d6',
                palegoldenrod: '#eee8aa',
                palegreen: '#98fb98',
                paleturquoise: '#afeeee',
                palevioletred: '#db7093',
                papayawhip: '#ffefd5',
                peachpuff: '#ffdab9',
                peru: '#cd853f',
                pink: '#ffc0cb',
                plum: '#dda0dd',
                powderblue: '#b0e0e6',
                purple: '#800080',
                rebeccapurple: '#663399',
                red: '#ff0000',
                rosybrown: '#bc8f8f',
                royalblue: '#4169e1',
                saddlebrown: '#8b4513',
                salmon: '#fa8072',
                sandybrown: '#f4a460',
                seagreen: '#2e8b57',
                seashell: '#fff5ee',
                sienna: '#a0522d',
                silver: '#c0c0c0',
                skyblue: '#87ceeb',
                slateblue: '#6a5acd',
                slategray: '#708090',
                slategrey: '#708090',
                snow: '#fffafa',
                springgreen: '#00ff7f',
                tan: '#d2b48c',
                teal: '#008080',
                thistle: '#d8bfd8',
                transparent: '#00000000',
                turquoise: '#40e0d0',
                violet: '#ee82ee',
                wheat: '#f5deb3',
                white: '#ffffff',
                whitesmoke: '#f5f5f5',
                yellow: '#ffff00',
                yellowgreen: '#9acd32'
            },
            parse: (color)=>{
                color = color.toLowerCase();
                const hex = Keyword.colors[color];
                if (!hex) return;
                return color_hex.parse(hex);
            },
            stringify: (channels)=>{
                const hex = color_hex.stringify(channels);
                for(const name in Keyword.colors)if (Keyword.colors[name] === hex) return name;
            }
        };
        const keyword = Keyword;
        const RGB = {
            re: /^rgba?\(\s*?(-?(?:\d+(?:\.\d+)?|(?:\.\d+))(?:e\d+)?(%?))\s*?(?:,|\s)\s*?(-?(?:\d+(?:\.\d+)?|(?:\.\d+))(?:e\d+)?(%?))\s*?(?:,|\s)\s*?(-?(?:\d+(?:\.\d+)?|(?:\.\d+))(?:e\d+)?(%?))(?:\s*?(?:,|\/)\s*?\+?(-?(?:\d+(?:\.\d+)?|(?:\.\d+))(?:e\d+)?(%?)))?\s*?\)$/i,
            parse: (color)=>{
                const charCode = color.charCodeAt(0);
                if (114 !== charCode && 82 !== charCode) return;
                const match = color.match(RGB.re);
                if (!match) return;
                const [, r, isRedPercentage, g, isGreenPercentage, b, isBluePercentage, a, isAlphaPercentage] = match;
                return reusable.Z.set({
                    r: utils.Z.channel.clamp.r(isRedPercentage ? 2.55 * parseFloat(r) : parseFloat(r)),
                    g: utils.Z.channel.clamp.g(isGreenPercentage ? 2.55 * parseFloat(g) : parseFloat(g)),
                    b: utils.Z.channel.clamp.b(isBluePercentage ? 2.55 * parseFloat(b) : parseFloat(b)),
                    a: a ? utils.Z.channel.clamp.a(isAlphaPercentage ? parseFloat(a) / 100 : parseFloat(a)) : 1
                }, color);
            },
            stringify: (channels)=>{
                const { r, g, b, a } = channels;
                if (a < 1) return `rgba(${utils.Z.lang.round(r)}, ${utils.Z.lang.round(g)}, ${utils.Z.lang.round(b)}, ${utils.Z.lang.round(a)})`;
                return `rgb(${utils.Z.lang.round(r)}, ${utils.Z.lang.round(g)}, ${utils.Z.lang.round(b)})`;
            }
        };
        const rgb = RGB;
        const Color = {
            format: {
                keyword: keyword,
                hex: color_hex,
                rgb: rgb,
                rgba: rgb,
                hsl: hsl,
                hsla: hsl
            },
            parse: (color)=>{
                if ('string' != typeof color) return color;
                const channels = color_hex.parse(color) || rgb.parse(color) || hsl.parse(color) || keyword.parse(color);
                if (channels) return channels;
                throw new Error(`Unsupported color format: "${color}"`);
            },
            stringify: (channels)=>{
                if (!channels.changed && channels.color) return channels.color;
                if (channels.type.is(constants.w.HSL) || void 0 === channels.data.r) return hsl.stringify(channels);
                if (channels.a < 1 || !Number.isInteger(channels.r) || !Number.isInteger(channels.g) || !Number.isInteger(channels.b)) return rgb.stringify(channels);
                return color_hex.stringify(channels);
            }
        };
        const dist_color = Color;
    },
    "./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/constants.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Q: ()=>DEC2HEX,
            w: ()=>TYPE
        });
        var _utils_index_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/utils/index.js");
        const DEC2HEX = {};
        for(let i = 0; i <= 255; i++)DEC2HEX[i] = _utils_index_js__WEBPACK_IMPORTED_MODULE_0__.Z.unit.dec2hex(i);
        const TYPE = {
            ALL: 0,
            RGB: 1,
            HSL: 2
        };
    },
    "./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/methods/adjust_channel.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _utils_index_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/utils/index.js");
        var _color_index_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/color/index.js");
        const adjustChannel = (color, channel, amount)=>{
            const channels = _color_index_js__WEBPACK_IMPORTED_MODULE_0__.Z.parse(color);
            const amountCurrent = channels[channel];
            const amountNext = _utils_index_js__WEBPACK_IMPORTED_MODULE_1__.Z.channel.clamp[channel](amountCurrent + amount);
            if (amountCurrent !== amountNext) channels[channel] = amountNext;
            return _color_index_js__WEBPACK_IMPORTED_MODULE_0__.Z.stringify(channels);
        };
        const __WEBPACK_DEFAULT_EXPORT__ = adjustChannel;
    },
    "./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/methods/change.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _utils_index_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/utils/index.js");
        var _color_index_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/color/index.js");
        const change = (color, channels)=>{
            const ch = _color_index_js__WEBPACK_IMPORTED_MODULE_0__.Z.parse(color);
            for(const c in channels)ch[c] = _utils_index_js__WEBPACK_IMPORTED_MODULE_1__.Z.channel.clamp[c](channels[c]);
            return _color_index_js__WEBPACK_IMPORTED_MODULE_0__.Z.stringify(ch);
        };
        const __WEBPACK_DEFAULT_EXPORT__ = change;
    },
    "./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/methods/darken.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _adjust_channel_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/methods/adjust_channel.js");
        const darken = (color, amount)=>(0, _adjust_channel_js__WEBPACK_IMPORTED_MODULE_0__.Z)(color, 'l', -amount);
        const __WEBPACK_DEFAULT_EXPORT__ = darken;
    },
    "./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/methods/is_dark.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>is_dark
        });
        var utils = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/utils/index.js");
        var dist_color = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/color/index.js");
        const luminance_luminance = (color)=>{
            const { r, g, b } = dist_color.Z.parse(color);
            const luminance = .2126 * utils.Z.channel.toLinear(r) + .7152 * utils.Z.channel.toLinear(g) + .0722 * utils.Z.channel.toLinear(b);
            return utils.Z.lang.round(luminance);
        };
        const methods_luminance = luminance_luminance;
        const isLight = (color)=>methods_luminance(color) >= .5;
        const is_light = isLight;
        const isDark = (color)=>!is_light(color);
        const is_dark = isDark;
    },
    "./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/methods/lighten.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _adjust_channel_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/methods/adjust_channel.js");
        const lighten = (color, amount)=>(0, _adjust_channel_js__WEBPACK_IMPORTED_MODULE_0__.Z)(color, 'l', amount);
        const __WEBPACK_DEFAULT_EXPORT__ = lighten;
    },
    "./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/methods/rgba.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _utils_index_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/utils/index.js");
        var _channels_reusable_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/channels/reusable.js");
        var _color_index_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/color/index.js");
        var _change_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/methods/change.js");
        const rgba = (r, g, b = 0, a = 1)=>{
            if ('number' != typeof r) return (0, _change_js__WEBPACK_IMPORTED_MODULE_0__.Z)(r, {
                a: g
            });
            const channels = _channels_reusable_js__WEBPACK_IMPORTED_MODULE_1__.Z.set({
                r: _utils_index_js__WEBPACK_IMPORTED_MODULE_2__.Z.channel.clamp.r(r),
                g: _utils_index_js__WEBPACK_IMPORTED_MODULE_2__.Z.channel.clamp.g(g),
                b: _utils_index_js__WEBPACK_IMPORTED_MODULE_2__.Z.channel.clamp.b(b),
                a: _utils_index_js__WEBPACK_IMPORTED_MODULE_2__.Z.channel.clamp.a(a)
            });
            return _color_index_js__WEBPACK_IMPORTED_MODULE_3__.Z.stringify(channels);
        };
        const __WEBPACK_DEFAULT_EXPORT__ = rgba;
    },
    "./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/utils/index.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>utils
        });
        const Channel = {
            min: {
                r: 0,
                g: 0,
                b: 0,
                s: 0,
                l: 0,
                a: 0
            },
            max: {
                r: 255,
                g: 255,
                b: 255,
                h: 360,
                s: 100,
                l: 100,
                a: 1
            },
            clamp: {
                r: (r)=>r >= 255 ? 255 : r < 0 ? 0 : r,
                g: (g)=>g >= 255 ? 255 : g < 0 ? 0 : g,
                b: (b)=>b >= 255 ? 255 : b < 0 ? 0 : b,
                h: (h)=>h % 360,
                s: (s)=>s >= 100 ? 100 : s < 0 ? 0 : s,
                l: (l)=>l >= 100 ? 100 : l < 0 ? 0 : l,
                a: (a)=>a >= 1 ? 1 : a < 0 ? 0 : a
            },
            toLinear: (c)=>{
                const n = c / 255;
                return c > .03928 ? Math.pow((n + .055) / 1.055, 2.4) : n / 12.92;
            },
            hue2rgb: (p, q, t)=>{
                if (t < 0) t += 1;
                if (t > 1) t -= 1;
                if (t < 1 / 6) return p + (q - p) * 6 * t;
                if (t < 0.5) return q;
                if (t < 2 / 3) return p + (q - p) * (2 / 3 - t) * 6;
                return p;
            },
            hsl2rgb: ({ h, s, l }, channel)=>{
                if (!s) return 2.55 * l;
                h /= 360;
                s /= 100;
                l /= 100;
                const q = l < .5 ? l * (1 + s) : l + s - l * s;
                const p = 2 * l - q;
                switch(channel){
                    case 'r':
                        return 255 * Channel.hue2rgb(p, q, h + 1 / 3);
                    case 'g':
                        return 255 * Channel.hue2rgb(p, q, h);
                    case 'b':
                        return 255 * Channel.hue2rgb(p, q, h - 1 / 3);
                }
            },
            rgb2hsl: ({ r, g, b }, channel)=>{
                r /= 255;
                g /= 255;
                b /= 255;
                const max = Math.max(r, g, b);
                const min = Math.min(r, g, b);
                const l = (max + min) / 2;
                if ('l' === channel) return 100 * l;
                if (max === min) return 0;
                const d = max - min;
                const s = l > .5 ? d / (2 - max - min) : d / (max + min);
                if ('s' === channel) return 100 * s;
                switch(max){
                    case r:
                        return ((g - b) / d + (g < b ? 6 : 0)) * 60;
                    case g:
                        return ((b - r) / d + 2) * 60;
                    case b:
                        return ((r - g) / d + 4) * 60;
                    default:
                        return -1;
                }
            }
        };
        const utils_channel = Channel;
        const Lang = {
            clamp: (number, lower, upper)=>{
                if (lower > upper) return Math.min(lower, Math.max(upper, number));
                return Math.min(upper, Math.max(lower, number));
            },
            round: (number)=>Math.round(10000000000 * number) / 10000000000
        };
        const lang = Lang;
        const Unit = {
            dec2hex: (dec)=>{
                const hex = Math.round(dec).toString(16);
                return hex.length > 1 ? hex : `0${hex}`;
            }
        };
        const unit = Unit;
        const Utils = {
            channel: utils_channel,
            lang: lang,
            unit: unit
        };
        const utils = Utils;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_ListCache.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>_ListCache
        });
        function listCacheClear() {
            this.__data__ = [];
            this.size = 0;
        }
        const _listCacheClear = listCacheClear;
        var eq = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/eq.js");
        function assocIndexOf(array, key) {
            var length = array.length;
            while(length--)if ((0, eq.Z)(array[length][0], key)) return length;
            return -1;
        }
        const _assocIndexOf = assocIndexOf;
        var arrayProto = Array.prototype;
        var splice = arrayProto.splice;
        function listCacheDelete(key) {
            var data = this.__data__, index = _assocIndexOf(data, key);
            if (index < 0) return false;
            var lastIndex = data.length - 1;
            if (index == lastIndex) data.pop();
            else splice.call(data, index, 1);
            --this.size;
            return true;
        }
        const _listCacheDelete = listCacheDelete;
        function listCacheGet(key) {
            var data = this.__data__, index = _assocIndexOf(data, key);
            return index < 0 ? void 0 : data[index][1];
        }
        const _listCacheGet = listCacheGet;
        function listCacheHas(key) {
            return _assocIndexOf(this.__data__, key) > -1;
        }
        const _listCacheHas = listCacheHas;
        function listCacheSet(key, value) {
            var data = this.__data__, index = _assocIndexOf(data, key);
            if (index < 0) {
                ++this.size;
                data.push([
                    key,
                    value
                ]);
            } else data[index][1] = value;
            return this;
        }
        const _listCacheSet = listCacheSet;
        function ListCache(entries) {
            var index = -1, length = null == entries ? 0 : entries.length;
            this.clear();
            while(++index < length){
                var entry = entries[index];
                this.set(entry[0], entry[1]);
            }
        }
        ListCache.prototype.clear = _listCacheClear;
        ListCache.prototype['delete'] = _listCacheDelete;
        ListCache.prototype.get = _listCacheGet;
        ListCache.prototype.has = _listCacheHas;
        ListCache.prototype.set = _listCacheSet;
        const _ListCache = ListCache;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Map.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _getNative_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getNative.js");
        var _root_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_root.js");
        var Map1 = (0, _getNative_js__WEBPACK_IMPORTED_MODULE_0__.Z)(_root_js__WEBPACK_IMPORTED_MODULE_1__.Z, 'Map');
        const __WEBPACK_DEFAULT_EXPORT__ = Map1;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_MapCache.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>_MapCache
        });
        var _getNative = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getNative.js");
        var nativeCreate = (0, _getNative.Z)(Object, 'create');
        const _nativeCreate = nativeCreate;
        function hashClear() {
            this.__data__ = _nativeCreate ? _nativeCreate(null) : {};
            this.size = 0;
        }
        const _hashClear = hashClear;
        function hashDelete(key) {
            var result = this.has(key) && delete this.__data__[key];
            this.size -= result ? 1 : 0;
            return result;
        }
        const _hashDelete = hashDelete;
        var HASH_UNDEFINED = '__lodash_hash_undefined__';
        var objectProto = Object.prototype;
        var _hashGet_hasOwnProperty = objectProto.hasOwnProperty;
        function hashGet(key) {
            var data = this.__data__;
            if (_nativeCreate) {
                var result = data[key];
                return result === HASH_UNDEFINED ? void 0 : result;
            }
            return _hashGet_hasOwnProperty.call(data, key) ? data[key] : void 0;
        }
        const _hashGet = hashGet;
        var _hashHas_objectProto = Object.prototype;
        var _hashHas_hasOwnProperty = _hashHas_objectProto.hasOwnProperty;
        function hashHas(key) {
            var data = this.__data__;
            return _nativeCreate ? void 0 !== data[key] : _hashHas_hasOwnProperty.call(data, key);
        }
        const _hashHas = hashHas;
        var _hashSet_HASH_UNDEFINED = '__lodash_hash_undefined__';
        function hashSet(key, value) {
            var data = this.__data__;
            this.size += this.has(key) ? 0 : 1;
            data[key] = _nativeCreate && void 0 === value ? _hashSet_HASH_UNDEFINED : value;
            return this;
        }
        const _hashSet = hashSet;
        function Hash(entries) {
            var index = -1, length = null == entries ? 0 : entries.length;
            this.clear();
            while(++index < length){
                var entry = entries[index];
                this.set(entry[0], entry[1]);
            }
        }
        Hash.prototype.clear = _hashClear;
        Hash.prototype['delete'] = _hashDelete;
        Hash.prototype.get = _hashGet;
        Hash.prototype.has = _hashHas;
        Hash.prototype.set = _hashSet;
        const _Hash = Hash;
        var _ListCache = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_ListCache.js");
        var _Map = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Map.js");
        function mapCacheClear() {
            this.size = 0;
            this.__data__ = {
                hash: new _Hash,
                map: new (_Map.Z || _ListCache.Z),
                string: new _Hash
            };
        }
        const _mapCacheClear = mapCacheClear;
        function isKeyable(value) {
            var type = typeof value;
            return 'string' == type || 'number' == type || 'symbol' == type || 'boolean' == type ? '__proto__' !== value : null === value;
        }
        const _isKeyable = isKeyable;
        function getMapData(map, key) {
            var data = map.__data__;
            return _isKeyable(key) ? data['string' == typeof key ? 'string' : 'hash'] : data.map;
        }
        const _getMapData = getMapData;
        function mapCacheDelete(key) {
            var result = _getMapData(this, key)['delete'](key);
            this.size -= result ? 1 : 0;
            return result;
        }
        const _mapCacheDelete = mapCacheDelete;
        function mapCacheGet(key) {
            return _getMapData(this, key).get(key);
        }
        const _mapCacheGet = mapCacheGet;
        function mapCacheHas(key) {
            return _getMapData(this, key).has(key);
        }
        const _mapCacheHas = mapCacheHas;
        function mapCacheSet(key, value) {
            var data = _getMapData(this, key), size = data.size;
            data.set(key, value);
            this.size += data.size == size ? 0 : 1;
            return this;
        }
        const _mapCacheSet = mapCacheSet;
        function MapCache(entries) {
            var index = -1, length = null == entries ? 0 : entries.length;
            this.clear();
            while(++index < length){
                var entry = entries[index];
                this.set(entry[0], entry[1]);
            }
        }
        MapCache.prototype.clear = _mapCacheClear;
        MapCache.prototype['delete'] = _mapCacheDelete;
        MapCache.prototype.get = _mapCacheGet;
        MapCache.prototype.has = _mapCacheHas;
        MapCache.prototype.set = _mapCacheSet;
        const _MapCache = MapCache;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Set.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _getNative_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getNative.js");
        var _root_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_root.js");
        var Set1 = (0, _getNative_js__WEBPACK_IMPORTED_MODULE_0__.Z)(_root_js__WEBPACK_IMPORTED_MODULE_1__.Z, 'Set');
        const __WEBPACK_DEFAULT_EXPORT__ = Set1;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Stack.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>_Stack
        });
        var _ListCache = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_ListCache.js");
        function stackClear() {
            this.__data__ = new _ListCache.Z;
            this.size = 0;
        }
        const _stackClear = stackClear;
        function stackDelete(key) {
            var data = this.__data__, result = data['delete'](key);
            this.size = data.size;
            return result;
        }
        const _stackDelete = stackDelete;
        function stackGet(key) {
            return this.__data__.get(key);
        }
        const _stackGet = stackGet;
        function stackHas(key) {
            return this.__data__.has(key);
        }
        const _stackHas = stackHas;
        var _Map = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Map.js");
        var _MapCache = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_MapCache.js");
        var LARGE_ARRAY_SIZE = 200;
        function stackSet(key, value) {
            var data = this.__data__;
            if (data instanceof _ListCache.Z) {
                var pairs = data.__data__;
                if (!_Map.Z || pairs.length < LARGE_ARRAY_SIZE - 1) {
                    pairs.push([
                        key,
                        value
                    ]);
                    this.size = ++data.size;
                    return this;
                }
                data = this.__data__ = new _MapCache.Z(pairs);
            }
            data.set(key, value);
            this.size = data.size;
            return this;
        }
        const _stackSet = stackSet;
        function Stack(entries) {
            var data = this.__data__ = new _ListCache.Z(entries);
            this.size = data.size;
        }
        Stack.prototype.clear = _stackClear;
        Stack.prototype['delete'] = _stackDelete;
        Stack.prototype.get = _stackGet;
        Stack.prototype.has = _stackHas;
        Stack.prototype.set = _stackSet;
        const _Stack = Stack;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Symbol.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _root_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_root.js");
        var Symbol1 = _root_js__WEBPACK_IMPORTED_MODULE_0__.Z.Symbol;
        const __WEBPACK_DEFAULT_EXPORT__ = Symbol1;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Uint8Array.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _root_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_root.js");
        var Uint8Array1 = _root_js__WEBPACK_IMPORTED_MODULE_0__.Z.Uint8Array;
        const __WEBPACK_DEFAULT_EXPORT__ = Uint8Array1;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayLikeKeys.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>_arrayLikeKeys
        });
        function baseTimes(n, iteratee) {
            var index = -1, result = Array(n);
            while(++index < n)result[index] = iteratee(index);
            return result;
        }
        const _baseTimes = baseTimes;
        var isArguments = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArguments.js");
        var isArray = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArray.js");
        var isBuffer = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isBuffer.js");
        var _isIndex = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isIndex.js");
        var isTypedArray = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isTypedArray.js");
        var objectProto = Object.prototype;
        var _arrayLikeKeys_hasOwnProperty = objectProto.hasOwnProperty;
        function arrayLikeKeys(value, inherited) {
            var isArr = (0, isArray.Z)(value), isArg = !isArr && (0, isArguments.Z)(value), isBuff = !isArr && !isArg && (0, isBuffer.Z)(value), isType = !isArr && !isArg && !isBuff && (0, isTypedArray.Z)(value), skipIndexes = isArr || isArg || isBuff || isType, result = skipIndexes ? _baseTimes(value.length, String) : [], length = result.length;
            for(var key in value)if ((inherited || _arrayLikeKeys_hasOwnProperty.call(value, key)) && !(skipIndexes && ('length' == key || isBuff && ('offset' == key || 'parent' == key) || isType && ('buffer' == key || 'byteLength' == key || 'byteOffset' == key) || (0, _isIndex.Z)(key, length)))) result.push(key);
            return result;
        }
        const _arrayLikeKeys = arrayLikeKeys;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_assignValue.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _baseAssignValue_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseAssignValue.js");
        var _eq_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/eq.js");
        var objectProto = Object.prototype;
        var hasOwnProperty = objectProto.hasOwnProperty;
        function assignValue(object, key, value) {
            var objValue = object[key];
            if (!(hasOwnProperty.call(object, key) && (0, _eq_js__WEBPACK_IMPORTED_MODULE_0__.Z)(objValue, value)) || void 0 === value && !(key in object)) (0, _baseAssignValue_js__WEBPACK_IMPORTED_MODULE_1__.Z)(object, key, value);
        }
        const __WEBPACK_DEFAULT_EXPORT__ = assignValue;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseAssignValue.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _defineProperty_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_defineProperty.js");
        function baseAssignValue(object, key, value) {
            if ('__proto__' == key && _defineProperty_js__WEBPACK_IMPORTED_MODULE_0__.Z) (0, _defineProperty_js__WEBPACK_IMPORTED_MODULE_0__.Z)(object, key, {
                configurable: true,
                enumerable: true,
                value: value,
                writable: true
            });
            else object[key] = value;
        }
        const __WEBPACK_DEFAULT_EXPORT__ = baseAssignValue;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseFor.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>_baseFor
        });
        function createBaseFor(fromRight) {
            return function(object, iteratee, keysFunc) {
                var index = -1, iterable = Object(object), props = keysFunc(object), length = props.length;
                while(length--){
                    var key = props[fromRight ? length : ++index];
                    if (false === iteratee(iterable[key], key, iterable)) break;
                }
                return object;
            };
        }
        const _createBaseFor = createBaseFor;
        var baseFor = _createBaseFor();
        const _baseFor = baseFor;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseGetTag.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>_baseGetTag
        });
        var _Symbol = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Symbol.js");
        var objectProto = Object.prototype;
        var _getRawTag_hasOwnProperty = objectProto.hasOwnProperty;
        var nativeObjectToString = objectProto.toString;
        var symToStringTag = _Symbol.Z ? _Symbol.Z.toStringTag : void 0;
        function getRawTag(value) {
            var isOwn = _getRawTag_hasOwnProperty.call(value, symToStringTag), tag = value[symToStringTag];
            try {
                value[symToStringTag] = void 0;
                var unmasked = true;
            } catch (e) {}
            var result = nativeObjectToString.call(value);
            if (unmasked) {
                if (isOwn) value[symToStringTag] = tag;
                else delete value[symToStringTag];
            }
            return result;
        }
        const _getRawTag = getRawTag;
        var _objectToString_objectProto = Object.prototype;
        var _objectToString_nativeObjectToString = _objectToString_objectProto.toString;
        function objectToString(value) {
            return _objectToString_nativeObjectToString.call(value);
        }
        const _objectToString = objectToString;
        var nullTag = '[object Null]', undefinedTag = '[object Undefined]';
        var _baseGetTag_symToStringTag = _Symbol.Z ? _Symbol.Z.toStringTag : void 0;
        function baseGetTag(value) {
            if (null == value) return void 0 === value ? undefinedTag : nullTag;
            return _baseGetTag_symToStringTag && _baseGetTag_symToStringTag in Object(value) ? _getRawTag(value) : _objectToString(value);
        }
        const _baseGetTag = baseGetTag;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseKeys.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>_baseKeys
        });
        var _isPrototype = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isPrototype.js");
        var _overArg = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_overArg.js");
        var nativeKeys = (0, _overArg.Z)(Object.keys, Object);
        const _nativeKeys = nativeKeys;
        var objectProto = Object.prototype;
        var _baseKeys_hasOwnProperty = objectProto.hasOwnProperty;
        function baseKeys(object) {
            if (!(0, _isPrototype.Z)(object)) return _nativeKeys(object);
            var result = [];
            for(var key in Object(object))if (_baseKeys_hasOwnProperty.call(object, key) && 'constructor' != key) result.push(key);
            return result;
        }
        const _baseKeys = baseKeys;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseRest.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _identity_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/identity.js");
        var _overRest_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_overRest.js");
        var _setToString_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_setToString.js");
        function baseRest(func, start) {
            return (0, _setToString_js__WEBPACK_IMPORTED_MODULE_0__.Z)((0, _overRest_js__WEBPACK_IMPORTED_MODULE_1__.Z)(func, start, _identity_js__WEBPACK_IMPORTED_MODULE_2__.Z), func + '');
        }
        const __WEBPACK_DEFAULT_EXPORT__ = baseRest;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseUnary.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        function baseUnary(func) {
            return function(value) {
                return func(value);
            };
        }
        const __WEBPACK_DEFAULT_EXPORT__ = baseUnary;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_cloneArrayBuffer.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _Uint8Array_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Uint8Array.js");
        function cloneArrayBuffer(arrayBuffer) {
            var result = new arrayBuffer.constructor(arrayBuffer.byteLength);
            new _Uint8Array_js__WEBPACK_IMPORTED_MODULE_0__.Z(result).set(new _Uint8Array_js__WEBPACK_IMPORTED_MODULE_0__.Z(arrayBuffer));
            return result;
        }
        const __WEBPACK_DEFAULT_EXPORT__ = cloneArrayBuffer;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_cloneBuffer.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _root_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_root.js");
        var freeExports = 'object' == typeof exports && exports && !exports.nodeType && exports;
        var freeModule = freeExports && 'object' == typeof module && module && !module.nodeType && module;
        var moduleExports = freeModule && freeModule.exports === freeExports;
        var Buffer = moduleExports ? _root_js__WEBPACK_IMPORTED_MODULE_0__.Z.Buffer : void 0, allocUnsafe = Buffer ? Buffer.allocUnsafe : void 0;
        function cloneBuffer(buffer, isDeep) {
            if (isDeep) return buffer.slice();
            var length = buffer.length, result = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);
            buffer.copy(result);
            return result;
        }
        const __WEBPACK_DEFAULT_EXPORT__ = cloneBuffer;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_cloneTypedArray.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _cloneArrayBuffer_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_cloneArrayBuffer.js");
        function cloneTypedArray(typedArray, isDeep) {
            var buffer = isDeep ? (0, _cloneArrayBuffer_js__WEBPACK_IMPORTED_MODULE_0__.Z)(typedArray.buffer) : typedArray.buffer;
            return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
        }
        const __WEBPACK_DEFAULT_EXPORT__ = cloneTypedArray;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_copyArray.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        function copyArray(source, array) {
            var index = -1, length = source.length;
            array || (array = Array(length));
            while(++index < length)array[index] = source[index];
            return array;
        }
        const __WEBPACK_DEFAULT_EXPORT__ = copyArray;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_copyObject.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _assignValue_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_assignValue.js");
        var _baseAssignValue_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseAssignValue.js");
        function copyObject(source, props, object, customizer) {
            var isNew = !object;
            object || (object = {});
            var index = -1, length = props.length;
            while(++index < length){
                var key = props[index];
                var newValue = customizer ? customizer(object[key], source[key], key, object, source) : void 0;
                if (void 0 === newValue) newValue = source[key];
                if (isNew) (0, _baseAssignValue_js__WEBPACK_IMPORTED_MODULE_0__.Z)(object, key, newValue);
                else (0, _assignValue_js__WEBPACK_IMPORTED_MODULE_1__.Z)(object, key, newValue);
            }
            return object;
        }
        const __WEBPACK_DEFAULT_EXPORT__ = copyObject;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createAssigner.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _baseRest_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseRest.js");
        var _isIterateeCall_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isIterateeCall.js");
        function createAssigner(assigner) {
            return (0, _baseRest_js__WEBPACK_IMPORTED_MODULE_0__.Z)(function(object, sources) {
                var index = -1, length = sources.length, customizer = length > 1 ? sources[length - 1] : void 0, guard = length > 2 ? sources[2] : void 0;
                customizer = assigner.length > 3 && 'function' == typeof customizer ? (length--, customizer) : void 0;
                if (guard && (0, _isIterateeCall_js__WEBPACK_IMPORTED_MODULE_1__.Z)(sources[0], sources[1], guard)) {
                    customizer = length < 3 ? void 0 : customizer;
                    length = 1;
                }
                object = Object(object);
                while(++index < length){
                    var source = sources[index];
                    if (source) assigner(object, source, index, customizer);
                }
                return object;
            });
        }
        const __WEBPACK_DEFAULT_EXPORT__ = createAssigner;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_defineProperty.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _getNative_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getNative.js");
        var defineProperty = function() {
            try {
                var func = (0, _getNative_js__WEBPACK_IMPORTED_MODULE_0__.Z)(Object, 'defineProperty');
                func({}, '', {});
                return func;
            } catch (e) {}
        }();
        const __WEBPACK_DEFAULT_EXPORT__ = defineProperty;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_freeGlobal.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var freeGlobal = 'object' == typeof global && global && global.Object === Object && global;
        const __WEBPACK_DEFAULT_EXPORT__ = freeGlobal;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getNative.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>_getNative
        });
        var isFunction = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isFunction.js");
        var _root = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_root.js");
        var coreJsData = _root.Z["__core-js_shared__"];
        const _coreJsData = coreJsData;
        var maskSrcKey = function() {
            var uid = /[^.]+$/.exec(_coreJsData && _coreJsData.keys && _coreJsData.keys.IE_PROTO || '');
            return uid ? 'Symbol(src)_1.' + uid : '';
        }();
        function isMasked(func) {
            return !!maskSrcKey && maskSrcKey in func;
        }
        const _isMasked = isMasked;
        var isObject = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isObject.js");
        var _toSource = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_toSource.js");
        var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;
        var reIsHostCtor = /^\[object .+?Constructor\]$/;
        var funcProto = Function.prototype, objectProto = Object.prototype;
        var funcToString = funcProto.toString;
        var _baseIsNative_hasOwnProperty = objectProto.hasOwnProperty;
        var reIsNative = RegExp('^' + funcToString.call(_baseIsNative_hasOwnProperty).replace(reRegExpChar, '\\$&').replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$');
        function baseIsNative(value) {
            if (!(0, isObject.Z)(value) || _isMasked(value)) return false;
            var pattern = (0, isFunction.Z)(value) ? reIsNative : reIsHostCtor;
            return pattern.test((0, _toSource.Z)(value));
        }
        const _baseIsNative = baseIsNative;
        function getValue(object, key) {
            return null == object ? void 0 : object[key];
        }
        const _getValue = getValue;
        function getNative(object, key) {
            var value = _getValue(object, key);
            return _baseIsNative(value) ? value : void 0;
        }
        const _getNative = getNative;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getPrototype.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _overArg_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_overArg.js");
        var getPrototype = (0, _overArg_js__WEBPACK_IMPORTED_MODULE_0__.Z)(Object.getPrototypeOf, Object);
        const __WEBPACK_DEFAULT_EXPORT__ = getPrototype;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getTag.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>_getTag
        });
        var _getNative = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getNative.js");
        var _root = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_root.js");
        var DataView1 = (0, _getNative.Z)(_root.Z, 'DataView');
        const _DataView = DataView1;
        var _Map = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Map.js");
        var Promise1 = (0, _getNative.Z)(_root.Z, 'Promise');
        const _Promise = Promise1;
        var _Set = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Set.js");
        var WeakMap = (0, _getNative.Z)(_root.Z, 'WeakMap');
        const _WeakMap = WeakMap;
        var _baseGetTag = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseGetTag.js");
        var _toSource = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_toSource.js");
        var mapTag = '[object Map]', objectTag = '[object Object]', promiseTag = '[object Promise]', setTag = '[object Set]', weakMapTag = '[object WeakMap]';
        var dataViewTag = '[object DataView]';
        var dataViewCtorString = (0, _toSource.Z)(_DataView), mapCtorString = (0, _toSource.Z)(_Map.Z), promiseCtorString = (0, _toSource.Z)(_Promise), setCtorString = (0, _toSource.Z)(_Set.Z), weakMapCtorString = (0, _toSource.Z)(_WeakMap);
        var getTag = _baseGetTag.Z;
        if (_DataView && getTag(new _DataView(new ArrayBuffer(1))) != dataViewTag || _Map.Z && getTag(new _Map.Z) != mapTag || _Promise && getTag(_Promise.resolve()) != promiseTag || _Set.Z && getTag(new _Set.Z) != setTag || _WeakMap && getTag(new _WeakMap) != weakMapTag) getTag = function(value) {
            var result = (0, _baseGetTag.Z)(value), Ctor = result == objectTag ? value.constructor : void 0, ctorString = Ctor ? (0, _toSource.Z)(Ctor) : '';
            if (ctorString) switch(ctorString){
                case dataViewCtorString:
                    return dataViewTag;
                case mapCtorString:
                    return mapTag;
                case promiseCtorString:
                    return promiseTag;
                case setCtorString:
                    return setTag;
                case weakMapCtorString:
                    return weakMapTag;
            }
            return result;
        };
        const _getTag = getTag;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_initCloneObject.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>_initCloneObject
        });
        var isObject = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isObject.js");
        var objectCreate = Object.create;
        var baseCreate = function() {
            function object() {}
            return function(proto) {
                if (!(0, isObject.Z)(proto)) return {};
                if (objectCreate) return objectCreate(proto);
                object.prototype = proto;
                var result = new object;
                object.prototype = void 0;
                return result;
            };
        }();
        const _baseCreate = baseCreate;
        var _getPrototype = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getPrototype.js");
        var _isPrototype = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isPrototype.js");
        function initCloneObject(object) {
            return 'function' != typeof object.constructor || (0, _isPrototype.Z)(object) ? {} : _baseCreate((0, _getPrototype.Z)(object));
        }
        const _initCloneObject = initCloneObject;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isIndex.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var MAX_SAFE_INTEGER = 9007199254740991;
        var reIsUint = /^(?:0|[1-9]\d*)$/;
        function isIndex(value, length) {
            var type = typeof value;
            length = null == length ? MAX_SAFE_INTEGER : length;
            return !!length && ('number' == type || 'symbol' != type && reIsUint.test(value)) && value > -1 && value % 1 == 0 && value < length;
        }
        const __WEBPACK_DEFAULT_EXPORT__ = isIndex;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isIterateeCall.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _eq_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/eq.js");
        var _isArrayLike_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArrayLike.js");
        var _isIndex_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isIndex.js");
        var _isObject_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isObject.js");
        function isIterateeCall(value, index, object) {
            if (!(0, _isObject_js__WEBPACK_IMPORTED_MODULE_0__.Z)(object)) return false;
            var type = typeof index;
            if ('number' == type ? (0, _isArrayLike_js__WEBPACK_IMPORTED_MODULE_1__.Z)(object) && (0, _isIndex_js__WEBPACK_IMPORTED_MODULE_2__.Z)(index, object.length) : 'string' == type && index in object) return (0, _eq_js__WEBPACK_IMPORTED_MODULE_3__.Z)(object[index], value);
            return false;
        }
        const __WEBPACK_DEFAULT_EXPORT__ = isIterateeCall;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isPrototype.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var objectProto = Object.prototype;
        function isPrototype(value) {
            var Ctor = value && value.constructor, proto = 'function' == typeof Ctor && Ctor.prototype || objectProto;
            return value === proto;
        }
        const __WEBPACK_DEFAULT_EXPORT__ = isPrototype;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_nodeUtil.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _freeGlobal_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_freeGlobal.js");
        var freeExports = 'object' == typeof exports && exports && !exports.nodeType && exports;
        var freeModule = freeExports && 'object' == typeof module && module && !module.nodeType && module;
        var moduleExports = freeModule && freeModule.exports === freeExports;
        var freeProcess = moduleExports && _freeGlobal_js__WEBPACK_IMPORTED_MODULE_0__.Z.process;
        var nodeUtil = function() {
            try {
                var types = freeModule && freeModule.require && freeModule.require('util').types;
                if (types) return types;
                return freeProcess && freeProcess.binding && freeProcess.binding('util');
            } catch (e) {}
        }();
        const __WEBPACK_DEFAULT_EXPORT__ = nodeUtil;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_overArg.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        function overArg(func, transform) {
            return function(arg) {
                return func(transform(arg));
            };
        }
        const __WEBPACK_DEFAULT_EXPORT__ = overArg;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_overRest.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>_overRest
        });
        function apply(func, thisArg, args) {
            switch(args.length){
                case 0:
                    return func.call(thisArg);
                case 1:
                    return func.call(thisArg, args[0]);
                case 2:
                    return func.call(thisArg, args[0], args[1]);
                case 3:
                    return func.call(thisArg, args[0], args[1], args[2]);
            }
            return func.apply(thisArg, args);
        }
        const _apply = apply;
        var nativeMax = Math.max;
        function overRest(func, start, transform) {
            start = nativeMax(void 0 === start ? func.length - 1 : start, 0);
            return function() {
                var args = arguments, index = -1, length = nativeMax(args.length - start, 0), array = Array(length);
                while(++index < length)array[index] = args[start + index];
                index = -1;
                var otherArgs = Array(start + 1);
                while(++index < start)otherArgs[index] = args[index];
                otherArgs[start] = transform(array);
                return _apply(func, this, otherArgs);
            };
        }
        const _overRest = overRest;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_root.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _freeGlobal_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_freeGlobal.js");
        var freeSelf = 'object' == typeof self && self && self.Object === Object && self;
        var root = _freeGlobal_js__WEBPACK_IMPORTED_MODULE_0__.Z || freeSelf || Function('return this')();
        const __WEBPACK_DEFAULT_EXPORT__ = root;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_setToString.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>_setToString
        });
        var constant = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/constant.js");
        var _defineProperty = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_defineProperty.js");
        var identity = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/identity.js");
        var baseSetToString = _defineProperty.Z ? function(func, string) {
            return (0, _defineProperty.Z)(func, 'toString', {
                configurable: true,
                enumerable: false,
                value: (0, constant.Z)(string),
                writable: true
            });
        } : identity.Z;
        const _baseSetToString = baseSetToString;
        var HOT_COUNT = 800, HOT_SPAN = 16;
        var nativeNow = Date.now;
        function shortOut(func) {
            var count = 0, lastCalled = 0;
            return function() {
                var stamp = nativeNow(), remaining = HOT_SPAN - (stamp - lastCalled);
                lastCalled = stamp;
                if (remaining > 0) {
                    if (++count >= HOT_COUNT) return arguments[0];
                } else count = 0;
                return func.apply(void 0, arguments);
            };
        }
        const _shortOut = shortOut;
        var setToString = _shortOut(_baseSetToString);
        const _setToString = setToString;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_toSource.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var funcProto = Function.prototype;
        var funcToString = funcProto.toString;
        function toSource(func) {
            if (null != func) {
                try {
                    return funcToString.call(func);
                } catch (e) {}
                try {
                    return func + '';
                } catch (e) {}
            }
            return '';
        }
        const __WEBPACK_DEFAULT_EXPORT__ = toSource;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/constant.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        function constant(value) {
            return function() {
                return value;
            };
        }
        const __WEBPACK_DEFAULT_EXPORT__ = constant;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/eq.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        function eq(value, other) {
            return value === other || value !== value && other !== other;
        }
        const __WEBPACK_DEFAULT_EXPORT__ = eq;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/identity.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        function identity(value) {
            return value;
        }
        const __WEBPACK_DEFAULT_EXPORT__ = identity;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArguments.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>lodash_es_isArguments
        });
        var _baseGetTag = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseGetTag.js");
        var isObjectLike = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isObjectLike.js");
        var argsTag = '[object Arguments]';
        function baseIsArguments(value) {
            return (0, isObjectLike.Z)(value) && (0, _baseGetTag.Z)(value) == argsTag;
        }
        const _baseIsArguments = baseIsArguments;
        var objectProto = Object.prototype;
        var isArguments_hasOwnProperty = objectProto.hasOwnProperty;
        var propertyIsEnumerable = objectProto.propertyIsEnumerable;
        var isArguments = _baseIsArguments(function() {
            return arguments;
        }()) ? _baseIsArguments : function(value) {
            return (0, isObjectLike.Z)(value) && isArguments_hasOwnProperty.call(value, 'callee') && !propertyIsEnumerable.call(value, 'callee');
        };
        const lodash_es_isArguments = isArguments;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArray.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var isArray = Array.isArray;
        const __WEBPACK_DEFAULT_EXPORT__ = isArray;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArrayLike.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _isFunction_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isFunction.js");
        var _isLength_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isLength.js");
        function isArrayLike(value) {
            return null != value && (0, _isLength_js__WEBPACK_IMPORTED_MODULE_0__.Z)(value.length) && !(0, _isFunction_js__WEBPACK_IMPORTED_MODULE_1__.Z)(value);
        }
        const __WEBPACK_DEFAULT_EXPORT__ = isArrayLike;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArrayLikeObject.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _isArrayLike_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArrayLike.js");
        var _isObjectLike_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isObjectLike.js");
        function isArrayLikeObject(value) {
            return (0, _isObjectLike_js__WEBPACK_IMPORTED_MODULE_0__.Z)(value) && (0, _isArrayLike_js__WEBPACK_IMPORTED_MODULE_1__.Z)(value);
        }
        const __WEBPACK_DEFAULT_EXPORT__ = isArrayLikeObject;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isBuffer.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>lodash_es_isBuffer
        });
        var _root = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_root.js");
        function stubFalse_stubFalse() {
            return false;
        }
        const stubFalse = stubFalse_stubFalse;
        var freeExports = 'object' == typeof exports && exports && !exports.nodeType && exports;
        var freeModule = freeExports && 'object' == typeof module && module && !module.nodeType && module;
        var moduleExports = freeModule && freeModule.exports === freeExports;
        var Buffer = moduleExports ? _root.Z.Buffer : void 0;
        var nativeIsBuffer = Buffer ? Buffer.isBuffer : void 0;
        var isBuffer = nativeIsBuffer || stubFalse;
        const lodash_es_isBuffer = isBuffer;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isEmpty.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _baseKeys_js__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseKeys.js");
        var _getTag_js__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getTag.js");
        var _isArguments_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArguments.js");
        var _isArray_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArray.js");
        var _isArrayLike_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArrayLike.js");
        var _isBuffer_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isBuffer.js");
        var _isPrototype_js__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isPrototype.js");
        var _isTypedArray_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isTypedArray.js");
        var mapTag = '[object Map]', setTag = '[object Set]';
        var objectProto = Object.prototype;
        var hasOwnProperty = objectProto.hasOwnProperty;
        function isEmpty(value) {
            if (null == value) return true;
            if ((0, _isArrayLike_js__WEBPACK_IMPORTED_MODULE_0__.Z)(value) && ((0, _isArray_js__WEBPACK_IMPORTED_MODULE_1__.Z)(value) || 'string' == typeof value || 'function' == typeof value.splice || (0, _isBuffer_js__WEBPACK_IMPORTED_MODULE_2__.Z)(value) || (0, _isTypedArray_js__WEBPACK_IMPORTED_MODULE_3__.Z)(value) || (0, _isArguments_js__WEBPACK_IMPORTED_MODULE_4__.Z)(value))) return !value.length;
            var tag = (0, _getTag_js__WEBPACK_IMPORTED_MODULE_5__.Z)(value);
            if (tag == mapTag || tag == setTag) return !value.size;
            if ((0, _isPrototype_js__WEBPACK_IMPORTED_MODULE_6__.Z)(value)) return !(0, _baseKeys_js__WEBPACK_IMPORTED_MODULE_7__.Z)(value).length;
            for(var key in value)if (hasOwnProperty.call(value, key)) return false;
            return true;
        }
        const __WEBPACK_DEFAULT_EXPORT__ = isEmpty;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isFunction.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _baseGetTag_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseGetTag.js");
        var _isObject_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isObject.js");
        var asyncTag = '[object AsyncFunction]', funcTag = '[object Function]', genTag = '[object GeneratorFunction]', proxyTag = '[object Proxy]';
        function isFunction(value) {
            if (!(0, _isObject_js__WEBPACK_IMPORTED_MODULE_0__.Z)(value)) return false;
            var tag = (0, _baseGetTag_js__WEBPACK_IMPORTED_MODULE_1__.Z)(value);
            return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
        }
        const __WEBPACK_DEFAULT_EXPORT__ = isFunction;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isLength.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var MAX_SAFE_INTEGER = 9007199254740991;
        function isLength(value) {
            return 'number' == typeof value && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
        }
        const __WEBPACK_DEFAULT_EXPORT__ = isLength;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isObject.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        function isObject(value) {
            var type = typeof value;
            return null != value && ('object' == type || 'function' == type);
        }
        const __WEBPACK_DEFAULT_EXPORT__ = isObject;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isObjectLike.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        function isObjectLike(value) {
            return null != value && 'object' == typeof value;
        }
        const __WEBPACK_DEFAULT_EXPORT__ = isObjectLike;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isTypedArray.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>isTypedArray
        });
        var _baseGetTag = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseGetTag.js");
        var isLength = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isLength.js");
        var isObjectLike = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isObjectLike.js");
        var argsTag = '[object Arguments]', arrayTag = '[object Array]', boolTag = '[object Boolean]', dateTag = '[object Date]', errorTag = '[object Error]', funcTag = '[object Function]', mapTag = '[object Map]', numberTag = '[object Number]', objectTag = '[object Object]', regexpTag = '[object RegExp]', setTag = '[object Set]', stringTag = '[object String]', weakMapTag = '[object WeakMap]';
        var arrayBufferTag = '[object ArrayBuffer]', dataViewTag = '[object DataView]', float32Tag = '[object Float32Array]', float64Tag = '[object Float64Array]', int8Tag = '[object Int8Array]', int16Tag = '[object Int16Array]', int32Tag = '[object Int32Array]', uint8Tag = '[object Uint8Array]', uint8ClampedTag = '[object Uint8ClampedArray]', uint16Tag = '[object Uint16Array]', uint32Tag = '[object Uint32Array]';
        var typedArrayTags = {};
        typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = true;
        typedArrayTags[argsTag] = typedArrayTags[arrayTag] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag] = typedArrayTags[mapTag] = typedArrayTags[numberTag] = typedArrayTags[objectTag] = typedArrayTags[regexpTag] = typedArrayTags[setTag] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = false;
        function baseIsTypedArray(value) {
            return (0, isObjectLike.Z)(value) && (0, isLength.Z)(value.length) && !!typedArrayTags[(0, _baseGetTag.Z)(value)];
        }
        const _baseIsTypedArray = baseIsTypedArray;
        var _baseUnary = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseUnary.js");
        var _nodeUtil = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_nodeUtil.js");
        var nodeIsTypedArray = _nodeUtil.Z && _nodeUtil.Z.isTypedArray;
        var isTypedArray_isTypedArray = nodeIsTypedArray ? (0, _baseUnary.Z)(nodeIsTypedArray) : _baseIsTypedArray;
        const isTypedArray = isTypedArray_isTypedArray;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/keysIn.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>lodash_es_keysIn
        });
        var _arrayLikeKeys = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayLikeKeys.js");
        var isObject = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isObject.js");
        var _isPrototype = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isPrototype.js");
        function nativeKeysIn(object) {
            var result = [];
            if (null != object) for(var key in Object(object))result.push(key);
            return result;
        }
        const _nativeKeysIn = nativeKeysIn;
        var objectProto = Object.prototype;
        var _baseKeysIn_hasOwnProperty = objectProto.hasOwnProperty;
        function baseKeysIn(object) {
            if (!(0, isObject.Z)(object)) return _nativeKeysIn(object);
            var isProto = (0, _isPrototype.Z)(object), result = [];
            for(var key in object)if (!('constructor' == key && (isProto || !_baseKeysIn_hasOwnProperty.call(object, key)))) result.push(key);
            return result;
        }
        const _baseKeysIn = baseKeysIn;
        var isArrayLike = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArrayLike.js");
        function keysIn(object) {
            return (0, isArrayLike.Z)(object) ? (0, _arrayLikeKeys.Z)(object, true) : _baseKeysIn(object);
        }
        const lodash_es_keysIn = keysIn;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/memoize.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>__WEBPACK_DEFAULT_EXPORT__
        });
        var _MapCache_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_MapCache.js");
        var FUNC_ERROR_TEXT = 'Expected a function';
        function memoize(func, resolver) {
            if ('function' != typeof func || null != resolver && 'function' != typeof resolver) throw new TypeError(FUNC_ERROR_TEXT);
            var memoized = function() {
                var args = arguments, key = resolver ? resolver.apply(this, args) : args[0], cache = memoized.cache;
                if (cache.has(key)) return cache.get(key);
                var result = func.apply(this, args);
                memoized.cache = cache.set(key, result) || cache;
                return result;
            };
            memoized.cache = new (memoize.Cache || _MapCache_js__WEBPACK_IMPORTED_MODULE_0__.Z);
            return memoized;
        }
        memoize.Cache = _MapCache_js__WEBPACK_IMPORTED_MODULE_0__.Z;
        const __WEBPACK_DEFAULT_EXPORT__ = memoize;
    },
    "./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/merge.js": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Z: ()=>merge
        });
        var _Stack = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Stack.js");
        var _baseAssignValue = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseAssignValue.js");
        var eq = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/eq.js");
        function assignMergeValue(object, key, value) {
            if (void 0 !== value && !(0, eq.Z)(object[key], value) || void 0 === value && !(key in object)) (0, _baseAssignValue.Z)(object, key, value);
        }
        const _assignMergeValue = assignMergeValue;
        var _baseFor = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseFor.js");
        var _cloneBuffer = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_cloneBuffer.js");
        var _cloneTypedArray = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_cloneTypedArray.js");
        var _copyArray = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_copyArray.js");
        var _initCloneObject = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_initCloneObject.js");
        var isArguments = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArguments.js");
        var isArray = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArray.js");
        var isArrayLikeObject = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArrayLikeObject.js");
        var isBuffer = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isBuffer.js");
        var isFunction = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isFunction.js");
        var isObject = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isObject.js");
        var _baseGetTag = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseGetTag.js");
        var _getPrototype = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getPrototype.js");
        var isObjectLike = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isObjectLike.js");
        var objectTag = '[object Object]';
        var funcProto = Function.prototype, objectProto = Object.prototype;
        var funcToString = funcProto.toString;
        var isPlainObject_hasOwnProperty = objectProto.hasOwnProperty;
        var objectCtorString = funcToString.call(Object);
        function isPlainObject(value) {
            if (!(0, isObjectLike.Z)(value) || (0, _baseGetTag.Z)(value) != objectTag) return false;
            var proto = (0, _getPrototype.Z)(value);
            if (null === proto) return true;
            var Ctor = isPlainObject_hasOwnProperty.call(proto, 'constructor') && proto.constructor;
            return 'function' == typeof Ctor && Ctor instanceof Ctor && funcToString.call(Ctor) == objectCtorString;
        }
        const lodash_es_isPlainObject = isPlainObject;
        var isTypedArray = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isTypedArray.js");
        function safeGet(object, key) {
            if ('constructor' === key && 'function' == typeof object[key]) return;
            if ('__proto__' == key) return;
            return object[key];
        }
        const _safeGet = safeGet;
        var _copyObject = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_copyObject.js");
        var keysIn = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/keysIn.js");
        function toPlainObject(value) {
            return (0, _copyObject.Z)(value, (0, keysIn.Z)(value));
        }
        const lodash_es_toPlainObject = toPlainObject;
        function baseMergeDeep(object, source, key, srcIndex, mergeFunc, customizer, stack) {
            var objValue = _safeGet(object, key), srcValue = _safeGet(source, key), stacked = stack.get(srcValue);
            if (stacked) {
                _assignMergeValue(object, key, stacked);
                return;
            }
            var newValue = customizer ? customizer(objValue, srcValue, key + '', object, source, stack) : void 0;
            var isCommon = void 0 === newValue;
            if (isCommon) {
                var isArr = (0, isArray.Z)(srcValue), isBuff = !isArr && (0, isBuffer.Z)(srcValue), isTyped = !isArr && !isBuff && (0, isTypedArray.Z)(srcValue);
                newValue = srcValue;
                if (isArr || isBuff || isTyped) {
                    if ((0, isArray.Z)(objValue)) newValue = objValue;
                    else if ((0, isArrayLikeObject.Z)(objValue)) newValue = (0, _copyArray.Z)(objValue);
                    else if (isBuff) {
                        isCommon = false;
                        newValue = (0, _cloneBuffer.Z)(srcValue, true);
                    } else if (isTyped) {
                        isCommon = false;
                        newValue = (0, _cloneTypedArray.Z)(srcValue, true);
                    } else newValue = [];
                } else if (lodash_es_isPlainObject(srcValue) || (0, isArguments.Z)(srcValue)) {
                    newValue = objValue;
                    if ((0, isArguments.Z)(objValue)) newValue = lodash_es_toPlainObject(objValue);
                    else if (!(0, isObject.Z)(objValue) || (0, isFunction.Z)(objValue)) newValue = (0, _initCloneObject.Z)(srcValue);
                } else isCommon = false;
            }
            if (isCommon) {
                stack.set(srcValue, newValue);
                mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
                stack['delete'](srcValue);
            }
            _assignMergeValue(object, key, newValue);
        }
        const _baseMergeDeep = baseMergeDeep;
        function baseMerge(object, source, srcIndex, customizer, stack) {
            if (object === source) return;
            (0, _baseFor.Z)(source, function(srcValue, key) {
                stack || (stack = new _Stack.Z);
                if ((0, isObject.Z)(srcValue)) _baseMergeDeep(object, source, key, srcIndex, baseMerge, customizer, stack);
                else {
                    var newValue = customizer ? customizer(_safeGet(object, key), srcValue, key + '', object, source, stack) : void 0;
                    if (void 0 === newValue) newValue = srcValue;
                    _assignMergeValue(object, key, newValue);
                }
            }, keysIn.Z);
        }
        const _baseMerge = baseMerge;
        var _createAssigner = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createAssigner.js");
        var merge_merge = (0, _createAssigner.Z)(function(object, source, srcIndex) {
            _baseMerge(object, source, srcIndex);
        });
        const merge = merge_merge;
    },
    "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-3JNJP5BE.mjs": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            o: ()=>getLineFunctionsWithOffset
        });
        var _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-6DBFFHIP.mjs");
        var markerOffsets = {
            aggregation: 18,
            extension: 18,
            composition: 18,
            dependency: 6,
            lollipop: 13.5,
            arrow_point: 4
        };
        function calculateDeltaAndAngle(point1, point2) {
            if (void 0 === point1 || void 0 === point2) return {
                angle: 0,
                deltaX: 0,
                deltaY: 0
            };
            point1 = pointTransformer(point1);
            point2 = pointTransformer(point2);
            const [x1, y1] = [
                point1.x,
                point1.y
            ];
            const [x2, y2] = [
                point2.x,
                point2.y
            ];
            const deltaX = x2 - x1;
            const deltaY = y2 - y1;
            return {
                angle: Math.atan(deltaY / deltaX),
                deltaX,
                deltaY
            };
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(calculateDeltaAndAngle, "calculateDeltaAndAngle");
        var pointTransformer = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)((data)=>{
            if (Array.isArray(data)) return {
                x: data[0],
                y: data[1]
            };
            return data;
        }, "pointTransformer");
        var getLineFunctionsWithOffset = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)((edge)=>({
                x: /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(d, i, data) {
                    let offset = 0;
                    const DIRECTION = pointTransformer(data[0]).x < pointTransformer(data[data.length - 1]).x ? "left" : "right";
                    if (0 === i && Object.hasOwn(markerOffsets, edge.arrowTypeStart)) {
                        const { angle, deltaX } = calculateDeltaAndAngle(data[0], data[1]);
                        offset = markerOffsets[edge.arrowTypeStart] * Math.cos(angle) * (deltaX >= 0 ? 1 : -1);
                    } else if (i === data.length - 1 && Object.hasOwn(markerOffsets, edge.arrowTypeEnd)) {
                        const { angle, deltaX } = calculateDeltaAndAngle(data[data.length - 1], data[data.length - 2]);
                        offset = markerOffsets[edge.arrowTypeEnd] * Math.cos(angle) * (deltaX >= 0 ? 1 : -1);
                    }
                    const differenceToEnd = Math.abs(pointTransformer(d).x - pointTransformer(data[data.length - 1]).x);
                    const differenceInYEnd = Math.abs(pointTransformer(d).y - pointTransformer(data[data.length - 1]).y);
                    const differenceToStart = Math.abs(pointTransformer(d).x - pointTransformer(data[0]).x);
                    const differenceInYStart = Math.abs(pointTransformer(d).y - pointTransformer(data[0]).y);
                    const startMarkerHeight = markerOffsets[edge.arrowTypeStart];
                    const endMarkerHeight = markerOffsets[edge.arrowTypeEnd];
                    const extraRoom = 1;
                    if (differenceToEnd < endMarkerHeight && differenceToEnd > 0 && differenceInYEnd < endMarkerHeight) {
                        let adjustment = endMarkerHeight + extraRoom - differenceToEnd;
                        adjustment *= "right" === DIRECTION ? -1 : 1;
                        offset -= adjustment;
                    }
                    if (differenceToStart < startMarkerHeight && differenceToStart > 0 && differenceInYStart < startMarkerHeight) {
                        let adjustment = startMarkerHeight + extraRoom - differenceToStart;
                        adjustment *= "right" === DIRECTION ? -1 : 1;
                        offset += adjustment;
                    }
                    return pointTransformer(d).x + offset;
                }, "x"),
                y: /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(d, i, data) {
                    let offset = 0;
                    const DIRECTION = pointTransformer(data[0]).y < pointTransformer(data[data.length - 1]).y ? "down" : "up";
                    if (0 === i && Object.hasOwn(markerOffsets, edge.arrowTypeStart)) {
                        const { angle, deltaY } = calculateDeltaAndAngle(data[0], data[1]);
                        offset = markerOffsets[edge.arrowTypeStart] * Math.abs(Math.sin(angle)) * (deltaY >= 0 ? 1 : -1);
                    } else if (i === data.length - 1 && Object.hasOwn(markerOffsets, edge.arrowTypeEnd)) {
                        const { angle, deltaY } = calculateDeltaAndAngle(data[data.length - 1], data[data.length - 2]);
                        offset = markerOffsets[edge.arrowTypeEnd] * Math.abs(Math.sin(angle)) * (deltaY >= 0 ? 1 : -1);
                    }
                    const differenceToEnd = Math.abs(pointTransformer(d).y - pointTransformer(data[data.length - 1]).y);
                    const differenceInXEnd = Math.abs(pointTransformer(d).x - pointTransformer(data[data.length - 1]).x);
                    const differenceToStart = Math.abs(pointTransformer(d).y - pointTransformer(data[0]).y);
                    const differenceInXStart = Math.abs(pointTransformer(d).x - pointTransformer(data[0]).x);
                    const startMarkerHeight = markerOffsets[edge.arrowTypeStart];
                    const endMarkerHeight = markerOffsets[edge.arrowTypeEnd];
                    const extraRoom = 1;
                    if (differenceToEnd < endMarkerHeight && differenceToEnd > 0 && differenceInXEnd < endMarkerHeight) {
                        let adjustment = endMarkerHeight + extraRoom - differenceToEnd;
                        adjustment *= "up" === DIRECTION ? -1 : 1;
                        offset -= adjustment;
                    }
                    if (differenceToStart < startMarkerHeight && differenceToStart > 0 && differenceInXStart < startMarkerHeight) {
                        let adjustment = startMarkerHeight + extraRoom - differenceToStart;
                        adjustment *= "up" === DIRECTION ? -1 : 1;
                        offset += adjustment;
                    }
                    return pointTransformer(d).y + offset;
                }, "y")
            }), "getLineFunctionsWithOffset");
    },
    "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-3X56UNUX.mjs": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            L: ()=>getSubGraphTitleMargins
        });
        var _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-6DBFFHIP.mjs");
        var getSubGraphTitleMargins = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(({ flowchart })=>{
            const subGraphTitleTopMargin = flowchart?.subGraphTitleMargin?.top ?? 0;
            const subGraphTitleBottomMargin = flowchart?.subGraphTitleMargin?.bottom ?? 0;
            const subGraphTitleTotalMargin = subGraphTitleTopMargin + subGraphTitleBottomMargin;
            return {
                subGraphTitleTopMargin,
                subGraphTitleBottomMargin,
                subGraphTitleTotalMargin
            };
        }, "getSubGraphTitleMargins");
    },
    "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-66SQ7PYY.mjs": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            DQ: ()=>markers_default,
            I_: ()=>insertEdgeLabel,
            Jj: ()=>positionEdgeLabel,
            QP: ()=>insertEdge,
            ZH: ()=>clear
        });
        var _chunk_7NZE2EM7_mjs__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-7NZE2EM7.mjs");
        var _chunk_3JNJP5BE_mjs__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-3JNJP5BE.mjs");
        var _chunk_3X56UNUX_mjs__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-3X56UNUX.mjs");
        var _chunk_6JOS74DS_mjs__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-6JOS74DS.mjs");
        var _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-7DKRZKHE.mjs");
        var _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-6DBFFHIP.mjs");
        var d3__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__("./node_modules/.pnpm/d3@7.9.0/node_modules/d3/src/index.js");
        var roughjs__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__("./node_modules/.pnpm/roughjs@4.6.6/node_modules/roughjs/bundled/rough.esm.js");
        var addEdgeMarkers = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)((svgPath, edge, url, id, diagramType)=>{
            if (edge.arrowTypeStart) addEdgeMarker(svgPath, "start", edge.arrowTypeStart, url, id, diagramType);
            if (edge.arrowTypeEnd) addEdgeMarker(svgPath, "end", edge.arrowTypeEnd, url, id, diagramType);
        }, "addEdgeMarkers");
        var arrowTypesMap = {
            arrow_cross: "cross",
            arrow_point: "point",
            arrow_barb: "barb",
            arrow_circle: "circle",
            aggregation: "aggregation",
            extension: "extension",
            composition: "composition",
            dependency: "dependency",
            lollipop: "lollipop"
        };
        var addEdgeMarker = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)((svgPath, position, arrowType, url, id, diagramType)=>{
            const endMarkerType = arrowTypesMap[arrowType];
            if (!endMarkerType) {
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.cM.warn(`Unknown arrow type: ${arrowType}`);
                return;
            }
            const suffix = "start" === position ? "Start" : "End";
            svgPath.attr(`marker-${position}`, `url(${url}#${id}_${diagramType}-${endMarkerType}${suffix})`);
        }, "addEdgeMarker");
        var edgeLabels = /* @__PURE__ */ new Map();
        var terminalLabels = /* @__PURE__ */ new Map();
        var clear = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)(()=>{
            edgeLabels.clear();
            terminalLabels.clear();
        }, "clear");
        var getLabelStyles = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)((styleArray)=>{
            let styles = styleArray ? styleArray.reduce((acc, style)=>acc + ";" + style, "") : "";
            return styles;
        }, "getLabelStyles");
        var insertEdgeLabel = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)(async (elem, edge)=>{
            let useHtmlLabels = (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.ku)((0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.nV)().flowchart.htmlLabels);
            const labelElement = await (0, _chunk_6JOS74DS_mjs__WEBPACK_IMPORTED_MODULE_3__.rw)(elem, edge.label, {
                style: getLabelStyles(edge.labelStyle),
                useHtmlLabels,
                addSvgBackground: true,
                isNode: false
            });
            _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.cM.info("abc82", edge, edge.labelType);
            const edgeLabel = elem.insert("g").attr("class", "edgeLabel");
            const label = edgeLabel.insert("g").attr("class", "label");
            label.node().appendChild(labelElement);
            let bbox = labelElement.getBBox();
            if (useHtmlLabels) {
                const div = labelElement.children[0];
                const dv = (0, d3__WEBPACK_IMPORTED_MODULE_6__.Ys)(labelElement);
                bbox = div.getBoundingClientRect();
                dv.attr("width", bbox.width);
                dv.attr("height", bbox.height);
            }
            label.attr("transform", "translate(" + -bbox.width / 2 + ", " + -bbox.height / 2 + ")");
            edgeLabels.set(edge.id, edgeLabel);
            edge.width = bbox.width;
            edge.height = bbox.height;
            let fo;
            if (edge.startLabelLeft) {
                const startLabelElement = await (0, _chunk_7NZE2EM7_mjs__WEBPACK_IMPORTED_MODULE_0__.XO)(edge.startLabelLeft, getLabelStyles(edge.labelStyle));
                const startEdgeLabelLeft = elem.insert("g").attr("class", "edgeTerminals");
                const inner = startEdgeLabelLeft.insert("g").attr("class", "inner");
                fo = inner.node().appendChild(startLabelElement);
                const slBox = startLabelElement.getBBox();
                inner.attr("transform", "translate(" + -slBox.width / 2 + ", " + -slBox.height / 2 + ")");
                if (!terminalLabels.get(edge.id)) terminalLabels.set(edge.id, {});
                terminalLabels.get(edge.id).startLeft = startEdgeLabelLeft;
                setTerminalWidth(fo, edge.startLabelLeft);
            }
            if (edge.startLabelRight) {
                const startLabelElement = await (0, _chunk_7NZE2EM7_mjs__WEBPACK_IMPORTED_MODULE_0__.XO)(edge.startLabelRight, getLabelStyles(edge.labelStyle));
                const startEdgeLabelRight = elem.insert("g").attr("class", "edgeTerminals");
                const inner = startEdgeLabelRight.insert("g").attr("class", "inner");
                fo = startEdgeLabelRight.node().appendChild(startLabelElement);
                inner.node().appendChild(startLabelElement);
                const slBox = startLabelElement.getBBox();
                inner.attr("transform", "translate(" + -slBox.width / 2 + ", " + -slBox.height / 2 + ")");
                if (!terminalLabels.get(edge.id)) terminalLabels.set(edge.id, {});
                terminalLabels.get(edge.id).startRight = startEdgeLabelRight;
                setTerminalWidth(fo, edge.startLabelRight);
            }
            if (edge.endLabelLeft) {
                const endLabelElement = await (0, _chunk_7NZE2EM7_mjs__WEBPACK_IMPORTED_MODULE_0__.XO)(edge.endLabelLeft, getLabelStyles(edge.labelStyle));
                const endEdgeLabelLeft = elem.insert("g").attr("class", "edgeTerminals");
                const inner = endEdgeLabelLeft.insert("g").attr("class", "inner");
                fo = inner.node().appendChild(endLabelElement);
                const slBox = endLabelElement.getBBox();
                inner.attr("transform", "translate(" + -slBox.width / 2 + ", " + -slBox.height / 2 + ")");
                endEdgeLabelLeft.node().appendChild(endLabelElement);
                if (!terminalLabels.get(edge.id)) terminalLabels.set(edge.id, {});
                terminalLabels.get(edge.id).endLeft = endEdgeLabelLeft;
                setTerminalWidth(fo, edge.endLabelLeft);
            }
            if (edge.endLabelRight) {
                const endLabelElement = await (0, _chunk_7NZE2EM7_mjs__WEBPACK_IMPORTED_MODULE_0__.XO)(edge.endLabelRight, getLabelStyles(edge.labelStyle));
                const endEdgeLabelRight = elem.insert("g").attr("class", "edgeTerminals");
                const inner = endEdgeLabelRight.insert("g").attr("class", "inner");
                fo = inner.node().appendChild(endLabelElement);
                const slBox = endLabelElement.getBBox();
                inner.attr("transform", "translate(" + -slBox.width / 2 + ", " + -slBox.height / 2 + ")");
                endEdgeLabelRight.node().appendChild(endLabelElement);
                if (!terminalLabels.get(edge.id)) terminalLabels.set(edge.id, {});
                terminalLabels.get(edge.id).endRight = endEdgeLabelRight;
                setTerminalWidth(fo, edge.endLabelRight);
            }
            return labelElement;
        }, "insertEdgeLabel");
        function setTerminalWidth(fo, value) {
            if ((0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.nV)().flowchart.htmlLabels && fo) {
                fo.style.width = 9 * value.length + "px";
                fo.style.height = "12px";
            }
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)(setTerminalWidth, "setTerminalWidth");
        var positionEdgeLabel = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)((edge, paths)=>{
            _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.cM.debug("Moving label abc88 ", edge.id, edge.label, edgeLabels.get(edge.id), paths);
            let path = paths.updatedPath ? paths.updatedPath : paths.originalPath;
            const siteConfig = (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.nV)();
            const { subGraphTitleTotalMargin } = (0, _chunk_3X56UNUX_mjs__WEBPACK_IMPORTED_MODULE_2__.L)(siteConfig);
            if (edge.label) {
                const el = edgeLabels.get(edge.id);
                let x = edge.x;
                let y = edge.y;
                if (path) {
                    const pos = _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_4__.w8.calcLabelPosition(path);
                    _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.cM.debug("Moving label " + edge.label + " from (", x, ",", y, ") to (", pos.x, ",", pos.y, ") abc88");
                    if (paths.updatedPath) {
                        x = pos.x;
                        y = pos.y;
                    }
                }
                el.attr("transform", `translate(${x}, ${y + subGraphTitleTotalMargin / 2})`);
            }
            if (edge.startLabelLeft) {
                const el = terminalLabels.get(edge.id).startLeft;
                let x = edge.x;
                let y = edge.y;
                if (path) {
                    const pos = _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_4__.w8.calcTerminalLabelPosition(edge.arrowTypeStart ? 10 : 0, "start_left", path);
                    x = pos.x;
                    y = pos.y;
                }
                el.attr("transform", `translate(${x}, ${y})`);
            }
            if (edge.startLabelRight) {
                const el = terminalLabels.get(edge.id).startRight;
                let x = edge.x;
                let y = edge.y;
                if (path) {
                    const pos = _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_4__.w8.calcTerminalLabelPosition(edge.arrowTypeStart ? 10 : 0, "start_right", path);
                    x = pos.x;
                    y = pos.y;
                }
                el.attr("transform", `translate(${x}, ${y})`);
            }
            if (edge.endLabelLeft) {
                const el = terminalLabels.get(edge.id).endLeft;
                let x = edge.x;
                let y = edge.y;
                if (path) {
                    const pos = _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_4__.w8.calcTerminalLabelPosition(edge.arrowTypeEnd ? 10 : 0, "end_left", path);
                    x = pos.x;
                    y = pos.y;
                }
                el.attr("transform", `translate(${x}, ${y})`);
            }
            if (edge.endLabelRight) {
                const el = terminalLabels.get(edge.id).endRight;
                let x = edge.x;
                let y = edge.y;
                if (path) {
                    const pos = _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_4__.w8.calcTerminalLabelPosition(edge.arrowTypeEnd ? 10 : 0, "end_right", path);
                    x = pos.x;
                    y = pos.y;
                }
                el.attr("transform", `translate(${x}, ${y})`);
            }
        }, "positionEdgeLabel");
        var outsideNode = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)((node, point2)=>{
            const x = node.x;
            const y = node.y;
            const dx = Math.abs(point2.x - x);
            const dy = Math.abs(point2.y - y);
            const w = node.width / 2;
            const h = node.height / 2;
            return dx >= w || dy >= h;
        }, "outsideNode");
        var intersection = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)((node, outsidePoint, insidePoint)=>{
            _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.cM.debug(`intersection calc abc89:
  outsidePoint: ${JSON.stringify(outsidePoint)}
  insidePoint : ${JSON.stringify(insidePoint)}
  node        : x:${node.x} y:${node.y} w:${node.width} h:${node.height}`);
            const x = node.x;
            const y = node.y;
            const dx = Math.abs(x - insidePoint.x);
            const w = node.width / 2;
            let r = insidePoint.x < outsidePoint.x ? w - dx : w + dx;
            const h = node.height / 2;
            const Q = Math.abs(outsidePoint.y - insidePoint.y);
            const R = Math.abs(outsidePoint.x - insidePoint.x);
            if (Math.abs(y - outsidePoint.y) * w > Math.abs(x - outsidePoint.x) * h) {
                let q = insidePoint.y < outsidePoint.y ? outsidePoint.y - h - y : y - h - outsidePoint.y;
                r = R * q / Q;
                const res = {
                    x: insidePoint.x < outsidePoint.x ? insidePoint.x + r : insidePoint.x - R + r,
                    y: insidePoint.y < outsidePoint.y ? insidePoint.y + Q - q : insidePoint.y - Q + q
                };
                if (0 === r) {
                    res.x = outsidePoint.x;
                    res.y = outsidePoint.y;
                }
                if (0 === R) res.x = outsidePoint.x;
                if (0 === Q) res.y = outsidePoint.y;
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.cM.debug(`abc89 top/bottom calc, Q ${Q}, q ${q}, R ${R}, r ${r}`, res);
                return res;
            }
            {
                r = insidePoint.x < outsidePoint.x ? outsidePoint.x - w - x : x - w - outsidePoint.x;
                let q = Q * r / R;
                let _x = insidePoint.x < outsidePoint.x ? insidePoint.x + R - r : insidePoint.x - R + r;
                let _y = insidePoint.y < outsidePoint.y ? insidePoint.y + q : insidePoint.y - q;
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.cM.debug(`sides calc abc89, Q ${Q}, q ${q}, R ${R}, r ${r}`, {
                    _x,
                    _y
                });
                if (0 === r) {
                    _x = outsidePoint.x;
                    _y = outsidePoint.y;
                }
                if (0 === R) _x = outsidePoint.x;
                if (0 === Q) _y = outsidePoint.y;
                return {
                    x: _x,
                    y: _y
                };
            }
        }, "intersection");
        var cutPathAtIntersect = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)((_points, boundaryNode)=>{
            _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.cM.warn("abc88 cutPathAtIntersect", _points, boundaryNode);
            let points = [];
            let lastPointOutside = _points[0];
            let isInside = false;
            _points.forEach((point2)=>{
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.cM.info("abc88 checking point", point2, boundaryNode);
                if (outsideNode(boundaryNode, point2) || isInside) {
                    _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.cM.warn("abc88 outside", point2, lastPointOutside);
                    lastPointOutside = point2;
                    if (!isInside) points.push(point2);
                } else {
                    const inter = intersection(boundaryNode, lastPointOutside, point2);
                    _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.cM.debug("abc88 inside", point2, lastPointOutside, inter);
                    _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.cM.debug("abc88 intersection", inter, boundaryNode);
                    let pointPresent = false;
                    points.forEach((p)=>{
                        pointPresent = pointPresent || p.x === inter.x && p.y === inter.y;
                    });
                    if (points.some((e)=>e.x === inter.x && e.y === inter.y)) _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.cM.warn("abc88 no intersect", inter, points);
                    else points.push(inter);
                    isInside = true;
                }
            });
            _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.cM.debug("returning points", points);
            return points;
        }, "cutPathAtIntersect");
        function extractCornerPoints(points) {
            const cornerPoints = [];
            const cornerPointPositions = [];
            for(let i = 1; i < points.length - 1; i++){
                const prev = points[i - 1];
                const curr = points[i];
                const next = points[i + 1];
                if (prev.x === curr.x && curr.y === next.y && Math.abs(curr.x - next.x) > 5 && Math.abs(curr.y - prev.y) > 5) {
                    cornerPoints.push(curr);
                    cornerPointPositions.push(i);
                } else if (prev.y === curr.y && curr.x === next.x && Math.abs(curr.x - prev.x) > 5 && Math.abs(curr.y - next.y) > 5) {
                    cornerPoints.push(curr);
                    cornerPointPositions.push(i);
                }
            }
            return {
                cornerPoints,
                cornerPointPositions
            };
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)(extractCornerPoints, "extractCornerPoints");
        var findAdjacentPoint = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)(function(pointA, pointB, distance) {
            const xDiff = pointB.x - pointA.x;
            const yDiff = pointB.y - pointA.y;
            const length = Math.sqrt(xDiff * xDiff + yDiff * yDiff);
            const ratio = distance / length;
            return {
                x: pointB.x - ratio * xDiff,
                y: pointB.y - ratio * yDiff
            };
        }, "findAdjacentPoint");
        var fixCorners = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)(function(lineData) {
            const { cornerPointPositions } = extractCornerPoints(lineData);
            const newLineData = [];
            for(let i = 0; i < lineData.length; i++)if (cornerPointPositions.includes(i)) {
                const prevPoint = lineData[i - 1];
                const nextPoint = lineData[i + 1];
                const cornerPoint = lineData[i];
                const newPrevPoint = findAdjacentPoint(prevPoint, cornerPoint, 5);
                const newNextPoint = findAdjacentPoint(nextPoint, cornerPoint, 5);
                const xDiff = newNextPoint.x - newPrevPoint.x;
                const yDiff = newNextPoint.y - newPrevPoint.y;
                newLineData.push(newPrevPoint);
                const a = 2 * Math.sqrt(2);
                let newCornerPoint = {
                    x: cornerPoint.x,
                    y: cornerPoint.y
                };
                if (Math.abs(nextPoint.x - prevPoint.x) > 10 && Math.abs(nextPoint.y - prevPoint.y) >= 10) {
                    _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.cM.debug("Corner point fixing", Math.abs(nextPoint.x - prevPoint.x), Math.abs(nextPoint.y - prevPoint.y));
                    const r = 5;
                    newCornerPoint = cornerPoint.x === newPrevPoint.x ? {
                        x: xDiff < 0 ? newPrevPoint.x - r + a : newPrevPoint.x + r - a,
                        y: yDiff < 0 ? newPrevPoint.y - a : newPrevPoint.y + a
                    } : {
                        x: xDiff < 0 ? newPrevPoint.x - a : newPrevPoint.x + a,
                        y: yDiff < 0 ? newPrevPoint.y - r + a : newPrevPoint.y + r - a
                    };
                } else _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.cM.debug("Corner point skipping fixing", Math.abs(nextPoint.x - prevPoint.x), Math.abs(nextPoint.y - prevPoint.y));
                newLineData.push(newCornerPoint, newNextPoint);
            } else newLineData.push(lineData[i]);
            return newLineData;
        }, "fixCorners");
        var insertEdge = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)(function(elem, edge, clusterDb, diagramType, startNode, endNode, id) {
            const { handDrawnSeed } = (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.nV)();
            let points = edge.points;
            let pointsHasChanged = false;
            const tail = startNode;
            var head = endNode;
            if (head.intersect && tail.intersect) {
                points = points.slice(1, edge.points.length - 1);
                points.unshift(tail.intersect(points[0]));
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.cM.debug("Last point APA12", edge.start, "-->", edge.end, points[points.length - 1], head, head.intersect(points[points.length - 1]));
                points.push(head.intersect(points[points.length - 1]));
            }
            if (edge.toCluster) {
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.cM.info("to cluster abc88", clusterDb.get(edge.toCluster));
                points = cutPathAtIntersect(edge.points, clusterDb.get(edge.toCluster).node);
                pointsHasChanged = true;
            }
            if (edge.fromCluster) {
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.cM.debug("from cluster abc88", clusterDb.get(edge.fromCluster), JSON.stringify(points, null, 2));
                points = cutPathAtIntersect(points.reverse(), clusterDb.get(edge.fromCluster).node).reverse();
                pointsHasChanged = true;
            }
            let lineData = points.filter((p)=>!Number.isNaN(p.y));
            lineData = fixCorners(lineData);
            let curve = d3__WEBPACK_IMPORTED_MODULE_6__.$0Z;
            if (edge.curve) curve = edge.curve;
            const { x, y } = (0, _chunk_3JNJP5BE_mjs__WEBPACK_IMPORTED_MODULE_1__.o)(edge);
            const lineFunction = (0, d3__WEBPACK_IMPORTED_MODULE_6__.jvg)().x(x).y(y).curve(curve);
            let strokeClasses;
            switch(edge.thickness){
                case "normal":
                    strokeClasses = "edge-thickness-normal";
                    break;
                case "thick":
                    strokeClasses = "edge-thickness-thick";
                    break;
                case "invisible":
                    strokeClasses = "edge-thickness-invisible";
                    break;
                default:
                    strokeClasses = "edge-thickness-normal";
            }
            switch(edge.pattern){
                case "solid":
                    strokeClasses += " edge-pattern-solid";
                    break;
                case "dotted":
                    strokeClasses += " edge-pattern-dotted";
                    break;
                case "dashed":
                    strokeClasses += " edge-pattern-dashed";
                    break;
                default:
                    strokeClasses += " edge-pattern-solid";
            }
            let svgPath;
            let linePath = lineFunction(lineData);
            const edgeStyles = Array.isArray(edge.style) ? edge.style : [
                edge.style
            ];
            if ("handDrawn" === edge.look) {
                const rc = roughjs__WEBPACK_IMPORTED_MODULE_7__.Z.svg(elem);
                Object.assign([], lineData);
                const svgPathNode = rc.path(linePath, {
                    roughness: 0.3,
                    seed: handDrawnSeed
                });
                strokeClasses += " transition";
                svgPath = (0, d3__WEBPACK_IMPORTED_MODULE_6__.Ys)(svgPathNode).select("path").attr("id", edge.id).attr("class", " " + strokeClasses + (edge.classes ? " " + edge.classes : "")).attr("style", edgeStyles ? edgeStyles.reduce((acc, style)=>acc + ";" + style, "") : "");
                let d = svgPath.attr("d");
                svgPath.attr("d", d);
                elem.node().appendChild(svgPath.node());
            } else svgPath = elem.append("path").attr("d", linePath).attr("id", edge.id).attr("class", " " + strokeClasses + (edge.classes ? " " + edge.classes : "")).attr("style", edgeStyles ? edgeStyles.reduce((acc, style)=>acc + ";" + style, "") : "");
            let url = "";
            if ((0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.nV)().flowchart.arrowMarkerAbsolute || (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.nV)().state.arrowMarkerAbsolute) {
                url = window.location.protocol + "//" + window.location.host + window.location.pathname + window.location.search;
                url = url.replace(/\(/g, "\\(").replace(/\)/g, "\\)");
            }
            _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.cM.info("arrowTypeStart", edge.arrowTypeStart);
            _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.cM.info("arrowTypeEnd", edge.arrowTypeEnd);
            addEdgeMarkers(svgPath, edge, url, id, diagramType);
            let paths = {};
            if (pointsHasChanged) paths.updatedPath = points;
            paths.originalPath = edge.points;
            return paths;
        }, "insertEdge");
        var insertMarkers = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)((elem, markerArray, type, id)=>{
            markerArray.forEach((markerName)=>{
                markers[markerName](elem, type, id);
            });
        }, "insertMarkers");
        var extension = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)((elem, type, id)=>{
            _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.cM.trace("Making markers for ", id);
            elem.append("defs").append("marker").attr("id", id + "_" + type + "-extensionStart").attr("class", "marker extension " + type).attr("refX", 18).attr("refY", 7).attr("markerWidth", 190).attr("markerHeight", 240).attr("orient", "auto").append("path").attr("d", "M 1,7 L18,13 V 1 Z");
            elem.append("defs").append("marker").attr("id", id + "_" + type + "-extensionEnd").attr("class", "marker extension " + type).attr("refX", 1).attr("refY", 7).attr("markerWidth", 20).attr("markerHeight", 28).attr("orient", "auto").append("path").attr("d", "M 1,1 V 13 L18,7 Z");
        }, "extension");
        var composition = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)((elem, type, id)=>{
            elem.append("defs").append("marker").attr("id", id + "_" + type + "-compositionStart").attr("class", "marker composition " + type).attr("refX", 18).attr("refY", 7).attr("markerWidth", 190).attr("markerHeight", 240).attr("orient", "auto").append("path").attr("d", "M 18,7 L9,13 L1,7 L9,1 Z");
            elem.append("defs").append("marker").attr("id", id + "_" + type + "-compositionEnd").attr("class", "marker composition " + type).attr("refX", 1).attr("refY", 7).attr("markerWidth", 20).attr("markerHeight", 28).attr("orient", "auto").append("path").attr("d", "M 18,7 L9,13 L1,7 L9,1 Z");
        }, "composition");
        var aggregation = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)((elem, type, id)=>{
            elem.append("defs").append("marker").attr("id", id + "_" + type + "-aggregationStart").attr("class", "marker aggregation " + type).attr("refX", 18).attr("refY", 7).attr("markerWidth", 190).attr("markerHeight", 240).attr("orient", "auto").append("path").attr("d", "M 18,7 L9,13 L1,7 L9,1 Z");
            elem.append("defs").append("marker").attr("id", id + "_" + type + "-aggregationEnd").attr("class", "marker aggregation " + type).attr("refX", 1).attr("refY", 7).attr("markerWidth", 20).attr("markerHeight", 28).attr("orient", "auto").append("path").attr("d", "M 18,7 L9,13 L1,7 L9,1 Z");
        }, "aggregation");
        var dependency = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)((elem, type, id)=>{
            elem.append("defs").append("marker").attr("id", id + "_" + type + "-dependencyStart").attr("class", "marker dependency " + type).attr("refX", 6).attr("refY", 7).attr("markerWidth", 190).attr("markerHeight", 240).attr("orient", "auto").append("path").attr("d", "M 5,7 L9,13 L1,7 L9,1 Z");
            elem.append("defs").append("marker").attr("id", id + "_" + type + "-dependencyEnd").attr("class", "marker dependency " + type).attr("refX", 13).attr("refY", 7).attr("markerWidth", 20).attr("markerHeight", 28).attr("orient", "auto").append("path").attr("d", "M 18,7 L9,13 L14,7 L9,1 Z");
        }, "dependency");
        var lollipop = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)((elem, type, id)=>{
            elem.append("defs").append("marker").attr("id", id + "_" + type + "-lollipopStart").attr("class", "marker lollipop " + type).attr("refX", 13).attr("refY", 7).attr("markerWidth", 190).attr("markerHeight", 240).attr("orient", "auto").append("circle").attr("stroke", "black").attr("fill", "transparent").attr("cx", 7).attr("cy", 7).attr("r", 6);
            elem.append("defs").append("marker").attr("id", id + "_" + type + "-lollipopEnd").attr("class", "marker lollipop " + type).attr("refX", 1).attr("refY", 7).attr("markerWidth", 190).attr("markerHeight", 240).attr("orient", "auto").append("circle").attr("stroke", "black").attr("fill", "transparent").attr("cx", 7).attr("cy", 7).attr("r", 6);
        }, "lollipop");
        var point = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)((elem, type, id)=>{
            elem.append("marker").attr("id", id + "_" + type + "-pointEnd").attr("class", "marker " + type).attr("viewBox", "0 0 10 10").attr("refX", 5).attr("refY", 5).attr("markerUnits", "userSpaceOnUse").attr("markerWidth", 8).attr("markerHeight", 8).attr("orient", "auto").append("path").attr("d", "M 0 0 L 10 5 L 0 10 z").attr("class", "arrowMarkerPath").style("stroke-width", 1).style("stroke-dasharray", "1,0");
            elem.append("marker").attr("id", id + "_" + type + "-pointStart").attr("class", "marker " + type).attr("viewBox", "0 0 10 10").attr("refX", 4.5).attr("refY", 5).attr("markerUnits", "userSpaceOnUse").attr("markerWidth", 8).attr("markerHeight", 8).attr("orient", "auto").append("path").attr("d", "M 0 5 L 10 10 L 10 0 z").attr("class", "arrowMarkerPath").style("stroke-width", 1).style("stroke-dasharray", "1,0");
        }, "point");
        var circle = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)((elem, type, id)=>{
            elem.append("marker").attr("id", id + "_" + type + "-circleEnd").attr("class", "marker " + type).attr("viewBox", "0 0 10 10").attr("refX", 11).attr("refY", 5).attr("markerUnits", "userSpaceOnUse").attr("markerWidth", 11).attr("markerHeight", 11).attr("orient", "auto").append("circle").attr("cx", "5").attr("cy", "5").attr("r", "5").attr("class", "arrowMarkerPath").style("stroke-width", 1).style("stroke-dasharray", "1,0");
            elem.append("marker").attr("id", id + "_" + type + "-circleStart").attr("class", "marker " + type).attr("viewBox", "0 0 10 10").attr("refX", -1).attr("refY", 5).attr("markerUnits", "userSpaceOnUse").attr("markerWidth", 11).attr("markerHeight", 11).attr("orient", "auto").append("circle").attr("cx", "5").attr("cy", "5").attr("r", "5").attr("class", "arrowMarkerPath").style("stroke-width", 1).style("stroke-dasharray", "1,0");
        }, "circle");
        var cross = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)((elem, type, id)=>{
            elem.append("marker").attr("id", id + "_" + type + "-crossEnd").attr("class", "marker cross " + type).attr("viewBox", "0 0 11 11").attr("refX", 12).attr("refY", 5.2).attr("markerUnits", "userSpaceOnUse").attr("markerWidth", 11).attr("markerHeight", 11).attr("orient", "auto").append("path").attr("d", "M 1,1 l 9,9 M 10,1 l -9,9").attr("class", "arrowMarkerPath").style("stroke-width", 2).style("stroke-dasharray", "1,0");
            elem.append("marker").attr("id", id + "_" + type + "-crossStart").attr("class", "marker cross " + type).attr("viewBox", "0 0 11 11").attr("refX", -1).attr("refY", 5.2).attr("markerUnits", "userSpaceOnUse").attr("markerWidth", 11).attr("markerHeight", 11).attr("orient", "auto").append("path").attr("d", "M 1,1 l 9,9 M 10,1 l -9,9").attr("class", "arrowMarkerPath").style("stroke-width", 2).style("stroke-dasharray", "1,0");
        }, "cross");
        var barb = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_5__.eW)((elem, type, id)=>{
            elem.append("defs").append("marker").attr("id", id + "_" + type + "-barbEnd").attr("refX", 19).attr("refY", 7).attr("markerWidth", 20).attr("markerHeight", 14).attr("markerUnits", "userSpaceOnUse").attr("orient", "auto").append("path").attr("d", "M 19,7 L9,13 L14,7 L9,1 Z");
        }, "barb");
        var markers = {
            extension,
            composition,
            aggregation,
            dependency,
            lollipop,
            point,
            circle,
            cross,
            barb
        };
        var markers_default = insertMarkers;
    },
    "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-6DBFFHIP.mjs": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            Kr: ()=>getDiagramTitle,
            Vg: ()=>detectType,
            Yc: ()=>assignWithDepth_default,
            ZH: ()=>clear,
            l0: ()=>hasKatex,
            NM: ()=>sanitizeDirective,
            Yn: ()=>setSiteConfig,
            cj: ()=>UnknownDiagramError,
            xN: ()=>getThemeVariables3,
            Fy: ()=>defaultConfig2,
            oO: ()=>sanitizeText,
            XV: ()=>addDirective,
            SY: ()=>common_default,
            eW: ()=>__name,
            u_: ()=>defaultConfig,
            vZ: ()=>defaultConfig_default,
            nV: ()=>getConfig2,
            UO: ()=>parseGenericTypes,
            cM: ()=>log,
            iE: ()=>getConfig,
            uT: ()=>renderKatex,
            _j: ()=>themes_default,
            Y4: ()=>setConfig2,
            _7: ()=>getDiagram,
            j7: ()=>setupGraphViewbox,
            v2: ()=>configureSvgSize,
            uX: ()=>sanitizeText3,
            GN: ()=>setAccTitle,
            g2: ()=>setDiagramTitle,
            r2: ()=>__export,
            Ee: ()=>styles_default,
            Ub: ()=>setLogLevel,
            eu: ()=>getAccTitle,
            mc: ()=>chunk_6DBFFHIP_reset,
            nH: ()=>calculateMathMLDimensions,
            Cq: ()=>registerDiagram,
            dY: ()=>saveConfigFromInitialize,
            v6: ()=>setConfig,
            Mx: ()=>getAccDescription,
            Zn: ()=>directiveRegex,
            M6: ()=>frontMatterRegex,
            Vw: ()=>lineBreakRegex,
            U$: ()=>setAccDescription,
            Rw: ()=>setupGraphViewbox2,
            ZD: ()=>getSiteConfig,
            Tb: ()=>updateSiteConfig,
            Bf: ()=>detectors,
            LJ: ()=>commonDb_exports,
            KO: ()=>registerLazyLoadedDiagrams,
            cq: ()=>getDiagramLoader,
            ku: ()=>evaluate
        });
        var dayjs_min = __webpack_require__("./node_modules/.pnpm/dayjs@1.11.11/node_modules/dayjs/dayjs.min.js");
        var dist_color = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/color/index.js");
        var change = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/methods/change.js");
        const adjust = (color, channels)=>{
            const ch = dist_color.Z.parse(color);
            const changes = {};
            for(const c in channels)if (!!channels[c]) changes[c] = ch[c] + channels[c];
            return (0, change.Z)(color, changes);
        };
        const methods_adjust = adjust;
        var rgba = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/methods/rgba.js");
        const mix = (color1, color2, weight = 50)=>{
            const { r: r1, g: g1, b: b1, a: a1 } = dist_color.Z.parse(color1);
            const { r: r2, g: g2, b: b2, a: a2 } = dist_color.Z.parse(color2);
            const weightScale = weight / 100;
            const weightNormalized = 2 * weightScale - 1;
            const alphaDelta = a1 - a2;
            const weight1combined = weightNormalized * alphaDelta === -1 ? weightNormalized : (weightNormalized + alphaDelta) / (1 + weightNormalized * alphaDelta);
            const weight1 = (weight1combined + 1) / 2;
            const weight2 = 1 - weight1;
            const r = r1 * weight1 + r2 * weight2;
            const g = g1 * weight1 + g2 * weight2;
            const b = b1 * weight1 + b2 * weight2;
            const a = a1 * weightScale + a2 * (1 - weightScale);
            return (0, rgba.Z)(r, g, b, a);
        };
        const methods_mix = mix;
        const invert_invert = (color, weight = 100)=>{
            const inverse = dist_color.Z.parse(color);
            inverse.r = 255 - inverse.r;
            inverse.g = 255 - inverse.g;
            inverse.b = 255 - inverse.b;
            return methods_mix(inverse, color, weight);
        };
        const invert = invert_invert;
        var darken = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/methods/darken.js");
        var lighten = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/methods/lighten.js");
        var is_dark = __webpack_require__("./node_modules/.pnpm/khroma@2.1.0/node_modules/khroma/dist/methods/is_dark.js");
        var purify_es = __webpack_require__("./node_modules/.pnpm/dompurify@3.2.4/node_modules/dompurify/dist/purify.es.mjs");
        var __defProp = Object.defineProperty;
        var __name = (target, value)=>__defProp(target, "name", {
                value,
                configurable: true
            });
        var __export = (target, all)=>{
            for(var name in all)__defProp(target, name, {
                get: all[name],
                enumerable: true
            });
        };
        var LEVELS = {
            trace: 0,
            debug: 1,
            info: 2,
            warn: 3,
            error: 4,
            fatal: 5
        };
        var log = {
            trace: /* @__PURE__ */ __name((..._args)=>{}, "trace"),
            debug: /* @__PURE__ */ __name((..._args)=>{}, "debug"),
            info: /* @__PURE__ */ __name((..._args)=>{}, "info"),
            warn: /* @__PURE__ */ __name((..._args)=>{}, "warn"),
            error: /* @__PURE__ */ __name((..._args)=>{}, "error"),
            fatal: /* @__PURE__ */ __name((..._args)=>{}, "fatal")
        };
        var setLogLevel = /* @__PURE__ */ __name(function(level = "fatal") {
            let numericLevel = LEVELS.fatal;
            if ("string" == typeof level) {
                if (level.toLowerCase() in LEVELS) numericLevel = LEVELS[level];
            } else if ("number" == typeof level) numericLevel = level;
            log.trace = ()=>{};
            log.debug = ()=>{};
            log.info = ()=>{};
            log.warn = ()=>{};
            log.error = ()=>{};
            log.fatal = ()=>{};
            if (numericLevel <= LEVELS.fatal) log.fatal = console.error ? console.error.bind(console, format("FATAL"), "color: orange") : console.log.bind(console, "\x1B[35m", format("FATAL"));
            if (numericLevel <= LEVELS.error) log.error = console.error ? console.error.bind(console, format("ERROR"), "color: orange") : console.log.bind(console, "\x1B[31m", format("ERROR"));
            if (numericLevel <= LEVELS.warn) log.warn = console.warn ? console.warn.bind(console, format("WARN"), "color: orange") : console.log.bind(console, `\x1B[33m`, format("WARN"));
            if (numericLevel <= LEVELS.info) log.info = console.info ? console.info.bind(console, format("INFO"), "color: lightblue") : console.log.bind(console, "\x1B[34m", format("INFO"));
            if (numericLevel <= LEVELS.debug) log.debug = console.debug ? console.debug.bind(console, format("DEBUG"), "color: lightgreen") : console.log.bind(console, "\x1B[32m", format("DEBUG"));
            if (numericLevel <= LEVELS.trace) log.trace = console.debug ? console.debug.bind(console, format("TRACE"), "color: lightgreen") : console.log.bind(console, "\x1B[32m", format("TRACE"));
        }, "setLogLevel");
        var format = /* @__PURE__ */ __name((level)=>{
            const time = dayjs_min().format("ss.SSS");
            return `%c${time} : ${level} : `;
        }, "format");
        var frontMatterRegex = /^-{3}\s*[\n\r](.*?)[\n\r]-{3}\s*[\n\r]+/s;
        var directiveRegex = /%{2}{\s*(?:(\w+)\s*:|(\w+))\s*(?:(\w+)|((?:(?!}%{2}).|\r?\n)*))?\s*(?:}%{2})?/gi;
        var anyCommentRegex = /\s*%%.*\n/gm;
        var UnknownDiagramError = class extends Error {
            static{
                __name(this, "UnknownDiagramError");
            }
            constructor(message){
                super(message);
                this.name = "UnknownDiagramError";
            }
        };
        var detectors = {};
        var detectType = /* @__PURE__ */ __name(function(text, config2) {
            text = text.replace(frontMatterRegex, "").replace(directiveRegex, "").replace(anyCommentRegex, "\n");
            for (const [key, { detector }] of Object.entries(detectors)){
                const diagram = detector(text, config2);
                if (diagram) return key;
            }
            throw new UnknownDiagramError(`No diagram type detected matching given configuration for text: ${text}`);
        }, "detectType");
        var registerLazyLoadedDiagrams = /* @__PURE__ */ __name((...diagrams2)=>{
            for (const { id, detector, loader } of diagrams2)addDetector(id, detector, loader);
        }, "registerLazyLoadedDiagrams");
        var addDetector = /* @__PURE__ */ __name((key, detector, loader)=>{
            if (detectors[key]) log.warn(`Detector with key ${key} already exists. Overwriting.`);
            detectors[key] = {
                detector,
                loader
            };
            log.debug(`Detector with key ${key} added${loader ? " with loader" : ""}`);
        }, "addDetector");
        var getDiagramLoader = /* @__PURE__ */ __name((key)=>detectors[key].loader, "getDiagramLoader");
        var assignWithDepth = /* @__PURE__ */ __name((dst, src, { depth = 2, clobber = false } = {})=>{
            const config2 = {
                depth,
                clobber
            };
            if (Array.isArray(src) && !Array.isArray(dst)) {
                src.forEach((s)=>assignWithDepth(dst, s, config2));
                return dst;
            }
            if (Array.isArray(src) && Array.isArray(dst)) {
                src.forEach((s)=>{
                    if (!dst.includes(s)) dst.push(s);
                });
                return dst;
            }
            if (void 0 === dst || depth <= 0) {
                if (null != dst && "object" == typeof dst && "object" == typeof src) return Object.assign(dst, src);
                return src;
            }
            if (void 0 !== src && "object" == typeof dst && "object" == typeof src) Object.keys(src).forEach((key)=>{
                if ("object" == typeof src[key] && (void 0 === dst[key] || "object" == typeof dst[key])) {
                    if (void 0 === dst[key]) dst[key] = Array.isArray(src[key]) ? [] : {};
                    dst[key] = assignWithDepth(dst[key], src[key], {
                        depth: depth - 1,
                        clobber
                    });
                } else if (clobber || "object" != typeof dst[key] && "object" != typeof src[key]) dst[key] = src[key];
            });
            return dst;
        }, "assignWithDepth");
        var assignWithDepth_default = assignWithDepth;
        var oldAttributeBackgroundColorOdd = "#ffffff";
        var oldAttributeBackgroundColorEven = "#f2f2f2";
        var mkBorder = /* @__PURE__ */ __name((col, darkMode)=>darkMode ? methods_adjust(col, {
                s: -40,
                l: 10
            }) : methods_adjust(col, {
                s: -40,
                l: -10
            }), "mkBorder");
        var Theme = class {
            static{
                __name(this, "Theme");
            }
            constructor(){
                this.background = "#f4f4f4";
                this.primaryColor = "#fff4dd";
                this.noteBkgColor = "#fff5ad";
                this.noteTextColor = "#333";
                this.THEME_COLOR_LIMIT = 12;
                this.fontFamily = '"trebuchet ms", verdana, arial, sans-serif';
                this.fontSize = "16px";
            }
            updateColors() {
                this.primaryTextColor = this.primaryTextColor || (this.darkMode ? "#eee" : "#333");
                this.secondaryColor = this.secondaryColor || methods_adjust(this.primaryColor, {
                    h: -120
                });
                this.tertiaryColor = this.tertiaryColor || methods_adjust(this.primaryColor, {
                    h: 180,
                    l: 5
                });
                this.primaryBorderColor = this.primaryBorderColor || mkBorder(this.primaryColor, this.darkMode);
                this.secondaryBorderColor = this.secondaryBorderColor || mkBorder(this.secondaryColor, this.darkMode);
                this.tertiaryBorderColor = this.tertiaryBorderColor || mkBorder(this.tertiaryColor, this.darkMode);
                this.noteBorderColor = this.noteBorderColor || mkBorder(this.noteBkgColor, this.darkMode);
                this.noteBkgColor = this.noteBkgColor || "#fff5ad";
                this.noteTextColor = this.noteTextColor || "#333";
                this.secondaryTextColor = this.secondaryTextColor || invert(this.secondaryColor);
                this.tertiaryTextColor = this.tertiaryTextColor || invert(this.tertiaryColor);
                this.lineColor = this.lineColor || invert(this.background);
                this.arrowheadColor = this.arrowheadColor || invert(this.background);
                this.textColor = this.textColor || this.primaryTextColor;
                this.border2 = this.border2 || this.tertiaryBorderColor;
                this.nodeBkg = this.nodeBkg || this.primaryColor;
                this.mainBkg = this.mainBkg || this.primaryColor;
                this.nodeBorder = this.nodeBorder || this.primaryBorderColor;
                this.clusterBkg = this.clusterBkg || this.tertiaryColor;
                this.clusterBorder = this.clusterBorder || this.tertiaryBorderColor;
                this.defaultLinkColor = this.defaultLinkColor || this.lineColor;
                this.titleColor = this.titleColor || this.tertiaryTextColor;
                this.edgeLabelBackground = this.edgeLabelBackground || (this.darkMode ? (0, darken.Z)(this.secondaryColor, 30) : this.secondaryColor);
                this.nodeTextColor = this.nodeTextColor || this.primaryTextColor;
                this.actorBorder = this.actorBorder || this.primaryBorderColor;
                this.actorBkg = this.actorBkg || this.mainBkg;
                this.actorTextColor = this.actorTextColor || this.primaryTextColor;
                this.actorLineColor = this.actorLineColor || this.actorBorder;
                this.labelBoxBkgColor = this.labelBoxBkgColor || this.actorBkg;
                this.signalColor = this.signalColor || this.textColor;
                this.signalTextColor = this.signalTextColor || this.textColor;
                this.labelBoxBorderColor = this.labelBoxBorderColor || this.actorBorder;
                this.labelTextColor = this.labelTextColor || this.actorTextColor;
                this.loopTextColor = this.loopTextColor || this.actorTextColor;
                this.activationBorderColor = this.activationBorderColor || (0, darken.Z)(this.secondaryColor, 10);
                this.activationBkgColor = this.activationBkgColor || this.secondaryColor;
                this.sequenceNumberColor = this.sequenceNumberColor || invert(this.lineColor);
                this.sectionBkgColor = this.sectionBkgColor || this.tertiaryColor;
                this.altSectionBkgColor = this.altSectionBkgColor || "white";
                this.sectionBkgColor = this.sectionBkgColor || this.secondaryColor;
                this.sectionBkgColor2 = this.sectionBkgColor2 || this.primaryColor;
                this.excludeBkgColor = this.excludeBkgColor || "#eeeeee";
                this.taskBorderColor = this.taskBorderColor || this.primaryBorderColor;
                this.taskBkgColor = this.taskBkgColor || this.primaryColor;
                this.activeTaskBorderColor = this.activeTaskBorderColor || this.primaryColor;
                this.activeTaskBkgColor = this.activeTaskBkgColor || (0, lighten.Z)(this.primaryColor, 23);
                this.gridColor = this.gridColor || "lightgrey";
                this.doneTaskBkgColor = this.doneTaskBkgColor || "lightgrey";
                this.doneTaskBorderColor = this.doneTaskBorderColor || "grey";
                this.critBorderColor = this.critBorderColor || "#ff8888";
                this.critBkgColor = this.critBkgColor || "red";
                this.todayLineColor = this.todayLineColor || "red";
                this.taskTextColor = this.taskTextColor || this.textColor;
                this.taskTextOutsideColor = this.taskTextOutsideColor || this.textColor;
                this.taskTextLightColor = this.taskTextLightColor || this.textColor;
                this.taskTextColor = this.taskTextColor || this.primaryTextColor;
                this.taskTextDarkColor = this.taskTextDarkColor || this.textColor;
                this.taskTextClickableColor = this.taskTextClickableColor || "#003163";
                this.personBorder = this.personBorder || this.primaryBorderColor;
                this.personBkg = this.personBkg || this.mainBkg;
                this.transitionColor = this.transitionColor || this.lineColor;
                this.transitionLabelColor = this.transitionLabelColor || this.textColor;
                this.stateLabelColor = this.stateLabelColor || this.stateBkg || this.primaryTextColor;
                this.stateBkg = this.stateBkg || this.mainBkg;
                this.labelBackgroundColor = this.labelBackgroundColor || this.stateBkg;
                this.compositeBackground = this.compositeBackground || this.background || this.tertiaryColor;
                this.altBackground = this.altBackground || this.tertiaryColor;
                this.compositeTitleBackground = this.compositeTitleBackground || this.mainBkg;
                this.compositeBorder = this.compositeBorder || this.nodeBorder;
                this.innerEndBackground = this.nodeBorder;
                this.errorBkgColor = this.errorBkgColor || this.tertiaryColor;
                this.errorTextColor = this.errorTextColor || this.tertiaryTextColor;
                this.transitionColor = this.transitionColor || this.lineColor;
                this.specialStateColor = this.lineColor;
                this.cScale0 = this.cScale0 || this.primaryColor;
                this.cScale1 = this.cScale1 || this.secondaryColor;
                this.cScale2 = this.cScale2 || this.tertiaryColor;
                this.cScale3 = this.cScale3 || methods_adjust(this.primaryColor, {
                    h: 30
                });
                this.cScale4 = this.cScale4 || methods_adjust(this.primaryColor, {
                    h: 60
                });
                this.cScale5 = this.cScale5 || methods_adjust(this.primaryColor, {
                    h: 90
                });
                this.cScale6 = this.cScale6 || methods_adjust(this.primaryColor, {
                    h: 120
                });
                this.cScale7 = this.cScale7 || methods_adjust(this.primaryColor, {
                    h: 150
                });
                this.cScale8 = this.cScale8 || methods_adjust(this.primaryColor, {
                    h: 210,
                    l: 150
                });
                this.cScale9 = this.cScale9 || methods_adjust(this.primaryColor, {
                    h: 270
                });
                this.cScale10 = this.cScale10 || methods_adjust(this.primaryColor, {
                    h: 300
                });
                this.cScale11 = this.cScale11 || methods_adjust(this.primaryColor, {
                    h: 330
                });
                if (this.darkMode) for(let i = 0; i < this.THEME_COLOR_LIMIT; i++)this["cScale" + i] = (0, darken.Z)(this["cScale" + i], 75);
                else for(let i = 0; i < this.THEME_COLOR_LIMIT; i++)this["cScale" + i] = (0, darken.Z)(this["cScale" + i], 25);
                for(let i = 0; i < this.THEME_COLOR_LIMIT; i++)this["cScaleInv" + i] = this["cScaleInv" + i] || invert(this["cScale" + i]);
                for(let i = 0; i < this.THEME_COLOR_LIMIT; i++)if (this.darkMode) this["cScalePeer" + i] = this["cScalePeer" + i] || (0, lighten.Z)(this["cScale" + i], 10);
                else this["cScalePeer" + i] = this["cScalePeer" + i] || (0, darken.Z)(this["cScale" + i], 10);
                this.scaleLabelColor = this.scaleLabelColor || this.labelTextColor;
                for(let i = 0; i < this.THEME_COLOR_LIMIT; i++)this["cScaleLabel" + i] = this["cScaleLabel" + i] || this.scaleLabelColor;
                const multiplier = this.darkMode ? -4 : -1;
                for(let i = 0; i < 5; i++){
                    this["surface" + i] = this["surface" + i] || methods_adjust(this.mainBkg, {
                        h: 180,
                        s: -15,
                        l: multiplier * (5 + 3 * i)
                    });
                    this["surfacePeer" + i] = this["surfacePeer" + i] || methods_adjust(this.mainBkg, {
                        h: 180,
                        s: -15,
                        l: multiplier * (8 + 3 * i)
                    });
                }
                this.classText = this.classText || this.textColor;
                this.fillType0 = this.fillType0 || this.primaryColor;
                this.fillType1 = this.fillType1 || this.secondaryColor;
                this.fillType2 = this.fillType2 || methods_adjust(this.primaryColor, {
                    h: 64
                });
                this.fillType3 = this.fillType3 || methods_adjust(this.secondaryColor, {
                    h: 64
                });
                this.fillType4 = this.fillType4 || methods_adjust(this.primaryColor, {
                    h: -64
                });
                this.fillType5 = this.fillType5 || methods_adjust(this.secondaryColor, {
                    h: -64
                });
                this.fillType6 = this.fillType6 || methods_adjust(this.primaryColor, {
                    h: 128
                });
                this.fillType7 = this.fillType7 || methods_adjust(this.secondaryColor, {
                    h: 128
                });
                this.pie1 = this.pie1 || this.primaryColor;
                this.pie2 = this.pie2 || this.secondaryColor;
                this.pie3 = this.pie3 || this.tertiaryColor;
                this.pie4 = this.pie4 || methods_adjust(this.primaryColor, {
                    l: -10
                });
                this.pie5 = this.pie5 || methods_adjust(this.secondaryColor, {
                    l: -10
                });
                this.pie6 = this.pie6 || methods_adjust(this.tertiaryColor, {
                    l: -10
                });
                this.pie7 = this.pie7 || methods_adjust(this.primaryColor, {
                    h: 60,
                    l: -10
                });
                this.pie8 = this.pie8 || methods_adjust(this.primaryColor, {
                    h: -60,
                    l: -10
                });
                this.pie9 = this.pie9 || methods_adjust(this.primaryColor, {
                    h: 120,
                    l: 0
                });
                this.pie10 = this.pie10 || methods_adjust(this.primaryColor, {
                    h: 60,
                    l: -20
                });
                this.pie11 = this.pie11 || methods_adjust(this.primaryColor, {
                    h: -60,
                    l: -20
                });
                this.pie12 = this.pie12 || methods_adjust(this.primaryColor, {
                    h: 120,
                    l: -10
                });
                this.pieTitleTextSize = this.pieTitleTextSize || "25px";
                this.pieTitleTextColor = this.pieTitleTextColor || this.taskTextDarkColor;
                this.pieSectionTextSize = this.pieSectionTextSize || "17px";
                this.pieSectionTextColor = this.pieSectionTextColor || this.textColor;
                this.pieLegendTextSize = this.pieLegendTextSize || "17px";
                this.pieLegendTextColor = this.pieLegendTextColor || this.taskTextDarkColor;
                this.pieStrokeColor = this.pieStrokeColor || "black";
                this.pieStrokeWidth = this.pieStrokeWidth || "2px";
                this.pieOuterStrokeWidth = this.pieOuterStrokeWidth || "2px";
                this.pieOuterStrokeColor = this.pieOuterStrokeColor || "black";
                this.pieOpacity = this.pieOpacity || "0.7";
                this.archEdgeColor = this.archEdgeColor || "#777";
                this.archEdgeArrowColor = this.archEdgeArrowColor || "#777";
                this.archEdgeWidth = this.archEdgeWidth || "3";
                this.archGroupBorderColor = this.archGroupBorderColor || "#000";
                this.archGroupBorderWidth = this.archGroupBorderWidth || "2px";
                this.quadrant1Fill = this.quadrant1Fill || this.primaryColor;
                this.quadrant2Fill = this.quadrant2Fill || methods_adjust(this.primaryColor, {
                    r: 5,
                    g: 5,
                    b: 5
                });
                this.quadrant3Fill = this.quadrant3Fill || methods_adjust(this.primaryColor, {
                    r: 10,
                    g: 10,
                    b: 10
                });
                this.quadrant4Fill = this.quadrant4Fill || methods_adjust(this.primaryColor, {
                    r: 15,
                    g: 15,
                    b: 15
                });
                this.quadrant1TextFill = this.quadrant1TextFill || this.primaryTextColor;
                this.quadrant2TextFill = this.quadrant2TextFill || methods_adjust(this.primaryTextColor, {
                    r: -5,
                    g: -5,
                    b: -5
                });
                this.quadrant3TextFill = this.quadrant3TextFill || methods_adjust(this.primaryTextColor, {
                    r: -10,
                    g: -10,
                    b: -10
                });
                this.quadrant4TextFill = this.quadrant4TextFill || methods_adjust(this.primaryTextColor, {
                    r: -15,
                    g: -15,
                    b: -15
                });
                this.quadrantPointFill = this.quadrantPointFill || (0, is_dark.Z)(this.quadrant1Fill) ? (0, lighten.Z)(this.quadrant1Fill) : (0, darken.Z)(this.quadrant1Fill);
                this.quadrantPointTextFill = this.quadrantPointTextFill || this.primaryTextColor;
                this.quadrantXAxisTextFill = this.quadrantXAxisTextFill || this.primaryTextColor;
                this.quadrantYAxisTextFill = this.quadrantYAxisTextFill || this.primaryTextColor;
                this.quadrantInternalBorderStrokeFill = this.quadrantInternalBorderStrokeFill || this.primaryBorderColor;
                this.quadrantExternalBorderStrokeFill = this.quadrantExternalBorderStrokeFill || this.primaryBorderColor;
                this.quadrantTitleFill = this.quadrantTitleFill || this.primaryTextColor;
                this.xyChart = {
                    backgroundColor: this.xyChart?.backgroundColor || this.background,
                    titleColor: this.xyChart?.titleColor || this.primaryTextColor,
                    xAxisTitleColor: this.xyChart?.xAxisTitleColor || this.primaryTextColor,
                    xAxisLabelColor: this.xyChart?.xAxisLabelColor || this.primaryTextColor,
                    xAxisTickColor: this.xyChart?.xAxisTickColor || this.primaryTextColor,
                    xAxisLineColor: this.xyChart?.xAxisLineColor || this.primaryTextColor,
                    yAxisTitleColor: this.xyChart?.yAxisTitleColor || this.primaryTextColor,
                    yAxisLabelColor: this.xyChart?.yAxisLabelColor || this.primaryTextColor,
                    yAxisTickColor: this.xyChart?.yAxisTickColor || this.primaryTextColor,
                    yAxisLineColor: this.xyChart?.yAxisLineColor || this.primaryTextColor,
                    plotColorPalette: this.xyChart?.plotColorPalette || "#FFF4DD,#FFD8B1,#FFA07A,#ECEFF1,#D6DBDF,#C3E0A8,#FFB6A4,#FFD74D,#738FA7,#FFFFF0"
                };
                this.requirementBackground = this.requirementBackground || this.primaryColor;
                this.requirementBorderColor = this.requirementBorderColor || this.primaryBorderColor;
                this.requirementBorderSize = this.requirementBorderSize || "1";
                this.requirementTextColor = this.requirementTextColor || this.primaryTextColor;
                this.relationColor = this.relationColor || this.lineColor;
                this.relationLabelBackground = this.relationLabelBackground || (this.darkMode ? (0, darken.Z)(this.secondaryColor, 30) : this.secondaryColor);
                this.relationLabelColor = this.relationLabelColor || this.actorTextColor;
                this.git0 = this.git0 || this.primaryColor;
                this.git1 = this.git1 || this.secondaryColor;
                this.git2 = this.git2 || this.tertiaryColor;
                this.git3 = this.git3 || methods_adjust(this.primaryColor, {
                    h: -30
                });
                this.git4 = this.git4 || methods_adjust(this.primaryColor, {
                    h: -60
                });
                this.git5 = this.git5 || methods_adjust(this.primaryColor, {
                    h: -90
                });
                this.git6 = this.git6 || methods_adjust(this.primaryColor, {
                    h: 60
                });
                this.git7 = this.git7 || methods_adjust(this.primaryColor, {
                    h: 120
                });
                if (this.darkMode) {
                    this.git0 = (0, lighten.Z)(this.git0, 25);
                    this.git1 = (0, lighten.Z)(this.git1, 25);
                    this.git2 = (0, lighten.Z)(this.git2, 25);
                    this.git3 = (0, lighten.Z)(this.git3, 25);
                    this.git4 = (0, lighten.Z)(this.git4, 25);
                    this.git5 = (0, lighten.Z)(this.git5, 25);
                    this.git6 = (0, lighten.Z)(this.git6, 25);
                    this.git7 = (0, lighten.Z)(this.git7, 25);
                } else {
                    this.git0 = (0, darken.Z)(this.git0, 25);
                    this.git1 = (0, darken.Z)(this.git1, 25);
                    this.git2 = (0, darken.Z)(this.git2, 25);
                    this.git3 = (0, darken.Z)(this.git3, 25);
                    this.git4 = (0, darken.Z)(this.git4, 25);
                    this.git5 = (0, darken.Z)(this.git5, 25);
                    this.git6 = (0, darken.Z)(this.git6, 25);
                    this.git7 = (0, darken.Z)(this.git7, 25);
                }
                this.gitInv0 = this.gitInv0 || invert(this.git0);
                this.gitInv1 = this.gitInv1 || invert(this.git1);
                this.gitInv2 = this.gitInv2 || invert(this.git2);
                this.gitInv3 = this.gitInv3 || invert(this.git3);
                this.gitInv4 = this.gitInv4 || invert(this.git4);
                this.gitInv5 = this.gitInv5 || invert(this.git5);
                this.gitInv6 = this.gitInv6 || invert(this.git6);
                this.gitInv7 = this.gitInv7 || invert(this.git7);
                this.branchLabelColor = this.branchLabelColor || (this.darkMode ? "black" : this.labelTextColor);
                this.gitBranchLabel0 = this.gitBranchLabel0 || this.branchLabelColor;
                this.gitBranchLabel1 = this.gitBranchLabel1 || this.branchLabelColor;
                this.gitBranchLabel2 = this.gitBranchLabel2 || this.branchLabelColor;
                this.gitBranchLabel3 = this.gitBranchLabel3 || this.branchLabelColor;
                this.gitBranchLabel4 = this.gitBranchLabel4 || this.branchLabelColor;
                this.gitBranchLabel5 = this.gitBranchLabel5 || this.branchLabelColor;
                this.gitBranchLabel6 = this.gitBranchLabel6 || this.branchLabelColor;
                this.gitBranchLabel7 = this.gitBranchLabel7 || this.branchLabelColor;
                this.tagLabelColor = this.tagLabelColor || this.primaryTextColor;
                this.tagLabelBackground = this.tagLabelBackground || this.primaryColor;
                this.tagLabelBorder = this.tagBorder || this.primaryBorderColor;
                this.tagLabelFontSize = this.tagLabelFontSize || "10px";
                this.commitLabelColor = this.commitLabelColor || this.secondaryTextColor;
                this.commitLabelBackground = this.commitLabelBackground || this.secondaryColor;
                this.commitLabelFontSize = this.commitLabelFontSize || "10px";
                this.attributeBackgroundColorOdd = this.attributeBackgroundColorOdd || oldAttributeBackgroundColorOdd;
                this.attributeBackgroundColorEven = this.attributeBackgroundColorEven || oldAttributeBackgroundColorEven;
            }
            calculate(overrides) {
                if ("object" != typeof overrides) {
                    this.updateColors();
                    return;
                }
                const keys = Object.keys(overrides);
                keys.forEach((k)=>{
                    this[k] = overrides[k];
                });
                this.updateColors();
                keys.forEach((k)=>{
                    this[k] = overrides[k];
                });
            }
        };
        var getThemeVariables = /* @__PURE__ */ __name((userOverrides)=>{
            const theme = new Theme();
            theme.calculate(userOverrides);
            return theme;
        }, "getThemeVariables");
        var Theme2 = class {
            static{
                __name(this, "Theme");
            }
            constructor(){
                this.background = "#333";
                this.primaryColor = "#1f2020";
                this.secondaryColor = (0, lighten.Z)(this.primaryColor, 16);
                this.tertiaryColor = methods_adjust(this.primaryColor, {
                    h: -160
                });
                this.primaryBorderColor = invert(this.background);
                this.secondaryBorderColor = mkBorder(this.secondaryColor, this.darkMode);
                this.tertiaryBorderColor = mkBorder(this.tertiaryColor, this.darkMode);
                this.primaryTextColor = invert(this.primaryColor);
                this.secondaryTextColor = invert(this.secondaryColor);
                this.tertiaryTextColor = invert(this.tertiaryColor);
                this.lineColor = invert(this.background);
                this.textColor = invert(this.background);
                this.mainBkg = "#1f2020";
                this.secondBkg = "calculated";
                this.mainContrastColor = "lightgrey";
                this.darkTextColor = (0, lighten.Z)(invert("#323D47"), 10);
                this.lineColor = "calculated";
                this.border1 = "#ccc";
                this.border2 = (0, rgba.Z)(255, 255, 255, 0.25);
                this.arrowheadColor = "calculated";
                this.fontFamily = '"trebuchet ms", verdana, arial, sans-serif';
                this.fontSize = "16px";
                this.labelBackground = "#181818";
                this.textColor = "#ccc";
                this.THEME_COLOR_LIMIT = 12;
                this.nodeBkg = "calculated";
                this.nodeBorder = "calculated";
                this.clusterBkg = "calculated";
                this.clusterBorder = "calculated";
                this.defaultLinkColor = "calculated";
                this.titleColor = "#F9FFFE";
                this.edgeLabelBackground = "calculated";
                this.actorBorder = "calculated";
                this.actorBkg = "calculated";
                this.actorTextColor = "calculated";
                this.actorLineColor = "calculated";
                this.signalColor = "calculated";
                this.signalTextColor = "calculated";
                this.labelBoxBkgColor = "calculated";
                this.labelBoxBorderColor = "calculated";
                this.labelTextColor = "calculated";
                this.loopTextColor = "calculated";
                this.noteBorderColor = "calculated";
                this.noteBkgColor = "#fff5ad";
                this.noteTextColor = "calculated";
                this.activationBorderColor = "calculated";
                this.activationBkgColor = "calculated";
                this.sequenceNumberColor = "black";
                this.sectionBkgColor = (0, darken.Z)("#EAE8D9", 30);
                this.altSectionBkgColor = "calculated";
                this.sectionBkgColor2 = "#EAE8D9";
                this.excludeBkgColor = (0, darken.Z)(this.sectionBkgColor, 10);
                this.taskBorderColor = (0, rgba.Z)(255, 255, 255, 70);
                this.taskBkgColor = "calculated";
                this.taskTextColor = "calculated";
                this.taskTextLightColor = "calculated";
                this.taskTextOutsideColor = "calculated";
                this.taskTextClickableColor = "#003163";
                this.activeTaskBorderColor = (0, rgba.Z)(255, 255, 255, 50);
                this.activeTaskBkgColor = "#81B1DB";
                this.gridColor = "calculated";
                this.doneTaskBkgColor = "calculated";
                this.doneTaskBorderColor = "grey";
                this.critBorderColor = "#E83737";
                this.critBkgColor = "#E83737";
                this.taskTextDarkColor = "calculated";
                this.todayLineColor = "#DB5757";
                this.personBorder = this.primaryBorderColor;
                this.personBkg = this.mainBkg;
                this.archEdgeColor = "calculated";
                this.archEdgeArrowColor = "calculated";
                this.archEdgeWidth = "3";
                this.archGroupBorderColor = this.primaryBorderColor;
                this.archGroupBorderWidth = "2px";
                this.labelColor = "calculated";
                this.errorBkgColor = "#a44141";
                this.errorTextColor = "#ddd";
            }
            updateColors() {
                this.secondBkg = (0, lighten.Z)(this.mainBkg, 16);
                this.lineColor = this.mainContrastColor;
                this.arrowheadColor = this.mainContrastColor;
                this.nodeBkg = this.mainBkg;
                this.nodeBorder = this.border1;
                this.clusterBkg = this.secondBkg;
                this.clusterBorder = this.border2;
                this.defaultLinkColor = this.lineColor;
                this.edgeLabelBackground = (0, lighten.Z)(this.labelBackground, 25);
                this.actorBorder = this.border1;
                this.actorBkg = this.mainBkg;
                this.actorTextColor = this.mainContrastColor;
                this.actorLineColor = this.actorBorder;
                this.signalColor = this.mainContrastColor;
                this.signalTextColor = this.mainContrastColor;
                this.labelBoxBkgColor = this.actorBkg;
                this.labelBoxBorderColor = this.actorBorder;
                this.labelTextColor = this.mainContrastColor;
                this.loopTextColor = this.mainContrastColor;
                this.noteBorderColor = this.secondaryBorderColor;
                this.noteBkgColor = this.secondBkg;
                this.noteTextColor = this.secondaryTextColor;
                this.activationBorderColor = this.border1;
                this.activationBkgColor = this.secondBkg;
                this.altSectionBkgColor = this.background;
                this.taskBkgColor = (0, lighten.Z)(this.mainBkg, 23);
                this.taskTextColor = this.darkTextColor;
                this.taskTextLightColor = this.mainContrastColor;
                this.taskTextOutsideColor = this.taskTextLightColor;
                this.gridColor = this.mainContrastColor;
                this.doneTaskBkgColor = this.mainContrastColor;
                this.taskTextDarkColor = this.darkTextColor;
                this.archEdgeColor = this.lineColor;
                this.archEdgeArrowColor = this.lineColor;
                this.transitionColor = this.transitionColor || this.lineColor;
                this.transitionLabelColor = this.transitionLabelColor || this.textColor;
                this.stateLabelColor = this.stateLabelColor || this.stateBkg || this.primaryTextColor;
                this.stateBkg = this.stateBkg || this.mainBkg;
                this.labelBackgroundColor = this.labelBackgroundColor || this.stateBkg;
                this.compositeBackground = this.compositeBackground || this.background || this.tertiaryColor;
                this.altBackground = this.altBackground || "#555";
                this.compositeTitleBackground = this.compositeTitleBackground || this.mainBkg;
                this.compositeBorder = this.compositeBorder || this.nodeBorder;
                this.innerEndBackground = this.primaryBorderColor;
                this.specialStateColor = "#f4f4f4";
                this.errorBkgColor = this.errorBkgColor || this.tertiaryColor;
                this.errorTextColor = this.errorTextColor || this.tertiaryTextColor;
                this.fillType0 = this.primaryColor;
                this.fillType1 = this.secondaryColor;
                this.fillType2 = methods_adjust(this.primaryColor, {
                    h: 64
                });
                this.fillType3 = methods_adjust(this.secondaryColor, {
                    h: 64
                });
                this.fillType4 = methods_adjust(this.primaryColor, {
                    h: -64
                });
                this.fillType5 = methods_adjust(this.secondaryColor, {
                    h: -64
                });
                this.fillType6 = methods_adjust(this.primaryColor, {
                    h: 128
                });
                this.fillType7 = methods_adjust(this.secondaryColor, {
                    h: 128
                });
                this.cScale1 = this.cScale1 || "#0b0000";
                this.cScale2 = this.cScale2 || "#4d1037";
                this.cScale3 = this.cScale3 || "#3f5258";
                this.cScale4 = this.cScale4 || "#4f2f1b";
                this.cScale5 = this.cScale5 || "#6e0a0a";
                this.cScale6 = this.cScale6 || "#3b0048";
                this.cScale7 = this.cScale7 || "#995a01";
                this.cScale8 = this.cScale8 || "#154706";
                this.cScale9 = this.cScale9 || "#161722";
                this.cScale10 = this.cScale10 || "#00296f";
                this.cScale11 = this.cScale11 || "#01629c";
                this.cScale12 = this.cScale12 || "#010029";
                this.cScale0 = this.cScale0 || this.primaryColor;
                this.cScale1 = this.cScale1 || this.secondaryColor;
                this.cScale2 = this.cScale2 || this.tertiaryColor;
                this.cScale3 = this.cScale3 || methods_adjust(this.primaryColor, {
                    h: 30
                });
                this.cScale4 = this.cScale4 || methods_adjust(this.primaryColor, {
                    h: 60
                });
                this.cScale5 = this.cScale5 || methods_adjust(this.primaryColor, {
                    h: 90
                });
                this.cScale6 = this.cScale6 || methods_adjust(this.primaryColor, {
                    h: 120
                });
                this.cScale7 = this.cScale7 || methods_adjust(this.primaryColor, {
                    h: 150
                });
                this.cScale8 = this.cScale8 || methods_adjust(this.primaryColor, {
                    h: 210
                });
                this.cScale9 = this.cScale9 || methods_adjust(this.primaryColor, {
                    h: 270
                });
                this.cScale10 = this.cScale10 || methods_adjust(this.primaryColor, {
                    h: 300
                });
                this.cScale11 = this.cScale11 || methods_adjust(this.primaryColor, {
                    h: 330
                });
                for(let i = 0; i < this.THEME_COLOR_LIMIT; i++)this["cScaleInv" + i] = this["cScaleInv" + i] || invert(this["cScale" + i]);
                for(let i = 0; i < this.THEME_COLOR_LIMIT; i++)this["cScalePeer" + i] = this["cScalePeer" + i] || (0, lighten.Z)(this["cScale" + i], 10);
                for(let i = 0; i < 5; i++){
                    this["surface" + i] = this["surface" + i] || methods_adjust(this.mainBkg, {
                        h: 30,
                        s: -30,
                        l: -(-10 + 4 * i)
                    });
                    this["surfacePeer" + i] = this["surfacePeer" + i] || methods_adjust(this.mainBkg, {
                        h: 30,
                        s: -30,
                        l: -(-7 + 4 * i)
                    });
                }
                this.scaleLabelColor = this.scaleLabelColor || (this.darkMode ? "black" : this.labelTextColor);
                for(let i = 0; i < this.THEME_COLOR_LIMIT; i++)this["cScaleLabel" + i] = this["cScaleLabel" + i] || this.scaleLabelColor;
                for(let i = 0; i < this.THEME_COLOR_LIMIT; i++)this["pie" + i] = this["cScale" + i];
                this.pieTitleTextSize = this.pieTitleTextSize || "25px";
                this.pieTitleTextColor = this.pieTitleTextColor || this.taskTextDarkColor;
                this.pieSectionTextSize = this.pieSectionTextSize || "17px";
                this.pieSectionTextColor = this.pieSectionTextColor || this.textColor;
                this.pieLegendTextSize = this.pieLegendTextSize || "17px";
                this.pieLegendTextColor = this.pieLegendTextColor || this.taskTextDarkColor;
                this.pieStrokeColor = this.pieStrokeColor || "black";
                this.pieStrokeWidth = this.pieStrokeWidth || "2px";
                this.pieOuterStrokeWidth = this.pieOuterStrokeWidth || "2px";
                this.pieOuterStrokeColor = this.pieOuterStrokeColor || "black";
                this.pieOpacity = this.pieOpacity || "0.7";
                this.quadrant1Fill = this.quadrant1Fill || this.primaryColor;
                this.quadrant2Fill = this.quadrant2Fill || methods_adjust(this.primaryColor, {
                    r: 5,
                    g: 5,
                    b: 5
                });
                this.quadrant3Fill = this.quadrant3Fill || methods_adjust(this.primaryColor, {
                    r: 10,
                    g: 10,
                    b: 10
                });
                this.quadrant4Fill = this.quadrant4Fill || methods_adjust(this.primaryColor, {
                    r: 15,
                    g: 15,
                    b: 15
                });
                this.quadrant1TextFill = this.quadrant1TextFill || this.primaryTextColor;
                this.quadrant2TextFill = this.quadrant2TextFill || methods_adjust(this.primaryTextColor, {
                    r: -5,
                    g: -5,
                    b: -5
                });
                this.quadrant3TextFill = this.quadrant3TextFill || methods_adjust(this.primaryTextColor, {
                    r: -10,
                    g: -10,
                    b: -10
                });
                this.quadrant4TextFill = this.quadrant4TextFill || methods_adjust(this.primaryTextColor, {
                    r: -15,
                    g: -15,
                    b: -15
                });
                this.quadrantPointFill = this.quadrantPointFill || (0, is_dark.Z)(this.quadrant1Fill) ? (0, lighten.Z)(this.quadrant1Fill) : (0, darken.Z)(this.quadrant1Fill);
                this.quadrantPointTextFill = this.quadrantPointTextFill || this.primaryTextColor;
                this.quadrantXAxisTextFill = this.quadrantXAxisTextFill || this.primaryTextColor;
                this.quadrantYAxisTextFill = this.quadrantYAxisTextFill || this.primaryTextColor;
                this.quadrantInternalBorderStrokeFill = this.quadrantInternalBorderStrokeFill || this.primaryBorderColor;
                this.quadrantExternalBorderStrokeFill = this.quadrantExternalBorderStrokeFill || this.primaryBorderColor;
                this.quadrantTitleFill = this.quadrantTitleFill || this.primaryTextColor;
                this.xyChart = {
                    backgroundColor: this.xyChart?.backgroundColor || this.background,
                    titleColor: this.xyChart?.titleColor || this.primaryTextColor,
                    xAxisTitleColor: this.xyChart?.xAxisTitleColor || this.primaryTextColor,
                    xAxisLabelColor: this.xyChart?.xAxisLabelColor || this.primaryTextColor,
                    xAxisTickColor: this.xyChart?.xAxisTickColor || this.primaryTextColor,
                    xAxisLineColor: this.xyChart?.xAxisLineColor || this.primaryTextColor,
                    yAxisTitleColor: this.xyChart?.yAxisTitleColor || this.primaryTextColor,
                    yAxisLabelColor: this.xyChart?.yAxisLabelColor || this.primaryTextColor,
                    yAxisTickColor: this.xyChart?.yAxisTickColor || this.primaryTextColor,
                    yAxisLineColor: this.xyChart?.yAxisLineColor || this.primaryTextColor,
                    plotColorPalette: this.xyChart?.plotColorPalette || "#3498db,#2ecc71,#e74c3c,#f1c40f,#bdc3c7,#ffffff,#34495e,#9b59b6,#1abc9c,#e67e22"
                };
                this.packet = {
                    startByteColor: this.primaryTextColor,
                    endByteColor: this.primaryTextColor,
                    labelColor: this.primaryTextColor,
                    titleColor: this.primaryTextColor,
                    blockStrokeColor: this.primaryTextColor,
                    blockFillColor: this.background
                };
                this.classText = this.primaryTextColor;
                this.requirementBackground = this.requirementBackground || this.primaryColor;
                this.requirementBorderColor = this.requirementBorderColor || this.primaryBorderColor;
                this.requirementBorderSize = this.requirementBorderSize || "1";
                this.requirementTextColor = this.requirementTextColor || this.primaryTextColor;
                this.relationColor = this.relationColor || this.lineColor;
                this.relationLabelBackground = this.relationLabelBackground || (this.darkMode ? (0, darken.Z)(this.secondaryColor, 30) : this.secondaryColor);
                this.relationLabelColor = this.relationLabelColor || this.actorTextColor;
                this.git0 = (0, lighten.Z)(this.secondaryColor, 20);
                this.git1 = (0, lighten.Z)(this.pie2 || this.secondaryColor, 20);
                this.git2 = (0, lighten.Z)(this.pie3 || this.tertiaryColor, 20);
                this.git3 = (0, lighten.Z)(this.pie4 || methods_adjust(this.primaryColor, {
                    h: -30
                }), 20);
                this.git4 = (0, lighten.Z)(this.pie5 || methods_adjust(this.primaryColor, {
                    h: -60
                }), 20);
                this.git5 = (0, lighten.Z)(this.pie6 || methods_adjust(this.primaryColor, {
                    h: -90
                }), 10);
                this.git6 = (0, lighten.Z)(this.pie7 || methods_adjust(this.primaryColor, {
                    h: 60
                }), 10);
                this.git7 = (0, lighten.Z)(this.pie8 || methods_adjust(this.primaryColor, {
                    h: 120
                }), 20);
                this.gitInv0 = this.gitInv0 || invert(this.git0);
                this.gitInv1 = this.gitInv1 || invert(this.git1);
                this.gitInv2 = this.gitInv2 || invert(this.git2);
                this.gitInv3 = this.gitInv3 || invert(this.git3);
                this.gitInv4 = this.gitInv4 || invert(this.git4);
                this.gitInv5 = this.gitInv5 || invert(this.git5);
                this.gitInv6 = this.gitInv6 || invert(this.git6);
                this.gitInv7 = this.gitInv7 || invert(this.git7);
                this.gitBranchLabel0 = this.gitBranchLabel0 || invert(this.labelTextColor);
                this.gitBranchLabel1 = this.gitBranchLabel1 || this.labelTextColor;
                this.gitBranchLabel2 = this.gitBranchLabel2 || this.labelTextColor;
                this.gitBranchLabel3 = this.gitBranchLabel3 || invert(this.labelTextColor);
                this.gitBranchLabel4 = this.gitBranchLabel4 || this.labelTextColor;
                this.gitBranchLabel5 = this.gitBranchLabel5 || this.labelTextColor;
                this.gitBranchLabel6 = this.gitBranchLabel6 || this.labelTextColor;
                this.gitBranchLabel7 = this.gitBranchLabel7 || this.labelTextColor;
                this.tagLabelColor = this.tagLabelColor || this.primaryTextColor;
                this.tagLabelBackground = this.tagLabelBackground || this.primaryColor;
                this.tagLabelBorder = this.tagBorder || this.primaryBorderColor;
                this.tagLabelFontSize = this.tagLabelFontSize || "10px";
                this.commitLabelColor = this.commitLabelColor || this.secondaryTextColor;
                this.commitLabelBackground = this.commitLabelBackground || this.secondaryColor;
                this.commitLabelFontSize = this.commitLabelFontSize || "10px";
                this.attributeBackgroundColorOdd = this.attributeBackgroundColorOdd || (0, lighten.Z)(this.background, 12);
                this.attributeBackgroundColorEven = this.attributeBackgroundColorEven || (0, lighten.Z)(this.background, 2);
                this.nodeBorder = this.nodeBorder || "#999";
            }
            calculate(overrides) {
                if ("object" != typeof overrides) {
                    this.updateColors();
                    return;
                }
                const keys = Object.keys(overrides);
                keys.forEach((k)=>{
                    this[k] = overrides[k];
                });
                this.updateColors();
                keys.forEach((k)=>{
                    this[k] = overrides[k];
                });
            }
        };
        var getThemeVariables2 = /* @__PURE__ */ __name((userOverrides)=>{
            const theme = new Theme2();
            theme.calculate(userOverrides);
            return theme;
        }, "getThemeVariables");
        var Theme3 = class {
            static{
                __name(this, "Theme");
            }
            constructor(){
                this.background = "#f4f4f4";
                this.primaryColor = "#ECECFF";
                this.secondaryColor = methods_adjust(this.primaryColor, {
                    h: 120
                });
                this.secondaryColor = "#ffffde";
                this.tertiaryColor = methods_adjust(this.primaryColor, {
                    h: -160
                });
                this.primaryBorderColor = mkBorder(this.primaryColor, this.darkMode);
                this.secondaryBorderColor = mkBorder(this.secondaryColor, this.darkMode);
                this.tertiaryBorderColor = mkBorder(this.tertiaryColor, this.darkMode);
                this.primaryTextColor = invert(this.primaryColor);
                this.secondaryTextColor = invert(this.secondaryColor);
                this.tertiaryTextColor = invert(this.tertiaryColor);
                this.lineColor = invert(this.background);
                this.textColor = invert(this.background);
                this.background = "white";
                this.mainBkg = "#ECECFF";
                this.secondBkg = "#ffffde";
                this.lineColor = "#333333";
                this.border1 = "#9370DB";
                this.border2 = "#aaaa33";
                this.arrowheadColor = "#333333";
                this.fontFamily = '"trebuchet ms", verdana, arial, sans-serif';
                this.fontSize = "16px";
                this.labelBackground = "rgba(232,232,232, 0.8)";
                this.textColor = "#333";
                this.THEME_COLOR_LIMIT = 12;
                this.nodeBkg = "calculated";
                this.nodeBorder = "calculated";
                this.clusterBkg = "calculated";
                this.clusterBorder = "calculated";
                this.defaultLinkColor = "calculated";
                this.titleColor = "calculated";
                this.edgeLabelBackground = "calculated";
                this.actorBorder = "calculated";
                this.actorBkg = "calculated";
                this.actorTextColor = "black";
                this.actorLineColor = "calculated";
                this.signalColor = "calculated";
                this.signalTextColor = "calculated";
                this.labelBoxBkgColor = "calculated";
                this.labelBoxBorderColor = "calculated";
                this.labelTextColor = "calculated";
                this.loopTextColor = "calculated";
                this.noteBorderColor = "calculated";
                this.noteBkgColor = "#fff5ad";
                this.noteTextColor = "calculated";
                this.activationBorderColor = "#666";
                this.activationBkgColor = "#f4f4f4";
                this.sequenceNumberColor = "white";
                this.sectionBkgColor = "calculated";
                this.altSectionBkgColor = "calculated";
                this.sectionBkgColor2 = "calculated";
                this.excludeBkgColor = "#eeeeee";
                this.taskBorderColor = "calculated";
                this.taskBkgColor = "calculated";
                this.taskTextLightColor = "calculated";
                this.taskTextColor = this.taskTextLightColor;
                this.taskTextDarkColor = "calculated";
                this.taskTextOutsideColor = this.taskTextDarkColor;
                this.taskTextClickableColor = "calculated";
                this.activeTaskBorderColor = "calculated";
                this.activeTaskBkgColor = "calculated";
                this.gridColor = "calculated";
                this.doneTaskBkgColor = "calculated";
                this.doneTaskBorderColor = "calculated";
                this.critBorderColor = "calculated";
                this.critBkgColor = "calculated";
                this.todayLineColor = "calculated";
                this.sectionBkgColor = (0, rgba.Z)(102, 102, 255, 0.49);
                this.altSectionBkgColor = "white";
                this.sectionBkgColor2 = "#fff400";
                this.taskBorderColor = "#534fbc";
                this.taskBkgColor = "#8a90dd";
                this.taskTextLightColor = "white";
                this.taskTextColor = "calculated";
                this.taskTextDarkColor = "black";
                this.taskTextOutsideColor = "calculated";
                this.taskTextClickableColor = "#003163";
                this.activeTaskBorderColor = "#534fbc";
                this.activeTaskBkgColor = "#bfc7ff";
                this.gridColor = "lightgrey";
                this.doneTaskBkgColor = "lightgrey";
                this.doneTaskBorderColor = "grey";
                this.critBorderColor = "#ff8888";
                this.critBkgColor = "red";
                this.todayLineColor = "red";
                this.personBorder = this.primaryBorderColor;
                this.personBkg = this.mainBkg;
                this.archEdgeColor = "calculated";
                this.archEdgeArrowColor = "calculated";
                this.archEdgeWidth = "3";
                this.archGroupBorderColor = this.primaryBorderColor;
                this.archGroupBorderWidth = "2px";
                this.labelColor = "black";
                this.errorBkgColor = "#552222";
                this.errorTextColor = "#552222";
                this.updateColors();
            }
            updateColors() {
                this.cScale0 = this.cScale0 || this.primaryColor;
                this.cScale1 = this.cScale1 || this.secondaryColor;
                this.cScale2 = this.cScale2 || this.tertiaryColor;
                this.cScale3 = this.cScale3 || methods_adjust(this.primaryColor, {
                    h: 30
                });
                this.cScale4 = this.cScale4 || methods_adjust(this.primaryColor, {
                    h: 60
                });
                this.cScale5 = this.cScale5 || methods_adjust(this.primaryColor, {
                    h: 90
                });
                this.cScale6 = this.cScale6 || methods_adjust(this.primaryColor, {
                    h: 120
                });
                this.cScale7 = this.cScale7 || methods_adjust(this.primaryColor, {
                    h: 150
                });
                this.cScale8 = this.cScale8 || methods_adjust(this.primaryColor, {
                    h: 210
                });
                this.cScale9 = this.cScale9 || methods_adjust(this.primaryColor, {
                    h: 270
                });
                this.cScale10 = this.cScale10 || methods_adjust(this.primaryColor, {
                    h: 300
                });
                this.cScale11 = this.cScale11 || methods_adjust(this.primaryColor, {
                    h: 330
                });
                this["cScalePeer1"] = this["cScalePeer1"] || (0, darken.Z)(this.secondaryColor, 45);
                this["cScalePeer2"] = this["cScalePeer2"] || (0, darken.Z)(this.tertiaryColor, 40);
                for(let i = 0; i < this.THEME_COLOR_LIMIT; i++){
                    this["cScale" + i] = (0, darken.Z)(this["cScale" + i], 10);
                    this["cScalePeer" + i] = this["cScalePeer" + i] || (0, darken.Z)(this["cScale" + i], 25);
                }
                for(let i = 0; i < this.THEME_COLOR_LIMIT; i++)this["cScaleInv" + i] = this["cScaleInv" + i] || methods_adjust(this["cScale" + i], {
                    h: 180
                });
                for(let i = 0; i < 5; i++){
                    this["surface" + i] = this["surface" + i] || methods_adjust(this.mainBkg, {
                        h: 30,
                        l: -(5 + 5 * i)
                    });
                    this["surfacePeer" + i] = this["surfacePeer" + i] || methods_adjust(this.mainBkg, {
                        h: 30,
                        l: -(7 + 5 * i)
                    });
                }
                this.scaleLabelColor = "calculated" !== this.scaleLabelColor && this.scaleLabelColor ? this.scaleLabelColor : this.labelTextColor;
                if ("calculated" !== this.labelTextColor) {
                    this.cScaleLabel0 = this.cScaleLabel0 || invert(this.labelTextColor);
                    this.cScaleLabel3 = this.cScaleLabel3 || invert(this.labelTextColor);
                    for(let i = 0; i < this.THEME_COLOR_LIMIT; i++)this["cScaleLabel" + i] = this["cScaleLabel" + i] || this.labelTextColor;
                }
                this.nodeBkg = this.mainBkg;
                this.nodeBorder = this.border1;
                this.clusterBkg = this.secondBkg;
                this.clusterBorder = this.border2;
                this.defaultLinkColor = this.lineColor;
                this.titleColor = this.textColor;
                this.edgeLabelBackground = this.labelBackground;
                this.actorBorder = (0, lighten.Z)(this.border1, 23);
                this.actorBkg = this.mainBkg;
                this.labelBoxBkgColor = this.actorBkg;
                this.signalColor = this.textColor;
                this.signalTextColor = this.textColor;
                this.labelBoxBorderColor = this.actorBorder;
                this.labelTextColor = this.actorTextColor;
                this.loopTextColor = this.actorTextColor;
                this.noteBorderColor = this.border2;
                this.noteTextColor = this.actorTextColor;
                this.actorLineColor = this.actorBorder;
                this.taskTextColor = this.taskTextLightColor;
                this.taskTextOutsideColor = this.taskTextDarkColor;
                this.archEdgeColor = this.lineColor;
                this.archEdgeArrowColor = this.lineColor;
                this.transitionColor = this.transitionColor || this.lineColor;
                this.transitionLabelColor = this.transitionLabelColor || this.textColor;
                this.stateLabelColor = this.stateLabelColor || this.stateBkg || this.primaryTextColor;
                this.stateBkg = this.stateBkg || this.mainBkg;
                this.labelBackgroundColor = this.labelBackgroundColor || this.stateBkg;
                this.compositeBackground = this.compositeBackground || this.background || this.tertiaryColor;
                this.altBackground = this.altBackground || "#f0f0f0";
                this.compositeTitleBackground = this.compositeTitleBackground || this.mainBkg;
                this.compositeBorder = this.compositeBorder || this.nodeBorder;
                this.innerEndBackground = this.nodeBorder;
                this.specialStateColor = this.lineColor;
                this.errorBkgColor = this.errorBkgColor || this.tertiaryColor;
                this.errorTextColor = this.errorTextColor || this.tertiaryTextColor;
                this.transitionColor = this.transitionColor || this.lineColor;
                this.classText = this.primaryTextColor;
                this.fillType0 = this.primaryColor;
                this.fillType1 = this.secondaryColor;
                this.fillType2 = methods_adjust(this.primaryColor, {
                    h: 64
                });
                this.fillType3 = methods_adjust(this.secondaryColor, {
                    h: 64
                });
                this.fillType4 = methods_adjust(this.primaryColor, {
                    h: -64
                });
                this.fillType5 = methods_adjust(this.secondaryColor, {
                    h: -64
                });
                this.fillType6 = methods_adjust(this.primaryColor, {
                    h: 128
                });
                this.fillType7 = methods_adjust(this.secondaryColor, {
                    h: 128
                });
                this.pie1 = this.pie1 || this.primaryColor;
                this.pie2 = this.pie2 || this.secondaryColor;
                this.pie3 = this.pie3 || methods_adjust(this.tertiaryColor, {
                    l: -40
                });
                this.pie4 = this.pie4 || methods_adjust(this.primaryColor, {
                    l: -10
                });
                this.pie5 = this.pie5 || methods_adjust(this.secondaryColor, {
                    l: -30
                });
                this.pie6 = this.pie6 || methods_adjust(this.tertiaryColor, {
                    l: -20
                });
                this.pie7 = this.pie7 || methods_adjust(this.primaryColor, {
                    h: 60,
                    l: -20
                });
                this.pie8 = this.pie8 || methods_adjust(this.primaryColor, {
                    h: -60,
                    l: -40
                });
                this.pie9 = this.pie9 || methods_adjust(this.primaryColor, {
                    h: 120,
                    l: -40
                });
                this.pie10 = this.pie10 || methods_adjust(this.primaryColor, {
                    h: 60,
                    l: -40
                });
                this.pie11 = this.pie11 || methods_adjust(this.primaryColor, {
                    h: -90,
                    l: -40
                });
                this.pie12 = this.pie12 || methods_adjust(this.primaryColor, {
                    h: 120,
                    l: -30
                });
                this.pieTitleTextSize = this.pieTitleTextSize || "25px";
                this.pieTitleTextColor = this.pieTitleTextColor || this.taskTextDarkColor;
                this.pieSectionTextSize = this.pieSectionTextSize || "17px";
                this.pieSectionTextColor = this.pieSectionTextColor || this.textColor;
                this.pieLegendTextSize = this.pieLegendTextSize || "17px";
                this.pieLegendTextColor = this.pieLegendTextColor || this.taskTextDarkColor;
                this.pieStrokeColor = this.pieStrokeColor || "black";
                this.pieStrokeWidth = this.pieStrokeWidth || "2px";
                this.pieOuterStrokeWidth = this.pieOuterStrokeWidth || "2px";
                this.pieOuterStrokeColor = this.pieOuterStrokeColor || "black";
                this.pieOpacity = this.pieOpacity || "0.7";
                this.quadrant1Fill = this.quadrant1Fill || this.primaryColor;
                this.quadrant2Fill = this.quadrant2Fill || methods_adjust(this.primaryColor, {
                    r: 5,
                    g: 5,
                    b: 5
                });
                this.quadrant3Fill = this.quadrant3Fill || methods_adjust(this.primaryColor, {
                    r: 10,
                    g: 10,
                    b: 10
                });
                this.quadrant4Fill = this.quadrant4Fill || methods_adjust(this.primaryColor, {
                    r: 15,
                    g: 15,
                    b: 15
                });
                this.quadrant1TextFill = this.quadrant1TextFill || this.primaryTextColor;
                this.quadrant2TextFill = this.quadrant2TextFill || methods_adjust(this.primaryTextColor, {
                    r: -5,
                    g: -5,
                    b: -5
                });
                this.quadrant3TextFill = this.quadrant3TextFill || methods_adjust(this.primaryTextColor, {
                    r: -10,
                    g: -10,
                    b: -10
                });
                this.quadrant4TextFill = this.quadrant4TextFill || methods_adjust(this.primaryTextColor, {
                    r: -15,
                    g: -15,
                    b: -15
                });
                this.quadrantPointFill = this.quadrantPointFill || (0, is_dark.Z)(this.quadrant1Fill) ? (0, lighten.Z)(this.quadrant1Fill) : (0, darken.Z)(this.quadrant1Fill);
                this.quadrantPointTextFill = this.quadrantPointTextFill || this.primaryTextColor;
                this.quadrantXAxisTextFill = this.quadrantXAxisTextFill || this.primaryTextColor;
                this.quadrantYAxisTextFill = this.quadrantYAxisTextFill || this.primaryTextColor;
                this.quadrantInternalBorderStrokeFill = this.quadrantInternalBorderStrokeFill || this.primaryBorderColor;
                this.quadrantExternalBorderStrokeFill = this.quadrantExternalBorderStrokeFill || this.primaryBorderColor;
                this.quadrantTitleFill = this.quadrantTitleFill || this.primaryTextColor;
                this.xyChart = {
                    backgroundColor: this.xyChart?.backgroundColor || this.background,
                    titleColor: this.xyChart?.titleColor || this.primaryTextColor,
                    xAxisTitleColor: this.xyChart?.xAxisTitleColor || this.primaryTextColor,
                    xAxisLabelColor: this.xyChart?.xAxisLabelColor || this.primaryTextColor,
                    xAxisTickColor: this.xyChart?.xAxisTickColor || this.primaryTextColor,
                    xAxisLineColor: this.xyChart?.xAxisLineColor || this.primaryTextColor,
                    yAxisTitleColor: this.xyChart?.yAxisTitleColor || this.primaryTextColor,
                    yAxisLabelColor: this.xyChart?.yAxisLabelColor || this.primaryTextColor,
                    yAxisTickColor: this.xyChart?.yAxisTickColor || this.primaryTextColor,
                    yAxisLineColor: this.xyChart?.yAxisLineColor || this.primaryTextColor,
                    plotColorPalette: this.xyChart?.plotColorPalette || "#ECECFF,#8493A6,#FFC3A0,#DCDDE1,#B8E994,#D1A36F,#C3CDE6,#FFB6C1,#496078,#F8F3E3"
                };
                this.requirementBackground = this.requirementBackground || this.primaryColor;
                this.requirementBorderColor = this.requirementBorderColor || this.primaryBorderColor;
                this.requirementBorderSize = this.requirementBorderSize || "1";
                this.requirementTextColor = this.requirementTextColor || this.primaryTextColor;
                this.relationColor = this.relationColor || this.lineColor;
                this.relationLabelBackground = this.relationLabelBackground || this.labelBackground;
                this.relationLabelColor = this.relationLabelColor || this.actorTextColor;
                this.git0 = this.git0 || this.primaryColor;
                this.git1 = this.git1 || this.secondaryColor;
                this.git2 = this.git2 || this.tertiaryColor;
                this.git3 = this.git3 || methods_adjust(this.primaryColor, {
                    h: -30
                });
                this.git4 = this.git4 || methods_adjust(this.primaryColor, {
                    h: -60
                });
                this.git5 = this.git5 || methods_adjust(this.primaryColor, {
                    h: -90
                });
                this.git6 = this.git6 || methods_adjust(this.primaryColor, {
                    h: 60
                });
                this.git7 = this.git7 || methods_adjust(this.primaryColor, {
                    h: 120
                });
                if (this.darkMode) {
                    this.git0 = (0, lighten.Z)(this.git0, 25);
                    this.git1 = (0, lighten.Z)(this.git1, 25);
                    this.git2 = (0, lighten.Z)(this.git2, 25);
                    this.git3 = (0, lighten.Z)(this.git3, 25);
                    this.git4 = (0, lighten.Z)(this.git4, 25);
                    this.git5 = (0, lighten.Z)(this.git5, 25);
                    this.git6 = (0, lighten.Z)(this.git6, 25);
                    this.git7 = (0, lighten.Z)(this.git7, 25);
                } else {
                    this.git0 = (0, darken.Z)(this.git0, 25);
                    this.git1 = (0, darken.Z)(this.git1, 25);
                    this.git2 = (0, darken.Z)(this.git2, 25);
                    this.git3 = (0, darken.Z)(this.git3, 25);
                    this.git4 = (0, darken.Z)(this.git4, 25);
                    this.git5 = (0, darken.Z)(this.git5, 25);
                    this.git6 = (0, darken.Z)(this.git6, 25);
                    this.git7 = (0, darken.Z)(this.git7, 25);
                }
                this.gitInv0 = this.gitInv0 || (0, darken.Z)(invert(this.git0), 25);
                this.gitInv1 = this.gitInv1 || invert(this.git1);
                this.gitInv2 = this.gitInv2 || invert(this.git2);
                this.gitInv3 = this.gitInv3 || invert(this.git3);
                this.gitInv4 = this.gitInv4 || invert(this.git4);
                this.gitInv5 = this.gitInv5 || invert(this.git5);
                this.gitInv6 = this.gitInv6 || invert(this.git6);
                this.gitInv7 = this.gitInv7 || invert(this.git7);
                this.gitBranchLabel0 = this.gitBranchLabel0 || invert(this.labelTextColor);
                this.gitBranchLabel1 = this.gitBranchLabel1 || this.labelTextColor;
                this.gitBranchLabel2 = this.gitBranchLabel2 || this.labelTextColor;
                this.gitBranchLabel3 = this.gitBranchLabel3 || invert(this.labelTextColor);
                this.gitBranchLabel4 = this.gitBranchLabel4 || this.labelTextColor;
                this.gitBranchLabel5 = this.gitBranchLabel5 || this.labelTextColor;
                this.gitBranchLabel6 = this.gitBranchLabel6 || this.labelTextColor;
                this.gitBranchLabel7 = this.gitBranchLabel7 || this.labelTextColor;
                this.tagLabelColor = this.tagLabelColor || this.primaryTextColor;
                this.tagLabelBackground = this.tagLabelBackground || this.primaryColor;
                this.tagLabelBorder = this.tagBorder || this.primaryBorderColor;
                this.tagLabelFontSize = this.tagLabelFontSize || "10px";
                this.commitLabelColor = this.commitLabelColor || this.secondaryTextColor;
                this.commitLabelBackground = this.commitLabelBackground || this.secondaryColor;
                this.commitLabelFontSize = this.commitLabelFontSize || "10px";
                this.attributeBackgroundColorOdd = this.attributeBackgroundColorOdd || oldAttributeBackgroundColorOdd;
                this.attributeBackgroundColorEven = this.attributeBackgroundColorEven || oldAttributeBackgroundColorEven;
            }
            calculate(overrides) {
                if ("object" != typeof overrides) {
                    this.updateColors();
                    return;
                }
                const keys = Object.keys(overrides);
                keys.forEach((k)=>{
                    this[k] = overrides[k];
                });
                this.updateColors();
                keys.forEach((k)=>{
                    this[k] = overrides[k];
                });
            }
        };
        var getThemeVariables3 = /* @__PURE__ */ __name((userOverrides)=>{
            const theme = new Theme3();
            theme.calculate(userOverrides);
            return theme;
        }, "getThemeVariables");
        var Theme4 = class {
            static{
                __name(this, "Theme");
            }
            constructor(){
                this.background = "#f4f4f4";
                this.primaryColor = "#cde498";
                this.secondaryColor = "#cdffb2";
                this.background = "white";
                this.mainBkg = "#cde498";
                this.secondBkg = "#cdffb2";
                this.lineColor = "green";
                this.border1 = "#13540c";
                this.border2 = "#6eaa49";
                this.arrowheadColor = "green";
                this.fontFamily = '"trebuchet ms", verdana, arial, sans-serif';
                this.fontSize = "16px";
                this.tertiaryColor = (0, lighten.Z)("#cde498", 10);
                this.primaryBorderColor = mkBorder(this.primaryColor, this.darkMode);
                this.secondaryBorderColor = mkBorder(this.secondaryColor, this.darkMode);
                this.tertiaryBorderColor = mkBorder(this.tertiaryColor, this.darkMode);
                this.primaryTextColor = invert(this.primaryColor);
                this.secondaryTextColor = invert(this.secondaryColor);
                this.tertiaryTextColor = invert(this.primaryColor);
                this.lineColor = invert(this.background);
                this.textColor = invert(this.background);
                this.THEME_COLOR_LIMIT = 12;
                this.nodeBkg = "calculated";
                this.nodeBorder = "calculated";
                this.clusterBkg = "calculated";
                this.clusterBorder = "calculated";
                this.defaultLinkColor = "calculated";
                this.titleColor = "#333";
                this.edgeLabelBackground = "#e8e8e8";
                this.actorBorder = "calculated";
                this.actorBkg = "calculated";
                this.actorTextColor = "black";
                this.actorLineColor = "calculated";
                this.signalColor = "#333";
                this.signalTextColor = "#333";
                this.labelBoxBkgColor = "calculated";
                this.labelBoxBorderColor = "#326932";
                this.labelTextColor = "calculated";
                this.loopTextColor = "calculated";
                this.noteBorderColor = "calculated";
                this.noteBkgColor = "#fff5ad";
                this.noteTextColor = "calculated";
                this.activationBorderColor = "#666";
                this.activationBkgColor = "#f4f4f4";
                this.sequenceNumberColor = "white";
                this.sectionBkgColor = "#6eaa49";
                this.altSectionBkgColor = "white";
                this.sectionBkgColor2 = "#6eaa49";
                this.excludeBkgColor = "#eeeeee";
                this.taskBorderColor = "calculated";
                this.taskBkgColor = "#487e3a";
                this.taskTextLightColor = "white";
                this.taskTextColor = "calculated";
                this.taskTextDarkColor = "black";
                this.taskTextOutsideColor = "calculated";
                this.taskTextClickableColor = "#003163";
                this.activeTaskBorderColor = "calculated";
                this.activeTaskBkgColor = "calculated";
                this.gridColor = "lightgrey";
                this.doneTaskBkgColor = "lightgrey";
                this.doneTaskBorderColor = "grey";
                this.critBorderColor = "#ff8888";
                this.critBkgColor = "red";
                this.todayLineColor = "red";
                this.personBorder = this.primaryBorderColor;
                this.personBkg = this.mainBkg;
                this.archEdgeColor = "calculated";
                this.archEdgeArrowColor = "calculated";
                this.archEdgeWidth = "3";
                this.archGroupBorderColor = this.primaryBorderColor;
                this.archGroupBorderWidth = "2px";
                this.labelColor = "black";
                this.errorBkgColor = "#552222";
                this.errorTextColor = "#552222";
            }
            updateColors() {
                this.actorBorder = (0, darken.Z)(this.mainBkg, 20);
                this.actorBkg = this.mainBkg;
                this.labelBoxBkgColor = this.actorBkg;
                this.labelTextColor = this.actorTextColor;
                this.loopTextColor = this.actorTextColor;
                this.noteBorderColor = this.border2;
                this.noteTextColor = this.actorTextColor;
                this.actorLineColor = this.actorBorder;
                this.cScale0 = this.cScale0 || this.primaryColor;
                this.cScale1 = this.cScale1 || this.secondaryColor;
                this.cScale2 = this.cScale2 || this.tertiaryColor;
                this.cScale3 = this.cScale3 || methods_adjust(this.primaryColor, {
                    h: 30
                });
                this.cScale4 = this.cScale4 || methods_adjust(this.primaryColor, {
                    h: 60
                });
                this.cScale5 = this.cScale5 || methods_adjust(this.primaryColor, {
                    h: 90
                });
                this.cScale6 = this.cScale6 || methods_adjust(this.primaryColor, {
                    h: 120
                });
                this.cScale7 = this.cScale7 || methods_adjust(this.primaryColor, {
                    h: 150
                });
                this.cScale8 = this.cScale8 || methods_adjust(this.primaryColor, {
                    h: 210
                });
                this.cScale9 = this.cScale9 || methods_adjust(this.primaryColor, {
                    h: 270
                });
                this.cScale10 = this.cScale10 || methods_adjust(this.primaryColor, {
                    h: 300
                });
                this.cScale11 = this.cScale11 || methods_adjust(this.primaryColor, {
                    h: 330
                });
                this["cScalePeer1"] = this["cScalePeer1"] || (0, darken.Z)(this.secondaryColor, 45);
                this["cScalePeer2"] = this["cScalePeer2"] || (0, darken.Z)(this.tertiaryColor, 40);
                for(let i = 0; i < this.THEME_COLOR_LIMIT; i++){
                    this["cScale" + i] = (0, darken.Z)(this["cScale" + i], 10);
                    this["cScalePeer" + i] = this["cScalePeer" + i] || (0, darken.Z)(this["cScale" + i], 25);
                }
                for(let i = 0; i < this.THEME_COLOR_LIMIT; i++)this["cScaleInv" + i] = this["cScaleInv" + i] || methods_adjust(this["cScale" + i], {
                    h: 180
                });
                this.scaleLabelColor = "calculated" !== this.scaleLabelColor && this.scaleLabelColor ? this.scaleLabelColor : this.labelTextColor;
                for(let i = 0; i < this.THEME_COLOR_LIMIT; i++)this["cScaleLabel" + i] = this["cScaleLabel" + i] || this.scaleLabelColor;
                for(let i = 0; i < 5; i++){
                    this["surface" + i] = this["surface" + i] || methods_adjust(this.mainBkg, {
                        h: 30,
                        s: -30,
                        l: -(5 + 5 * i)
                    });
                    this["surfacePeer" + i] = this["surfacePeer" + i] || methods_adjust(this.mainBkg, {
                        h: 30,
                        s: -30,
                        l: -(8 + 5 * i)
                    });
                }
                this.nodeBkg = this.mainBkg;
                this.nodeBorder = this.border1;
                this.clusterBkg = this.secondBkg;
                this.clusterBorder = this.border2;
                this.defaultLinkColor = this.lineColor;
                this.taskBorderColor = this.border1;
                this.taskTextColor = this.taskTextLightColor;
                this.taskTextOutsideColor = this.taskTextDarkColor;
                this.activeTaskBorderColor = this.taskBorderColor;
                this.activeTaskBkgColor = this.mainBkg;
                this.archEdgeColor = this.lineColor;
                this.archEdgeArrowColor = this.lineColor;
                this.transitionColor = this.transitionColor || this.lineColor;
                this.transitionLabelColor = this.transitionLabelColor || this.textColor;
                this.stateLabelColor = this.stateLabelColor || this.stateBkg || this.primaryTextColor;
                this.stateBkg = this.stateBkg || this.mainBkg;
                this.labelBackgroundColor = this.labelBackgroundColor || this.stateBkg;
                this.compositeBackground = this.compositeBackground || this.background || this.tertiaryColor;
                this.altBackground = this.altBackground || "#f0f0f0";
                this.compositeTitleBackground = this.compositeTitleBackground || this.mainBkg;
                this.compositeBorder = this.compositeBorder || this.nodeBorder;
                this.innerEndBackground = this.primaryBorderColor;
                this.specialStateColor = this.lineColor;
                this.errorBkgColor = this.errorBkgColor || this.tertiaryColor;
                this.errorTextColor = this.errorTextColor || this.tertiaryTextColor;
                this.transitionColor = this.transitionColor || this.lineColor;
                this.classText = this.primaryTextColor;
                this.fillType0 = this.primaryColor;
                this.fillType1 = this.secondaryColor;
                this.fillType2 = methods_adjust(this.primaryColor, {
                    h: 64
                });
                this.fillType3 = methods_adjust(this.secondaryColor, {
                    h: 64
                });
                this.fillType4 = methods_adjust(this.primaryColor, {
                    h: -64
                });
                this.fillType5 = methods_adjust(this.secondaryColor, {
                    h: -64
                });
                this.fillType6 = methods_adjust(this.primaryColor, {
                    h: 128
                });
                this.fillType7 = methods_adjust(this.secondaryColor, {
                    h: 128
                });
                this.pie1 = this.pie1 || this.primaryColor;
                this.pie2 = this.pie2 || this.secondaryColor;
                this.pie3 = this.pie3 || this.tertiaryColor;
                this.pie4 = this.pie4 || methods_adjust(this.primaryColor, {
                    l: -30
                });
                this.pie5 = this.pie5 || methods_adjust(this.secondaryColor, {
                    l: -30
                });
                this.pie6 = this.pie6 || methods_adjust(this.tertiaryColor, {
                    h: 40,
                    l: -40
                });
                this.pie7 = this.pie7 || methods_adjust(this.primaryColor, {
                    h: 60,
                    l: -10
                });
                this.pie8 = this.pie8 || methods_adjust(this.primaryColor, {
                    h: -60,
                    l: -10
                });
                this.pie9 = this.pie9 || methods_adjust(this.primaryColor, {
                    h: 120,
                    l: 0
                });
                this.pie10 = this.pie10 || methods_adjust(this.primaryColor, {
                    h: 60,
                    l: -50
                });
                this.pie11 = this.pie11 || methods_adjust(this.primaryColor, {
                    h: -60,
                    l: -50
                });
                this.pie12 = this.pie12 || methods_adjust(this.primaryColor, {
                    h: 120,
                    l: -50
                });
                this.pieTitleTextSize = this.pieTitleTextSize || "25px";
                this.pieTitleTextColor = this.pieTitleTextColor || this.taskTextDarkColor;
                this.pieSectionTextSize = this.pieSectionTextSize || "17px";
                this.pieSectionTextColor = this.pieSectionTextColor || this.textColor;
                this.pieLegendTextSize = this.pieLegendTextSize || "17px";
                this.pieLegendTextColor = this.pieLegendTextColor || this.taskTextDarkColor;
                this.pieStrokeColor = this.pieStrokeColor || "black";
                this.pieStrokeWidth = this.pieStrokeWidth || "2px";
                this.pieOuterStrokeWidth = this.pieOuterStrokeWidth || "2px";
                this.pieOuterStrokeColor = this.pieOuterStrokeColor || "black";
                this.pieOpacity = this.pieOpacity || "0.7";
                this.quadrant1Fill = this.quadrant1Fill || this.primaryColor;
                this.quadrant2Fill = this.quadrant2Fill || methods_adjust(this.primaryColor, {
                    r: 5,
                    g: 5,
                    b: 5
                });
                this.quadrant3Fill = this.quadrant3Fill || methods_adjust(this.primaryColor, {
                    r: 10,
                    g: 10,
                    b: 10
                });
                this.quadrant4Fill = this.quadrant4Fill || methods_adjust(this.primaryColor, {
                    r: 15,
                    g: 15,
                    b: 15
                });
                this.quadrant1TextFill = this.quadrant1TextFill || this.primaryTextColor;
                this.quadrant2TextFill = this.quadrant2TextFill || methods_adjust(this.primaryTextColor, {
                    r: -5,
                    g: -5,
                    b: -5
                });
                this.quadrant3TextFill = this.quadrant3TextFill || methods_adjust(this.primaryTextColor, {
                    r: -10,
                    g: -10,
                    b: -10
                });
                this.quadrant4TextFill = this.quadrant4TextFill || methods_adjust(this.primaryTextColor, {
                    r: -15,
                    g: -15,
                    b: -15
                });
                this.quadrantPointFill = this.quadrantPointFill || (0, is_dark.Z)(this.quadrant1Fill) ? (0, lighten.Z)(this.quadrant1Fill) : (0, darken.Z)(this.quadrant1Fill);
                this.quadrantPointTextFill = this.quadrantPointTextFill || this.primaryTextColor;
                this.quadrantXAxisTextFill = this.quadrantXAxisTextFill || this.primaryTextColor;
                this.quadrantYAxisTextFill = this.quadrantYAxisTextFill || this.primaryTextColor;
                this.quadrantInternalBorderStrokeFill = this.quadrantInternalBorderStrokeFill || this.primaryBorderColor;
                this.quadrantExternalBorderStrokeFill = this.quadrantExternalBorderStrokeFill || this.primaryBorderColor;
                this.quadrantTitleFill = this.quadrantTitleFill || this.primaryTextColor;
                this.packet = {
                    startByteColor: this.primaryTextColor,
                    endByteColor: this.primaryTextColor,
                    labelColor: this.primaryTextColor,
                    titleColor: this.primaryTextColor,
                    blockStrokeColor: this.primaryTextColor,
                    blockFillColor: this.mainBkg
                };
                this.xyChart = {
                    backgroundColor: this.xyChart?.backgroundColor || this.background,
                    titleColor: this.xyChart?.titleColor || this.primaryTextColor,
                    xAxisTitleColor: this.xyChart?.xAxisTitleColor || this.primaryTextColor,
                    xAxisLabelColor: this.xyChart?.xAxisLabelColor || this.primaryTextColor,
                    xAxisTickColor: this.xyChart?.xAxisTickColor || this.primaryTextColor,
                    xAxisLineColor: this.xyChart?.xAxisLineColor || this.primaryTextColor,
                    yAxisTitleColor: this.xyChart?.yAxisTitleColor || this.primaryTextColor,
                    yAxisLabelColor: this.xyChart?.yAxisLabelColor || this.primaryTextColor,
                    yAxisTickColor: this.xyChart?.yAxisTickColor || this.primaryTextColor,
                    yAxisLineColor: this.xyChart?.yAxisLineColor || this.primaryTextColor,
                    plotColorPalette: this.xyChart?.plotColorPalette || "#CDE498,#FF6B6B,#A0D2DB,#D7BDE2,#F0F0F0,#FFC3A0,#7FD8BE,#FF9A8B,#FAF3E0,#FFF176"
                };
                this.requirementBackground = this.requirementBackground || this.primaryColor;
                this.requirementBorderColor = this.requirementBorderColor || this.primaryBorderColor;
                this.requirementBorderSize = this.requirementBorderSize || "1";
                this.requirementTextColor = this.requirementTextColor || this.primaryTextColor;
                this.relationColor = this.relationColor || this.lineColor;
                this.relationLabelBackground = this.relationLabelBackground || this.edgeLabelBackground;
                this.relationLabelColor = this.relationLabelColor || this.actorTextColor;
                this.git0 = this.git0 || this.primaryColor;
                this.git1 = this.git1 || this.secondaryColor;
                this.git2 = this.git2 || this.tertiaryColor;
                this.git3 = this.git3 || methods_adjust(this.primaryColor, {
                    h: -30
                });
                this.git4 = this.git4 || methods_adjust(this.primaryColor, {
                    h: -60
                });
                this.git5 = this.git5 || methods_adjust(this.primaryColor, {
                    h: -90
                });
                this.git6 = this.git6 || methods_adjust(this.primaryColor, {
                    h: 60
                });
                this.git7 = this.git7 || methods_adjust(this.primaryColor, {
                    h: 120
                });
                if (this.darkMode) {
                    this.git0 = (0, lighten.Z)(this.git0, 25);
                    this.git1 = (0, lighten.Z)(this.git1, 25);
                    this.git2 = (0, lighten.Z)(this.git2, 25);
                    this.git3 = (0, lighten.Z)(this.git3, 25);
                    this.git4 = (0, lighten.Z)(this.git4, 25);
                    this.git5 = (0, lighten.Z)(this.git5, 25);
                    this.git6 = (0, lighten.Z)(this.git6, 25);
                    this.git7 = (0, lighten.Z)(this.git7, 25);
                } else {
                    this.git0 = (0, darken.Z)(this.git0, 25);
                    this.git1 = (0, darken.Z)(this.git1, 25);
                    this.git2 = (0, darken.Z)(this.git2, 25);
                    this.git3 = (0, darken.Z)(this.git3, 25);
                    this.git4 = (0, darken.Z)(this.git4, 25);
                    this.git5 = (0, darken.Z)(this.git5, 25);
                    this.git6 = (0, darken.Z)(this.git6, 25);
                    this.git7 = (0, darken.Z)(this.git7, 25);
                }
                this.gitInv0 = this.gitInv0 || invert(this.git0);
                this.gitInv1 = this.gitInv1 || invert(this.git1);
                this.gitInv2 = this.gitInv2 || invert(this.git2);
                this.gitInv3 = this.gitInv3 || invert(this.git3);
                this.gitInv4 = this.gitInv4 || invert(this.git4);
                this.gitInv5 = this.gitInv5 || invert(this.git5);
                this.gitInv6 = this.gitInv6 || invert(this.git6);
                this.gitInv7 = this.gitInv7 || invert(this.git7);
                this.gitBranchLabel0 = this.gitBranchLabel0 || invert(this.labelTextColor);
                this.gitBranchLabel1 = this.gitBranchLabel1 || this.labelTextColor;
                this.gitBranchLabel2 = this.gitBranchLabel2 || this.labelTextColor;
                this.gitBranchLabel3 = this.gitBranchLabel3 || invert(this.labelTextColor);
                this.gitBranchLabel4 = this.gitBranchLabel4 || this.labelTextColor;
                this.gitBranchLabel5 = this.gitBranchLabel5 || this.labelTextColor;
                this.gitBranchLabel6 = this.gitBranchLabel6 || this.labelTextColor;
                this.gitBranchLabel7 = this.gitBranchLabel7 || this.labelTextColor;
                this.tagLabelColor = this.tagLabelColor || this.primaryTextColor;
                this.tagLabelBackground = this.tagLabelBackground || this.primaryColor;
                this.tagLabelBorder = this.tagBorder || this.primaryBorderColor;
                this.tagLabelFontSize = this.tagLabelFontSize || "10px";
                this.commitLabelColor = this.commitLabelColor || this.secondaryTextColor;
                this.commitLabelBackground = this.commitLabelBackground || this.secondaryColor;
                this.commitLabelFontSize = this.commitLabelFontSize || "10px";
                this.attributeBackgroundColorOdd = this.attributeBackgroundColorOdd || oldAttributeBackgroundColorOdd;
                this.attributeBackgroundColorEven = this.attributeBackgroundColorEven || oldAttributeBackgroundColorEven;
            }
            calculate(overrides) {
                if ("object" != typeof overrides) {
                    this.updateColors();
                    return;
                }
                const keys = Object.keys(overrides);
                keys.forEach((k)=>{
                    this[k] = overrides[k];
                });
                this.updateColors();
                keys.forEach((k)=>{
                    this[k] = overrides[k];
                });
            }
        };
        var getThemeVariables4 = /* @__PURE__ */ __name((userOverrides)=>{
            const theme = new Theme4();
            theme.calculate(userOverrides);
            return theme;
        }, "getThemeVariables");
        var Theme5 = class {
            static{
                __name(this, "Theme");
            }
            constructor(){
                this.primaryColor = "#eee";
                this.contrast = "#707070";
                this.secondaryColor = (0, lighten.Z)(this.contrast, 55);
                this.background = "#ffffff";
                this.tertiaryColor = methods_adjust(this.primaryColor, {
                    h: -160
                });
                this.primaryBorderColor = mkBorder(this.primaryColor, this.darkMode);
                this.secondaryBorderColor = mkBorder(this.secondaryColor, this.darkMode);
                this.tertiaryBorderColor = mkBorder(this.tertiaryColor, this.darkMode);
                this.primaryTextColor = invert(this.primaryColor);
                this.secondaryTextColor = invert(this.secondaryColor);
                this.tertiaryTextColor = invert(this.tertiaryColor);
                this.lineColor = invert(this.background);
                this.textColor = invert(this.background);
                this.mainBkg = "#eee";
                this.secondBkg = "calculated";
                this.lineColor = "#666";
                this.border1 = "#999";
                this.border2 = "calculated";
                this.note = "#ffa";
                this.text = "#333";
                this.critical = "#d42";
                this.done = "#bbb";
                this.arrowheadColor = "#333333";
                this.fontFamily = '"trebuchet ms", verdana, arial, sans-serif';
                this.fontSize = "16px";
                this.THEME_COLOR_LIMIT = 12;
                this.nodeBkg = "calculated";
                this.nodeBorder = "calculated";
                this.clusterBkg = "calculated";
                this.clusterBorder = "calculated";
                this.defaultLinkColor = "calculated";
                this.titleColor = "calculated";
                this.edgeLabelBackground = "white";
                this.actorBorder = "calculated";
                this.actorBkg = "calculated";
                this.actorTextColor = "calculated";
                this.actorLineColor = this.actorBorder;
                this.signalColor = "calculated";
                this.signalTextColor = "calculated";
                this.labelBoxBkgColor = "calculated";
                this.labelBoxBorderColor = "calculated";
                this.labelTextColor = "calculated";
                this.loopTextColor = "calculated";
                this.noteBorderColor = "calculated";
                this.noteBkgColor = "calculated";
                this.noteTextColor = "calculated";
                this.activationBorderColor = "#666";
                this.activationBkgColor = "#f4f4f4";
                this.sequenceNumberColor = "white";
                this.sectionBkgColor = "calculated";
                this.altSectionBkgColor = "white";
                this.sectionBkgColor2 = "calculated";
                this.excludeBkgColor = "#eeeeee";
                this.taskBorderColor = "calculated";
                this.taskBkgColor = "calculated";
                this.taskTextLightColor = "white";
                this.taskTextColor = "calculated";
                this.taskTextDarkColor = "calculated";
                this.taskTextOutsideColor = "calculated";
                this.taskTextClickableColor = "#003163";
                this.activeTaskBorderColor = "calculated";
                this.activeTaskBkgColor = "calculated";
                this.gridColor = "calculated";
                this.doneTaskBkgColor = "calculated";
                this.doneTaskBorderColor = "calculated";
                this.critBkgColor = "calculated";
                this.critBorderColor = "calculated";
                this.todayLineColor = "calculated";
                this.personBorder = this.primaryBorderColor;
                this.personBkg = this.mainBkg;
                this.archEdgeColor = "calculated";
                this.archEdgeArrowColor = "calculated";
                this.archEdgeWidth = "3";
                this.archGroupBorderColor = this.primaryBorderColor;
                this.archGroupBorderWidth = "2px";
                this.labelColor = "black";
                this.errorBkgColor = "#552222";
                this.errorTextColor = "#552222";
            }
            updateColors() {
                this.secondBkg = (0, lighten.Z)(this.contrast, 55);
                this.border2 = this.contrast;
                this.actorBorder = (0, lighten.Z)(this.border1, 23);
                this.actorBkg = this.mainBkg;
                this.actorTextColor = this.text;
                this.actorLineColor = this.actorBorder;
                this.signalColor = this.text;
                this.signalTextColor = this.text;
                this.labelBoxBkgColor = this.actorBkg;
                this.labelBoxBorderColor = this.actorBorder;
                this.labelTextColor = this.text;
                this.loopTextColor = this.text;
                this.noteBorderColor = "#999";
                this.noteBkgColor = "#666";
                this.noteTextColor = "#fff";
                this.cScale0 = this.cScale0 || "#555";
                this.cScale1 = this.cScale1 || "#F4F4F4";
                this.cScale2 = this.cScale2 || "#555";
                this.cScale3 = this.cScale3 || "#BBB";
                this.cScale4 = this.cScale4 || "#777";
                this.cScale5 = this.cScale5 || "#999";
                this.cScale6 = this.cScale6 || "#DDD";
                this.cScale7 = this.cScale7 || "#FFF";
                this.cScale8 = this.cScale8 || "#DDD";
                this.cScale9 = this.cScale9 || "#BBB";
                this.cScale10 = this.cScale10 || "#999";
                this.cScale11 = this.cScale11 || "#777";
                for(let i = 0; i < this.THEME_COLOR_LIMIT; i++)this["cScaleInv" + i] = this["cScaleInv" + i] || invert(this["cScale" + i]);
                for(let i = 0; i < this.THEME_COLOR_LIMIT; i++)if (this.darkMode) this["cScalePeer" + i] = this["cScalePeer" + i] || (0, lighten.Z)(this["cScale" + i], 10);
                else this["cScalePeer" + i] = this["cScalePeer" + i] || (0, darken.Z)(this["cScale" + i], 10);
                this.scaleLabelColor = this.scaleLabelColor || (this.darkMode ? "black" : this.labelTextColor);
                this.cScaleLabel0 = this.cScaleLabel0 || this.cScale1;
                this.cScaleLabel2 = this.cScaleLabel2 || this.cScale1;
                for(let i = 0; i < this.THEME_COLOR_LIMIT; i++)this["cScaleLabel" + i] = this["cScaleLabel" + i] || this.scaleLabelColor;
                for(let i = 0; i < 5; i++){
                    this["surface" + i] = this["surface" + i] || methods_adjust(this.mainBkg, {
                        l: -(5 + 5 * i)
                    });
                    this["surfacePeer" + i] = this["surfacePeer" + i] || methods_adjust(this.mainBkg, {
                        l: -(8 + 5 * i)
                    });
                }
                this.nodeBkg = this.mainBkg;
                this.nodeBorder = this.border1;
                this.clusterBkg = this.secondBkg;
                this.clusterBorder = this.border2;
                this.defaultLinkColor = this.lineColor;
                this.titleColor = this.text;
                this.sectionBkgColor = (0, lighten.Z)(this.contrast, 30);
                this.sectionBkgColor2 = (0, lighten.Z)(this.contrast, 30);
                this.taskBorderColor = (0, darken.Z)(this.contrast, 10);
                this.taskBkgColor = this.contrast;
                this.taskTextColor = this.taskTextLightColor;
                this.taskTextDarkColor = this.text;
                this.taskTextOutsideColor = this.taskTextDarkColor;
                this.activeTaskBorderColor = this.taskBorderColor;
                this.activeTaskBkgColor = this.mainBkg;
                this.gridColor = (0, lighten.Z)(this.border1, 30);
                this.doneTaskBkgColor = this.done;
                this.doneTaskBorderColor = this.lineColor;
                this.critBkgColor = this.critical;
                this.critBorderColor = (0, darken.Z)(this.critBkgColor, 10);
                this.todayLineColor = this.critBkgColor;
                this.archEdgeColor = this.lineColor;
                this.archEdgeArrowColor = this.lineColor;
                this.transitionColor = this.transitionColor || "#000";
                this.transitionLabelColor = this.transitionLabelColor || this.textColor;
                this.stateLabelColor = this.stateLabelColor || this.stateBkg || this.primaryTextColor;
                this.stateBkg = this.stateBkg || this.mainBkg;
                this.labelBackgroundColor = this.labelBackgroundColor || this.stateBkg;
                this.compositeBackground = this.compositeBackground || this.background || this.tertiaryColor;
                this.altBackground = this.altBackground || "#f4f4f4";
                this.compositeTitleBackground = this.compositeTitleBackground || this.mainBkg;
                this.stateBorder = this.stateBorder || "#000";
                this.innerEndBackground = this.primaryBorderColor;
                this.specialStateColor = "#222";
                this.errorBkgColor = this.errorBkgColor || this.tertiaryColor;
                this.errorTextColor = this.errorTextColor || this.tertiaryTextColor;
                this.classText = this.primaryTextColor;
                this.fillType0 = this.primaryColor;
                this.fillType1 = this.secondaryColor;
                this.fillType2 = methods_adjust(this.primaryColor, {
                    h: 64
                });
                this.fillType3 = methods_adjust(this.secondaryColor, {
                    h: 64
                });
                this.fillType4 = methods_adjust(this.primaryColor, {
                    h: -64
                });
                this.fillType5 = methods_adjust(this.secondaryColor, {
                    h: -64
                });
                this.fillType6 = methods_adjust(this.primaryColor, {
                    h: 128
                });
                this.fillType7 = methods_adjust(this.secondaryColor, {
                    h: 128
                });
                for(let i = 0; i < this.THEME_COLOR_LIMIT; i++)this["pie" + i] = this["cScale" + i];
                this.pie12 = this.pie0;
                this.pieTitleTextSize = this.pieTitleTextSize || "25px";
                this.pieTitleTextColor = this.pieTitleTextColor || this.taskTextDarkColor;
                this.pieSectionTextSize = this.pieSectionTextSize || "17px";
                this.pieSectionTextColor = this.pieSectionTextColor || this.textColor;
                this.pieLegendTextSize = this.pieLegendTextSize || "17px";
                this.pieLegendTextColor = this.pieLegendTextColor || this.taskTextDarkColor;
                this.pieStrokeColor = this.pieStrokeColor || "black";
                this.pieStrokeWidth = this.pieStrokeWidth || "2px";
                this.pieOuterStrokeWidth = this.pieOuterStrokeWidth || "2px";
                this.pieOuterStrokeColor = this.pieOuterStrokeColor || "black";
                this.pieOpacity = this.pieOpacity || "0.7";
                this.quadrant1Fill = this.quadrant1Fill || this.primaryColor;
                this.quadrant2Fill = this.quadrant2Fill || methods_adjust(this.primaryColor, {
                    r: 5,
                    g: 5,
                    b: 5
                });
                this.quadrant3Fill = this.quadrant3Fill || methods_adjust(this.primaryColor, {
                    r: 10,
                    g: 10,
                    b: 10
                });
                this.quadrant4Fill = this.quadrant4Fill || methods_adjust(this.primaryColor, {
                    r: 15,
                    g: 15,
                    b: 15
                });
                this.quadrant1TextFill = this.quadrant1TextFill || this.primaryTextColor;
                this.quadrant2TextFill = this.quadrant2TextFill || methods_adjust(this.primaryTextColor, {
                    r: -5,
                    g: -5,
                    b: -5
                });
                this.quadrant3TextFill = this.quadrant3TextFill || methods_adjust(this.primaryTextColor, {
                    r: -10,
                    g: -10,
                    b: -10
                });
                this.quadrant4TextFill = this.quadrant4TextFill || methods_adjust(this.primaryTextColor, {
                    r: -15,
                    g: -15,
                    b: -15
                });
                this.quadrantPointFill = this.quadrantPointFill || (0, is_dark.Z)(this.quadrant1Fill) ? (0, lighten.Z)(this.quadrant1Fill) : (0, darken.Z)(this.quadrant1Fill);
                this.quadrantPointTextFill = this.quadrantPointTextFill || this.primaryTextColor;
                this.quadrantXAxisTextFill = this.quadrantXAxisTextFill || this.primaryTextColor;
                this.quadrantYAxisTextFill = this.quadrantYAxisTextFill || this.primaryTextColor;
                this.quadrantInternalBorderStrokeFill = this.quadrantInternalBorderStrokeFill || this.primaryBorderColor;
                this.quadrantExternalBorderStrokeFill = this.quadrantExternalBorderStrokeFill || this.primaryBorderColor;
                this.quadrantTitleFill = this.quadrantTitleFill || this.primaryTextColor;
                this.xyChart = {
                    backgroundColor: this.xyChart?.backgroundColor || this.background,
                    titleColor: this.xyChart?.titleColor || this.primaryTextColor,
                    xAxisTitleColor: this.xyChart?.xAxisTitleColor || this.primaryTextColor,
                    xAxisLabelColor: this.xyChart?.xAxisLabelColor || this.primaryTextColor,
                    xAxisTickColor: this.xyChart?.xAxisTickColor || this.primaryTextColor,
                    xAxisLineColor: this.xyChart?.xAxisLineColor || this.primaryTextColor,
                    yAxisTitleColor: this.xyChart?.yAxisTitleColor || this.primaryTextColor,
                    yAxisLabelColor: this.xyChart?.yAxisLabelColor || this.primaryTextColor,
                    yAxisTickColor: this.xyChart?.yAxisTickColor || this.primaryTextColor,
                    yAxisLineColor: this.xyChart?.yAxisLineColor || this.primaryTextColor,
                    plotColorPalette: this.xyChart?.plotColorPalette || "#EEE,#6BB8E4,#8ACB88,#C7ACD6,#E8DCC2,#FFB2A8,#FFF380,#7E8D91,#FFD8B1,#FAF3E0"
                };
                this.requirementBackground = this.requirementBackground || this.primaryColor;
                this.requirementBorderColor = this.requirementBorderColor || this.primaryBorderColor;
                this.requirementBorderSize = this.requirementBorderSize || "1";
                this.requirementTextColor = this.requirementTextColor || this.primaryTextColor;
                this.relationColor = this.relationColor || this.lineColor;
                this.relationLabelBackground = this.relationLabelBackground || this.edgeLabelBackground;
                this.relationLabelColor = this.relationLabelColor || this.actorTextColor;
                this.git0 = (0, darken.Z)(this.pie1, 25) || this.primaryColor;
                this.git1 = this.pie2 || this.secondaryColor;
                this.git2 = this.pie3 || this.tertiaryColor;
                this.git3 = this.pie4 || methods_adjust(this.primaryColor, {
                    h: -30
                });
                this.git4 = this.pie5 || methods_adjust(this.primaryColor, {
                    h: -60
                });
                this.git5 = this.pie6 || methods_adjust(this.primaryColor, {
                    h: -90
                });
                this.git6 = this.pie7 || methods_adjust(this.primaryColor, {
                    h: 60
                });
                this.git7 = this.pie8 || methods_adjust(this.primaryColor, {
                    h: 120
                });
                this.gitInv0 = this.gitInv0 || invert(this.git0);
                this.gitInv1 = this.gitInv1 || invert(this.git1);
                this.gitInv2 = this.gitInv2 || invert(this.git2);
                this.gitInv3 = this.gitInv3 || invert(this.git3);
                this.gitInv4 = this.gitInv4 || invert(this.git4);
                this.gitInv5 = this.gitInv5 || invert(this.git5);
                this.gitInv6 = this.gitInv6 || invert(this.git6);
                this.gitInv7 = this.gitInv7 || invert(this.git7);
                this.branchLabelColor = this.branchLabelColor || this.labelTextColor;
                this.gitBranchLabel0 = this.branchLabelColor;
                this.gitBranchLabel1 = "white";
                this.gitBranchLabel2 = this.branchLabelColor;
                this.gitBranchLabel3 = "white";
                this.gitBranchLabel4 = this.branchLabelColor;
                this.gitBranchLabel5 = this.branchLabelColor;
                this.gitBranchLabel6 = this.branchLabelColor;
                this.gitBranchLabel7 = this.branchLabelColor;
                this.tagLabelColor = this.tagLabelColor || this.primaryTextColor;
                this.tagLabelBackground = this.tagLabelBackground || this.primaryColor;
                this.tagLabelBorder = this.tagBorder || this.primaryBorderColor;
                this.tagLabelFontSize = this.tagLabelFontSize || "10px";
                this.commitLabelColor = this.commitLabelColor || this.secondaryTextColor;
                this.commitLabelBackground = this.commitLabelBackground || this.secondaryColor;
                this.commitLabelFontSize = this.commitLabelFontSize || "10px";
                this.attributeBackgroundColorOdd = this.attributeBackgroundColorOdd || oldAttributeBackgroundColorOdd;
                this.attributeBackgroundColorEven = this.attributeBackgroundColorEven || oldAttributeBackgroundColorEven;
            }
            calculate(overrides) {
                if ("object" != typeof overrides) {
                    this.updateColors();
                    return;
                }
                const keys = Object.keys(overrides);
                keys.forEach((k)=>{
                    this[k] = overrides[k];
                });
                this.updateColors();
                keys.forEach((k)=>{
                    this[k] = overrides[k];
                });
            }
        };
        var getThemeVariables5 = /* @__PURE__ */ __name((userOverrides)=>{
            const theme = new Theme5();
            theme.calculate(userOverrides);
            return theme;
        }, "getThemeVariables");
        var themes_default = {
            base: {
                getThemeVariables
            },
            dark: {
                getThemeVariables: getThemeVariables2
            },
            default: {
                getThemeVariables: getThemeVariables3
            },
            forest: {
                getThemeVariables: getThemeVariables4
            },
            neutral: {
                getThemeVariables: getThemeVariables5
            }
        };
        var config_schema_default = {
            flowchart: {
                useMaxWidth: true,
                titleTopMargin: 25,
                subGraphTitleMargin: {
                    top: 0,
                    bottom: 0
                },
                diagramPadding: 8,
                htmlLabels: true,
                nodeSpacing: 50,
                rankSpacing: 50,
                curve: "basis",
                padding: 15,
                defaultRenderer: "dagre-wrapper",
                wrappingWidth: 200
            },
            sequence: {
                useMaxWidth: true,
                hideUnusedParticipants: false,
                activationWidth: 10,
                diagramMarginX: 50,
                diagramMarginY: 10,
                actorMargin: 50,
                width: 150,
                height: 65,
                boxMargin: 10,
                boxTextMargin: 5,
                noteMargin: 10,
                messageMargin: 35,
                messageAlign: "center",
                mirrorActors: true,
                forceMenus: false,
                bottomMarginAdj: 1,
                rightAngles: false,
                showSequenceNumbers: false,
                actorFontSize: 14,
                actorFontFamily: '"Open Sans", sans-serif',
                actorFontWeight: 400,
                noteFontSize: 14,
                noteFontFamily: '"trebuchet ms", verdana, arial, sans-serif',
                noteFontWeight: 400,
                noteAlign: "center",
                messageFontSize: 16,
                messageFontFamily: '"trebuchet ms", verdana, arial, sans-serif',
                messageFontWeight: 400,
                wrap: false,
                wrapPadding: 10,
                labelBoxWidth: 50,
                labelBoxHeight: 20
            },
            gantt: {
                useMaxWidth: true,
                titleTopMargin: 25,
                barHeight: 20,
                barGap: 4,
                topPadding: 50,
                rightPadding: 75,
                leftPadding: 75,
                gridLineStartPadding: 35,
                fontSize: 11,
                sectionFontSize: 11,
                numberSectionStyles: 4,
                axisFormat: "%Y-%m-%d",
                topAxis: false,
                displayMode: "",
                weekday: "sunday"
            },
            journey: {
                useMaxWidth: true,
                diagramMarginX: 50,
                diagramMarginY: 10,
                leftMargin: 150,
                width: 150,
                height: 50,
                boxMargin: 10,
                boxTextMargin: 5,
                noteMargin: 10,
                messageMargin: 35,
                messageAlign: "center",
                bottomMarginAdj: 1,
                rightAngles: false,
                taskFontSize: 14,
                taskFontFamily: '"Open Sans", sans-serif',
                taskMargin: 50,
                activationWidth: 10,
                textPlacement: "fo",
                actorColours: [
                    "#8FBC8F",
                    "#7CFC00",
                    "#00FFFF",
                    "#20B2AA",
                    "#B0E0E6",
                    "#FFFFE0"
                ],
                sectionFills: [
                    "#191970",
                    "#8B008B",
                    "#4B0082",
                    "#2F4F4F",
                    "#800000",
                    "#8B4513",
                    "#00008B"
                ],
                sectionColours: [
                    "#fff"
                ]
            },
            class: {
                useMaxWidth: true,
                titleTopMargin: 25,
                arrowMarkerAbsolute: false,
                dividerMargin: 10,
                padding: 5,
                textHeight: 10,
                defaultRenderer: "dagre-wrapper",
                htmlLabels: false,
                hideEmptyMembersBox: false
            },
            state: {
                useMaxWidth: true,
                titleTopMargin: 25,
                dividerMargin: 10,
                sizeUnit: 5,
                padding: 8,
                textHeight: 10,
                titleShift: -15,
                noteMargin: 10,
                forkWidth: 70,
                forkHeight: 7,
                miniPadding: 2,
                fontSizeFactor: 5.02,
                fontSize: 24,
                labelHeight: 16,
                edgeLengthFactor: "20",
                compositTitleSize: 35,
                radius: 5,
                defaultRenderer: "dagre-wrapper"
            },
            er: {
                useMaxWidth: true,
                titleTopMargin: 25,
                diagramPadding: 20,
                layoutDirection: "TB",
                minEntityWidth: 100,
                minEntityHeight: 75,
                entityPadding: 15,
                stroke: "gray",
                fill: "honeydew",
                fontSize: 12
            },
            pie: {
                useMaxWidth: true,
                textPosition: 0.75
            },
            quadrantChart: {
                useMaxWidth: true,
                chartWidth: 500,
                chartHeight: 500,
                titleFontSize: 20,
                titlePadding: 10,
                quadrantPadding: 5,
                xAxisLabelPadding: 5,
                yAxisLabelPadding: 5,
                xAxisLabelFontSize: 16,
                yAxisLabelFontSize: 16,
                quadrantLabelFontSize: 16,
                quadrantTextTopPadding: 5,
                pointTextPadding: 5,
                pointLabelFontSize: 12,
                pointRadius: 5,
                xAxisPosition: "top",
                yAxisPosition: "left",
                quadrantInternalBorderStrokeWidth: 1,
                quadrantExternalBorderStrokeWidth: 2
            },
            xyChart: {
                useMaxWidth: true,
                width: 700,
                height: 500,
                titleFontSize: 20,
                titlePadding: 10,
                showTitle: true,
                xAxis: {
                    $ref: "#/$defs/XYChartAxisConfig",
                    showLabel: true,
                    labelFontSize: 14,
                    labelPadding: 5,
                    showTitle: true,
                    titleFontSize: 16,
                    titlePadding: 5,
                    showTick: true,
                    tickLength: 5,
                    tickWidth: 2,
                    showAxisLine: true,
                    axisLineWidth: 2
                },
                yAxis: {
                    $ref: "#/$defs/XYChartAxisConfig",
                    showLabel: true,
                    labelFontSize: 14,
                    labelPadding: 5,
                    showTitle: true,
                    titleFontSize: 16,
                    titlePadding: 5,
                    showTick: true,
                    tickLength: 5,
                    tickWidth: 2,
                    showAxisLine: true,
                    axisLineWidth: 2
                },
                chartOrientation: "vertical",
                plotReservedSpacePercent: 50
            },
            requirement: {
                useMaxWidth: true,
                rect_fill: "#f9f9f9",
                text_color: "#333",
                rect_border_size: "0.5px",
                rect_border_color: "#bbb",
                rect_min_width: 200,
                rect_min_height: 200,
                fontSize: 14,
                rect_padding: 10,
                line_height: 20
            },
            mindmap: {
                useMaxWidth: true,
                padding: 10,
                maxNodeWidth: 200
            },
            kanban: {
                useMaxWidth: true,
                padding: 8,
                sectionWidth: 200,
                ticketBaseUrl: ""
            },
            timeline: {
                useMaxWidth: true,
                diagramMarginX: 50,
                diagramMarginY: 10,
                leftMargin: 150,
                width: 150,
                height: 50,
                boxMargin: 10,
                boxTextMargin: 5,
                noteMargin: 10,
                messageMargin: 35,
                messageAlign: "center",
                bottomMarginAdj: 1,
                rightAngles: false,
                taskFontSize: 14,
                taskFontFamily: '"Open Sans", sans-serif',
                taskMargin: 50,
                activationWidth: 10,
                textPlacement: "fo",
                actorColours: [
                    "#8FBC8F",
                    "#7CFC00",
                    "#00FFFF",
                    "#20B2AA",
                    "#B0E0E6",
                    "#FFFFE0"
                ],
                sectionFills: [
                    "#191970",
                    "#8B008B",
                    "#4B0082",
                    "#2F4F4F",
                    "#800000",
                    "#8B4513",
                    "#00008B"
                ],
                sectionColours: [
                    "#fff"
                ],
                disableMulticolor: false
            },
            gitGraph: {
                useMaxWidth: true,
                titleTopMargin: 25,
                diagramPadding: 8,
                nodeLabel: {
                    width: 75,
                    height: 100,
                    x: -25,
                    y: 0
                },
                mainBranchName: "main",
                mainBranchOrder: 0,
                showCommitLabel: true,
                showBranches: true,
                rotateCommitLabel: true,
                parallelCommits: false,
                arrowMarkerAbsolute: false
            },
            c4: {
                useMaxWidth: true,
                diagramMarginX: 50,
                diagramMarginY: 10,
                c4ShapeMargin: 50,
                c4ShapePadding: 20,
                width: 216,
                height: 60,
                boxMargin: 10,
                c4ShapeInRow: 4,
                nextLinePaddingX: 0,
                c4BoundaryInRow: 2,
                personFontSize: 14,
                personFontFamily: '"Open Sans", sans-serif',
                personFontWeight: "normal",
                external_personFontSize: 14,
                external_personFontFamily: '"Open Sans", sans-serif',
                external_personFontWeight: "normal",
                systemFontSize: 14,
                systemFontFamily: '"Open Sans", sans-serif',
                systemFontWeight: "normal",
                external_systemFontSize: 14,
                external_systemFontFamily: '"Open Sans", sans-serif',
                external_systemFontWeight: "normal",
                system_dbFontSize: 14,
                system_dbFontFamily: '"Open Sans", sans-serif',
                system_dbFontWeight: "normal",
                external_system_dbFontSize: 14,
                external_system_dbFontFamily: '"Open Sans", sans-serif',
                external_system_dbFontWeight: "normal",
                system_queueFontSize: 14,
                system_queueFontFamily: '"Open Sans", sans-serif',
                system_queueFontWeight: "normal",
                external_system_queueFontSize: 14,
                external_system_queueFontFamily: '"Open Sans", sans-serif',
                external_system_queueFontWeight: "normal",
                boundaryFontSize: 14,
                boundaryFontFamily: '"Open Sans", sans-serif',
                boundaryFontWeight: "normal",
                messageFontSize: 12,
                messageFontFamily: '"Open Sans", sans-serif',
                messageFontWeight: "normal",
                containerFontSize: 14,
                containerFontFamily: '"Open Sans", sans-serif',
                containerFontWeight: "normal",
                external_containerFontSize: 14,
                external_containerFontFamily: '"Open Sans", sans-serif',
                external_containerFontWeight: "normal",
                container_dbFontSize: 14,
                container_dbFontFamily: '"Open Sans", sans-serif',
                container_dbFontWeight: "normal",
                external_container_dbFontSize: 14,
                external_container_dbFontFamily: '"Open Sans", sans-serif',
                external_container_dbFontWeight: "normal",
                container_queueFontSize: 14,
                container_queueFontFamily: '"Open Sans", sans-serif',
                container_queueFontWeight: "normal",
                external_container_queueFontSize: 14,
                external_container_queueFontFamily: '"Open Sans", sans-serif',
                external_container_queueFontWeight: "normal",
                componentFontSize: 14,
                componentFontFamily: '"Open Sans", sans-serif',
                componentFontWeight: "normal",
                external_componentFontSize: 14,
                external_componentFontFamily: '"Open Sans", sans-serif',
                external_componentFontWeight: "normal",
                component_dbFontSize: 14,
                component_dbFontFamily: '"Open Sans", sans-serif',
                component_dbFontWeight: "normal",
                external_component_dbFontSize: 14,
                external_component_dbFontFamily: '"Open Sans", sans-serif',
                external_component_dbFontWeight: "normal",
                component_queueFontSize: 14,
                component_queueFontFamily: '"Open Sans", sans-serif',
                component_queueFontWeight: "normal",
                external_component_queueFontSize: 14,
                external_component_queueFontFamily: '"Open Sans", sans-serif',
                external_component_queueFontWeight: "normal",
                wrap: true,
                wrapPadding: 10,
                person_bg_color: "#08427B",
                person_border_color: "#073B6F",
                external_person_bg_color: "#686868",
                external_person_border_color: "#8A8A8A",
                system_bg_color: "#1168BD",
                system_border_color: "#3C7FC0",
                system_db_bg_color: "#1168BD",
                system_db_border_color: "#3C7FC0",
                system_queue_bg_color: "#1168BD",
                system_queue_border_color: "#3C7FC0",
                external_system_bg_color: "#999999",
                external_system_border_color: "#8A8A8A",
                external_system_db_bg_color: "#999999",
                external_system_db_border_color: "#8A8A8A",
                external_system_queue_bg_color: "#999999",
                external_system_queue_border_color: "#8A8A8A",
                container_bg_color: "#438DD5",
                container_border_color: "#3C7FC0",
                container_db_bg_color: "#438DD5",
                container_db_border_color: "#3C7FC0",
                container_queue_bg_color: "#438DD5",
                container_queue_border_color: "#3C7FC0",
                external_container_bg_color: "#B3B3B3",
                external_container_border_color: "#A6A6A6",
                external_container_db_bg_color: "#B3B3B3",
                external_container_db_border_color: "#A6A6A6",
                external_container_queue_bg_color: "#B3B3B3",
                external_container_queue_border_color: "#A6A6A6",
                component_bg_color: "#85BBF0",
                component_border_color: "#78A8D8",
                component_db_bg_color: "#85BBF0",
                component_db_border_color: "#78A8D8",
                component_queue_bg_color: "#85BBF0",
                component_queue_border_color: "#78A8D8",
                external_component_bg_color: "#CCCCCC",
                external_component_border_color: "#BFBFBF",
                external_component_db_bg_color: "#CCCCCC",
                external_component_db_border_color: "#BFBFBF",
                external_component_queue_bg_color: "#CCCCCC",
                external_component_queue_border_color: "#BFBFBF"
            },
            sankey: {
                useMaxWidth: true,
                width: 600,
                height: 400,
                linkColor: "gradient",
                nodeAlignment: "justify",
                showValues: true,
                prefix: "",
                suffix: ""
            },
            block: {
                useMaxWidth: true,
                padding: 8
            },
            packet: {
                useMaxWidth: true,
                rowHeight: 32,
                bitWidth: 32,
                bitsPerRow: 32,
                showBits: true,
                paddingX: 5,
                paddingY: 5
            },
            architecture: {
                useMaxWidth: true,
                padding: 40,
                iconSize: 80,
                fontSize: 16
            },
            theme: "default",
            look: "classic",
            handDrawnSeed: 0,
            layout: "dagre",
            maxTextSize: 5e4,
            maxEdges: 500,
            darkMode: false,
            fontFamily: '"trebuchet ms", verdana, arial, sans-serif;',
            logLevel: 5,
            securityLevel: "strict",
            startOnLoad: true,
            arrowMarkerAbsolute: false,
            secure: [
                "secure",
                "securityLevel",
                "startOnLoad",
                "maxTextSize",
                "suppressErrorRendering",
                "maxEdges"
            ],
            legacyMathML: false,
            forceLegacyMathML: false,
            deterministicIds: false,
            fontSize: 16,
            markdownAutoWrap: true,
            suppressErrorRendering: false
        };
        var config = {
            ...config_schema_default,
            deterministicIDSeed: void 0,
            elk: {
                mergeEdges: false,
                nodePlacementStrategy: "BRANDES_KOEPF"
            },
            themeCSS: void 0,
            themeVariables: themes_default.default.getThemeVariables(),
            sequence: {
                ...config_schema_default.sequence,
                messageFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.messageFontFamily,
                        fontSize: this.messageFontSize,
                        fontWeight: this.messageFontWeight
                    };
                }, "messageFont"),
                noteFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.noteFontFamily,
                        fontSize: this.noteFontSize,
                        fontWeight: this.noteFontWeight
                    };
                }, "noteFont"),
                actorFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.actorFontFamily,
                        fontSize: this.actorFontSize,
                        fontWeight: this.actorFontWeight
                    };
                }, "actorFont")
            },
            class: {
                hideEmptyMembersBox: false
            },
            gantt: {
                ...config_schema_default.gantt,
                tickInterval: void 0,
                useWidth: void 0
            },
            c4: {
                ...config_schema_default.c4,
                useWidth: void 0,
                personFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.personFontFamily,
                        fontSize: this.personFontSize,
                        fontWeight: this.personFontWeight
                    };
                }, "personFont"),
                external_personFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.external_personFontFamily,
                        fontSize: this.external_personFontSize,
                        fontWeight: this.external_personFontWeight
                    };
                }, "external_personFont"),
                systemFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.systemFontFamily,
                        fontSize: this.systemFontSize,
                        fontWeight: this.systemFontWeight
                    };
                }, "systemFont"),
                external_systemFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.external_systemFontFamily,
                        fontSize: this.external_systemFontSize,
                        fontWeight: this.external_systemFontWeight
                    };
                }, "external_systemFont"),
                system_dbFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.system_dbFontFamily,
                        fontSize: this.system_dbFontSize,
                        fontWeight: this.system_dbFontWeight
                    };
                }, "system_dbFont"),
                external_system_dbFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.external_system_dbFontFamily,
                        fontSize: this.external_system_dbFontSize,
                        fontWeight: this.external_system_dbFontWeight
                    };
                }, "external_system_dbFont"),
                system_queueFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.system_queueFontFamily,
                        fontSize: this.system_queueFontSize,
                        fontWeight: this.system_queueFontWeight
                    };
                }, "system_queueFont"),
                external_system_queueFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.external_system_queueFontFamily,
                        fontSize: this.external_system_queueFontSize,
                        fontWeight: this.external_system_queueFontWeight
                    };
                }, "external_system_queueFont"),
                containerFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.containerFontFamily,
                        fontSize: this.containerFontSize,
                        fontWeight: this.containerFontWeight
                    };
                }, "containerFont"),
                external_containerFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.external_containerFontFamily,
                        fontSize: this.external_containerFontSize,
                        fontWeight: this.external_containerFontWeight
                    };
                }, "external_containerFont"),
                container_dbFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.container_dbFontFamily,
                        fontSize: this.container_dbFontSize,
                        fontWeight: this.container_dbFontWeight
                    };
                }, "container_dbFont"),
                external_container_dbFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.external_container_dbFontFamily,
                        fontSize: this.external_container_dbFontSize,
                        fontWeight: this.external_container_dbFontWeight
                    };
                }, "external_container_dbFont"),
                container_queueFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.container_queueFontFamily,
                        fontSize: this.container_queueFontSize,
                        fontWeight: this.container_queueFontWeight
                    };
                }, "container_queueFont"),
                external_container_queueFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.external_container_queueFontFamily,
                        fontSize: this.external_container_queueFontSize,
                        fontWeight: this.external_container_queueFontWeight
                    };
                }, "external_container_queueFont"),
                componentFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.componentFontFamily,
                        fontSize: this.componentFontSize,
                        fontWeight: this.componentFontWeight
                    };
                }, "componentFont"),
                external_componentFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.external_componentFontFamily,
                        fontSize: this.external_componentFontSize,
                        fontWeight: this.external_componentFontWeight
                    };
                }, "external_componentFont"),
                component_dbFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.component_dbFontFamily,
                        fontSize: this.component_dbFontSize,
                        fontWeight: this.component_dbFontWeight
                    };
                }, "component_dbFont"),
                external_component_dbFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.external_component_dbFontFamily,
                        fontSize: this.external_component_dbFontSize,
                        fontWeight: this.external_component_dbFontWeight
                    };
                }, "external_component_dbFont"),
                component_queueFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.component_queueFontFamily,
                        fontSize: this.component_queueFontSize,
                        fontWeight: this.component_queueFontWeight
                    };
                }, "component_queueFont"),
                external_component_queueFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.external_component_queueFontFamily,
                        fontSize: this.external_component_queueFontSize,
                        fontWeight: this.external_component_queueFontWeight
                    };
                }, "external_component_queueFont"),
                boundaryFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.boundaryFontFamily,
                        fontSize: this.boundaryFontSize,
                        fontWeight: this.boundaryFontWeight
                    };
                }, "boundaryFont"),
                messageFont: /* @__PURE__ */ __name(function() {
                    return {
                        fontFamily: this.messageFontFamily,
                        fontSize: this.messageFontSize,
                        fontWeight: this.messageFontWeight
                    };
                }, "messageFont")
            },
            pie: {
                ...config_schema_default.pie,
                useWidth: 984
            },
            xyChart: {
                ...config_schema_default.xyChart,
                useWidth: void 0
            },
            requirement: {
                ...config_schema_default.requirement,
                useWidth: void 0
            },
            packet: {
                ...config_schema_default.packet
            }
        };
        var keyify = /* @__PURE__ */ __name((obj, prefix = "")=>Object.keys(obj).reduce((res, el)=>{
                if (Array.isArray(obj[el])) return res;
                if ("object" == typeof obj[el] && null !== obj[el]) return [
                    ...res,
                    prefix + el,
                    ...keyify(obj[el], "")
                ];
                return [
                    ...res,
                    prefix + el
                ];
            }, []), "keyify");
        var configKeys = new Set(keyify(config, ""));
        var defaultConfig_default = config;
        var sanitizeDirective = /* @__PURE__ */ __name((args)=>{
            log.debug("sanitizeDirective called with", args);
            if ("object" != typeof args || null == args) return;
            if (Array.isArray(args)) {
                args.forEach((arg)=>sanitizeDirective(arg));
                return;
            }
            for (const key of Object.keys(args)){
                log.debug("Checking key", key);
                if (key.startsWith("__") || key.includes("proto") || key.includes("constr") || !configKeys.has(key) || null == args[key]) {
                    log.debug("sanitize deleting key: ", key);
                    delete args[key];
                    continue;
                }
                if ("object" == typeof args[key]) {
                    log.debug("sanitizing object", key);
                    sanitizeDirective(args[key]);
                    continue;
                }
                const cssMatchers = [
                    "themeCSS",
                    "fontFamily",
                    "altFontFamily"
                ];
                for (const cssKey of cssMatchers)if (key.includes(cssKey)) {
                    log.debug("sanitizing css option", key);
                    args[key] = sanitizeCss(args[key]);
                }
            }
            if (args.themeVariables) for (const k of Object.keys(args.themeVariables)){
                const val = args.themeVariables[k];
                if (val?.match && !val.match(/^[\d "#%(),.;A-Za-z]+$/)) args.themeVariables[k] = "";
            }
            log.debug("After sanitization", args);
        }, "sanitizeDirective");
        var sanitizeCss = /* @__PURE__ */ __name((str)=>{
            let startCnt = 0;
            let endCnt = 0;
            for (const element of str){
                if (startCnt < endCnt) return "{ /* ERROR: Unbalanced CSS */ }";
                if ("{" === element) startCnt++;
                else if ("}" === element) endCnt++;
            }
            if (startCnt !== endCnt) return "{ /* ERROR: Unbalanced CSS */ }";
            return str;
        }, "sanitizeCss");
        var defaultConfig = Object.freeze(defaultConfig_default);
        var siteConfig = assignWithDepth_default({}, defaultConfig);
        var configFromInitialize;
        var directives = [];
        var currentConfig = assignWithDepth_default({}, defaultConfig);
        var updateCurrentConfig = /* @__PURE__ */ __name((siteCfg, _directives)=>{
            let cfg = assignWithDepth_default({}, siteCfg);
            let sumOfDirectives = {};
            for (const d of _directives){
                sanitize(d);
                sumOfDirectives = assignWithDepth_default(sumOfDirectives, d);
            }
            cfg = assignWithDepth_default(cfg, sumOfDirectives);
            if (sumOfDirectives.theme && sumOfDirectives.theme in themes_default) {
                const tmpConfigFromInitialize = assignWithDepth_default({}, configFromInitialize);
                const themeVariables = assignWithDepth_default(tmpConfigFromInitialize.themeVariables || {}, sumOfDirectives.themeVariables);
                if (cfg.theme && cfg.theme in themes_default) cfg.themeVariables = themes_default[cfg.theme].getThemeVariables(themeVariables);
            }
            currentConfig = cfg;
            checkConfig(currentConfig);
            return currentConfig;
        }, "updateCurrentConfig");
        var setSiteConfig = /* @__PURE__ */ __name((conf)=>{
            siteConfig = assignWithDepth_default({}, defaultConfig);
            siteConfig = assignWithDepth_default(siteConfig, conf);
            if (conf.theme && themes_default[conf.theme]) siteConfig.themeVariables = themes_default[conf.theme].getThemeVariables(conf.themeVariables);
            updateCurrentConfig(siteConfig, directives);
            return siteConfig;
        }, "setSiteConfig");
        var saveConfigFromInitialize = /* @__PURE__ */ __name((conf)=>{
            configFromInitialize = assignWithDepth_default({}, conf);
        }, "saveConfigFromInitialize");
        var updateSiteConfig = /* @__PURE__ */ __name((conf)=>{
            siteConfig = assignWithDepth_default(siteConfig, conf);
            updateCurrentConfig(siteConfig, directives);
            return siteConfig;
        }, "updateSiteConfig");
        var getSiteConfig = /* @__PURE__ */ __name(()=>assignWithDepth_default({}, siteConfig), "getSiteConfig");
        var setConfig = /* @__PURE__ */ __name((conf)=>{
            checkConfig(conf);
            assignWithDepth_default(currentConfig, conf);
            return getConfig();
        }, "setConfig");
        var getConfig = /* @__PURE__ */ __name(()=>assignWithDepth_default({}, currentConfig), "getConfig");
        var sanitize = /* @__PURE__ */ __name((options)=>{
            if (!options) return;
            [
                "secure",
                ...siteConfig.secure ?? []
            ].forEach((key)=>{
                if (Object.hasOwn(options, key)) {
                    log.debug(`Denied attempt to modify a secure key ${key}`, options[key]);
                    delete options[key];
                }
            });
            Object.keys(options).forEach((key)=>{
                if (key.startsWith("__")) delete options[key];
            });
            Object.keys(options).forEach((key)=>{
                if ("string" == typeof options[key] && (options[key].includes("<") || options[key].includes(">") || options[key].includes("url(data:"))) delete options[key];
                if ("object" == typeof options[key]) sanitize(options[key]);
            });
        }, "sanitize");
        var addDirective = /* @__PURE__ */ __name((directive)=>{
            sanitizeDirective(directive);
            if (directive.fontFamily && !directive.themeVariables?.fontFamily) directive.themeVariables = {
                ...directive.themeVariables,
                fontFamily: directive.fontFamily
            };
            directives.push(directive);
            updateCurrentConfig(siteConfig, directives);
        }, "addDirective");
        var chunk_6DBFFHIP_reset = /* @__PURE__ */ __name((config2 = siteConfig)=>{
            directives = [];
            updateCurrentConfig(config2, directives);
        }, "reset");
        var ConfigWarning = {
            LAZY_LOAD_DEPRECATED: "The configuration options lazyLoadedDiagrams and loadExternalDiagramsAtStartup are deprecated. Please use registerExternalDiagrams instead."
        };
        var issuedWarnings = {};
        var issueWarning = /* @__PURE__ */ __name((warning)=>{
            if (issuedWarnings[warning]) return;
            log.warn(ConfigWarning[warning]);
            issuedWarnings[warning] = true;
        }, "issueWarning");
        var checkConfig = /* @__PURE__ */ __name((config2)=>{
            if (!config2) return;
            if (config2.lazyLoadedDiagrams || config2.loadExternalDiagramsAtStartup) issueWarning("LAZY_LOAD_DEPRECATED");
        }, "checkConfig");
        var lineBreakRegex = /<br\s*\/?>/gi;
        var getRows = /* @__PURE__ */ __name((s)=>{
            if (!s) return [
                ""
            ];
            const str = breakToPlaceholder(s).replace(/\\n/g, "#br#");
            return str.split("#br#");
        }, "getRows");
        var setupDompurifyHooksIfNotSetup = /* @__PURE__ */ (()=>{
            let setup = false;
            return ()=>{
                if (!setup) {
                    setupDompurifyHooks();
                    setup = true;
                }
            };
        })();
        function setupDompurifyHooks() {
            const TEMPORARY_ATTRIBUTE = "data-temp-href-target";
            purify_es.Z.addHook("beforeSanitizeAttributes", (node)=>{
                if (node instanceof Element && "A" === node.tagName && node.hasAttribute("target")) node.setAttribute(TEMPORARY_ATTRIBUTE, node.getAttribute("target") ?? "");
            });
            purify_es.Z.addHook("afterSanitizeAttributes", (node)=>{
                if (node instanceof Element && "A" === node.tagName && node.hasAttribute(TEMPORARY_ATTRIBUTE)) {
                    node.setAttribute("target", node.getAttribute(TEMPORARY_ATTRIBUTE) ?? "");
                    node.removeAttribute(TEMPORARY_ATTRIBUTE);
                    if ("_blank" === node.getAttribute("target")) node.setAttribute("rel", "noopener");
                }
            });
        }
        __name(setupDompurifyHooks, "setupDompurifyHooks");
        var removeScript = /* @__PURE__ */ __name((txt)=>{
            setupDompurifyHooksIfNotSetup();
            const sanitizedText = purify_es.Z.sanitize(txt);
            return sanitizedText;
        }, "removeScript");
        var sanitizeMore = /* @__PURE__ */ __name((text, config2)=>{
            if (config2.flowchart?.htmlLabels !== false) {
                const level = config2.securityLevel;
                if ("antiscript" === level || "strict" === level) text = removeScript(text);
                else if ("loose" !== level) {
                    text = breakToPlaceholder(text);
                    text = text.replace(/</g, "&lt;").replace(/>/g, "&gt;");
                    text = text.replace(/=/g, "&equals;");
                    text = placeholderToBreak(text);
                }
            }
            return text;
        }, "sanitizeMore");
        var sanitizeText = /* @__PURE__ */ __name((text, config2)=>{
            if (!text) return text;
            text = config2.dompurifyConfig ? purify_es.Z.sanitize(sanitizeMore(text, config2), config2.dompurifyConfig).toString() : purify_es.Z.sanitize(sanitizeMore(text, config2), {
                FORBID_TAGS: [
                    "style"
                ]
            }).toString();
            return text;
        }, "sanitizeText");
        var sanitizeTextOrArray = /* @__PURE__ */ __name((a, config2)=>{
            if ("string" == typeof a) return sanitizeText(a, config2);
            return a.flat().map((x)=>sanitizeText(x, config2));
        }, "sanitizeTextOrArray");
        var hasBreaks = /* @__PURE__ */ __name((text)=>lineBreakRegex.test(text), "hasBreaks");
        var splitBreaks = /* @__PURE__ */ __name((text)=>text.split(lineBreakRegex), "splitBreaks");
        var placeholderToBreak = /* @__PURE__ */ __name((s)=>s.replace(/#br#/g, "<br/>"), "placeholderToBreak");
        var breakToPlaceholder = /* @__PURE__ */ __name((s)=>s.replace(lineBreakRegex, "#br#"), "breakToPlaceholder");
        var getUrl = /* @__PURE__ */ __name((useAbsolute)=>{
            let url = "";
            if (useAbsolute) {
                url = window.location.protocol + "//" + window.location.host + window.location.pathname + window.location.search;
                url = url.replaceAll(/\(/g, "\\(");
                url = url.replaceAll(/\)/g, "\\)");
            }
            return url;
        }, "getUrl");
        var evaluate = /* @__PURE__ */ __name((val)=>!(false === val || [
                "false",
                "null",
                "0"
            ].includes(String(val).trim().toLowerCase())) && true, "evaluate");
        var getMax = /* @__PURE__ */ __name(function(...values) {
            const newValues = values.filter((value)=>!isNaN(value));
            return Math.max(...newValues);
        }, "getMax");
        var getMin = /* @__PURE__ */ __name(function(...values) {
            const newValues = values.filter((value)=>!isNaN(value));
            return Math.min(...newValues);
        }, "getMin");
        var parseGenericTypes = /* @__PURE__ */ __name(function(input) {
            const inputSets = input.split(/(,)/);
            const output = [];
            for(let i = 0; i < inputSets.length; i++){
                let thisSet = inputSets[i];
                if ("," === thisSet && i > 0 && i + 1 < inputSets.length) {
                    const previousSet = inputSets[i - 1];
                    const nextSet = inputSets[i + 1];
                    if (shouldCombineSets(previousSet, nextSet)) {
                        thisSet = previousSet + "," + nextSet;
                        i++;
                        output.pop();
                    }
                }
                output.push(processSet(thisSet));
            }
            return output.join("");
        }, "parseGenericTypes");
        var countOccurrence = /* @__PURE__ */ __name((string, substring)=>Math.max(0, string.split(substring).length - 1), "countOccurrence");
        var shouldCombineSets = /* @__PURE__ */ __name((previousSet, nextSet)=>{
            const prevCount = countOccurrence(previousSet, "~");
            const nextCount = countOccurrence(nextSet, "~");
            return 1 === prevCount && 1 === nextCount;
        }, "shouldCombineSets");
        var processSet = /* @__PURE__ */ __name((input)=>{
            const tildeCount = countOccurrence(input, "~");
            let hasStartingTilde = false;
            if (tildeCount <= 1) return input;
            if (tildeCount % 2 !== 0 && input.startsWith("~")) {
                input = input.substring(1);
                hasStartingTilde = true;
            }
            const chars = [
                ...input
            ];
            let first = chars.indexOf("~");
            let last = chars.lastIndexOf("~");
            while(-1 !== first && -1 !== last && first !== last){
                chars[first] = "<";
                chars[last] = ">";
                first = chars.indexOf("~");
                last = chars.lastIndexOf("~");
            }
            if (hasStartingTilde) chars.unshift("~");
            return chars.join("");
        }, "processSet");
        var isMathMLSupported = /* @__PURE__ */ __name(()=>void 0 !== window.MathMLElement, "isMathMLSupported");
        var katexRegex = /\$\$(.*)\$\$/g;
        var hasKatex = /* @__PURE__ */ __name((text)=>(text.match(katexRegex)?.length ?? 0) > 0, "hasKatex");
        var calculateMathMLDimensions = /* @__PURE__ */ __name(async (text, config2)=>{
            text = await renderKatex(text, config2);
            const divElem = document.createElement("div");
            divElem.innerHTML = text;
            divElem.id = "katex-temp";
            divElem.style.visibility = "hidden";
            divElem.style.position = "absolute";
            divElem.style.top = "0";
            const body = document.querySelector("body");
            body?.insertAdjacentElement("beforeend", divElem);
            const dim = {
                width: divElem.clientWidth,
                height: divElem.clientHeight
            };
            divElem.remove();
            return dim;
        }, "calculateMathMLDimensions");
        var renderKatex = /* @__PURE__ */ __name(async (text, config2)=>{
            if (!hasKatex(text)) return text;
            if (!(isMathMLSupported() || config2.legacyMathML || config2.forceLegacyMathML)) return text.replace(katexRegex, "MathML is unsupported in this environment.");
            const { default: katex } = await __webpack_require__.e("885").then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/katex@0.16.21/node_modules/katex/dist/katex.mjs"));
            const outputMode = config2.forceLegacyMathML || !isMathMLSupported() && config2.legacyMathML ? "htmlAndMathml" : "mathml";
            return text.split(lineBreakRegex).map((line)=>hasKatex(line) ? `<div style="display: flex; align-items: center; justify-content: center; white-space: nowrap;">${line}</div>` : `<div>${line}</div>`).join("").replace(katexRegex, (_, c)=>katex.renderToString(c, {
                    throwOnError: true,
                    displayMode: true,
                    output: outputMode
                }).replace(/\n/g, " ").replace(/<annotation.*<\/annotation>/g, ""));
        }, "renderKatex");
        var common_default = {
            getRows,
            sanitizeText,
            sanitizeTextOrArray,
            hasBreaks,
            splitBreaks,
            lineBreakRegex,
            removeScript,
            getUrl,
            evaluate,
            getMax,
            getMin
        };
        var d3Attrs = /* @__PURE__ */ __name(function(d3Elem, attrs) {
            for (let attr of attrs)d3Elem.attr(attr[0], attr[1]);
        }, "d3Attrs");
        var calculateSvgSizeAttrs = /* @__PURE__ */ __name(function(height, width, useMaxWidth) {
            let attrs = /* @__PURE__ */ new Map();
            if (useMaxWidth) {
                attrs.set("width", "100%");
                attrs.set("style", `max-width: ${width}px;`);
            } else {
                attrs.set("height", height);
                attrs.set("width", width);
            }
            return attrs;
        }, "calculateSvgSizeAttrs");
        var configureSvgSize = /* @__PURE__ */ __name(function(svgElem, height, width, useMaxWidth) {
            const attrs = calculateSvgSizeAttrs(height, width, useMaxWidth);
            d3Attrs(svgElem, attrs);
        }, "configureSvgSize");
        var setupGraphViewbox = /* @__PURE__ */ __name(function(graph, svgElem, padding, useMaxWidth) {
            const svgBounds = svgElem.node().getBBox();
            const sWidth = svgBounds.width;
            const sHeight = svgBounds.height;
            log.info(`SVG bounds: ${sWidth}x${sHeight}`, svgBounds);
            let width = 0;
            let height = 0;
            log.info(`Graph bounds: ${width}x${height}`, graph);
            width = sWidth + 2 * padding;
            height = sHeight + 2 * padding;
            log.info(`Calculated bounds: ${width}x${height}`);
            configureSvgSize(svgElem, height, width, useMaxWidth);
            const vBox = `${svgBounds.x - padding} ${svgBounds.y - padding} ${svgBounds.width + 2 * padding} ${svgBounds.height + 2 * padding}`;
            svgElem.attr("viewBox", vBox);
        }, "setupGraphViewbox");
        var themes = {};
        var getStyles = /* @__PURE__ */ __name((type, userStyles, options)=>{
            let diagramStyles = "";
            if (type in themes && themes[type]) diagramStyles = themes[type](options);
            else log.warn(`No theme found for ${type}`);
            return ` & {
    font-family: ${options.fontFamily};
    font-size: ${options.fontSize};
    fill: ${options.textColor}
  }

  /* Classes common for multiple diagrams */

  & .error-icon {
    fill: ${options.errorBkgColor};
  }
  & .error-text {
    fill: ${options.errorTextColor};
    stroke: ${options.errorTextColor};
  }

  & .edge-thickness-normal {
    stroke-width: 1px;
  }
  & .edge-thickness-thick {
    stroke-width: 3.5px
  }
  & .edge-pattern-solid {
    stroke-dasharray: 0;
  }
  & .edge-thickness-invisible {
    stroke-width: 0;
    fill: none;
  }
  & .edge-pattern-dashed{
    stroke-dasharray: 3;
  }
  .edge-pattern-dotted {
    stroke-dasharray: 2;
  }

  & .marker {
    fill: ${options.lineColor};
    stroke: ${options.lineColor};
  }
  & .marker.cross {
    stroke: ${options.lineColor};
  }

  & svg {
    font-family: ${options.fontFamily};
    font-size: ${options.fontSize};
  }
   & p {
    margin: 0
   }

  ${diagramStyles}

  ${userStyles}
`;
        }, "getStyles");
        var addStylesForDiagram = /* @__PURE__ */ __name((type, diagramTheme)=>{
            if (void 0 !== diagramTheme) themes[type] = diagramTheme;
        }, "addStylesForDiagram");
        var styles_default = getStyles;
        var commonDb_exports = {};
        __export(commonDb_exports, {
            clear: ()=>clear,
            getAccDescription: ()=>getAccDescription,
            getAccTitle: ()=>getAccTitle,
            getDiagramTitle: ()=>getDiagramTitle,
            setAccDescription: ()=>setAccDescription,
            setAccTitle: ()=>setAccTitle,
            setDiagramTitle: ()=>setDiagramTitle
        });
        var accTitle = "";
        var diagramTitle = "";
        var accDescription = "";
        var sanitizeText2 = /* @__PURE__ */ __name((txt)=>sanitizeText(txt, getConfig()), "sanitizeText");
        var clear = /* @__PURE__ */ __name(()=>{
            accTitle = "";
            accDescription = "";
            diagramTitle = "";
        }, "clear");
        var setAccTitle = /* @__PURE__ */ __name((txt)=>{
            accTitle = sanitizeText2(txt).replace(/^\s+/g, "");
        }, "setAccTitle");
        var getAccTitle = /* @__PURE__ */ __name(()=>accTitle, "getAccTitle");
        var setAccDescription = /* @__PURE__ */ __name((txt)=>{
            accDescription = sanitizeText2(txt).replace(/\n\s+/g, "\n");
        }, "setAccDescription");
        var getAccDescription = /* @__PURE__ */ __name(()=>accDescription, "getAccDescription");
        var setDiagramTitle = /* @__PURE__ */ __name((txt)=>{
            diagramTitle = sanitizeText2(txt);
        }, "setDiagramTitle");
        var getDiagramTitle = /* @__PURE__ */ __name(()=>diagramTitle, "getDiagramTitle");
        var log2 = log;
        var setLogLevel2 = setLogLevel;
        var getConfig2 = getConfig;
        var setConfig2 = setConfig;
        var defaultConfig2 = defaultConfig;
        var sanitizeText3 = /* @__PURE__ */ __name((text)=>sanitizeText(text, getConfig2()), "sanitizeText");
        var setupGraphViewbox2 = setupGraphViewbox;
        var getCommonDb = /* @__PURE__ */ __name(()=>commonDb_exports, "getCommonDb");
        var diagrams = {};
        var registerDiagram = /* @__PURE__ */ __name((id, diagram, detector)=>{
            if (diagrams[id]) log2.warn(`Diagram with id ${id} already registered. Overwriting.`);
            diagrams[id] = diagram;
            if (detector) addDetector(id, detector);
            addStylesForDiagram(id, diagram.styles);
            diagram.injectUtils?.(log2, setLogLevel2, getConfig2, sanitizeText3, setupGraphViewbox2, getCommonDb(), ()=>{});
        }, "registerDiagram");
        var getDiagram = /* @__PURE__ */ __name((name)=>{
            if (name in diagrams) return diagrams[name];
            throw new DiagramNotFoundError(name);
        }, "getDiagram");
        var DiagramNotFoundError = class extends Error {
            static{
                __name(this, "DiagramNotFoundError");
            }
            constructor(name){
                super(`Diagram ${name} not found.`);
            }
        };
    },
    "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-6JOS74DS.mjs": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            rw: ()=>createText,
            EY: ()=>replaceIconSubstring,
            QA: ()=>computeDimensionOfText
        });
        var chunk_7DKRZKHE = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-7DKRZKHE.mjs");
        var chunk_6DBFFHIP = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-6DBFFHIP.mjs");
        var d3_src = __webpack_require__("./node_modules/.pnpm/d3@7.9.0/node_modules/d3/src/index.js");
        function _getDefaults() {
            return {
                async: false,
                breaks: false,
                extensions: null,
                gfm: true,
                hooks: null,
                pedantic: false,
                renderer: null,
                silent: false,
                tokenizer: null,
                walkTokens: null
            };
        }
        let _defaults = _getDefaults();
        function changeDefaults(newDefaults) {
            _defaults = newDefaults;
        }
        const escapeTest = /[&<>"']/;
        const escapeReplace = new RegExp(escapeTest.source, 'g');
        const escapeTestNoEncode = /[<>"']|&(?!(#\d{1,7}|#[Xx][a-fA-F0-9]{1,6}|\w+);)/;
        const escapeReplaceNoEncode = new RegExp(escapeTestNoEncode.source, 'g');
        const escapeReplacements = {
            '&': '&amp;',
            '<': '&lt;',
            '>': '&gt;',
            '"': '&quot;',
            "'": '&#39;'
        };
        const getEscapeReplacement = (ch)=>escapeReplacements[ch];
        function escape$1(html, encode) {
            if (encode) {
                if (escapeTest.test(html)) return html.replace(escapeReplace, getEscapeReplacement);
            } else if (escapeTestNoEncode.test(html)) return html.replace(escapeReplaceNoEncode, getEscapeReplacement);
            return html;
        }
        const unescapeTest = /&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;
        function marked_esm_unescape(html) {
            return html.replace(unescapeTest, (_, n)=>{
                n = n.toLowerCase();
                if ('colon' === n) return ':';
                if ('#' === n.charAt(0)) return 'x' === n.charAt(1) ? String.fromCharCode(parseInt(n.substring(2), 16)) : String.fromCharCode(+n.substring(1));
                return '';
            });
        }
        const caret = /(^|[^\[])\^/g;
        function edit(regex, opt) {
            let source = 'string' == typeof regex ? regex : regex.source;
            opt = opt || '';
            const obj = {
                replace: (name, val)=>{
                    let valSource = 'string' == typeof val ? val : val.source;
                    valSource = valSource.replace(caret, '$1');
                    source = source.replace(name, valSource);
                    return obj;
                },
                getRegex: ()=>new RegExp(source, opt)
            };
            return obj;
        }
        function cleanUrl(href) {
            try {
                href = encodeURI(href).replace(/%25/g, '%');
            } catch  {
                return null;
            }
            return href;
        }
        const noopTest = {
            exec: ()=>null
        };
        function splitCells(tableRow, count) {
            const row = tableRow.replace(/\|/g, (match, offset, str)=>{
                let escaped = false;
                let curr = offset;
                while(--curr >= 0 && '\\' === str[curr])escaped = !escaped;
                if (escaped) return '|';
                return ' |';
            }), cells = row.split(/ \|/);
            let i = 0;
            if (!cells[0].trim()) cells.shift();
            if (cells.length > 0 && !cells[cells.length - 1].trim()) cells.pop();
            if (count) {
                if (cells.length > count) cells.splice(count);
                else while(cells.length < count)cells.push('');
            }
            for(; i < cells.length; i++)cells[i] = cells[i].trim().replace(/\\\|/g, '|');
            return cells;
        }
        function rtrim(str, c, invert) {
            const l = str.length;
            if (0 === l) return '';
            let suffLen = 0;
            while(suffLen < l){
                const currChar = str.charAt(l - suffLen - 1);
                if (currChar !== c || invert) {
                    if (currChar !== c && invert) suffLen++;
                    else break;
                } else suffLen++;
            }
            return str.slice(0, l - suffLen);
        }
        function findClosingBracket(str, b) {
            if (-1 === str.indexOf(b[1])) return -1;
            let level = 0;
            for(let i = 0; i < str.length; i++)if ('\\' === str[i]) i++;
            else if (str[i] === b[0]) level++;
            else if (str[i] === b[1]) {
                level--;
                if (level < 0) return i;
            }
            return -1;
        }
        function outputLink(cap, link, raw, lexer) {
            const href = link.href;
            const title = link.title ? escape$1(link.title) : null;
            const text = cap[1].replace(/\\([\[\]])/g, '$1');
            if ('!' !== cap[0].charAt(0)) {
                lexer.state.inLink = true;
                const token = {
                    type: 'link',
                    raw,
                    href,
                    title,
                    text,
                    tokens: lexer.inlineTokens(text)
                };
                lexer.state.inLink = false;
                return token;
            }
            return {
                type: 'image',
                raw,
                href,
                title,
                text: escape$1(text)
            };
        }
        function indentCodeCompensation(raw, text) {
            const matchIndentToCode = raw.match(/^(\s+)(?:```)/);
            if (null === matchIndentToCode) return text;
            const indentToCode = matchIndentToCode[1];
            return text.split('\n').map((node)=>{
                const matchIndentInNode = node.match(/^\s+/);
                if (null === matchIndentInNode) return node;
                const [indentInNode] = matchIndentInNode;
                if (indentInNode.length >= indentToCode.length) return node.slice(indentToCode.length);
                return node;
            }).join('\n');
        }
        class _Tokenizer {
            options;
            rules;
            lexer;
            constructor(options){
                this.options = options || _defaults;
            }
            space(src) {
                const cap = this.rules.block.newline.exec(src);
                if (cap && cap[0].length > 0) return {
                    type: 'space',
                    raw: cap[0]
                };
            }
            code(src) {
                const cap = this.rules.block.code.exec(src);
                if (cap) {
                    const text = cap[0].replace(/^ {1,4}/gm, '');
                    return {
                        type: 'code',
                        raw: cap[0],
                        codeBlockStyle: 'indented',
                        text: this.options.pedantic ? text : rtrim(text, '\n')
                    };
                }
            }
            fences(src) {
                const cap = this.rules.block.fences.exec(src);
                if (cap) {
                    const raw = cap[0];
                    const text = indentCodeCompensation(raw, cap[3] || '');
                    return {
                        type: 'code',
                        raw,
                        lang: cap[2] ? cap[2].trim().replace(this.rules.inline.anyPunctuation, '$1') : cap[2],
                        text
                    };
                }
            }
            heading(src) {
                const cap = this.rules.block.heading.exec(src);
                if (cap) {
                    let text = cap[2].trim();
                    if (/#$/.test(text)) {
                        const trimmed = rtrim(text, '#');
                        if (this.options.pedantic) text = trimmed.trim();
                        else if (!trimmed || / $/.test(trimmed)) text = trimmed.trim();
                    }
                    return {
                        type: 'heading',
                        raw: cap[0],
                        depth: cap[1].length,
                        text,
                        tokens: this.lexer.inline(text)
                    };
                }
            }
            hr(src) {
                const cap = this.rules.block.hr.exec(src);
                if (cap) return {
                    type: 'hr',
                    raw: rtrim(cap[0], '\n')
                };
            }
            blockquote(src) {
                const cap = this.rules.block.blockquote.exec(src);
                if (cap) {
                    let lines = rtrim(cap[0], '\n').split('\n');
                    let raw = '';
                    let text = '';
                    const tokens = [];
                    while(lines.length > 0){
                        let inBlockquote = false;
                        const currentLines = [];
                        let i;
                        for(i = 0; i < lines.length; i++)if (/^ {0,3}>/.test(lines[i])) {
                            currentLines.push(lines[i]);
                            inBlockquote = true;
                        } else if (inBlockquote) break;
                        else currentLines.push(lines[i]);
                        lines = lines.slice(i);
                        const currentRaw = currentLines.join('\n');
                        const currentText = currentRaw.replace(/\n {0,3}((?:=+|-+) *)(?=\n|$)/g, '\n    $1').replace(/^ {0,3}>[ \t]?/gm, '');
                        raw = raw ? `${raw}\n${currentRaw}` : currentRaw;
                        text = text ? `${text}\n${currentText}` : currentText;
                        const top = this.lexer.state.top;
                        this.lexer.state.top = true;
                        this.lexer.blockTokens(currentText, tokens, true);
                        this.lexer.state.top = top;
                        if (0 === lines.length) break;
                        const lastToken = tokens[tokens.length - 1];
                        if (lastToken?.type === 'code') break;
                        if (lastToken?.type === 'blockquote') {
                            const oldToken = lastToken;
                            const newText = oldToken.raw + '\n' + lines.join('\n');
                            const newToken = this.blockquote(newText);
                            tokens[tokens.length - 1] = newToken;
                            raw = raw.substring(0, raw.length - oldToken.raw.length) + newToken.raw;
                            text = text.substring(0, text.length - oldToken.text.length) + newToken.text;
                            break;
                        }
                        if (lastToken?.type === 'list') {
                            const oldToken = lastToken;
                            const newText = oldToken.raw + '\n' + lines.join('\n');
                            const newToken = this.list(newText);
                            tokens[tokens.length - 1] = newToken;
                            raw = raw.substring(0, raw.length - lastToken.raw.length) + newToken.raw;
                            text = text.substring(0, text.length - oldToken.raw.length) + newToken.raw;
                            lines = newText.substring(tokens[tokens.length - 1].raw.length).split('\n');
                            continue;
                        }
                    }
                    return {
                        type: 'blockquote',
                        raw,
                        tokens,
                        text
                    };
                }
            }
            list(src) {
                let cap = this.rules.block.list.exec(src);
                if (cap) {
                    let bull = cap[1].trim();
                    const isordered = bull.length > 1;
                    const list = {
                        type: 'list',
                        raw: '',
                        ordered: isordered,
                        start: isordered ? +bull.slice(0, -1) : '',
                        loose: false,
                        items: []
                    };
                    bull = isordered ? `\\d{1,9}\\${bull.slice(-1)}` : `\\${bull}`;
                    if (this.options.pedantic) bull = isordered ? bull : '[*+-]';
                    const itemRegex = new RegExp(`^( {0,3}${bull})((?:[\t ][^\\n]*)?(?:\\n|$))`);
                    let endsWithBlankLine = false;
                    while(src){
                        let endEarly = false;
                        let raw = '';
                        let itemContents = '';
                        if (!(cap = itemRegex.exec(src))) break;
                        if (this.rules.block.hr.test(src)) break;
                        raw = cap[0];
                        src = src.substring(raw.length);
                        let line = cap[2].split('\n', 1)[0].replace(/^\t+/, (t)=>' '.repeat(3 * t.length));
                        let nextLine = src.split('\n', 1)[0];
                        let blankLine = !line.trim();
                        let indent = 0;
                        if (this.options.pedantic) {
                            indent = 2;
                            itemContents = line.trimStart();
                        } else if (blankLine) indent = cap[1].length + 1;
                        else {
                            indent = cap[2].search(/[^ ]/);
                            indent = indent > 4 ? 1 : indent;
                            itemContents = line.slice(indent);
                            indent += cap[1].length;
                        }
                        if (blankLine && /^ *$/.test(nextLine)) {
                            raw += nextLine + '\n';
                            src = src.substring(nextLine.length + 1);
                            endEarly = true;
                        }
                        if (!endEarly) {
                            const nextBulletRegex = new RegExp(`^ {0,${Math.min(3, indent - 1)}}(?:[*+-]|\\d{1,9}[.)])((?:[ \t][^\\n]*)?(?:\\n|$))`);
                            const hrRegex = new RegExp(`^ {0,${Math.min(3, indent - 1)}}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)`);
                            const fencesBeginRegex = new RegExp(`^ {0,${Math.min(3, indent - 1)}}(?:\`\`\`|~~~)`);
                            const headingBeginRegex = new RegExp(`^ {0,${Math.min(3, indent - 1)}}#`);
                            while(src){
                                const rawLine = src.split('\n', 1)[0];
                                nextLine = rawLine;
                                if (this.options.pedantic) nextLine = nextLine.replace(/^ {1,4}(?=( {4})*[^ ])/g, '  ');
                                if (fencesBeginRegex.test(nextLine)) break;
                                if (headingBeginRegex.test(nextLine)) break;
                                if (nextBulletRegex.test(nextLine)) break;
                                if (hrRegex.test(src)) break;
                                if (nextLine.search(/[^ ]/) >= indent || !nextLine.trim()) itemContents += '\n' + nextLine.slice(indent);
                                else {
                                    if (blankLine) break;
                                    if (line.search(/[^ ]/) >= 4) break;
                                    if (fencesBeginRegex.test(line)) break;
                                    if (headingBeginRegex.test(line)) break;
                                    if (hrRegex.test(line)) break;
                                    itemContents += '\n' + nextLine;
                                }
                                if (!blankLine && !nextLine.trim()) blankLine = true;
                                raw += rawLine + '\n';
                                src = src.substring(rawLine.length + 1);
                                line = nextLine.slice(indent);
                            }
                        }
                        if (!list.loose) {
                            if (endsWithBlankLine) list.loose = true;
                            else if (/\n *\n *$/.test(raw)) endsWithBlankLine = true;
                        }
                        let istask = null;
                        let ischecked;
                        if (this.options.gfm) {
                            istask = /^\[[ xX]\] /.exec(itemContents);
                            if (istask) {
                                ischecked = '[ ] ' !== istask[0];
                                itemContents = itemContents.replace(/^\[[ xX]\] +/, '');
                            }
                        }
                        list.items.push({
                            type: 'list_item',
                            raw,
                            task: !!istask,
                            checked: ischecked,
                            loose: false,
                            text: itemContents,
                            tokens: []
                        });
                        list.raw += raw;
                    }
                    list.items[list.items.length - 1].raw = list.items[list.items.length - 1].raw.trimEnd();
                    list.items[list.items.length - 1].text = list.items[list.items.length - 1].text.trimEnd();
                    list.raw = list.raw.trimEnd();
                    for(let i = 0; i < list.items.length; i++){
                        this.lexer.state.top = false;
                        list.items[i].tokens = this.lexer.blockTokens(list.items[i].text, []);
                        if (!list.loose) {
                            const spacers = list.items[i].tokens.filter((t)=>'space' === t.type);
                            const hasMultipleLineBreaks = spacers.length > 0 && spacers.some((t)=>/\n.*\n/.test(t.raw));
                            list.loose = hasMultipleLineBreaks;
                        }
                    }
                    if (list.loose) for(let i = 0; i < list.items.length; i++)list.items[i].loose = true;
                    return list;
                }
            }
            html(src) {
                const cap = this.rules.block.html.exec(src);
                if (cap) {
                    const token = {
                        type: 'html',
                        block: true,
                        raw: cap[0],
                        pre: 'pre' === cap[1] || "script" === cap[1] || 'style' === cap[1],
                        text: cap[0]
                    };
                    return token;
                }
            }
            def(src) {
                const cap = this.rules.block.def.exec(src);
                if (cap) {
                    const tag = cap[1].toLowerCase().replace(/\s+/g, ' ');
                    const href = cap[2] ? cap[2].replace(/^<(.*)>$/, '$1').replace(this.rules.inline.anyPunctuation, '$1') : '';
                    const title = cap[3] ? cap[3].substring(1, cap[3].length - 1).replace(this.rules.inline.anyPunctuation, '$1') : cap[3];
                    return {
                        type: 'def',
                        tag,
                        raw: cap[0],
                        href,
                        title
                    };
                }
            }
            table(src) {
                const cap = this.rules.block.table.exec(src);
                if (!cap) return;
                if (!/[:|]/.test(cap[2])) return;
                const headers = splitCells(cap[1]);
                const aligns = cap[2].replace(/^\||\| *$/g, '').split('|');
                const rows = cap[3] && cap[3].trim() ? cap[3].replace(/\n[ \t]*$/, '').split('\n') : [];
                const item = {
                    type: 'table',
                    raw: cap[0],
                    header: [],
                    align: [],
                    rows: []
                };
                if (headers.length !== aligns.length) return;
                for (const align of aligns)if (/^ *-+: *$/.test(align)) item.align.push('right');
                else if (/^ *:-+: *$/.test(align)) item.align.push('center');
                else if (/^ *:-+ *$/.test(align)) item.align.push('left');
                else item.align.push(null);
                for(let i = 0; i < headers.length; i++)item.header.push({
                    text: headers[i],
                    tokens: this.lexer.inline(headers[i]),
                    header: true,
                    align: item.align[i]
                });
                for (const row of rows)item.rows.push(splitCells(row, item.header.length).map((cell, i)=>({
                        text: cell,
                        tokens: this.lexer.inline(cell),
                        header: false,
                        align: item.align[i]
                    })));
                return item;
            }
            lheading(src) {
                const cap = this.rules.block.lheading.exec(src);
                if (cap) return {
                    type: 'heading',
                    raw: cap[0],
                    depth: '=' === cap[2].charAt(0) ? 1 : 2,
                    text: cap[1],
                    tokens: this.lexer.inline(cap[1])
                };
            }
            paragraph(src) {
                const cap = this.rules.block.paragraph.exec(src);
                if (cap) {
                    const text = '\n' === cap[1].charAt(cap[1].length - 1) ? cap[1].slice(0, -1) : cap[1];
                    return {
                        type: 'paragraph',
                        raw: cap[0],
                        text,
                        tokens: this.lexer.inline(text)
                    };
                }
            }
            text(src) {
                const cap = this.rules.block.text.exec(src);
                if (cap) return {
                    type: 'text',
                    raw: cap[0],
                    text: cap[0],
                    tokens: this.lexer.inline(cap[0])
                };
            }
            escape(src) {
                const cap = this.rules.inline.escape.exec(src);
                if (cap) return {
                    type: 'escape',
                    raw: cap[0],
                    text: escape$1(cap[1])
                };
            }
            tag(src) {
                const cap = this.rules.inline.tag.exec(src);
                if (cap) {
                    if (!this.lexer.state.inLink && /^<a /i.test(cap[0])) this.lexer.state.inLink = true;
                    else if (this.lexer.state.inLink && /^<\/a>/i.test(cap[0])) this.lexer.state.inLink = false;
                    if (!this.lexer.state.inRawBlock && /^<(pre|code|kbd|script)(\s|>)/i.test(cap[0])) this.lexer.state.inRawBlock = true;
                    else if (this.lexer.state.inRawBlock && /^<\/(pre|code|kbd|script)(\s|>)/i.test(cap[0])) this.lexer.state.inRawBlock = false;
                    return {
                        type: 'html',
                        raw: cap[0],
                        inLink: this.lexer.state.inLink,
                        inRawBlock: this.lexer.state.inRawBlock,
                        block: false,
                        text: cap[0]
                    };
                }
            }
            link(src) {
                const cap = this.rules.inline.link.exec(src);
                if (cap) {
                    const trimmedUrl = cap[2].trim();
                    if (!this.options.pedantic && /^</.test(trimmedUrl)) {
                        if (!/>$/.test(trimmedUrl)) return;
                        const rtrimSlash = rtrim(trimmedUrl.slice(0, -1), '\\');
                        if ((trimmedUrl.length - rtrimSlash.length) % 2 === 0) return;
                    } else {
                        const lastParenIndex = findClosingBracket(cap[2], '()');
                        if (lastParenIndex > -1) {
                            const start = 0 === cap[0].indexOf('!') ? 5 : 4;
                            const linkLen = start + cap[1].length + lastParenIndex;
                            cap[2] = cap[2].substring(0, lastParenIndex);
                            cap[0] = cap[0].substring(0, linkLen).trim();
                            cap[3] = '';
                        }
                    }
                    let href = cap[2];
                    let title = '';
                    if (this.options.pedantic) {
                        const link = /^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(href);
                        if (link) {
                            href = link[1];
                            title = link[3];
                        }
                    } else title = cap[3] ? cap[3].slice(1, -1) : '';
                    href = href.trim();
                    if (/^</.test(href)) href = this.options.pedantic && !/>$/.test(trimmedUrl) ? href.slice(1) : href.slice(1, -1);
                    return outputLink(cap, {
                        href: href ? href.replace(this.rules.inline.anyPunctuation, '$1') : href,
                        title: title ? title.replace(this.rules.inline.anyPunctuation, '$1') : title
                    }, cap[0], this.lexer);
                }
            }
            reflink(src, links) {
                let cap;
                if ((cap = this.rules.inline.reflink.exec(src)) || (cap = this.rules.inline.nolink.exec(src))) {
                    const linkString = (cap[2] || cap[1]).replace(/\s+/g, ' ');
                    const link = links[linkString.toLowerCase()];
                    if (!link) {
                        const text = cap[0].charAt(0);
                        return {
                            type: 'text',
                            raw: text,
                            text
                        };
                    }
                    return outputLink(cap, link, cap[0], this.lexer);
                }
            }
            emStrong(src, maskedSrc, prevChar = '') {
                let match = this.rules.inline.emStrongLDelim.exec(src);
                if (!match) return;
                if (match[3] && prevChar.match(/[\p{L}\p{N}]/u)) return;
                const nextChar = match[1] || match[2] || '';
                if (!nextChar || !prevChar || this.rules.inline.punctuation.exec(prevChar)) {
                    const lLength = [
                        ...match[0]
                    ].length - 1;
                    let rDelim, rLength, delimTotal = lLength, midDelimTotal = 0;
                    const endReg = '*' === match[0][0] ? this.rules.inline.emStrongRDelimAst : this.rules.inline.emStrongRDelimUnd;
                    endReg.lastIndex = 0;
                    maskedSrc = maskedSrc.slice(-1 * src.length + lLength);
                    while(null != (match = endReg.exec(maskedSrc))){
                        rDelim = match[1] || match[2] || match[3] || match[4] || match[5] || match[6];
                        if (!rDelim) continue;
                        rLength = [
                            ...rDelim
                        ].length;
                        if (match[3] || match[4]) {
                            delimTotal += rLength;
                            continue;
                        }
                        if (match[5] || match[6]) {
                            if (lLength % 3 && !((lLength + rLength) % 3)) {
                                midDelimTotal += rLength;
                                continue;
                            }
                        }
                        delimTotal -= rLength;
                        if (delimTotal > 0) continue;
                        rLength = Math.min(rLength, rLength + delimTotal + midDelimTotal);
                        const lastCharLength = [
                            ...match[0]
                        ][0].length;
                        const raw = src.slice(0, lLength + match.index + lastCharLength + rLength);
                        if (Math.min(lLength, rLength) % 2) {
                            const text = raw.slice(1, -1);
                            return {
                                type: 'em',
                                raw,
                                text,
                                tokens: this.lexer.inlineTokens(text)
                            };
                        }
                        const text = raw.slice(2, -2);
                        return {
                            type: 'strong',
                            raw,
                            text,
                            tokens: this.lexer.inlineTokens(text)
                        };
                    }
                }
            }
            codespan(src) {
                const cap = this.rules.inline.code.exec(src);
                if (cap) {
                    let text = cap[2].replace(/\n/g, ' ');
                    const hasNonSpaceChars = /[^ ]/.test(text);
                    const hasSpaceCharsOnBothEnds = /^ /.test(text) && / $/.test(text);
                    if (hasNonSpaceChars && hasSpaceCharsOnBothEnds) text = text.substring(1, text.length - 1);
                    text = escape$1(text, true);
                    return {
                        type: 'codespan',
                        raw: cap[0],
                        text
                    };
                }
            }
            br(src) {
                const cap = this.rules.inline.br.exec(src);
                if (cap) return {
                    type: 'br',
                    raw: cap[0]
                };
            }
            del(src) {
                const cap = this.rules.inline.del.exec(src);
                if (cap) return {
                    type: 'del',
                    raw: cap[0],
                    text: cap[2],
                    tokens: this.lexer.inlineTokens(cap[2])
                };
            }
            autolink(src) {
                const cap = this.rules.inline.autolink.exec(src);
                if (cap) {
                    let text, href;
                    if ('@' === cap[2]) {
                        text = escape$1(cap[1]);
                        href = 'mailto:' + text;
                    } else {
                        text = escape$1(cap[1]);
                        href = text;
                    }
                    return {
                        type: 'link',
                        raw: cap[0],
                        text,
                        href,
                        tokens: [
                            {
                                type: 'text',
                                raw: text,
                                text
                            }
                        ]
                    };
                }
            }
            url(src) {
                let cap;
                if (cap = this.rules.inline.url.exec(src)) {
                    let text, href;
                    if ('@' === cap[2]) {
                        text = escape$1(cap[0]);
                        href = 'mailto:' + text;
                    } else {
                        let prevCapZero;
                        do {
                            prevCapZero = cap[0];
                            cap[0] = this.rules.inline._backpedal.exec(cap[0])?.[0] ?? '';
                        }while (prevCapZero !== cap[0]);
                        text = escape$1(cap[0]);
                        href = 'www.' === cap[1] ? 'http://' + cap[0] : cap[0];
                    }
                    return {
                        type: 'link',
                        raw: cap[0],
                        text,
                        href,
                        tokens: [
                            {
                                type: 'text',
                                raw: text,
                                text
                            }
                        ]
                    };
                }
            }
            inlineText(src) {
                const cap = this.rules.inline.text.exec(src);
                if (cap) {
                    let text;
                    text = this.lexer.state.inRawBlock ? cap[0] : escape$1(cap[0]);
                    return {
                        type: 'text',
                        raw: cap[0],
                        text
                    };
                }
            }
        }
        const newline = /^(?: *(?:\n|$))+/;
        const blockCode = /^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/;
        const fences = /^ {0,3}(`{3,}(?=[^`\n]*(?:\n|$))|~{3,})([^\n]*)(?:\n|$)(?:|([\s\S]*?)(?:\n|$))(?: {0,3}\1[~`]* *(?=\n|$)|$)/;
        const hr = /^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/;
        const heading = /^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/;
        const bullet = /(?:[*+-]|\d{1,9}[.)])/;
        const lheading = edit(/^(?!bull |blockCode|fences|blockquote|heading|html)((?:.|\n(?!\s*?\n|bull |blockCode|fences|blockquote|heading|html))+?)\n {0,3}(=+|-+) *(?:\n+|$)/).replace(/bull/g, bullet).replace(/blockCode/g, / {4}/).replace(/fences/g, / {0,3}(?:`{3,}|~{3,})/).replace(/blockquote/g, / {0,3}>/).replace(/heading/g, / {0,3}#{1,6}/).replace(/html/g, / {0,3}<[^\n>]+>\n/).getRegex();
        const _paragraph = /^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/;
        const blockText = /^[^\n]+/;
        const _blockLabel = /(?!\s*\])(?:\\.|[^\[\]\\])+/;
        const def = edit(/^ {0,3}\[(label)\]: *(?:\n *)?([^<\s][^\s]*|<.*?>)(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/).replace('label', _blockLabel).replace('title', /(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/).getRegex();
        const marked_esm_list = edit(/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/).replace(/bull/g, bullet).getRegex();
        const _tag = "address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|search|section|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul";
        const _comment = /<!--(?:-?>|[\s\S]*?(?:-->|$))/;
        const marked_esm_html = edit("^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))", 'i').replace('comment', _comment).replace('tag', _tag).replace('attribute', / +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex();
        const paragraph = edit(_paragraph).replace('hr', hr).replace('heading', ' {0,3}#{1,6}(?:\\s|$)').replace('|lheading', '').replace('|table', '').replace('blockquote', ' {0,3}>').replace('fences', ' {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n').replace('list', ' {0,3}(?:[*+-]|1[.)]) ').replace('html', "</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace('tag', _tag).getRegex();
        const blockquote = edit(/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/).replace('paragraph', paragraph).getRegex();
        const blockNormal = {
            blockquote,
            code: blockCode,
            def,
            fences,
            heading,
            hr,
            html: marked_esm_html,
            lheading,
            list: marked_esm_list,
            newline,
            paragraph,
            table: noopTest,
            text: blockText
        };
        const gfmTable = edit("^ *([^\\n ].*)\\n {0,3}((?:\\| *)?:?-+:? *(?:\\| *:?-+:? *)*(?:\\| *)?)(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)").replace('hr', hr).replace('heading', ' {0,3}#{1,6}(?:\\s|$)').replace('blockquote', ' {0,3}>').replace('code', ' {4}[^\\n]').replace('fences', ' {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n').replace('list', ' {0,3}(?:[*+-]|1[.)]) ').replace('html', "</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace('tag', _tag).getRegex();
        const blockGfm = {
            ...blockNormal,
            table: gfmTable,
            paragraph: edit(_paragraph).replace('hr', hr).replace('heading', ' {0,3}#{1,6}(?:\\s|$)').replace('|lheading', '').replace('table', gfmTable).replace('blockquote', ' {0,3}>').replace('fences', ' {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n').replace('list', ' {0,3}(?:[*+-]|1[.)]) ').replace('html', "</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace('tag', _tag).getRegex()
        };
        const blockPedantic = {
            ...blockNormal,
            html: edit("^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:\"[^\"]*\"|'[^']*'|\\s[^'\"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))").replace('comment', _comment).replace(/tag/g, "(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),
            def: /^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,
            heading: /^(#{1,6})(.*)(?:\n+|$)/,
            fences: noopTest,
            lheading: /^(.+?)\n {0,3}(=+|-+) *(?:\n+|$)/,
            paragraph: edit(_paragraph).replace('hr', hr).replace('heading', ' *#{1,6} *[^\n]').replace('lheading', lheading).replace('|table', '').replace('blockquote', ' {0,3}>').replace('|fences', '').replace('|list', '').replace('|html', '').replace('|tag', '').getRegex()
        };
        const marked_esm_escape = /^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/;
        const inlineCode = /^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/;
        const br = /^( {2,}|\\)\n(?!\s*$)/;
        const inlineText = /^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/;
        const _punctuation = '\\p{P}\\p{S}';
        const punctuation = edit(/^((?![*_])[\spunctuation])/, 'u').replace(/punctuation/g, _punctuation).getRegex();
        const blockSkip = /\[[^[\]]*?\]\([^\(\)]*?\)|`[^`]*?`|<[^<>]*?>/g;
        const emStrongLDelim = edit(/^(?:\*+(?:((?!\*)[punct])|[^\s*]))|^_+(?:((?!_)[punct])|([^\s_]))/, 'u').replace(/punct/g, _punctuation).getRegex();
        const emStrongRDelimAst = edit("^[^_*]*?__[^_*]*?\\*[^_*]*?(?=__)|[^*]+(?=[^*])|(?!\\*)[punct](\\*+)(?=[\\s]|$)|[^punct\\s](\\*+)(?!\\*)(?=[punct\\s]|$)|(?!\\*)[punct\\s](\\*+)(?=[^punct\\s])|[\\s](\\*+)(?!\\*)(?=[punct])|(?!\\*)[punct](\\*+)(?!\\*)(?=[punct])|[^punct\\s](\\*+)(?=[^punct\\s])", 'gu').replace(/punct/g, _punctuation).getRegex();
        const emStrongRDelimUnd = edit("^[^_*]*?\\*\\*[^_*]*?_[^_*]*?(?=\\*\\*)|[^_]+(?=[^_])|(?!_)[punct](_+)(?=[\\s]|$)|[^punct\\s](_+)(?!_)(?=[punct\\s]|$)|(?!_)[punct\\s](_+)(?=[^punct\\s])|[\\s](_+)(?!_)(?=[punct])|(?!_)[punct](_+)(?!_)(?=[punct])", 'gu').replace(/punct/g, _punctuation).getRegex();
        const anyPunctuation = edit(/\\([punct])/, 'gu').replace(/punct/g, _punctuation).getRegex();
        const autolink = edit(/^<(scheme:[^\s\x00-\x1f<>]*|email)>/).replace('scheme', /[a-zA-Z][a-zA-Z0-9+.-]{1,31}/).replace('email', /[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/).getRegex();
        const _inlineComment = edit(_comment).replace('(?:-->|$)', '-->').getRegex();
        const marked_esm_tag = edit("^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>").replace('comment', _inlineComment).replace('attribute', /\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/).getRegex();
        const _inlineLabel = /(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/;
        const marked_esm_link = edit(/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/).replace('label', _inlineLabel).replace('href', /<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/).replace('title', /"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/).getRegex();
        const reflink = edit(/^!?\[(label)\]\[(ref)\]/).replace('label', _inlineLabel).replace('ref', _blockLabel).getRegex();
        const nolink = edit(/^!?\[(ref)\](?:\[\])?/).replace('ref', _blockLabel).getRegex();
        const reflinkSearch = edit('reflink|nolink(?!\\()', 'g').replace('reflink', reflink).replace('nolink', nolink).getRegex();
        const inlineNormal = {
            _backpedal: noopTest,
            anyPunctuation,
            autolink,
            blockSkip,
            br,
            code: inlineCode,
            del: noopTest,
            emStrongLDelim,
            emStrongRDelimAst,
            emStrongRDelimUnd,
            escape: marked_esm_escape,
            link: marked_esm_link,
            nolink,
            punctuation,
            reflink,
            reflinkSearch,
            tag: marked_esm_tag,
            text: inlineText,
            url: noopTest
        };
        const inlinePedantic = {
            ...inlineNormal,
            link: edit(/^!?\[(label)\]\((.*?)\)/).replace('label', _inlineLabel).getRegex(),
            reflink: edit(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace('label', _inlineLabel).getRegex()
        };
        const inlineGfm = {
            ...inlineNormal,
            escape: edit(marked_esm_escape).replace('])', '~|])').getRegex(),
            url: edit(/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/, 'i').replace('email', /[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/).getRegex(),
            _backpedal: /(?:[^?!.,:;*_'"~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_'"~)]+(?!$))+/,
            del: /^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,
            text: /^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/
        };
        const inlineBreaks = {
            ...inlineGfm,
            br: edit(br).replace('{2,}', '*').getRegex(),
            text: edit(inlineGfm.text).replace('\\b_', '\\b_| {2,}\\n').replace(/\{2,\}/g, '*').getRegex()
        };
        const block = {
            normal: blockNormal,
            gfm: blockGfm,
            pedantic: blockPedantic
        };
        const inline = {
            normal: inlineNormal,
            gfm: inlineGfm,
            breaks: inlineBreaks,
            pedantic: inlinePedantic
        };
        class _Lexer {
            tokens;
            options;
            state;
            tokenizer;
            inlineQueue;
            constructor(options){
                this.tokens = [];
                this.tokens.links = Object.create(null);
                this.options = options || _defaults;
                this.options.tokenizer = this.options.tokenizer || new _Tokenizer();
                this.tokenizer = this.options.tokenizer;
                this.tokenizer.options = this.options;
                this.tokenizer.lexer = this;
                this.inlineQueue = [];
                this.state = {
                    inLink: false,
                    inRawBlock: false,
                    top: true
                };
                const rules = {
                    block: block.normal,
                    inline: inline.normal
                };
                if (this.options.pedantic) {
                    rules.block = block.pedantic;
                    rules.inline = inline.pedantic;
                } else if (this.options.gfm) {
                    rules.block = block.gfm;
                    if (this.options.breaks) rules.inline = inline.breaks;
                    else rules.inline = inline.gfm;
                }
                this.tokenizer.rules = rules;
            }
            static get rules() {
                return {
                    block,
                    inline
                };
            }
            static lex(src, options) {
                const lexer = new _Lexer(options);
                return lexer.lex(src);
            }
            static lexInline(src, options) {
                const lexer = new _Lexer(options);
                return lexer.inlineTokens(src);
            }
            lex(src) {
                src = src.replace(/\r\n|\r/g, '\n');
                this.blockTokens(src, this.tokens);
                for(let i = 0; i < this.inlineQueue.length; i++){
                    const next = this.inlineQueue[i];
                    this.inlineTokens(next.src, next.tokens);
                }
                this.inlineQueue = [];
                return this.tokens;
            }
            blockTokens(src, tokens = [], lastParagraphClipped = false) {
                src = this.options.pedantic ? src.replace(/\t/g, '    ').replace(/^ +$/gm, '') : src.replace(/^( *)(\t+)/gm, (_, leading, tabs)=>leading + '    '.repeat(tabs.length));
                let token;
                let lastToken;
                let cutSrc;
                while(src){
                    if (this.options.extensions && this.options.extensions.block && this.options.extensions.block.some((extTokenizer)=>{
                        if (token = extTokenizer.call({
                            lexer: this
                        }, src, tokens)) {
                            src = src.substring(token.raw.length);
                            tokens.push(token);
                            return true;
                        }
                        return false;
                    })) continue;
                    if (token = this.tokenizer.space(src)) {
                        src = src.substring(token.raw.length);
                        if (1 === token.raw.length && tokens.length > 0) tokens[tokens.length - 1].raw += '\n';
                        else tokens.push(token);
                        continue;
                    }
                    if (token = this.tokenizer.code(src)) {
                        src = src.substring(token.raw.length);
                        lastToken = tokens[tokens.length - 1];
                        if (lastToken && ('paragraph' === lastToken.type || 'text' === lastToken.type)) {
                            lastToken.raw += '\n' + token.raw;
                            lastToken.text += '\n' + token.text;
                            this.inlineQueue[this.inlineQueue.length - 1].src = lastToken.text;
                        } else tokens.push(token);
                        continue;
                    }
                    if (token = this.tokenizer.fences(src)) {
                        src = src.substring(token.raw.length);
                        tokens.push(token);
                        continue;
                    }
                    if (token = this.tokenizer.heading(src)) {
                        src = src.substring(token.raw.length);
                        tokens.push(token);
                        continue;
                    }
                    if (token = this.tokenizer.hr(src)) {
                        src = src.substring(token.raw.length);
                        tokens.push(token);
                        continue;
                    }
                    if (token = this.tokenizer.blockquote(src)) {
                        src = src.substring(token.raw.length);
                        tokens.push(token);
                        continue;
                    }
                    if (token = this.tokenizer.list(src)) {
                        src = src.substring(token.raw.length);
                        tokens.push(token);
                        continue;
                    }
                    if (token = this.tokenizer.html(src)) {
                        src = src.substring(token.raw.length);
                        tokens.push(token);
                        continue;
                    }
                    if (token = this.tokenizer.def(src)) {
                        src = src.substring(token.raw.length);
                        lastToken = tokens[tokens.length - 1];
                        if (lastToken && ('paragraph' === lastToken.type || 'text' === lastToken.type)) {
                            lastToken.raw += '\n' + token.raw;
                            lastToken.text += '\n' + token.raw;
                            this.inlineQueue[this.inlineQueue.length - 1].src = lastToken.text;
                        } else if (!this.tokens.links[token.tag]) this.tokens.links[token.tag] = {
                            href: token.href,
                            title: token.title
                        };
                        continue;
                    }
                    if (token = this.tokenizer.table(src)) {
                        src = src.substring(token.raw.length);
                        tokens.push(token);
                        continue;
                    }
                    if (token = this.tokenizer.lheading(src)) {
                        src = src.substring(token.raw.length);
                        tokens.push(token);
                        continue;
                    }
                    cutSrc = src;
                    if (this.options.extensions && this.options.extensions.startBlock) {
                        let startIndex = 1 / 0;
                        const tempSrc = src.slice(1);
                        let tempStart;
                        this.options.extensions.startBlock.forEach((getStartIndex)=>{
                            tempStart = getStartIndex.call({
                                lexer: this
                            }, tempSrc);
                            if ('number' == typeof tempStart && tempStart >= 0) startIndex = Math.min(startIndex, tempStart);
                        });
                        if (startIndex < 1 / 0 && startIndex >= 0) cutSrc = src.substring(0, startIndex + 1);
                    }
                    if (this.state.top && (token = this.tokenizer.paragraph(cutSrc))) {
                        lastToken = tokens[tokens.length - 1];
                        if (lastParagraphClipped && lastToken?.type === 'paragraph') {
                            lastToken.raw += '\n' + token.raw;
                            lastToken.text += '\n' + token.text;
                            this.inlineQueue.pop();
                            this.inlineQueue[this.inlineQueue.length - 1].src = lastToken.text;
                        } else tokens.push(token);
                        lastParagraphClipped = cutSrc.length !== src.length;
                        src = src.substring(token.raw.length);
                        continue;
                    }
                    if (token = this.tokenizer.text(src)) {
                        src = src.substring(token.raw.length);
                        lastToken = tokens[tokens.length - 1];
                        if (lastToken && 'text' === lastToken.type) {
                            lastToken.raw += '\n' + token.raw;
                            lastToken.text += '\n' + token.text;
                            this.inlineQueue.pop();
                            this.inlineQueue[this.inlineQueue.length - 1].src = lastToken.text;
                        } else tokens.push(token);
                        continue;
                    }
                    if (src) {
                        const errMsg = 'Infinite loop on byte: ' + src.charCodeAt(0);
                        if (this.options.silent) {
                            console.error(errMsg);
                            break;
                        }
                        throw new Error(errMsg);
                    }
                }
                this.state.top = true;
                return tokens;
            }
            inline(src, tokens = []) {
                this.inlineQueue.push({
                    src,
                    tokens
                });
                return tokens;
            }
            inlineTokens(src, tokens = []) {
                let token, lastToken, cutSrc;
                let maskedSrc = src;
                let match;
                let keepPrevChar, prevChar;
                if (this.tokens.links) {
                    const links = Object.keys(this.tokens.links);
                    if (links.length > 0) {
                        while(null != (match = this.tokenizer.rules.inline.reflinkSearch.exec(maskedSrc)))if (links.includes(match[0].slice(match[0].lastIndexOf('[') + 1, -1))) maskedSrc = maskedSrc.slice(0, match.index) + '[' + 'a'.repeat(match[0].length - 2) + ']' + maskedSrc.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex);
                    }
                }
                while(null != (match = this.tokenizer.rules.inline.blockSkip.exec(maskedSrc)))maskedSrc = maskedSrc.slice(0, match.index) + '[' + 'a'.repeat(match[0].length - 2) + ']' + maskedSrc.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);
                while(null != (match = this.tokenizer.rules.inline.anyPunctuation.exec(maskedSrc)))maskedSrc = maskedSrc.slice(0, match.index) + '++' + maskedSrc.slice(this.tokenizer.rules.inline.anyPunctuation.lastIndex);
                while(src){
                    if (!keepPrevChar) prevChar = '';
                    keepPrevChar = false;
                    if (this.options.extensions && this.options.extensions.inline && this.options.extensions.inline.some((extTokenizer)=>{
                        if (token = extTokenizer.call({
                            lexer: this
                        }, src, tokens)) {
                            src = src.substring(token.raw.length);
                            tokens.push(token);
                            return true;
                        }
                        return false;
                    })) continue;
                    if (token = this.tokenizer.escape(src)) {
                        src = src.substring(token.raw.length);
                        tokens.push(token);
                        continue;
                    }
                    if (token = this.tokenizer.tag(src)) {
                        src = src.substring(token.raw.length);
                        lastToken = tokens[tokens.length - 1];
                        if (lastToken && 'text' === token.type && 'text' === lastToken.type) {
                            lastToken.raw += token.raw;
                            lastToken.text += token.text;
                        } else tokens.push(token);
                        continue;
                    }
                    if (token = this.tokenizer.link(src)) {
                        src = src.substring(token.raw.length);
                        tokens.push(token);
                        continue;
                    }
                    if (token = this.tokenizer.reflink(src, this.tokens.links)) {
                        src = src.substring(token.raw.length);
                        lastToken = tokens[tokens.length - 1];
                        if (lastToken && 'text' === token.type && 'text' === lastToken.type) {
                            lastToken.raw += token.raw;
                            lastToken.text += token.text;
                        } else tokens.push(token);
                        continue;
                    }
                    if (token = this.tokenizer.emStrong(src, maskedSrc, prevChar)) {
                        src = src.substring(token.raw.length);
                        tokens.push(token);
                        continue;
                    }
                    if (token = this.tokenizer.codespan(src)) {
                        src = src.substring(token.raw.length);
                        tokens.push(token);
                        continue;
                    }
                    if (token = this.tokenizer.br(src)) {
                        src = src.substring(token.raw.length);
                        tokens.push(token);
                        continue;
                    }
                    if (token = this.tokenizer.del(src)) {
                        src = src.substring(token.raw.length);
                        tokens.push(token);
                        continue;
                    }
                    if (token = this.tokenizer.autolink(src)) {
                        src = src.substring(token.raw.length);
                        tokens.push(token);
                        continue;
                    }
                    if (!this.state.inLink && (token = this.tokenizer.url(src))) {
                        src = src.substring(token.raw.length);
                        tokens.push(token);
                        continue;
                    }
                    cutSrc = src;
                    if (this.options.extensions && this.options.extensions.startInline) {
                        let startIndex = 1 / 0;
                        const tempSrc = src.slice(1);
                        let tempStart;
                        this.options.extensions.startInline.forEach((getStartIndex)=>{
                            tempStart = getStartIndex.call({
                                lexer: this
                            }, tempSrc);
                            if ('number' == typeof tempStart && tempStart >= 0) startIndex = Math.min(startIndex, tempStart);
                        });
                        if (startIndex < 1 / 0 && startIndex >= 0) cutSrc = src.substring(0, startIndex + 1);
                    }
                    if (token = this.tokenizer.inlineText(cutSrc)) {
                        src = src.substring(token.raw.length);
                        if ('_' !== token.raw.slice(-1)) prevChar = token.raw.slice(-1);
                        keepPrevChar = true;
                        lastToken = tokens[tokens.length - 1];
                        if (lastToken && 'text' === lastToken.type) {
                            lastToken.raw += token.raw;
                            lastToken.text += token.text;
                        } else tokens.push(token);
                        continue;
                    }
                    if (src) {
                        const errMsg = 'Infinite loop on byte: ' + src.charCodeAt(0);
                        if (this.options.silent) {
                            console.error(errMsg);
                            break;
                        }
                        throw new Error(errMsg);
                    }
                }
                return tokens;
            }
        }
        class _Renderer {
            options;
            parser;
            constructor(options){
                this.options = options || _defaults;
            }
            space(token) {
                return '';
            }
            code({ text, lang, escaped }) {
                const langString = (lang || '').match(/^\S*/)?.[0];
                const code = text.replace(/\n$/, '') + '\n';
                if (!langString) return '<pre><code>' + (escaped ? code : escape$1(code, true)) + '</code></pre>\n';
                return '<pre><code class="language-' + escape$1(langString) + '">' + (escaped ? code : escape$1(code, true)) + '</code></pre>\n';
            }
            blockquote({ tokens }) {
                const body = this.parser.parse(tokens);
                return `<blockquote>\n${body}</blockquote>\n`;
            }
            html({ text }) {
                return text;
            }
            heading({ tokens, depth }) {
                return `<h${depth}>${this.parser.parseInline(tokens)}</h${depth}>\n`;
            }
            hr(token) {
                return '<hr>\n';
            }
            list(token) {
                const ordered = token.ordered;
                const start = token.start;
                let body = '';
                for(let j = 0; j < token.items.length; j++){
                    const item = token.items[j];
                    body += this.listitem(item);
                }
                const type = ordered ? 'ol' : 'ul';
                const startAttr = ordered && 1 !== start ? ' start="' + start + '"' : '';
                return '<' + type + startAttr + '>\n' + body + '</' + type + '>\n';
            }
            listitem(item) {
                let itemBody = '';
                if (item.task) {
                    const checkbox = this.checkbox({
                        checked: !!item.checked
                    });
                    if (item.loose) {
                        if (item.tokens.length > 0 && 'paragraph' === item.tokens[0].type) {
                            item.tokens[0].text = checkbox + ' ' + item.tokens[0].text;
                            if (item.tokens[0].tokens && item.tokens[0].tokens.length > 0 && 'text' === item.tokens[0].tokens[0].type) item.tokens[0].tokens[0].text = checkbox + ' ' + item.tokens[0].tokens[0].text;
                        } else item.tokens.unshift({
                            type: 'text',
                            raw: checkbox + ' ',
                            text: checkbox + ' '
                        });
                    } else itemBody += checkbox + ' ';
                }
                itemBody += this.parser.parse(item.tokens, !!item.loose);
                return `<li>${itemBody}</li>\n`;
            }
            checkbox({ checked }) {
                return '<input ' + (checked ? 'checked="" ' : '') + 'disabled="" type="checkbox">';
            }
            paragraph({ tokens }) {
                return `<p>${this.parser.parseInline(tokens)}</p>\n`;
            }
            table(token) {
                let header = '';
                let cell = '';
                for(let j = 0; j < token.header.length; j++)cell += this.tablecell(token.header[j]);
                header += this.tablerow({
                    text: cell
                });
                let body = '';
                for(let j = 0; j < token.rows.length; j++){
                    const row = token.rows[j];
                    cell = '';
                    for(let k = 0; k < row.length; k++)cell += this.tablecell(row[k]);
                    body += this.tablerow({
                        text: cell
                    });
                }
                if (body) body = `<tbody>${body}</tbody>`;
                return "<table>\n<thead>\n" + header + '</thead>\n' + body + '</table>\n';
            }
            tablerow({ text }) {
                return `<tr>\n${text}</tr>\n`;
            }
            tablecell(token) {
                const content = this.parser.parseInline(token.tokens);
                const type = token.header ? 'th' : 'td';
                const tag = token.align ? `<${type} align="${token.align}">` : `<${type}>`;
                return tag + content + `</${type}>\n`;
            }
            strong({ tokens }) {
                return `<strong>${this.parser.parseInline(tokens)}</strong>`;
            }
            em({ tokens }) {
                return `<em>${this.parser.parseInline(tokens)}</em>`;
            }
            codespan({ text }) {
                return `<code>${text}</code>`;
            }
            br(token) {
                return '<br>';
            }
            del({ tokens }) {
                return `<del>${this.parser.parseInline(tokens)}</del>`;
            }
            link({ href, title, tokens }) {
                const text = this.parser.parseInline(tokens);
                const cleanHref = cleanUrl(href);
                if (null === cleanHref) return text;
                href = cleanHref;
                let out = '<a href="' + href + '"';
                if (title) out += ' title="' + title + '"';
                out += '>' + text + '</a>';
                return out;
            }
            image({ href, title, text }) {
                const cleanHref = cleanUrl(href);
                if (null === cleanHref) return text;
                href = cleanHref;
                let out = `<img src="${href}" alt="${text}"`;
                if (title) out += ` title="${title}"`;
                out += '>';
                return out;
            }
            text(token) {
                return 'tokens' in token && token.tokens ? this.parser.parseInline(token.tokens) : token.text;
            }
        }
        class _TextRenderer {
            strong({ text }) {
                return text;
            }
            em({ text }) {
                return text;
            }
            codespan({ text }) {
                return text;
            }
            del({ text }) {
                return text;
            }
            html({ text }) {
                return text;
            }
            text({ text }) {
                return text;
            }
            link({ text }) {
                return '' + text;
            }
            image({ text }) {
                return '' + text;
            }
            br() {
                return '';
            }
        }
        class _Parser {
            options;
            renderer;
            textRenderer;
            constructor(options){
                this.options = options || _defaults;
                this.options.renderer = this.options.renderer || new _Renderer();
                this.renderer = this.options.renderer;
                this.renderer.options = this.options;
                this.renderer.parser = this;
                this.textRenderer = new _TextRenderer();
            }
            static parse(tokens, options) {
                const parser = new _Parser(options);
                return parser.parse(tokens);
            }
            static parseInline(tokens, options) {
                const parser = new _Parser(options);
                return parser.parseInline(tokens);
            }
            parse(tokens, top = true) {
                let out = '';
                for(let i = 0; i < tokens.length; i++){
                    const anyToken = tokens[i];
                    if (this.options.extensions && this.options.extensions.renderers && this.options.extensions.renderers[anyToken.type]) {
                        const genericToken = anyToken;
                        const ret = this.options.extensions.renderers[genericToken.type].call({
                            parser: this
                        }, genericToken);
                        if (false !== ret || ![
                            'space',
                            'hr',
                            'heading',
                            'code',
                            'table',
                            'blockquote',
                            'list',
                            'html',
                            'paragraph',
                            'text'
                        ].includes(genericToken.type)) {
                            out += ret || '';
                            continue;
                        }
                    }
                    const token = anyToken;
                    switch(token.type){
                        case 'space':
                            out += this.renderer.space(token);
                            continue;
                        case 'hr':
                            out += this.renderer.hr(token);
                            continue;
                        case 'heading':
                            out += this.renderer.heading(token);
                            continue;
                        case 'code':
                            out += this.renderer.code(token);
                            continue;
                        case 'table':
                            out += this.renderer.table(token);
                            continue;
                        case 'blockquote':
                            out += this.renderer.blockquote(token);
                            continue;
                        case 'list':
                            out += this.renderer.list(token);
                            continue;
                        case 'html':
                            out += this.renderer.html(token);
                            continue;
                        case 'paragraph':
                            out += this.renderer.paragraph(token);
                            continue;
                        case 'text':
                            {
                                let textToken = token;
                                let body = this.renderer.text(textToken);
                                while(i + 1 < tokens.length && 'text' === tokens[i + 1].type){
                                    textToken = tokens[++i];
                                    body += '\n' + this.renderer.text(textToken);
                                }
                                if (top) out += this.renderer.paragraph({
                                    type: 'paragraph',
                                    raw: body,
                                    text: body,
                                    tokens: [
                                        {
                                            type: 'text',
                                            raw: body,
                                            text: body
                                        }
                                    ]
                                });
                                else out += body;
                                continue;
                            }
                        default:
                            {
                                const errMsg = 'Token with "' + token.type + '" type was not found.';
                                if (this.options.silent) {
                                    console.error(errMsg);
                                    return '';
                                }
                                throw new Error(errMsg);
                            }
                    }
                }
                return out;
            }
            parseInline(tokens, renderer) {
                renderer = renderer || this.renderer;
                let out = '';
                for(let i = 0; i < tokens.length; i++){
                    const anyToken = tokens[i];
                    if (this.options.extensions && this.options.extensions.renderers && this.options.extensions.renderers[anyToken.type]) {
                        const ret = this.options.extensions.renderers[anyToken.type].call({
                            parser: this
                        }, anyToken);
                        if (false !== ret || ![
                            'escape',
                            'html',
                            'link',
                            'image',
                            'strong',
                            'em',
                            'codespan',
                            'br',
                            'del',
                            'text'
                        ].includes(anyToken.type)) {
                            out += ret || '';
                            continue;
                        }
                    }
                    const token = anyToken;
                    switch(token.type){
                        case 'escape':
                            out += renderer.text(token);
                            break;
                        case 'html':
                            out += renderer.html(token);
                            break;
                        case 'link':
                            out += renderer.link(token);
                            break;
                        case 'image':
                            out += renderer.image(token);
                            break;
                        case 'strong':
                            out += renderer.strong(token);
                            break;
                        case 'em':
                            out += renderer.em(token);
                            break;
                        case 'codespan':
                            out += renderer.codespan(token);
                            break;
                        case 'br':
                            out += renderer.br(token);
                            break;
                        case 'del':
                            out += renderer.del(token);
                            break;
                        case 'text':
                            out += renderer.text(token);
                            break;
                        default:
                            {
                                const errMsg = 'Token with "' + token.type + '" type was not found.';
                                if (this.options.silent) {
                                    console.error(errMsg);
                                    return '';
                                }
                                throw new Error(errMsg);
                            }
                    }
                }
                return out;
            }
        }
        class _Hooks {
            options;
            constructor(options){
                this.options = options || _defaults;
            }
            static passThroughHooks = new Set([
                'preprocess',
                'postprocess',
                'processAllTokens'
            ]);
            preprocess(markdown) {
                return markdown;
            }
            postprocess(html) {
                return html;
            }
            processAllTokens(tokens) {
                return tokens;
            }
        }
        class Marked {
            defaults = _getDefaults();
            options = this.setOptions;
            parse = this.#parseMarkdown(_Lexer.lex, _Parser.parse);
            parseInline = this.#parseMarkdown(_Lexer.lexInline, _Parser.parseInline);
            Parser = _Parser;
            Renderer = _Renderer;
            TextRenderer = _TextRenderer;
            Lexer = _Lexer;
            Tokenizer = _Tokenizer;
            Hooks = _Hooks;
            constructor(...args){
                this.use(...args);
            }
            walkTokens(tokens, callback) {
                let values = [];
                for (const token of tokens){
                    values = values.concat(callback.call(this, token));
                    switch(token.type){
                        case 'table':
                            {
                                const tableToken = token;
                                for (const cell of tableToken.header)values = values.concat(this.walkTokens(cell.tokens, callback));
                                for (const row of tableToken.rows)for (const cell of row)values = values.concat(this.walkTokens(cell.tokens, callback));
                                break;
                            }
                        case 'list':
                            {
                                const listToken = token;
                                values = values.concat(this.walkTokens(listToken.items, callback));
                                break;
                            }
                        default:
                            {
                                const genericToken = token;
                                if (this.defaults.extensions?.childTokens?.[genericToken.type]) this.defaults.extensions.childTokens[genericToken.type].forEach((childTokens)=>{
                                    const tokens = genericToken[childTokens].flat(1 / 0);
                                    values = values.concat(this.walkTokens(tokens, callback));
                                });
                                else if (genericToken.tokens) values = values.concat(this.walkTokens(genericToken.tokens, callback));
                            }
                    }
                }
                return values;
            }
            use(...args) {
                const extensions = this.defaults.extensions || {
                    renderers: {},
                    childTokens: {}
                };
                args.forEach((pack)=>{
                    const opts = {
                        ...pack
                    };
                    opts.async = this.defaults.async || opts.async || false;
                    if (pack.extensions) {
                        pack.extensions.forEach((ext)=>{
                            if (!ext.name) throw new Error('extension name required');
                            if ('renderer' in ext) {
                                const prevRenderer = extensions.renderers[ext.name];
                                if (prevRenderer) extensions.renderers[ext.name] = function(...args) {
                                    let ret = ext.renderer.apply(this, args);
                                    if (false === ret) ret = prevRenderer.apply(this, args);
                                    return ret;
                                };
                                else extensions.renderers[ext.name] = ext.renderer;
                            }
                            if ('tokenizer' in ext) {
                                if (!ext.level || 'block' !== ext.level && 'inline' !== ext.level) throw new Error("extension level must be 'block' or 'inline'");
                                const extLevel = extensions[ext.level];
                                if (extLevel) extLevel.unshift(ext.tokenizer);
                                else extensions[ext.level] = [
                                    ext.tokenizer
                                ];
                                if (ext.start) {
                                    if ('block' === ext.level) {
                                        if (extensions.startBlock) extensions.startBlock.push(ext.start);
                                        else extensions.startBlock = [
                                            ext.start
                                        ];
                                    } else if ('inline' === ext.level) {
                                        if (extensions.startInline) extensions.startInline.push(ext.start);
                                        else extensions.startInline = [
                                            ext.start
                                        ];
                                    }
                                }
                            }
                            if ('childTokens' in ext && ext.childTokens) extensions.childTokens[ext.name] = ext.childTokens;
                        });
                        opts.extensions = extensions;
                    }
                    if (pack.renderer) {
                        const renderer = this.defaults.renderer || new _Renderer(this.defaults);
                        for(const prop in pack.renderer){
                            if (!(prop in renderer)) throw new Error(`renderer '${prop}' does not exist`);
                            if ([
                                'options',
                                'parser'
                            ].includes(prop)) continue;
                            const rendererProp = prop;
                            let rendererFunc = pack.renderer[rendererProp];
                            if (!pack.useNewRenderer) rendererFunc = this.#convertRendererFunction(rendererFunc, rendererProp, renderer);
                            const prevRenderer = renderer[rendererProp];
                            renderer[rendererProp] = (...args)=>{
                                let ret = rendererFunc.apply(renderer, args);
                                if (false === ret) ret = prevRenderer.apply(renderer, args);
                                return ret || '';
                            };
                        }
                        opts.renderer = renderer;
                    }
                    if (pack.tokenizer) {
                        const tokenizer = this.defaults.tokenizer || new _Tokenizer(this.defaults);
                        for(const prop in pack.tokenizer){
                            if (!(prop in tokenizer)) throw new Error(`tokenizer '${prop}' does not exist`);
                            if ([
                                'options',
                                'rules',
                                'lexer'
                            ].includes(prop)) continue;
                            const tokenizerProp = prop;
                            const tokenizerFunc = pack.tokenizer[tokenizerProp];
                            const prevTokenizer = tokenizer[tokenizerProp];
                            tokenizer[tokenizerProp] = (...args)=>{
                                let ret = tokenizerFunc.apply(tokenizer, args);
                                if (false === ret) ret = prevTokenizer.apply(tokenizer, args);
                                return ret;
                            };
                        }
                        opts.tokenizer = tokenizer;
                    }
                    if (pack.hooks) {
                        const hooks = this.defaults.hooks || new _Hooks();
                        for(const prop in pack.hooks){
                            if (!(prop in hooks)) throw new Error(`hook '${prop}' does not exist`);
                            if ('options' === prop) continue;
                            const hooksProp = prop;
                            const hooksFunc = pack.hooks[hooksProp];
                            const prevHook = hooks[hooksProp];
                            if (_Hooks.passThroughHooks.has(prop)) hooks[hooksProp] = (arg)=>{
                                if (this.defaults.async) return Promise.resolve(hooksFunc.call(hooks, arg)).then((ret)=>prevHook.call(hooks, ret));
                                const ret = hooksFunc.call(hooks, arg);
                                return prevHook.call(hooks, ret);
                            };
                            else hooks[hooksProp] = (...args)=>{
                                let ret = hooksFunc.apply(hooks, args);
                                if (false === ret) ret = prevHook.apply(hooks, args);
                                return ret;
                            };
                        }
                        opts.hooks = hooks;
                    }
                    if (pack.walkTokens) {
                        const walkTokens = this.defaults.walkTokens;
                        const packWalktokens = pack.walkTokens;
                        opts.walkTokens = function(token) {
                            let values = [];
                            values.push(packWalktokens.call(this, token));
                            if (walkTokens) values = values.concat(walkTokens.call(this, token));
                            return values;
                        };
                    }
                    this.defaults = {
                        ...this.defaults,
                        ...opts
                    };
                });
                return this;
            }
            #convertRendererFunction(func, prop, renderer) {
                switch(prop){
                    case 'heading':
                        return function(token) {
                            if (!token.type || token.type !== prop) return func.apply(this, arguments);
                            return func.call(this, renderer.parser.parseInline(token.tokens), token.depth, marked_esm_unescape(renderer.parser.parseInline(token.tokens, renderer.parser.textRenderer)));
                        };
                    case 'code':
                        return function(token) {
                            if (!token.type || token.type !== prop) return func.apply(this, arguments);
                            return func.call(this, token.text, token.lang, !!token.escaped);
                        };
                    case 'table':
                        return function(token) {
                            if (!token.type || token.type !== prop) return func.apply(this, arguments);
                            let header = '';
                            let cell = '';
                            for(let j = 0; j < token.header.length; j++)cell += this.tablecell({
                                text: token.header[j].text,
                                tokens: token.header[j].tokens,
                                header: true,
                                align: token.align[j]
                            });
                            header += this.tablerow({
                                text: cell
                            });
                            let body = '';
                            for(let j = 0; j < token.rows.length; j++){
                                const row = token.rows[j];
                                cell = '';
                                for(let k = 0; k < row.length; k++)cell += this.tablecell({
                                    text: row[k].text,
                                    tokens: row[k].tokens,
                                    header: false,
                                    align: token.align[k]
                                });
                                body += this.tablerow({
                                    text: cell
                                });
                            }
                            return func.call(this, header, body);
                        };
                    case 'blockquote':
                        return function(token) {
                            if (!token.type || token.type !== prop) return func.apply(this, arguments);
                            const body = this.parser.parse(token.tokens);
                            return func.call(this, body);
                        };
                    case 'list':
                        return function(token) {
                            if (!token.type || token.type !== prop) return func.apply(this, arguments);
                            const ordered = token.ordered;
                            const start = token.start;
                            const loose = token.loose;
                            let body = '';
                            for(let j = 0; j < token.items.length; j++){
                                const item = token.items[j];
                                const checked = item.checked;
                                const task = item.task;
                                let itemBody = '';
                                if (item.task) {
                                    const checkbox = this.checkbox({
                                        checked: !!checked
                                    });
                                    if (loose) {
                                        if (item.tokens.length > 0 && 'paragraph' === item.tokens[0].type) {
                                            item.tokens[0].text = checkbox + ' ' + item.tokens[0].text;
                                            if (item.tokens[0].tokens && item.tokens[0].tokens.length > 0 && 'text' === item.tokens[0].tokens[0].type) item.tokens[0].tokens[0].text = checkbox + ' ' + item.tokens[0].tokens[0].text;
                                        } else item.tokens.unshift({
                                            type: 'text',
                                            text: checkbox + ' '
                                        });
                                    } else itemBody += checkbox + ' ';
                                }
                                itemBody += this.parser.parse(item.tokens, loose);
                                body += this.listitem({
                                    type: 'list_item',
                                    raw: itemBody,
                                    text: itemBody,
                                    task,
                                    checked: !!checked,
                                    loose,
                                    tokens: item.tokens
                                });
                            }
                            return func.call(this, body, ordered, start);
                        };
                    case 'html':
                        return function(token) {
                            if (!token.type || token.type !== prop) return func.apply(this, arguments);
                            return func.call(this, token.text, token.block);
                        };
                    case 'paragraph':
                        return function(token) {
                            if (!token.type || token.type !== prop) return func.apply(this, arguments);
                            return func.call(this, this.parser.parseInline(token.tokens));
                        };
                    case 'escape':
                        return function(token) {
                            if (!token.type || token.type !== prop) return func.apply(this, arguments);
                            return func.call(this, token.text);
                        };
                    case 'link':
                        return function(token) {
                            if (!token.type || token.type !== prop) return func.apply(this, arguments);
                            return func.call(this, token.href, token.title, this.parser.parseInline(token.tokens));
                        };
                    case 'image':
                        return function(token) {
                            if (!token.type || token.type !== prop) return func.apply(this, arguments);
                            return func.call(this, token.href, token.title, token.text);
                        };
                    case 'strong':
                        return function(token) {
                            if (!token.type || token.type !== prop) return func.apply(this, arguments);
                            return func.call(this, this.parser.parseInline(token.tokens));
                        };
                    case 'em':
                        return function(token) {
                            if (!token.type || token.type !== prop) return func.apply(this, arguments);
                            return func.call(this, this.parser.parseInline(token.tokens));
                        };
                    case 'codespan':
                        return function(token) {
                            if (!token.type || token.type !== prop) return func.apply(this, arguments);
                            return func.call(this, token.text);
                        };
                    case 'del':
                        return function(token) {
                            if (!token.type || token.type !== prop) return func.apply(this, arguments);
                            return func.call(this, this.parser.parseInline(token.tokens));
                        };
                    case 'text':
                        return function(token) {
                            if (!token.type || token.type !== prop) return func.apply(this, arguments);
                            return func.call(this, token.text);
                        };
                }
                return func;
            }
            setOptions(opt) {
                this.defaults = {
                    ...this.defaults,
                    ...opt
                };
                return this;
            }
            lexer(src, options) {
                return _Lexer.lex(src, options ?? this.defaults);
            }
            parser(tokens, options) {
                return _Parser.parse(tokens, options ?? this.defaults);
            }
            #parseMarkdown(lexer, parser) {
                return (src, options)=>{
                    const origOpt = {
                        ...options
                    };
                    const opt = {
                        ...this.defaults,
                        ...origOpt
                    };
                    if (true === this.defaults.async && false === origOpt.async) {
                        if (!opt.silent) console.warn('marked(): The async option was set to true by an extension. The async: false option sent to parse will be ignored.');
                        opt.async = true;
                    }
                    const throwError = this.#onError(!!opt.silent, !!opt.async);
                    if (null == src) return throwError(new Error('marked(): input parameter is undefined or null'));
                    if ('string' != typeof src) return throwError(new Error('marked(): input parameter is of type ' + Object.prototype.toString.call(src) + ', string expected'));
                    if (opt.hooks) opt.hooks.options = opt;
                    if (opt.async) return Promise.resolve(opt.hooks ? opt.hooks.preprocess(src) : src).then((src)=>lexer(src, opt)).then((tokens)=>opt.hooks ? opt.hooks.processAllTokens(tokens) : tokens).then((tokens)=>opt.walkTokens ? Promise.all(this.walkTokens(tokens, opt.walkTokens)).then(()=>tokens) : tokens).then((tokens)=>parser(tokens, opt)).then((html)=>opt.hooks ? opt.hooks.postprocess(html) : html).catch(throwError);
                    try {
                        if (opt.hooks) src = opt.hooks.preprocess(src);
                        let tokens = lexer(src, opt);
                        if (opt.hooks) tokens = opt.hooks.processAllTokens(tokens);
                        if (opt.walkTokens) this.walkTokens(tokens, opt.walkTokens);
                        let html = parser(tokens, opt);
                        if (opt.hooks) html = opt.hooks.postprocess(html);
                        return html;
                    } catch (e) {
                        return throwError(e);
                    }
                };
            }
            #onError(silent, async) {
                return (e)=>{
                    e.message += '\nPlease report this to https://github.com/markedjs/marked.';
                    if (silent) {
                        const msg = '<p>An error occurred:</p><pre>' + escape$1(e.message + '', true) + '</pre>';
                        if (async) return Promise.resolve(msg);
                        return msg;
                    }
                    if (async) return Promise.reject(e);
                    throw e;
                };
            }
        }
        const markedInstance = new Marked();
        function marked(src, opt) {
            return markedInstance.parse(src, opt);
        }
        marked.options = marked.setOptions = function(options) {
            markedInstance.setOptions(options);
            marked.defaults = markedInstance.defaults;
            changeDefaults(marked.defaults);
            return marked;
        };
        marked.getDefaults = _getDefaults;
        marked.defaults = _defaults;
        marked.use = function(...args) {
            markedInstance.use(...args);
            marked.defaults = markedInstance.defaults;
            changeDefaults(marked.defaults);
            return marked;
        };
        marked.walkTokens = function(tokens, callback) {
            return markedInstance.walkTokens(tokens, callback);
        };
        marked.parseInline = markedInstance.parseInline;
        marked.Parser = _Parser;
        marked.parser = _Parser.parse;
        marked.Renderer = _Renderer;
        marked.TextRenderer = _TextRenderer;
        marked.Lexer = _Lexer;
        marked.lexer = _Lexer.lex;
        marked.Tokenizer = _Tokenizer;
        marked.Hooks = _Hooks;
        marked.parse = marked;
        marked.options;
        marked.setOptions;
        marked.use;
        marked.walkTokens;
        marked.parseInline;
        _Parser.parse;
        _Lexer.lex;
        var esm = __webpack_require__("./node_modules/.pnpm/ts-dedent@2.2.0/node_modules/ts-dedent/esm/index.js");
        function preprocessMarkdown(markdown, { markdownAutoWrap }) {
            const withoutBR = markdown.replace(/<br\/>/g, "\n");
            const withoutMultipleNewlines = withoutBR.replace(/\n{2,}/g, "\n");
            const withoutExtraSpaces = (0, esm.Z)(withoutMultipleNewlines);
            if (false === markdownAutoWrap) return withoutExtraSpaces.replace(/ /g, "&nbsp;");
            return withoutExtraSpaces;
        }
        (0, chunk_6DBFFHIP.eW)(preprocessMarkdown, "preprocessMarkdown");
        function markdownToLines(markdown, config = {}) {
            const preprocessedMarkdown = preprocessMarkdown(markdown, config);
            const nodes = marked.lexer(preprocessedMarkdown);
            const lines = [
                []
            ];
            let currentLine = 0;
            function processNode(node, parentType = "normal") {
                if ("text" === node.type) {
                    const textLines = node.text.split("\n");
                    textLines.forEach((textLine, index)=>{
                        if (0 !== index) {
                            currentLine++;
                            lines.push([]);
                        }
                        textLine.split(" ").forEach((word)=>{
                            word = word.replace(/&#39;/g, "'");
                            if (word) lines[currentLine].push({
                                content: word,
                                type: parentType
                            });
                        });
                    });
                } else if ("strong" === node.type || "em" === node.type) node.tokens.forEach((contentNode)=>{
                    processNode(contentNode, node.type);
                });
                else if ("html" === node.type) lines[currentLine].push({
                    content: node.text,
                    type: "normal"
                });
            }
            (0, chunk_6DBFFHIP.eW)(processNode, "processNode");
            nodes.forEach((treeNode)=>{
                if ("paragraph" === treeNode.type) treeNode.tokens?.forEach((contentNode)=>{
                    processNode(contentNode);
                });
                else if ("html" === treeNode.type) lines[currentLine].push({
                    content: treeNode.text,
                    type: "normal"
                });
            });
            return lines;
        }
        (0, chunk_6DBFFHIP.eW)(markdownToLines, "markdownToLines");
        function markdownToHTML(markdown, { markdownAutoWrap } = {}) {
            const nodes = marked.lexer(markdown);
            function output(node) {
                if ("text" === node.type) {
                    if (false === markdownAutoWrap) return node.text.replace(/\n */g, "<br/>").replace(/ /g, "&nbsp;");
                    return node.text.replace(/\n */g, "<br/>");
                }
                if ("strong" === node.type) return `<strong>${node.tokens?.map(output).join("")}</strong>`;
                if ("em" === node.type) return `<em>${node.tokens?.map(output).join("")}</em>`;
                if ("paragraph" === node.type) return `<p>${node.tokens?.map(output).join("")}</p>`;
                if ("space" === node.type) return "";
                else if ("html" === node.type) return `${node.text}`;
                else if ("escape" === node.type) return node.text;
                return `Unsupported markdown: ${node.type}`;
            }
            (0, chunk_6DBFFHIP.eW)(output, "output");
            return nodes.map(output).join("");
        }
        (0, chunk_6DBFFHIP.eW)(markdownToHTML, "markdownToHTML");
        function splitTextToChars(text) {
            if (Intl.Segmenter) return [
                ...new Intl.Segmenter().segment(text)
            ].map((s)=>s.segment);
            return [
                ...text
            ];
        }
        (0, chunk_6DBFFHIP.eW)(splitTextToChars, "splitTextToChars");
        function splitWordToFitWidth(checkFit, word) {
            const characters = splitTextToChars(word.content);
            return splitWordToFitWidthRecursion(checkFit, [], characters, word.type);
        }
        (0, chunk_6DBFFHIP.eW)(splitWordToFitWidth, "splitWordToFitWidth");
        function splitWordToFitWidthRecursion(checkFit, usedChars, remainingChars, type) {
            if (0 === remainingChars.length) return [
                {
                    content: usedChars.join(""),
                    type
                },
                {
                    content: "",
                    type
                }
            ];
            const [nextChar, ...rest] = remainingChars;
            const newWord = [
                ...usedChars,
                nextChar
            ];
            if (checkFit([
                {
                    content: newWord.join(""),
                    type
                }
            ])) return splitWordToFitWidthRecursion(checkFit, newWord, rest, type);
            if (0 === usedChars.length && nextChar) {
                usedChars.push(nextChar);
                remainingChars.shift();
            }
            return [
                {
                    content: usedChars.join(""),
                    type
                },
                {
                    content: remainingChars.join(""),
                    type
                }
            ];
        }
        (0, chunk_6DBFFHIP.eW)(splitWordToFitWidthRecursion, "splitWordToFitWidthRecursion");
        function splitLineToFitWidth(line, checkFit) {
            if (line.some(({ content })=>content.includes("\n"))) throw new Error("splitLineToFitWidth does not support newlines in the line");
            return splitLineToFitWidthRecursion(line, checkFit);
        }
        (0, chunk_6DBFFHIP.eW)(splitLineToFitWidth, "splitLineToFitWidth");
        function splitLineToFitWidthRecursion(words, checkFit, lines = [], newLine = []) {
            if (0 === words.length) {
                if (newLine.length > 0) lines.push(newLine);
                return lines.length > 0 ? lines : [];
            }
            let joiner = "";
            if (" " === words[0].content) {
                joiner = " ";
                words.shift();
            }
            const nextWord = words.shift() ?? {
                content: " ",
                type: "normal"
            };
            const lineWithNextWord = [
                ...newLine
            ];
            if ("" !== joiner) lineWithNextWord.push({
                content: joiner,
                type: "normal"
            });
            lineWithNextWord.push(nextWord);
            if (checkFit(lineWithNextWord)) return splitLineToFitWidthRecursion(words, checkFit, lines, lineWithNextWord);
            if (newLine.length > 0) {
                lines.push(newLine);
                words.unshift(nextWord);
            } else if (nextWord.content) {
                const [line, rest] = splitWordToFitWidth(checkFit, nextWord);
                lines.push([
                    line
                ]);
                if (rest.content) words.unshift(rest);
            }
            return splitLineToFitWidthRecursion(words, checkFit, lines);
        }
        (0, chunk_6DBFFHIP.eW)(splitLineToFitWidthRecursion, "splitLineToFitWidthRecursion");
        function applyStyle(dom, styleFn) {
            if (styleFn) dom.attr("style", styleFn);
        }
        (0, chunk_6DBFFHIP.eW)(applyStyle, "applyStyle");
        async function addHtmlSpan(element, node, width, classes, addBackground = false) {
            const fo = element.append("foreignObject");
            fo.attr("width", `${10 * width}px`);
            fo.attr("height", `${10 * width}px`);
            const div = fo.append("xhtml:div");
            let label = node.label;
            if (node.label && (0, chunk_6DBFFHIP.l0)(node.label)) label = await (0, chunk_6DBFFHIP.uT)(node.label.replace(chunk_6DBFFHIP.SY.lineBreakRegex, "\n"), (0, chunk_6DBFFHIP.nV)());
            const labelClass = node.isNode ? "nodeLabel" : "edgeLabel";
            const span = div.append("span");
            span.html(label);
            applyStyle(span, node.labelStyle);
            span.attr("class", `${labelClass} ${classes}`);
            applyStyle(div, node.labelStyle);
            div.style("display", "table-cell");
            div.style("white-space", "nowrap");
            div.style("line-height", "1.5");
            div.style("max-width", width + "px");
            div.style("text-align", "center");
            div.attr("xmlns", "http://www.w3.org/1999/xhtml");
            if (addBackground) div.attr("class", "labelBkg");
            let bbox = div.node().getBoundingClientRect();
            if (bbox.width === width) {
                div.style("display", "table");
                div.style("white-space", "break-spaces");
                div.style("width", width + "px");
                bbox = div.node().getBoundingClientRect();
            }
            return fo.node();
        }
        (0, chunk_6DBFFHIP.eW)(addHtmlSpan, "addHtmlSpan");
        function createTspan(textElement, lineIndex, lineHeight) {
            return textElement.append("tspan").attr("class", "text-outer-tspan").attr("x", 0).attr("y", lineIndex * lineHeight - 0.1 + "em").attr("dy", lineHeight + "em");
        }
        (0, chunk_6DBFFHIP.eW)(createTspan, "createTspan");
        function computeWidthOfText(parentNode, lineHeight, line) {
            const testElement = parentNode.append("text");
            const testSpan = createTspan(testElement, 1, lineHeight);
            updateTextContentAndStyles(testSpan, line);
            const textLength = testSpan.node().getComputedTextLength();
            testElement.remove();
            return textLength;
        }
        (0, chunk_6DBFFHIP.eW)(computeWidthOfText, "computeWidthOfText");
        function computeDimensionOfText(parentNode, lineHeight, text) {
            const testElement = parentNode.append("text");
            const testSpan = createTspan(testElement, 1, lineHeight);
            updateTextContentAndStyles(testSpan, [
                {
                    content: text,
                    type: "normal"
                }
            ]);
            const textDimension = testSpan.node()?.getBoundingClientRect();
            if (textDimension) testElement.remove();
            return textDimension;
        }
        (0, chunk_6DBFFHIP.eW)(computeDimensionOfText, "computeDimensionOfText");
        function createFormattedText(width, g, structuredText, addBackground = false) {
            const lineHeight = 1.1;
            const labelGroup = g.append("g");
            const bkg = labelGroup.insert("rect").attr("class", "background").attr("style", "stroke: none");
            const textElement = labelGroup.append("text").attr("y", "-10.1");
            let lineIndex = 0;
            for (const line of structuredText){
                const checkWidth = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((line2)=>computeWidthOfText(labelGroup, lineHeight, line2) <= width, "checkWidth");
                const linesUnderWidth = checkWidth(line) ? [
                    line
                ] : splitLineToFitWidth(line, checkWidth);
                for (const preparedLine of linesUnderWidth){
                    const tspan = createTspan(textElement, lineIndex, lineHeight);
                    updateTextContentAndStyles(tspan, preparedLine);
                    lineIndex++;
                }
            }
            if (!addBackground) return textElement.node();
            {
                const bbox = textElement.node().getBBox();
                const padding = 2;
                bkg.attr("x", bbox.x - padding).attr("y", bbox.y - padding).attr("width", bbox.width + 2 * padding).attr("height", bbox.height + 2 * padding);
                return labelGroup.node();
            }
        }
        (0, chunk_6DBFFHIP.eW)(createFormattedText, "createFormattedText");
        function updateTextContentAndStyles(tspan, wrappedLine) {
            tspan.text("");
            wrappedLine.forEach((word, index)=>{
                const innerTspan = tspan.append("tspan").attr("font-style", "em" === word.type ? "italic" : "normal").attr("class", "text-inner-tspan").attr("font-weight", "strong" === word.type ? "bold" : "normal");
                if (0 === index) innerTspan.text(word.content);
                else innerTspan.text(" " + word.content);
            });
        }
        (0, chunk_6DBFFHIP.eW)(updateTextContentAndStyles, "updateTextContentAndStyles");
        function replaceIconSubstring(text) {
            return text.replace(/fa[bklrs]?:fa-[\w-]+/g, (s)=>`<i class='${s.replace(":", " ")}'></i>`);
        }
        (0, chunk_6DBFFHIP.eW)(replaceIconSubstring, "replaceIconSubstring");
        var createText = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async (el, text = "", { style = "", isTitle = false, classes = "", useHtmlLabels = true, isNode = true, width = 200, addSvgBackground = false } = {}, config)=>{
            chunk_6DBFFHIP.cM.debug("XYZ createText", text, style, isTitle, classes, useHtmlLabels, isNode, "addSvgBackground: ", addSvgBackground);
            if (useHtmlLabels) {
                const htmlText = markdownToHTML(text, config);
                const decodedReplacedText = replaceIconSubstring((0, chunk_7DKRZKHE.SH)(htmlText));
                const inputForKatex = text.replace(/\\\\/g, "\\");
                const node = {
                    isNode,
                    label: (0, chunk_6DBFFHIP.l0)(text) ? inputForKatex : decodedReplacedText,
                    labelStyle: style.replace("fill:", "color:")
                };
                const vertexNode = await addHtmlSpan(el, node, width, classes, addSvgBackground);
                return vertexNode;
            }
            {
                const sanitizeBR = text.replace(/<br\s*\/?>/g, "<br/>");
                const structuredText = markdownToLines(sanitizeBR.replace("<br>", "<br/>"), config);
                const svgLabel = createFormattedText(width, el, structuredText, !!text && addSvgBackground);
                if (isNode) {
                    if (/stroke:/.exec(style)) style = style.replace("stroke:", "lineColor:");
                    const nodeLabelTextStyle = style.replace(/stroke:[^;]+;?/g, "").replace(/stroke-width:[^;]+;?/g, "").replace(/fill:[^;]+;?/g, "").replace(/color:/g, "fill:");
                    (0, d3_src.Ys)(svgLabel).attr("style", nodeLabelTextStyle);
                } else {
                    const edgeLabelRectStyle = style.replace(/stroke:[^;]+;?/g, "").replace(/stroke-width:[^;]+;?/g, "").replace(/fill:[^;]+;?/g, "").replace(/background:/g, "fill:");
                    (0, d3_src.Ys)(svgLabel).select("rect").attr("style", edgeLabelRectStyle.replace(/background:/g, "fill:"));
                    const edgeLabelTextStyle = style.replace(/stroke:[^;]+;?/g, "").replace(/stroke-width:[^;]+;?/g, "").replace(/fill:[^;]+;?/g, "").replace(/color:/g, "fill:");
                    (0, d3_src.Ys)(svgLabel).select("text").attr("style", edgeLabelTextStyle);
                }
                return svgLabel;
            }
        }, "createText");
    },
    "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-7DKRZKHE.mjs": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            $m: ()=>ZERO_WIDTH_SPACE,
            Cq: ()=>calculateTextWidth,
            Ln: ()=>getEdgeId,
            MX: ()=>random,
            Ox: ()=>generateId,
            R7: ()=>handleUndefinedAttr,
            Rb: ()=>cleanAndMerge,
            SH: ()=>decodeEntities,
            VG: ()=>parseFontSize,
            Vy: ()=>encodeEntities,
            X4: ()=>wrapLabel,
            XD: ()=>calculateTextHeight,
            bZ: ()=>isDetailedError,
            be: ()=>getStylesFromArray,
            le: ()=>interpolateToCurve,
            tf: ()=>removeDirectives,
            w8: ()=>utils_default
        });
        var _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-6DBFFHIP.mjs");
        var _braintree_sanitize_url__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/.pnpm/@braintree+sanitize-url@7.1.1/node_modules/@braintree/sanitize-url/dist/index.js");
        var d3__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./node_modules/.pnpm/d3@7.9.0/node_modules/d3/src/index.js");
        var lodash_es_memoize_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/memoize.js");
        var lodash_es_merge_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/merge.js");
        var ZERO_WIDTH_SPACE = "\u200B";
        var d3CurveTypes = {
            curveBasis: d3__WEBPACK_IMPORTED_MODULE_2__.$0Z,
            curveBasisClosed: d3__WEBPACK_IMPORTED_MODULE_2__.Dts,
            curveBasisOpen: d3__WEBPACK_IMPORTED_MODULE_2__.WQY,
            curveBumpX: d3__WEBPACK_IMPORTED_MODULE_2__.qpX,
            curveBumpY: d3__WEBPACK_IMPORTED_MODULE_2__.u93,
            curveBundle: d3__WEBPACK_IMPORTED_MODULE_2__.tFB,
            curveCardinalClosed: d3__WEBPACK_IMPORTED_MODULE_2__.OvA,
            curveCardinalOpen: d3__WEBPACK_IMPORTED_MODULE_2__.dCK,
            curveCardinal: d3__WEBPACK_IMPORTED_MODULE_2__.YY7,
            curveCatmullRomClosed: d3__WEBPACK_IMPORTED_MODULE_2__.fGX,
            curveCatmullRomOpen: d3__WEBPACK_IMPORTED_MODULE_2__.$m7,
            curveCatmullRom: d3__WEBPACK_IMPORTED_MODULE_2__.zgE,
            curveLinear: d3__WEBPACK_IMPORTED_MODULE_2__.c_6,
            curveLinearClosed: d3__WEBPACK_IMPORTED_MODULE_2__.fxm,
            curveMonotoneX: d3__WEBPACK_IMPORTED_MODULE_2__.FdL,
            curveMonotoneY: d3__WEBPACK_IMPORTED_MODULE_2__.ak_,
            curveNatural: d3__WEBPACK_IMPORTED_MODULE_2__.SxZ,
            curveStep: d3__WEBPACK_IMPORTED_MODULE_2__.eA_,
            curveStepAfter: d3__WEBPACK_IMPORTED_MODULE_2__.jsv,
            curveStepBefore: d3__WEBPACK_IMPORTED_MODULE_2__.iJ
        };
        var directiveWithoutOpen = /\s*(?:(\w+)(?=:):|(\w+))\s*(?:(\w+)|((?:(?!}%{2}).|\r?\n)*))?\s*(?:}%{2})?/gi;
        var detectInit = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(text, config) {
            const inits = detectDirective(text, /(?:init\b)|(?:initialize\b)/);
            let results = {};
            if (Array.isArray(inits)) {
                const args = inits.map((init)=>init.args);
                (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.NM)(args);
                results = (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.Yc)(results, [
                    ...args
                ]);
            } else results = inits.args;
            if (!results) return;
            let type = (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.Vg)(text, config);
            const prop = "config";
            if (void 0 !== results[prop]) {
                if ("flowchart-v2" === type) type = "flowchart";
                results[type] = results[prop];
                delete results[prop];
            }
            return results;
        }, "detectInit");
        var detectDirective = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(text, type = null) {
            try {
                const commentWithoutDirectives = new RegExp(`[%]{2}(?![{]${directiveWithoutOpen.source})(?=[}][%]{2}).*
`, "ig");
                text = text.trim().replace(commentWithoutDirectives, "").replace(/'/gm, '"');
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.cM.debug(`Detecting diagram directive${null !== type ? " type:" + type : ""} based on the text:${text}`);
                let match;
                const result = [];
                while(null !== (match = _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.Zn.exec(text))){
                    if (match.index === _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.Zn.lastIndex) _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.Zn.lastIndex++;
                    if (match && !type || type && match[1]?.match(type) || type && match[2]?.match(type)) {
                        const type2 = match[1] ? match[1] : match[2];
                        const args = match[3] ? match[3].trim() : match[4] ? JSON.parse(match[4].trim()) : null;
                        result.push({
                            type: type2,
                            args
                        });
                    }
                }
                if (0 === result.length) return {
                    type: text,
                    args: null
                };
                return 1 === result.length ? result[0] : result;
            } catch (error) {
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.cM.error(`ERROR: ${error.message} - Unable to parse directive type: '${type}' based on the text: '${text}'`);
                return {
                    type: void 0,
                    args: null
                };
            }
        }, "detectDirective");
        var removeDirectives = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(text) {
            return text.replace(_chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.Zn, "");
        }, "removeDirectives");
        var isSubstringInArray = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(str, arr) {
            for (const [i, element] of arr.entries())if (element.match(str)) return i;
            return -1;
        }, "isSubstringInArray");
        function interpolateToCurve(interpolate, defaultCurve) {
            if (!interpolate) return defaultCurve;
            const curveName = `curve${interpolate.charAt(0).toUpperCase() + interpolate.slice(1)}`;
            return d3CurveTypes[curveName] ?? defaultCurve;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(interpolateToCurve, "interpolateToCurve");
        function formatUrl(linkStr, config) {
            const url = linkStr.trim();
            if (!url) return;
            if ("loose" !== config.securityLevel) return (0, _braintree_sanitize_url__WEBPACK_IMPORTED_MODULE_1__.sanitizeUrl)(url);
            return url;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(formatUrl, "formatUrl");
        var runFunc = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)((functionName, ...params)=>{
            const arrPaths = functionName.split(".");
            const len = arrPaths.length - 1;
            const fnName = arrPaths[len];
            let obj = window;
            for(let i = 0; i < len; i++){
                obj = obj[arrPaths[i]];
                if (!obj) {
                    _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.cM.error(`Function name: ${functionName} not found in window`);
                    return;
                }
            }
            obj[fnName](...params);
        }, "runFunc");
        function distance(p1, p2) {
            if (!p1 || !p2) return 0;
            return Math.sqrt(Math.pow(p2.x - p1.x, 2) + Math.pow(p2.y - p1.y, 2));
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(distance, "distance");
        function traverseEdge(points) {
            let prevPoint;
            let totalDistance = 0;
            points.forEach((point)=>{
                totalDistance += distance(point, prevPoint);
                prevPoint = point;
            });
            const remainingDistance = totalDistance / 2;
            return calculatePoint(points, remainingDistance);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(traverseEdge, "traverseEdge");
        function calcLabelPosition(points) {
            if (1 === points.length) return points[0];
            return traverseEdge(points);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(calcLabelPosition, "calcLabelPosition");
        var roundNumber = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)((num, precision = 2)=>{
            const factor = Math.pow(10, precision);
            return Math.round(num * factor) / factor;
        }, "roundNumber");
        var calculatePoint = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)((points, distanceToTraverse)=>{
            let prevPoint;
            let remainingDistance = distanceToTraverse;
            for (const point of points){
                if (prevPoint) {
                    const vectorDistance = distance(point, prevPoint);
                    if (vectorDistance < remainingDistance) remainingDistance -= vectorDistance;
                    else {
                        const distanceRatio = remainingDistance / vectorDistance;
                        if (distanceRatio <= 0) return prevPoint;
                        if (distanceRatio >= 1) return {
                            x: point.x,
                            y: point.y
                        };
                        if (distanceRatio > 0 && distanceRatio < 1) return {
                            x: roundNumber((1 - distanceRatio) * prevPoint.x + distanceRatio * point.x, 5),
                            y: roundNumber((1 - distanceRatio) * prevPoint.y + distanceRatio * point.y, 5)
                        };
                    }
                }
                prevPoint = point;
            }
            throw new Error("Could not find a suitable point for the given distance");
        }, "calculatePoint");
        var calcCardinalityPosition = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)((isRelationTypePresent, points, initialPosition)=>{
            _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.cM.info(`our points ${JSON.stringify(points)}`);
            if (points[0] !== initialPosition) points = points.reverse();
            const distanceToCardinalityPoint = 25;
            const center = calculatePoint(points, distanceToCardinalityPoint);
            const d = isRelationTypePresent ? 10 : 5;
            const angle = Math.atan2(points[0].y - center.y, points[0].x - center.x);
            const cardinalityPosition = {
                x: 0,
                y: 0
            };
            cardinalityPosition.x = Math.sin(angle) * d + (points[0].x + center.x) / 2;
            cardinalityPosition.y = -Math.cos(angle) * d + (points[0].y + center.y) / 2;
            return cardinalityPosition;
        }, "calcCardinalityPosition");
        function calcTerminalLabelPosition(terminalMarkerSize, position, _points) {
            const points = structuredClone(_points);
            _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.cM.info("our points", points);
            if ("start_left" !== position && "start_right" !== position) points.reverse();
            const distanceToCardinalityPoint = 25 + terminalMarkerSize;
            const center = calculatePoint(points, distanceToCardinalityPoint);
            const d = 10 + 0.5 * terminalMarkerSize;
            const angle = Math.atan2(points[0].y - center.y, points[0].x - center.x);
            const cardinalityPosition = {
                x: 0,
                y: 0
            };
            if ("start_left" === position) {
                cardinalityPosition.x = Math.sin(angle + Math.PI) * d + (points[0].x + center.x) / 2;
                cardinalityPosition.y = -Math.cos(angle + Math.PI) * d + (points[0].y + center.y) / 2;
            } else if ("end_right" === position) {
                cardinalityPosition.x = Math.sin(angle - Math.PI) * d + (points[0].x + center.x) / 2 - 5;
                cardinalityPosition.y = -Math.cos(angle - Math.PI) * d + (points[0].y + center.y) / 2 - 5;
            } else if ("end_left" === position) {
                cardinalityPosition.x = Math.sin(angle) * d + (points[0].x + center.x) / 2 - 5;
                cardinalityPosition.y = -Math.cos(angle) * d + (points[0].y + center.y) / 2 - 5;
            } else {
                cardinalityPosition.x = Math.sin(angle) * d + (points[0].x + center.x) / 2;
                cardinalityPosition.y = -Math.cos(angle) * d + (points[0].y + center.y) / 2;
            }
            return cardinalityPosition;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(calcTerminalLabelPosition, "calcTerminalLabelPosition");
        function getStylesFromArray(arr) {
            let style = "";
            let labelStyle = "";
            for (const element of arr)if (void 0 !== element) {
                if (element.startsWith("color:") || element.startsWith("text-align:")) labelStyle = labelStyle + element + ";";
                else style = style + element + ";";
            }
            return {
                style,
                labelStyle
            };
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(getStylesFromArray, "getStylesFromArray");
        var cnt = 0;
        var generateId = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(()=>{
            cnt++;
            return "id-" + Math.random().toString(36).substr(2, 12) + "-" + cnt;
        }, "generateId");
        function makeRandomHex(length) {
            let result = "";
            const characters = "0123456789abcdef";
            const charactersLength = characters.length;
            for(let i = 0; i < length; i++)result += characters.charAt(Math.floor(Math.random() * charactersLength));
            return result;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(makeRandomHex, "makeRandomHex");
        var random = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)((options)=>makeRandomHex(options.length), "random");
        var getTextObj = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function() {
            return {
                x: 0,
                y: 0,
                fill: void 0,
                anchor: "start",
                style: "#666",
                width: 100,
                height: 100,
                textMargin: 0,
                rx: 0,
                ry: 0,
                valign: void 0,
                text: ""
            };
        }, "getTextObj");
        var drawSimpleText = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(elem, textData) {
            const nText = textData.text.replace(_chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.SY.lineBreakRegex, " ");
            const [, _fontSizePx] = parseFontSize(textData.fontSize);
            const textElem = elem.append("text");
            textElem.attr("x", textData.x);
            textElem.attr("y", textData.y);
            textElem.style("text-anchor", textData.anchor);
            textElem.style("font-family", textData.fontFamily);
            textElem.style("font-size", _fontSizePx);
            textElem.style("font-weight", textData.fontWeight);
            textElem.attr("fill", textData.fill);
            if (void 0 !== textData.class) textElem.attr("class", textData.class);
            const span = textElem.append("tspan");
            span.attr("x", textData.x + 2 * textData.textMargin);
            span.attr("fill", textData.fill);
            span.text(nText);
            return textElem;
        }, "drawSimpleText");
        var wrapLabel = (0, lodash_es_memoize_js__WEBPACK_IMPORTED_MODULE_3__.Z)((label, maxWidth, config)=>{
            if (!label) return label;
            config = Object.assign({
                fontSize: 12,
                fontWeight: 400,
                fontFamily: "Arial",
                joinWith: "<br/>"
            }, config);
            if (_chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.SY.lineBreakRegex.test(label)) return label;
            const words = label.split(" ").filter(Boolean);
            const completedLines = [];
            let nextLine = "";
            words.forEach((word, index)=>{
                const wordLength = calculateTextWidth(`${word} `, config);
                const nextLineLength = calculateTextWidth(nextLine, config);
                if (wordLength > maxWidth) {
                    const { hyphenatedStrings, remainingWord } = breakString(word, maxWidth, "-", config);
                    completedLines.push(nextLine, ...hyphenatedStrings);
                    nextLine = remainingWord;
                } else if (nextLineLength + wordLength >= maxWidth) {
                    completedLines.push(nextLine);
                    nextLine = word;
                } else nextLine = [
                    nextLine,
                    word
                ].filter(Boolean).join(" ");
                const currentWord = index + 1;
                const isLastWord = currentWord === words.length;
                if (isLastWord) completedLines.push(nextLine);
            });
            return completedLines.filter((line)=>"" !== line).join(config.joinWith);
        }, (label, maxWidth, config)=>`${label}${maxWidth}${config.fontSize}${config.fontWeight}${config.fontFamily}${config.joinWith}`);
        var breakString = (0, lodash_es_memoize_js__WEBPACK_IMPORTED_MODULE_3__.Z)((word, maxWidth, hyphenCharacter = "-", config)=>{
            config = Object.assign({
                fontSize: 12,
                fontWeight: 400,
                fontFamily: "Arial",
                margin: 0
            }, config);
            const characters = [
                ...word
            ];
            const lines = [];
            let currentLine = "";
            characters.forEach((character, index)=>{
                const nextLine = `${currentLine}${character}`;
                const lineWidth = calculateTextWidth(nextLine, config);
                if (lineWidth >= maxWidth) {
                    const currentCharacter = index + 1;
                    const isLastLine = characters.length === currentCharacter;
                    const hyphenatedNextLine = `${nextLine}${hyphenCharacter}`;
                    lines.push(isLastLine ? nextLine : hyphenatedNextLine);
                    currentLine = "";
                } else currentLine = nextLine;
            });
            return {
                hyphenatedStrings: lines,
                remainingWord: currentLine
            };
        }, (word, maxWidth, hyphenCharacter = "-", config)=>`${word}${maxWidth}${hyphenCharacter}${config.fontSize}${config.fontWeight}${config.fontFamily}`);
        function calculateTextHeight(text, config) {
            return calculateTextDimensions(text, config).height;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(calculateTextHeight, "calculateTextHeight");
        function calculateTextWidth(text, config) {
            return calculateTextDimensions(text, config).width;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(calculateTextWidth, "calculateTextWidth");
        var calculateTextDimensions = (0, lodash_es_memoize_js__WEBPACK_IMPORTED_MODULE_3__.Z)((text, config)=>{
            const { fontSize = 12, fontFamily = "Arial", fontWeight = 400 } = config;
            if (!text) return {
                width: 0,
                height: 0
            };
            const [, _fontSizePx] = parseFontSize(fontSize);
            const fontFamilies = [
                "sans-serif",
                fontFamily
            ];
            const lines = text.split(_chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.SY.lineBreakRegex);
            const dims = [];
            const body = (0, d3__WEBPACK_IMPORTED_MODULE_2__.Ys)("body");
            if (!body.remove) return {
                width: 0,
                height: 0,
                lineHeight: 0
            };
            const g = body.append("svg");
            for (const fontFamily2 of fontFamilies){
                let cHeight = 0;
                const dim = {
                    width: 0,
                    height: 0,
                    lineHeight: 0
                };
                for (const line of lines){
                    const textObj = getTextObj();
                    textObj.text = line || ZERO_WIDTH_SPACE;
                    const textElem = drawSimpleText(g, textObj).style("font-size", _fontSizePx).style("font-weight", fontWeight).style("font-family", fontFamily2);
                    const bBox = (textElem._groups || textElem)[0][0].getBBox();
                    if (0 === bBox.width && 0 === bBox.height) throw new Error("svg element not in render tree");
                    dim.width = Math.round(Math.max(dim.width, bBox.width));
                    cHeight = Math.round(bBox.height);
                    dim.height += cHeight;
                    dim.lineHeight = Math.round(Math.max(dim.lineHeight, cHeight));
                }
                dims.push(dim);
            }
            g.remove();
            const index = isNaN(dims[1].height) || isNaN(dims[1].width) || isNaN(dims[1].lineHeight) || dims[0].height > dims[1].height && dims[0].width > dims[1].width && dims[0].lineHeight > dims[1].lineHeight ? 0 : 1;
            return dims[index];
        }, (text, config)=>`${text}${config.fontSize}${config.fontWeight}${config.fontFamily}`);
        var InitIDGenerator = class {
            constructor(deterministic = false, seed){
                this.count = 0;
                this.count = seed ? seed.length : 0;
                this.next = deterministic ? ()=>this.count++ : ()=>Date.now();
            }
            static{
                (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(this, "InitIDGenerator");
            }
        };
        var decoder;
        var entityDecode = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(html) {
            decoder = decoder || document.createElement("div");
            html = escape(html).replace(/%26/g, "&").replace(/%23/g, "#").replace(/%3B/g, ";");
            decoder.innerHTML = html;
            return unescape(decoder.textContent);
        }, "entityDecode");
        function isDetailedError(error) {
            return "str" in error;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(isDetailedError, "isDetailedError");
        var insertTitle = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)((parent, cssClass, titleTopMargin, title)=>{
            if (!title) return;
            const bounds = parent.node()?.getBBox();
            if (!bounds) return;
            parent.append("text").text(title).attr("text-anchor", "middle").attr("x", bounds.x + bounds.width / 2).attr("y", -titleTopMargin).attr("class", cssClass);
        }, "insertTitle");
        var parseFontSize = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)((fontSize)=>{
            if ("number" == typeof fontSize) return [
                fontSize,
                fontSize + "px"
            ];
            const fontSizeNumber = parseInt(fontSize ?? "", 10);
            if (Number.isNaN(fontSizeNumber)) return [
                void 0,
                void 0
            ];
            if (fontSize === String(fontSizeNumber)) return [
                fontSizeNumber,
                fontSize + "px"
            ];
            return [
                fontSizeNumber,
                fontSize
            ];
        }, "parseFontSize");
        function cleanAndMerge(defaultData, data) {
            return (0, lodash_es_merge_js__WEBPACK_IMPORTED_MODULE_4__.Z)({}, defaultData, data);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(cleanAndMerge, "cleanAndMerge");
        var utils_default = {
            assignWithDepth: _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.Yc,
            wrapLabel,
            calculateTextHeight,
            calculateTextWidth,
            calculateTextDimensions,
            cleanAndMerge,
            detectInit,
            detectDirective,
            isSubstringInArray,
            interpolateToCurve,
            calcLabelPosition,
            calcCardinalityPosition,
            calcTerminalLabelPosition,
            formatUrl,
            getStylesFromArray,
            generateId,
            random,
            runFunc,
            entityDecode,
            insertTitle,
            parseFontSize,
            InitIDGenerator
        };
        var encodeEntities = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(text) {
            let txt = text;
            txt = txt.replace(/style.*:\S*#.*;/g, function(s) {
                return s.substring(0, s.length - 1);
            });
            txt = txt.replace(/classDef.*:\S*#.*;/g, function(s) {
                return s.substring(0, s.length - 1);
            });
            txt = txt.replace(/#\w+;/g, function(s) {
                const innerTxt = s.substring(1, s.length - 1);
                const isInt = /^\+?\d+$/.test(innerTxt);
                if (isInt) return "\uFB02\xB0\xB0" + innerTxt + "\xB6\xDF";
                return "\uFB02\xB0" + innerTxt + "\xB6\xDF";
            });
            return txt;
        }, "encodeEntities");
        var decodeEntities = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(text) {
            return text.replace(/ﬂ°°/g, "&#").replace(/ﬂ°/g, "&").replace(/¶ß/g, ";");
        }, "decodeEntities");
        var getEdgeId = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)((from, to, { counter = 0, prefix, suffix })=>`${prefix ? `${prefix}_` : ""}${from}_${to}_${counter}${suffix ? `_${suffix}` : ""}`, "getEdgeId");
        function handleUndefinedAttr(attrValue) {
            return attrValue ?? null;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(handleUndefinedAttr, "handleUndefinedAttr");
    },
    "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-7NZE2EM7.mjs": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            C1: ()=>labelHelper,
            Lf: ()=>insertNode,
            XO: ()=>createLabel_default,
            Yn: ()=>setNodeElem,
            ZH: ()=>clear,
            aH: ()=>positionNode,
            dW: ()=>isValidShape,
            gU: ()=>clear2,
            jr: ()=>updateNodeBounds,
            us: ()=>insertCluster
        });
        var _chunk_OPO4IU42_mjs__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-OPO4IU42.mjs");
        var _chunk_3X56UNUX_mjs__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-3X56UNUX.mjs");
        var _chunk_6JOS74DS_mjs__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-6JOS74DS.mjs");
        var _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-7DKRZKHE.mjs");
        var _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-6DBFFHIP.mjs");
        var d3__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__("./node_modules/.pnpm/d3@7.9.0/node_modules/d3/src/index.js");
        var roughjs__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__("./node_modules/.pnpm/roughjs@4.6.6/node_modules/roughjs/bundled/rough.esm.js");
        var labelHelper = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(async (parent, node, _classes)=>{
            let cssClasses;
            const useHtmlLabels = node.useHtmlLabels || (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.ku)(_chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.nV()?.htmlLabels);
            cssClasses = _classes ? _classes : "node default";
            const shapeSvg = parent.insert("g").attr("class", cssClasses).attr("id", node.domId || node.id);
            const labelEl = shapeSvg.insert("g").attr("class", "label").attr("style", (0, _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_3__.R7)(node.labelStyle));
            let label;
            label = void 0 === node.label ? "" : "string" == typeof node.label ? node.label : node.label[0];
            const text2 = await (0, _chunk_6JOS74DS_mjs__WEBPACK_IMPORTED_MODULE_2__.rw)(labelEl, (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.oO)((0, _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_3__.SH)(label), (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.nV)()), {
                useHtmlLabels,
                width: node.width || _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.nV().flowchart?.wrappingWidth,
                cssClasses: "markdown-node-label",
                style: node.labelStyle,
                addSvgBackground: !!node.icon || !!node.img
            });
            let bbox = text2.getBBox();
            const halfPadding = (node?.padding ?? 0) / 2;
            if (useHtmlLabels) {
                const div = text2.children[0];
                const dv = (0, d3__WEBPACK_IMPORTED_MODULE_5__.Ys)(text2);
                const images = div.getElementsByTagName("img");
                if (images) {
                    const noImgText = "" === label.replace(/<img[^>]*>/g, "").trim();
                    await Promise.all([
                        ...images
                    ].map((img)=>new Promise((res)=>{
                            function setupImage() {
                                img.style.display = "flex";
                                img.style.flexDirection = "column";
                                if (noImgText) {
                                    const bodyFontSize = (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.nV)().fontSize ? (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.nV)().fontSize : window.getComputedStyle(document.body).fontSize;
                                    const enlargingFactor = 5;
                                    const [parsedBodyFontSize = _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.vZ.fontSize] = (0, _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_3__.VG)(bodyFontSize);
                                    const width = parsedBodyFontSize * enlargingFactor + "px";
                                    img.style.minWidth = width;
                                    img.style.maxWidth = width;
                                } else img.style.width = "100%";
                                res(img);
                            }
                            (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(setupImage, "setupImage");
                            setTimeout(()=>{
                                if (img.complete) setupImage();
                            });
                            img.addEventListener("error", setupImage);
                            img.addEventListener("load", setupImage);
                        })));
                }
                bbox = div.getBoundingClientRect();
                dv.attr("width", bbox.width);
                dv.attr("height", bbox.height);
            }
            if (useHtmlLabels) labelEl.attr("transform", "translate(" + -bbox.width / 2 + ", " + -bbox.height / 2 + ")");
            else labelEl.attr("transform", "translate(0, " + -bbox.height / 2 + ")");
            if (node.centerLabel) labelEl.attr("transform", "translate(" + -bbox.width / 2 + ", " + -bbox.height / 2 + ")");
            labelEl.insert("rect", ":first-child");
            return {
                shapeSvg,
                bbox,
                halfPadding,
                label: labelEl
            };
        }, "labelHelper");
        var insertLabel = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(async (parent, label, options)=>{
            const useHtmlLabels = options.useHtmlLabels || (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.ku)(_chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.nV()?.flowchart?.htmlLabels);
            const labelEl = parent.insert("g").attr("class", "label").attr("style", options.labelStyle || "");
            const text2 = await (0, _chunk_6JOS74DS_mjs__WEBPACK_IMPORTED_MODULE_2__.rw)(labelEl, (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.oO)((0, _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_3__.SH)(label), (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.nV)()), {
                useHtmlLabels,
                width: options.width || _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.nV()?.flowchart?.wrappingWidth,
                style: options.labelStyle,
                addSvgBackground: !!options.icon || !!options.img
            });
            let bbox = text2.getBBox();
            const halfPadding = options.padding / 2;
            if ((0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.ku)(_chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.nV()?.flowchart?.htmlLabels)) {
                const div = text2.children[0];
                const dv = (0, d3__WEBPACK_IMPORTED_MODULE_5__.Ys)(text2);
                bbox = div.getBoundingClientRect();
                dv.attr("width", bbox.width);
                dv.attr("height", bbox.height);
            }
            if (useHtmlLabels) labelEl.attr("transform", "translate(" + -bbox.width / 2 + ", " + -bbox.height / 2 + ")");
            else labelEl.attr("transform", "translate(0, " + -bbox.height / 2 + ")");
            if (options.centerLabel) labelEl.attr("transform", "translate(" + -bbox.width / 2 + ", " + -bbox.height / 2 + ")");
            labelEl.insert("rect", ":first-child");
            return {
                shapeSvg: parent,
                bbox,
                halfPadding,
                label: labelEl
            };
        }, "insertLabel");
        var updateNodeBounds = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((node, element)=>{
            const bbox = element.node().getBBox();
            node.width = bbox.width;
            node.height = bbox.height;
        }, "updateNodeBounds");
        var getNodeClasses = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((node, extra)=>("handDrawn" === node.look ? "rough-node" : "node") + " " + node.cssClasses + " " + (extra || ""), "getNodeClasses");
        function createPathFromPoints(points) {
            const pointStrings = points.map((p, i)=>`${0 === i ? "M" : "L"}${p.x},${p.y}`);
            pointStrings.push("Z");
            return pointStrings.join(" ");
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(createPathFromPoints, "createPathFromPoints");
        function generateFullSineWavePoints(x1, y1, x2, y2, amplitude, numCycles) {
            const points = [];
            const steps = 50;
            const deltaX = x2 - x1;
            const deltaY = y2 - y1;
            const cycleLength = deltaX / numCycles;
            const frequency = 2 * Math.PI / cycleLength;
            const midY = y1 + deltaY / 2;
            for(let i = 0; i <= steps; i++){
                const t = i / steps;
                const x = x1 + t * deltaX;
                const y = midY + amplitude * Math.sin(frequency * (x - x1));
                points.push({
                    x,
                    y
                });
            }
            return points;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(generateFullSineWavePoints, "generateFullSineWavePoints");
        function generateCirclePoints(centerX, centerY, radius, numPoints, startAngle, endAngle) {
            const points = [];
            const startAngleRad = startAngle * Math.PI / 180;
            const endAngleRad = endAngle * Math.PI / 180;
            const angleRange = endAngleRad - startAngleRad;
            const angleStep = angleRange / (numPoints - 1);
            for(let i = 0; i < numPoints; i++){
                const angle = startAngleRad + i * angleStep;
                const x = centerX + radius * Math.cos(angle);
                const y = centerY + radius * Math.sin(angle);
                points.push({
                    x: -x,
                    y: -y
                });
            }
            return points;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(generateCirclePoints, "generateCirclePoints");
        var intersectRect = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((node, point)=>{
            var x = node.x;
            var y = node.y;
            var dx = point.x - x;
            var dy = point.y - y;
            var w = node.width / 2;
            var h = node.height / 2;
            var sx, sy;
            if (Math.abs(dy) * w > Math.abs(dx) * h) {
                if (dy < 0) h = -h;
                sx = 0 === dy ? 0 : h * dx / dy;
                sy = h;
            } else {
                if (dx < 0) w = -w;
                sx = w;
                sy = 0 === dx ? 0 : w * dy / dx;
            }
            return {
                x: x + sx,
                y: y + sy
            };
        }, "intersectRect");
        var intersect_rect_default = intersectRect;
        function applyStyle(dom, styleFn) {
            if (styleFn) dom.attr("style", styleFn);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(applyStyle, "applyStyle");
        async function addHtmlLabel(node) {
            const fo = (0, d3__WEBPACK_IMPORTED_MODULE_5__.Ys)(document.createElementNS("http://www.w3.org/2000/svg", "foreignObject"));
            const div = fo.append("xhtml:div");
            let label = node.label;
            if (node.label && (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.l0)(node.label)) label = await (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.uT)(node.label.replace(_chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.SY.lineBreakRegex, "\n"), (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.nV)());
            const labelClass = node.isNode ? "nodeLabel" : "edgeLabel";
            div.html('<span class="' + labelClass + '" ' + (node.labelStyle ? 'style="' + node.labelStyle + '"' : "") + ">" + label + "</span>");
            applyStyle(div, node.labelStyle);
            div.style("display", "inline-block");
            div.style("padding-right", "1px");
            div.style("white-space", "nowrap");
            div.attr("xmlns", "http://www.w3.org/1999/xhtml");
            return fo.node();
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(addHtmlLabel, "addHtmlLabel");
        var createLabel = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(async (_vertexText, style, isTitle, isNode)=>{
            let vertexText = _vertexText || "";
            if ("object" == typeof vertexText) vertexText = vertexText[0];
            if ((0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.ku)((0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.nV)().flowchart.htmlLabels)) {
                vertexText = vertexText.replace(/\\n|\n/g, "<br />");
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.info("vertexText" + vertexText);
                const node = {
                    isNode,
                    label: (0, _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_3__.SH)(vertexText).replace(/fa[blrs]?:fa-[\w-]+/g, (s)=>`<i class='${s.replace(":", " ")}'></i>`),
                    labelStyle: style ? style.replace("fill:", "color:") : style
                };
                let vertexNode = await addHtmlLabel(node);
                return vertexNode;
            }
            {
                const svgLabel = document.createElementNS("http://www.w3.org/2000/svg", "text");
                svgLabel.setAttribute("style", style.replace("color:", "fill:"));
                let rows = [];
                rows = "string" == typeof vertexText ? vertexText.split(/\\n|\n|<br\s*\/?>/gi) : Array.isArray(vertexText) ? vertexText : [];
                for (const row of rows){
                    const tspan = document.createElementNS("http://www.w3.org/2000/svg", "tspan");
                    tspan.setAttributeNS("http://www.w3.org/XML/1998/namespace", "xml:space", "preserve");
                    tspan.setAttribute("dy", "1em");
                    tspan.setAttribute("x", "0");
                    if (isTitle) tspan.setAttribute("class", "title-row");
                    else tspan.setAttribute("class", "row");
                    tspan.textContent = row.trim();
                    svgLabel.appendChild(tspan);
                }
                return svgLabel;
            }
        }, "createLabel");
        var createLabel_default = createLabel;
        var createRoundedRectPathD = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((x, y, totalWidth, totalHeight, radius)=>[
                "M",
                x + radius,
                y,
                "H",
                x + totalWidth - radius,
                "A",
                radius,
                radius,
                0,
                0,
                1,
                x + totalWidth,
                y + radius,
                "V",
                y + totalHeight - radius,
                "A",
                radius,
                radius,
                0,
                0,
                1,
                x + totalWidth - radius,
                y + totalHeight,
                "H",
                x + radius,
                "A",
                radius,
                radius,
                0,
                0,
                1,
                x,
                y + totalHeight - radius,
                "V",
                y + radius,
                "A",
                radius,
                radius,
                0,
                0,
                1,
                x + radius,
                y,
                "Z"
            ].join(" "), "createRoundedRectPathD");
        var solidStateFill = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((color)=>{
            const { handDrawnSeed } = (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.nV)();
            return {
                fill: color,
                hachureAngle: 120,
                hachureGap: 4,
                fillWeight: 2,
                roughness: 0.7,
                stroke: color,
                seed: handDrawnSeed
            };
        }, "solidStateFill");
        var compileStyles = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((node)=>{
            const stylesMap = styles2Map([
                ...node.cssCompiledStyles || [],
                ...node.cssStyles || []
            ]);
            return {
                stylesMap,
                stylesArray: [
                    ...stylesMap
                ]
            };
        }, "compileStyles");
        var styles2Map = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((styles)=>{
            const styleMap = /* @__PURE__ */ new Map();
            styles.forEach((style)=>{
                const [key, value] = style.split(":");
                styleMap.set(key.trim(), value?.trim());
            });
            return styleMap;
        }, "styles2Map");
        var styles2String = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((node)=>{
            const { stylesArray } = compileStyles(node);
            const labelStyles = [];
            const nodeStyles = [];
            const borderStyles = [];
            const backgroundStyles = [];
            stylesArray.forEach((style)=>{
                const key = style[0];
                if ("color" === key || "font-size" === key || "font-family" === key || "font-weight" === key || "font-style" === key || "text-decoration" === key || "text-align" === key || "text-transform" === key || "line-height" === key || "letter-spacing" === key || "word-spacing" === key || "text-shadow" === key || "text-overflow" === key || "white-space" === key || "word-wrap" === key || "word-break" === key || "overflow-wrap" === key || "hyphens" === key) labelStyles.push(style.join(":") + " !important");
                else {
                    nodeStyles.push(style.join(":") + " !important");
                    if (key.includes("stroke")) borderStyles.push(style.join(":") + " !important");
                    if ("fill" === key) backgroundStyles.push(style.join(":") + " !important");
                }
            });
            return {
                labelStyles: labelStyles.join(";"),
                nodeStyles: nodeStyles.join(";"),
                stylesArray,
                borderStyles,
                backgroundStyles
            };
        }, "styles2String");
        var userNodeOverrides = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((node, options)=>{
            const { themeVariables, handDrawnSeed } = (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.nV)();
            const { nodeBorder, mainBkg } = themeVariables;
            const { stylesMap } = compileStyles(node);
            const result = Object.assign({
                roughness: 0.7,
                fill: stylesMap.get("fill") || mainBkg,
                fillStyle: "hachure",
                fillWeight: 4,
                hachureGap: 5.2,
                stroke: stylesMap.get("stroke") || nodeBorder,
                seed: handDrawnSeed,
                strokeWidth: stylesMap.get("stroke-width")?.replace("px", "") || 1.3,
                fillLineDash: [
                    0,
                    0
                ]
            }, options);
            return result;
        }, "userNodeOverrides");
        var rect = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(async (parent, node)=>{
            _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.info("Creating subgraph rect for ", node.id, node);
            const siteConfig = (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.nV)();
            const { themeVariables, handDrawnSeed } = siteConfig;
            const { clusterBkg, clusterBorder } = themeVariables;
            const { labelStyles, nodeStyles, borderStyles, backgroundStyles } = styles2String(node);
            const shapeSvg = parent.insert("g").attr("class", "cluster " + node.cssClasses).attr("id", node.id).attr("data-look", node.look);
            const useHtmlLabels = (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.ku)(siteConfig.flowchart.htmlLabels);
            const labelEl = shapeSvg.insert("g").attr("class", "cluster-label ");
            const text2 = await (0, _chunk_6JOS74DS_mjs__WEBPACK_IMPORTED_MODULE_2__.rw)(labelEl, node.label, {
                style: node.labelStyle,
                useHtmlLabels,
                isNode: true
            });
            let bbox = text2.getBBox();
            if ((0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.ku)(siteConfig.flowchart.htmlLabels)) {
                const div = text2.children[0];
                const dv = (0, d3__WEBPACK_IMPORTED_MODULE_5__.Ys)(text2);
                bbox = div.getBoundingClientRect();
                dv.attr("width", bbox.width);
                dv.attr("height", bbox.height);
            }
            const width = node.width <= bbox.width + node.padding ? bbox.width + node.padding : node.width;
            if (node.width <= bbox.width + node.padding) node.diff = (width - node.width) / 2 - node.padding;
            else node.diff = -node.padding;
            const height = node.height;
            const x = node.x - width / 2;
            const y = node.y - height / 2;
            _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.trace("Data ", node, JSON.stringify(node));
            let rect2;
            if ("handDrawn" === node.look) {
                const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
                const options = userNodeOverrides(node, {
                    roughness: 0.7,
                    fill: clusterBkg,
                    stroke: clusterBorder,
                    fillWeight: 3,
                    seed: handDrawnSeed
                });
                const roughNode = rc.path(createRoundedRectPathD(x, y, width, height, 0), options);
                rect2 = shapeSvg.insert(()=>{
                    _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.debug("Rough node insert CXC", roughNode);
                    return roughNode;
                }, ":first-child");
                rect2.select("path:nth-child(2)").attr("style", borderStyles.join(";"));
                rect2.select("path").attr("style", backgroundStyles.join(";").replace("fill", "stroke"));
            } else {
                rect2 = shapeSvg.insert("rect", ":first-child");
                rect2.attr("style", nodeStyles).attr("rx", node.rx).attr("ry", node.ry).attr("x", x).attr("y", y).attr("width", width).attr("height", height);
            }
            const { subGraphTitleTopMargin } = (0, _chunk_3X56UNUX_mjs__WEBPACK_IMPORTED_MODULE_1__.L)(siteConfig);
            labelEl.attr("transform", `translate(${node.x - bbox.width / 2}, ${node.y - node.height / 2 + subGraphTitleTopMargin})`);
            if (labelStyles) {
                const span = labelEl.select("span");
                if (span) span.attr("style", labelStyles);
            }
            const rectBox = rect2.node().getBBox();
            node.offsetX = 0;
            node.width = rectBox.width;
            node.height = rectBox.height;
            node.offsetY = bbox.height - node.padding / 2;
            node.intersect = function(point) {
                return intersect_rect_default(node, point);
            };
            return {
                cluster: shapeSvg,
                labelBBox: bbox
            };
        }, "rect");
        var noteGroup = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((parent, node)=>{
            const shapeSvg = parent.insert("g").attr("class", "note-cluster").attr("id", node.id);
            const rect2 = shapeSvg.insert("rect", ":first-child");
            const padding = 0 * node.padding;
            const halfPadding = padding / 2;
            rect2.attr("rx", node.rx).attr("ry", node.ry).attr("x", node.x - node.width / 2 - halfPadding).attr("y", node.y - node.height / 2 - halfPadding).attr("width", node.width + padding).attr("height", node.height + padding).attr("fill", "none");
            const rectBox = rect2.node().getBBox();
            node.width = rectBox.width;
            node.height = rectBox.height;
            node.intersect = function(point) {
                return intersect_rect_default(node, point);
            };
            return {
                cluster: shapeSvg,
                labelBBox: {
                    width: 0,
                    height: 0
                }
            };
        }, "noteGroup");
        var roundedWithTitle = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(async (parent, node)=>{
            const siteConfig = (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.nV)();
            const { themeVariables, handDrawnSeed } = siteConfig;
            const { altBackground, compositeBackground, compositeTitleBackground, nodeBorder } = themeVariables;
            const shapeSvg = parent.insert("g").attr("class", node.cssClasses).attr("id", node.id).attr("data-id", node.id).attr("data-look", node.look);
            const outerRectG = shapeSvg.insert("g", ":first-child");
            const label = shapeSvg.insert("g").attr("class", "cluster-label");
            let innerRect = shapeSvg.append("rect");
            const text2 = label.node().appendChild(await createLabel_default(node.label, node.labelStyle, void 0, true));
            let bbox = text2.getBBox();
            if ((0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.ku)(siteConfig.flowchart.htmlLabels)) {
                const div = text2.children[0];
                const dv = (0, d3__WEBPACK_IMPORTED_MODULE_5__.Ys)(text2);
                bbox = div.getBoundingClientRect();
                dv.attr("width", bbox.width);
                dv.attr("height", bbox.height);
            }
            const padding = 0 * node.padding;
            const halfPadding = padding / 2;
            const width = (node.width <= bbox.width + node.padding ? bbox.width + node.padding : node.width) + padding;
            if (node.width <= bbox.width + node.padding) node.diff = (width - node.width) / 2 - node.padding;
            else node.diff = -node.padding;
            const height = node.height + padding;
            const innerHeight = node.height + padding - bbox.height - 6;
            const x = node.x - width / 2;
            const y = node.y - height / 2;
            node.width = width;
            const innerY = node.y - node.height / 2 - halfPadding + bbox.height + 2;
            let rect2;
            if ("handDrawn" === node.look) {
                const isAlt = node.cssClasses.includes("statediagram-cluster-alt");
                const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
                const roughOuterNode = node.rx || node.ry ? rc.path(createRoundedRectPathD(x, y, width, height, 10), {
                    roughness: 0.7,
                    fill: compositeTitleBackground,
                    fillStyle: "solid",
                    stroke: nodeBorder,
                    seed: handDrawnSeed
                }) : rc.rectangle(x, y, width, height, {
                    seed: handDrawnSeed
                });
                rect2 = shapeSvg.insert(()=>roughOuterNode, ":first-child");
                const roughInnerNode = rc.rectangle(x, innerY, width, innerHeight, {
                    fill: isAlt ? altBackground : compositeBackground,
                    fillStyle: isAlt ? "hachure" : "solid",
                    stroke: nodeBorder,
                    seed: handDrawnSeed
                });
                rect2 = shapeSvg.insert(()=>roughOuterNode, ":first-child");
                innerRect = shapeSvg.insert(()=>roughInnerNode);
            } else {
                rect2 = outerRectG.insert("rect", ":first-child");
                const outerRectClass = "outer";
                rect2.attr("class", outerRectClass).attr("x", x).attr("y", y).attr("width", width).attr("height", height).attr("data-look", node.look);
                innerRect.attr("class", "inner").attr("x", x).attr("y", innerY).attr("width", width).attr("height", innerHeight);
            }
            label.attr("transform", `translate(${node.x - bbox.width / 2}, ${y + 1 - ((0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.ku)(siteConfig.flowchart.htmlLabels) ? 0 : 3)})`);
            const rectBox = rect2.node().getBBox();
            node.height = rectBox.height;
            node.offsetX = 0;
            node.offsetY = bbox.height - node.padding / 2;
            node.labelBBox = bbox;
            node.intersect = function(point) {
                return intersect_rect_default(node, point);
            };
            return {
                cluster: shapeSvg,
                labelBBox: bbox
            };
        }, "roundedWithTitle");
        var kanbanSection = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(async (parent, node)=>{
            _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.info("Creating subgraph rect for ", node.id, node);
            const siteConfig = (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.nV)();
            const { themeVariables, handDrawnSeed } = siteConfig;
            const { clusterBkg, clusterBorder } = themeVariables;
            const { labelStyles, nodeStyles, borderStyles, backgroundStyles } = styles2String(node);
            const shapeSvg = parent.insert("g").attr("class", "cluster " + node.cssClasses).attr("id", node.id).attr("data-look", node.look);
            const useHtmlLabels = (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.ku)(siteConfig.flowchart.htmlLabels);
            const labelEl = shapeSvg.insert("g").attr("class", "cluster-label ");
            const text2 = await (0, _chunk_6JOS74DS_mjs__WEBPACK_IMPORTED_MODULE_2__.rw)(labelEl, node.label, {
                style: node.labelStyle,
                useHtmlLabels,
                isNode: true,
                width: node.width
            });
            let bbox = text2.getBBox();
            if ((0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.ku)(siteConfig.flowchart.htmlLabels)) {
                const div = text2.children[0];
                const dv = (0, d3__WEBPACK_IMPORTED_MODULE_5__.Ys)(text2);
                bbox = div.getBoundingClientRect();
                dv.attr("width", bbox.width);
                dv.attr("height", bbox.height);
            }
            const width = node.width <= bbox.width + node.padding ? bbox.width + node.padding : node.width;
            if (node.width <= bbox.width + node.padding) node.diff = (width - node.width) / 2 - node.padding;
            else node.diff = -node.padding;
            const height = node.height;
            const x = node.x - width / 2;
            const y = node.y - height / 2;
            _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.trace("Data ", node, JSON.stringify(node));
            let rect2;
            if ("handDrawn" === node.look) {
                const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
                const options = userNodeOverrides(node, {
                    roughness: 0.7,
                    fill: clusterBkg,
                    stroke: clusterBorder,
                    fillWeight: 4,
                    seed: handDrawnSeed
                });
                const roughNode = rc.path(createRoundedRectPathD(x, y, width, height, node.rx), options);
                rect2 = shapeSvg.insert(()=>{
                    _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.debug("Rough node insert CXC", roughNode);
                    return roughNode;
                }, ":first-child");
                rect2.select("path:nth-child(2)").attr("style", borderStyles.join(";"));
                rect2.select("path").attr("style", backgroundStyles.join(";").replace("fill", "stroke"));
            } else {
                rect2 = shapeSvg.insert("rect", ":first-child");
                rect2.attr("style", nodeStyles).attr("rx", node.rx).attr("ry", node.ry).attr("x", x).attr("y", y).attr("width", width).attr("height", height);
            }
            const { subGraphTitleTopMargin } = (0, _chunk_3X56UNUX_mjs__WEBPACK_IMPORTED_MODULE_1__.L)(siteConfig);
            labelEl.attr("transform", `translate(${node.x - bbox.width / 2}, ${node.y - node.height / 2 + subGraphTitleTopMargin})`);
            if (labelStyles) {
                const span = labelEl.select("span");
                if (span) span.attr("style", labelStyles);
            }
            const rectBox = rect2.node().getBBox();
            node.offsetX = 0;
            node.width = rectBox.width;
            node.height = rectBox.height;
            node.offsetY = bbox.height - node.padding / 2;
            node.intersect = function(point) {
                return intersect_rect_default(node, point);
            };
            return {
                cluster: shapeSvg,
                labelBBox: bbox
            };
        }, "kanbanSection");
        var divider = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((parent, node)=>{
            const siteConfig = (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.nV)();
            const { themeVariables, handDrawnSeed } = siteConfig;
            const { nodeBorder } = themeVariables;
            const shapeSvg = parent.insert("g").attr("class", node.cssClasses).attr("id", node.id).attr("data-look", node.look);
            const outerRectG = shapeSvg.insert("g", ":first-child");
            const padding = 0 * node.padding;
            const width = node.width + padding;
            node.diff = -node.padding;
            const height = node.height + padding;
            const x = node.x - width / 2;
            const y = node.y - height / 2;
            node.width = width;
            let rect2;
            if ("handDrawn" === node.look) {
                const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
                const roughOuterNode = rc.rectangle(x, y, width, height, {
                    fill: "lightgrey",
                    roughness: 0.5,
                    strokeLineDash: [
                        5
                    ],
                    stroke: nodeBorder,
                    seed: handDrawnSeed
                });
                rect2 = shapeSvg.insert(()=>roughOuterNode, ":first-child");
            } else {
                rect2 = outerRectG.insert("rect", ":first-child");
                const outerRectClass = "divider";
                rect2.attr("class", outerRectClass).attr("x", x).attr("y", y).attr("width", width).attr("height", height).attr("data-look", node.look);
            }
            const rectBox = rect2.node().getBBox();
            node.height = rectBox.height;
            node.offsetX = 0;
            node.offsetY = 0;
            node.intersect = function(point) {
                return intersect_rect_default(node, point);
            };
            return {
                cluster: shapeSvg,
                labelBBox: {}
            };
        }, "divider");
        var squareRect = rect;
        var shapes = {
            rect,
            squareRect,
            roundedWithTitle,
            noteGroup,
            divider,
            kanbanSection
        };
        var clusterElems = /* @__PURE__ */ new Map();
        var insertCluster = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(async (elem, node)=>{
            const shape = node.shape || "rect";
            const cluster = await shapes[shape](elem, node);
            clusterElems.set(node.id, cluster);
            return cluster;
        }, "insertCluster");
        var clear = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(()=>{
            clusterElems = /* @__PURE__ */ new Map();
        }, "clear");
        function intersectNode(node, point) {
            return node.intersect(point);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(intersectNode, "intersectNode");
        var intersect_node_default = intersectNode;
        function intersectEllipse(node, rx, ry, point) {
            var cx = node.x;
            var cy = node.y;
            var px = cx - point.x;
            var py = cy - point.y;
            var det = Math.sqrt(rx * rx * py * py + ry * ry * px * px);
            var dx = Math.abs(rx * ry * px / det);
            if (point.x < cx) dx = -dx;
            var dy = Math.abs(rx * ry * py / det);
            if (point.y < cy) dy = -dy;
            return {
                x: cx + dx,
                y: cy + dy
            };
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(intersectEllipse, "intersectEllipse");
        var intersect_ellipse_default = intersectEllipse;
        function intersectCircle(node, rx, point) {
            return intersect_ellipse_default(node, rx, rx, point);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(intersectCircle, "intersectCircle");
        var intersect_circle_default = intersectCircle;
        function intersectLine(p1, p2, q1, q2) {
            var a1, a2, b1, b2, c1, c2;
            var r1, r2, r3, r4;
            var denom, offset, num;
            var x, y;
            a1 = p2.y - p1.y;
            b1 = p1.x - p2.x;
            c1 = p2.x * p1.y - p1.x * p2.y;
            r3 = a1 * q1.x + b1 * q1.y + c1;
            r4 = a1 * q2.x + b1 * q2.y + c1;
            if (0 !== r3 && 0 !== r4 && sameSign(r3, r4)) return;
            a2 = q2.y - q1.y;
            b2 = q1.x - q2.x;
            c2 = q2.x * q1.y - q1.x * q2.y;
            r1 = a2 * p1.x + b2 * p1.y + c2;
            r2 = a2 * p2.x + b2 * p2.y + c2;
            if (0 !== r1 && 0 !== r2 && sameSign(r1, r2)) return;
            denom = a1 * b2 - a2 * b1;
            if (0 === denom) return;
            offset = Math.abs(denom / 2);
            num = b1 * c2 - b2 * c1;
            x = num < 0 ? (num - offset) / denom : (num + offset) / denom;
            num = a2 * c1 - a1 * c2;
            y = num < 0 ? (num - offset) / denom : (num + offset) / denom;
            return {
                x,
                y
            };
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(intersectLine, "intersectLine");
        function sameSign(r1, r2) {
            return r1 * r2 > 0;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(sameSign, "sameSign");
        var intersect_line_default = intersectLine;
        function intersectPolygon(node, polyPoints, point) {
            let x1 = node.x;
            let y1 = node.y;
            let intersections = [];
            let minX = Number.POSITIVE_INFINITY;
            let minY = Number.POSITIVE_INFINITY;
            if ("function" == typeof polyPoints.forEach) polyPoints.forEach(function(entry) {
                minX = Math.min(minX, entry.x);
                minY = Math.min(minY, entry.y);
            });
            else {
                minX = Math.min(minX, polyPoints.x);
                minY = Math.min(minY, polyPoints.y);
            }
            let left = x1 - node.width / 2 - minX;
            let top = y1 - node.height / 2 - minY;
            for(let i = 0; i < polyPoints.length; i++){
                let p1 = polyPoints[i];
                let p2 = polyPoints[i < polyPoints.length - 1 ? i + 1 : 0];
                let intersect = intersect_line_default(node, point, {
                    x: left + p1.x,
                    y: top + p1.y
                }, {
                    x: left + p2.x,
                    y: top + p2.y
                });
                if (intersect) intersections.push(intersect);
            }
            if (!intersections.length) return node;
            if (intersections.length > 1) intersections.sort(function(p, q) {
                let pdx = p.x - point.x;
                let pdy = p.y - point.y;
                let distp = Math.sqrt(pdx * pdx + pdy * pdy);
                let qdx = q.x - point.x;
                let qdy = q.y - point.y;
                let distq = Math.sqrt(qdx * qdx + qdy * qdy);
                return distp < distq ? -1 : distp === distq ? 0 : 1;
            });
            return intersections[0];
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(intersectPolygon, "intersectPolygon");
        var intersect_polygon_default = intersectPolygon;
        var intersect_default = {
            node: intersect_node_default,
            circle: intersect_circle_default,
            ellipse: intersect_ellipse_default,
            polygon: intersect_polygon_default,
            rect: intersect_rect_default
        };
        function anchor(parent, node) {
            const { labelStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const classes = getNodeClasses(node);
            let cssClasses = classes;
            if (!classes) cssClasses = "anchor";
            const shapeSvg = parent.insert("g").attr("class", cssClasses).attr("id", node.domId || node.id);
            const radius = 1;
            const { cssStyles } = node;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {
                fill: "black",
                stroke: "none",
                fillStyle: "solid"
            });
            if ("handDrawn" !== node.look) options.roughness = 0;
            const roughNode = rc.circle(0, 0, 2 * radius, options);
            const circleElem = shapeSvg.insert(()=>roughNode, ":first-child");
            circleElem.attr("class", "anchor").attr("style", (0, _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_3__.R7)(cssStyles));
            updateNodeBounds(node, circleElem);
            node.intersect = function(point) {
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.info("Circle intersect", node, radius, point);
                return intersect_default.circle(node, radius, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(anchor, "anchor");
        function generateArcPoints(x1, y1, x2, y2, rx, ry, clockwise) {
            const numPoints = 20;
            const midX = (x1 + x2) / 2;
            const midY = (y1 + y2) / 2;
            const angle = Math.atan2(y2 - y1, x2 - x1);
            const dx = (x2 - x1) / 2;
            const dy = (y2 - y1) / 2;
            const transformedX = dx / rx;
            const transformedY = dy / ry;
            const distance = Math.sqrt(transformedX ** 2 + transformedY ** 2);
            if (distance > 1) throw new Error("The given radii are too small to create an arc between the points.");
            const scaledCenterDistance = Math.sqrt(1 - distance ** 2);
            const centerX = midX + scaledCenterDistance * ry * Math.sin(angle) * (clockwise ? -1 : 1);
            const centerY = midY - scaledCenterDistance * rx * Math.cos(angle) * (clockwise ? -1 : 1);
            const startAngle = Math.atan2((y1 - centerY) / ry, (x1 - centerX) / rx);
            const endAngle = Math.atan2((y2 - centerY) / ry, (x2 - centerX) / rx);
            let angleRange = endAngle - startAngle;
            if (clockwise && angleRange < 0) angleRange += 2 * Math.PI;
            if (!clockwise && angleRange > 0) angleRange -= 2 * Math.PI;
            const points = [];
            for(let i = 0; i < numPoints; i++){
                const t = i / (numPoints - 1);
                const angle2 = startAngle + t * angleRange;
                const x = centerX + rx * Math.cos(angle2);
                const y = centerY + ry * Math.sin(angle2);
                points.push({
                    x,
                    y
                });
            }
            return points;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(generateArcPoints, "generateArcPoints");
        async function bowTieRect(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox } = await labelHelper(parent, node, getNodeClasses(node));
            const w = bbox.width + node.padding + 20;
            const h = bbox.height + node.padding;
            const ry = h / 2;
            const rx = ry / (2.5 + h / 50);
            const { cssStyles } = node;
            const points = [
                {
                    x: w / 2,
                    y: -h / 2
                },
                {
                    x: -w / 2,
                    y: -h / 2
                },
                ...generateArcPoints(-w / 2, -h / 2, -w / 2, h / 2, rx, ry, false),
                {
                    x: w / 2,
                    y: h / 2
                },
                ...generateArcPoints(w / 2, h / 2, w / 2, -h / 2, rx, ry, true)
            ];
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const bowTieRectPath = createPathFromPoints(points);
            const bowTieRectShapePath = rc.path(bowTieRectPath, options);
            const bowTieRectShape = shapeSvg.insert(()=>bowTieRectShapePath, ":first-child");
            bowTieRectShape.attr("class", "basic label-container");
            if (cssStyles && "handDrawn" !== node.look) bowTieRectShape.selectAll("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) bowTieRectShape.selectAll("path").attr("style", nodeStyles);
            bowTieRectShape.attr("transform", `translate(${rx / 2}, 0)`);
            updateNodeBounds(node, bowTieRectShape);
            node.intersect = function(point) {
                const pos = intersect_default.polygon(node, points, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(bowTieRect, "bowTieRect");
        function insertPolygonShape(parent, w, h, points) {
            return parent.insert("polygon", ":first-child").attr("points", points.map(function(d) {
                return d.x + "," + d.y;
            }).join(" ")).attr("class", "label-container").attr("transform", "translate(" + -w / 2 + "," + h / 2 + ")");
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(insertPolygonShape, "insertPolygonShape");
        async function card(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox } = await labelHelper(parent, node, getNodeClasses(node));
            const h = bbox.height + node.padding;
            const padding = 12;
            const w = bbox.width + node.padding + padding;
            const left = 0;
            const right = w;
            const top = -h;
            const bottom = 0;
            const points = [
                {
                    x: left + padding,
                    y: top
                },
                {
                    x: right,
                    y: top
                },
                {
                    x: right,
                    y: bottom
                },
                {
                    x: left,
                    y: bottom
                },
                {
                    x: left,
                    y: top + padding
                },
                {
                    x: left + padding,
                    y: top
                }
            ];
            let polygon;
            const { cssStyles } = node;
            if ("handDrawn" === node.look) {
                const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
                const options = userNodeOverrides(node, {});
                const pathData = createPathFromPoints(points);
                const roughNode = rc.path(pathData, options);
                polygon = shapeSvg.insert(()=>roughNode, ":first-child").attr("transform", `translate(${-w / 2}, ${h / 2})`);
                if (cssStyles) polygon.attr("style", cssStyles);
            } else polygon = insertPolygonShape(shapeSvg, w, h, points);
            if (nodeStyles) polygon.attr("style", nodeStyles);
            updateNodeBounds(node, polygon);
            node.intersect = function(point) {
                return intersect_default.polygon(node, points, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(card, "card");
        function choice(parent, node) {
            const { nodeStyles } = styles2String(node);
            node.label = "";
            const shapeSvg = parent.insert("g").attr("class", getNodeClasses(node)).attr("id", node.domId ?? node.id);
            const { cssStyles } = node;
            const s = Math.max(28, node.width ?? 0);
            const points = [
                {
                    x: 0,
                    y: s / 2
                },
                {
                    x: s / 2,
                    y: 0
                },
                {
                    x: 0,
                    y: -s / 2
                },
                {
                    x: -s / 2,
                    y: 0
                }
            ];
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const choicePath = createPathFromPoints(points);
            const roughNode = rc.path(choicePath, options);
            const choiceShape = shapeSvg.insert(()=>roughNode, ":first-child");
            if (cssStyles && "handDrawn" !== node.look) choiceShape.selectAll("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) choiceShape.selectAll("path").attr("style", nodeStyles);
            node.width = 28;
            node.height = 28;
            node.intersect = function(point) {
                return intersect_default.polygon(node, points, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(choice, "choice");
        async function circle(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox, halfPadding } = await labelHelper(parent, node, getNodeClasses(node));
            const radius = bbox.width / 2 + halfPadding;
            let circleElem;
            const { cssStyles } = node;
            if ("handDrawn" === node.look) {
                const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
                const options = userNodeOverrides(node, {});
                const roughNode = rc.circle(0, 0, 2 * radius, options);
                circleElem = shapeSvg.insert(()=>roughNode, ":first-child");
                circleElem.attr("class", "basic label-container").attr("style", (0, _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_3__.R7)(cssStyles));
            } else circleElem = shapeSvg.insert("circle", ":first-child").attr("class", "basic label-container").attr("style", nodeStyles).attr("r", radius).attr("cx", 0).attr("cy", 0);
            updateNodeBounds(node, circleElem);
            node.intersect = function(point) {
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.info("Circle intersect", node, radius, point);
                return intersect_default.circle(node, radius, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(circle, "circle");
        function createLine(r) {
            const xAxis45 = Math.cos(Math.PI / 4);
            const yAxis45 = Math.sin(Math.PI / 4);
            const lineLength = 2 * r;
            const pointQ1 = {
                x: lineLength / 2 * xAxis45,
                y: lineLength / 2 * yAxis45
            };
            const pointQ2 = {
                x: -(lineLength / 2) * xAxis45,
                y: lineLength / 2 * yAxis45
            };
            const pointQ3 = {
                x: -(lineLength / 2) * xAxis45,
                y: -(lineLength / 2) * yAxis45
            };
            const pointQ4 = {
                x: lineLength / 2 * xAxis45,
                y: -(lineLength / 2) * yAxis45
            };
            return `M ${pointQ2.x},${pointQ2.y} L ${pointQ4.x},${pointQ4.y}
                   M ${pointQ1.x},${pointQ1.y} L ${pointQ3.x},${pointQ3.y}`;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(createLine, "createLine");
        function crossedCircle(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            node.label = "";
            const shapeSvg = parent.insert("g").attr("class", getNodeClasses(node)).attr("id", node.domId ?? node.id);
            const radius = Math.max(30, node?.width ?? 0);
            const { cssStyles } = node;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const circleNode = rc.circle(0, 0, 2 * radius, options);
            const linePath = createLine(radius);
            const lineNode = rc.path(linePath, options);
            const crossedCircle2 = shapeSvg.insert(()=>circleNode, ":first-child");
            crossedCircle2.insert(()=>lineNode);
            if (cssStyles && "handDrawn" !== node.look) crossedCircle2.selectAll("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) crossedCircle2.selectAll("path").attr("style", nodeStyles);
            updateNodeBounds(node, crossedCircle2);
            node.intersect = function(point) {
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.info("crossedCircle intersect", node, {
                    radius,
                    point
                });
                const pos = intersect_default.circle(node, radius, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(crossedCircle, "crossedCircle");
        function generateCirclePoints2(centerX, centerY, radius, numPoints = 100, startAngle = 0, endAngle = 180) {
            const points = [];
            const startAngleRad = startAngle * Math.PI / 180;
            const endAngleRad = endAngle * Math.PI / 180;
            const angleRange = endAngleRad - startAngleRad;
            const angleStep = angleRange / (numPoints - 1);
            for(let i = 0; i < numPoints; i++){
                const angle = startAngleRad + i * angleStep;
                const x = centerX + radius * Math.cos(angle);
                const y = centerY + radius * Math.sin(angle);
                points.push({
                    x: -x,
                    y: -y
                });
            }
            return points;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(generateCirclePoints2, "generateCirclePoints");
        async function curlyBraceLeft(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox, label } = await labelHelper(parent, node, getNodeClasses(node));
            const w = bbox.width + (node.padding ?? 0);
            const h = bbox.height + (node.padding ?? 0);
            const radius = Math.max(5, 0.1 * h);
            const { cssStyles } = node;
            const points = [
                ...generateCirclePoints2(w / 2, -h / 2, radius, 30, -90, 0),
                {
                    x: -w / 2 - radius,
                    y: radius
                },
                ...generateCirclePoints2(w / 2 + 2 * radius, -radius, radius, 20, -180, -270),
                ...generateCirclePoints2(w / 2 + 2 * radius, radius, radius, 20, -90, -180),
                {
                    x: -w / 2 - radius,
                    y: -h / 2
                },
                ...generateCirclePoints2(w / 2, h / 2, radius, 20, 0, 90)
            ];
            const rectPoints = [
                {
                    x: w / 2,
                    y: -h / 2 - radius
                },
                {
                    x: -w / 2,
                    y: -h / 2 - radius
                },
                ...generateCirclePoints2(w / 2, -h / 2, radius, 20, -90, 0),
                {
                    x: -w / 2 - radius,
                    y: -radius
                },
                ...generateCirclePoints2(w / 2 + 0.1 * w, -radius, radius, 20, -180, -270),
                ...generateCirclePoints2(w / 2 + 0.1 * w, radius, radius, 20, -90, -180),
                {
                    x: -w / 2 - radius,
                    y: h / 2
                },
                ...generateCirclePoints2(w / 2, h / 2, radius, 20, 0, 90),
                {
                    x: -w / 2,
                    y: h / 2 + radius
                },
                {
                    x: w / 2,
                    y: h / 2 + radius
                }
            ];
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {
                fill: "none"
            });
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const curlyBraceLeftPath = createPathFromPoints(points);
            const newCurlyBracePath = curlyBraceLeftPath.replace("Z", "");
            const curlyBraceLeftNode = rc.path(newCurlyBracePath, options);
            const rectPath = createPathFromPoints(rectPoints);
            const rectShape = rc.path(rectPath, {
                ...options
            });
            const curlyBraceLeftShape = shapeSvg.insert("g", ":first-child");
            curlyBraceLeftShape.insert(()=>rectShape, ":first-child").attr("stroke-opacity", 0);
            curlyBraceLeftShape.insert(()=>curlyBraceLeftNode, ":first-child");
            curlyBraceLeftShape.attr("class", "text");
            if (cssStyles && "handDrawn" !== node.look) curlyBraceLeftShape.selectAll("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) curlyBraceLeftShape.selectAll("path").attr("style", nodeStyles);
            curlyBraceLeftShape.attr("transform", `translate(${radius}, 0)`);
            label.attr("transform", `translate(${-w / 2 + radius - (bbox.x - (bbox.left ?? 0))},${-h / 2 + (node.padding ?? 0) / 2 - (bbox.y - (bbox.top ?? 0))})`);
            updateNodeBounds(node, curlyBraceLeftShape);
            node.intersect = function(point) {
                const pos = intersect_default.polygon(node, rectPoints, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(curlyBraceLeft, "curlyBraceLeft");
        function generateCirclePoints3(centerX, centerY, radius, numPoints = 100, startAngle = 0, endAngle = 180) {
            const points = [];
            const startAngleRad = startAngle * Math.PI / 180;
            const endAngleRad = endAngle * Math.PI / 180;
            const angleRange = endAngleRad - startAngleRad;
            const angleStep = angleRange / (numPoints - 1);
            for(let i = 0; i < numPoints; i++){
                const angle = startAngleRad + i * angleStep;
                const x = centerX + radius * Math.cos(angle);
                const y = centerY + radius * Math.sin(angle);
                points.push({
                    x,
                    y
                });
            }
            return points;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(generateCirclePoints3, "generateCirclePoints");
        async function curlyBraceRight(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox, label } = await labelHelper(parent, node, getNodeClasses(node));
            const w = bbox.width + (node.padding ?? 0);
            const h = bbox.height + (node.padding ?? 0);
            const radius = Math.max(5, 0.1 * h);
            const { cssStyles } = node;
            const points = [
                ...generateCirclePoints3(w / 2, -h / 2, radius, 20, -90, 0),
                {
                    x: w / 2 + radius,
                    y: -radius
                },
                ...generateCirclePoints3(w / 2 + 2 * radius, -radius, radius, 20, -180, -270),
                ...generateCirclePoints3(w / 2 + 2 * radius, radius, radius, 20, -90, -180),
                {
                    x: w / 2 + radius,
                    y: h / 2
                },
                ...generateCirclePoints3(w / 2, h / 2, radius, 20, 0, 90)
            ];
            const rectPoints = [
                {
                    x: -w / 2,
                    y: -h / 2 - radius
                },
                {
                    x: w / 2,
                    y: -h / 2 - radius
                },
                ...generateCirclePoints3(w / 2, -h / 2, radius, 20, -90, 0),
                {
                    x: w / 2 + radius,
                    y: -radius
                },
                ...generateCirclePoints3(w / 2 + 2 * radius, -radius, radius, 20, -180, -270),
                ...generateCirclePoints3(w / 2 + 2 * radius, radius, radius, 20, -90, -180),
                {
                    x: w / 2 + radius,
                    y: h / 2
                },
                ...generateCirclePoints3(w / 2, h / 2, radius, 20, 0, 90),
                {
                    x: w / 2,
                    y: h / 2 + radius
                },
                {
                    x: -w / 2,
                    y: h / 2 + radius
                }
            ];
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {
                fill: "none"
            });
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const curlyBraceRightPath = createPathFromPoints(points);
            const newCurlyBracePath = curlyBraceRightPath.replace("Z", "");
            const curlyBraceRightNode = rc.path(newCurlyBracePath, options);
            const rectPath = createPathFromPoints(rectPoints);
            const rectShape = rc.path(rectPath, {
                ...options
            });
            const curlyBraceRightShape = shapeSvg.insert("g", ":first-child");
            curlyBraceRightShape.insert(()=>rectShape, ":first-child").attr("stroke-opacity", 0);
            curlyBraceRightShape.insert(()=>curlyBraceRightNode, ":first-child");
            curlyBraceRightShape.attr("class", "text");
            if (cssStyles && "handDrawn" !== node.look) curlyBraceRightShape.selectAll("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) curlyBraceRightShape.selectAll("path").attr("style", nodeStyles);
            curlyBraceRightShape.attr("transform", `translate(${-radius}, 0)`);
            label.attr("transform", `translate(${-w / 2 + (node.padding ?? 0) / 2 - (bbox.x - (bbox.left ?? 0))},${-h / 2 + (node.padding ?? 0) / 2 - (bbox.y - (bbox.top ?? 0))})`);
            updateNodeBounds(node, curlyBraceRightShape);
            node.intersect = function(point) {
                const pos = intersect_default.polygon(node, rectPoints, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(curlyBraceRight, "curlyBraceRight");
        function generateCirclePoints4(centerX, centerY, radius, numPoints = 100, startAngle = 0, endAngle = 180) {
            const points = [];
            const startAngleRad = startAngle * Math.PI / 180;
            const endAngleRad = endAngle * Math.PI / 180;
            const angleRange = endAngleRad - startAngleRad;
            const angleStep = angleRange / (numPoints - 1);
            for(let i = 0; i < numPoints; i++){
                const angle = startAngleRad + i * angleStep;
                const x = centerX + radius * Math.cos(angle);
                const y = centerY + radius * Math.sin(angle);
                points.push({
                    x: -x,
                    y: -y
                });
            }
            return points;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(generateCirclePoints4, "generateCirclePoints");
        async function curlyBraces(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox, label } = await labelHelper(parent, node, getNodeClasses(node));
            const w = bbox.width + (node.padding ?? 0);
            const h = bbox.height + (node.padding ?? 0);
            const radius = Math.max(5, 0.1 * h);
            const { cssStyles } = node;
            const leftCurlyBracePoints = [
                ...generateCirclePoints4(w / 2, -h / 2, radius, 30, -90, 0),
                {
                    x: -w / 2 - radius,
                    y: radius
                },
                ...generateCirclePoints4(w / 2 + 2 * radius, -radius, radius, 20, -180, -270),
                ...generateCirclePoints4(w / 2 + 2 * radius, radius, radius, 20, -90, -180),
                {
                    x: -w / 2 - radius,
                    y: -h / 2
                },
                ...generateCirclePoints4(w / 2, h / 2, radius, 20, 0, 90)
            ];
            const rightCurlyBracePoints = [
                ...generateCirclePoints4(-w / 2 + radius + radius / 2, -h / 2, radius, 20, -90, -180),
                {
                    x: w / 2 - radius / 2,
                    y: radius
                },
                ...generateCirclePoints4(-w / 2 - radius / 2, -radius, radius, 20, 0, 90),
                ...generateCirclePoints4(-w / 2 - radius / 2, radius, radius, 20, -90, 0),
                {
                    x: w / 2 - radius / 2,
                    y: -radius
                },
                ...generateCirclePoints4(-w / 2 + radius + radius / 2, h / 2, radius, 30, -180, -270)
            ];
            const rectPoints = [
                {
                    x: w / 2,
                    y: -h / 2 - radius
                },
                {
                    x: -w / 2,
                    y: -h / 2 - radius
                },
                ...generateCirclePoints4(w / 2, -h / 2, radius, 20, -90, 0),
                {
                    x: -w / 2 - radius,
                    y: -radius
                },
                ...generateCirclePoints4(w / 2 + 2 * radius, -radius, radius, 20, -180, -270),
                ...generateCirclePoints4(w / 2 + 2 * radius, radius, radius, 20, -90, -180),
                {
                    x: -w / 2 - radius,
                    y: h / 2
                },
                ...generateCirclePoints4(w / 2, h / 2, radius, 20, 0, 90),
                {
                    x: -w / 2,
                    y: h / 2 + radius
                },
                {
                    x: w / 2 - radius - radius / 2,
                    y: h / 2 + radius
                },
                ...generateCirclePoints4(-w / 2 + radius + radius / 2, -h / 2, radius, 20, -90, -180),
                {
                    x: w / 2 - radius / 2,
                    y: radius
                },
                ...generateCirclePoints4(-w / 2 - radius / 2, -radius, radius, 20, 0, 90),
                ...generateCirclePoints4(-w / 2 - radius / 2, radius, radius, 20, -90, 0),
                {
                    x: w / 2 - radius / 2,
                    y: -radius
                },
                ...generateCirclePoints4(-w / 2 + radius + radius / 2, h / 2, radius, 30, -180, -270)
            ];
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {
                fill: "none"
            });
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const leftCurlyBracePath = createPathFromPoints(leftCurlyBracePoints);
            const newLeftCurlyBracePath = leftCurlyBracePath.replace("Z", "");
            const leftCurlyBraceNode = rc.path(newLeftCurlyBracePath, options);
            const rightCurlyBracePath = createPathFromPoints(rightCurlyBracePoints);
            const newRightCurlyBracePath = rightCurlyBracePath.replace("Z", "");
            const rightCurlyBraceNode = rc.path(newRightCurlyBracePath, options);
            const rectPath = createPathFromPoints(rectPoints);
            const rectShape = rc.path(rectPath, {
                ...options
            });
            const curlyBracesShape = shapeSvg.insert("g", ":first-child");
            curlyBracesShape.insert(()=>rectShape, ":first-child").attr("stroke-opacity", 0);
            curlyBracesShape.insert(()=>leftCurlyBraceNode, ":first-child");
            curlyBracesShape.insert(()=>rightCurlyBraceNode, ":first-child");
            curlyBracesShape.attr("class", "text");
            if (cssStyles && "handDrawn" !== node.look) curlyBracesShape.selectAll("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) curlyBracesShape.selectAll("path").attr("style", nodeStyles);
            curlyBracesShape.attr("transform", `translate(${radius - radius / 4}, 0)`);
            label.attr("transform", `translate(${-w / 2 + (node.padding ?? 0) / 2 - (bbox.x - (bbox.left ?? 0))},${-h / 2 + (node.padding ?? 0) / 2 - (bbox.y - (bbox.top ?? 0))})`);
            updateNodeBounds(node, curlyBracesShape);
            node.intersect = function(point) {
                const pos = intersect_default.polygon(node, rectPoints, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(curlyBraces, "curlyBraces");
        async function curvedTrapezoid(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox } = await labelHelper(parent, node, getNodeClasses(node));
            const minWidth = 80, minHeight = 20;
            const w = Math.max(minWidth, (bbox.width + (node.padding ?? 0) * 2) * 1.25, node?.width ?? 0);
            const h = Math.max(minHeight, bbox.height + (node.padding ?? 0) * 2, node?.height ?? 0);
            const radius = h / 2;
            const { cssStyles } = node;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const totalWidth = w, totalHeight = h;
            const rw = totalWidth - radius;
            const tw = totalHeight / 4;
            const points = [
                {
                    x: rw,
                    y: 0
                },
                {
                    x: tw,
                    y: 0
                },
                {
                    x: 0,
                    y: totalHeight / 2
                },
                {
                    x: tw,
                    y: totalHeight
                },
                {
                    x: rw,
                    y: totalHeight
                },
                ...generateCirclePoints(-rw, -totalHeight / 2, radius, 50, 270, 90)
            ];
            const pathData = createPathFromPoints(points);
            const shapeNode = rc.path(pathData, options);
            const polygon = shapeSvg.insert(()=>shapeNode, ":first-child");
            polygon.attr("class", "basic label-container");
            if (cssStyles && "handDrawn" !== node.look) polygon.selectChildren("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) polygon.selectChildren("path").attr("style", nodeStyles);
            polygon.attr("transform", `translate(${-w / 2}, ${-h / 2})`);
            updateNodeBounds(node, polygon);
            node.intersect = function(point) {
                const pos = intersect_default.polygon(node, points, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(curvedTrapezoid, "curvedTrapezoid");
        var createCylinderPathD = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((x, y, width, height, rx, ry)=>[
                `M${x},${y + ry}`,
                `a${rx},${ry} 0,0,0 ${width},0`,
                `a${rx},${ry} 0,0,0 ${-width},0`,
                `l0,${height}`,
                `a${rx},${ry} 0,0,0 ${width},0`,
                `l0,${-height}`
            ].join(" "), "createCylinderPathD");
        var createOuterCylinderPathD = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((x, y, width, height, rx, ry)=>[
                `M${x},${y + ry}`,
                `M${x + width},${y + ry}`,
                `a${rx},${ry} 0,0,0 ${-width},0`,
                `l0,${height}`,
                `a${rx},${ry} 0,0,0 ${width},0`,
                `l0,${-height}`
            ].join(" "), "createOuterCylinderPathD");
        var createInnerCylinderPathD = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((x, y, width, height, rx, ry)=>[
                `M${x - width / 2},${-height / 2}`,
                `a${rx},${ry} 0,0,0 ${width},0`
            ].join(" "), "createInnerCylinderPathD");
        async function cylinder(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox, label } = await labelHelper(parent, node, getNodeClasses(node));
            const w = Math.max(bbox.width + node.padding, node.width ?? 0);
            const rx = w / 2;
            const ry = rx / (2.5 + w / 50);
            const h = Math.max(bbox.height + ry + node.padding, node.height ?? 0);
            let cylinder2;
            const { cssStyles } = node;
            if ("handDrawn" === node.look) {
                const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
                const outerPathData = createOuterCylinderPathD(0, 0, w, h, rx, ry);
                const innerPathData = createInnerCylinderPathD(0, ry, w, h, rx, ry);
                const outerNode = rc.path(outerPathData, userNodeOverrides(node, {}));
                const innerLine = rc.path(innerPathData, userNodeOverrides(node, {
                    fill: "none"
                }));
                cylinder2 = shapeSvg.insert(()=>innerLine, ":first-child");
                cylinder2 = shapeSvg.insert(()=>outerNode, ":first-child");
                cylinder2.attr("class", "basic label-container");
                if (cssStyles) cylinder2.attr("style", cssStyles);
            } else {
                const pathData = createCylinderPathD(0, 0, w, h, rx, ry);
                cylinder2 = shapeSvg.insert("path", ":first-child").attr("d", pathData).attr("class", "basic label-container").attr("style", (0, _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_3__.R7)(cssStyles)).attr("style", nodeStyles);
            }
            cylinder2.attr("label-offset-y", ry);
            cylinder2.attr("transform", `translate(${-w / 2}, ${-(h / 2 + ry)})`);
            updateNodeBounds(node, cylinder2);
            label.attr("transform", `translate(${-(bbox.width / 2) - (bbox.x - (bbox.left ?? 0))}, ${-(bbox.height / 2) + (node.padding ?? 0) / 1.5 - (bbox.y - (bbox.top ?? 0))})`);
            node.intersect = function(point) {
                const pos = intersect_default.rect(node, point);
                const x = pos.x - (node.x ?? 0);
                if (0 != rx && (Math.abs(x) < (node.width ?? 0) / 2 || Math.abs(x) == (node.width ?? 0) / 2 && Math.abs(pos.y - (node.y ?? 0)) > (node.height ?? 0) / 2 - ry)) {
                    let y = ry * ry * (1 - x * x / (rx * rx));
                    if (y > 0) y = Math.sqrt(y);
                    y = ry - y;
                    if (point.y - (node.y ?? 0) > 0) y = -y;
                    pos.y += y;
                }
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(cylinder, "cylinder");
        async function dividedRectangle(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox, label } = await labelHelper(parent, node, getNodeClasses(node));
            const w = bbox.width + node.padding;
            const h = bbox.height + node.padding;
            const rectOffset = 0.2 * h;
            const x = -w / 2;
            const y = -h / 2 - rectOffset / 2;
            const { cssStyles } = node;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const pts = [
                {
                    x,
                    y: y + rectOffset
                },
                {
                    x: -x,
                    y: y + rectOffset
                },
                {
                    x: -x,
                    y: -y
                },
                {
                    x,
                    y: -y
                },
                {
                    x,
                    y
                },
                {
                    x: -x,
                    y
                },
                {
                    x: -x,
                    y: y + rectOffset
                }
            ];
            const poly = rc.polygon(pts.map((p)=>[
                    p.x,
                    p.y
                ]), options);
            const polygon = shapeSvg.insert(()=>poly, ":first-child");
            polygon.attr("class", "basic label-container");
            if (cssStyles && "handDrawn" !== node.look) polygon.selectAll("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) polygon.selectAll("path").attr("style", nodeStyles);
            label.attr("transform", `translate(${x + (node.padding ?? 0) / 2 - (bbox.x - (bbox.left ?? 0))}, ${y + rectOffset + (node.padding ?? 0) / 2 - (bbox.y - (bbox.top ?? 0))})`);
            updateNodeBounds(node, polygon);
            node.intersect = function(point) {
                const pos = intersect_default.rect(node, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(dividedRectangle, "dividedRectangle");
        async function doublecircle(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox, halfPadding } = await labelHelper(parent, node, getNodeClasses(node));
            const gap = 5;
            const outerRadius = bbox.width / 2 + halfPadding + gap;
            const innerRadius = bbox.width / 2 + halfPadding;
            let circleGroup;
            const { cssStyles } = node;
            if ("handDrawn" === node.look) {
                const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
                const outerOptions = userNodeOverrides(node, {
                    roughness: 0.2,
                    strokeWidth: 2.5
                });
                const innerOptions = userNodeOverrides(node, {
                    roughness: 0.2,
                    strokeWidth: 1.5
                });
                const outerRoughNode = rc.circle(0, 0, 2 * outerRadius, outerOptions);
                const innerRoughNode = rc.circle(0, 0, 2 * innerRadius, innerOptions);
                circleGroup = shapeSvg.insert("g", ":first-child");
                circleGroup.attr("class", (0, _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_3__.R7)(node.cssClasses)).attr("style", (0, _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_3__.R7)(cssStyles));
                circleGroup.node()?.appendChild(outerRoughNode);
                circleGroup.node()?.appendChild(innerRoughNode);
            } else {
                circleGroup = shapeSvg.insert("g", ":first-child");
                const outerCircle = circleGroup.insert("circle", ":first-child");
                const innerCircle = circleGroup.insert("circle");
                circleGroup.attr("class", "basic label-container").attr("style", nodeStyles);
                outerCircle.attr("class", "outer-circle").attr("style", nodeStyles).attr("r", outerRadius).attr("cx", 0).attr("cy", 0);
                innerCircle.attr("class", "inner-circle").attr("style", nodeStyles).attr("r", innerRadius).attr("cx", 0).attr("cy", 0);
            }
            updateNodeBounds(node, circleGroup);
            node.intersect = function(point) {
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.info("DoubleCircle intersect", node, outerRadius, point);
                return intersect_default.circle(node, outerRadius, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(doublecircle, "doublecircle");
        function filledCircle(parent, node, { config: { themeVariables } }) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.label = "";
            node.labelStyle = labelStyles;
            const shapeSvg = parent.insert("g").attr("class", getNodeClasses(node)).attr("id", node.domId ?? node.id);
            const radius = 7;
            const { cssStyles } = node;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const { nodeBorder } = themeVariables;
            const options = userNodeOverrides(node, {
                fillStyle: "solid"
            });
            if ("handDrawn" !== node.look) options.roughness = 0;
            const circleNode = rc.circle(0, 0, 2 * radius, options);
            const filledCircle2 = shapeSvg.insert(()=>circleNode, ":first-child");
            filledCircle2.selectAll("path").attr("style", `fill: ${nodeBorder} !important;`);
            if (cssStyles && cssStyles.length > 0 && "handDrawn" !== node.look) filledCircle2.selectAll("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) filledCircle2.selectAll("path").attr("style", nodeStyles);
            updateNodeBounds(node, filledCircle2);
            node.intersect = function(point) {
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.info("filledCircle intersect", node, {
                    radius,
                    point
                });
                const pos = intersect_default.circle(node, radius, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(filledCircle, "filledCircle");
        async function flippedTriangle(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox, label } = await labelHelper(parent, node, getNodeClasses(node));
            const w = bbox.width + (node.padding ?? 0);
            const h = w + bbox.height;
            const tw = w + bbox.height;
            const points = [
                {
                    x: 0,
                    y: -h
                },
                {
                    x: tw,
                    y: -h
                },
                {
                    x: tw / 2,
                    y: 0
                }
            ];
            const { cssStyles } = node;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const pathData = createPathFromPoints(points);
            const roughNode = rc.path(pathData, options);
            const flippedTriangle2 = shapeSvg.insert(()=>roughNode, ":first-child").attr("transform", `translate(${-h / 2}, ${h / 2})`);
            if (cssStyles && "handDrawn" !== node.look) flippedTriangle2.selectChildren("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) flippedTriangle2.selectChildren("path").attr("style", nodeStyles);
            node.width = w;
            node.height = h;
            updateNodeBounds(node, flippedTriangle2);
            label.attr("transform", `translate(${-bbox.width / 2 - (bbox.x - (bbox.left ?? 0))}, ${-h / 2 + (node.padding ?? 0) / 2 + (bbox.y - (bbox.top ?? 0))})`);
            node.intersect = function(point) {
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.info("Triangle intersect", node, points, point);
                return intersect_default.polygon(node, points, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(flippedTriangle, "flippedTriangle");
        function forkJoin(parent, node, { dir, config: { state: state2, themeVariables } }) {
            const { nodeStyles } = styles2String(node);
            node.label = "";
            const shapeSvg = parent.insert("g").attr("class", getNodeClasses(node)).attr("id", node.domId ?? node.id);
            const { cssStyles } = node;
            let width = Math.max(70, node?.width ?? 0);
            let height = Math.max(10, node?.height ?? 0);
            if ("LR" === dir) {
                width = Math.max(10, node?.width ?? 0);
                height = Math.max(70, node?.height ?? 0);
            }
            const x = -1 * width / 2;
            const y = -1 * height / 2;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {
                stroke: themeVariables.lineColor,
                fill: themeVariables.lineColor
            });
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const roughNode = rc.rectangle(x, y, width, height, options);
            const shape = shapeSvg.insert(()=>roughNode, ":first-child");
            if (cssStyles && "handDrawn" !== node.look) shape.selectAll("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) shape.selectAll("path").attr("style", nodeStyles);
            updateNodeBounds(node, shape);
            const padding = state2?.padding ?? 0;
            if (node.width && node.height) {
                node.width += padding / 2 || 0;
                node.height += padding / 2 || 0;
            }
            node.intersect = function(point) {
                return intersect_default.rect(node, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(forkJoin, "forkJoin");
        async function halfRoundedRectangle(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const minWidth = 80, minHeight = 50;
            const { shapeSvg, bbox } = await labelHelper(parent, node, getNodeClasses(node));
            const w = Math.max(minWidth, bbox.width + (node.padding ?? 0) * 2, node?.width ?? 0);
            const h = Math.max(minHeight, bbox.height + (node.padding ?? 0) * 2, node?.height ?? 0);
            const radius = h / 2;
            const { cssStyles } = node;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const points = [
                {
                    x: -w / 2,
                    y: -h / 2
                },
                {
                    x: w / 2 - radius,
                    y: -h / 2
                },
                ...generateCirclePoints(-w / 2 + radius, 0, radius, 50, 90, 270),
                {
                    x: w / 2 - radius,
                    y: h / 2
                },
                {
                    x: -w / 2,
                    y: h / 2
                }
            ];
            const pathData = createPathFromPoints(points);
            const shapeNode = rc.path(pathData, options);
            const polygon = shapeSvg.insert(()=>shapeNode, ":first-child");
            polygon.attr("class", "basic label-container");
            if (cssStyles && "handDrawn" !== node.look) polygon.selectChildren("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) polygon.selectChildren("path").attr("style", nodeStyles);
            updateNodeBounds(node, polygon);
            node.intersect = function(point) {
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.info("Pill intersect", node, {
                    radius,
                    point
                });
                const pos = intersect_default.polygon(node, points, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(halfRoundedRectangle, "halfRoundedRectangle");
        var createHexagonPathD = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((x, y, width, height, m)=>[
                `M${x + m},${y}`,
                `L${x + width - m},${y}`,
                `L${x + width},${y - height / 2}`,
                `L${x + width - m},${y - height}`,
                `L${x + m},${y - height}`,
                `L${x},${y - height / 2}`,
                "Z"
            ].join(" "), "createHexagonPathD");
        async function hexagon(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox } = await labelHelper(parent, node, getNodeClasses(node));
            const f = 4;
            const h = bbox.height + node.padding;
            const m = h / f;
            const w = bbox.width + 2 * m + node.padding;
            const points = [
                {
                    x: m,
                    y: 0
                },
                {
                    x: w - m,
                    y: 0
                },
                {
                    x: w,
                    y: -h / 2
                },
                {
                    x: w - m,
                    y: -h
                },
                {
                    x: m,
                    y: -h
                },
                {
                    x: 0,
                    y: -h / 2
                }
            ];
            let polygon;
            const { cssStyles } = node;
            if ("handDrawn" === node.look) {
                const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
                const options = userNodeOverrides(node, {});
                const pathData = createHexagonPathD(0, 0, w, h, m);
                const roughNode = rc.path(pathData, options);
                polygon = shapeSvg.insert(()=>roughNode, ":first-child").attr("transform", `translate(${-w / 2}, ${h / 2})`);
                if (cssStyles) polygon.attr("style", cssStyles);
            } else polygon = insertPolygonShape(shapeSvg, w, h, points);
            if (nodeStyles) polygon.attr("style", nodeStyles);
            node.width = w;
            node.height = h;
            updateNodeBounds(node, polygon);
            node.intersect = function(point) {
                return intersect_default.polygon(node, points, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(hexagon, "hexagon");
        async function hourglass(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.label = "";
            node.labelStyle = labelStyles;
            const { shapeSvg } = await labelHelper(parent, node, getNodeClasses(node));
            const w = Math.max(30, node?.width ?? 0);
            const h = Math.max(30, node?.height ?? 0);
            const { cssStyles } = node;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const points = [
                {
                    x: 0,
                    y: 0
                },
                {
                    x: w,
                    y: 0
                },
                {
                    x: 0,
                    y: h
                },
                {
                    x: w,
                    y: h
                }
            ];
            const pathData = createPathFromPoints(points);
            const shapeNode = rc.path(pathData, options);
            const polygon = shapeSvg.insert(()=>shapeNode, ":first-child");
            polygon.attr("class", "basic label-container");
            if (cssStyles && "handDrawn" !== node.look) polygon.selectChildren("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) polygon.selectChildren("path").attr("style", nodeStyles);
            polygon.attr("transform", `translate(${-w / 2}, ${-h / 2})`);
            updateNodeBounds(node, polygon);
            node.intersect = function(point) {
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.info("Pill intersect", node, {
                    points
                });
                const pos = intersect_default.polygon(node, points, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(hourglass, "hourglass");
        async function icon(parent, node, { config: { themeVariables, flowchart } }) {
            const { labelStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const assetHeight = node.assetHeight ?? 48;
            const assetWidth = node.assetWidth ?? 48;
            const iconSize = Math.max(assetHeight, assetWidth);
            const defaultWidth = flowchart?.wrappingWidth;
            node.width = Math.max(iconSize, defaultWidth ?? 0);
            const { shapeSvg, bbox, label } = await labelHelper(parent, node, "icon-shape default");
            const topLabel = "t" === node.pos;
            const height = iconSize;
            const width = iconSize;
            const { nodeBorder } = themeVariables;
            const { stylesMap } = compileStyles(node);
            const x = -width / 2;
            const y = -height / 2;
            const labelPadding = node.label ? 8 : 0;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {
                stroke: "none",
                fill: "none"
            });
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const iconNode = rc.rectangle(x, y, width, height, options);
            const outerWidth = Math.max(width, bbox.width);
            const outerHeight = height + bbox.height + labelPadding;
            const outerNode = rc.rectangle(-outerWidth / 2, -outerHeight / 2, outerWidth, outerHeight, {
                ...options,
                fill: "transparent",
                stroke: "none"
            });
            const iconShape = shapeSvg.insert(()=>iconNode, ":first-child");
            const outerShape = shapeSvg.insert(()=>outerNode);
            if (node.icon) {
                const iconElem = shapeSvg.append("g");
                iconElem.html(`<g>${await (0, _chunk_OPO4IU42_mjs__WEBPACK_IMPORTED_MODULE_0__.s4)(node.icon, {
                    height: iconSize,
                    width: iconSize,
                    fallbackPrefix: ""
                })}</g>`);
                const iconBBox = iconElem.node().getBBox();
                const iconWidth = iconBBox.width;
                const iconHeight = iconBBox.height;
                const iconX = iconBBox.x;
                const iconY = iconBBox.y;
                iconElem.attr("transform", `translate(${-iconWidth / 2 - iconX},${topLabel ? bbox.height / 2 + labelPadding / 2 - iconHeight / 2 - iconY : -bbox.height / 2 - labelPadding / 2 - iconHeight / 2 - iconY})`);
                iconElem.attr("style", `color: ${stylesMap.get("stroke") ?? nodeBorder};`);
            }
            label.attr("transform", `translate(${-bbox.width / 2 - (bbox.x - (bbox.left ?? 0))},${topLabel ? -outerHeight / 2 : outerHeight / 2 - bbox.height})`);
            iconShape.attr("transform", `translate(0,${topLabel ? bbox.height / 2 + labelPadding / 2 : -bbox.height / 2 - labelPadding / 2})`);
            updateNodeBounds(node, outerShape);
            node.intersect = function(point) {
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.info("iconSquare intersect", node, point);
                if (!node.label) return intersect_default.rect(node, point);
                const dx = node.x ?? 0;
                const dy = node.y ?? 0;
                const nodeHeight = node.height ?? 0;
                let points = [];
                points = topLabel ? [
                    {
                        x: dx - bbox.width / 2,
                        y: dy - nodeHeight / 2
                    },
                    {
                        x: dx + bbox.width / 2,
                        y: dy - nodeHeight / 2
                    },
                    {
                        x: dx + bbox.width / 2,
                        y: dy - nodeHeight / 2 + bbox.height + labelPadding
                    },
                    {
                        x: dx + width / 2,
                        y: dy - nodeHeight / 2 + bbox.height + labelPadding
                    },
                    {
                        x: dx + width / 2,
                        y: dy + nodeHeight / 2
                    },
                    {
                        x: dx - width / 2,
                        y: dy + nodeHeight / 2
                    },
                    {
                        x: dx - width / 2,
                        y: dy - nodeHeight / 2 + bbox.height + labelPadding
                    },
                    {
                        x: dx - bbox.width / 2,
                        y: dy - nodeHeight / 2 + bbox.height + labelPadding
                    }
                ] : [
                    {
                        x: dx - width / 2,
                        y: dy - nodeHeight / 2
                    },
                    {
                        x: dx + width / 2,
                        y: dy - nodeHeight / 2
                    },
                    {
                        x: dx + width / 2,
                        y: dy - nodeHeight / 2 + height
                    },
                    {
                        x: dx + bbox.width / 2,
                        y: dy - nodeHeight / 2 + height
                    },
                    {
                        x: dx + bbox.width / 2 / 2,
                        y: dy + nodeHeight / 2
                    },
                    {
                        x: dx - bbox.width / 2,
                        y: dy + nodeHeight / 2
                    },
                    {
                        x: dx - bbox.width / 2,
                        y: dy - nodeHeight / 2 + height
                    },
                    {
                        x: dx - width / 2,
                        y: dy - nodeHeight / 2 + height
                    }
                ];
                const pos = intersect_default.polygon(node, points, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(icon, "icon");
        async function iconCircle(parent, node, { config: { themeVariables, flowchart } }) {
            const { labelStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const assetHeight = node.assetHeight ?? 48;
            const assetWidth = node.assetWidth ?? 48;
            const iconSize = Math.max(assetHeight, assetWidth);
            const defaultWidth = flowchart?.wrappingWidth;
            node.width = Math.max(iconSize, defaultWidth ?? 0);
            const { shapeSvg, bbox, label } = await labelHelper(parent, node, "icon-shape default");
            const padding = 20;
            const labelPadding = node.label ? 8 : 0;
            const topLabel = "t" === node.pos;
            const { nodeBorder, mainBkg } = themeVariables;
            const { stylesMap } = compileStyles(node);
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const fill = stylesMap.get("fill");
            options.stroke = fill ?? mainBkg;
            const iconElem = shapeSvg.append("g");
            if (node.icon) iconElem.html(`<g>${await (0, _chunk_OPO4IU42_mjs__WEBPACK_IMPORTED_MODULE_0__.s4)(node.icon, {
                height: iconSize,
                width: iconSize,
                fallbackPrefix: ""
            })}</g>`);
            const iconBBox = iconElem.node().getBBox();
            const iconWidth = iconBBox.width;
            const iconHeight = iconBBox.height;
            const iconX = iconBBox.x;
            const iconY = iconBBox.y;
            const diameter = Math.max(iconWidth, iconHeight) * Math.SQRT2 + 2 * padding;
            const iconNode = rc.circle(0, 0, diameter, options);
            const outerWidth = Math.max(diameter, bbox.width);
            const outerHeight = diameter + bbox.height + labelPadding;
            const outerNode = rc.rectangle(-outerWidth / 2, -outerHeight / 2, outerWidth, outerHeight, {
                ...options,
                fill: "transparent",
                stroke: "none"
            });
            const iconShape = shapeSvg.insert(()=>iconNode, ":first-child");
            const outerShape = shapeSvg.insert(()=>outerNode);
            iconElem.attr("transform", `translate(${-iconWidth / 2 - iconX},${topLabel ? bbox.height / 2 + labelPadding / 2 - iconHeight / 2 - iconY : -bbox.height / 2 - labelPadding / 2 - iconHeight / 2 - iconY})`);
            iconElem.attr("style", `color: ${stylesMap.get("stroke") ?? nodeBorder};`);
            label.attr("transform", `translate(${-bbox.width / 2 - (bbox.x - (bbox.left ?? 0))},${topLabel ? -outerHeight / 2 : outerHeight / 2 - bbox.height})`);
            iconShape.attr("transform", `translate(0,${topLabel ? bbox.height / 2 + labelPadding / 2 : -bbox.height / 2 - labelPadding / 2})`);
            updateNodeBounds(node, outerShape);
            node.intersect = function(point) {
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.info("iconSquare intersect", node, point);
                const pos = intersect_default.rect(node, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(iconCircle, "iconCircle");
        async function iconRounded(parent, node, { config: { themeVariables, flowchart } }) {
            const { labelStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const assetHeight = node.assetHeight ?? 48;
            const assetWidth = node.assetWidth ?? 48;
            const iconSize = Math.max(assetHeight, assetWidth);
            const defaultWidth = flowchart?.wrappingWidth;
            node.width = Math.max(iconSize, defaultWidth ?? 0);
            const { shapeSvg, bbox, halfPadding, label } = await labelHelper(parent, node, "icon-shape default");
            const topLabel = "t" === node.pos;
            const height = iconSize + 2 * halfPadding;
            const width = iconSize + 2 * halfPadding;
            const { nodeBorder, mainBkg } = themeVariables;
            const { stylesMap } = compileStyles(node);
            const x = -width / 2;
            const y = -height / 2;
            const labelPadding = node.label ? 8 : 0;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const fill = stylesMap.get("fill");
            options.stroke = fill ?? mainBkg;
            const iconNode = rc.path(createRoundedRectPathD(x, y, width, height, 5), options);
            const outerWidth = Math.max(width, bbox.width);
            const outerHeight = height + bbox.height + labelPadding;
            const outerNode = rc.rectangle(-outerWidth / 2, -outerHeight / 2, outerWidth, outerHeight, {
                ...options,
                fill: "transparent",
                stroke: "none"
            });
            const iconShape = shapeSvg.insert(()=>iconNode, ":first-child").attr("class", "icon-shape2");
            const outerShape = shapeSvg.insert(()=>outerNode);
            if (node.icon) {
                const iconElem = shapeSvg.append("g");
                iconElem.html(`<g>${await (0, _chunk_OPO4IU42_mjs__WEBPACK_IMPORTED_MODULE_0__.s4)(node.icon, {
                    height: iconSize,
                    width: iconSize,
                    fallbackPrefix: ""
                })}</g>`);
                const iconBBox = iconElem.node().getBBox();
                const iconWidth = iconBBox.width;
                const iconHeight = iconBBox.height;
                const iconX = iconBBox.x;
                const iconY = iconBBox.y;
                iconElem.attr("transform", `translate(${-iconWidth / 2 - iconX},${topLabel ? bbox.height / 2 + labelPadding / 2 - iconHeight / 2 - iconY : -bbox.height / 2 - labelPadding / 2 - iconHeight / 2 - iconY})`);
                iconElem.attr("style", `color: ${stylesMap.get("stroke") ?? nodeBorder};`);
            }
            label.attr("transform", `translate(${-bbox.width / 2 - (bbox.x - (bbox.left ?? 0))},${topLabel ? -outerHeight / 2 : outerHeight / 2 - bbox.height})`);
            iconShape.attr("transform", `translate(0,${topLabel ? bbox.height / 2 + labelPadding / 2 : -bbox.height / 2 - labelPadding / 2})`);
            updateNodeBounds(node, outerShape);
            node.intersect = function(point) {
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.info("iconSquare intersect", node, point);
                if (!node.label) return intersect_default.rect(node, point);
                const dx = node.x ?? 0;
                const dy = node.y ?? 0;
                const nodeHeight = node.height ?? 0;
                let points = [];
                points = topLabel ? [
                    {
                        x: dx - bbox.width / 2,
                        y: dy - nodeHeight / 2
                    },
                    {
                        x: dx + bbox.width / 2,
                        y: dy - nodeHeight / 2
                    },
                    {
                        x: dx + bbox.width / 2,
                        y: dy - nodeHeight / 2 + bbox.height + labelPadding
                    },
                    {
                        x: dx + width / 2,
                        y: dy - nodeHeight / 2 + bbox.height + labelPadding
                    },
                    {
                        x: dx + width / 2,
                        y: dy + nodeHeight / 2
                    },
                    {
                        x: dx - width / 2,
                        y: dy + nodeHeight / 2
                    },
                    {
                        x: dx - width / 2,
                        y: dy - nodeHeight / 2 + bbox.height + labelPadding
                    },
                    {
                        x: dx - bbox.width / 2,
                        y: dy - nodeHeight / 2 + bbox.height + labelPadding
                    }
                ] : [
                    {
                        x: dx - width / 2,
                        y: dy - nodeHeight / 2
                    },
                    {
                        x: dx + width / 2,
                        y: dy - nodeHeight / 2
                    },
                    {
                        x: dx + width / 2,
                        y: dy - nodeHeight / 2 + height
                    },
                    {
                        x: dx + bbox.width / 2,
                        y: dy - nodeHeight / 2 + height
                    },
                    {
                        x: dx + bbox.width / 2 / 2,
                        y: dy + nodeHeight / 2
                    },
                    {
                        x: dx - bbox.width / 2,
                        y: dy + nodeHeight / 2
                    },
                    {
                        x: dx - bbox.width / 2,
                        y: dy - nodeHeight / 2 + height
                    },
                    {
                        x: dx - width / 2,
                        y: dy - nodeHeight / 2 + height
                    }
                ];
                const pos = intersect_default.polygon(node, points, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(iconRounded, "iconRounded");
        async function iconSquare(parent, node, { config: { themeVariables, flowchart } }) {
            const { labelStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const assetHeight = node.assetHeight ?? 48;
            const assetWidth = node.assetWidth ?? 48;
            const iconSize = Math.max(assetHeight, assetWidth);
            const defaultWidth = flowchart?.wrappingWidth;
            node.width = Math.max(iconSize, defaultWidth ?? 0);
            const { shapeSvg, bbox, halfPadding, label } = await labelHelper(parent, node, "icon-shape default");
            const topLabel = "t" === node.pos;
            const height = iconSize + 2 * halfPadding;
            const width = iconSize + 2 * halfPadding;
            const { nodeBorder, mainBkg } = themeVariables;
            const { stylesMap } = compileStyles(node);
            const x = -width / 2;
            const y = -height / 2;
            const labelPadding = node.label ? 8 : 0;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const fill = stylesMap.get("fill");
            options.stroke = fill ?? mainBkg;
            const iconNode = rc.path(createRoundedRectPathD(x, y, width, height, 0.1), options);
            const outerWidth = Math.max(width, bbox.width);
            const outerHeight = height + bbox.height + labelPadding;
            const outerNode = rc.rectangle(-outerWidth / 2, -outerHeight / 2, outerWidth, outerHeight, {
                ...options,
                fill: "transparent",
                stroke: "none"
            });
            const iconShape = shapeSvg.insert(()=>iconNode, ":first-child");
            const outerShape = shapeSvg.insert(()=>outerNode);
            if (node.icon) {
                const iconElem = shapeSvg.append("g");
                iconElem.html(`<g>${await (0, _chunk_OPO4IU42_mjs__WEBPACK_IMPORTED_MODULE_0__.s4)(node.icon, {
                    height: iconSize,
                    width: iconSize,
                    fallbackPrefix: ""
                })}</g>`);
                const iconBBox = iconElem.node().getBBox();
                const iconWidth = iconBBox.width;
                const iconHeight = iconBBox.height;
                const iconX = iconBBox.x;
                const iconY = iconBBox.y;
                iconElem.attr("transform", `translate(${-iconWidth / 2 - iconX},${topLabel ? bbox.height / 2 + labelPadding / 2 - iconHeight / 2 - iconY : -bbox.height / 2 - labelPadding / 2 - iconHeight / 2 - iconY})`);
                iconElem.attr("style", `color: ${stylesMap.get("stroke") ?? nodeBorder};`);
            }
            label.attr("transform", `translate(${-bbox.width / 2 - (bbox.x - (bbox.left ?? 0))},${topLabel ? -outerHeight / 2 : outerHeight / 2 - bbox.height})`);
            iconShape.attr("transform", `translate(0,${topLabel ? bbox.height / 2 + labelPadding / 2 : -bbox.height / 2 - labelPadding / 2})`);
            updateNodeBounds(node, outerShape);
            node.intersect = function(point) {
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.info("iconSquare intersect", node, point);
                if (!node.label) return intersect_default.rect(node, point);
                const dx = node.x ?? 0;
                const dy = node.y ?? 0;
                const nodeHeight = node.height ?? 0;
                let points = [];
                points = topLabel ? [
                    {
                        x: dx - bbox.width / 2,
                        y: dy - nodeHeight / 2
                    },
                    {
                        x: dx + bbox.width / 2,
                        y: dy - nodeHeight / 2
                    },
                    {
                        x: dx + bbox.width / 2,
                        y: dy - nodeHeight / 2 + bbox.height + labelPadding
                    },
                    {
                        x: dx + width / 2,
                        y: dy - nodeHeight / 2 + bbox.height + labelPadding
                    },
                    {
                        x: dx + width / 2,
                        y: dy + nodeHeight / 2
                    },
                    {
                        x: dx - width / 2,
                        y: dy + nodeHeight / 2
                    },
                    {
                        x: dx - width / 2,
                        y: dy - nodeHeight / 2 + bbox.height + labelPadding
                    },
                    {
                        x: dx - bbox.width / 2,
                        y: dy - nodeHeight / 2 + bbox.height + labelPadding
                    }
                ] : [
                    {
                        x: dx - width / 2,
                        y: dy - nodeHeight / 2
                    },
                    {
                        x: dx + width / 2,
                        y: dy - nodeHeight / 2
                    },
                    {
                        x: dx + width / 2,
                        y: dy - nodeHeight / 2 + height
                    },
                    {
                        x: dx + bbox.width / 2,
                        y: dy - nodeHeight / 2 + height
                    },
                    {
                        x: dx + bbox.width / 2 / 2,
                        y: dy + nodeHeight / 2
                    },
                    {
                        x: dx - bbox.width / 2,
                        y: dy + nodeHeight / 2
                    },
                    {
                        x: dx - bbox.width / 2,
                        y: dy - nodeHeight / 2 + height
                    },
                    {
                        x: dx - width / 2,
                        y: dy - nodeHeight / 2 + height
                    }
                ];
                const pos = intersect_default.polygon(node, points, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(iconSquare, "iconSquare");
        async function imageSquare(parent, node, { config: { flowchart } }) {
            const img = new Image();
            img.src = node?.img ?? "";
            await img.decode();
            const imageNaturalWidth = Number(img.naturalWidth.toString().replace("px", ""));
            const imageNaturalHeight = Number(img.naturalHeight.toString().replace("px", ""));
            node.imageAspectRatio = imageNaturalWidth / imageNaturalHeight;
            const { labelStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const defaultWidth = flowchart?.wrappingWidth;
            node.defaultWidth = flowchart?.wrappingWidth;
            const imageRawWidth = Math.max(node.label ? defaultWidth ?? 0 : 0, node?.assetWidth ?? imageNaturalWidth);
            const imageWidth = "on" === node.constraint ? node?.assetHeight ? node.assetHeight * node.imageAspectRatio : imageRawWidth : imageRawWidth;
            const imageHeight = "on" === node.constraint ? imageWidth / node.imageAspectRatio : node?.assetHeight ?? imageNaturalHeight;
            node.width = Math.max(imageWidth, defaultWidth ?? 0);
            const { shapeSvg, bbox, label } = await labelHelper(parent, node, "image-shape default");
            const topLabel = "t" === node.pos;
            const x = -imageWidth / 2;
            const y = -imageHeight / 2;
            const labelPadding = node.label ? 8 : 0;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const imageNode = rc.rectangle(x, y, imageWidth, imageHeight, options);
            const outerWidth = Math.max(imageWidth, bbox.width);
            const outerHeight = imageHeight + bbox.height + labelPadding;
            const outerNode = rc.rectangle(-outerWidth / 2, -outerHeight / 2, outerWidth, outerHeight, {
                ...options,
                fill: "none",
                stroke: "none"
            });
            const iconShape = shapeSvg.insert(()=>imageNode, ":first-child");
            const outerShape = shapeSvg.insert(()=>outerNode);
            if (node.img) {
                const image = shapeSvg.append("image");
                image.attr("href", node.img);
                image.attr("width", imageWidth);
                image.attr("height", imageHeight);
                image.attr("preserveAspectRatio", "none");
                image.attr("transform", `translate(${-imageWidth / 2},${topLabel ? outerHeight / 2 - imageHeight : -outerHeight / 2})`);
            }
            label.attr("transform", `translate(${-bbox.width / 2 - (bbox.x - (bbox.left ?? 0))},${topLabel ? -imageHeight / 2 - bbox.height / 2 - labelPadding / 2 : imageHeight / 2 - bbox.height / 2 + labelPadding / 2})`);
            iconShape.attr("transform", `translate(0,${topLabel ? bbox.height / 2 + labelPadding / 2 : -bbox.height / 2 - labelPadding / 2})`);
            updateNodeBounds(node, outerShape);
            node.intersect = function(point) {
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.info("iconSquare intersect", node, point);
                if (!node.label) return intersect_default.rect(node, point);
                const dx = node.x ?? 0;
                const dy = node.y ?? 0;
                const nodeHeight = node.height ?? 0;
                let points = [];
                points = topLabel ? [
                    {
                        x: dx - bbox.width / 2,
                        y: dy - nodeHeight / 2
                    },
                    {
                        x: dx + bbox.width / 2,
                        y: dy - nodeHeight / 2
                    },
                    {
                        x: dx + bbox.width / 2,
                        y: dy - nodeHeight / 2 + bbox.height + labelPadding
                    },
                    {
                        x: dx + imageWidth / 2,
                        y: dy - nodeHeight / 2 + bbox.height + labelPadding
                    },
                    {
                        x: dx + imageWidth / 2,
                        y: dy + nodeHeight / 2
                    },
                    {
                        x: dx - imageWidth / 2,
                        y: dy + nodeHeight / 2
                    },
                    {
                        x: dx - imageWidth / 2,
                        y: dy - nodeHeight / 2 + bbox.height + labelPadding
                    },
                    {
                        x: dx - bbox.width / 2,
                        y: dy - nodeHeight / 2 + bbox.height + labelPadding
                    }
                ] : [
                    {
                        x: dx - imageWidth / 2,
                        y: dy - nodeHeight / 2
                    },
                    {
                        x: dx + imageWidth / 2,
                        y: dy - nodeHeight / 2
                    },
                    {
                        x: dx + imageWidth / 2,
                        y: dy - nodeHeight / 2 + imageHeight
                    },
                    {
                        x: dx + bbox.width / 2,
                        y: dy - nodeHeight / 2 + imageHeight
                    },
                    {
                        x: dx + bbox.width / 2 / 2,
                        y: dy + nodeHeight / 2
                    },
                    {
                        x: dx - bbox.width / 2,
                        y: dy + nodeHeight / 2
                    },
                    {
                        x: dx - bbox.width / 2,
                        y: dy - nodeHeight / 2 + imageHeight
                    },
                    {
                        x: dx - imageWidth / 2,
                        y: dy - nodeHeight / 2 + imageHeight
                    }
                ];
                const pos = intersect_default.polygon(node, points, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(imageSquare, "imageSquare");
        async function inv_trapezoid(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox } = await labelHelper(parent, node, getNodeClasses(node));
            const w = Math.max(bbox.width + (node.padding ?? 0) * 2, node?.width ?? 0);
            const h = Math.max(bbox.height + (node.padding ?? 0) * 2, node?.height ?? 0);
            const points = [
                {
                    x: 0,
                    y: 0
                },
                {
                    x: w,
                    y: 0
                },
                {
                    x: w + 3 * h / 6,
                    y: -h
                },
                {
                    x: -3 * h / 6,
                    y: -h
                }
            ];
            let polygon;
            const { cssStyles } = node;
            if ("handDrawn" === node.look) {
                const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
                const options = userNodeOverrides(node, {});
                const pathData = createPathFromPoints(points);
                const roughNode = rc.path(pathData, options);
                polygon = shapeSvg.insert(()=>roughNode, ":first-child").attr("transform", `translate(${-w / 2}, ${h / 2})`);
                if (cssStyles) polygon.attr("style", cssStyles);
            } else polygon = insertPolygonShape(shapeSvg, w, h, points);
            if (nodeStyles) polygon.attr("style", nodeStyles);
            node.width = w;
            node.height = h;
            updateNodeBounds(node, polygon);
            node.intersect = function(point) {
                return intersect_default.polygon(node, points, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(inv_trapezoid, "inv_trapezoid");
        async function drawRect(parent, node, options) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox } = await labelHelper(parent, node, getNodeClasses(node));
            const totalWidth = Math.max(bbox.width + 2 * options.labelPaddingX, node?.width || 0);
            const totalHeight = Math.max(bbox.height + 2 * options.labelPaddingY, node?.height || 0);
            const x = -totalWidth / 2;
            const y = -totalHeight / 2;
            let rect2;
            let { rx, ry } = node;
            const { cssStyles } = node;
            if (options?.rx && options.ry) {
                rx = options.rx;
                ry = options.ry;
            }
            if ("handDrawn" === node.look) {
                const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
                const options2 = userNodeOverrides(node, {});
                const roughNode = rx || ry ? rc.path(createRoundedRectPathD(x, y, totalWidth, totalHeight, rx || 0), options2) : rc.rectangle(x, y, totalWidth, totalHeight, options2);
                rect2 = shapeSvg.insert(()=>roughNode, ":first-child");
                rect2.attr("class", "basic label-container").attr("style", (0, _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_3__.R7)(cssStyles));
            } else {
                rect2 = shapeSvg.insert("rect", ":first-child");
                rect2.attr("class", "basic label-container").attr("style", nodeStyles).attr("rx", (0, _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_3__.R7)(rx)).attr("ry", (0, _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_3__.R7)(ry)).attr("x", x).attr("y", y).attr("width", totalWidth).attr("height", totalHeight);
            }
            updateNodeBounds(node, rect2);
            node.intersect = function(point) {
                return intersect_default.rect(node, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(drawRect, "drawRect");
        async function labelRect(parent, node) {
            const { shapeSvg, bbox, label } = await labelHelper(parent, node, "label");
            const rect2 = shapeSvg.insert("rect", ":first-child");
            const totalWidth = 0.1;
            const totalHeight = 0.1;
            rect2.attr("width", totalWidth).attr("height", totalHeight);
            shapeSvg.attr("class", "label edgeLabel");
            label.attr("transform", `translate(${-(bbox.width / 2) - (bbox.x - (bbox.left ?? 0))}, ${-(bbox.height / 2) - (bbox.y - (bbox.top ?? 0))})`);
            updateNodeBounds(node, rect2);
            node.intersect = function(point) {
                return intersect_default.rect(node, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(labelRect, "labelRect");
        async function lean_left(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox } = await labelHelper(parent, node, getNodeClasses(node));
            const w = Math.max(bbox.width + (node.padding ?? 0), node?.width ?? 0);
            const h = Math.max(bbox.height + (node.padding ?? 0), node?.height ?? 0);
            const points = [
                {
                    x: 0,
                    y: 0
                },
                {
                    x: w + 3 * h / 6,
                    y: 0
                },
                {
                    x: w,
                    y: -h
                },
                {
                    x: -(3 * h) / 6,
                    y: -h
                }
            ];
            let polygon;
            const { cssStyles } = node;
            if ("handDrawn" === node.look) {
                const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
                const options = userNodeOverrides(node, {});
                const pathData = createPathFromPoints(points);
                const roughNode = rc.path(pathData, options);
                polygon = shapeSvg.insert(()=>roughNode, ":first-child").attr("transform", `translate(${-w / 2}, ${h / 2})`);
                if (cssStyles) polygon.attr("style", cssStyles);
            } else polygon = insertPolygonShape(shapeSvg, w, h, points);
            if (nodeStyles) polygon.attr("style", nodeStyles);
            node.width = w;
            node.height = h;
            updateNodeBounds(node, polygon);
            node.intersect = function(point) {
                return intersect_default.polygon(node, points, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(lean_left, "lean_left");
        async function lean_right(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox } = await labelHelper(parent, node, getNodeClasses(node));
            const w = Math.max(bbox.width + (node.padding ?? 0), node?.width ?? 0);
            const h = Math.max(bbox.height + (node.padding ?? 0), node?.height ?? 0);
            const points = [
                {
                    x: -3 * h / 6,
                    y: 0
                },
                {
                    x: w,
                    y: 0
                },
                {
                    x: w + 3 * h / 6,
                    y: -h
                },
                {
                    x: 0,
                    y: -h
                }
            ];
            let polygon;
            const { cssStyles } = node;
            if ("handDrawn" === node.look) {
                const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
                const options = userNodeOverrides(node, {});
                const pathData = createPathFromPoints(points);
                const roughNode = rc.path(pathData, options);
                polygon = shapeSvg.insert(()=>roughNode, ":first-child").attr("transform", `translate(${-w / 2}, ${h / 2})`);
                if (cssStyles) polygon.attr("style", cssStyles);
            } else polygon = insertPolygonShape(shapeSvg, w, h, points);
            if (nodeStyles) polygon.attr("style", nodeStyles);
            node.width = w;
            node.height = h;
            updateNodeBounds(node, polygon);
            node.intersect = function(point) {
                return intersect_default.polygon(node, points, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(lean_right, "lean_right");
        function lightningBolt(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.label = "";
            node.labelStyle = labelStyles;
            const shapeSvg = parent.insert("g").attr("class", getNodeClasses(node)).attr("id", node.domId ?? node.id);
            const { cssStyles } = node;
            const width = Math.max(35, node?.width ?? 0);
            const height = Math.max(35, node?.height ?? 0);
            const gap = 7;
            const points = [
                {
                    x: width,
                    y: 0
                },
                {
                    x: 0,
                    y: height + gap / 2
                },
                {
                    x: width - 2 * gap,
                    y: height + gap / 2
                },
                {
                    x: 0,
                    y: 2 * height
                },
                {
                    x: width,
                    y: height - gap / 2
                },
                {
                    x: 2 * gap,
                    y: height - gap / 2
                }
            ];
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const linePath = createPathFromPoints(points);
            const lineNode = rc.path(linePath, options);
            const lightningBolt2 = shapeSvg.insert(()=>lineNode, ":first-child");
            if (cssStyles && "handDrawn" !== node.look) lightningBolt2.selectAll("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) lightningBolt2.selectAll("path").attr("style", nodeStyles);
            lightningBolt2.attr("transform", `translate(-${width / 2},${-height})`);
            updateNodeBounds(node, lightningBolt2);
            node.intersect = function(point) {
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.info("lightningBolt intersect", node, point);
                const pos = intersect_default.polygon(node, points, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(lightningBolt, "lightningBolt");
        var createCylinderPathD2 = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((x, y, width, height, rx, ry, outerOffset)=>[
                `M${x},${y + ry}`,
                `a${rx},${ry} 0,0,0 ${width},0`,
                `a${rx},${ry} 0,0,0 ${-width},0`,
                `l0,${height}`,
                `a${rx},${ry} 0,0,0 ${width},0`,
                `l0,${-height}`,
                `M${x},${y + ry + outerOffset}`,
                `a${rx},${ry} 0,0,0 ${width},0`
            ].join(" "), "createCylinderPathD");
        var createOuterCylinderPathD2 = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((x, y, width, height, rx, ry, outerOffset)=>[
                `M${x},${y + ry}`,
                `M${x + width},${y + ry}`,
                `a${rx},${ry} 0,0,0 ${-width},0`,
                `l0,${height}`,
                `a${rx},${ry} 0,0,0 ${width},0`,
                `l0,${-height}`,
                `M${x},${y + ry + outerOffset}`,
                `a${rx},${ry} 0,0,0 ${width},0`
            ].join(" "), "createOuterCylinderPathD");
        var createInnerCylinderPathD2 = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((x, y, width, height, rx, ry)=>[
                `M${x - width / 2},${-height / 2}`,
                `a${rx},${ry} 0,0,0 ${width},0`
            ].join(" "), "createInnerCylinderPathD");
        async function linedCylinder(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox, label } = await labelHelper(parent, node, getNodeClasses(node));
            const w = Math.max(bbox.width + (node.padding ?? 0), node.width ?? 0);
            const rx = w / 2;
            const ry = rx / (2.5 + w / 50);
            const h = Math.max(bbox.height + ry + (node.padding ?? 0), node.height ?? 0);
            const outerOffset = 0.1 * h;
            let cylinder2;
            const { cssStyles } = node;
            if ("handDrawn" === node.look) {
                const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
                const outerPathData = createOuterCylinderPathD2(0, 0, w, h, rx, ry, outerOffset);
                const innerPathData = createInnerCylinderPathD2(0, ry, w, h, rx, ry);
                const options = userNodeOverrides(node, {});
                const outerNode = rc.path(outerPathData, options);
                const innerLine = rc.path(innerPathData, options);
                const innerLineEl = shapeSvg.insert(()=>innerLine, ":first-child");
                innerLineEl.attr("class", "line");
                cylinder2 = shapeSvg.insert(()=>outerNode, ":first-child");
                cylinder2.attr("class", "basic label-container");
                if (cssStyles) cylinder2.attr("style", cssStyles);
            } else {
                const pathData = createCylinderPathD2(0, 0, w, h, rx, ry, outerOffset);
                cylinder2 = shapeSvg.insert("path", ":first-child").attr("d", pathData).attr("class", "basic label-container").attr("style", (0, _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_3__.R7)(cssStyles)).attr("style", nodeStyles);
            }
            cylinder2.attr("label-offset-y", ry);
            cylinder2.attr("transform", `translate(${-w / 2}, ${-(h / 2 + ry)})`);
            updateNodeBounds(node, cylinder2);
            label.attr("transform", `translate(${-(bbox.width / 2) - (bbox.x - (bbox.left ?? 0))}, ${-(bbox.height / 2) + ry - (bbox.y - (bbox.top ?? 0))})`);
            node.intersect = function(point) {
                const pos = intersect_default.rect(node, point);
                const x = pos.x - (node.x ?? 0);
                if (0 != rx && (Math.abs(x) < (node.width ?? 0) / 2 || Math.abs(x) == (node.width ?? 0) / 2 && Math.abs(pos.y - (node.y ?? 0)) > (node.height ?? 0) / 2 - ry)) {
                    let y = ry * ry * (1 - x * x / (rx * rx));
                    if (y > 0) y = Math.sqrt(y);
                    y = ry - y;
                    if (point.y - (node.y ?? 0) > 0) y = -y;
                    pos.y += y;
                }
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(linedCylinder, "linedCylinder");
        async function linedWaveEdgedRect(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox, label } = await labelHelper(parent, node, getNodeClasses(node));
            const w = Math.max(bbox.width + (node.padding ?? 0) * 2, node?.width ?? 0);
            const h = Math.max(bbox.height + (node.padding ?? 0) * 2, node?.height ?? 0);
            const waveAmplitude = h / 4;
            const finalH = h + waveAmplitude;
            const { cssStyles } = node;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const points = [
                {
                    x: -w / 2 - w / 2 * 0.1,
                    y: -finalH / 2
                },
                {
                    x: -w / 2 - w / 2 * 0.1,
                    y: finalH / 2
                },
                ...generateFullSineWavePoints(-w / 2 - w / 2 * 0.1, finalH / 2, w / 2 + w / 2 * 0.1, finalH / 2, waveAmplitude, 0.8),
                {
                    x: w / 2 + w / 2 * 0.1,
                    y: -finalH / 2
                },
                {
                    x: -w / 2 - w / 2 * 0.1,
                    y: -finalH / 2
                },
                {
                    x: -w / 2,
                    y: -finalH / 2
                },
                {
                    x: -w / 2,
                    y: finalH / 2 * 1.1
                },
                {
                    x: -w / 2,
                    y: -finalH / 2
                }
            ];
            const poly = rc.polygon(points.map((p)=>[
                    p.x,
                    p.y
                ]), options);
            const waveEdgeRect = shapeSvg.insert(()=>poly, ":first-child");
            waveEdgeRect.attr("class", "basic label-container");
            if (cssStyles && "handDrawn" !== node.look) waveEdgeRect.selectAll("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) waveEdgeRect.selectAll("path").attr("style", nodeStyles);
            waveEdgeRect.attr("transform", `translate(0,${-waveAmplitude / 2})`);
            label.attr("transform", `translate(${-w / 2 + (node.padding ?? 0) + w / 2 * 0.1 / 2 - (bbox.x - (bbox.left ?? 0))},${-h / 2 + (node.padding ?? 0) - waveAmplitude / 2 - (bbox.y - (bbox.top ?? 0))})`);
            updateNodeBounds(node, waveEdgeRect);
            node.intersect = function(point) {
                const pos = intersect_default.polygon(node, points, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(linedWaveEdgedRect, "linedWaveEdgedRect");
        async function multiRect(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox, label } = await labelHelper(parent, node, getNodeClasses(node));
            const w = Math.max(bbox.width + (node.padding ?? 0) * 2, node?.width ?? 0);
            const h = Math.max(bbox.height + (node.padding ?? 0) * 2, node?.height ?? 0);
            const rectOffset = 5;
            const x = -w / 2;
            const y = -h / 2;
            const { cssStyles } = node;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            const outerPathPoints = [
                {
                    x: x - rectOffset,
                    y: y + rectOffset
                },
                {
                    x: x - rectOffset,
                    y: y + h + rectOffset
                },
                {
                    x: x + w - rectOffset,
                    y: y + h + rectOffset
                },
                {
                    x: x + w - rectOffset,
                    y: y + h
                },
                {
                    x: x + w,
                    y: y + h
                },
                {
                    x: x + w,
                    y: y + h - rectOffset
                },
                {
                    x: x + w + rectOffset,
                    y: y + h - rectOffset
                },
                {
                    x: x + w + rectOffset,
                    y: y - rectOffset
                },
                {
                    x: x + rectOffset,
                    y: y - rectOffset
                },
                {
                    x: x + rectOffset,
                    y
                },
                {
                    x,
                    y
                },
                {
                    x,
                    y: y + rectOffset
                }
            ];
            const innerPathPoints = [
                {
                    x,
                    y: y + rectOffset
                },
                {
                    x: x + w - rectOffset,
                    y: y + rectOffset
                },
                {
                    x: x + w - rectOffset,
                    y: y + h
                },
                {
                    x: x + w,
                    y: y + h
                },
                {
                    x: x + w,
                    y
                },
                {
                    x,
                    y
                }
            ];
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const outerPath = createPathFromPoints(outerPathPoints);
            const outerNode = rc.path(outerPath, options);
            const innerPath = createPathFromPoints(innerPathPoints);
            const innerNode = rc.path(innerPath, {
                ...options,
                fill: "none"
            });
            const multiRect2 = shapeSvg.insert(()=>innerNode, ":first-child");
            multiRect2.insert(()=>outerNode, ":first-child");
            multiRect2.attr("class", "basic label-container");
            if (cssStyles && "handDrawn" !== node.look) multiRect2.selectAll("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) multiRect2.selectAll("path").attr("style", nodeStyles);
            label.attr("transform", `translate(${-(bbox.width / 2) - rectOffset - (bbox.x - (bbox.left ?? 0))}, ${-(bbox.height / 2) + rectOffset - (bbox.y - (bbox.top ?? 0))})`);
            updateNodeBounds(node, multiRect2);
            node.intersect = function(point) {
                const pos = intersect_default.polygon(node, outerPathPoints, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(multiRect, "multiRect");
        async function multiWaveEdgedRectangle(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox, label } = await labelHelper(parent, node, getNodeClasses(node));
            const w = Math.max(bbox.width + (node.padding ?? 0) * 2, node?.width ?? 0);
            const h = Math.max(bbox.height + (node.padding ?? 0) * 2, node?.height ?? 0);
            const waveAmplitude = h / 4;
            const finalH = h + waveAmplitude;
            const x = -w / 2;
            const y = -finalH / 2;
            const rectOffset = 5;
            const { cssStyles } = node;
            const wavePoints = generateFullSineWavePoints(x - rectOffset, y + finalH + rectOffset, x + w - rectOffset, y + finalH + rectOffset, waveAmplitude, 0.8);
            const lastWavePoint = wavePoints?.[wavePoints.length - 1];
            const outerPathPoints = [
                {
                    x: x - rectOffset,
                    y: y + rectOffset
                },
                {
                    x: x - rectOffset,
                    y: y + finalH + rectOffset
                },
                ...wavePoints,
                {
                    x: x + w - rectOffset,
                    y: lastWavePoint.y - rectOffset
                },
                {
                    x: x + w,
                    y: lastWavePoint.y - rectOffset
                },
                {
                    x: x + w,
                    y: lastWavePoint.y - 2 * rectOffset
                },
                {
                    x: x + w + rectOffset,
                    y: lastWavePoint.y - 2 * rectOffset
                },
                {
                    x: x + w + rectOffset,
                    y: y - rectOffset
                },
                {
                    x: x + rectOffset,
                    y: y - rectOffset
                },
                {
                    x: x + rectOffset,
                    y
                },
                {
                    x,
                    y
                },
                {
                    x,
                    y: y + rectOffset
                }
            ];
            const innerPathPoints = [
                {
                    x,
                    y: y + rectOffset
                },
                {
                    x: x + w - rectOffset,
                    y: y + rectOffset
                },
                {
                    x: x + w - rectOffset,
                    y: lastWavePoint.y - rectOffset
                },
                {
                    x: x + w,
                    y: lastWavePoint.y - rectOffset
                },
                {
                    x: x + w,
                    y
                },
                {
                    x,
                    y
                }
            ];
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const outerPath = createPathFromPoints(outerPathPoints);
            const outerNode = rc.path(outerPath, options);
            const innerPath = createPathFromPoints(innerPathPoints);
            const innerNode = rc.path(innerPath, options);
            const shape = shapeSvg.insert(()=>outerNode, ":first-child");
            shape.insert(()=>innerNode);
            shape.attr("class", "basic label-container");
            if (cssStyles && "handDrawn" !== node.look) shape.selectAll("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) shape.selectAll("path").attr("style", nodeStyles);
            shape.attr("transform", `translate(0,${-waveAmplitude / 2})`);
            label.attr("transform", `translate(${-(bbox.width / 2) - rectOffset - (bbox.x - (bbox.left ?? 0))}, ${-(bbox.height / 2) + rectOffset - waveAmplitude / 2 - (bbox.y - (bbox.top ?? 0))})`);
            updateNodeBounds(node, shape);
            node.intersect = function(point) {
                const pos = intersect_default.polygon(node, outerPathPoints, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(multiWaveEdgedRectangle, "multiWaveEdgedRectangle");
        async function note(parent, node, { config: { themeVariables } }) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const useHtmlLabels = node.useHtmlLabels || _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.iE().flowchart?.htmlLabels !== false;
            if (!useHtmlLabels) node.centerLabel = true;
            const { shapeSvg, bbox } = await labelHelper(parent, node, getNodeClasses(node));
            const totalWidth = Math.max(bbox.width + (node.padding ?? 0) * 2, node?.width ?? 0);
            const totalHeight = Math.max(bbox.height + (node.padding ?? 0) * 2, node?.height ?? 0);
            const x = -totalWidth / 2;
            const y = -totalHeight / 2;
            const { cssStyles } = node;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {
                fill: themeVariables.noteBkgColor,
                stroke: themeVariables.noteBorderColor
            });
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const noteShapeNode = rc.rectangle(x, y, totalWidth, totalHeight, options);
            const rect2 = shapeSvg.insert(()=>noteShapeNode, ":first-child");
            rect2.attr("class", "basic label-container");
            if (cssStyles && "handDrawn" !== node.look) rect2.selectAll("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) rect2.selectAll("path").attr("style", nodeStyles);
            updateNodeBounds(node, rect2);
            node.intersect = function(point) {
                return intersect_default.rect(node, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(note, "note");
        var createDecisionBoxPathD = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((x, y, size)=>[
                `M${x + size / 2},${y}`,
                `L${x + size},${y - size / 2}`,
                `L${x + size / 2},${y - size}`,
                `L${x},${y - size / 2}`,
                "Z"
            ].join(" "), "createDecisionBoxPathD");
        async function question(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox } = await labelHelper(parent, node, getNodeClasses(node));
            const w = bbox.width + node.padding;
            const h = bbox.height + node.padding;
            const s = w + h;
            const points = [
                {
                    x: s / 2,
                    y: 0
                },
                {
                    x: s,
                    y: -s / 2
                },
                {
                    x: s / 2,
                    y: -s
                },
                {
                    x: 0,
                    y: -s / 2
                }
            ];
            let polygon;
            const { cssStyles } = node;
            if ("handDrawn" === node.look) {
                const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
                const options = userNodeOverrides(node, {});
                const pathData = createDecisionBoxPathD(0, 0, s);
                const roughNode = rc.path(pathData, options);
                polygon = shapeSvg.insert(()=>roughNode, ":first-child").attr("transform", `translate(${-s / 2}, ${s / 2})`);
                if (cssStyles) polygon.attr("style", cssStyles);
            } else polygon = insertPolygonShape(shapeSvg, s, s, points);
            if (nodeStyles) polygon.attr("style", nodeStyles);
            updateNodeBounds(node, polygon);
            node.intersect = function(point) {
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.debug("APA12 Intersect called SPLIT\npoint:", point, "\nnode:\n", node, "\nres:", intersect_default.polygon(node, points, point));
                return intersect_default.polygon(node, points, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(question, "question");
        async function rect_left_inv_arrow(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox, label } = await labelHelper(parent, node, getNodeClasses(node));
            const w = Math.max(bbox.width + (node.padding ?? 0), node?.width ?? 0);
            const h = Math.max(bbox.height + (node.padding ?? 0), node?.height ?? 0);
            const x = -w / 2;
            const y = -h / 2;
            const notch = y / 2;
            const points = [
                {
                    x: x + notch,
                    y
                },
                {
                    x,
                    y: 0
                },
                {
                    x: x + notch,
                    y: -y
                },
                {
                    x: -x,
                    y: -y
                },
                {
                    x: -x,
                    y
                }
            ];
            const { cssStyles } = node;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const pathData = createPathFromPoints(points);
            const roughNode = rc.path(pathData, options);
            const polygon = shapeSvg.insert(()=>roughNode, ":first-child");
            polygon.attr("class", "basic label-container");
            if (cssStyles && "handDrawn" !== node.look) polygon.selectAll("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) polygon.selectAll("path").attr("style", nodeStyles);
            polygon.attr("transform", `translate(${-notch / 2},0)`);
            label.attr("transform", `translate(${-notch / 2 - bbox.width / 2 - (bbox.x - (bbox.left ?? 0))}, ${-(bbox.height / 2) - (bbox.y - (bbox.top ?? 0))})`);
            updateNodeBounds(node, polygon);
            node.intersect = function(point) {
                return intersect_default.polygon(node, points, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(rect_left_inv_arrow, "rect_left_inv_arrow");
        async function rectWithTitle(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            let classes;
            classes = node.cssClasses ? "node " + node.cssClasses : "node default";
            const shapeSvg = parent.insert("g").attr("class", classes).attr("id", node.domId || node.id);
            const g = shapeSvg.insert("g");
            const label = shapeSvg.insert("g").attr("class", "label").attr("style", nodeStyles);
            const description = node.description;
            const title = node.label;
            const text2 = label.node().appendChild(await createLabel_default(title, node.labelStyle, true, true));
            let bbox = {
                width: 0,
                height: 0
            };
            if ((0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.ku)(_chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.nV()?.flowchart?.htmlLabels)) {
                const div2 = text2.children[0];
                const dv2 = (0, d3__WEBPACK_IMPORTED_MODULE_5__.Ys)(text2);
                bbox = div2.getBoundingClientRect();
                dv2.attr("width", bbox.width);
                dv2.attr("height", bbox.height);
            }
            _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.info("Text 2", description);
            const textRows = description || [];
            const titleBox = text2.getBBox();
            const descr = label.node().appendChild(await createLabel_default(textRows.join ? textRows.join("<br/>") : textRows, node.labelStyle, true, true));
            const div = descr.children[0];
            const dv = (0, d3__WEBPACK_IMPORTED_MODULE_5__.Ys)(descr);
            bbox = div.getBoundingClientRect();
            dv.attr("width", bbox.width);
            dv.attr("height", bbox.height);
            const halfPadding = (node.padding || 0) / 2;
            (0, d3__WEBPACK_IMPORTED_MODULE_5__.Ys)(descr).attr("transform", "translate( " + (bbox.width > titleBox.width ? 0 : (titleBox.width - bbox.width) / 2) + ", " + (titleBox.height + halfPadding + 5) + ")");
            (0, d3__WEBPACK_IMPORTED_MODULE_5__.Ys)(text2).attr("transform", "translate( " + (bbox.width < titleBox.width ? 0 : -(titleBox.width - bbox.width) / 2) + ", 0)");
            bbox = label.node().getBBox();
            label.attr("transform", "translate(" + -bbox.width / 2 + ", " + (-bbox.height / 2 - halfPadding + 3) + ")");
            const totalWidth = bbox.width + (node.padding || 0);
            const totalHeight = bbox.height + (node.padding || 0);
            const x = -bbox.width / 2 - halfPadding;
            const y = -bbox.height / 2 - halfPadding;
            let rect2;
            let innerLine;
            if ("handDrawn" === node.look) {
                const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
                const options = userNodeOverrides(node, {});
                const roughNode = rc.path(createRoundedRectPathD(x, y, totalWidth, totalHeight, node.rx || 0), options);
                const roughLine = rc.line(-bbox.width / 2 - halfPadding, -bbox.height / 2 - halfPadding + titleBox.height + halfPadding, bbox.width / 2 + halfPadding, -bbox.height / 2 - halfPadding + titleBox.height + halfPadding, options);
                innerLine = shapeSvg.insert(()=>{
                    _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.debug("Rough node insert CXC", roughNode);
                    return roughLine;
                }, ":first-child");
                rect2 = shapeSvg.insert(()=>{
                    _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.debug("Rough node insert CXC", roughNode);
                    return roughNode;
                }, ":first-child");
            } else {
                rect2 = g.insert("rect", ":first-child");
                innerLine = g.insert("line");
                rect2.attr("class", "outer title-state").attr("style", nodeStyles).attr("x", -bbox.width / 2 - halfPadding).attr("y", -bbox.height / 2 - halfPadding).attr("width", bbox.width + (node.padding || 0)).attr("height", bbox.height + (node.padding || 0));
                innerLine.attr("class", "divider").attr("x1", -bbox.width / 2 - halfPadding).attr("x2", bbox.width / 2 + halfPadding).attr("y1", -bbox.height / 2 - halfPadding + titleBox.height + halfPadding).attr("y2", -bbox.height / 2 - halfPadding + titleBox.height + halfPadding);
            }
            updateNodeBounds(node, rect2);
            node.intersect = function(point) {
                return intersect_default.rect(node, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(rectWithTitle, "rectWithTitle");
        async function roundedRect(parent, node) {
            const options = {
                rx: 5,
                ry: 5,
                classes: "",
                labelPaddingX: 1 * (node?.padding || 0),
                labelPaddingY: 1 * (node?.padding || 0)
            };
            return drawRect(parent, node, options);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(roundedRect, "roundedRect");
        async function shadedProcess(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox, label } = await labelHelper(parent, node, getNodeClasses(node));
            const halfPadding = node?.padding ?? 0;
            const w = Math.max(bbox.width + (node.padding ?? 0) * 2, node?.width ?? 0);
            const h = Math.max(bbox.height + (node.padding ?? 0) * 2, node?.height ?? 0);
            const x = -bbox.width / 2 - halfPadding;
            const y = -bbox.height / 2 - halfPadding;
            const { cssStyles } = node;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const points = [
                {
                    x,
                    y
                },
                {
                    x: x + w + 8,
                    y
                },
                {
                    x: x + w + 8,
                    y: y + h
                },
                {
                    x: x - 8,
                    y: y + h
                },
                {
                    x: x - 8,
                    y
                },
                {
                    x,
                    y
                },
                {
                    x,
                    y: y + h
                }
            ];
            const roughNode = rc.polygon(points.map((p)=>[
                    p.x,
                    p.y
                ]), options);
            const rect2 = shapeSvg.insert(()=>roughNode, ":first-child");
            rect2.attr("class", "basic label-container").attr("style", (0, _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_3__.R7)(cssStyles));
            if (nodeStyles && "handDrawn" !== node.look) rect2.selectAll("path").attr("style", nodeStyles);
            if (cssStyles && "handDrawn" !== node.look) rect2.selectAll("path").attr("style", nodeStyles);
            label.attr("transform", `translate(${-w / 2 + 4 + (node.padding ?? 0) - (bbox.x - (bbox.left ?? 0))},${-h / 2 + (node.padding ?? 0) - (bbox.y - (bbox.top ?? 0))})`);
            updateNodeBounds(node, rect2);
            node.intersect = function(point) {
                return intersect_default.rect(node, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(shadedProcess, "shadedProcess");
        async function slopedRect(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox, label } = await labelHelper(parent, node, getNodeClasses(node));
            const w = Math.max(bbox.width + (node.padding ?? 0) * 2, node?.width ?? 0);
            const h = Math.max(bbox.height + (node.padding ?? 0) * 2, node?.height ?? 0);
            const x = -w / 2;
            const y = -h / 2;
            const { cssStyles } = node;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const points = [
                {
                    x,
                    y
                },
                {
                    x,
                    y: y + h
                },
                {
                    x: x + w,
                    y: y + h
                },
                {
                    x: x + w,
                    y: y - h / 2
                }
            ];
            const pathData = createPathFromPoints(points);
            const shapeNode = rc.path(pathData, options);
            const polygon = shapeSvg.insert(()=>shapeNode, ":first-child");
            polygon.attr("class", "basic label-container");
            if (cssStyles && "handDrawn" !== node.look) polygon.selectChildren("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) polygon.selectChildren("path").attr("style", nodeStyles);
            polygon.attr("transform", `translate(0, ${h / 4})`);
            label.attr("transform", `translate(${-w / 2 + (node.padding ?? 0) - (bbox.x - (bbox.left ?? 0))}, ${-h / 4 + (node.padding ?? 0) - (bbox.y - (bbox.top ?? 0))})`);
            updateNodeBounds(node, polygon);
            node.intersect = function(point) {
                const pos = intersect_default.polygon(node, points, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(slopedRect, "slopedRect");
        async function squareRect2(parent, node) {
            const options = {
                rx: 0,
                ry: 0,
                classes: "",
                labelPaddingX: 2 * (node?.padding || 0),
                labelPaddingY: 1 * (node?.padding || 0)
            };
            return drawRect(parent, node, options);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(squareRect2, "squareRect");
        async function stadium(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox } = await labelHelper(parent, node, getNodeClasses(node));
            const h = bbox.height + node.padding;
            const w = bbox.width + h / 4 + node.padding;
            let rect2;
            const { cssStyles } = node;
            if ("handDrawn" === node.look) {
                const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
                const options = userNodeOverrides(node, {});
                const pathData = createRoundedRectPathD(-w / 2, -h / 2, w, h, h / 2);
                const roughNode = rc.path(pathData, options);
                rect2 = shapeSvg.insert(()=>roughNode, ":first-child");
                rect2.attr("class", "basic label-container").attr("style", (0, _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_3__.R7)(cssStyles));
            } else {
                rect2 = shapeSvg.insert("rect", ":first-child");
                rect2.attr("class", "basic label-container").attr("style", nodeStyles).attr("rx", h / 2).attr("ry", h / 2).attr("x", -w / 2).attr("y", -h / 2).attr("width", w).attr("height", h);
            }
            updateNodeBounds(node, rect2);
            node.intersect = function(point) {
                return intersect_default.rect(node, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(stadium, "stadium");
        async function state(parent, node) {
            const options = {
                rx: 5,
                ry: 5,
                classes: "flowchart-node"
            };
            return drawRect(parent, node, options);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(state, "state");
        function stateEnd(parent, node, { config: { themeVariables } }) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { cssStyles } = node;
            const { lineColor, stateBorder, nodeBorder } = themeVariables;
            const shapeSvg = parent.insert("g").attr("class", "node default").attr("id", node.domId || node.id);
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const roughNode = rc.circle(0, 0, 14, {
                ...options,
                stroke: lineColor,
                strokeWidth: 2
            });
            const innerFill = stateBorder ?? nodeBorder;
            const roughInnerNode = rc.circle(0, 0, 5, {
                ...options,
                fill: innerFill,
                stroke: innerFill,
                strokeWidth: 2,
                fillStyle: "solid"
            });
            const circle2 = shapeSvg.insert(()=>roughNode, ":first-child");
            circle2.insert(()=>roughInnerNode);
            if (cssStyles) circle2.selectAll("path").attr("style", cssStyles);
            if (nodeStyles) circle2.selectAll("path").attr("style", nodeStyles);
            updateNodeBounds(node, circle2);
            node.intersect = function(point) {
                return intersect_default.circle(node, 7, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(stateEnd, "stateEnd");
        function stateStart(parent, node, { config: { themeVariables } }) {
            const { lineColor } = themeVariables;
            const shapeSvg = parent.insert("g").attr("class", "node default").attr("id", node.domId || node.id);
            let circle2;
            if ("handDrawn" === node.look) {
                const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
                const roughNode = rc.circle(0, 0, 14, solidStateFill(lineColor));
                circle2 = shapeSvg.insert(()=>roughNode);
                circle2.attr("class", "state-start").attr("r", 7).attr("width", 14).attr("height", 14);
            } else {
                circle2 = shapeSvg.insert("circle", ":first-child");
                circle2.attr("class", "state-start").attr("r", 7).attr("width", 14).attr("height", 14);
            }
            updateNodeBounds(node, circle2);
            node.intersect = function(point) {
                return intersect_default.circle(node, 7, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(stateStart, "stateStart");
        async function subroutine(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox } = await labelHelper(parent, node, getNodeClasses(node));
            const halfPadding = (node?.padding || 0) / 2;
            const w = bbox.width + node.padding;
            const h = bbox.height + node.padding;
            const x = -bbox.width / 2 - halfPadding;
            const y = -bbox.height / 2 - halfPadding;
            const points = [
                {
                    x: 0,
                    y: 0
                },
                {
                    x: w,
                    y: 0
                },
                {
                    x: w,
                    y: -h
                },
                {
                    x: 0,
                    y: -h
                },
                {
                    x: 0,
                    y: 0
                },
                {
                    x: -8,
                    y: 0
                },
                {
                    x: w + 8,
                    y: 0
                },
                {
                    x: w + 8,
                    y: -h
                },
                {
                    x: -8,
                    y: -h
                },
                {
                    x: -8,
                    y: 0
                }
            ];
            if ("handDrawn" === node.look) {
                const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
                const options = userNodeOverrides(node, {});
                const roughNode = rc.rectangle(x - 8, y, w + 16, h, options);
                const l1 = rc.line(x, y, x, y + h, options);
                const l2 = rc.line(x + w, y, x + w, y + h, options);
                shapeSvg.insert(()=>l1, ":first-child");
                shapeSvg.insert(()=>l2, ":first-child");
                const rect2 = shapeSvg.insert(()=>roughNode, ":first-child");
                const { cssStyles } = node;
                rect2.attr("class", "basic label-container").attr("style", (0, _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_3__.R7)(cssStyles));
                updateNodeBounds(node, rect2);
            } else {
                const el = insertPolygonShape(shapeSvg, w, h, points);
                if (nodeStyles) el.attr("style", nodeStyles);
                updateNodeBounds(node, el);
            }
            node.intersect = function(point) {
                return intersect_default.polygon(node, points, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(subroutine, "subroutine");
        async function taggedRect(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox } = await labelHelper(parent, node, getNodeClasses(node));
            const w = Math.max(bbox.width + (node.padding ?? 0) * 2, node?.width ?? 0);
            const h = Math.max(bbox.height + (node.padding ?? 0) * 2, node?.height ?? 0);
            const x = -w / 2;
            const y = -h / 2;
            const tagWidth = 0.2 * h;
            const tagHeight = 0.2 * h;
            const { cssStyles } = node;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            const rectPoints = [
                {
                    x: x - tagWidth / 2,
                    y
                },
                {
                    x: x + w + tagWidth / 2,
                    y
                },
                {
                    x: x + w + tagWidth / 2,
                    y: y + h
                },
                {
                    x: x - tagWidth / 2,
                    y: y + h
                }
            ];
            const tagPoints = [
                {
                    x: x + w - tagWidth / 2,
                    y: y + h
                },
                {
                    x: x + w + tagWidth / 2,
                    y: y + h
                },
                {
                    x: x + w + tagWidth / 2,
                    y: y + h - tagHeight
                }
            ];
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const rectPath = createPathFromPoints(rectPoints);
            const rectNode = rc.path(rectPath, options);
            const tagPath = createPathFromPoints(tagPoints);
            const tagNode = rc.path(tagPath, {
                ...options,
                fillStyle: "solid"
            });
            const taggedRect2 = shapeSvg.insert(()=>tagNode, ":first-child");
            taggedRect2.insert(()=>rectNode, ":first-child");
            taggedRect2.attr("class", "basic label-container");
            if (cssStyles && "handDrawn" !== node.look) taggedRect2.selectAll("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) taggedRect2.selectAll("path").attr("style", nodeStyles);
            updateNodeBounds(node, taggedRect2);
            node.intersect = function(point) {
                const pos = intersect_default.polygon(node, rectPoints, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(taggedRect, "taggedRect");
        async function taggedWaveEdgedRectangle(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox, label } = await labelHelper(parent, node, getNodeClasses(node));
            const w = Math.max(bbox.width + (node.padding ?? 0) * 2, node?.width ?? 0);
            const h = Math.max(bbox.height + (node.padding ?? 0) * 2, node?.height ?? 0);
            const waveAmplitude = h / 4;
            const tagWidth = 0.2 * w;
            const tagHeight = 0.2 * h;
            const finalH = h + waveAmplitude;
            const { cssStyles } = node;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const points = [
                {
                    x: -w / 2 - w / 2 * 0.1,
                    y: finalH / 2
                },
                ...generateFullSineWavePoints(-w / 2 - w / 2 * 0.1, finalH / 2, w / 2 + w / 2 * 0.1, finalH / 2, waveAmplitude, 0.8),
                {
                    x: w / 2 + w / 2 * 0.1,
                    y: -finalH / 2
                },
                {
                    x: -w / 2 - w / 2 * 0.1,
                    y: -finalH / 2
                }
            ];
            const x = -w / 2 + w / 2 * 0.1;
            const y = -finalH / 2 - 0.4 * tagHeight;
            const tagPoints = [
                {
                    x: x + w - tagWidth,
                    y: (y + h) * 1.4
                },
                {
                    x: x + w,
                    y: y + h - tagHeight
                },
                {
                    x: x + w,
                    y: (y + h) * 0.9
                },
                ...generateFullSineWavePoints(x + w, (y + h) * 1.3, x + w - tagWidth, (y + h) * 1.5, 0.03 * -h, 0.5)
            ];
            const waveEdgeRectPath = createPathFromPoints(points);
            const waveEdgeRectNode = rc.path(waveEdgeRectPath, options);
            const taggedWaveEdgeRectPath = createPathFromPoints(tagPoints);
            const taggedWaveEdgeRectNode = rc.path(taggedWaveEdgeRectPath, {
                ...options,
                fillStyle: "solid"
            });
            const waveEdgeRect = shapeSvg.insert(()=>taggedWaveEdgeRectNode, ":first-child");
            waveEdgeRect.insert(()=>waveEdgeRectNode, ":first-child");
            waveEdgeRect.attr("class", "basic label-container");
            if (cssStyles && "handDrawn" !== node.look) waveEdgeRect.selectAll("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) waveEdgeRect.selectAll("path").attr("style", nodeStyles);
            waveEdgeRect.attr("transform", `translate(0,${-waveAmplitude / 2})`);
            label.attr("transform", `translate(${-w / 2 + (node.padding ?? 0) - (bbox.x - (bbox.left ?? 0))},${-h / 2 + (node.padding ?? 0) - waveAmplitude / 2 - (bbox.y - (bbox.top ?? 0))})`);
            updateNodeBounds(node, waveEdgeRect);
            node.intersect = function(point) {
                const pos = intersect_default.polygon(node, points, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(taggedWaveEdgedRectangle, "taggedWaveEdgedRectangle");
        async function text(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox } = await labelHelper(parent, node, getNodeClasses(node));
            const totalWidth = Math.max(bbox.width + node.padding, node?.width || 0);
            const totalHeight = Math.max(bbox.height + node.padding, node?.height || 0);
            const x = -totalWidth / 2;
            const y = -totalHeight / 2;
            const rect2 = shapeSvg.insert("rect", ":first-child");
            rect2.attr("class", "text").attr("style", nodeStyles).attr("rx", 0).attr("ry", 0).attr("x", x).attr("y", y).attr("width", totalWidth).attr("height", totalHeight);
            updateNodeBounds(node, rect2);
            node.intersect = function(point) {
                return intersect_default.rect(node, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(text, "text");
        var createCylinderPathD3 = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((x, y, width, height, rx, ry)=>`M${x},${y}
    a${rx},${ry} 0,0,1 0,${-height}
    l${width},0
    a${rx},${ry} 0,0,1 0,${height}
    M${width},${-height}
    a${rx},${ry} 0,0,0 0,${height}
    l${-width},0`, "createCylinderPathD");
        var createOuterCylinderPathD3 = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((x, y, width, height, rx, ry)=>[
                `M${x},${y}`,
                `M${x + width},${y}`,
                `a${rx},${ry} 0,0,0 0,${-height}`,
                `l${-width},0`,
                `a${rx},${ry} 0,0,0 0,${height}`,
                `l${width},0`
            ].join(" "), "createOuterCylinderPathD");
        var createInnerCylinderPathD3 = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((x, y, width, height, rx, ry)=>[
                `M${x + width / 2},${-height / 2}`,
                `a${rx},${ry} 0,0,0 0,${height}`
            ].join(" "), "createInnerCylinderPathD");
        async function tiltedCylinder(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox, label, halfPadding } = await labelHelper(parent, node, getNodeClasses(node));
            const labelPadding = "neo" === node.look ? 2 * halfPadding : halfPadding;
            const h = bbox.height + labelPadding;
            const ry = h / 2;
            const rx = ry / (2.5 + h / 50);
            const w = bbox.width + rx + labelPadding;
            const { cssStyles } = node;
            let cylinder2;
            if ("handDrawn" === node.look) {
                const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
                const outerPathData = createOuterCylinderPathD3(0, 0, w, h, rx, ry);
                const innerPathData = createInnerCylinderPathD3(0, 0, w, h, rx, ry);
                const outerNode = rc.path(outerPathData, userNodeOverrides(node, {}));
                const innerLine = rc.path(innerPathData, userNodeOverrides(node, {
                    fill: "none"
                }));
                cylinder2 = shapeSvg.insert(()=>innerLine, ":first-child");
                cylinder2 = shapeSvg.insert(()=>outerNode, ":first-child");
                cylinder2.attr("class", "basic label-container");
                if (cssStyles) cylinder2.attr("style", cssStyles);
            } else {
                const pathData = createCylinderPathD3(0, 0, w, h, rx, ry);
                cylinder2 = shapeSvg.insert("path", ":first-child").attr("d", pathData).attr("class", "basic label-container").attr("style", (0, _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_3__.R7)(cssStyles)).attr("style", nodeStyles);
                cylinder2.attr("class", "basic label-container");
                if (cssStyles) cylinder2.selectAll("path").attr("style", cssStyles);
                if (nodeStyles) cylinder2.selectAll("path").attr("style", nodeStyles);
            }
            cylinder2.attr("label-offset-x", rx);
            cylinder2.attr("transform", `translate(${-w / 2}, ${h / 2} )`);
            label.attr("transform", `translate(${-(bbox.width / 2) - rx - (bbox.x - (bbox.left ?? 0))}, ${-(bbox.height / 2) - (bbox.y - (bbox.top ?? 0))})`);
            updateNodeBounds(node, cylinder2);
            node.intersect = function(point) {
                const pos = intersect_default.rect(node, point);
                const y = pos.y - (node.y ?? 0);
                if (0 != ry && (Math.abs(y) < (node.height ?? 0) / 2 || Math.abs(y) == (node.height ?? 0) / 2 && Math.abs(pos.x - (node.x ?? 0)) > (node.width ?? 0) / 2 - rx)) {
                    let x = rx * rx * (1 - y * y / (ry * ry));
                    if (0 != x) x = Math.sqrt(Math.abs(x));
                    x = rx - x;
                    if (point.x - (node.x ?? 0) > 0) x = -x;
                    pos.x += x;
                }
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(tiltedCylinder, "tiltedCylinder");
        async function trapezoid(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox } = await labelHelper(parent, node, getNodeClasses(node));
            const w = bbox.width + node.padding;
            const h = bbox.height + node.padding;
            const points = [
                {
                    x: -3 * h / 6,
                    y: 0
                },
                {
                    x: w + 3 * h / 6,
                    y: 0
                },
                {
                    x: w,
                    y: -h
                },
                {
                    x: 0,
                    y: -h
                }
            ];
            let polygon;
            const { cssStyles } = node;
            if ("handDrawn" === node.look) {
                const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
                const options = userNodeOverrides(node, {});
                const pathData = createPathFromPoints(points);
                const roughNode = rc.path(pathData, options);
                polygon = shapeSvg.insert(()=>roughNode, ":first-child").attr("transform", `translate(${-w / 2}, ${h / 2})`);
                if (cssStyles) polygon.attr("style", cssStyles);
            } else polygon = insertPolygonShape(shapeSvg, w, h, points);
            if (nodeStyles) polygon.attr("style", nodeStyles);
            node.width = w;
            node.height = h;
            updateNodeBounds(node, polygon);
            node.intersect = function(point) {
                return intersect_default.polygon(node, points, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(trapezoid, "trapezoid");
        async function trapezoidalPentagon(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox } = await labelHelper(parent, node, getNodeClasses(node));
            const minWidth = 60, minHeight = 20;
            const w = Math.max(minWidth, bbox.width + (node.padding ?? 0) * 2, node?.width ?? 0);
            const h = Math.max(minHeight, bbox.height + (node.padding ?? 0) * 2, node?.height ?? 0);
            const { cssStyles } = node;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const points = [
                {
                    x: -w / 2 * 0.8,
                    y: -h / 2
                },
                {
                    x: w / 2 * 0.8,
                    y: -h / 2
                },
                {
                    x: w / 2,
                    y: -h / 2 * 0.6
                },
                {
                    x: w / 2,
                    y: h / 2
                },
                {
                    x: -w / 2,
                    y: h / 2
                },
                {
                    x: -w / 2,
                    y: -h / 2 * 0.6
                }
            ];
            const pathData = createPathFromPoints(points);
            const shapeNode = rc.path(pathData, options);
            const polygon = shapeSvg.insert(()=>shapeNode, ":first-child");
            polygon.attr("class", "basic label-container");
            if (cssStyles && "handDrawn" !== node.look) polygon.selectChildren("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) polygon.selectChildren("path").attr("style", nodeStyles);
            updateNodeBounds(node, polygon);
            node.intersect = function(point) {
                const pos = intersect_default.polygon(node, points, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(trapezoidalPentagon, "trapezoidalPentagon");
        async function triangle(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox, label } = await labelHelper(parent, node, getNodeClasses(node));
            const useHtmlLabels = (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.ku)(_chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.nV().flowchart?.htmlLabels);
            const w = bbox.width + (node.padding ?? 0);
            const h = w + bbox.height;
            const tw = w + bbox.height;
            const points = [
                {
                    x: 0,
                    y: 0
                },
                {
                    x: tw,
                    y: 0
                },
                {
                    x: tw / 2,
                    y: -h
                }
            ];
            const { cssStyles } = node;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const pathData = createPathFromPoints(points);
            const roughNode = rc.path(pathData, options);
            const polygon = shapeSvg.insert(()=>roughNode, ":first-child").attr("transform", `translate(${-h / 2}, ${h / 2})`);
            if (cssStyles && "handDrawn" !== node.look) polygon.selectChildren("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) polygon.selectChildren("path").attr("style", nodeStyles);
            node.width = w;
            node.height = h;
            updateNodeBounds(node, polygon);
            label.attr("transform", `translate(${-bbox.width / 2 - (bbox.x - (bbox.left ?? 0))}, ${h / 2 - (bbox.height + (node.padding ?? 0) / (useHtmlLabels ? 2 : 1) - (bbox.y - (bbox.top ?? 0)))})`);
            node.intersect = function(point) {
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.info("Triangle intersect", node, points, point);
                return intersect_default.polygon(node, points, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(triangle, "triangle");
        async function waveEdgedRectangle(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox, label } = await labelHelper(parent, node, getNodeClasses(node));
            const w = Math.max(bbox.width + (node.padding ?? 0) * 2, node?.width ?? 0);
            const h = Math.max(bbox.height + (node.padding ?? 0) * 2, node?.height ?? 0);
            const waveAmplitude = h / 8;
            const finalH = h + waveAmplitude;
            const { cssStyles } = node;
            const minWidth = 70;
            const widthDif = minWidth - w;
            const extraW = widthDif > 0 ? widthDif / 2 : 0;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const points = [
                {
                    x: -w / 2 - extraW,
                    y: finalH / 2
                },
                ...generateFullSineWavePoints(-w / 2 - extraW, finalH / 2, w / 2 + extraW, finalH / 2, waveAmplitude, 0.8),
                {
                    x: w / 2 + extraW,
                    y: -finalH / 2
                },
                {
                    x: -w / 2 - extraW,
                    y: -finalH / 2
                }
            ];
            const waveEdgeRectPath = createPathFromPoints(points);
            const waveEdgeRectNode = rc.path(waveEdgeRectPath, options);
            const waveEdgeRect = shapeSvg.insert(()=>waveEdgeRectNode, ":first-child");
            waveEdgeRect.attr("class", "basic label-container");
            if (cssStyles && "handDrawn" !== node.look) waveEdgeRect.selectAll("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) waveEdgeRect.selectAll("path").attr("style", nodeStyles);
            waveEdgeRect.attr("transform", `translate(0,${-waveAmplitude / 2})`);
            label.attr("transform", `translate(${-w / 2 + (node.padding ?? 0) - (bbox.x - (bbox.left ?? 0))},${-h / 2 + (node.padding ?? 0) - waveAmplitude - (bbox.y - (bbox.top ?? 0))})`);
            updateNodeBounds(node, waveEdgeRect);
            node.intersect = function(point) {
                const pos = intersect_default.polygon(node, points, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(waveEdgedRectangle, "waveEdgedRectangle");
        async function waveRectangle(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox } = await labelHelper(parent, node, getNodeClasses(node));
            const minWidth = 100;
            const minHeight = 50;
            const baseWidth = Math.max(bbox.width + (node.padding ?? 0) * 2, node?.width ?? 0);
            const baseHeight = Math.max(bbox.height + (node.padding ?? 0) * 2, node?.height ?? 0);
            const aspectRatio = baseWidth / baseHeight;
            let w = baseWidth;
            let h = baseHeight;
            if (w > h * aspectRatio) h = w / aspectRatio;
            else w = h * aspectRatio;
            w = Math.max(w, minWidth);
            h = Math.max(h, minHeight);
            const waveAmplitude = Math.min(0.2 * h, h / 4);
            const finalH = h + 2 * waveAmplitude;
            const { cssStyles } = node;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const points = [
                {
                    x: -w / 2,
                    y: finalH / 2
                },
                ...generateFullSineWavePoints(-w / 2, finalH / 2, w / 2, finalH / 2, waveAmplitude, 1),
                {
                    x: w / 2,
                    y: -finalH / 2
                },
                ...generateFullSineWavePoints(w / 2, -finalH / 2, -w / 2, -finalH / 2, waveAmplitude, -1)
            ];
            const waveRectPath = createPathFromPoints(points);
            const waveRectNode = rc.path(waveRectPath, options);
            const waveRect = shapeSvg.insert(()=>waveRectNode, ":first-child");
            waveRect.attr("class", "basic label-container");
            if (cssStyles && "handDrawn" !== node.look) waveRect.selectAll("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) waveRect.selectAll("path").attr("style", nodeStyles);
            updateNodeBounds(node, waveRect);
            node.intersect = function(point) {
                const pos = intersect_default.polygon(node, points, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(waveRectangle, "waveRectangle");
        async function windowPane(parent, node) {
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            const { shapeSvg, bbox, label } = await labelHelper(parent, node, getNodeClasses(node));
            const w = Math.max(bbox.width + (node.padding ?? 0) * 2, node?.width ?? 0);
            const h = Math.max(bbox.height + (node.padding ?? 0) * 2, node?.height ?? 0);
            const rectOffset = 5;
            const x = -w / 2;
            const y = -h / 2;
            const { cssStyles } = node;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            const outerPathPoints = [
                {
                    x: x - rectOffset,
                    y: y - rectOffset
                },
                {
                    x: x - rectOffset,
                    y: y + h
                },
                {
                    x: x + w,
                    y: y + h
                },
                {
                    x: x + w,
                    y: y - rectOffset
                }
            ];
            const path = `M${x - rectOffset},${y - rectOffset} L${x + w},${y - rectOffset} L${x + w},${y + h} L${x - rectOffset},${y + h} L${x - rectOffset},${y - rectOffset}
                M${x - rectOffset},${y} L${x + w},${y}
                M${x},${y - rectOffset} L${x},${y + h}`;
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const no = rc.path(path, options);
            const windowPane2 = shapeSvg.insert(()=>no, ":first-child");
            windowPane2.attr("transform", `translate(${rectOffset / 2}, ${rectOffset / 2})`);
            windowPane2.attr("class", "basic label-container");
            if (cssStyles && "handDrawn" !== node.look) windowPane2.selectAll("path").attr("style", cssStyles);
            if (nodeStyles && "handDrawn" !== node.look) windowPane2.selectAll("path").attr("style", nodeStyles);
            label.attr("transform", `translate(${-(bbox.width / 2) + rectOffset / 2 - (bbox.x - (bbox.left ?? 0))}, ${-(bbox.height / 2) + rectOffset / 2 - (bbox.y - (bbox.top ?? 0))})`);
            updateNodeBounds(node, windowPane2);
            node.intersect = function(point) {
                const pos = intersect_default.polygon(node, outerPathPoints, point);
                return pos;
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(windowPane, "windowPane");
        async function textHelper(parent, node, config, useHtmlLabels, GAP = config.class.padding ?? 12) {
            const TEXT_PADDING = useHtmlLabels ? 0 : 3;
            const shapeSvg = parent.insert("g").attr("class", getNodeClasses(node)).attr("id", node.domId || node.id);
            let annotationGroup = null;
            let labelGroup = null;
            let membersGroup = null;
            let methodsGroup = null;
            let annotationGroupHeight = 0;
            let labelGroupHeight = 0;
            let membersGroupHeight = 0;
            annotationGroup = shapeSvg.insert("g").attr("class", "annotation-group text");
            if (node.annotations.length > 0) {
                const annotation = node.annotations[0];
                await addText(annotationGroup, {
                    text: `\xAB${annotation}\xBB`
                }, 0);
                const annotationGroupBBox = annotationGroup.node().getBBox();
                annotationGroupHeight = annotationGroupBBox.height;
            }
            labelGroup = shapeSvg.insert("g").attr("class", "label-group text");
            await addText(labelGroup, node, 0, [
                "font-weight: bolder"
            ]);
            const labelGroupBBox = labelGroup.node().getBBox();
            labelGroupHeight = labelGroupBBox.height;
            membersGroup = shapeSvg.insert("g").attr("class", "members-group text");
            let yOffset = 0;
            for (const member of node.members){
                const height = await addText(membersGroup, member, yOffset, [
                    member.parseClassifier()
                ]);
                yOffset += height + TEXT_PADDING;
            }
            membersGroupHeight = membersGroup.node().getBBox().height;
            if (membersGroupHeight <= 0) membersGroupHeight = GAP / 2;
            methodsGroup = shapeSvg.insert("g").attr("class", "methods-group text");
            let methodsYOffset = 0;
            for (const method of node.methods){
                const height = await addText(methodsGroup, method, methodsYOffset, [
                    method.parseClassifier()
                ]);
                methodsYOffset += height + TEXT_PADDING;
            }
            let bbox = shapeSvg.node().getBBox();
            if (null !== annotationGroup) {
                const annotationGroupBBox = annotationGroup.node().getBBox();
                annotationGroup.attr("transform", `translate(${-annotationGroupBBox.width / 2})`);
            }
            labelGroup.attr("transform", `translate(${-labelGroupBBox.width / 2}, ${annotationGroupHeight})`);
            bbox = shapeSvg.node().getBBox();
            membersGroup.attr("transform", `translate(0, ${annotationGroupHeight + labelGroupHeight + 2 * GAP})`);
            bbox = shapeSvg.node().getBBox();
            methodsGroup.attr("transform", `translate(0, ${annotationGroupHeight + labelGroupHeight + (membersGroupHeight ? membersGroupHeight + 4 * GAP : 2 * GAP)})`);
            bbox = shapeSvg.node().getBBox();
            return {
                shapeSvg,
                bbox
            };
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(textHelper, "textHelper");
        async function addText(parentGroup, node, yOffset, styles = []) {
            const textEl = parentGroup.insert("g").attr("class", "label").attr("style", styles.join("; "));
            const config = (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.iE)();
            let useHtmlLabels = "useHtmlLabels" in node ? node.useHtmlLabels : (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.ku)(config.htmlLabels) ?? true;
            let textContent = "";
            textContent = "text" in node ? node.text : node.label;
            if (!useHtmlLabels && textContent.startsWith("\\")) textContent = textContent.substring(1);
            if ((0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.l0)(textContent)) useHtmlLabels = true;
            const text2 = await (0, _chunk_6JOS74DS_mjs__WEBPACK_IMPORTED_MODULE_2__.rw)(textEl, (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.uX)((0, _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_3__.SH)(textContent)), {
                width: (0, _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_3__.Cq)(textContent, config) + 50,
                classes: "markdown-node-label",
                useHtmlLabels
            }, config);
            let bbox;
            let numberOfLines = 1;
            if (useHtmlLabels) {
                const div = text2.children[0];
                const dv = (0, d3__WEBPACK_IMPORTED_MODULE_5__.Ys)(text2);
                numberOfLines = div.innerHTML.split("<br>").length;
                if (div.innerHTML.includes("</math>")) numberOfLines += div.innerHTML.split("<mrow>").length - 1;
                const images = div.getElementsByTagName("img");
                if (images) {
                    const noImgText = "" === textContent.replace(/<img[^>]*>/g, "").trim();
                    await Promise.all([
                        ...images
                    ].map((img)=>new Promise((res)=>{
                            function setupImage() {
                                img.style.display = "flex";
                                img.style.flexDirection = "column";
                                if (noImgText) {
                                    const bodyFontSize = config.fontSize?.toString() ?? window.getComputedStyle(document.body).fontSize;
                                    const enlargingFactor = 5;
                                    const width = parseInt(bodyFontSize, 10) * enlargingFactor + "px";
                                    img.style.minWidth = width;
                                    img.style.maxWidth = width;
                                } else img.style.width = "100%";
                                res(img);
                            }
                            (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(setupImage, "setupImage");
                            setTimeout(()=>{
                                if (img.complete) setupImage();
                            });
                            img.addEventListener("error", setupImage);
                            img.addEventListener("load", setupImage);
                        })));
                }
                bbox = div.getBoundingClientRect();
                dv.attr("width", bbox.width);
                dv.attr("height", bbox.height);
            } else {
                if (styles.includes("font-weight: bolder")) (0, d3__WEBPACK_IMPORTED_MODULE_5__.Ys)(text2).selectAll("tspan").attr("font-weight", "");
                numberOfLines = text2.children.length;
                const textChild = text2.children[0];
                if ("" === text2.textContent || text2.textContent.includes("&gt")) {
                    textChild.textContent = textContent[0] + textContent.substring(1).replaceAll("&gt;", ">").replaceAll("&lt;", "<").trim();
                    const preserveSpace = " " === textContent[1];
                    if (preserveSpace) textChild.textContent = textChild.textContent[0] + " " + textChild.textContent.substring(1);
                }
                if ("undefined" === textChild.textContent) textChild.textContent = "";
                bbox = text2.getBBox();
            }
            textEl.attr("transform", "translate(0," + (-bbox.height / (2 * numberOfLines) + yOffset) + ")");
            return bbox.height;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(addText, "addText");
        async function classBox(parent, node) {
            const config = (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.nV)();
            const PADDING = config.class.padding ?? 12;
            const GAP = PADDING;
            const useHtmlLabels = node.useHtmlLabels ?? (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.ku)(config.htmlLabels) ?? true;
            const classNode = node;
            classNode.annotations = classNode.annotations ?? [];
            classNode.members = classNode.members ?? [];
            classNode.methods = classNode.methods ?? [];
            const { shapeSvg, bbox } = await textHelper(parent, node, config, useHtmlLabels, GAP);
            const { labelStyles, nodeStyles } = styles2String(node);
            node.labelStyle = labelStyles;
            node.cssStyles = classNode.styles || "";
            const styles = classNode.styles?.join(";") || nodeStyles || "";
            if (!node.cssStyles) node.cssStyles = styles.replaceAll("!important", "").split(";");
            const renderExtraBox = 0 === classNode.members.length && 0 === classNode.methods.length && !config.class?.hideEmptyMembersBox;
            const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
            const options = userNodeOverrides(node, {});
            if ("handDrawn" !== node.look) {
                options.roughness = 0;
                options.fillStyle = "solid";
            }
            const w = bbox.width;
            let h = bbox.height;
            if (0 === classNode.members.length && 0 === classNode.methods.length) h += GAP;
            else if (classNode.members.length > 0 && 0 === classNode.methods.length) h += 2 * GAP;
            const x = -w / 2;
            const y = -h / 2;
            const roughRect = rc.rectangle(x - PADDING, y - PADDING - (renderExtraBox ? PADDING : 0 === classNode.members.length && 0 === classNode.methods.length ? -PADDING / 2 : 0), w + 2 * PADDING, h + 2 * PADDING + (renderExtraBox ? 2 * PADDING : 0 === classNode.members.length && 0 === classNode.methods.length ? -PADDING : 0), options);
            const rect2 = shapeSvg.insert(()=>roughRect, ":first-child");
            rect2.attr("class", "basic label-container");
            const rectBBox = rect2.node().getBBox();
            shapeSvg.selectAll(".text").each((_, i, nodes)=>{
                const text2 = (0, d3__WEBPACK_IMPORTED_MODULE_5__.Ys)(nodes[i]);
                const transform = text2.attr("transform");
                let translateY = 0;
                if (transform) {
                    const regex = RegExp(/translate\(([^,]+),([^)]+)\)/);
                    const translate = regex.exec(transform);
                    if (translate) translateY = parseFloat(translate[2]);
                }
                let newTranslateY = translateY + y + PADDING - (renderExtraBox ? PADDING : 0 === classNode.members.length && 0 === classNode.methods.length ? -PADDING / 2 : 0);
                if (!useHtmlLabels) newTranslateY -= 4;
                let newTranslateX = x;
                if (text2.attr("class").includes("label-group") || text2.attr("class").includes("annotation-group")) {
                    newTranslateX = -text2.node()?.getBBox().width / 2 || 0;
                    shapeSvg.selectAll("text").each(function(_2, i2, nodes2) {
                        if ("middle" === window.getComputedStyle(nodes2[i2]).textAnchor) newTranslateX = 0;
                    });
                }
                text2.attr("transform", `translate(${newTranslateX}, ${newTranslateY})`);
            });
            const annotationGroupHeight = shapeSvg.select(".annotation-group").node().getBBox().height - (renderExtraBox ? PADDING / 2 : 0) || 0;
            const labelGroupHeight = shapeSvg.select(".label-group").node().getBBox().height - (renderExtraBox ? PADDING / 2 : 0) || 0;
            const membersGroupHeight = shapeSvg.select(".members-group").node().getBBox().height - (renderExtraBox ? PADDING / 2 : 0) || 0;
            if (classNode.members.length > 0 || classNode.methods.length > 0 || renderExtraBox) {
                const roughLine = rc.line(rectBBox.x, annotationGroupHeight + labelGroupHeight + y + PADDING, rectBBox.x + rectBBox.width, annotationGroupHeight + labelGroupHeight + y + PADDING, options);
                const line = shapeSvg.insert(()=>roughLine);
                line.attr("class", "divider").attr("style", styles);
            }
            if (renderExtraBox || classNode.members.length > 0 || classNode.methods.length > 0) {
                const roughLine = rc.line(rectBBox.x, annotationGroupHeight + labelGroupHeight + membersGroupHeight + y + 2 * GAP + PADDING, rectBBox.x + rectBBox.width, annotationGroupHeight + labelGroupHeight + membersGroupHeight + y + PADDING + 2 * GAP, options);
                const line = shapeSvg.insert(()=>roughLine);
                line.attr("class", "divider").attr("style", styles);
            }
            if ("handDrawn" !== classNode.look) shapeSvg.selectAll("path").attr("style", styles);
            rect2.select(":nth-child(2)").attr("style", styles);
            shapeSvg.selectAll(".divider").select("path").attr("style", styles);
            if (node.labelStyle) shapeSvg.selectAll("span").attr("style", node.labelStyle);
            else shapeSvg.selectAll("span").attr("style", styles);
            if (!useHtmlLabels) {
                const colorRegex = RegExp(/color\s*:\s*([^;]*)/);
                const match = colorRegex.exec(styles);
                if (match) {
                    const colorStyle = match[0].replace("color", "fill");
                    shapeSvg.selectAll("tspan").attr("style", colorStyle);
                } else if (labelStyles) {
                    const match2 = colorRegex.exec(labelStyles);
                    if (match2) {
                        const colorStyle = match2[0].replace("color", "fill");
                        shapeSvg.selectAll("tspan").attr("style", colorStyle);
                    }
                }
            }
            updateNodeBounds(node, rect2);
            node.intersect = function(point) {
                return intersect_default.rect(node, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(classBox, "classBox");
        var colorFromPriority = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((priority)=>{
            switch(priority){
                case "Very High":
                    return "red";
                case "High":
                    return "orange";
                case "Medium":
                    return null;
                case "Low":
                    return "blue";
                case "Very Low":
                    return "lightblue";
            }
        }, "colorFromPriority");
        async function kanbanItem(parent, kanbanNode, { config }) {
            const { labelStyles, nodeStyles } = styles2String(kanbanNode);
            kanbanNode.labelStyle = labelStyles || "";
            const labelPaddingX = 10;
            const orgWidth = kanbanNode.width;
            kanbanNode.width = (kanbanNode.width ?? 200) - 10;
            const { shapeSvg, bbox, label: labelElTitle } = await labelHelper(parent, kanbanNode, getNodeClasses(kanbanNode));
            const padding = kanbanNode.padding || 10;
            let ticketUrl = "";
            let link;
            if ("ticket" in kanbanNode && kanbanNode.ticket && config?.kanban?.ticketBaseUrl) {
                ticketUrl = config?.kanban?.ticketBaseUrl.replace("#TICKET#", kanbanNode.ticket);
                link = shapeSvg.insert("svg:a", ":first-child").attr("class", "kanban-ticket-link").attr("xlink:href", ticketUrl).attr("target", "_blank");
            }
            const options = {
                useHtmlLabels: kanbanNode.useHtmlLabels,
                labelStyle: kanbanNode.labelStyle || "",
                width: kanbanNode.width,
                img: kanbanNode.img,
                padding: kanbanNode.padding || 8,
                centerLabel: false
            };
            let labelEl, bbox2;
            if (link) ({ label: labelEl, bbox: bbox2 } = await insertLabel(link, "ticket" in kanbanNode && kanbanNode.ticket || "", options));
            else ({ label: labelEl, bbox: bbox2 } = await insertLabel(shapeSvg, "ticket" in kanbanNode && kanbanNode.ticket || "", options));
            const { label: labelElAssigned, bbox: bboxAssigned } = await insertLabel(shapeSvg, "assigned" in kanbanNode && kanbanNode.assigned || "", options);
            kanbanNode.width = orgWidth;
            const labelPaddingY = 10;
            const totalWidth = kanbanNode?.width || 0;
            const heightAdj = Math.max(bbox2.height, bboxAssigned.height) / 2;
            const totalHeight = Math.max(bbox.height + 2 * labelPaddingY, kanbanNode?.height || 0) + heightAdj;
            const x = -totalWidth / 2;
            const y = -totalHeight / 2;
            labelElTitle.attr("transform", "translate(" + (padding - totalWidth / 2) + ", " + (-heightAdj - bbox.height / 2) + ")");
            labelEl.attr("transform", "translate(" + (padding - totalWidth / 2) + ", " + (-heightAdj + bbox.height / 2) + ")");
            labelElAssigned.attr("transform", "translate(" + (padding + totalWidth / 2 - bboxAssigned.width - 2 * labelPaddingX) + ", " + (-heightAdj + bbox.height / 2) + ")");
            let rect2;
            const { rx, ry } = kanbanNode;
            const { cssStyles } = kanbanNode;
            if ("handDrawn" === kanbanNode.look) {
                const rc = roughjs__WEBPACK_IMPORTED_MODULE_6__.Z.svg(shapeSvg);
                const options2 = userNodeOverrides(kanbanNode, {});
                const roughNode = rx || ry ? rc.path(createRoundedRectPathD(x, y, totalWidth, totalHeight, rx || 0), options2) : rc.rectangle(x, y, totalWidth, totalHeight, options2);
                rect2 = shapeSvg.insert(()=>roughNode, ":first-child");
                rect2.attr("class", "basic label-container").attr("style", cssStyles ? cssStyles : null);
            } else {
                rect2 = shapeSvg.insert("rect", ":first-child");
                rect2.attr("class", "basic label-container __APA__").attr("style", nodeStyles).attr("rx", rx ?? 5).attr("ry", ry ?? 5).attr("x", x).attr("y", y).attr("width", totalWidth).attr("height", totalHeight);
                const priority = "priority" in kanbanNode && kanbanNode.priority;
                if (priority) {
                    const line = shapeSvg.append("line");
                    const lineX = x + 2;
                    const y1 = y + Math.floor((rx ?? 0) / 2);
                    const y2 = y + totalHeight - Math.floor((rx ?? 0) / 2);
                    line.attr("x1", lineX).attr("y1", y1).attr("x2", lineX).attr("y2", y2).attr("stroke-width", "4").attr("stroke", colorFromPriority(priority));
                }
            }
            updateNodeBounds(kanbanNode, rect2);
            kanbanNode.height = totalHeight;
            kanbanNode.intersect = function(point) {
                return intersect_default.rect(kanbanNode, point);
            };
            return shapeSvg;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(kanbanItem, "kanbanItem");
        var shapesDefs = [
            {
                semanticName: "Process",
                name: "Rectangle",
                shortName: "rect",
                description: "Standard process shape",
                aliases: [
                    "proc",
                    "process",
                    "rectangle"
                ],
                internalAliases: [
                    "squareRect"
                ],
                handler: squareRect2
            },
            {
                semanticName: "Event",
                name: "Rounded Rectangle",
                shortName: "rounded",
                description: "Represents an event",
                aliases: [
                    "event"
                ],
                internalAliases: [
                    "roundedRect"
                ],
                handler: roundedRect
            },
            {
                semanticName: "Terminal Point",
                name: "Stadium",
                shortName: "stadium",
                description: "Terminal point",
                aliases: [
                    "terminal",
                    "pill"
                ],
                handler: stadium
            },
            {
                semanticName: "Subprocess",
                name: "Framed Rectangle",
                shortName: "fr-rect",
                description: "Subprocess",
                aliases: [
                    "subprocess",
                    "subproc",
                    "framed-rectangle",
                    "subroutine"
                ],
                handler: subroutine
            },
            {
                semanticName: "Database",
                name: "Cylinder",
                shortName: "cyl",
                description: "Database storage",
                aliases: [
                    "db",
                    "database",
                    "cylinder"
                ],
                handler: cylinder
            },
            {
                semanticName: "Start",
                name: "Circle",
                shortName: "circle",
                description: "Starting point",
                aliases: [
                    "circ"
                ],
                handler: circle
            },
            {
                semanticName: "Decision",
                name: "Diamond",
                shortName: "diam",
                description: "Decision-making step",
                aliases: [
                    "decision",
                    "diamond",
                    "question"
                ],
                handler: question
            },
            {
                semanticName: "Prepare Conditional",
                name: "Hexagon",
                shortName: "hex",
                description: "Preparation or condition step",
                aliases: [
                    "hexagon",
                    "prepare"
                ],
                handler: hexagon
            },
            {
                semanticName: "Data Input/Output",
                name: "Lean Right",
                shortName: "lean-r",
                description: "Represents input or output",
                aliases: [
                    "lean-right",
                    "in-out"
                ],
                internalAliases: [
                    "lean_right"
                ],
                handler: lean_right
            },
            {
                semanticName: "Data Input/Output",
                name: "Lean Left",
                shortName: "lean-l",
                description: "Represents output or input",
                aliases: [
                    "lean-left",
                    "out-in"
                ],
                internalAliases: [
                    "lean_left"
                ],
                handler: lean_left
            },
            {
                semanticName: "Priority Action",
                name: "Trapezoid Base Bottom",
                shortName: "trap-b",
                description: "Priority action",
                aliases: [
                    "priority",
                    "trapezoid-bottom",
                    "trapezoid"
                ],
                handler: trapezoid
            },
            {
                semanticName: "Manual Operation",
                name: "Trapezoid Base Top",
                shortName: "trap-t",
                description: "Represents a manual task",
                aliases: [
                    "manual",
                    "trapezoid-top",
                    "inv-trapezoid"
                ],
                internalAliases: [
                    "inv_trapezoid"
                ],
                handler: inv_trapezoid
            },
            {
                semanticName: "Stop",
                name: "Double Circle",
                shortName: "dbl-circ",
                description: "Represents a stop point",
                aliases: [
                    "double-circle"
                ],
                internalAliases: [
                    "doublecircle"
                ],
                handler: doublecircle
            },
            {
                semanticName: "Text Block",
                name: "Text Block",
                shortName: "text",
                description: "Text block",
                handler: text
            },
            {
                semanticName: "Card",
                name: "Notched Rectangle",
                shortName: "notch-rect",
                description: "Represents a card",
                aliases: [
                    "card",
                    "notched-rectangle"
                ],
                handler: card
            },
            {
                semanticName: "Lined/Shaded Process",
                name: "Lined Rectangle",
                shortName: "lin-rect",
                description: "Lined process shape",
                aliases: [
                    "lined-rectangle",
                    "lined-process",
                    "lin-proc",
                    "shaded-process"
                ],
                handler: shadedProcess
            },
            {
                semanticName: "Start",
                name: "Small Circle",
                shortName: "sm-circ",
                description: "Small starting point",
                aliases: [
                    "start",
                    "small-circle"
                ],
                internalAliases: [
                    "stateStart"
                ],
                handler: stateStart
            },
            {
                semanticName: "Stop",
                name: "Framed Circle",
                shortName: "fr-circ",
                description: "Stop point",
                aliases: [
                    "stop",
                    "framed-circle"
                ],
                internalAliases: [
                    "stateEnd"
                ],
                handler: stateEnd
            },
            {
                semanticName: "Fork/Join",
                name: "Filled Rectangle",
                shortName: "fork",
                description: "Fork or join in process flow",
                aliases: [
                    "join"
                ],
                internalAliases: [
                    "forkJoin"
                ],
                handler: forkJoin
            },
            {
                semanticName: "Collate",
                name: "Hourglass",
                shortName: "hourglass",
                description: "Represents a collate operation",
                aliases: [
                    "hourglass",
                    "collate"
                ],
                handler: hourglass
            },
            {
                semanticName: "Comment",
                name: "Curly Brace",
                shortName: "brace",
                description: "Adds a comment",
                aliases: [
                    "comment",
                    "brace-l"
                ],
                handler: curlyBraceLeft
            },
            {
                semanticName: "Comment Right",
                name: "Curly Brace",
                shortName: "brace-r",
                description: "Adds a comment",
                handler: curlyBraceRight
            },
            {
                semanticName: "Comment with braces on both sides",
                name: "Curly Braces",
                shortName: "braces",
                description: "Adds a comment",
                handler: curlyBraces
            },
            {
                semanticName: "Com Link",
                name: "Lightning Bolt",
                shortName: "bolt",
                description: "Communication link",
                aliases: [
                    "com-link",
                    "lightning-bolt"
                ],
                handler: lightningBolt
            },
            {
                semanticName: "Document",
                name: "Document",
                shortName: "doc",
                description: "Represents a document",
                aliases: [
                    "doc",
                    "document"
                ],
                handler: waveEdgedRectangle
            },
            {
                semanticName: "Delay",
                name: "Half-Rounded Rectangle",
                shortName: "delay",
                description: "Represents a delay",
                aliases: [
                    "half-rounded-rectangle"
                ],
                handler: halfRoundedRectangle
            },
            {
                semanticName: "Direct Access Storage",
                name: "Horizontal Cylinder",
                shortName: "h-cyl",
                description: "Direct access storage",
                aliases: [
                    "das",
                    "horizontal-cylinder"
                ],
                handler: tiltedCylinder
            },
            {
                semanticName: "Disk Storage",
                name: "Lined Cylinder",
                shortName: "lin-cyl",
                description: "Disk storage",
                aliases: [
                    "disk",
                    "lined-cylinder"
                ],
                handler: linedCylinder
            },
            {
                semanticName: "Display",
                name: "Curved Trapezoid",
                shortName: "curv-trap",
                description: "Represents a display",
                aliases: [
                    "curved-trapezoid",
                    "display"
                ],
                handler: curvedTrapezoid
            },
            {
                semanticName: "Divided Process",
                name: "Divided Rectangle",
                shortName: "div-rect",
                description: "Divided process shape",
                aliases: [
                    "div-proc",
                    "divided-rectangle",
                    "divided-process"
                ],
                handler: dividedRectangle
            },
            {
                semanticName: "Extract",
                name: "Triangle",
                shortName: "tri",
                description: "Extraction process",
                aliases: [
                    "extract",
                    "triangle"
                ],
                handler: triangle
            },
            {
                semanticName: "Internal Storage",
                name: "Window Pane",
                shortName: "win-pane",
                description: "Internal storage",
                aliases: [
                    "internal-storage",
                    "window-pane"
                ],
                handler: windowPane
            },
            {
                semanticName: "Junction",
                name: "Filled Circle",
                shortName: "f-circ",
                description: "Junction point",
                aliases: [
                    "junction",
                    "filled-circle"
                ],
                handler: filledCircle
            },
            {
                semanticName: "Loop Limit",
                name: "Trapezoidal Pentagon",
                shortName: "notch-pent",
                description: "Loop limit step",
                aliases: [
                    "loop-limit",
                    "notched-pentagon"
                ],
                handler: trapezoidalPentagon
            },
            {
                semanticName: "Manual File",
                name: "Flipped Triangle",
                shortName: "flip-tri",
                description: "Manual file operation",
                aliases: [
                    "manual-file",
                    "flipped-triangle"
                ],
                handler: flippedTriangle
            },
            {
                semanticName: "Manual Input",
                name: "Sloped Rectangle",
                shortName: "sl-rect",
                description: "Manual input step",
                aliases: [
                    "manual-input",
                    "sloped-rectangle"
                ],
                handler: slopedRect
            },
            {
                semanticName: "Multi-Document",
                name: "Stacked Document",
                shortName: "docs",
                description: "Multiple documents",
                aliases: [
                    "documents",
                    "st-doc",
                    "stacked-document"
                ],
                handler: multiWaveEdgedRectangle
            },
            {
                semanticName: "Multi-Process",
                name: "Stacked Rectangle",
                shortName: "st-rect",
                description: "Multiple processes",
                aliases: [
                    "procs",
                    "processes",
                    "stacked-rectangle"
                ],
                handler: multiRect
            },
            {
                semanticName: "Stored Data",
                name: "Bow Tie Rectangle",
                shortName: "bow-rect",
                description: "Stored data",
                aliases: [
                    "stored-data",
                    "bow-tie-rectangle"
                ],
                handler: bowTieRect
            },
            {
                semanticName: "Summary",
                name: "Crossed Circle",
                shortName: "cross-circ",
                description: "Summary",
                aliases: [
                    "summary",
                    "crossed-circle"
                ],
                handler: crossedCircle
            },
            {
                semanticName: "Tagged Document",
                name: "Tagged Document",
                shortName: "tag-doc",
                description: "Tagged document",
                aliases: [
                    "tag-doc",
                    "tagged-document"
                ],
                handler: taggedWaveEdgedRectangle
            },
            {
                semanticName: "Tagged Process",
                name: "Tagged Rectangle",
                shortName: "tag-rect",
                description: "Tagged process",
                aliases: [
                    "tagged-rectangle",
                    "tag-proc",
                    "tagged-process"
                ],
                handler: taggedRect
            },
            {
                semanticName: "Paper Tape",
                name: "Flag",
                shortName: "flag",
                description: "Paper tape",
                aliases: [
                    "paper-tape"
                ],
                handler: waveRectangle
            },
            {
                semanticName: "Odd",
                name: "Odd",
                shortName: "odd",
                description: "Odd shape",
                internalAliases: [
                    "rect_left_inv_arrow"
                ],
                handler: rect_left_inv_arrow
            },
            {
                semanticName: "Lined Document",
                name: "Lined Document",
                shortName: "lin-doc",
                description: "Lined document",
                aliases: [
                    "lined-document"
                ],
                handler: linedWaveEdgedRect
            }
        ];
        var generateShapeMap = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(()=>{
            const undocumentedShapes = {
                state,
                choice,
                note,
                rectWithTitle,
                labelRect,
                iconSquare,
                iconCircle,
                icon,
                iconRounded,
                imageSquare,
                anchor,
                kanbanItem,
                classBox
            };
            const entries = [
                ...Object.entries(undocumentedShapes),
                ...shapesDefs.flatMap((shape)=>{
                    const aliases = [
                        shape.shortName,
                        ..."aliases" in shape ? shape.aliases : [],
                        ..."internalAliases" in shape ? shape.internalAliases : []
                    ];
                    return aliases.map((alias)=>[
                            alias,
                            shape.handler
                        ]);
                })
            ];
            return Object.fromEntries(entries);
        }, "generateShapeMap");
        var shapes2 = generateShapeMap();
        function isValidShape(shape) {
            return shape in shapes2;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(isValidShape, "isValidShape");
        var nodeElems = /* @__PURE__ */ new Map();
        async function insertNode(elem, node, renderOptions) {
            let newEl;
            let el;
            if ("rect" === node.shape) {
                if (node.rx && node.ry) node.shape = "roundedRect";
                else node.shape = "squareRect";
            }
            const shapeHandler = node.shape ? shapes2[node.shape] : void 0;
            if (!shapeHandler) throw new Error(`No such shape: ${node.shape}. Please check your syntax.`);
            if (node.link) {
                let target;
                if ("sandbox" === renderOptions.config.securityLevel) target = "_top";
                else if (node.linkTarget) target = node.linkTarget || "_blank";
                newEl = elem.insert("svg:a").attr("xlink:href", node.link).attr("target", target ?? null);
                el = await shapeHandler(newEl, node, renderOptions);
            } else {
                el = await shapeHandler(elem, node, renderOptions);
                newEl = el;
            }
            if (node.tooltip) el.attr("title", node.tooltip);
            nodeElems.set(node.id, newEl);
            if (node.haveCallback) newEl.attr("class", newEl.attr("class") + " clickable");
            return newEl;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(insertNode, "insertNode");
        var setNodeElem = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((elem, node)=>{
            nodeElems.set(node.id, elem);
        }, "setNodeElem");
        var clear2 = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)(()=>{
            nodeElems.clear();
        }, "clear");
        var positionNode = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.eW)((node)=>{
            const el = nodeElems.get(node.id);
            _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_4__.cM.trace("Transforming node", node.diff, node, "translate(" + (node.x - node.width / 2 - 5) + ", " + node.width / 2 + ")");
            const padding = 8;
            const diff = node.diff || 0;
            if (node.clusterNode) el.attr("transform", "translate(" + (node.x + diff - node.width / 2) + ", " + (node.y - node.height / 2 - padding) + ")");
            else el.attr("transform", "translate(" + node.x + ", " + node.y + ")");
            return diff;
        }, "positionNode");
    },
    "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-BO7VGL7K.mjs": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            _b: ()=>getRegisteredLayoutAlgorithm,
            jM: ()=>registerLayoutLoaders,
            sY: ()=>render
        });
        var _chunk_66SQ7PYY_mjs__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-66SQ7PYY.mjs");
        var _chunk_7NZE2EM7_mjs__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-7NZE2EM7.mjs");
        var _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-7DKRZKHE.mjs");
        var _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-6DBFFHIP.mjs");
        var internalHelpers = {
            common: _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_3__.SY,
            getConfig: _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_3__.iE,
            insertCluster: _chunk_7NZE2EM7_mjs__WEBPACK_IMPORTED_MODULE_1__.us,
            insertEdge: _chunk_66SQ7PYY_mjs__WEBPACK_IMPORTED_MODULE_0__.QP,
            insertEdgeLabel: _chunk_66SQ7PYY_mjs__WEBPACK_IMPORTED_MODULE_0__.I_,
            insertMarkers: _chunk_66SQ7PYY_mjs__WEBPACK_IMPORTED_MODULE_0__.DQ,
            insertNode: _chunk_7NZE2EM7_mjs__WEBPACK_IMPORTED_MODULE_1__.Lf,
            interpolateToCurve: _chunk_7DKRZKHE_mjs__WEBPACK_IMPORTED_MODULE_2__.le,
            labelHelper: _chunk_7NZE2EM7_mjs__WEBPACK_IMPORTED_MODULE_1__.C1,
            log: _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_3__.cM,
            positionEdgeLabel: _chunk_66SQ7PYY_mjs__WEBPACK_IMPORTED_MODULE_0__.Jj
        };
        var layoutAlgorithms = {};
        var registerLayoutLoaders = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_3__.eW)((loaders)=>{
            for (const loader of loaders)layoutAlgorithms[loader.name] = loader;
        }, "registerLayoutLoaders");
        var registerDefaultLayoutLoaders = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_3__.eW)(()=>{
            registerLayoutLoaders([
                {
                    name: "dagre",
                    loader: /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_3__.eW)(async ()=>await Promise.all([
                            __webpack_require__.e("603"),
                            __webpack_require__.e("226"),
                            __webpack_require__.e("886")
                        ]).then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/dagre-4EVJKHTY.mjs")), "loader")
                }
            ]);
        }, "registerDefaultLayoutLoaders");
        registerDefaultLayoutLoaders();
        var render = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_3__.eW)(async (data4Layout, svg)=>{
            if (!(data4Layout.layoutAlgorithm in layoutAlgorithms)) throw new Error(`Unknown layout algorithm: ${data4Layout.layoutAlgorithm}`);
            const layoutDefinition = layoutAlgorithms[data4Layout.layoutAlgorithm];
            const layoutRenderer = await layoutDefinition.loader();
            return layoutRenderer.render(data4Layout, svg, internalHelpers, {
                algorithm: layoutDefinition.algorithm
            });
        }, "render");
        var getRegisteredLayoutAlgorithm = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_3__.eW)((algorithm = "", { fallback = "dagre" } = {})=>{
            if (algorithm in layoutAlgorithms) return algorithm;
            if (fallback in layoutAlgorithms) {
                _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_3__.cM.warn(`Layout algorithm ${algorithm} is not registered. Using ${fallback} as fallback.`);
                return fallback;
            }
            throw new Error(`Both layout algorithms ${algorithm} and ${fallback} are not registered.`);
        }, "getRegisteredLayoutAlgorithm");
    },
    "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-EJ4ZWXGL.mjs": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            P: ()=>selectSvgElement
        });
        var _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-6DBFFHIP.mjs");
        var d3__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("./node_modules/.pnpm/d3@7.9.0/node_modules/d3/src/index.js");
        var selectSvgElement = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)((id)=>{
            const { securityLevel } = (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.nV)();
            let root = (0, d3__WEBPACK_IMPORTED_MODULE_1__.Ys)("body");
            if ("sandbox" === securityLevel) {
                const sandboxElement = (0, d3__WEBPACK_IMPORTED_MODULE_1__.Ys)(`#i${id}`);
                const doc = sandboxElement.node()?.contentDocument ?? document;
                root = (0, d3__WEBPACK_IMPORTED_MODULE_1__.Ys)(doc.body);
            }
            const svg = root.select(`#${id}`);
            return svg;
        }, "selectSvgElement");
    },
    "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-K6PMAZHR.mjs": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            i: ()=>version
        });
        var version = "11.4.1";
    },
    "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-OPO4IU42.mjs": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            ef: ()=>registerIconPacks,
            cN: ()=>unknownIcon,
            s4: ()=>getIconSVG
        });
        var chunk_6DBFFHIP = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-6DBFFHIP.mjs");
        const stringToIcon = (value, validate, allowSimpleName, provider = "")=>{
            const colonSeparated = value.split(":");
            if ("@" === value.slice(0, 1)) {
                if (colonSeparated.length < 2 || colonSeparated.length > 3) return null;
                provider = colonSeparated.shift().slice(1);
            }
            if (colonSeparated.length > 3 || !colonSeparated.length) return null;
            if (colonSeparated.length > 1) {
                const name2 = colonSeparated.pop();
                const prefix = colonSeparated.pop();
                const result = {
                    provider: colonSeparated.length > 0 ? colonSeparated[0] : provider,
                    prefix,
                    name: name2
                };
                return validate && !validateIconName(result) ? null : result;
            }
            const name = colonSeparated[0];
            const dashSeparated = name.split("-");
            if (dashSeparated.length > 1) {
                const result = {
                    provider,
                    prefix: dashSeparated.shift(),
                    name: dashSeparated.join("-")
                };
                return validate && !validateIconName(result) ? null : result;
            }
            if (allowSimpleName && "" === provider) {
                const result = {
                    provider,
                    prefix: "",
                    name
                };
                return validate && !validateIconName(result, allowSimpleName) ? null : result;
            }
            return null;
        };
        const validateIconName = (icon, allowSimpleName)=>{
            if (!icon) return false;
            return !!((allowSimpleName && "" === icon.prefix || !!icon.prefix) && !!icon.name);
        };
        const defaultIconDimensions = Object.freeze({
            left: 0,
            top: 0,
            width: 16,
            height: 16
        });
        const defaultIconTransformations = Object.freeze({
            rotate: 0,
            vFlip: false,
            hFlip: false
        });
        const defaultIconProps = Object.freeze({
            ...defaultIconDimensions,
            ...defaultIconTransformations
        });
        const defaultExtendedIconProps = Object.freeze({
            ...defaultIconProps,
            body: "",
            hidden: false
        });
        function mergeIconTransformations(obj1, obj2) {
            const result = {};
            if (!obj1.hFlip !== !obj2.hFlip) result.hFlip = true;
            if (!obj1.vFlip !== !obj2.vFlip) result.vFlip = true;
            const rotate = ((obj1.rotate || 0) + (obj2.rotate || 0)) % 4;
            if (rotate) result.rotate = rotate;
            return result;
        }
        function mergeIconData(parent, child) {
            const result = mergeIconTransformations(parent, child);
            for(const key in defaultExtendedIconProps)if (key in defaultIconTransformations) {
                if (key in parent && !(key in result)) result[key] = defaultIconTransformations[key];
            } else if (key in child) result[key] = child[key];
            else if (key in parent) result[key] = parent[key];
            return result;
        }
        function getIconsTree(data, names) {
            const icons = data.icons;
            const aliases = data.aliases || /* @__PURE__ */ Object.create(null);
            const resolved = /* @__PURE__ */ Object.create(null);
            function resolve(name) {
                if (icons[name]) return resolved[name] = [];
                if (!(name in resolved)) {
                    resolved[name] = null;
                    const parent = aliases[name] && aliases[name].parent;
                    const value = parent && resolve(parent);
                    if (value) resolved[name] = [
                        parent
                    ].concat(value);
                }
                return resolved[name];
            }
            (names || Object.keys(icons).concat(Object.keys(aliases))).forEach(resolve);
            return resolved;
        }
        function internalGetIconData(data, name, tree) {
            const icons = data.icons;
            const aliases = data.aliases || /* @__PURE__ */ Object.create(null);
            let currentProps = {};
            function parse(name2) {
                currentProps = mergeIconData(icons[name2] || aliases[name2], currentProps);
            }
            parse(name);
            tree.forEach(parse);
            return mergeIconData(data, currentProps);
        }
        function getIconData(data, name) {
            if (data.icons[name]) return internalGetIconData(data, name, []);
            const tree = getIconsTree(data, [
                name
            ])[name];
            return tree ? internalGetIconData(data, name, tree) : null;
        }
        const defaultIconSizeCustomisations = Object.freeze({
            width: null,
            height: null
        });
        const defaultIconCustomisations = Object.freeze({
            ...defaultIconSizeCustomisations,
            ...defaultIconTransformations
        });
        const unitsSplit = /(-?[0-9.]*[0-9]+[0-9.]*)/g;
        const unitsTest = /^-?[0-9.]*[0-9]+[0-9.]*$/g;
        function calculateSize(size, ratio, precision) {
            if (1 === ratio) return size;
            precision = precision || 100;
            if ("number" == typeof size) return Math.ceil(size * ratio * precision) / precision;
            if ("string" != typeof size) return size;
            const oldParts = size.split(unitsSplit);
            if (null === oldParts || !oldParts.length) return size;
            const newParts = [];
            let code = oldParts.shift();
            let isNumber = unitsTest.test(code);
            while(true){
                if (isNumber) {
                    const num = parseFloat(code);
                    if (isNaN(num)) newParts.push(code);
                    else newParts.push(Math.ceil(num * ratio * precision) / precision);
                } else newParts.push(code);
                code = oldParts.shift();
                if (void 0 === code) return newParts.join("");
                isNumber = !isNumber;
            }
        }
        function splitSVGDefs(content, tag = "defs") {
            let defs = "";
            const index = content.indexOf("<" + tag);
            while(index >= 0){
                const start = content.indexOf(">", index);
                const end = content.indexOf("</" + tag);
                if (-1 === start || -1 === end) break;
                const endEnd = content.indexOf(">", end);
                if (-1 === endEnd) break;
                defs += content.slice(start + 1, end).trim();
                content = content.slice(0, index).trim() + content.slice(endEnd + 1);
            }
            return {
                defs,
                content
            };
        }
        function mergeDefsAndContent(defs, content) {
            return defs ? "<defs>" + defs + "</defs>" + content : content;
        }
        function wrapSVGContent(body, start, end) {
            const split = splitSVGDefs(body);
            return mergeDefsAndContent(split.defs, start + split.content + end);
        }
        const isUnsetKeyword = (value)=>"unset" === value || "undefined" === value || "none" === value;
        function iconToSVG(icon, customisations) {
            const fullIcon = {
                ...defaultIconProps,
                ...icon
            };
            const fullCustomisations = {
                ...defaultIconCustomisations,
                ...customisations
            };
            const box = {
                left: fullIcon.left,
                top: fullIcon.top,
                width: fullIcon.width,
                height: fullIcon.height
            };
            let body = fullIcon.body;
            [
                fullIcon,
                fullCustomisations
            ].forEach((props)=>{
                const transformations = [];
                const hFlip = props.hFlip;
                const vFlip = props.vFlip;
                let rotation = props.rotate;
                if (hFlip) {
                    if (vFlip) rotation += 2;
                    else {
                        transformations.push("translate(" + (box.width + box.left).toString() + " " + (0 - box.top).toString() + ")");
                        transformations.push("scale(-1 1)");
                        box.top = box.left = 0;
                    }
                } else if (vFlip) {
                    transformations.push("translate(" + (0 - box.left).toString() + " " + (box.height + box.top).toString() + ")");
                    transformations.push("scale(1 -1)");
                    box.top = box.left = 0;
                }
                let tempValue;
                if (rotation < 0) rotation -= 4 * Math.floor(rotation / 4);
                rotation %= 4;
                switch(rotation){
                    case 1:
                        tempValue = box.height / 2 + box.top;
                        transformations.unshift("rotate(90 " + tempValue.toString() + " " + tempValue.toString() + ")");
                        break;
                    case 2:
                        transformations.unshift("rotate(180 " + (box.width / 2 + box.left).toString() + " " + (box.height / 2 + box.top).toString() + ")");
                        break;
                    case 3:
                        tempValue = box.width / 2 + box.left;
                        transformations.unshift("rotate(-90 " + tempValue.toString() + " " + tempValue.toString() + ")");
                        break;
                }
                if (rotation % 2 === 1) {
                    if (box.left !== box.top) {
                        tempValue = box.left;
                        box.left = box.top;
                        box.top = tempValue;
                    }
                    if (box.width !== box.height) {
                        tempValue = box.width;
                        box.width = box.height;
                        box.height = tempValue;
                    }
                }
                if (transformations.length) body = wrapSVGContent(body, '<g transform="' + transformations.join(" ") + '">', "</g>");
            });
            const customisationsWidth = fullCustomisations.width;
            const customisationsHeight = fullCustomisations.height;
            const boxWidth = box.width;
            const boxHeight = box.height;
            let width;
            let height;
            if (null === customisationsWidth) {
                height = null === customisationsHeight ? "1em" : "auto" === customisationsHeight ? boxHeight : customisationsHeight;
                width = calculateSize(height, boxWidth / boxHeight);
            } else {
                width = "auto" === customisationsWidth ? boxWidth : customisationsWidth;
                height = null === customisationsHeight ? calculateSize(width, boxHeight / boxWidth) : "auto" === customisationsHeight ? boxHeight : customisationsHeight;
            }
            const attributes = {};
            const setAttr = (prop, value)=>{
                if (!isUnsetKeyword(value)) attributes[prop] = value.toString();
            };
            setAttr("width", width);
            setAttr("height", height);
            const viewBox = [
                box.left,
                box.top,
                boxWidth,
                boxHeight
            ];
            attributes.viewBox = viewBox.join(" ");
            return {
                attributes,
                viewBox,
                body
            };
        }
        function iconToHTML(body, attributes) {
            let renderAttribsHTML = -1 === body.indexOf("xlink:") ? "" : ' xmlns:xlink="http://www.w3.org/1999/xlink"';
            for(const attr in attributes)renderAttribsHTML += " " + attr + '="' + attributes[attr] + '"';
            return '<svg xmlns="http://www.w3.org/2000/svg"' + renderAttribsHTML + ">" + body + "</svg>";
        }
        const regex = /\sid="(\S+)"/g;
        const randomPrefix = "IconifyId" + Date.now().toString(16) + (16777216 * Math.random() | 0).toString(16);
        let counter = 0;
        function replaceIDs(body, prefix = randomPrefix) {
            const ids = [];
            let match;
            while(match = regex.exec(body))ids.push(match[1]);
            if (!ids.length) return body;
            const suffix = "suffix" + (16777216 * Math.random() | Date.now()).toString(16);
            ids.forEach((id)=>{
                const newID = "function" == typeof prefix ? prefix(id) : prefix + (counter++).toString();
                const escapedID = id.replace(/[.*+?^${}()|[\]\\]/g, "\\$&");
                body = body.replace(new RegExp('([#;"])(' + escapedID + ')([")]|\\.[a-z])', "g"), "$1" + newID + suffix + "$3");
            });
            body = body.replace(new RegExp(suffix, "g"), "");
            return body;
        }
        var unknownIcon = {
            body: '<g><rect width="80" height="80" style="fill: #087ebf; stroke-width: 0px;"/><text transform="translate(21.16 64.67)" style="fill: #fff; font-family: ArialMT, Arial; font-size: 67.75px;"><tspan x="0" y="0">?</tspan></text></g>',
            height: 80,
            width: 80
        };
        var iconsStore = /* @__PURE__ */ new Map();
        var loaderStore = /* @__PURE__ */ new Map();
        var registerIconPacks = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((iconLoaders)=>{
            for (const iconLoader of iconLoaders){
                if (!iconLoader.name) throw new Error('Invalid icon loader. Must have a "name" property with non-empty string value.');
                chunk_6DBFFHIP.cM.debug("Registering icon pack:", iconLoader.name);
                if ("loader" in iconLoader) loaderStore.set(iconLoader.name, iconLoader.loader);
                else if ("icons" in iconLoader) iconsStore.set(iconLoader.name, iconLoader.icons);
                else {
                    chunk_6DBFFHIP.cM.error("Invalid icon loader:", iconLoader);
                    throw new Error('Invalid icon loader. Must have either "icons" or "loader" property.');
                }
            }
        }, "registerIconPacks");
        var getRegisteredIconData = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async (iconName, fallbackPrefix)=>{
            const data = stringToIcon(iconName, true, void 0 !== fallbackPrefix);
            if (!data) throw new Error(`Invalid icon name: ${iconName}`);
            const prefix = data.prefix || fallbackPrefix;
            if (!prefix) throw new Error(`Icon name must contain a prefix: ${iconName}`);
            let icons = iconsStore.get(prefix);
            if (!icons) {
                const loader = loaderStore.get(prefix);
                if (!loader) throw new Error(`Icon set not found: ${data.prefix}`);
                try {
                    const loaded = await loader();
                    icons = {
                        ...loaded,
                        prefix
                    };
                    iconsStore.set(prefix, icons);
                } catch (e) {
                    chunk_6DBFFHIP.cM.error(e);
                    throw new Error(`Failed to load icon set: ${data.prefix}`);
                }
            }
            const iconData = getIconData(icons, data.name);
            if (!iconData) throw new Error(`Icon not found: ${iconName}`);
            return iconData;
        }, "getRegisteredIconData");
        var getIconSVG = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async (iconName, customisations)=>{
            let iconData;
            try {
                iconData = await getRegisteredIconData(iconName, customisations?.fallbackPrefix);
            } catch (e) {
                chunk_6DBFFHIP.cM.error(e);
                iconData = unknownIcon;
            }
            const renderData = iconToSVG(iconData, customisations);
            const svg = iconToHTML(replaceIDs(renderData.body), renderData.attributes);
            return svg;
        }, "getIconSVG");
    },
    "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-S3SWNSAA.mjs": function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {
        __webpack_require__.d(__webpack_exports__, {
            A: ()=>JSON_SCHEMA,
            z: ()=>load
        });
        var _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-6DBFFHIP.mjs");
        function isNothing(subject) {
            return null == subject;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(isNothing, "isNothing");
        function isObject(subject) {
            return "object" == typeof subject && null !== subject;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(isObject, "isObject");
        function toArray(sequence) {
            if (Array.isArray(sequence)) return sequence;
            if (isNothing(sequence)) return [];
            return [
                sequence
            ];
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(toArray, "toArray");
        function extend(target, source) {
            var index, length, key, sourceKeys;
            if (source) {
                sourceKeys = Object.keys(source);
                for(index = 0, length = sourceKeys.length; index < length; index += 1){
                    key = sourceKeys[index];
                    target[key] = source[key];
                }
            }
            return target;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(extend, "extend");
        function repeat(string, count) {
            var result = "", cycle;
            for(cycle = 0; cycle < count; cycle += 1)result += string;
            return result;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(repeat, "repeat");
        function isNegativeZero(number) {
            return 0 === number && Number.NEGATIVE_INFINITY === 1 / number;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(isNegativeZero, "isNegativeZero");
        var isNothing_1 = isNothing;
        var isObject_1 = isObject;
        var toArray_1 = toArray;
        var repeat_1 = repeat;
        var isNegativeZero_1 = isNegativeZero;
        var extend_1 = extend;
        var common = {
            isNothing: isNothing_1,
            isObject: isObject_1,
            toArray: toArray_1,
            repeat: repeat_1,
            isNegativeZero: isNegativeZero_1,
            extend: extend_1
        };
        function formatError(exception2, compact) {
            var where = "", message = exception2.reason || "(unknown reason)";
            if (!exception2.mark) return message;
            if (exception2.mark.name) where += 'in "' + exception2.mark.name + '" ';
            where += "(" + (exception2.mark.line + 1) + ":" + (exception2.mark.column + 1) + ")";
            if (!compact && exception2.mark.snippet) where += "\n\n" + exception2.mark.snippet;
            return message + " " + where;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(formatError, "formatError");
        function YAMLException$1(reason, mark) {
            Error.call(this);
            this.name = "YAMLException";
            this.reason = reason;
            this.mark = mark;
            this.message = formatError(this, false);
            if (Error.captureStackTrace) Error.captureStackTrace(this, this.constructor);
            else this.stack = new Error().stack || "";
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(YAMLException$1, "YAMLException$1");
        YAMLException$1.prototype = Object.create(Error.prototype);
        YAMLException$1.prototype.constructor = YAMLException$1;
        YAMLException$1.prototype.toString = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(compact) {
            return this.name + ": " + formatError(this, compact);
        }, "toString");
        var exception = YAMLException$1;
        function getLine(buffer, lineStart, lineEnd, position, maxLineLength) {
            var head = "";
            var tail = "";
            var maxHalfLength = Math.floor(maxLineLength / 2) - 1;
            if (position - lineStart > maxHalfLength) {
                head = " ... ";
                lineStart = position - maxHalfLength + head.length;
            }
            if (lineEnd - position > maxHalfLength) {
                tail = " ...";
                lineEnd = position + maxHalfLength - tail.length;
            }
            return {
                str: head + buffer.slice(lineStart, lineEnd).replace(/\t/g, "\u2192") + tail,
                pos: position - lineStart + head.length
            };
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(getLine, "getLine");
        function padStart(string, max) {
            return common.repeat(" ", max - string.length) + string;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(padStart, "padStart");
        function makeSnippet(mark, options) {
            options = Object.create(options || null);
            if (!mark.buffer) return null;
            if (!options.maxLength) options.maxLength = 79;
            if ("number" != typeof options.indent) options.indent = 1;
            if ("number" != typeof options.linesBefore) options.linesBefore = 3;
            if ("number" != typeof options.linesAfter) options.linesAfter = 2;
            var re = /\r?\n|\r|\0/g;
            var lineStarts = [
                0
            ];
            var lineEnds = [];
            var match;
            var foundLineNo = -1;
            while(match = re.exec(mark.buffer)){
                lineEnds.push(match.index);
                lineStarts.push(match.index + match[0].length);
                if (mark.position <= match.index && foundLineNo < 0) foundLineNo = lineStarts.length - 2;
            }
            if (foundLineNo < 0) foundLineNo = lineStarts.length - 1;
            var result = "", i, line;
            var lineNoLength = Math.min(mark.line + options.linesAfter, lineEnds.length).toString().length;
            var maxLineLength = options.maxLength - (options.indent + lineNoLength + 3);
            for(i = 1; i <= options.linesBefore; i++){
                if (foundLineNo - i < 0) break;
                line = getLine(mark.buffer, lineStarts[foundLineNo - i], lineEnds[foundLineNo - i], mark.position - (lineStarts[foundLineNo] - lineStarts[foundLineNo - i]), maxLineLength);
                result = common.repeat(" ", options.indent) + padStart((mark.line - i + 1).toString(), lineNoLength) + " | " + line.str + "\n" + result;
            }
            line = getLine(mark.buffer, lineStarts[foundLineNo], lineEnds[foundLineNo], mark.position, maxLineLength);
            result += common.repeat(" ", options.indent) + padStart((mark.line + 1).toString(), lineNoLength) + " | " + line.str + "\n";
            result += common.repeat("-", options.indent + lineNoLength + 3 + line.pos) + "^\n";
            for(i = 1; i <= options.linesAfter; i++){
                if (foundLineNo + i >= lineEnds.length) break;
                line = getLine(mark.buffer, lineStarts[foundLineNo + i], lineEnds[foundLineNo + i], mark.position - (lineStarts[foundLineNo] - lineStarts[foundLineNo + i]), maxLineLength);
                result += common.repeat(" ", options.indent) + padStart((mark.line + i + 1).toString(), lineNoLength) + " | " + line.str + "\n";
            }
            return result.replace(/\n$/, "");
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(makeSnippet, "makeSnippet");
        var snippet = makeSnippet;
        var TYPE_CONSTRUCTOR_OPTIONS = [
            "kind",
            "multi",
            "resolve",
            "construct",
            "instanceOf",
            "predicate",
            "represent",
            "representName",
            "defaultStyle",
            "styleAliases"
        ];
        var YAML_NODE_KINDS = [
            "scalar",
            "sequence",
            "mapping"
        ];
        function compileStyleAliases(map2) {
            var result = {};
            if (null !== map2) Object.keys(map2).forEach(function(style) {
                map2[style].forEach(function(alias) {
                    result[String(alias)] = style;
                });
            });
            return result;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(compileStyleAliases, "compileStyleAliases");
        function Type$1(tag, options) {
            options = options || {};
            Object.keys(options).forEach(function(name) {
                if (-1 === TYPE_CONSTRUCTOR_OPTIONS.indexOf(name)) throw new exception('Unknown option "' + name + '" is met in definition of "' + tag + '" YAML type.');
            });
            this.options = options;
            this.tag = tag;
            this.kind = options["kind"] || null;
            this.resolve = options["resolve"] || function() {
                return true;
            };
            this.construct = options["construct"] || function(data) {
                return data;
            };
            this.instanceOf = options["instanceOf"] || null;
            this.predicate = options["predicate"] || null;
            this.represent = options["represent"] || null;
            this.representName = options["representName"] || null;
            this.defaultStyle = options["defaultStyle"] || null;
            this.multi = options["multi"] || false;
            this.styleAliases = compileStyleAliases(options["styleAliases"] || null);
            if (-1 === YAML_NODE_KINDS.indexOf(this.kind)) throw new exception('Unknown kind "' + this.kind + '" is specified for "' + tag + '" YAML type.');
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(Type$1, "Type$1");
        var type = Type$1;
        function compileList(schema2, name) {
            var result = [];
            schema2[name].forEach(function(currentType) {
                var newIndex = result.length;
                result.forEach(function(previousType, previousIndex) {
                    if (previousType.tag === currentType.tag && previousType.kind === currentType.kind && previousType.multi === currentType.multi) newIndex = previousIndex;
                });
                result[newIndex] = currentType;
            });
            return result;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(compileList, "compileList");
        function compileMap() {
            var result = {
                scalar: {},
                sequence: {},
                mapping: {},
                fallback: {},
                multi: {
                    scalar: [],
                    sequence: [],
                    mapping: [],
                    fallback: []
                }
            }, index, length;
            function collectType(type2) {
                if (type2.multi) {
                    result.multi[type2.kind].push(type2);
                    result.multi["fallback"].push(type2);
                } else result[type2.kind][type2.tag] = result["fallback"][type2.tag] = type2;
            }
            (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(collectType, "collectType");
            for(index = 0, length = arguments.length; index < length; index += 1)arguments[index].forEach(collectType);
            return result;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(compileMap, "compileMap");
        function Schema$1(definition) {
            return this.extend(definition);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(Schema$1, "Schema$1");
        Schema$1.prototype.extend = /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(definition) {
            var implicit = [];
            var explicit = [];
            if (definition instanceof type) explicit.push(definition);
            else if (Array.isArray(definition)) explicit = explicit.concat(definition);
            else if (definition && (Array.isArray(definition.implicit) || Array.isArray(definition.explicit))) {
                if (definition.implicit) implicit = implicit.concat(definition.implicit);
                if (definition.explicit) explicit = explicit.concat(definition.explicit);
            } else throw new exception("Schema.extend argument should be a Type, [ Type ], or a schema definition ({ implicit: [...], explicit: [...] })");
            implicit.forEach(function(type$1) {
                if (!(type$1 instanceof type)) throw new exception("Specified list of YAML types (or a single Type object) contains a non-Type object.");
                if (type$1.loadKind && "scalar" !== type$1.loadKind) throw new exception("There is a non-scalar type in the implicit list of a schema. Implicit resolving of such types is not supported.");
                if (type$1.multi) throw new exception("There is a multi type in the implicit list of a schema. Multi tags can only be listed as explicit.");
            });
            explicit.forEach(function(type$1) {
                if (!(type$1 instanceof type)) throw new exception("Specified list of YAML types (or a single Type object) contains a non-Type object.");
            });
            var result = Object.create(Schema$1.prototype);
            result.implicit = (this.implicit || []).concat(implicit);
            result.explicit = (this.explicit || []).concat(explicit);
            result.compiledImplicit = compileList(result, "implicit");
            result.compiledExplicit = compileList(result, "explicit");
            result.compiledTypeMap = compileMap(result.compiledImplicit, result.compiledExplicit);
            return result;
        }, "extend");
        var schema = Schema$1;
        var str = new type("tag:yaml.org,2002:str", {
            kind: "scalar",
            construct: /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(data) {
                return null !== data ? data : "";
            }, "construct")
        });
        var seq = new type("tag:yaml.org,2002:seq", {
            kind: "sequence",
            construct: /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(data) {
                return null !== data ? data : [];
            }, "construct")
        });
        var map = new type("tag:yaml.org,2002:map", {
            kind: "mapping",
            construct: /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(data) {
                return null !== data ? data : {};
            }, "construct")
        });
        var failsafe = new schema({
            explicit: [
                str,
                seq,
                map
            ]
        });
        function resolveYamlNull(data) {
            if (null === data) return true;
            var max = data.length;
            return 1 === max && "~" === data || 4 === max && ("null" === data || "Null" === data || "NULL" === data);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(resolveYamlNull, "resolveYamlNull");
        function constructYamlNull() {
            return null;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(constructYamlNull, "constructYamlNull");
        function isNull(object) {
            return null === object;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(isNull, "isNull");
        var _null = new type("tag:yaml.org,2002:null", {
            kind: "scalar",
            resolve: resolveYamlNull,
            construct: constructYamlNull,
            predicate: isNull,
            represent: {
                canonical: /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function() {
                    return "~";
                }, "canonical"),
                lowercase: /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function() {
                    return "null";
                }, "lowercase"),
                uppercase: /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function() {
                    return "NULL";
                }, "uppercase"),
                camelcase: /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function() {
                    return "Null";
                }, "camelcase"),
                empty: /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function() {
                    return "";
                }, "empty")
            },
            defaultStyle: "lowercase"
        });
        function resolveYamlBoolean(data) {
            if (null === data) return false;
            var max = data.length;
            return 4 === max && ("true" === data || "True" === data || "TRUE" === data) || 5 === max && ("false" === data || "False" === data || "FALSE" === data);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(resolveYamlBoolean, "resolveYamlBoolean");
        function constructYamlBoolean(data) {
            return "true" === data || "True" === data || "TRUE" === data;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(constructYamlBoolean, "constructYamlBoolean");
        function isBoolean(object) {
            return "[object Boolean]" === Object.prototype.toString.call(object);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(isBoolean, "isBoolean");
        var bool = new type("tag:yaml.org,2002:bool", {
            kind: "scalar",
            resolve: resolveYamlBoolean,
            construct: constructYamlBoolean,
            predicate: isBoolean,
            represent: {
                lowercase: /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(object) {
                    return object ? "true" : "false";
                }, "lowercase"),
                uppercase: /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(object) {
                    return object ? "TRUE" : "FALSE";
                }, "uppercase"),
                camelcase: /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(object) {
                    return object ? "True" : "False";
                }, "camelcase")
            },
            defaultStyle: "lowercase"
        });
        function isHexCode(c) {
            return 48 <= c && c <= 57 || 65 <= c && c <= 70 || 97 <= c && c <= 102;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(isHexCode, "isHexCode");
        function isOctCode(c) {
            return 48 <= c && c <= 55;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(isOctCode, "isOctCode");
        function isDecCode(c) {
            return 48 <= c && c <= 57;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(isDecCode, "isDecCode");
        function resolveYamlInteger(data) {
            if (null === data) return false;
            var max = data.length, index = 0, hasDigits = false, ch;
            if (!max) return false;
            ch = data[index];
            if ("-" === ch || "+" === ch) ch = data[++index];
            if ("0" === ch) {
                if (index + 1 === max) return true;
                ch = data[++index];
                if ("b" === ch) {
                    index++;
                    for(; index < max; index++){
                        ch = data[index];
                        if ("_" !== ch) {
                            if ("0" !== ch && "1" !== ch) return false;
                            hasDigits = true;
                        }
                    }
                    return hasDigits && "_" !== ch;
                }
                if ("x" === ch) {
                    index++;
                    for(; index < max; index++){
                        ch = data[index];
                        if ("_" !== ch) {
                            if (!isHexCode(data.charCodeAt(index))) return false;
                            hasDigits = true;
                        }
                    }
                    return hasDigits && "_" !== ch;
                }
                if ("o" === ch) {
                    index++;
                    for(; index < max; index++){
                        ch = data[index];
                        if ("_" !== ch) {
                            if (!isOctCode(data.charCodeAt(index))) return false;
                            hasDigits = true;
                        }
                    }
                    return hasDigits && "_" !== ch;
                }
            }
            if ("_" === ch) return false;
            for(; index < max; index++){
                ch = data[index];
                if ("_" !== ch) {
                    if (!isDecCode(data.charCodeAt(index))) return false;
                    hasDigits = true;
                }
            }
            if (!hasDigits || "_" === ch) return false;
            return true;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(resolveYamlInteger, "resolveYamlInteger");
        function constructYamlInteger(data) {
            var value = data, sign = 1, ch;
            if (-1 !== value.indexOf("_")) value = value.replace(/_/g, "");
            ch = value[0];
            if ("-" === ch || "+" === ch) {
                if ("-" === ch) sign = -1;
                value = value.slice(1);
                ch = value[0];
            }
            if ("0" === value) return 0;
            if ("0" === ch) {
                if ("b" === value[1]) return sign * parseInt(value.slice(2), 2);
                if ("x" === value[1]) return sign * parseInt(value.slice(2), 16);
                if ("o" === value[1]) return sign * parseInt(value.slice(2), 8);
            }
            return sign * parseInt(value, 10);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(constructYamlInteger, "constructYamlInteger");
        function isInteger(object) {
            return "[object Number]" === Object.prototype.toString.call(object) && object % 1 === 0 && !common.isNegativeZero(object);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(isInteger, "isInteger");
        var int = new type("tag:yaml.org,2002:int", {
            kind: "scalar",
            resolve: resolveYamlInteger,
            construct: constructYamlInteger,
            predicate: isInteger,
            represent: {
                binary: /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(obj) {
                    return obj >= 0 ? "0b" + obj.toString(2) : "-0b" + obj.toString(2).slice(1);
                }, "binary"),
                octal: /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(obj) {
                    return obj >= 0 ? "0o" + obj.toString(8) : "-0o" + obj.toString(8).slice(1);
                }, "octal"),
                decimal: /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(obj) {
                    return obj.toString(10);
                }, "decimal"),
                hexadecimal: /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(obj) {
                    return obj >= 0 ? "0x" + obj.toString(16).toUpperCase() : "-0x" + obj.toString(16).toUpperCase().slice(1);
                }, "hexadecimal")
            },
            defaultStyle: "decimal",
            styleAliases: {
                binary: [
                    2,
                    "bin"
                ],
                octal: [
                    8,
                    "oct"
                ],
                decimal: [
                    10,
                    "dec"
                ],
                hexadecimal: [
                    16,
                    "hex"
                ]
            }
        });
        var YAML_FLOAT_PATTERN = new RegExp("^(?:[-+]?(?:[0-9][0-9_]*)(?:\\.[0-9_]*)?(?:[eE][-+]?[0-9]+)?|\\.[0-9_]+(?:[eE][-+]?[0-9]+)?|[-+]?\\.(?:inf|Inf|INF)|\\.(?:nan|NaN|NAN))$");
        function resolveYamlFloat(data) {
            if (null === data) return false;
            if (!YAML_FLOAT_PATTERN.test(data) || "_" === data[data.length - 1]) return false;
            return true;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(resolveYamlFloat, "resolveYamlFloat");
        function constructYamlFloat(data) {
            var value, sign;
            value = data.replace(/_/g, "").toLowerCase();
            sign = "-" === value[0] ? -1 : 1;
            if ("+-".indexOf(value[0]) >= 0) value = value.slice(1);
            if (".inf" === value) return 1 === sign ? Number.POSITIVE_INFINITY : Number.NEGATIVE_INFINITY;
            if (".nan" === value) return NaN;
            return sign * parseFloat(value, 10);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(constructYamlFloat, "constructYamlFloat");
        var SCIENTIFIC_WITHOUT_DOT = /^[-+]?[0-9]+e/;
        function representYamlFloat(object, style) {
            var res;
            if (isNaN(object)) switch(style){
                case "lowercase":
                    return ".nan";
                case "uppercase":
                    return ".NAN";
                case "camelcase":
                    return ".NaN";
            }
            else if (Number.POSITIVE_INFINITY === object) switch(style){
                case "lowercase":
                    return ".inf";
                case "uppercase":
                    return ".INF";
                case "camelcase":
                    return ".Inf";
            }
            else if (Number.NEGATIVE_INFINITY === object) switch(style){
                case "lowercase":
                    return "-.inf";
                case "uppercase":
                    return "-.INF";
                case "camelcase":
                    return "-.Inf";
            }
            else if (common.isNegativeZero(object)) return "-0.0";
            res = object.toString(10);
            return SCIENTIFIC_WITHOUT_DOT.test(res) ? res.replace("e", ".e") : res;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(representYamlFloat, "representYamlFloat");
        function isFloat(object) {
            return "[object Number]" === Object.prototype.toString.call(object) && (object % 1 !== 0 || common.isNegativeZero(object));
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(isFloat, "isFloat");
        var float = new type("tag:yaml.org,2002:float", {
            kind: "scalar",
            resolve: resolveYamlFloat,
            construct: constructYamlFloat,
            predicate: isFloat,
            represent: representYamlFloat,
            defaultStyle: "lowercase"
        });
        var json = failsafe.extend({
            implicit: [
                _null,
                bool,
                int,
                float
            ]
        });
        var core = json;
        var YAML_DATE_REGEXP = new RegExp("^([0-9][0-9][0-9][0-9])-([0-9][0-9])-([0-9][0-9])$");
        var YAML_TIMESTAMP_REGEXP = new RegExp("^([0-9][0-9][0-9][0-9])-([0-9][0-9]?)-([0-9][0-9]?)(?:[Tt]|[ \\t]+)([0-9][0-9]?):([0-9][0-9]):([0-9][0-9])(?:\\.([0-9]*))?(?:[ \\t]*(Z|([-+])([0-9][0-9]?)(?::([0-9][0-9]))?))?$");
        function resolveYamlTimestamp(data) {
            if (null === data) return false;
            if (null !== YAML_DATE_REGEXP.exec(data)) return true;
            if (null !== YAML_TIMESTAMP_REGEXP.exec(data)) return true;
            return false;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(resolveYamlTimestamp, "resolveYamlTimestamp");
        function constructYamlTimestamp(data) {
            var match, year, month, day, hour, minute, second, fraction = 0, delta = null, tz_hour, tz_minute, date;
            match = YAML_DATE_REGEXP.exec(data);
            if (null === match) match = YAML_TIMESTAMP_REGEXP.exec(data);
            if (null === match) throw new Error("Date resolve error");
            year = +match[1];
            month = +match[2] - 1;
            day = +match[3];
            if (!match[4]) return new Date(Date.UTC(year, month, day));
            hour = +match[4];
            minute = +match[5];
            second = +match[6];
            if (match[7]) {
                fraction = match[7].slice(0, 3);
                while(fraction.length < 3)fraction += "0";
                fraction = +fraction;
            }
            if (match[9]) {
                tz_hour = +match[10];
                tz_minute = +(match[11] || 0);
                delta = (60 * tz_hour + tz_minute) * 6e4;
                if ("-" === match[9]) delta = -delta;
            }
            date = new Date(Date.UTC(year, month, day, hour, minute, second, fraction));
            if (delta) date.setTime(date.getTime() - delta);
            return date;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(constructYamlTimestamp, "constructYamlTimestamp");
        function representYamlTimestamp(object) {
            return object.toISOString();
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(representYamlTimestamp, "representYamlTimestamp");
        var timestamp = new type("tag:yaml.org,2002:timestamp", {
            kind: "scalar",
            resolve: resolveYamlTimestamp,
            construct: constructYamlTimestamp,
            instanceOf: Date,
            represent: representYamlTimestamp
        });
        function resolveYamlMerge(data) {
            return "<<" === data || null === data;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(resolveYamlMerge, "resolveYamlMerge");
        var merge = new type("tag:yaml.org,2002:merge", {
            kind: "scalar",
            resolve: resolveYamlMerge
        });
        var BASE64_MAP = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=\n\r";
        function resolveYamlBinary(data) {
            if (null === data) return false;
            var code, idx, bitlen = 0, max = data.length, map2 = BASE64_MAP;
            for(idx = 0; idx < max; idx++){
                code = map2.indexOf(data.charAt(idx));
                if (!(code > 64)) {
                    if (code < 0) return false;
                    bitlen += 6;
                }
            }
            return bitlen % 8 === 0;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(resolveYamlBinary, "resolveYamlBinary");
        function constructYamlBinary(data) {
            var idx, tailbits, input = data.replace(/[\r\n=]/g, ""), max = input.length, map2 = BASE64_MAP, bits = 0, result = [];
            for(idx = 0; idx < max; idx++){
                if (idx % 4 === 0 && idx) {
                    result.push(bits >> 16 & 255);
                    result.push(bits >> 8 & 255);
                    result.push(255 & bits);
                }
                bits = bits << 6 | map2.indexOf(input.charAt(idx));
            }
            tailbits = max % 4 * 6;
            if (0 === tailbits) {
                result.push(bits >> 16 & 255);
                result.push(bits >> 8 & 255);
                result.push(255 & bits);
            } else if (18 === tailbits) {
                result.push(bits >> 10 & 255);
                result.push(bits >> 2 & 255);
            } else if (12 === tailbits) result.push(bits >> 4 & 255);
            return new Uint8Array(result);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(constructYamlBinary, "constructYamlBinary");
        function representYamlBinary(object) {
            var result = "", bits = 0, idx, tail, max = object.length, map2 = BASE64_MAP;
            for(idx = 0; idx < max; idx++){
                if (idx % 3 === 0 && idx) {
                    result += map2[bits >> 18 & 63];
                    result += map2[bits >> 12 & 63];
                    result += map2[bits >> 6 & 63];
                    result += map2[63 & bits];
                }
                bits = (bits << 8) + object[idx];
            }
            tail = max % 3;
            if (0 === tail) {
                result += map2[bits >> 18 & 63];
                result += map2[bits >> 12 & 63];
                result += map2[bits >> 6 & 63];
                result += map2[63 & bits];
            } else if (2 === tail) {
                result += map2[bits >> 10 & 63];
                result += map2[bits >> 4 & 63];
                result += map2[bits << 2 & 63];
                result += map2[64];
            } else if (1 === tail) {
                result += map2[bits >> 2 & 63];
                result += map2[bits << 4 & 63];
                result += map2[64];
                result += map2[64];
            }
            return result;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(representYamlBinary, "representYamlBinary");
        function isBinary(obj) {
            return "[object Uint8Array]" === Object.prototype.toString.call(obj);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(isBinary, "isBinary");
        var binary = new type("tag:yaml.org,2002:binary", {
            kind: "scalar",
            resolve: resolveYamlBinary,
            construct: constructYamlBinary,
            predicate: isBinary,
            represent: representYamlBinary
        });
        var _hasOwnProperty$3 = Object.prototype.hasOwnProperty;
        var _toString$2 = Object.prototype.toString;
        function resolveYamlOmap(data) {
            if (null === data) return true;
            var objectKeys = [], index, length, pair, pairKey, pairHasKey, object = data;
            for(index = 0, length = object.length; index < length; index += 1){
                pair = object[index];
                pairHasKey = false;
                if ("[object Object]" !== _toString$2.call(pair)) return false;
                for(pairKey in pair)if (_hasOwnProperty$3.call(pair, pairKey)) {
                    if (pairHasKey) return false;
                    pairHasKey = true;
                }
                if (!pairHasKey) return false;
                if (-1 !== objectKeys.indexOf(pairKey)) return false;
                objectKeys.push(pairKey);
            }
            return true;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(resolveYamlOmap, "resolveYamlOmap");
        function constructYamlOmap(data) {
            return null !== data ? data : [];
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(constructYamlOmap, "constructYamlOmap");
        var omap = new type("tag:yaml.org,2002:omap", {
            kind: "sequence",
            resolve: resolveYamlOmap,
            construct: constructYamlOmap
        });
        var _toString$1 = Object.prototype.toString;
        function resolveYamlPairs(data) {
            if (null === data) return true;
            var index, length, pair, keys, result, object = data;
            result = new Array(object.length);
            for(index = 0, length = object.length; index < length; index += 1){
                pair = object[index];
                if ("[object Object]" !== _toString$1.call(pair)) return false;
                keys = Object.keys(pair);
                if (1 !== keys.length) return false;
                result[index] = [
                    keys[0],
                    pair[keys[0]]
                ];
            }
            return true;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(resolveYamlPairs, "resolveYamlPairs");
        function constructYamlPairs(data) {
            if (null === data) return [];
            var index, length, pair, keys, result, object = data;
            result = new Array(object.length);
            for(index = 0, length = object.length; index < length; index += 1){
                pair = object[index];
                keys = Object.keys(pair);
                result[index] = [
                    keys[0],
                    pair[keys[0]]
                ];
            }
            return result;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(constructYamlPairs, "constructYamlPairs");
        var pairs = new type("tag:yaml.org,2002:pairs", {
            kind: "sequence",
            resolve: resolveYamlPairs,
            construct: constructYamlPairs
        });
        var _hasOwnProperty$2 = Object.prototype.hasOwnProperty;
        function resolveYamlSet(data) {
            if (null === data) return true;
            var key, object = data;
            for(key in object)if (_hasOwnProperty$2.call(object, key)) {
                if (null !== object[key]) return false;
            }
            return true;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(resolveYamlSet, "resolveYamlSet");
        function constructYamlSet(data) {
            return null !== data ? data : {};
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(constructYamlSet, "constructYamlSet");
        var set = new type("tag:yaml.org,2002:set", {
            kind: "mapping",
            resolve: resolveYamlSet,
            construct: constructYamlSet
        });
        var _default = core.extend({
            implicit: [
                timestamp,
                merge
            ],
            explicit: [
                binary,
                omap,
                pairs,
                set
            ]
        });
        var _hasOwnProperty$1 = Object.prototype.hasOwnProperty;
        var CONTEXT_FLOW_IN = 1;
        var CONTEXT_FLOW_OUT = 2;
        var CONTEXT_BLOCK_IN = 3;
        var CONTEXT_BLOCK_OUT = 4;
        var CHOMPING_CLIP = 1;
        var CHOMPING_STRIP = 2;
        var CHOMPING_KEEP = 3;
        var PATTERN_NON_PRINTABLE = /[\x00-\x08\x0B\x0C\x0E-\x1F\x7F-\x84\x86-\x9F\uFFFE\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/;
        var PATTERN_NON_ASCII_LINE_BREAKS = /[\x85\u2028\u2029]/;
        var PATTERN_FLOW_INDICATORS = /[,\[\]\{\}]/;
        var PATTERN_TAG_HANDLE = /^(?:!|!!|![a-z\-]+!)$/i;
        var PATTERN_TAG_URI = /^(?:!|[^,\[\]\{\}])(?:%[0-9a-f]{2}|[0-9a-z\-#;\/\?:@&=\+\$,_\.!~\*'\(\)\[\]])*$/i;
        function _class(obj) {
            return Object.prototype.toString.call(obj);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(_class, "_class");
        function is_EOL(c) {
            return 10 === c || 13 === c;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(is_EOL, "is_EOL");
        function is_WHITE_SPACE(c) {
            return 9 === c || 32 === c;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(is_WHITE_SPACE, "is_WHITE_SPACE");
        function is_WS_OR_EOL(c) {
            return 9 === c || 32 === c || 10 === c || 13 === c;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(is_WS_OR_EOL, "is_WS_OR_EOL");
        function is_FLOW_INDICATOR(c) {
            return 44 === c || 91 === c || 93 === c || 123 === c || 125 === c;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(is_FLOW_INDICATOR, "is_FLOW_INDICATOR");
        function fromHexCode(c) {
            var lc;
            if (48 <= c && c <= 57) return c - 48;
            lc = 32 | c;
            if (97 <= lc && lc <= 102) return lc - 97 + 10;
            return -1;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(fromHexCode, "fromHexCode");
        function escapedHexLen(c) {
            if (120 === c) return 2;
            if (117 === c) return 4;
            if (85 === c) return 8;
            return 0;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(escapedHexLen, "escapedHexLen");
        function fromDecimalCode(c) {
            if (48 <= c && c <= 57) return c - 48;
            return -1;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(fromDecimalCode, "fromDecimalCode");
        function simpleEscapeSequence(c) {
            return 48 === c ? "\0" : 97 === c ? "\x07" : 98 === c ? "\b" : 116 === c ? "	" : 9 === c ? "	" : 110 === c ? "\n" : 118 === c ? "\v" : 102 === c ? "\f" : 114 === c ? "\r" : 101 === c ? "\x1B" : 32 === c ? " " : 34 === c ? '"' : 47 === c ? "/" : 92 === c ? "\\" : 78 === c ? "\x85" : 95 === c ? "\xA0" : 76 === c ? "\u2028" : 80 === c ? "\u2029" : "";
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(simpleEscapeSequence, "simpleEscapeSequence");
        function charFromCodepoint(c) {
            if (c <= 65535) return String.fromCharCode(c);
            return String.fromCharCode((c - 65536 >> 10) + 55296, (c - 65536 & 1023) + 56320);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(charFromCodepoint, "charFromCodepoint");
        var simpleEscapeCheck = new Array(256);
        var simpleEscapeMap = new Array(256);
        for(i = 0; i < 256; i++){
            simpleEscapeCheck[i] = simpleEscapeSequence(i) ? 1 : 0;
            simpleEscapeMap[i] = simpleEscapeSequence(i);
        }
        var i;
        function State$1(input, options) {
            this.input = input;
            this.filename = options["filename"] || null;
            this.schema = options["schema"] || _default;
            this.onWarning = options["onWarning"] || null;
            this.legacy = options["legacy"] || false;
            this.json = options["json"] || false;
            this.listener = options["listener"] || null;
            this.implicitTypes = this.schema.compiledImplicit;
            this.typeMap = this.schema.compiledTypeMap;
            this.length = input.length;
            this.position = 0;
            this.line = 0;
            this.lineStart = 0;
            this.lineIndent = 0;
            this.firstTabInLine = -1;
            this.documents = [];
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(State$1, "State$1");
        function generateError(state, message) {
            var mark = {
                name: state.filename,
                buffer: state.input.slice(0, -1),
                position: state.position,
                line: state.line,
                column: state.position - state.lineStart
            };
            mark.snippet = snippet(mark);
            return new exception(message, mark);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(generateError, "generateError");
        function throwError(state, message) {
            throw generateError(state, message);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(throwError, "throwError");
        function throwWarning(state, message) {
            if (state.onWarning) state.onWarning.call(null, generateError(state, message));
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(throwWarning, "throwWarning");
        var directiveHandlers = {
            YAML: /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(state, name, args) {
                var match, major, minor;
                if (null !== state.version) throwError(state, "duplication of %YAML directive");
                if (1 !== args.length) throwError(state, "YAML directive accepts exactly one argument");
                match = /^([0-9]+)\.([0-9]+)$/.exec(args[0]);
                if (null === match) throwError(state, "ill-formed argument of the YAML directive");
                major = parseInt(match[1], 10);
                minor = parseInt(match[2], 10);
                if (1 !== major) throwError(state, "unacceptable YAML version of the document");
                state.version = args[0];
                state.checkLineBreaks = minor < 2;
                if (1 !== minor && 2 !== minor) throwWarning(state, "unsupported YAML version of the document");
            }, "handleYamlDirective"),
            TAG: /* @__PURE__ */ (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(function(state, name, args) {
                var handle, prefix;
                if (2 !== args.length) throwError(state, "TAG directive accepts exactly two arguments");
                handle = args[0];
                prefix = args[1];
                if (!PATTERN_TAG_HANDLE.test(handle)) throwError(state, "ill-formed tag handle (first argument) of the TAG directive");
                if (_hasOwnProperty$1.call(state.tagMap, handle)) throwError(state, 'there is a previously declared suffix for "' + handle + '" tag handle');
                if (!PATTERN_TAG_URI.test(prefix)) throwError(state, "ill-formed tag prefix (second argument) of the TAG directive");
                try {
                    prefix = decodeURIComponent(prefix);
                } catch (err) {
                    throwError(state, "tag prefix is malformed: " + prefix);
                }
                state.tagMap[handle] = prefix;
            }, "handleTagDirective")
        };
        function captureSegment(state, start, end, checkJson) {
            var _position, _length, _character, _result;
            if (start < end) {
                _result = state.input.slice(start, end);
                if (checkJson) for(_position = 0, _length = _result.length; _position < _length; _position += 1){
                    _character = _result.charCodeAt(_position);
                    if (!(9 === _character || 32 <= _character && _character <= 1114111)) throwError(state, "expected valid JSON character");
                }
                else if (PATTERN_NON_PRINTABLE.test(_result)) throwError(state, "the stream contains non-printable characters");
                state.result += _result;
            }
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(captureSegment, "captureSegment");
        function mergeMappings(state, destination, source, overridableKeys) {
            var sourceKeys, key, index, quantity;
            if (!common.isObject(source)) throwError(state, "cannot merge mappings; the provided source object is unacceptable");
            sourceKeys = Object.keys(source);
            for(index = 0, quantity = sourceKeys.length; index < quantity; index += 1){
                key = sourceKeys[index];
                if (!_hasOwnProperty$1.call(destination, key)) {
                    destination[key] = source[key];
                    overridableKeys[key] = true;
                }
            }
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(mergeMappings, "mergeMappings");
        function storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, startLine, startLineStart, startPos) {
            var index, quantity;
            if (Array.isArray(keyNode)) {
                keyNode = Array.prototype.slice.call(keyNode);
                for(index = 0, quantity = keyNode.length; index < quantity; index += 1){
                    if (Array.isArray(keyNode[index])) throwError(state, "nested arrays are not supported inside keys");
                    if ("object" == typeof keyNode && "[object Object]" === _class(keyNode[index])) keyNode[index] = "[object Object]";
                }
            }
            if ("object" == typeof keyNode && "[object Object]" === _class(keyNode)) keyNode = "[object Object]";
            keyNode = String(keyNode);
            if (null === _result) _result = {};
            if ("tag:yaml.org,2002:merge" === keyTag) {
                if (Array.isArray(valueNode)) for(index = 0, quantity = valueNode.length; index < quantity; index += 1)mergeMappings(state, _result, valueNode[index], overridableKeys);
                else mergeMappings(state, _result, valueNode, overridableKeys);
            } else {
                if (!state.json && !_hasOwnProperty$1.call(overridableKeys, keyNode) && _hasOwnProperty$1.call(_result, keyNode)) {
                    state.line = startLine || state.line;
                    state.lineStart = startLineStart || state.lineStart;
                    state.position = startPos || state.position;
                    throwError(state, "duplicated mapping key");
                }
                if ("__proto__" === keyNode) Object.defineProperty(_result, keyNode, {
                    configurable: true,
                    enumerable: true,
                    writable: true,
                    value: valueNode
                });
                else _result[keyNode] = valueNode;
                delete overridableKeys[keyNode];
            }
            return _result;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(storeMappingPair, "storeMappingPair");
        function readLineBreak(state) {
            var ch;
            ch = state.input.charCodeAt(state.position);
            if (10 === ch) state.position++;
            else if (13 === ch) {
                state.position++;
                if (10 === state.input.charCodeAt(state.position)) state.position++;
            } else throwError(state, "a line break is expected");
            state.line += 1;
            state.lineStart = state.position;
            state.firstTabInLine = -1;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(readLineBreak, "readLineBreak");
        function skipSeparationSpace(state, allowComments, checkIndent) {
            var lineBreaks = 0, ch = state.input.charCodeAt(state.position);
            while(0 !== ch){
                while(is_WHITE_SPACE(ch)){
                    if (9 === ch && -1 === state.firstTabInLine) state.firstTabInLine = state.position;
                    ch = state.input.charCodeAt(++state.position);
                }
                if (allowComments && 35 === ch) do ch = state.input.charCodeAt(++state.position);
                while (10 !== ch && 13 !== ch && 0 !== ch);
                if (is_EOL(ch)) {
                    readLineBreak(state);
                    ch = state.input.charCodeAt(state.position);
                    lineBreaks++;
                    state.lineIndent = 0;
                    while(32 === ch){
                        state.lineIndent++;
                        ch = state.input.charCodeAt(++state.position);
                    }
                } else break;
            }
            if (-1 !== checkIndent && 0 !== lineBreaks && state.lineIndent < checkIndent) throwWarning(state, "deficient indentation");
            return lineBreaks;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(skipSeparationSpace, "skipSeparationSpace");
        function testDocumentSeparator(state) {
            var _position = state.position, ch;
            ch = state.input.charCodeAt(_position);
            if ((45 === ch || 46 === ch) && ch === state.input.charCodeAt(_position + 1) && ch === state.input.charCodeAt(_position + 2)) {
                _position += 3;
                ch = state.input.charCodeAt(_position);
                if (0 === ch || is_WS_OR_EOL(ch)) return true;
            }
            return false;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(testDocumentSeparator, "testDocumentSeparator");
        function writeFoldedLines(state, count) {
            if (1 === count) state.result += " ";
            else if (count > 1) state.result += common.repeat("\n", count - 1);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(writeFoldedLines, "writeFoldedLines");
        function readPlainScalar(state, nodeIndent, withinFlowCollection) {
            var preceding, following, captureStart, captureEnd, hasPendingContent, _line, _lineStart, _lineIndent, _kind = state.kind, _result = state.result, ch;
            ch = state.input.charCodeAt(state.position);
            if (is_WS_OR_EOL(ch) || is_FLOW_INDICATOR(ch) || 35 === ch || 38 === ch || 42 === ch || 33 === ch || 124 === ch || 62 === ch || 39 === ch || 34 === ch || 37 === ch || 64 === ch || 96 === ch) return false;
            if (63 === ch || 45 === ch) {
                following = state.input.charCodeAt(state.position + 1);
                if (is_WS_OR_EOL(following) || withinFlowCollection && is_FLOW_INDICATOR(following)) return false;
            }
            state.kind = "scalar";
            state.result = "";
            captureStart = captureEnd = state.position;
            hasPendingContent = false;
            while(0 !== ch){
                if (58 === ch) {
                    following = state.input.charCodeAt(state.position + 1);
                    if (is_WS_OR_EOL(following) || withinFlowCollection && is_FLOW_INDICATOR(following)) break;
                } else if (35 === ch) {
                    preceding = state.input.charCodeAt(state.position - 1);
                    if (is_WS_OR_EOL(preceding)) break;
                } else if (state.position === state.lineStart && testDocumentSeparator(state) || withinFlowCollection && is_FLOW_INDICATOR(ch)) break;
                else if (is_EOL(ch)) {
                    _line = state.line;
                    _lineStart = state.lineStart;
                    _lineIndent = state.lineIndent;
                    skipSeparationSpace(state, false, -1);
                    if (state.lineIndent >= nodeIndent) {
                        hasPendingContent = true;
                        ch = state.input.charCodeAt(state.position);
                        continue;
                    }
                    state.position = captureEnd;
                    state.line = _line;
                    state.lineStart = _lineStart;
                    state.lineIndent = _lineIndent;
                    break;
                }
                if (hasPendingContent) {
                    captureSegment(state, captureStart, captureEnd, false);
                    writeFoldedLines(state, state.line - _line);
                    captureStart = captureEnd = state.position;
                    hasPendingContent = false;
                }
                if (!is_WHITE_SPACE(ch)) captureEnd = state.position + 1;
                ch = state.input.charCodeAt(++state.position);
            }
            captureSegment(state, captureStart, captureEnd, false);
            if (state.result) return true;
            state.kind = _kind;
            state.result = _result;
            return false;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(readPlainScalar, "readPlainScalar");
        function readSingleQuotedScalar(state, nodeIndent) {
            var ch, captureStart, captureEnd;
            ch = state.input.charCodeAt(state.position);
            if (39 !== ch) return false;
            state.kind = "scalar";
            state.result = "";
            state.position++;
            captureStart = captureEnd = state.position;
            while(0 !== (ch = state.input.charCodeAt(state.position)))if (39 === ch) {
                captureSegment(state, captureStart, state.position, true);
                ch = state.input.charCodeAt(++state.position);
                if (39 !== ch) return true;
                captureStart = state.position;
                state.position++;
                captureEnd = state.position;
            } else if (is_EOL(ch)) {
                captureSegment(state, captureStart, captureEnd, true);
                writeFoldedLines(state, skipSeparationSpace(state, false, nodeIndent));
                captureStart = captureEnd = state.position;
            } else if (state.position === state.lineStart && testDocumentSeparator(state)) throwError(state, "unexpected end of the document within a single quoted scalar");
            else {
                state.position++;
                captureEnd = state.position;
            }
            throwError(state, "unexpected end of the stream within a single quoted scalar");
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(readSingleQuotedScalar, "readSingleQuotedScalar");
        function readDoubleQuotedScalar(state, nodeIndent) {
            var captureStart, captureEnd, hexLength, hexResult, tmp, ch;
            ch = state.input.charCodeAt(state.position);
            if (34 !== ch) return false;
            state.kind = "scalar";
            state.result = "";
            state.position++;
            captureStart = captureEnd = state.position;
            while(0 !== (ch = state.input.charCodeAt(state.position))){
                if (34 === ch) {
                    captureSegment(state, captureStart, state.position, true);
                    state.position++;
                    return true;
                }
                if (92 === ch) {
                    captureSegment(state, captureStart, state.position, true);
                    ch = state.input.charCodeAt(++state.position);
                    if (is_EOL(ch)) skipSeparationSpace(state, false, nodeIndent);
                    else if (ch < 256 && simpleEscapeCheck[ch]) {
                        state.result += simpleEscapeMap[ch];
                        state.position++;
                    } else if ((tmp = escapedHexLen(ch)) > 0) {
                        hexLength = tmp;
                        hexResult = 0;
                        for(; hexLength > 0; hexLength--){
                            ch = state.input.charCodeAt(++state.position);
                            if ((tmp = fromHexCode(ch)) >= 0) hexResult = (hexResult << 4) + tmp;
                            else throwError(state, "expected hexadecimal character");
                        }
                        state.result += charFromCodepoint(hexResult);
                        state.position++;
                    } else throwError(state, "unknown escape sequence");
                    captureStart = captureEnd = state.position;
                } else if (is_EOL(ch)) {
                    captureSegment(state, captureStart, captureEnd, true);
                    writeFoldedLines(state, skipSeparationSpace(state, false, nodeIndent));
                    captureStart = captureEnd = state.position;
                } else if (state.position === state.lineStart && testDocumentSeparator(state)) throwError(state, "unexpected end of the document within a double quoted scalar");
                else {
                    state.position++;
                    captureEnd = state.position;
                }
            }
            throwError(state, "unexpected end of the stream within a double quoted scalar");
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(readDoubleQuotedScalar, "readDoubleQuotedScalar");
        function readFlowCollection(state, nodeIndent) {
            var readNext = true, _line, _lineStart, _pos, _tag = state.tag, _result, _anchor = state.anchor, following, terminator, isPair, isExplicitPair, isMapping, overridableKeys = /* @__PURE__ */ Object.create(null), keyNode, keyTag, valueNode, ch;
            ch = state.input.charCodeAt(state.position);
            if (91 === ch) {
                terminator = 93;
                isMapping = false;
                _result = [];
            } else {
                if (123 !== ch) return false;
                terminator = 125;
                isMapping = true;
                _result = {};
            }
            if (null !== state.anchor) state.anchorMap[state.anchor] = _result;
            ch = state.input.charCodeAt(++state.position);
            while(0 !== ch){
                skipSeparationSpace(state, true, nodeIndent);
                ch = state.input.charCodeAt(state.position);
                if (ch === terminator) {
                    state.position++;
                    state.tag = _tag;
                    state.anchor = _anchor;
                    state.kind = isMapping ? "mapping" : "sequence";
                    state.result = _result;
                    return true;
                }
                if (readNext) {
                    if (44 === ch) throwError(state, "expected the node content, but found ','");
                } else throwError(state, "missed comma between flow collection entries");
                keyTag = keyNode = valueNode = null;
                isPair = isExplicitPair = false;
                if (63 === ch) {
                    following = state.input.charCodeAt(state.position + 1);
                    if (is_WS_OR_EOL(following)) {
                        isPair = isExplicitPair = true;
                        state.position++;
                        skipSeparationSpace(state, true, nodeIndent);
                    }
                }
                _line = state.line;
                _lineStart = state.lineStart;
                _pos = state.position;
                composeNode(state, nodeIndent, CONTEXT_FLOW_IN, false, true);
                keyTag = state.tag;
                keyNode = state.result;
                skipSeparationSpace(state, true, nodeIndent);
                ch = state.input.charCodeAt(state.position);
                if ((isExplicitPair || state.line === _line) && 58 === ch) {
                    isPair = true;
                    ch = state.input.charCodeAt(++state.position);
                    skipSeparationSpace(state, true, nodeIndent);
                    composeNode(state, nodeIndent, CONTEXT_FLOW_IN, false, true);
                    valueNode = state.result;
                }
                if (isMapping) storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, _line, _lineStart, _pos);
                else if (isPair) _result.push(storeMappingPair(state, null, overridableKeys, keyTag, keyNode, valueNode, _line, _lineStart, _pos));
                else _result.push(keyNode);
                skipSeparationSpace(state, true, nodeIndent);
                ch = state.input.charCodeAt(state.position);
                if (44 === ch) {
                    readNext = true;
                    ch = state.input.charCodeAt(++state.position);
                } else readNext = false;
            }
            throwError(state, "unexpected end of the stream within a flow collection");
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(readFlowCollection, "readFlowCollection");
        function readBlockScalar(state, nodeIndent) {
            var captureStart, folding, chomping = CHOMPING_CLIP, didReadContent = false, detectedIndent = false, textIndent = nodeIndent, emptyLines = 0, atMoreIndented = false, tmp, ch;
            ch = state.input.charCodeAt(state.position);
            if (124 === ch) folding = false;
            else {
                if (62 !== ch) return false;
                folding = true;
            }
            state.kind = "scalar";
            state.result = "";
            while(0 !== ch){
                ch = state.input.charCodeAt(++state.position);
                if (43 === ch || 45 === ch) {
                    if (CHOMPING_CLIP === chomping) chomping = 43 === ch ? CHOMPING_KEEP : CHOMPING_STRIP;
                    else throwError(state, "repeat of a chomping mode identifier");
                } else if ((tmp = fromDecimalCode(ch)) >= 0) {
                    if (0 === tmp) throwError(state, "bad explicit indentation width of a block scalar; it cannot be less than one");
                    else if (detectedIndent) throwError(state, "repeat of an indentation width identifier");
                    else {
                        textIndent = nodeIndent + tmp - 1;
                        detectedIndent = true;
                    }
                } else break;
            }
            if (is_WHITE_SPACE(ch)) {
                do ch = state.input.charCodeAt(++state.position);
                while (is_WHITE_SPACE(ch));
                if (35 === ch) do ch = state.input.charCodeAt(++state.position);
                while (!is_EOL(ch) && 0 !== ch);
            }
            while(0 !== ch){
                readLineBreak(state);
                state.lineIndent = 0;
                ch = state.input.charCodeAt(state.position);
                while((!detectedIndent || state.lineIndent < textIndent) && 32 === ch){
                    state.lineIndent++;
                    ch = state.input.charCodeAt(++state.position);
                }
                if (!detectedIndent && state.lineIndent > textIndent) textIndent = state.lineIndent;
                if (is_EOL(ch)) {
                    emptyLines++;
                    continue;
                }
                if (state.lineIndent < textIndent) {
                    if (chomping === CHOMPING_KEEP) state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
                    else if (chomping === CHOMPING_CLIP) {
                        if (didReadContent) state.result += "\n";
                    }
                    break;
                }
                if (folding) {
                    if (is_WHITE_SPACE(ch)) {
                        atMoreIndented = true;
                        state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
                    } else if (atMoreIndented) {
                        atMoreIndented = false;
                        state.result += common.repeat("\n", emptyLines + 1);
                    } else if (0 === emptyLines) {
                        if (didReadContent) state.result += " ";
                    } else state.result += common.repeat("\n", emptyLines);
                } else state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
                didReadContent = true;
                detectedIndent = true;
                emptyLines = 0;
                captureStart = state.position;
                while(!is_EOL(ch) && 0 !== ch)ch = state.input.charCodeAt(++state.position);
                captureSegment(state, captureStart, state.position, false);
            }
            return true;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(readBlockScalar, "readBlockScalar");
        function readBlockSequence(state, nodeIndent) {
            var _line, _tag = state.tag, _anchor = state.anchor, _result = [], following, detected = false, ch;
            if (-1 !== state.firstTabInLine) return false;
            if (null !== state.anchor) state.anchorMap[state.anchor] = _result;
            ch = state.input.charCodeAt(state.position);
            while(0 !== ch){
                if (-1 !== state.firstTabInLine) {
                    state.position = state.firstTabInLine;
                    throwError(state, "tab characters must not be used in indentation");
                }
                if (45 !== ch) break;
                following = state.input.charCodeAt(state.position + 1);
                if (!is_WS_OR_EOL(following)) break;
                detected = true;
                state.position++;
                if (skipSeparationSpace(state, true, -1)) {
                    if (state.lineIndent <= nodeIndent) {
                        _result.push(null);
                        ch = state.input.charCodeAt(state.position);
                        continue;
                    }
                }
                _line = state.line;
                composeNode(state, nodeIndent, CONTEXT_BLOCK_IN, false, true);
                _result.push(state.result);
                skipSeparationSpace(state, true, -1);
                ch = state.input.charCodeAt(state.position);
                if ((state.line === _line || state.lineIndent > nodeIndent) && 0 !== ch) throwError(state, "bad indentation of a sequence entry");
                else if (state.lineIndent < nodeIndent) break;
            }
            if (detected) {
                state.tag = _tag;
                state.anchor = _anchor;
                state.kind = "sequence";
                state.result = _result;
                return true;
            }
            return false;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(readBlockSequence, "readBlockSequence");
        function readBlockMapping(state, nodeIndent, flowIndent) {
            var following, allowCompact, _line, _keyLine, _keyLineStart, _keyPos, _tag = state.tag, _anchor = state.anchor, _result = {}, overridableKeys = /* @__PURE__ */ Object.create(null), keyTag = null, keyNode = null, valueNode = null, atExplicitKey = false, detected = false, ch;
            if (-1 !== state.firstTabInLine) return false;
            if (null !== state.anchor) state.anchorMap[state.anchor] = _result;
            ch = state.input.charCodeAt(state.position);
            while(0 !== ch){
                if (!atExplicitKey && -1 !== state.firstTabInLine) {
                    state.position = state.firstTabInLine;
                    throwError(state, "tab characters must not be used in indentation");
                }
                following = state.input.charCodeAt(state.position + 1);
                _line = state.line;
                if ((63 === ch || 58 === ch) && is_WS_OR_EOL(following)) {
                    if (63 === ch) {
                        if (atExplicitKey) {
                            storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
                            keyTag = keyNode = valueNode = null;
                        }
                        detected = true;
                        atExplicitKey = true;
                        allowCompact = true;
                    } else if (atExplicitKey) {
                        atExplicitKey = false;
                        allowCompact = true;
                    } else throwError(state, "incomplete explicit mapping pair; a key node is missed; or followed by a non-tabulated empty line");
                    state.position += 1;
                    ch = following;
                } else {
                    _keyLine = state.line;
                    _keyLineStart = state.lineStart;
                    _keyPos = state.position;
                    if (!composeNode(state, flowIndent, CONTEXT_FLOW_OUT, false, true)) break;
                    if (state.line === _line) {
                        ch = state.input.charCodeAt(state.position);
                        while(is_WHITE_SPACE(ch))ch = state.input.charCodeAt(++state.position);
                        if (58 === ch) {
                            ch = state.input.charCodeAt(++state.position);
                            if (!is_WS_OR_EOL(ch)) throwError(state, "a whitespace character is expected after the key-value separator within a block mapping");
                            if (atExplicitKey) {
                                storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
                                keyTag = keyNode = valueNode = null;
                            }
                            detected = true;
                            atExplicitKey = false;
                            allowCompact = false;
                            keyTag = state.tag;
                            keyNode = state.result;
                        } else if (detected) throwError(state, "can not read an implicit mapping pair; a colon is missed");
                        else {
                            state.tag = _tag;
                            state.anchor = _anchor;
                            return true;
                        }
                    } else if (detected) throwError(state, "can not read a block mapping entry; a multiline key may not be an implicit key");
                    else {
                        state.tag = _tag;
                        state.anchor = _anchor;
                        return true;
                    }
                }
                if (state.line === _line || state.lineIndent > nodeIndent) {
                    if (atExplicitKey) {
                        _keyLine = state.line;
                        _keyLineStart = state.lineStart;
                        _keyPos = state.position;
                    }
                    if (composeNode(state, nodeIndent, CONTEXT_BLOCK_OUT, true, allowCompact)) {
                        if (atExplicitKey) keyNode = state.result;
                        else valueNode = state.result;
                    }
                    if (!atExplicitKey) {
                        storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, _keyLine, _keyLineStart, _keyPos);
                        keyTag = keyNode = valueNode = null;
                    }
                    skipSeparationSpace(state, true, -1);
                    ch = state.input.charCodeAt(state.position);
                }
                if ((state.line === _line || state.lineIndent > nodeIndent) && 0 !== ch) throwError(state, "bad indentation of a mapping entry");
                else if (state.lineIndent < nodeIndent) break;
            }
            if (atExplicitKey) storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
            if (detected) {
                state.tag = _tag;
                state.anchor = _anchor;
                state.kind = "mapping";
                state.result = _result;
            }
            return detected;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(readBlockMapping, "readBlockMapping");
        function readTagProperty(state) {
            var _position, isVerbatim = false, isNamed = false, tagHandle, tagName, ch;
            ch = state.input.charCodeAt(state.position);
            if (33 !== ch) return false;
            if (null !== state.tag) throwError(state, "duplication of a tag property");
            ch = state.input.charCodeAt(++state.position);
            if (60 === ch) {
                isVerbatim = true;
                ch = state.input.charCodeAt(++state.position);
            } else if (33 === ch) {
                isNamed = true;
                tagHandle = "!!";
                ch = state.input.charCodeAt(++state.position);
            } else tagHandle = "!";
            _position = state.position;
            if (isVerbatim) {
                do ch = state.input.charCodeAt(++state.position);
                while (0 !== ch && 62 !== ch);
                if (state.position < state.length) {
                    tagName = state.input.slice(_position, state.position);
                    ch = state.input.charCodeAt(++state.position);
                } else throwError(state, "unexpected end of the stream within a verbatim tag");
            } else {
                while(0 !== ch && !is_WS_OR_EOL(ch)){
                    if (33 === ch) {
                        if (isNamed) throwError(state, "tag suffix cannot contain exclamation marks");
                        else {
                            tagHandle = state.input.slice(_position - 1, state.position + 1);
                            if (!PATTERN_TAG_HANDLE.test(tagHandle)) throwError(state, "named tag handle cannot contain such characters");
                            isNamed = true;
                            _position = state.position + 1;
                        }
                    }
                    ch = state.input.charCodeAt(++state.position);
                }
                tagName = state.input.slice(_position, state.position);
                if (PATTERN_FLOW_INDICATORS.test(tagName)) throwError(state, "tag suffix cannot contain flow indicator characters");
            }
            if (tagName && !PATTERN_TAG_URI.test(tagName)) throwError(state, "tag name cannot contain such characters: " + tagName);
            try {
                tagName = decodeURIComponent(tagName);
            } catch (err) {
                throwError(state, "tag name is malformed: " + tagName);
            }
            if (isVerbatim) state.tag = tagName;
            else if (_hasOwnProperty$1.call(state.tagMap, tagHandle)) state.tag = state.tagMap[tagHandle] + tagName;
            else if ("!" === tagHandle) state.tag = "!" + tagName;
            else if ("!!" === tagHandle) state.tag = "tag:yaml.org,2002:" + tagName;
            else throwError(state, 'undeclared tag handle "' + tagHandle + '"');
            return true;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(readTagProperty, "readTagProperty");
        function readAnchorProperty(state) {
            var _position, ch;
            ch = state.input.charCodeAt(state.position);
            if (38 !== ch) return false;
            if (null !== state.anchor) throwError(state, "duplication of an anchor property");
            ch = state.input.charCodeAt(++state.position);
            _position = state.position;
            while(0 !== ch && !is_WS_OR_EOL(ch) && !is_FLOW_INDICATOR(ch))ch = state.input.charCodeAt(++state.position);
            if (state.position === _position) throwError(state, "name of an anchor node must contain at least one character");
            state.anchor = state.input.slice(_position, state.position);
            return true;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(readAnchorProperty, "readAnchorProperty");
        function readAlias(state) {
            var _position, alias, ch;
            ch = state.input.charCodeAt(state.position);
            if (42 !== ch) return false;
            ch = state.input.charCodeAt(++state.position);
            _position = state.position;
            while(0 !== ch && !is_WS_OR_EOL(ch) && !is_FLOW_INDICATOR(ch))ch = state.input.charCodeAt(++state.position);
            if (state.position === _position) throwError(state, "name of an alias node must contain at least one character");
            alias = state.input.slice(_position, state.position);
            if (!_hasOwnProperty$1.call(state.anchorMap, alias)) throwError(state, 'unidentified alias "' + alias + '"');
            state.result = state.anchorMap[alias];
            skipSeparationSpace(state, true, -1);
            return true;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(readAlias, "readAlias");
        function composeNode(state, parentIndent, nodeContext, allowToSeek, allowCompact) {
            var allowBlockStyles, allowBlockScalars, allowBlockCollections, indentStatus = 1, atNewLine = false, hasContent = false, typeIndex, typeQuantity, typeList, type2, flowIndent, blockIndent;
            if (null !== state.listener) state.listener("open", state);
            state.tag = null;
            state.anchor = null;
            state.kind = null;
            state.result = null;
            allowBlockStyles = allowBlockScalars = allowBlockCollections = CONTEXT_BLOCK_OUT === nodeContext || CONTEXT_BLOCK_IN === nodeContext;
            if (allowToSeek) {
                if (skipSeparationSpace(state, true, -1)) {
                    atNewLine = true;
                    if (state.lineIndent > parentIndent) indentStatus = 1;
                    else if (state.lineIndent === parentIndent) indentStatus = 0;
                    else if (state.lineIndent < parentIndent) indentStatus = -1;
                }
            }
            if (1 === indentStatus) while(readTagProperty(state) || readAnchorProperty(state))if (skipSeparationSpace(state, true, -1)) {
                atNewLine = true;
                allowBlockCollections = allowBlockStyles;
                if (state.lineIndent > parentIndent) indentStatus = 1;
                else if (state.lineIndent === parentIndent) indentStatus = 0;
                else if (state.lineIndent < parentIndent) indentStatus = -1;
            } else allowBlockCollections = false;
            if (allowBlockCollections) allowBlockCollections = atNewLine || allowCompact;
            if (1 === indentStatus || CONTEXT_BLOCK_OUT === nodeContext) {
                flowIndent = CONTEXT_FLOW_IN === nodeContext || CONTEXT_FLOW_OUT === nodeContext ? parentIndent : parentIndent + 1;
                blockIndent = state.position - state.lineStart;
                if (1 === indentStatus) {
                    if (allowBlockCollections && (readBlockSequence(state, blockIndent) || readBlockMapping(state, blockIndent, flowIndent)) || readFlowCollection(state, flowIndent)) hasContent = true;
                    else {
                        if (allowBlockScalars && readBlockScalar(state, flowIndent) || readSingleQuotedScalar(state, flowIndent) || readDoubleQuotedScalar(state, flowIndent)) hasContent = true;
                        else if (readAlias(state)) {
                            hasContent = true;
                            if (null !== state.tag || null !== state.anchor) throwError(state, "alias node should not have any properties");
                        } else if (readPlainScalar(state, flowIndent, CONTEXT_FLOW_IN === nodeContext)) {
                            hasContent = true;
                            if (null === state.tag) state.tag = "?";
                        }
                        if (null !== state.anchor) state.anchorMap[state.anchor] = state.result;
                    }
                } else if (0 === indentStatus) hasContent = allowBlockCollections && readBlockSequence(state, blockIndent);
            }
            if (null === state.tag) {
                if (null !== state.anchor) state.anchorMap[state.anchor] = state.result;
            } else if ("?" === state.tag) {
                if (null !== state.result && "scalar" !== state.kind) throwError(state, 'unacceptable node kind for !<?> tag; it should be "scalar", not "' + state.kind + '"');
                for(typeIndex = 0, typeQuantity = state.implicitTypes.length; typeIndex < typeQuantity; typeIndex += 1){
                    type2 = state.implicitTypes[typeIndex];
                    if (type2.resolve(state.result)) {
                        state.result = type2.construct(state.result);
                        state.tag = type2.tag;
                        if (null !== state.anchor) state.anchorMap[state.anchor] = state.result;
                        break;
                    }
                }
            } else if ("!" !== state.tag) {
                if (_hasOwnProperty$1.call(state.typeMap[state.kind || "fallback"], state.tag)) type2 = state.typeMap[state.kind || "fallback"][state.tag];
                else {
                    type2 = null;
                    typeList = state.typeMap.multi[state.kind || "fallback"];
                    for(typeIndex = 0, typeQuantity = typeList.length; typeIndex < typeQuantity; typeIndex += 1)if (state.tag.slice(0, typeList[typeIndex].tag.length) === typeList[typeIndex].tag) {
                        type2 = typeList[typeIndex];
                        break;
                    }
                }
                if (!type2) throwError(state, "unknown tag !<" + state.tag + ">");
                if (null !== state.result && type2.kind !== state.kind) throwError(state, "unacceptable node kind for !<" + state.tag + '> tag; it should be "' + type2.kind + '", not "' + state.kind + '"');
                if (type2.resolve(state.result, state.tag)) {
                    state.result = type2.construct(state.result, state.tag);
                    if (null !== state.anchor) state.anchorMap[state.anchor] = state.result;
                } else throwError(state, "cannot resolve a node with !<" + state.tag + "> explicit tag");
            }
            if (null !== state.listener) state.listener("close", state);
            return null !== state.tag || null !== state.anchor || hasContent;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(composeNode, "composeNode");
        function readDocument(state) {
            var documentStart = state.position, _position, directiveName, directiveArgs, hasDirectives = false, ch;
            state.version = null;
            state.checkLineBreaks = state.legacy;
            state.tagMap = /* @__PURE__ */ Object.create(null);
            state.anchorMap = /* @__PURE__ */ Object.create(null);
            while(0 !== (ch = state.input.charCodeAt(state.position))){
                skipSeparationSpace(state, true, -1);
                ch = state.input.charCodeAt(state.position);
                if (state.lineIndent > 0 || 37 !== ch) break;
                hasDirectives = true;
                ch = state.input.charCodeAt(++state.position);
                _position = state.position;
                while(0 !== ch && !is_WS_OR_EOL(ch))ch = state.input.charCodeAt(++state.position);
                directiveName = state.input.slice(_position, state.position);
                directiveArgs = [];
                if (directiveName.length < 1) throwError(state, "directive name must not be less than one character in length");
                while(0 !== ch){
                    while(is_WHITE_SPACE(ch))ch = state.input.charCodeAt(++state.position);
                    if (35 === ch) {
                        do ch = state.input.charCodeAt(++state.position);
                        while (0 !== ch && !is_EOL(ch));
                        break;
                    }
                    if (is_EOL(ch)) break;
                    _position = state.position;
                    while(0 !== ch && !is_WS_OR_EOL(ch))ch = state.input.charCodeAt(++state.position);
                    directiveArgs.push(state.input.slice(_position, state.position));
                }
                if (0 !== ch) readLineBreak(state);
                if (_hasOwnProperty$1.call(directiveHandlers, directiveName)) directiveHandlers[directiveName](state, directiveName, directiveArgs);
                else throwWarning(state, 'unknown document directive "' + directiveName + '"');
            }
            skipSeparationSpace(state, true, -1);
            if (0 === state.lineIndent && 45 === state.input.charCodeAt(state.position) && 45 === state.input.charCodeAt(state.position + 1) && 45 === state.input.charCodeAt(state.position + 2)) {
                state.position += 3;
                skipSeparationSpace(state, true, -1);
            } else if (hasDirectives) throwError(state, "directives end mark is expected");
            composeNode(state, state.lineIndent - 1, CONTEXT_BLOCK_OUT, false, true);
            skipSeparationSpace(state, true, -1);
            if (state.checkLineBreaks && PATTERN_NON_ASCII_LINE_BREAKS.test(state.input.slice(documentStart, state.position))) throwWarning(state, "non-ASCII line breaks are interpreted as content");
            state.documents.push(state.result);
            if (state.position === state.lineStart && testDocumentSeparator(state)) {
                if (46 === state.input.charCodeAt(state.position)) {
                    state.position += 3;
                    skipSeparationSpace(state, true, -1);
                }
                return;
            }
            if (!(state.position < state.length - 1)) return;
            throwError(state, "end of the stream or a document separator is expected");
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(readDocument, "readDocument");
        function loadDocuments(input, options) {
            input = String(input);
            options = options || {};
            if (0 !== input.length) {
                if (10 !== input.charCodeAt(input.length - 1) && 13 !== input.charCodeAt(input.length - 1)) input += "\n";
                if (65279 === input.charCodeAt(0)) input = input.slice(1);
            }
            var state = new State$1(input, options);
            var nullpos = input.indexOf("\0");
            if (-1 !== nullpos) {
                state.position = nullpos;
                throwError(state, "null byte is not allowed in input");
            }
            state.input += "\0";
            while(32 === state.input.charCodeAt(state.position)){
                state.lineIndent += 1;
                state.position += 1;
            }
            while(state.position < state.length - 1)readDocument(state);
            return state.documents;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(loadDocuments, "loadDocuments");
        function loadAll$1(input, iterator, options) {
            if (null !== iterator && "object" == typeof iterator && void 0 === options) {
                options = iterator;
                iterator = null;
            }
            var documents = loadDocuments(input, options);
            if ("function" != typeof iterator) return documents;
            for(var index = 0, length = documents.length; index < length; index += 1)iterator(documents[index]);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(loadAll$1, "loadAll$1");
        function load$1(input, options) {
            var documents = loadDocuments(input, options);
            if (0 === documents.length) return;
            if (1 === documents.length) return documents[0];
            throw new exception("expected a single document in the stream, but found more");
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(load$1, "load$1");
        var loadAll_1 = loadAll$1;
        var load_1 = load$1;
        var loader = {
            loadAll: loadAll_1,
            load: load_1
        };
        var _toString = Object.prototype.toString;
        var _hasOwnProperty = Object.prototype.hasOwnProperty;
        var CHAR_BOM = 65279;
        var CHAR_TAB = 9;
        var CHAR_LINE_FEED = 10;
        var CHAR_CARRIAGE_RETURN = 13;
        var CHAR_SPACE = 32;
        var CHAR_EXCLAMATION = 33;
        var CHAR_DOUBLE_QUOTE = 34;
        var CHAR_SHARP = 35;
        var CHAR_PERCENT = 37;
        var CHAR_AMPERSAND = 38;
        var CHAR_SINGLE_QUOTE = 39;
        var CHAR_ASTERISK = 42;
        var CHAR_COMMA = 44;
        var CHAR_MINUS = 45;
        var CHAR_COLON = 58;
        var CHAR_EQUALS = 61;
        var CHAR_GREATER_THAN = 62;
        var CHAR_QUESTION = 63;
        var CHAR_COMMERCIAL_AT = 64;
        var CHAR_LEFT_SQUARE_BRACKET = 91;
        var CHAR_RIGHT_SQUARE_BRACKET = 93;
        var CHAR_GRAVE_ACCENT = 96;
        var CHAR_LEFT_CURLY_BRACKET = 123;
        var CHAR_VERTICAL_LINE = 124;
        var CHAR_RIGHT_CURLY_BRACKET = 125;
        var ESCAPE_SEQUENCES = {};
        ESCAPE_SEQUENCES[0] = "\\0";
        ESCAPE_SEQUENCES[7] = "\\a";
        ESCAPE_SEQUENCES[8] = "\\b";
        ESCAPE_SEQUENCES[9] = "\\t";
        ESCAPE_SEQUENCES[10] = "\\n";
        ESCAPE_SEQUENCES[11] = "\\v";
        ESCAPE_SEQUENCES[12] = "\\f";
        ESCAPE_SEQUENCES[13] = "\\r";
        ESCAPE_SEQUENCES[27] = "\\e";
        ESCAPE_SEQUENCES[34] = '\\"';
        ESCAPE_SEQUENCES[92] = "\\\\";
        ESCAPE_SEQUENCES[133] = "\\N";
        ESCAPE_SEQUENCES[160] = "\\_";
        ESCAPE_SEQUENCES[8232] = "\\L";
        ESCAPE_SEQUENCES[8233] = "\\P";
        var DEPRECATED_BOOLEANS_SYNTAX = [
            "y",
            "Y",
            "yes",
            "Yes",
            "YES",
            "on",
            "On",
            "ON",
            "n",
            "N",
            "no",
            "No",
            "NO",
            "off",
            "Off",
            "OFF"
        ];
        var DEPRECATED_BASE60_SYNTAX = /^[-+]?[0-9_]+(?::[0-9_]+)+(?:\.[0-9_]*)?$/;
        function compileStyleMap(schema2, map2) {
            var result, keys, index, length, tag, style, type2;
            if (null === map2) return {};
            result = {};
            keys = Object.keys(map2);
            for(index = 0, length = keys.length; index < length; index += 1){
                tag = keys[index];
                style = String(map2[tag]);
                if ("!!" === tag.slice(0, 2)) tag = "tag:yaml.org,2002:" + tag.slice(2);
                type2 = schema2.compiledTypeMap["fallback"][tag];
                if (type2 && _hasOwnProperty.call(type2.styleAliases, style)) style = type2.styleAliases[style];
                result[tag] = style;
            }
            return result;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(compileStyleMap, "compileStyleMap");
        function encodeHex(character) {
            var string, handle, length;
            string = character.toString(16).toUpperCase();
            if (character <= 255) {
                handle = "x";
                length = 2;
            } else if (character <= 65535) {
                handle = "u";
                length = 4;
            } else if (character <= 4294967295) {
                handle = "U";
                length = 8;
            } else throw new exception("code point within a string may not be greater than 0xFFFFFFFF");
            return "\\" + handle + common.repeat("0", length - string.length) + string;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(encodeHex, "encodeHex");
        var QUOTING_TYPE_SINGLE = 1;
        var QUOTING_TYPE_DOUBLE = 2;
        function State(options) {
            this.schema = options["schema"] || _default;
            this.indent = Math.max(1, options["indent"] || 2);
            this.noArrayIndent = options["noArrayIndent"] || false;
            this.skipInvalid = options["skipInvalid"] || false;
            this.flowLevel = common.isNothing(options["flowLevel"]) ? -1 : options["flowLevel"];
            this.styleMap = compileStyleMap(this.schema, options["styles"] || null);
            this.sortKeys = options["sortKeys"] || false;
            this.lineWidth = options["lineWidth"] || 80;
            this.noRefs = options["noRefs"] || false;
            this.noCompatMode = options["noCompatMode"] || false;
            this.condenseFlow = options["condenseFlow"] || false;
            this.quotingType = '"' === options["quotingType"] ? QUOTING_TYPE_DOUBLE : QUOTING_TYPE_SINGLE;
            this.forceQuotes = options["forceQuotes"] || false;
            this.replacer = "function" == typeof options["replacer"] ? options["replacer"] : null;
            this.implicitTypes = this.schema.compiledImplicit;
            this.explicitTypes = this.schema.compiledExplicit;
            this.tag = null;
            this.result = "";
            this.duplicates = [];
            this.usedDuplicates = null;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(State, "State");
        function indentString(string, spaces) {
            var ind = common.repeat(" ", spaces), position = 0, next = -1, result = "", line, length = string.length;
            while(position < length){
                next = string.indexOf("\n", position);
                if (-1 === next) {
                    line = string.slice(position);
                    position = length;
                } else {
                    line = string.slice(position, next + 1);
                    position = next + 1;
                }
                if (line.length && "\n" !== line) result += ind;
                result += line;
            }
            return result;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(indentString, "indentString");
        function generateNextLine(state, level) {
            return "\n" + common.repeat(" ", state.indent * level);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(generateNextLine, "generateNextLine");
        function testImplicitResolving(state, str2) {
            var index, length, type2;
            for(index = 0, length = state.implicitTypes.length; index < length; index += 1){
                type2 = state.implicitTypes[index];
                if (type2.resolve(str2)) return true;
            }
            return false;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(testImplicitResolving, "testImplicitResolving");
        function isWhitespace(c) {
            return c === CHAR_SPACE || c === CHAR_TAB;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(isWhitespace, "isWhitespace");
        function isPrintable(c) {
            return 32 <= c && c <= 126 || 161 <= c && c <= 55295 && 8232 !== c && 8233 !== c || 57344 <= c && c <= 65533 && c !== CHAR_BOM || 65536 <= c && c <= 1114111;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(isPrintable, "isPrintable");
        function isNsCharOrWhitespace(c) {
            return isPrintable(c) && c !== CHAR_BOM && c !== CHAR_CARRIAGE_RETURN && c !== CHAR_LINE_FEED;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(isNsCharOrWhitespace, "isNsCharOrWhitespace");
        function isPlainSafe(c, prev, inblock) {
            var cIsNsCharOrWhitespace = isNsCharOrWhitespace(c);
            var cIsNsChar = cIsNsCharOrWhitespace && !isWhitespace(c);
            return (inblock ? cIsNsCharOrWhitespace : cIsNsCharOrWhitespace && c !== CHAR_COMMA && c !== CHAR_LEFT_SQUARE_BRACKET && c !== CHAR_RIGHT_SQUARE_BRACKET && c !== CHAR_LEFT_CURLY_BRACKET && c !== CHAR_RIGHT_CURLY_BRACKET) && c !== CHAR_SHARP && !(prev === CHAR_COLON && !cIsNsChar) || isNsCharOrWhitespace(prev) && !isWhitespace(prev) && c === CHAR_SHARP || prev === CHAR_COLON && cIsNsChar;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(isPlainSafe, "isPlainSafe");
        function isPlainSafeFirst(c) {
            return isPrintable(c) && c !== CHAR_BOM && !isWhitespace(c) && c !== CHAR_MINUS && c !== CHAR_QUESTION && c !== CHAR_COLON && c !== CHAR_COMMA && c !== CHAR_LEFT_SQUARE_BRACKET && c !== CHAR_RIGHT_SQUARE_BRACKET && c !== CHAR_LEFT_CURLY_BRACKET && c !== CHAR_RIGHT_CURLY_BRACKET && c !== CHAR_SHARP && c !== CHAR_AMPERSAND && c !== CHAR_ASTERISK && c !== CHAR_EXCLAMATION && c !== CHAR_VERTICAL_LINE && c !== CHAR_EQUALS && c !== CHAR_GREATER_THAN && c !== CHAR_SINGLE_QUOTE && c !== CHAR_DOUBLE_QUOTE && c !== CHAR_PERCENT && c !== CHAR_COMMERCIAL_AT && c !== CHAR_GRAVE_ACCENT;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(isPlainSafeFirst, "isPlainSafeFirst");
        function isPlainSafeLast(c) {
            return !isWhitespace(c) && c !== CHAR_COLON;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(isPlainSafeLast, "isPlainSafeLast");
        function codePointAt(string, pos) {
            var first = string.charCodeAt(pos), second;
            if (first >= 55296 && first <= 56319 && pos + 1 < string.length) {
                second = string.charCodeAt(pos + 1);
                if (second >= 56320 && second <= 57343) return (first - 55296) * 1024 + second - 56320 + 65536;
            }
            return first;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(codePointAt, "codePointAt");
        function needIndentIndicator(string) {
            var leadingSpaceRe = /^\n* /;
            return leadingSpaceRe.test(string);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(needIndentIndicator, "needIndentIndicator");
        var STYLE_PLAIN = 1;
        var STYLE_SINGLE = 2;
        var STYLE_LITERAL = 3;
        var STYLE_FOLDED = 4;
        var STYLE_DOUBLE = 5;
        function chooseScalarStyle(string, singleLineOnly, indentPerLevel, lineWidth, testAmbiguousType, quotingType, forceQuotes, inblock) {
            var i;
            var char = 0;
            var prevChar = null;
            var hasLineBreak = false;
            var hasFoldableLine = false;
            var shouldTrackWidth = -1 !== lineWidth;
            var previousLineBreak = -1;
            var plain = isPlainSafeFirst(codePointAt(string, 0)) && isPlainSafeLast(codePointAt(string, string.length - 1));
            if (singleLineOnly || forceQuotes) for(i = 0; i < string.length; char >= 65536 ? i += 2 : i++){
                char = codePointAt(string, i);
                if (!isPrintable(char)) return STYLE_DOUBLE;
                plain = plain && isPlainSafe(char, prevChar, inblock);
                prevChar = char;
            }
            else {
                for(i = 0; i < string.length; char >= 65536 ? i += 2 : i++){
                    char = codePointAt(string, i);
                    if (char === CHAR_LINE_FEED) {
                        hasLineBreak = true;
                        if (shouldTrackWidth) {
                            hasFoldableLine = hasFoldableLine || i - previousLineBreak - 1 > lineWidth && " " !== string[previousLineBreak + 1];
                            previousLineBreak = i;
                        }
                    } else if (!isPrintable(char)) return STYLE_DOUBLE;
                    plain = plain && isPlainSafe(char, prevChar, inblock);
                    prevChar = char;
                }
                hasFoldableLine = hasFoldableLine || shouldTrackWidth && i - previousLineBreak - 1 > lineWidth && " " !== string[previousLineBreak + 1];
            }
            if (!hasLineBreak && !hasFoldableLine) {
                if (plain && !forceQuotes && !testAmbiguousType(string)) return STYLE_PLAIN;
                return quotingType === QUOTING_TYPE_DOUBLE ? STYLE_DOUBLE : STYLE_SINGLE;
            }
            if (indentPerLevel > 9 && needIndentIndicator(string)) return STYLE_DOUBLE;
            if (!forceQuotes) return hasFoldableLine ? STYLE_FOLDED : STYLE_LITERAL;
            return quotingType === QUOTING_TYPE_DOUBLE ? STYLE_DOUBLE : STYLE_SINGLE;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(chooseScalarStyle, "chooseScalarStyle");
        function writeScalar(state, string, level, iskey, inblock) {
            state.dump = function() {
                if (0 === string.length) return state.quotingType === QUOTING_TYPE_DOUBLE ? '""' : "''";
                if (!state.noCompatMode) {
                    if (-1 !== DEPRECATED_BOOLEANS_SYNTAX.indexOf(string) || DEPRECATED_BASE60_SYNTAX.test(string)) return state.quotingType === QUOTING_TYPE_DOUBLE ? '"' + string + '"' : "'" + string + "'";
                }
                var indent = state.indent * Math.max(1, level);
                var lineWidth = -1 === state.lineWidth ? -1 : Math.max(Math.min(state.lineWidth, 40), state.lineWidth - indent);
                var singleLineOnly = iskey || state.flowLevel > -1 && level >= state.flowLevel;
                function testAmbiguity(string2) {
                    return testImplicitResolving(state, string2);
                }
                (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(testAmbiguity, "testAmbiguity");
                switch(chooseScalarStyle(string, singleLineOnly, state.indent, lineWidth, testAmbiguity, state.quotingType, state.forceQuotes && !iskey, inblock)){
                    case STYLE_PLAIN:
                        return string;
                    case STYLE_SINGLE:
                        return "'" + string.replace(/'/g, "''") + "'";
                    case STYLE_LITERAL:
                        return "|" + blockHeader(string, state.indent) + dropEndingNewline(indentString(string, indent));
                    case STYLE_FOLDED:
                        return ">" + blockHeader(string, state.indent) + dropEndingNewline(indentString(foldString(string, lineWidth), indent));
                    case STYLE_DOUBLE:
                        return '"' + escapeString(string) + '"';
                    default:
                        throw new exception("impossible error: invalid scalar style");
                }
            }();
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(writeScalar, "writeScalar");
        function blockHeader(string, indentPerLevel) {
            var indentIndicator = needIndentIndicator(string) ? String(indentPerLevel) : "";
            var clip = "\n" === string[string.length - 1];
            var keep = clip && ("\n" === string[string.length - 2] || "\n" === string);
            var chomp = keep ? "+" : clip ? "" : "-";
            return indentIndicator + chomp + "\n";
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(blockHeader, "blockHeader");
        function dropEndingNewline(string) {
            return "\n" === string[string.length - 1] ? string.slice(0, -1) : string;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(dropEndingNewline, "dropEndingNewline");
        function foldString(string, width) {
            var lineRe = /(\n+)([^\n]*)/g;
            var result = function() {
                var nextLF = string.indexOf("\n");
                nextLF = -1 !== nextLF ? nextLF : string.length;
                lineRe.lastIndex = nextLF;
                return foldLine(string.slice(0, nextLF), width);
            }();
            var prevMoreIndented = "\n" === string[0] || " " === string[0];
            var moreIndented;
            var match;
            while(match = lineRe.exec(string)){
                var prefix = match[1], line = match[2];
                moreIndented = " " === line[0];
                result += prefix + (prevMoreIndented || moreIndented || "" === line ? "" : "\n") + foldLine(line, width);
                prevMoreIndented = moreIndented;
            }
            return result;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(foldString, "foldString");
        function foldLine(line, width) {
            if ("" === line || " " === line[0]) return line;
            var breakRe = / [^ ]/g;
            var match;
            var start = 0, end, curr = 0, next = 0;
            var result = "";
            while(match = breakRe.exec(line)){
                next = match.index;
                if (next - start > width) {
                    end = curr > start ? curr : next;
                    result += "\n" + line.slice(start, end);
                    start = end + 1;
                }
                curr = next;
            }
            result += "\n";
            if (line.length - start > width && curr > start) result += line.slice(start, curr) + "\n" + line.slice(curr + 1);
            else result += line.slice(start);
            return result.slice(1);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(foldLine, "foldLine");
        function escapeString(string) {
            var result = "";
            var char = 0;
            var escapeSeq;
            for(var i = 0; i < string.length; char >= 65536 ? i += 2 : i++){
                char = codePointAt(string, i);
                escapeSeq = ESCAPE_SEQUENCES[char];
                if (!escapeSeq && isPrintable(char)) {
                    result += string[i];
                    if (char >= 65536) result += string[i + 1];
                } else result += escapeSeq || encodeHex(char);
            }
            return result;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(escapeString, "escapeString");
        function writeFlowSequence(state, level, object) {
            var _result = "", _tag = state.tag, index, length, value;
            for(index = 0, length = object.length; index < length; index += 1){
                value = object[index];
                if (state.replacer) value = state.replacer.call(object, String(index), value);
                if (writeNode(state, level, value, false, false) || void 0 === value && writeNode(state, level, null, false, false)) {
                    if ("" !== _result) _result += "," + (state.condenseFlow ? "" : " ");
                    _result += state.dump;
                }
            }
            state.tag = _tag;
            state.dump = "[" + _result + "]";
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(writeFlowSequence, "writeFlowSequence");
        function writeBlockSequence(state, level, object, compact) {
            var _result = "", _tag = state.tag, index, length, value;
            for(index = 0, length = object.length; index < length; index += 1){
                value = object[index];
                if (state.replacer) value = state.replacer.call(object, String(index), value);
                if (writeNode(state, level + 1, value, true, true, false, true) || void 0 === value && writeNode(state, level + 1, null, true, true, false, true)) {
                    if (!compact || "" !== _result) _result += generateNextLine(state, level);
                    if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) _result += "-";
                    else _result += "- ";
                    _result += state.dump;
                }
            }
            state.tag = _tag;
            state.dump = _result || "[]";
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(writeBlockSequence, "writeBlockSequence");
        function writeFlowMapping(state, level, object) {
            var _result = "", _tag = state.tag, objectKeyList = Object.keys(object), index, length, objectKey, objectValue, pairBuffer;
            for(index = 0, length = objectKeyList.length; index < length; index += 1){
                pairBuffer = "";
                if ("" !== _result) pairBuffer += ", ";
                if (state.condenseFlow) pairBuffer += '"';
                objectKey = objectKeyList[index];
                objectValue = object[objectKey];
                if (state.replacer) objectValue = state.replacer.call(object, objectKey, objectValue);
                if (!!writeNode(state, level, objectKey, false, false)) {
                    if (state.dump.length > 1024) pairBuffer += "? ";
                    pairBuffer += state.dump + (state.condenseFlow ? '"' : "") + ":" + (state.condenseFlow ? "" : " ");
                    if (!!writeNode(state, level, objectValue, false, false)) {
                        pairBuffer += state.dump;
                        _result += pairBuffer;
                    }
                }
            }
            state.tag = _tag;
            state.dump = "{" + _result + "}";
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(writeFlowMapping, "writeFlowMapping");
        function writeBlockMapping(state, level, object, compact) {
            var _result = "", _tag = state.tag, objectKeyList = Object.keys(object), index, length, objectKey, objectValue, explicitPair, pairBuffer;
            if (true === state.sortKeys) objectKeyList.sort();
            else if ("function" == typeof state.sortKeys) objectKeyList.sort(state.sortKeys);
            else if (state.sortKeys) throw new exception("sortKeys must be a boolean or a function");
            for(index = 0, length = objectKeyList.length; index < length; index += 1){
                pairBuffer = "";
                if (!compact || "" !== _result) pairBuffer += generateNextLine(state, level);
                objectKey = objectKeyList[index];
                objectValue = object[objectKey];
                if (state.replacer) objectValue = state.replacer.call(object, objectKey, objectValue);
                if (!!writeNode(state, level + 1, objectKey, true, true, true)) {
                    explicitPair = null !== state.tag && "?" !== state.tag || state.dump && state.dump.length > 1024;
                    if (explicitPair) {
                        if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) pairBuffer += "?";
                        else pairBuffer += "? ";
                    }
                    pairBuffer += state.dump;
                    if (explicitPair) pairBuffer += generateNextLine(state, level);
                    if (!!writeNode(state, level + 1, objectValue, true, explicitPair)) {
                        if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) pairBuffer += ":";
                        else pairBuffer += ": ";
                        pairBuffer += state.dump;
                        _result += pairBuffer;
                    }
                }
            }
            state.tag = _tag;
            state.dump = _result || "{}";
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(writeBlockMapping, "writeBlockMapping");
        function detectType(state, object, explicit) {
            var _result, typeList, index, length, type2, style;
            typeList = explicit ? state.explicitTypes : state.implicitTypes;
            for(index = 0, length = typeList.length; index < length; index += 1){
                type2 = typeList[index];
                if ((type2.instanceOf || type2.predicate) && (!type2.instanceOf || "object" == typeof object && object instanceof type2.instanceOf) && (!type2.predicate || type2.predicate(object))) {
                    if (explicit) {
                        if (type2.multi && type2.representName) state.tag = type2.representName(object);
                        else state.tag = type2.tag;
                    } else state.tag = "?";
                    if (type2.represent) {
                        style = state.styleMap[type2.tag] || type2.defaultStyle;
                        if ("[object Function]" === _toString.call(type2.represent)) _result = type2.represent(object, style);
                        else if (_hasOwnProperty.call(type2.represent, style)) _result = type2.represent[style](object, style);
                        else throw new exception("!<" + type2.tag + '> tag resolver accepts not "' + style + '" style');
                        state.dump = _result;
                    }
                    return true;
                }
            }
            return false;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(detectType, "detectType");
        function writeNode(state, level, object, block, compact, iskey, isblockseq) {
            state.tag = null;
            state.dump = object;
            if (!detectType(state, object, false)) detectType(state, object, true);
            var type2 = _toString.call(state.dump);
            var inblock = block;
            var tagStr;
            if (block) block = state.flowLevel < 0 || state.flowLevel > level;
            var objectOrArray = "[object Object]" === type2 || "[object Array]" === type2, duplicateIndex, duplicate;
            if (objectOrArray) {
                duplicateIndex = state.duplicates.indexOf(object);
                duplicate = -1 !== duplicateIndex;
            }
            if (null !== state.tag && "?" !== state.tag || duplicate || 2 !== state.indent && level > 0) compact = false;
            if (duplicate && state.usedDuplicates[duplicateIndex]) state.dump = "*ref_" + duplicateIndex;
            else {
                if (objectOrArray && duplicate && !state.usedDuplicates[duplicateIndex]) state.usedDuplicates[duplicateIndex] = true;
                if ("[object Object]" === type2) {
                    if (block && 0 !== Object.keys(state.dump).length) {
                        writeBlockMapping(state, level, state.dump, compact);
                        if (duplicate) state.dump = "&ref_" + duplicateIndex + state.dump;
                    } else {
                        writeFlowMapping(state, level, state.dump);
                        if (duplicate) state.dump = "&ref_" + duplicateIndex + " " + state.dump;
                    }
                } else if ("[object Array]" === type2) {
                    if (block && 0 !== state.dump.length) {
                        state.noArrayIndent && !isblockseq && level > 0 ? writeBlockSequence(state, level - 1, state.dump, compact) : writeBlockSequence(state, level, state.dump, compact);
                        if (duplicate) state.dump = "&ref_" + duplicateIndex + state.dump;
                    } else {
                        writeFlowSequence(state, level, state.dump);
                        if (duplicate) state.dump = "&ref_" + duplicateIndex + " " + state.dump;
                    }
                } else if ("[object String]" === type2) {
                    if ("?" !== state.tag) writeScalar(state, state.dump, level, iskey, inblock);
                } else {
                    if ("[object Undefined]" === type2) return false;
                    if (state.skipInvalid) return false;
                    throw new exception("unacceptable kind of an object to dump " + type2);
                }
                if (null !== state.tag && "?" !== state.tag) {
                    tagStr = encodeURI("!" === state.tag[0] ? state.tag.slice(1) : state.tag).replace(/!/g, "%21");
                    tagStr = "!" === state.tag[0] ? "!" + tagStr : "tag:yaml.org,2002:" === tagStr.slice(0, 18) ? "!!" + tagStr.slice(18) : "!<" + tagStr + ">";
                    state.dump = tagStr + " " + state.dump;
                }
            }
            return true;
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(writeNode, "writeNode");
        function getDuplicateReferences(object, state) {
            var objects = [], duplicatesIndexes = [], index, length;
            inspectNode(object, objects, duplicatesIndexes);
            for(index = 0, length = duplicatesIndexes.length; index < length; index += 1)state.duplicates.push(objects[duplicatesIndexes[index]]);
            state.usedDuplicates = new Array(length);
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(getDuplicateReferences, "getDuplicateReferences");
        function inspectNode(object, objects, duplicatesIndexes) {
            var objectKeyList, index, length;
            if (null !== object && "object" == typeof object) {
                index = objects.indexOf(object);
                if (-1 !== index) {
                    if (-1 === duplicatesIndexes.indexOf(index)) duplicatesIndexes.push(index);
                } else {
                    objects.push(object);
                    if (Array.isArray(object)) for(index = 0, length = object.length; index < length; index += 1)inspectNode(object[index], objects, duplicatesIndexes);
                    else {
                        objectKeyList = Object.keys(object);
                        for(index = 0, length = objectKeyList.length; index < length; index += 1)inspectNode(object[objectKeyList[index]], objects, duplicatesIndexes);
                    }
                }
            }
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(inspectNode, "inspectNode");
        function dump$1(input, options) {
            options = options || {};
            var state = new State(options);
            if (!state.noRefs) getDuplicateReferences(input, state);
            var value = input;
            if (state.replacer) value = state.replacer.call({
                "": value
            }, "", value);
            if (writeNode(state, 0, value, true, true)) return state.dump + "\n";
            return "";
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(dump$1, "dump$1");
        var dump_1 = dump$1;
        var dumper = {
            dump: dump_1
        };
        function renamed(from, to) {
            return function() {
                throw new Error("Function yaml." + from + " is removed in js-yaml 4. Use yaml." + to + " instead, which is now safe by default.");
            };
        }
        (0, _chunk_6DBFFHIP_mjs__WEBPACK_IMPORTED_MODULE_0__.eW)(renamed, "renamed");
        var JSON_SCHEMA = json;
        var load = loader.load;
        loader.loadAll;
        dumper.dump;
        renamed("safeLoad", "load");
        renamed("safeLoadAll", "loadAll");
        renamed("safeDump", "dump");
    /*! Bundled license information:

js-yaml/dist/js-yaml.mjs:
  (*! js-yaml 4.1.0 https://github.com/nodeca/js-yaml @license MIT *)
*/ }
};
var __webpack_module_cache__ = {};
function __webpack_require__(moduleId) {
    var cachedModule = __webpack_module_cache__[moduleId];
    if (void 0 !== cachedModule) return cachedModule.exports;
    var module1 = __webpack_module_cache__[moduleId] = {
        exports: {}
    };
    __webpack_modules__[moduleId].call(module1.exports, module1, module1.exports, __webpack_require__);
    return module1.exports;
}
__webpack_require__.m = __webpack_modules__;
(()=>{
    __webpack_require__.d = function(exports1, definition) {
        for(var key in definition)if (__webpack_require__.o(definition, key) && !__webpack_require__.o(exports1, key)) Object.defineProperty(exports1, key, {
            enumerable: true,
            get: definition[key]
        });
    };
})();
(()=>{
    __webpack_require__.f = {};
    __webpack_require__.e = function(chunkId) {
        return Promise.all(Object.keys(__webpack_require__.f).reduce(function(promises, key) {
            __webpack_require__.f[key](chunkId, promises);
            return promises;
        }, []));
    };
})();
(()=>{
    __webpack_require__.u = function(chunkId) {
        return "" + chunkId + "/index.js";
    };
})();
(()=>{
    __webpack_require__.miniCssF = function(chunkId) {
        return "" + chunkId + ".css";
    };
})();
(()=>{
    __webpack_require__.g = function() {
        if ('object' == typeof globalThis) return globalThis;
        try {
            return this || new Function('return this')();
        } catch (e) {
            if ('object' == typeof window) return window;
        }
    }();
})();
(()=>{
    __webpack_require__.o = function(obj, prop) {
        return Object.prototype.hasOwnProperty.call(obj, prop);
    };
})();
(()=>{
    __webpack_require__.r = function(exports1) {
        if ('undefined' != typeof Symbol && Symbol.toStringTag) Object.defineProperty(exports1, Symbol.toStringTag, {
            value: 'Module'
        });
        Object.defineProperty(exports1, '__esModule', {
            value: true
        });
    };
})();
(()=>{
    var scriptUrl;
    if ("string" == typeof import.meta.url) scriptUrl = import.meta.url;
    if (!scriptUrl) throw new Error("Automatic publicPath is not supported in this browser");
    scriptUrl = scriptUrl.replace(/#.*$/, "").replace(/\?.*$/, "").replace(/\/[^\/]+$/, "/");
    __webpack_require__.p = scriptUrl + '../';
})();
(()=>{
    var installedChunks = {
        45: 0
    };
    var installChunk = function(data) {
        var ids = data.ids;
        var modules = data.modules;
        var runtime = data.runtime;
        var moduleId, chunkId, i = 0;
        for(moduleId in modules)if (__webpack_require__.o(modules, moduleId)) __webpack_require__.m[moduleId] = modules[moduleId];
        if (runtime) runtime(__webpack_require__);
        for(; i < ids.length; i++){
            chunkId = ids[i];
            if (__webpack_require__.o(installedChunks, chunkId) && installedChunks[chunkId]) installedChunks[chunkId][0]();
            installedChunks[ids[i]] = 0;
        }
    };
    __webpack_require__.f.j = function(chunkId, promises) {
        var installedChunkData = __webpack_require__.o(installedChunks, chunkId) ? installedChunks[chunkId] : void 0;
        if (0 !== installedChunkData) {
            if (installedChunkData) promises.push(installedChunkData[1]);
            else {
                var promise = import("../" + __webpack_require__.u(chunkId)).then(installChunk, function(e) {
                    if (0 !== installedChunks[chunkId]) installedChunks[chunkId] = void 0;
                    throw e;
                });
                var promise = Promise.race([
                    promise,
                    new Promise(function(resolve) {
                        installedChunkData = installedChunks[chunkId] = [
                            resolve
                        ];
                    })
                ]);
                promises.push(installedChunkData[1] = promise);
            }
        }
    };
})();
var chunk_S3SWNSAA = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-S3SWNSAA.mjs");
var chunk_BO7VGL7K = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-BO7VGL7K.mjs");
__webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-66SQ7PYY.mjs");
__webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-7NZE2EM7.mjs");
var chunk_OPO4IU42 = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-OPO4IU42.mjs");
__webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-3JNJP5BE.mjs");
__webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-3X56UNUX.mjs");
__webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-6JOS74DS.mjs");
var chunk_7DKRZKHE = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-7DKRZKHE.mjs");
var chunk_K6PMAZHR = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-K6PMAZHR.mjs");
var chunk_EJ4ZWXGL = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-EJ4ZWXGL.mjs");
var chunk_6DBFFHIP = __webpack_require__("./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/chunk-6DBFFHIP.mjs");
var esm = __webpack_require__("./node_modules/.pnpm/ts-dedent@2.2.0/node_modules/ts-dedent/esm/index.js");
var src = __webpack_require__("./node_modules/.pnpm/d3@7.9.0/node_modules/d3/src/index.js");
var COMMENT = 'comm';
var RULESET = 'rule';
var DECLARATION = 'decl';
var IMPORT = '@import';
var KEYFRAMES = '@keyframes';
var LAYER = '@layer';
var abs = Math.abs;
var Utility_from = String.fromCharCode;
function trim(value) {
    return value.trim();
}
function replace(value, pattern, replacement) {
    return value.replace(pattern, replacement);
}
function indexof(value, search, position) {
    return value.indexOf(search, position);
}
function charat(value, index) {
    return 0 | value.charCodeAt(index);
}
function substr(value, begin, end) {
    return value.slice(begin, end);
}
function strlen(value) {
    return value.length;
}
function sizeof(value) {
    return value.length;
}
function Utility_append(value, array) {
    return array.push(value), value;
}
function serialize(children, callback) {
    var output = '';
    for(var i = 0; i < children.length; i++)output += callback(children[i], i, children, callback) || '';
    return output;
}
function stringify(element, index, children, callback) {
    switch(element.type){
        case LAYER:
            if (element.children.length) break;
        case IMPORT:
        case DECLARATION:
            return element.return = element.return || element.value;
        case COMMENT:
            return '';
        case KEYFRAMES:
            return element.return = element.value + '{' + serialize(element.children, callback) + '}';
        case RULESET:
            if (!strlen(element.value = element.props.join(','))) return '';
    }
    return strlen(children = serialize(element.children, callback)) ? element.return = element.value + '{' + children + '}' : '';
}
var line = 1;
var column = 1;
var Tokenizer_length = 0;
var Tokenizer_position = 0;
var Tokenizer_character = 0;
var Tokenizer_characters = '';
function Tokenizer_node(value, root, parent, type, props, children, length, siblings) {
    return {
        value: value,
        root: root,
        parent: parent,
        type: type,
        props: props,
        children: children,
        line: line,
        column: column,
        length: length,
        return: '',
        siblings: siblings
    };
}
function Tokenizer_char() {
    return Tokenizer_character;
}
function prev() {
    Tokenizer_character = Tokenizer_position > 0 ? charat(Tokenizer_characters, --Tokenizer_position) : 0;
    if (column--, 10 === Tokenizer_character) column = 1, line--;
    return Tokenizer_character;
}
function next() {
    Tokenizer_character = Tokenizer_position < Tokenizer_length ? charat(Tokenizer_characters, Tokenizer_position++) : 0;
    if (column++, 10 === Tokenizer_character) column = 1, line++;
    return Tokenizer_character;
}
function peek() {
    return charat(Tokenizer_characters, Tokenizer_position);
}
function caret() {
    return Tokenizer_position;
}
function slice(begin, end) {
    return substr(Tokenizer_characters, begin, end);
}
function token(type) {
    switch(type){
        case 0:
        case 9:
        case 10:
        case 13:
        case 32:
            return 5;
        case 33:
        case 43:
        case 44:
        case 47:
        case 62:
        case 64:
        case 126:
        case 59:
        case 123:
        case 125:
            return 4;
        case 58:
            return 3;
        case 34:
        case 39:
        case 40:
        case 91:
            return 2;
        case 41:
        case 93:
            return 1;
    }
    return 0;
}
function alloc(value) {
    return line = column = 1, Tokenizer_length = strlen(Tokenizer_characters = value), Tokenizer_position = 0, [];
}
function dealloc(value) {
    return Tokenizer_characters = '', value;
}
function delimit(type) {
    return trim(slice(Tokenizer_position - 1, delimiter(91 === type ? type + 2 : 40 === type ? type + 1 : type)));
}
function whitespace(type) {
    while(Tokenizer_character = peek())if (Tokenizer_character < 33) next();
    else break;
    return token(type) > 2 || token(Tokenizer_character) > 3 ? '' : ' ';
}
function escaping(index, count) {
    while(--count && next())if (Tokenizer_character < 48 || Tokenizer_character > 102 || Tokenizer_character > 57 && Tokenizer_character < 65 || Tokenizer_character > 70 && Tokenizer_character < 97) break;
    return slice(index, caret() + (count < 6 && 32 == peek() && 32 == next()));
}
function delimiter(type) {
    while(next())switch(Tokenizer_character){
        case type:
            return Tokenizer_position;
        case 34:
        case 39:
            if (34 !== type && 39 !== type) delimiter(Tokenizer_character);
            break;
        case 40:
            if (41 === type) delimiter(type);
            break;
        case 92:
            next();
            break;
    }
    return Tokenizer_position;
}
function commenter(type, index) {
    while(next())if (type + Tokenizer_character === 57) break;
    else if (type + Tokenizer_character === 84 && 47 === peek()) break;
    return '/*' + slice(index, Tokenizer_position - 1) + '*' + Utility_from(47 === type ? type : next());
}
function identifier(index) {
    while(!token(peek()))next();
    return slice(index, Tokenizer_position);
}
function compile(value) {
    return dealloc(parse('', null, null, null, [
        ''
    ], value = alloc(value), 0, [
        0
    ], value));
}
function parse(value, root, parent, rule, rules, rulesets, pseudo, points, declarations) {
    var index = 0;
    var offset = 0;
    var length = pseudo;
    var atrule = 0;
    var property = 0;
    var previous = 0;
    var variable = 1;
    var scanning = 1;
    var ampersand = 1;
    var character = 0;
    var type = '';
    var props = rules;
    var children = rulesets;
    var reference = rule;
    var characters = type;
    while(scanning)switch(previous = character, character = next()){
        case 40:
            if (108 != previous && 58 == charat(characters, length - 1)) {
                if (-1 != indexof(characters += replace(delimit(character), '&', '&\f'), '&\f', abs(index ? points[index - 1] : 0))) ampersand = -1;
                break;
            }
        case 34:
        case 39:
        case 91:
            characters += delimit(character);
            break;
        case 9:
        case 10:
        case 13:
        case 32:
            characters += whitespace(previous);
            break;
        case 92:
            characters += escaping(caret() - 1, 7);
            continue;
        case 47:
            switch(peek()){
                case 42:
                case 47:
                    Utility_append(comment(commenter(next(), caret()), root, parent, declarations), declarations);
                    if ((5 == token(previous || 1) || 5 == token(peek() || 1)) && strlen(characters) && ' ' !== substr(characters, -1, void 0)) characters += ' ';
                    break;
                default:
                    characters += '/';
            }
            break;
        case 123 * variable:
            points[index++] = strlen(characters) * ampersand;
        case 125 * variable:
        case 59:
        case 0:
            switch(character){
                case 0:
                case 125:
                    scanning = 0;
                case 59 + offset:
                    if (-1 == ampersand) characters = replace(characters, /\f/g, '');
                    if (property > 0 && (strlen(characters) - length || 0 === variable && 47 === previous)) Utility_append(property > 32 ? declaration(characters + ';', rule, parent, length - 1, declarations) : declaration(replace(characters, ' ', '') + ';', rule, parent, length - 2, declarations), declarations);
                    break;
                case 59:
                    characters += ';';
                default:
                    Utility_append(reference = ruleset(characters, root, parent, index, offset, rules, points, type, props = [], children = [], length, rulesets), rulesets);
                    if (123 === character) {
                        if (0 === offset) parse(characters, root, reference, reference, props, rulesets, length, points, children);
                        else switch(99 === atrule && 110 === charat(characters, 3) ? 100 : atrule){
                            case 100:
                            case 108:
                            case 109:
                            case 115:
                                parse(value, reference, reference, rule && Utility_append(ruleset(value, reference, reference, 0, 0, rules, points, type, rules, props = [], length, children), children), rules, children, length, points, rule ? props : children);
                                break;
                            default:
                                parse(characters, reference, reference, reference, [
                                    ''
                                ], children, 0, points, children);
                        }
                    }
            }
            index = offset = property = 0, variable = ampersand = 1, type = characters = '', length = pseudo;
            break;
        case 58:
            length = 1 + strlen(characters), property = previous;
        default:
            if (variable < 1) {
                if (123 == character) --variable;
                else if (125 == character && 0 == variable++ && 125 == prev()) continue;
            }
            switch(characters += Utility_from(character), character * variable){
                case 38:
                    ampersand = offset > 0 ? 1 : (characters += '\f', -1);
                    break;
                case 44:
                    points[index++] = (strlen(characters) - 1) * ampersand, ampersand = 1;
                    break;
                case 64:
                    if (45 === peek()) characters += delimit(next());
                    atrule = peek(), offset = length = strlen(type = characters += identifier(caret())), character++;
                    break;
                case 45:
                    if (45 === previous && 2 == strlen(characters)) variable = 0;
            }
    }
    return rulesets;
}
function ruleset(value, root, parent, index, offset, rules, points, type, props, children, length, siblings) {
    var post = offset - 1;
    var rule = 0 === offset ? rules : [
        ''
    ];
    var size = sizeof(rule);
    for(var i = 0, j = 0, k = 0; i < index; ++i)for(var x = 0, y = substr(value, post + 1, post = abs(j = points[i])), z = value; x < size; ++x)if (z = trim(j > 0 ? rule[x] + ' ' + y : replace(y, /&\f/g, rule[x]))) props[k++] = z;
    return Tokenizer_node(value, root, parent, 0 === offset ? RULESET : type, props, children, length, siblings);
}
function comment(value, root, parent, siblings) {
    return Tokenizer_node(value, root, parent, COMMENT, Utility_from(Tokenizer_char()), substr(value, 2, -2), 0, siblings);
}
function declaration(value, root, parent, length, siblings) {
    return Tokenizer_node(value, root, parent, DECLARATION, substr(value, 0, length), substr(value, length + 1, -1), length, siblings);
}
var purify_es = __webpack_require__("./node_modules/.pnpm/dompurify@3.2.4/node_modules/dompurify/dist/purify.es.mjs");
var isEmpty = __webpack_require__("./node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isEmpty.js");
var id = "c4";
var detector = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt)=>/^\s*C4Context|C4Container|C4Component|C4Dynamic|C4Deployment/.test(txt), "detector");
var loader = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await __webpack_require__.e("70").then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/c4Diagram-6F5ED5ID.mjs"));
    return {
        id,
        diagram: diagram2
    };
}, "loader");
var mermaid_core_plugin = {
    id,
    detector,
    loader
};
var c4Detector_default = mermaid_core_plugin;
var id2 = "flowchart";
var detector2 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt, config)=>{
    if (config?.flowchart?.defaultRenderer === "dagre-wrapper" || config?.flowchart?.defaultRenderer === "elk") return false;
    return /^\s*graph/.test(txt);
}, "detector");
var loader2 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await __webpack_require__.e("96").then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/flowDiagram-7ASYPVHJ.mjs"));
    return {
        id: id2,
        diagram: diagram2
    };
}, "loader");
var plugin2 = {
    id: id2,
    detector: detector2,
    loader: loader2
};
var flowDetector_default = plugin2;
var id3 = "flowchart-v2";
var detector3 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt, config)=>{
    if (config?.flowchart?.defaultRenderer === "dagre-d3") return false;
    if (config?.flowchart?.defaultRenderer === "elk") config.layout = "elk";
    if (/^\s*graph/.test(txt) && config?.flowchart?.defaultRenderer === "dagre-wrapper") return true;
    return /^\s*flowchart/.test(txt);
}, "detector");
var loader3 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await __webpack_require__.e("96").then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/flowDiagram-7ASYPVHJ.mjs"));
    return {
        id: id3,
        diagram: diagram2
    };
}, "loader");
var plugin3 = {
    id: id3,
    detector: detector3,
    loader: loader3
};
var flowDetector_v2_default = plugin3;
var id4 = "er";
var detector4 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt)=>/^\s*erDiagram/.test(txt), "detector");
var loader4 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await Promise.all([
        __webpack_require__.e("603"),
        __webpack_require__.e("226"),
        __webpack_require__.e("410")
    ]).then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/erDiagram-6RL3IURR.mjs"));
    return {
        id: id4,
        diagram: diagram2
    };
}, "loader");
var plugin4 = {
    id: id4,
    detector: detector4,
    loader: loader4
};
var erDetector_default = plugin4;
var id5 = "gitGraph";
var detector5 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt)=>/^\s*gitGraph/.test(txt), "detector");
var loader5 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await Promise.all([
        __webpack_require__.e("603"),
        __webpack_require__.e("459"),
        __webpack_require__.e("966")
    ]).then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/gitGraphDiagram-NRZ2UAAF.mjs"));
    return {
        id: id5,
        diagram: diagram2
    };
}, "loader");
var plugin5 = {
    id: id5,
    detector: detector5,
    loader: loader5
};
var gitGraphDetector_default = plugin5;
var id6 = "gantt";
var detector6 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt)=>/^\s*gantt/.test(txt), "detector");
var loader6 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await __webpack_require__.e("470").then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/ganttDiagram-NTVNEXSI.mjs"));
    return {
        id: id6,
        diagram: diagram2
    };
}, "loader");
var plugin6 = {
    id: id6,
    detector: detector6,
    loader: loader6
};
var ganttDetector_default = plugin6;
var id7 = "info";
var detector7 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt)=>/^\s*info/.test(txt), "detector");
var loader7 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await Promise.all([
        __webpack_require__.e("603"),
        __webpack_require__.e("459"),
        __webpack_require__.e("416")
    ]).then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/infoDiagram-A4XQUW5V.mjs"));
    return {
        id: id7,
        diagram: diagram2
    };
}, "loader");
var info = {
    id: id7,
    detector: detector7,
    loader: loader7
};
var id8 = "pie";
var detector8 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt)=>/^\s*pie/.test(txt), "detector");
var loader8 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await Promise.all([
        __webpack_require__.e("603"),
        __webpack_require__.e("459"),
        __webpack_require__.e("817")
    ]).then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/pieDiagram-YF2LJOPJ.mjs"));
    return {
        id: id8,
        diagram: diagram2
    };
}, "loader");
var pie = {
    id: id8,
    detector: detector8,
    loader: loader8
};
var id9 = "quadrantChart";
var detector9 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt)=>/^\s*quadrantChart/.test(txt), "detector");
var loader9 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await __webpack_require__.e("806").then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/quadrantDiagram-OS5C2QUG.mjs"));
    return {
        id: id9,
        diagram: diagram2
    };
}, "loader");
var plugin7 = {
    id: id9,
    detector: detector9,
    loader: loader9
};
var quadrantDetector_default = plugin7;
var id10 = "xychart";
var detector10 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt)=>/^\s*xychart-beta/.test(txt), "detector");
var loader10 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await __webpack_require__.e("127").then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/xychartDiagram-6QU3TZC5.mjs"));
    return {
        id: id10,
        diagram: diagram2
    };
}, "loader");
var plugin8 = {
    id: id10,
    detector: detector10,
    loader: loader10
};
var xychartDetector_default = plugin8;
var id11 = "requirement";
var detector11 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt)=>/^\s*requirement(Diagram)?/.test(txt), "detector");
var loader11 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await Promise.all([
        __webpack_require__.e("603"),
        __webpack_require__.e("226"),
        __webpack_require__.e("203")
    ]).then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/requirementDiagram-MIRIMTAZ.mjs"));
    return {
        id: id11,
        diagram: diagram2
    };
}, "loader");
var plugin9 = {
    id: id11,
    detector: detector11,
    loader: loader11
};
var requirementDetector_default = plugin9;
var id12 = "sequence";
var detector12 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt)=>/^\s*sequenceDiagram/.test(txt), "detector");
var loader12 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await __webpack_require__.e("67").then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/sequenceDiagram-G6AWOVSC.mjs"));
    return {
        id: id12,
        diagram: diagram2
    };
}, "loader");
var plugin10 = {
    id: id12,
    detector: detector12,
    loader: loader12
};
var sequenceDetector_default = plugin10;
var id13 = "class";
var detector13 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt, config)=>{
    if (config?.class?.defaultRenderer === "dagre-wrapper") return false;
    return /^\s*classDiagram/.test(txt);
}, "detector");
var loader13 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await Promise.all([
        __webpack_require__.e("921"),
        __webpack_require__.e("448")
    ]).then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/classDiagram-LNE6IOMH.mjs"));
    return {
        id: id13,
        diagram: diagram2
    };
}, "loader");
var plugin11 = {
    id: id13,
    detector: detector13,
    loader: loader13
};
var classDetector_default = plugin11;
var id14 = "classDiagram";
var detector14 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt, config)=>{
    if (/^\s*classDiagram/.test(txt) && config?.class?.defaultRenderer === "dagre-wrapper") return true;
    return /^\s*classDiagram-v2/.test(txt);
}, "detector");
var loader14 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await Promise.all([
        __webpack_require__.e("921"),
        __webpack_require__.e("550")
    ]).then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/classDiagram-v2-MQ7JQ4JX.mjs"));
    return {
        id: id14,
        diagram: diagram2
    };
}, "loader");
var plugin12 = {
    id: id14,
    detector: detector14,
    loader: loader14
};
var classDetector_V2_default = plugin12;
var id15 = "state";
var detector15 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt, config)=>{
    if (config?.state?.defaultRenderer === "dagre-wrapper") return false;
    return /^\s*stateDiagram/.test(txt);
}, "detector");
var loader15 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await Promise.all([
        __webpack_require__.e("603"),
        __webpack_require__.e("226"),
        __webpack_require__.e("798"),
        __webpack_require__.e("366")
    ]).then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/stateDiagram-MAYHULR4.mjs"));
    return {
        id: id15,
        diagram: diagram2
    };
}, "loader");
var plugin13 = {
    id: id15,
    detector: detector15,
    loader: loader15
};
var stateDetector_default = plugin13;
var id16 = "stateDiagram";
var detector16 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt, config)=>{
    if (/^\s*stateDiagram-v2/.test(txt)) return true;
    if (/^\s*stateDiagram/.test(txt) && config?.state?.defaultRenderer === "dagre-wrapper") return true;
    return false;
}, "detector");
var loader16 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await Promise.all([
        __webpack_require__.e("798"),
        __webpack_require__.e("893")
    ]).then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/stateDiagram-v2-4JROLMXI.mjs"));
    return {
        id: id16,
        diagram: diagram2
    };
}, "loader");
var plugin14 = {
    id: id16,
    detector: detector16,
    loader: loader16
};
var stateDetector_V2_default = plugin14;
var id17 = "journey";
var detector17 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt)=>/^\s*journey/.test(txt), "detector");
var loader17 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await __webpack_require__.e("941").then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/journeyDiagram-G5WM74LC.mjs"));
    return {
        id: id17,
        diagram: diagram2
    };
}, "loader");
var plugin15 = {
    id: id17,
    detector: detector17,
    loader: loader17
};
var journeyDetector_default = plugin15;
var draw = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((_text, id26, version2)=>{
    chunk_6DBFFHIP.cM.debug("rendering svg for syntax error\n");
    const svg = (0, chunk_EJ4ZWXGL.P)(id26);
    const g = svg.append("g");
    svg.attr("viewBox", "0 0 2412 512");
    (0, chunk_6DBFFHIP.v2)(svg, 100, 512, true);
    g.append("path").attr("class", "error-icon").attr("d", "m411.313,123.313c6.25-6.25 6.25-16.375 0-22.625s-16.375-6.25-22.625,0l-32,32-9.375,9.375-20.688-20.688c-12.484-12.5-32.766-12.5-45.25,0l-16,16c-1.261,1.261-2.304,2.648-3.31,4.051-21.739-8.561-45.324-13.426-70.065-13.426-105.867,0-192,86.133-192,192s86.133,192 192,192 192-86.133 192-192c0-24.741-4.864-48.327-13.426-70.065 1.402-1.007 2.79-2.049 4.051-3.31l16-16c12.5-12.492 12.5-32.758 0-45.25l-20.688-20.688 9.375-9.375 32.001-31.999zm-219.313,100.687c-52.938,0-96,43.063-96,96 0,8.836-7.164,16-16,16s-16-7.164-16-16c0-70.578 57.422-128 128-128 8.836,0 16,7.164 16,16s-7.164,16-16,16z");
    g.append("path").attr("class", "error-icon").attr("d", "m459.02,148.98c-6.25-6.25-16.375-6.25-22.625,0s-6.25,16.375 0,22.625l16,16c3.125,3.125 7.219,4.688 11.313,4.688 4.094,0 8.188-1.563 11.313-4.688 6.25-6.25 6.25-16.375 0-22.625l-16.001-16z");
    g.append("path").attr("class", "error-icon").attr("d", "m340.395,75.605c3.125,3.125 7.219,4.688 11.313,4.688 4.094,0 8.188-1.563 11.313-4.688 6.25-6.25 6.25-16.375 0-22.625l-16-16c-6.25-6.25-16.375-6.25-22.625,0s-6.25,16.375 0,22.625l15.999,16z");
    g.append("path").attr("class", "error-icon").attr("d", "m400,64c8.844,0 16-7.164 16-16v-32c0-8.836-7.156-16-16-16-8.844,0-16,7.164-16,16v32c0,8.836 7.156,16 16,16z");
    g.append("path").attr("class", "error-icon").attr("d", "m496,96.586h-32c-8.844,0-16,7.164-16,16 0,8.836 7.156,16 16,16h32c8.844,0 16-7.164 16-16 0-8.836-7.156-16-16-16z");
    g.append("path").attr("class", "error-icon").attr("d", "m436.98,75.605c3.125,3.125 7.219,4.688 11.313,4.688 4.094,0 8.188-1.563 11.313-4.688l32-32c6.25-6.25 6.25-16.375 0-22.625s-16.375-6.25-22.625,0l-32,32c-6.251,6.25-6.251,16.375-0.001,22.625z");
    g.append("text").attr("class", "error-text").attr("x", 1440).attr("y", 250).attr("font-size", "150px").style("text-anchor", "middle").text("Syntax error in text");
    g.append("text").attr("class", "error-text").attr("x", 1250).attr("y", 400).attr("font-size", "100px").style("text-anchor", "middle").text(`mermaid version ${version2}`);
}, "draw");
var renderer = {
    draw
};
var errorRenderer_default = renderer;
var diagram = {
    db: {},
    renderer,
    parser: {
        parse: /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(()=>{}, "parse")
    }
};
var errorDiagram_default = diagram;
var id18 = "flowchart-elk";
var detector18 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt, config = {})=>{
    if (/^\s*flowchart-elk/.test(txt) || /^\s*flowchart|graph/.test(txt) && config?.flowchart?.defaultRenderer === "elk") {
        config.layout = "elk";
        return true;
    }
    return false;
}, "detector");
var loader18 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await __webpack_require__.e("96").then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/flowDiagram-7ASYPVHJ.mjs"));
    return {
        id: id18,
        diagram: diagram2
    };
}, "loader");
var plugin16 = {
    id: id18,
    detector: detector18,
    loader: loader18
};
var detector_default = plugin16;
var id19 = "timeline";
var detector19 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt)=>/^\s*timeline/.test(txt), "detector");
var loader19 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await __webpack_require__.e("336").then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/timeline-definition-U7ZMHBDA.mjs"));
    return {
        id: id19,
        diagram: diagram2
    };
}, "loader");
var plugin17 = {
    id: id19,
    detector: detector19,
    loader: loader19
};
var detector_default2 = plugin17;
var id20 = "mindmap";
var detector20 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt)=>/^\s*mindmap/.test(txt), "detector");
var loader20 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await Promise.all([
        __webpack_require__.e("509"),
        __webpack_require__.e("876")
    ]).then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/mindmap-definition-GWI6TPTV.mjs"));
    return {
        id: id20,
        diagram: diagram2
    };
}, "loader");
var plugin18 = {
    id: id20,
    detector: detector20,
    loader: loader20
};
var detector_default3 = plugin18;
var id21 = "kanban";
var detector21 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt)=>/^\s*kanban/.test(txt), "detector");
var loader21 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await __webpack_require__.e("351").then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/kanban-definition-QRCXZQQD.mjs"));
    return {
        id: id21,
        diagram: diagram2
    };
}, "loader");
var plugin19 = {
    id: id21,
    detector: detector21,
    loader: loader21
};
var detector_default4 = plugin19;
var id22 = "sankey";
var detector22 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt)=>/^\s*sankey-beta/.test(txt), "detector");
var loader22 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await __webpack_require__.e("483").then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/sankeyDiagram-Y46BX6SQ.mjs"));
    return {
        id: id22,
        diagram: diagram2
    };
}, "loader");
var plugin20 = {
    id: id22,
    detector: detector22,
    loader: loader22
};
var sankeyDetector_default = plugin20;
var id23 = "packet";
var detector23 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt)=>/^\s*packet-beta/.test(txt), "detector");
var loader23 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await Promise.all([
        __webpack_require__.e("603"),
        __webpack_require__.e("459"),
        __webpack_require__.e("300")
    ]).then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/diagram-QW4FP2JN.mjs"));
    return {
        id: id23,
        diagram: diagram2
    };
}, "loader");
var packet = {
    id: id23,
    detector: detector23,
    loader: loader23
};
var id24 = "block";
var detector24 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt)=>/^\s*block-beta/.test(txt), "detector");
var loader24 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await Promise.all([
        __webpack_require__.e("603"),
        __webpack_require__.e("367")
    ]).then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/blockDiagram-ZHA2E4KO.mjs"));
    return {
        id: id24,
        diagram: diagram2
    };
}, "loader");
var plugin21 = {
    id: id24,
    detector: detector24,
    loader: loader24
};
var blockDetector_default = plugin21;
var id25 = "architecture";
var detector25 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((txt)=>/^\s*architecture/.test(txt), "detector");
var loader25 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    const { diagram: diagram2 } = await Promise.all([
        __webpack_require__.e("603"),
        __webpack_require__.e("459"),
        __webpack_require__.e("509"),
        __webpack_require__.e("621")
    ]).then(__webpack_require__.bind(__webpack_require__, "./node_modules/.pnpm/mermaid@11.4.1/node_modules/mermaid/dist/chunks/mermaid.core/architectureDiagram-UYN6MBPD.mjs"));
    return {
        id: id25,
        diagram: diagram2
    };
}, "loader");
var architecture = {
    id: id25,
    detector: detector25,
    loader: loader25
};
var architectureDetector_default = architecture;
var hasLoadedDiagrams = false;
var addDiagrams = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(()=>{
    if (hasLoadedDiagrams) return;
    hasLoadedDiagrams = true;
    (0, chunk_6DBFFHIP.Cq)("error", errorDiagram_default, (text)=>"error" === text.toLowerCase().trim());
    (0, chunk_6DBFFHIP.Cq)("---", {
        db: {
            clear: /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(()=>{}, "clear")
        },
        styles: {},
        renderer: {
            draw: /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(()=>{}, "draw")
        },
        parser: {
            parse: /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(()=>{
                throw new Error("Diagrams beginning with --- are not valid. If you were trying to use a YAML front-matter, please ensure that you've correctly opened and closed the YAML front-matter with un-indented `---` blocks");
            }, "parse")
        },
        init: /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(()=>null, "init")
    }, (text)=>text.toLowerCase().trimStart().startsWith("---"));
    (0, chunk_6DBFFHIP.KO)(c4Detector_default, detector_default4, classDetector_V2_default, classDetector_default, erDetector_default, ganttDetector_default, info, pie, requirementDetector_default, sequenceDetector_default, detector_default, flowDetector_v2_default, flowDetector_default, detector_default3, detector_default2, gitGraphDetector_default, stateDetector_V2_default, stateDetector_default, journeyDetector_default, quadrantDetector_default, sankeyDetector_default, packet, xychartDetector_default, blockDetector_default, architectureDetector_default);
}, "addDiagrams");
var loadRegisteredDiagrams = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    chunk_6DBFFHIP.cM.debug("Loading registered diagrams");
    const results = await Promise.allSettled(Object.entries(chunk_6DBFFHIP.Bf).map(async ([key, { detector: detector26, loader: loader26 }])=>{
        if (loader26) try {
            (0, chunk_6DBFFHIP._7)(key);
        } catch  {
            try {
                const { diagram: diagram2, id: id26 } = await loader26();
                (0, chunk_6DBFFHIP.Cq)(id26, diagram2, detector26);
            } catch (err) {
                chunk_6DBFFHIP.cM.error(`Failed to load external diagram with key ${key}. Removing from detectors.`);
                delete chunk_6DBFFHIP.Bf[key];
                throw err;
            }
        }
    }));
    const failed = results.filter((result)=>"rejected" === result.status);
    if (failed.length > 0) {
        chunk_6DBFFHIP.cM.error(`Failed to load ${failed.length} external diagrams`);
        for (const res of failed)chunk_6DBFFHIP.cM.error(res);
        throw new Error(`Failed to load ${failed.length} external diagrams`);
    }
}, "loadRegisteredDiagrams");
var SVG_ROLE = "graphics-document document";
function setA11yDiagramInfo(svg, diagramType) {
    svg.attr("role", SVG_ROLE);
    if ("" !== diagramType) svg.attr("aria-roledescription", diagramType);
}
(0, chunk_6DBFFHIP.eW)(setA11yDiagramInfo, "setA11yDiagramInfo");
function addSVGa11yTitleDescription(svg, a11yTitle, a11yDesc, baseId) {
    if (void 0 === svg.insert) return;
    if (a11yDesc) {
        const descId = `chart-desc-${baseId}`;
        svg.attr("aria-describedby", descId);
        svg.insert("desc", ":first-child").attr("id", descId).text(a11yDesc);
    }
    if (a11yTitle) {
        const titleId = `chart-title-${baseId}`;
        svg.attr("aria-labelledby", titleId);
        svg.insert("title", ":first-child").attr("id", titleId).text(a11yTitle);
    }
}
(0, chunk_6DBFFHIP.eW)(addSVGa11yTitleDescription, "addSVGa11yTitleDescription");
var Diagram = class _Diagram {
    constructor(type, text, db, parser, renderer2){
        this.type = type;
        this.text = text;
        this.db = db;
        this.parser = parser;
        this.renderer = renderer2;
    }
    static{
        (0, chunk_6DBFFHIP.eW)(this, "Diagram");
    }
    static async fromText(text, metadata = {}) {
        const config = (0, chunk_6DBFFHIP.iE)();
        const type = (0, chunk_6DBFFHIP.Vg)(text, config);
        text = (0, chunk_7DKRZKHE.Vy)(text) + "\n";
        try {
            (0, chunk_6DBFFHIP._7)(type);
        } catch  {
            const loader26 = (0, chunk_6DBFFHIP.cq)(type);
            if (!loader26) throw new chunk_6DBFFHIP.cj(`Diagram ${type} not found.`);
            const { id: id26, diagram: diagram2 } = await loader26();
            (0, chunk_6DBFFHIP.Cq)(id26, diagram2);
        }
        const { db, parser, renderer: renderer2, init: init2 } = (0, chunk_6DBFFHIP._7)(type);
        if (parser.parser) parser.parser.yy = db;
        db.clear?.();
        init2?.(config);
        if (metadata.title) db.setDiagramTitle?.(metadata.title);
        await parser.parse(text);
        return new _Diagram(type, text, db, parser, renderer2);
    }
    async render(id26, version2) {
        await this.renderer.draw(this.text, id26, version2, this);
    }
    getParser() {
        return this.parser;
    }
    getType() {
        return this.type;
    }
};
var interactionFunctions = [];
var attachFunctions = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(()=>{
    interactionFunctions.forEach((f)=>{
        f();
    });
    interactionFunctions = [];
}, "attachFunctions");
var cleanupComments = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((text)=>text.replace(/^\s*%%(?!{)[^\n]+\n?/gm, "").trimStart(), "cleanupComments");
function extractFrontMatter(text) {
    const matches = text.match(chunk_6DBFFHIP.M6);
    if (!matches) return {
        text,
        metadata: {}
    };
    let parsed = (0, chunk_S3SWNSAA.z)(matches[1], {
        schema: chunk_S3SWNSAA.A
    }) ?? {};
    parsed = "object" != typeof parsed || Array.isArray(parsed) ? {} : parsed;
    const metadata = {};
    if (parsed.displayMode) metadata.displayMode = parsed.displayMode.toString();
    if (parsed.title) metadata.title = parsed.title.toString();
    if (parsed.config) metadata.config = parsed.config;
    return {
        text: text.slice(matches[0].length),
        metadata
    };
}
(0, chunk_6DBFFHIP.eW)(extractFrontMatter, "extractFrontMatter");
var cleanupText = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((code)=>code.replace(/\r\n?/g, "\n").replace(/<(\w+)([^>]*)>/g, (match, tag, attributes)=>"<" + tag + attributes.replace(/="([^"]*)"/g, "='$1'") + ">"), "cleanupText");
var processFrontmatter = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((code)=>{
    const { text, metadata } = extractFrontMatter(code);
    const { displayMode, title, config = {} } = metadata;
    if (displayMode) {
        if (!config.gantt) config.gantt = {};
        config.gantt.displayMode = displayMode;
    }
    return {
        title,
        config,
        text
    };
}, "processFrontmatter");
var processDirectives = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((code)=>{
    const initDirective = chunk_7DKRZKHE.w8.detectInit(code) ?? {};
    const wrapDirectives = chunk_7DKRZKHE.w8.detectDirective(code, "wrap");
    if (Array.isArray(wrapDirectives)) initDirective.wrap = wrapDirectives.some(({ type })=>"wrap" === type);
    else if (wrapDirectives?.type === "wrap") initDirective.wrap = true;
    return {
        text: (0, chunk_7DKRZKHE.tf)(code),
        directive: initDirective
    };
}, "processDirectives");
function preprocessDiagram(code) {
    const cleanedCode = cleanupText(code);
    const frontMatterResult = processFrontmatter(cleanedCode);
    const directiveResult = processDirectives(frontMatterResult.text);
    const config = (0, chunk_7DKRZKHE.Rb)(frontMatterResult.config, directiveResult.directive);
    code = cleanupComments(directiveResult.text);
    return {
        code,
        title: frontMatterResult.title,
        config
    };
}
(0, chunk_6DBFFHIP.eW)(preprocessDiagram, "preprocessDiagram");
function toBase64(str) {
    const utf8Bytes = new TextEncoder().encode(str);
    const utf8Str = Array.from(utf8Bytes, (byte)=>String.fromCodePoint(byte)).join("");
    return btoa(utf8Str);
}
(0, chunk_6DBFFHIP.eW)(toBase64, "toBase64");
var MAX_TEXTLENGTH = 5e4;
var MAX_TEXTLENGTH_EXCEEDED_MSG = "graph TB;a[Maximum text size in diagram exceeded];style a fill:#faa";
var SECURITY_LVL_SANDBOX = "sandbox";
var SECURITY_LVL_LOOSE = "loose";
var XMLNS_SVG_STD = "http://www.w3.org/2000/svg";
var XMLNS_XLINK_STD = "http://www.w3.org/1999/xlink";
var XMLNS_XHTML_STD = "http://www.w3.org/1999/xhtml";
var IFRAME_WIDTH = "100%";
var IFRAME_HEIGHT = "100%";
var IFRAME_STYLES = "border:0;margin:0;";
var IFRAME_BODY_STYLE = "margin:0";
var IFRAME_SANDBOX_OPTS = "allow-top-navigation-by-user-activation allow-popups";
var IFRAME_NOT_SUPPORTED_MSG = 'The "iframe" tag is not supported by your browser.';
var DOMPURIFY_TAGS = [
    "foreignobject"
];
var DOMPURIFY_ATTR = [
    "dominant-baseline"
];
function processAndSetConfigs(text) {
    const processed = preprocessDiagram(text);
    (0, chunk_6DBFFHIP.mc)();
    (0, chunk_6DBFFHIP.XV)(processed.config ?? {});
    return processed;
}
(0, chunk_6DBFFHIP.eW)(processAndSetConfigs, "processAndSetConfigs");
async function mermaid_core_parse(text, parseOptions) {
    addDiagrams();
    try {
        const { code, config } = processAndSetConfigs(text);
        const diagram2 = await getDiagramFromText(code);
        return {
            diagramType: diagram2.type,
            config
        };
    } catch (error) {
        if (parseOptions?.suppressErrors) return false;
        throw error;
    }
}
(0, chunk_6DBFFHIP.eW)(mermaid_core_parse, "parse");
var cssImportantStyles = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((cssClass, element, cssClasses = [])=>`
.${cssClass} ${element} { ${cssClasses.join(" !important; ")} !important; }`, "cssImportantStyles");
var createCssStyles = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((config, classDefs = /* @__PURE__ */ new Map())=>{
    let cssStyles = "";
    if (void 0 !== config.themeCSS) cssStyles += `
${config.themeCSS}`;
    if (void 0 !== config.fontFamily) cssStyles += `
:root { --mermaid-font-family: ${config.fontFamily}}`;
    if (void 0 !== config.altFontFamily) cssStyles += `
:root { --mermaid-alt-font-family: ${config.altFontFamily}}`;
    if (classDefs instanceof Map) {
        const htmlLabels = config.htmlLabels ?? config.flowchart?.htmlLabels;
        const cssHtmlElements = [
            "> *",
            "span"
        ];
        const cssShapeElements = [
            "rect",
            "polygon",
            "ellipse",
            "circle",
            "path"
        ];
        const cssElements = htmlLabels ? cssHtmlElements : cssShapeElements;
        classDefs.forEach((styleClassDef)=>{
            if (!(0, isEmpty.Z)(styleClassDef.styles)) cssElements.forEach((cssElement)=>{
                cssStyles += cssImportantStyles(styleClassDef.id, cssElement, styleClassDef.styles);
            });
            if (!(0, isEmpty.Z)(styleClassDef.textStyles)) cssStyles += cssImportantStyles(styleClassDef.id, "tspan", (styleClassDef?.textStyles || []).map((s)=>s.replace("color", "fill")));
        });
    }
    return cssStyles;
}, "createCssStyles");
var createUserStyles = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((config, graphType, classDefs, svgId)=>{
    const userCSSstyles = createCssStyles(config, classDefs);
    const allStyles = (0, chunk_6DBFFHIP.Ee)(graphType, userCSSstyles, config.themeVariables);
    return serialize(compile(`${svgId}{${allStyles}}`), stringify);
}, "createUserStyles");
var cleanUpSvgCode = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((svgCode = "", inSandboxMode, useArrowMarkerUrls)=>{
    let cleanedUpSvg = svgCode;
    if (!useArrowMarkerUrls && !inSandboxMode) cleanedUpSvg = cleanedUpSvg.replace(/marker-end="url\([\d+./:=?A-Za-z-]*?#/g, 'marker-end="url(#');
    cleanedUpSvg = (0, chunk_7DKRZKHE.SH)(cleanedUpSvg);
    cleanedUpSvg = cleanedUpSvg.replace(/<br>/g, "<br/>");
    return cleanedUpSvg;
}, "cleanUpSvgCode");
var putIntoIFrame = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((svgCode = "", svgElement)=>{
    const height = svgElement?.viewBox?.baseVal?.height ? svgElement.viewBox.baseVal.height + "px" : IFRAME_HEIGHT;
    const base64encodedSrc = toBase64(`<body style="${IFRAME_BODY_STYLE}">${svgCode}</body>`);
    return `<iframe style="width:${IFRAME_WIDTH};height:${height};${IFRAME_STYLES}" src="data:text/html;charset=UTF-8;base64,${base64encodedSrc}" sandbox="${IFRAME_SANDBOX_OPTS}">
  ${IFRAME_NOT_SUPPORTED_MSG}
</iframe>`;
}, "putIntoIFrame");
var appendDivSvgG = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((parentRoot, id26, enclosingDivId, divStyle, svgXlink)=>{
    const enclosingDiv = parentRoot.append("div");
    enclosingDiv.attr("id", enclosingDivId);
    if (divStyle) enclosingDiv.attr("style", divStyle);
    const svgNode = enclosingDiv.append("svg").attr("id", id26).attr("width", "100%").attr("xmlns", XMLNS_SVG_STD);
    if (svgXlink) svgNode.attr("xmlns:xlink", svgXlink);
    svgNode.append("g");
    return parentRoot;
}, "appendDivSvgG");
function sandboxedIframe(parentNode, iFrameId) {
    return parentNode.append("iframe").attr("id", iFrameId).attr("style", "width: 100%; height: 100%;").attr("sandbox", "");
}
(0, chunk_6DBFFHIP.eW)(sandboxedIframe, "sandboxedIframe");
var removeExistingElements = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((doc, id26, divId, iFrameId)=>{
    doc.getElementById(id26)?.remove();
    doc.getElementById(divId)?.remove();
    doc.getElementById(iFrameId)?.remove();
}, "removeExistingElements");
var render = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async function(id26, text, svgContainingElement) {
    addDiagrams();
    const processed = processAndSetConfigs(text);
    text = processed.code;
    const config = (0, chunk_6DBFFHIP.iE)();
    chunk_6DBFFHIP.cM.debug(config);
    if (text.length > (config?.maxTextSize ?? MAX_TEXTLENGTH)) text = MAX_TEXTLENGTH_EXCEEDED_MSG;
    const idSelector = "#" + id26;
    const iFrameID = "i" + id26;
    const iFrameID_selector = "#" + iFrameID;
    const enclosingDivID = "d" + id26;
    const enclosingDivID_selector = "#" + enclosingDivID;
    const removeTempElements = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(()=>{
        const tmpElementSelector = isSandboxed ? iFrameID_selector : enclosingDivID_selector;
        const node = (0, src.Ys)(tmpElementSelector).node();
        if (node && "remove" in node) node.remove();
    }, "removeTempElements");
    let root = (0, src.Ys)("body");
    const isSandboxed = config.securityLevel === SECURITY_LVL_SANDBOX;
    const isLooseSecurityLevel = config.securityLevel === SECURITY_LVL_LOOSE;
    const fontFamily = config.fontFamily;
    if (void 0 !== svgContainingElement) {
        if (svgContainingElement) svgContainingElement.innerHTML = "";
        if (isSandboxed) {
            const iframe = sandboxedIframe((0, src.Ys)(svgContainingElement), iFrameID);
            root = (0, src.Ys)(iframe.nodes()[0].contentDocument.body);
            root.node().style.margin = 0;
        } else root = (0, src.Ys)(svgContainingElement);
        appendDivSvgG(root, id26, enclosingDivID, `font-family: ${fontFamily}`, XMLNS_XLINK_STD);
    } else {
        removeExistingElements(document, id26, enclosingDivID, iFrameID);
        if (isSandboxed) {
            const iframe = sandboxedIframe((0, src.Ys)("body"), iFrameID);
            root = (0, src.Ys)(iframe.nodes()[0].contentDocument.body);
            root.node().style.margin = 0;
        } else root = (0, src.Ys)("body");
        appendDivSvgG(root, id26, enclosingDivID);
    }
    let diag;
    let parseEncounteredException;
    try {
        diag = await Diagram.fromText(text, {
            title: processed.title
        });
    } catch (error) {
        if (config.suppressErrorRendering) {
            removeTempElements();
            throw error;
        }
        diag = await Diagram.fromText("error");
        parseEncounteredException = error;
    }
    const element = root.select(enclosingDivID_selector).node();
    const diagramType = diag.type;
    const svg = element.firstChild;
    const firstChild = svg.firstChild;
    const diagramClassDefs = diag.renderer.getClasses?.(text, diag);
    const rules = createUserStyles(config, diagramType, diagramClassDefs, idSelector);
    const style1 = document.createElement("style");
    style1.innerHTML = rules;
    svg.insertBefore(style1, firstChild);
    try {
        await diag.renderer.draw(text, id26, chunk_K6PMAZHR.i, diag);
    } catch (e) {
        if (config.suppressErrorRendering) removeTempElements();
        else errorRenderer_default.draw(text, id26, chunk_K6PMAZHR.i);
        throw e;
    }
    const svgNode = root.select(`${enclosingDivID_selector} svg`);
    const a11yTitle = diag.db.getAccTitle?.();
    const a11yDescr = diag.db.getAccDescription?.();
    addA11yInfo(diagramType, svgNode, a11yTitle, a11yDescr);
    root.select(`[id="${id26}"]`).selectAll("foreignobject > *").attr("xmlns", XMLNS_XHTML_STD);
    let svgCode = root.select(enclosingDivID_selector).node().innerHTML;
    chunk_6DBFFHIP.cM.debug("config.arrowMarkerAbsolute", config.arrowMarkerAbsolute);
    svgCode = cleanUpSvgCode(svgCode, isSandboxed, (0, chunk_6DBFFHIP.ku)(config.arrowMarkerAbsolute));
    if (isSandboxed) {
        const svgEl = root.select(enclosingDivID_selector + " svg").node();
        svgCode = putIntoIFrame(svgCode, svgEl);
    } else if (!isLooseSecurityLevel) svgCode = purify_es.Z.sanitize(svgCode, {
        ADD_TAGS: DOMPURIFY_TAGS,
        ADD_ATTR: DOMPURIFY_ATTR,
        HTML_INTEGRATION_POINTS: {
            foreignobject: true
        }
    });
    attachFunctions();
    if (parseEncounteredException) throw parseEncounteredException;
    removeTempElements();
    return {
        diagramType,
        svg: svgCode,
        bindFunctions: diag.db.bindFunctions
    };
}, "render");
function initialize(userOptions = {}) {
    const options = (0, chunk_6DBFFHIP.Yc)({}, userOptions);
    if (options?.fontFamily && !options.themeVariables?.fontFamily) {
        if (!options.themeVariables) options.themeVariables = {};
        options.themeVariables.fontFamily = options.fontFamily;
    }
    (0, chunk_6DBFFHIP.dY)(options);
    if (options?.theme && options.theme in chunk_6DBFFHIP._j) options.themeVariables = chunk_6DBFFHIP._j[options.theme].getThemeVariables(options.themeVariables);
    else if (options) options.themeVariables = chunk_6DBFFHIP._j["default"].getThemeVariables(options.themeVariables);
    const config = "object" == typeof options ? (0, chunk_6DBFFHIP.Yn)(options) : (0, chunk_6DBFFHIP.ZD)();
    (0, chunk_6DBFFHIP.Ub)(config.logLevel);
    addDiagrams();
}
(0, chunk_6DBFFHIP.eW)(initialize, "initialize");
var getDiagramFromText = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((text, metadata = {})=>{
    const { code } = preprocessDiagram(text);
    return Diagram.fromText(code, metadata);
}, "getDiagramFromText");
function addA11yInfo(diagramType, svgNode, a11yTitle, a11yDescr) {
    setA11yDiagramInfo(svgNode, diagramType);
    addSVGa11yTitleDescription(svgNode, a11yTitle, a11yDescr, svgNode.attr("id"));
}
(0, chunk_6DBFFHIP.eW)(addA11yInfo, "addA11yInfo");
var mermaidAPI = Object.freeze({
    render,
    parse: mermaid_core_parse,
    getDiagramFromText,
    initialize,
    getConfig: chunk_6DBFFHIP.iE,
    setConfig: chunk_6DBFFHIP.v6,
    getSiteConfig: chunk_6DBFFHIP.ZD,
    updateSiteConfig: chunk_6DBFFHIP.Tb,
    reset: /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(()=>{
        (0, chunk_6DBFFHIP.mc)();
    }, "reset"),
    globalReset: /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(()=>{
        (0, chunk_6DBFFHIP.mc)(chunk_6DBFFHIP.u_);
    }, "globalReset"),
    defaultConfig: chunk_6DBFFHIP.u_
});
(0, chunk_6DBFFHIP.Ub)((0, chunk_6DBFFHIP.iE)().logLevel);
(0, chunk_6DBFFHIP.mc)((0, chunk_6DBFFHIP.iE)());
var handleError = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((error, errors, parseError)=>{
    chunk_6DBFFHIP.cM.warn(error);
    if ((0, chunk_7DKRZKHE.bZ)(error)) {
        if (parseError) parseError(error.str, error.hash);
        errors.push({
            ...error,
            message: error.str,
            error
        });
    } else {
        if (parseError) parseError(error);
        if (error instanceof Error) errors.push({
            str: error.message,
            message: error.message,
            hash: error.name,
            error
        });
    }
}, "handleError");
var run = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async function(options = {
    querySelector: ".mermaid"
}) {
    try {
        await runThrowsErrors(options);
    } catch (e) {
        if ((0, chunk_7DKRZKHE.bZ)(e)) chunk_6DBFFHIP.cM.error(e.str);
        if (mermaid.parseError) mermaid.parseError(e);
        if (!options.suppressErrors) {
            chunk_6DBFFHIP.cM.error("Use the suppressErrors option to suppress these errors");
            throw e;
        }
    }
}, "run");
var runThrowsErrors = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async function({ postRenderCallback, querySelector, nodes } = {
    querySelector: ".mermaid"
}) {
    const conf = mermaidAPI.getConfig();
    chunk_6DBFFHIP.cM.debug(`${postRenderCallback ? "" : "No "}Callback function found`);
    let nodesToProcess;
    if (nodes) nodesToProcess = nodes;
    else if (querySelector) nodesToProcess = document.querySelectorAll(querySelector);
    else throw new Error("Nodes and querySelector are both undefined");
    chunk_6DBFFHIP.cM.debug(`Found ${nodesToProcess.length} diagrams`);
    if (conf?.startOnLoad !== void 0) {
        chunk_6DBFFHIP.cM.debug("Start On Load: " + conf?.startOnLoad);
        mermaidAPI.updateSiteConfig({
            startOnLoad: conf?.startOnLoad
        });
    }
    const idGenerator = new chunk_7DKRZKHE.w8.InitIDGenerator(conf.deterministicIds, conf.deterministicIDSeed);
    let txt;
    const errors = [];
    for (const element of Array.from(nodesToProcess)){
        chunk_6DBFFHIP.cM.info("Rendering diagram: " + element.id);
        if (element.getAttribute("data-processed")) continue;
        element.setAttribute("data-processed", "true");
        const id26 = `mermaid-${idGenerator.next()}`;
        txt = element.innerHTML;
        txt = (0, esm.Z)(chunk_7DKRZKHE.w8.entityDecode(txt)).trim().replace(/<br\s*\/?>/gi, "<br/>");
        const init2 = chunk_7DKRZKHE.w8.detectInit(txt);
        if (init2) chunk_6DBFFHIP.cM.debug("Detected early reinit: ", init2);
        try {
            const { svg, bindFunctions } = await render2(id26, txt, element);
            element.innerHTML = svg;
            if (postRenderCallback) await postRenderCallback(id26);
            if (bindFunctions) bindFunctions(element);
        } catch (error) {
            handleError(error, errors, mermaid.parseError);
        }
    }
    if (errors.length > 0) throw errors[0];
}, "runThrowsErrors");
var initialize2 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(function(config) {
    mermaidAPI.initialize(config);
}, "initialize");
var init = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async function(config, nodes, callback) {
    chunk_6DBFFHIP.cM.warn("mermaid.init is deprecated. Please use run instead.");
    if (config) initialize2(config);
    const runOptions = {
        postRenderCallback: callback,
        querySelector: ".mermaid"
    };
    if ("string" == typeof nodes) runOptions.querySelector = nodes;
    else if (nodes) {
        if (nodes instanceof HTMLElement) runOptions.nodes = [
            nodes
        ];
        else runOptions.nodes = nodes;
    }
    await run(runOptions);
}, "init");
var registerExternalDiagrams = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async (diagrams, { lazyLoad = true } = {})=>{
    addDiagrams();
    (0, chunk_6DBFFHIP.KO)(...diagrams);
    if (false === lazyLoad) await loadRegisteredDiagrams();
}, "registerExternalDiagrams");
var contentLoaded = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(function() {
    if (mermaid.startOnLoad) {
        const { startOnLoad } = mermaidAPI.getConfig();
        if (startOnLoad) mermaid.run().catch((err)=>chunk_6DBFFHIP.cM.error("Mermaid failed to initialize", err));
    }
}, "contentLoaded");
if ("undefined" != typeof document) window.addEventListener("load", contentLoaded, false);
var setParseErrorHandler = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(function(parseErrorHandler) {
    mermaid.parseError = parseErrorHandler;
}, "setParseErrorHandler");
var executionQueue = [];
var executionQueueRunning = false;
var executeQueue = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async ()=>{
    if (executionQueueRunning) return;
    executionQueueRunning = true;
    while(executionQueue.length > 0){
        const f = executionQueue.shift();
        if (f) try {
            await f();
        } catch (e) {
            chunk_6DBFFHIP.cM.error("Error executing queue", e);
        }
    }
    executionQueueRunning = false;
}, "executeQueue");
var parse2 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(async (text, parseOptions)=>new Promise((resolve, reject)=>{
        const performCall = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(()=>new Promise((res, rej)=>{
                mermaidAPI.parse(text, parseOptions).then((r)=>{
                    res(r);
                    resolve(r);
                }, (e)=>{
                    chunk_6DBFFHIP.cM.error("Error parsing", e);
                    mermaid.parseError?.(e);
                    rej(e);
                    reject(e);
                });
            }), "performCall");
        executionQueue.push(performCall);
        executeQueue().catch(reject);
    }), "parse");
var render2 = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)((id26, text, container)=>new Promise((resolve, reject)=>{
        const performCall = /* @__PURE__ */ (0, chunk_6DBFFHIP.eW)(()=>new Promise((res, rej)=>{
                mermaidAPI.render(id26, text, container).then((r)=>{
                    res(r);
                    resolve(r);
                }, (e)=>{
                    chunk_6DBFFHIP.cM.error("Error parsing", e);
                    mermaid.parseError?.(e);
                    rej(e);
                    reject(e);
                });
            }), "performCall");
        executionQueue.push(performCall);
        executeQueue().catch(reject);
    }), "render");
var mermaid = {
    startOnLoad: true,
    mermaidAPI,
    parse: parse2,
    render: render2,
    init,
    run,
    registerExternalDiagrams,
    registerLayoutLoaders: chunk_BO7VGL7K.jM,
    initialize: initialize2,
    parseError: void 0,
    contentLoaded,
    setParseErrorHandler,
    detectType: chunk_6DBFFHIP.Vg,
    registerIconPacks: chunk_OPO4IU42.ef
};
var mermaid_default = mermaid; /*!
 * Wait for document loaded before starting the execution
 */ 
export { mermaid_default as mermaid };
